dart_library.library('dart/indexed_db', null, /* Imports */[
  "dart_runtime/dart",
  'dart/core',
  'dart/html_common',
  'dart/_js_helper',
  'dart/_interceptors',
  'dart/async',
  'dart/_metadata'
], /* Lazy imports */[
  'dart/html'
], function(exports, dart, core, html_common, _js_helper, _interceptors, async, _metadata, html) {
  'use strict';
  let dartx = dart.dartx;
  class _KeyRangeFactoryProvider extends core.Object {
    static createKeyRange_only(value) {
      return _KeyRangeFactoryProvider._only(_KeyRangeFactoryProvider._class(), _KeyRangeFactoryProvider._translateKey(value));
    }
    static createKeyRange_lowerBound(bound, open) {
      if (open === void 0)
        open = false;
      return _KeyRangeFactoryProvider._lowerBound(_KeyRangeFactoryProvider._class(), _KeyRangeFactoryProvider._translateKey(bound), open);
    }
    static createKeyRange_upperBound(bound, open) {
      if (open === void 0)
        open = false;
      return _KeyRangeFactoryProvider._upperBound(_KeyRangeFactoryProvider._class(), _KeyRangeFactoryProvider._translateKey(bound), open);
    }
    static createKeyRange_bound(lower, upper, lowerOpen, upperOpen) {
      if (lowerOpen === void 0)
        lowerOpen = false;
      if (upperOpen === void 0)
        upperOpen = false;
      return _KeyRangeFactoryProvider._bound(_KeyRangeFactoryProvider._class(), _KeyRangeFactoryProvider._translateKey(lower), _KeyRangeFactoryProvider._translateKey(upper), lowerOpen, upperOpen);
    }
    static _class() {
      if (_KeyRangeFactoryProvider._cachedClass != null)
        return _KeyRangeFactoryProvider._cachedClass;
      return _KeyRangeFactoryProvider._cachedClass = _KeyRangeFactoryProvider._uncachedClass();
    }
    static _uncachedClass() {
      return window.webkitIDBKeyRange || window.mozIDBKeyRange || window.msIDBKeyRange || window.IDBKeyRange;
    }
    static _translateKey(idbkey) {
      return idbkey;
    }
    static _only(cls, value) {
      return dart.as(cls.only(value), KeyRange);
    }
    static _lowerBound(cls, bound, open) {
      return dart.as(cls.lowerBound(bound, open), KeyRange);
    }
    static _upperBound(cls, bound, open) {
      return dart.as(cls.upperBound(bound, open), KeyRange);
    }
    static _bound(cls, lower, upper, lowerOpen, upperOpen) {
      return dart.as(cls.bound(lower, upper, lowerOpen, upperOpen), KeyRange);
    }
  }
  dart.setSignature(_KeyRangeFactoryProvider, {
    statics: () => ({
      createKeyRange_only: [KeyRange, [dart.dynamic]],
      createKeyRange_lowerBound: [KeyRange, [dart.dynamic], [core.bool]],
      createKeyRange_upperBound: [KeyRange, [dart.dynamic], [core.bool]],
      createKeyRange_bound: [KeyRange, [dart.dynamic, dart.dynamic], [core.bool, core.bool]],
      _class: [dart.dynamic, []],
      _uncachedClass: [dart.dynamic, []],
      _translateKey: [dart.dynamic, [dart.dynamic]],
      _only: [KeyRange, [dart.dynamic, dart.dynamic]],
      _lowerBound: [KeyRange, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _upperBound: [KeyRange, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _bound: [KeyRange, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['createKeyRange_only', 'createKeyRange_lowerBound', 'createKeyRange_upperBound', 'createKeyRange_bound', '_class', '_uncachedClass', '_translateKey', '_only', '_lowerBound', '_upperBound', '_bound']
  });
  _KeyRangeFactoryProvider._cachedClass = null;
  function _convertNativeToDart_IDBKey(nativeKey) {
    function containsDate(object) {
      if (dart.notNull(html_common.isJavaScriptDate(object)))
        return true;
      if (dart.is(object, core.List)) {
        for (let i = 0; dart.notNull(i) < dart.notNull(dart.as(dart.dload(object, 'length'), core.num)); i = dart.notNull(i) + 1) {
          if (dart.notNull(dart.as(containsDate(dart.dindex(object, i)), core.bool)))
            return true;
        }
      }
      return false;
    }
    dart.fn(containsDate);
    if (dart.notNull(dart.as(containsDate(nativeKey), core.bool))) {
      dart.throw(new core.UnimplementedError('Key containing DateTime'));
    }
    return nativeKey;
  }
  dart.fn(_convertNativeToDart_IDBKey);
  function _convertDartToNative_IDBKey(dartKey) {
    return dartKey;
  }
  dart.fn(_convertDartToNative_IDBKey);
  function _convertNativeToDart_IDBAny(object) {
    return html_common.convertNativeToDart_AcceptStructuredClone(object, {mustCopy: false});
  }
  dart.fn(_convertNativeToDart_IDBAny);
  let _idbKey = 'JSExtendableArray|=Object|num|String';
  let _annotation_Creates_IDBKey = dart.const(new _js_helper.Creates(_idbKey));
  let _annotation_Returns_IDBKey = dart.const(new _js_helper.Returns(_idbKey));
  let _delete = Symbol('_delete');
  let _update = Symbol('_update');
  let _update_1 = Symbol('_update_1');
  class Cursor extends _interceptors.Interceptor {
    delete() {
      try {
        return _completeRequest(this[_delete]());
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    update(value) {
      try {
        return _completeRequest(this[_update](value));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    next(key) {
      if (key === void 0)
        key = null;
      if (key == null) {
        this.continue();
      } else {
        this.continue(key);
      }
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    [_update](value) {
      let value_1 = html_common.convertDartToNative_SerializedScriptValue(value);
      return this[_update_1](value_1);
    }
  }
  dart.setSignature(Cursor, {
    constructors: () => ({_: [Cursor, []]}),
    methods: () => ({
      delete: [async.Future, []],
      update: [async.Future, [dart.dynamic]],
      next: [dart.void, [], [core.Object]],
      advance: [dart.void, [core.int]],
      continuePrimaryKey: [dart.void, [core.Object, core.Object]],
      [_delete]: [exports.Request, []],
      [_update]: [exports.Request, [dart.dynamic]],
      [_update_1]: [exports.Request, [dart.dynamic]]
    })
  });
  Cursor[dart.metadata] = () => [dart.const(new _metadata.DomName('IDBCursor')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBCursor"))];
  let _get_value = Symbol('_get_value');
  class CursorWithValue extends Cursor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get value() {
      return _convertNativeToDart_IDBAny(this[_get_value]);
    }
  }
  dart.setSignature(CursorWithValue, {
    constructors: () => ({_: [CursorWithValue, []]})
  });
  CursorWithValue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('IDBCursorWithValue')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBCursorWithValue"))];
  let _createObjectStore = Symbol('_createObjectStore');
  let _transaction = Symbol('_transaction');
  let _createObjectStore_1 = Symbol('_createObjectStore_1');
  let _createObjectStore_2 = Symbol('_createObjectStore_2');
  dart.defineLazyClass(exports, {
    get Database() {
      class Database extends html.EventTarget {
        createObjectStore(name, opts) {
          let keyPath = opts && 'keyPath' in opts ? opts.keyPath : null;
          let autoIncrement = opts && 'autoIncrement' in opts ? opts.autoIncrement : null;
          let options = dart.map();
          if (keyPath != null) {
            dart.dsetindex(options, 'keyPath', keyPath);
          }
          if (autoIncrement != null) {
            dart.dsetindex(options, 'autoIncrement', autoIncrement);
          }
          return this[_createObjectStore](name, dart.as(options, core.Map));
        }
        transaction(storeName_OR_storeNames, mode) {
          if (mode != 'readonly' && mode != 'readwrite') {
            dart.throw(new core.ArgumentError(mode));
          }
          return this[_transaction](storeName_OR_storeNames, mode);
        }
        transactionStore(storeName, mode) {
          if (mode != 'readonly' && mode != 'readwrite') {
            dart.throw(new core.ArgumentError(mode));
          }
          return this[_transaction](storeName, mode);
        }
        transactionList(storeNames, mode) {
          if (mode != 'readonly' && mode != 'readwrite') {
            dart.throw(new core.ArgumentError(mode));
          }
          let storeNames_1 = html_common.convertDartToNative_StringArray(storeNames);
          return this[_transaction](storeNames_1, mode);
        }
        transactionStores(storeNames, mode) {
          if (mode != 'readonly' && mode != 'readwrite') {
            dart.throw(new core.ArgumentError(mode));
          }
          return this[_transaction](storeNames, mode);
        }
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        [_createObjectStore](name, options) {
          if (options === void 0)
            options = null;
          if (options != null) {
            let options_1 = html_common.convertDartToNative_Dictionary(options);
            return this[_createObjectStore_1](name, options_1);
          }
          return this[_createObjectStore_2](name);
        }
        get onAbort() {
          return exports.Database.abortEvent.forTarget(this);
        }
        get onClose() {
          return exports.Database.closeEvent.forTarget(this);
        }
        get onError() {
          return exports.Database.errorEvent.forTarget(this);
        }
        get onVersionChange() {
          return exports.Database.versionChangeEvent.forTarget(this);
        }
      }
      dart.setSignature(Database, {
        constructors: () => ({_: [exports.Database, []]}),
        methods: () => ({
          createObjectStore: [ObjectStore, [core.String], {keyPath: core.String, autoIncrement: core.bool}],
          transaction: [exports.Transaction, [dart.dynamic, core.String]],
          transactionStore: [exports.Transaction, [core.String, core.String]],
          transactionList: [exports.Transaction, [core.List$(core.String), core.String]],
          transactionStores: [exports.Transaction, [html.DomStringList, core.String]],
          [_transaction]: [exports.Transaction, [dart.dynamic, dart.dynamic]],
          close: [dart.void, []],
          [_createObjectStore]: [ObjectStore, [core.String], [core.Map]],
          [_createObjectStore_1]: [ObjectStore, [dart.dynamic, dart.dynamic]],
          [_createObjectStore_2]: [ObjectStore, [dart.dynamic]],
          deleteObjectStore: [dart.void, [core.String]]
        })
      });
      Database[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('IDBDatabase')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX, '15')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.Experimental()), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBDatabase"))];
      return Database;
    }
  });
  dart.defineLazyProperties(Database, {
    get abortEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('abort'));
    },
    set abortEvent(_) {},
    get closeEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('close'));
    },
    set closeEvent(_) {},
    get errorEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('error'));
    },
    set errorEvent(_) {}
  });
  dart.defineLazyClass(exports, {
    get VersionChangeEvent() {
      class VersionChangeEvent extends html.Event {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(VersionChangeEvent, {
        constructors: () => ({_: [exports.VersionChangeEvent, []]})
      });
      VersionChangeEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('IDBVersionChangeEvent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBVersionChangeEvent"))];
      return VersionChangeEvent;
    }
  });
  dart.defineLazyProperties(Database, {
    get versionChangeEvent() {
      return dart.const(new (html.EventStreamProvider$(exports.VersionChangeEvent))('versionchange'));
    },
    set versionChangeEvent(_) {}
  });
  let _open = Symbol('_open');
  let _deleteDatabase = Symbol('_deleteDatabase');
  let _webkitGetDatabaseNames = Symbol('_webkitGetDatabaseNames');
  class IdbFactory extends _interceptors.Interceptor {
    static get supported() {
      return dart.as(!!(window.indexedDB || window.webkitIndexedDB || window.mozIndexedDB), core.bool);
    }
    open(name, opts) {
      let version = opts && 'version' in opts ? opts.version : null;
      let onUpgradeNeeded = opts && 'onUpgradeNeeded' in opts ? opts.onUpgradeNeeded : null;
      let onBlocked = opts && 'onBlocked' in opts ? opts.onBlocked : null;
      if (version == null != (onUpgradeNeeded == null)) {
        return async.Future$(exports.Database).error(new core.ArgumentError('version and onUpgradeNeeded must be specified together'));
      }
      try {
        let request = null;
        if (version != null) {
          request = this[_open](name, version);
        } else {
          request = this[_open](name);
        }
        if (onUpgradeNeeded != null) {
          dart.dsend(dart.dload(request, 'onUpgradeNeeded'), 'listen', onUpgradeNeeded);
        }
        if (onBlocked != null) {
          dart.dsend(dart.dload(request, 'onBlocked'), 'listen', onBlocked);
        }
        return dart.as(_completeRequest(dart.as(request, exports.Request)), async.Future$(exports.Database));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future$(exports.Database).error(e, stacktrace);
      }

    }
    deleteDatabase(name, opts) {
      let onBlocked = opts && 'onBlocked' in opts ? opts.onBlocked : null;
      try {
        let request = this[_deleteDatabase](name);
        if (onBlocked != null) {
          dart.dsend(dart.dload(request, 'onBlocked'), 'listen', onBlocked);
        }
        let completer = async.Completer.sync();
        dart.dsend(dart.dload(request, 'onSuccess'), 'listen', dart.fn(e => {
          dart.dsend(completer, 'complete', this);
        }));
        dart.dsend(dart.dload(request, 'onError'), 'listen', dart.dload(completer, 'completeError'));
        return dart.as(dart.dload(completer, 'future'), async.Future$(IdbFactory));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future$(IdbFactory).error(e, stacktrace);
      }

    }
    getDatabaseNames() {
      try {
        let request = this[_webkitGetDatabaseNames]();
        return dart.as(_completeRequest(dart.as(request, exports.Request)), async.Future$(core.List$(core.String)));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future$(core.List$(core.String)).error(e, stacktrace);
      }

    }
    get supportsDatabaseNames() {
      return dart.notNull(IdbFactory.supported) && dart.notNull(dart.as(!!(this.getDatabaseNames || this.webkitGetDatabaseNames), core.bool));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(IdbFactory, {
    constructors: () => ({_: [IdbFactory, []]}),
    methods: () => ({
      open: [async.Future$(exports.Database), [core.String], {version: core.int, onUpgradeNeeded: dart.functionType(dart.void, [dart.dynamic]), onBlocked: dart.functionType(dart.void, [dart.dynamic])}],
      deleteDatabase: [async.Future$(IdbFactory), [core.String], {onBlocked: dart.functionType(dart.void, [dart.dynamic])}],
      getDatabaseNames: [async.Future$(core.List$(core.String)), []],
      cmp: [core.int, [core.Object, core.Object]],
      [_deleteDatabase]: [exports.OpenDBRequest, [core.String]],
      [_open]: [exports.OpenDBRequest, [core.String], [core.int]],
      [_webkitGetDatabaseNames]: [exports.Request, []]
    })
  });
  IdbFactory[dart.metadata] = () => [dart.const(new _metadata.DomName('IDBFactory')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX, '15')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.Experimental()), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBFactory"))];
  function _completeRequest(request) {
    let completer = async.Completer.sync();
    request.onSuccess.listen(dart.fn(e => {
      dart.dsend(completer, 'complete', request.result);
    }));
    request.onError.listen(dart.as(dart.dload(completer, 'completeError'), __CastType0));
    return dart.as(dart.dload(completer, 'future'), async.Future);
  }
  dart.fn(_completeRequest, () => dart.definiteFunctionType(async.Future, [exports.Request]));
  let _count = Symbol('_count');
  let _get = Symbol('_get');
  let _getKey = Symbol('_getKey');
  let _openCursor = Symbol('_openCursor');
  let _openKeyCursor = Symbol('_openKeyCursor');
  class Index extends _interceptors.Interceptor {
    count(key_OR_range) {
      if (key_OR_range === void 0)
        key_OR_range = null;
      try {
        let request = this[_count](key_OR_range);
        return dart.as(_completeRequest(dart.as(request, exports.Request)), async.Future$(core.int));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future$(core.int).error(e, stacktrace);
      }

    }
    get(key) {
      try {
        let request = this[_get](key);
        return _completeRequest(dart.as(request, exports.Request));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    getKey(key) {
      try {
        let request = this[_getKey](key);
        return _completeRequest(dart.as(request, exports.Request));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    openCursor(opts) {
      let key = opts && 'key' in opts ? opts.key : null;
      let range = opts && 'range' in opts ? opts.range : null;
      let direction = opts && 'direction' in opts ? opts.direction : null;
      let autoAdvance = opts && 'autoAdvance' in opts ? opts.autoAdvance : null;
      let key_OR_range = null;
      if (key != null) {
        if (range != null) {
          dart.throw(new core.ArgumentError('Cannot specify both key and range.'));
        }
        key_OR_range = key;
      } else {
        key_OR_range = range;
      }
      let request = null;
      if (direction == null) {
        request = this[_openCursor](key_OR_range, "next");
      } else {
        request = this[_openCursor](key_OR_range, direction);
      }
      return dart.as(ObjectStore._cursorStreamFromResult(dart.as(request, exports.Request), autoAdvance), async.Stream$(CursorWithValue));
    }
    openKeyCursor(opts) {
      let key = opts && 'key' in opts ? opts.key : null;
      let range = opts && 'range' in opts ? opts.range : null;
      let direction = opts && 'direction' in opts ? opts.direction : null;
      let autoAdvance = opts && 'autoAdvance' in opts ? opts.autoAdvance : null;
      let key_OR_range = null;
      if (key != null) {
        if (range != null) {
          dart.throw(new core.ArgumentError('Cannot specify both key and range.'));
        }
        key_OR_range = key;
      } else {
        key_OR_range = range;
      }
      let request = null;
      if (direction == null) {
        request = this[_openKeyCursor](key_OR_range, "next");
      } else {
        request = this[_openKeyCursor](key_OR_range, direction);
      }
      return ObjectStore._cursorStreamFromResult(dart.as(request, exports.Request), autoAdvance);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Index, {
    constructors: () => ({_: [Index, []]}),
    methods: () => ({
      count: [async.Future$(core.int), [], [dart.dynamic]],
      get: [async.Future, [dart.dynamic]],
      getKey: [async.Future, [dart.dynamic]],
      openCursor: [async.Stream$(CursorWithValue), [], {key: dart.dynamic, range: KeyRange, direction: core.String, autoAdvance: core.bool}],
      openKeyCursor: [async.Stream$(Cursor), [], {key: dart.dynamic, range: KeyRange, direction: core.String, autoAdvance: core.bool}],
      [_count]: [exports.Request, [core.Object]],
      [_get]: [exports.Request, [core.Object]],
      [_getKey]: [exports.Request, [core.Object]],
      [_openCursor]: [exports.Request, [core.Object], [core.String]],
      [_openKeyCursor]: [exports.Request, [core.Object], [core.String]]
    })
  });
  Index[dart.metadata] = () => [dart.const(new _metadata.DomName('IDBIndex')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBIndex"))];
  class KeyRange extends _interceptors.Interceptor {
    static only(value) {
      return _KeyRangeFactoryProvider.createKeyRange_only(value);
    }
    static lowerBound(bound, open) {
      if (open === void 0)
        open = false;
      return _KeyRangeFactoryProvider.createKeyRange_lowerBound(bound, open);
    }
    static upperBound(bound, open) {
      if (open === void 0)
        open = false;
      return _KeyRangeFactoryProvider.createKeyRange_upperBound(bound, open);
    }
    static bound(lower, upper, lowerOpen, upperOpen) {
      if (lowerOpen === void 0)
        lowerOpen = false;
      if (upperOpen === void 0)
        upperOpen = false;
      return _KeyRangeFactoryProvider.createKeyRange_bound(lower, upper, lowerOpen, upperOpen);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(KeyRange, {
    constructors: () => ({
      only: [KeyRange, [dart.dynamic]],
      lowerBound: [KeyRange, [dart.dynamic], [core.bool]],
      upperBound: [KeyRange, [dart.dynamic], [core.bool]],
      bound: [KeyRange, [dart.dynamic, dart.dynamic], [core.bool, core.bool]],
      _: [KeyRange, []]
    }),
    statics: () => ({
      bound_: [KeyRange, [core.Object, core.Object], [core.bool, core.bool]],
      lowerBound_: [KeyRange, [core.Object], [core.bool]],
      only_: [KeyRange, [core.Object]],
      upperBound_: [KeyRange, [core.Object], [core.bool]]
    }),
    names: ['bound_', 'lowerBound_', 'only_', 'upperBound_']
  });
  KeyRange[dart.metadata] = () => [dart.const(new _metadata.DomName('IDBKeyRange')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBKeyRange"))];
  let _add = Symbol('_add');
  let _clear = Symbol('_clear');
  let _put = Symbol('_put');
  let _createIndex = Symbol('_createIndex');
  let _add_1 = Symbol('_add_1');
  let _add_2 = Symbol('_add_2');
  let _createIndex_1 = Symbol('_createIndex_1');
  let _createIndex_2 = Symbol('_createIndex_2');
  let _createIndex_3 = Symbol('_createIndex_3');
  let _createIndex_4 = Symbol('_createIndex_4');
  let _put_1 = Symbol('_put_1');
  let _put_2 = Symbol('_put_2');
  class ObjectStore extends _interceptors.Interceptor {
    add(value, key) {
      if (key === void 0)
        key = null;
      try {
        let request = null;
        if (key != null) {
          request = this[_add](value, key);
        } else {
          request = this[_add](value);
        }
        return _completeRequest(dart.as(request, exports.Request));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    clear() {
      try {
        return _completeRequest(this[_clear]());
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    delete(key_OR_keyRange) {
      try {
        return _completeRequest(this[_delete](key_OR_keyRange));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    count(key_OR_range) {
      if (key_OR_range === void 0)
        key_OR_range = null;
      try {
        let request = this[_count](key_OR_range);
        return dart.as(_completeRequest(dart.as(request, exports.Request)), async.Future$(core.int));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future$(core.int).error(e, stacktrace);
      }

    }
    put(value, key) {
      if (key === void 0)
        key = null;
      try {
        let request = null;
        if (key != null) {
          request = this[_put](value, key);
        } else {
          request = this[_put](value);
        }
        return _completeRequest(dart.as(request, exports.Request));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    getObject(key) {
      try {
        let request = this[_get](key);
        return _completeRequest(dart.as(request, exports.Request));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        return async.Future.error(e, stacktrace);
      }

    }
    openCursor(opts) {
      let key = opts && 'key' in opts ? opts.key : null;
      let range = opts && 'range' in opts ? opts.range : null;
      let direction = opts && 'direction' in opts ? opts.direction : null;
      let autoAdvance = opts && 'autoAdvance' in opts ? opts.autoAdvance : null;
      let key_OR_range = null;
      if (key != null) {
        if (range != null) {
          dart.throw(new core.ArgumentError('Cannot specify both key and range.'));
        }
        key_OR_range = key;
      } else {
        key_OR_range = range;
      }
      let request = null;
      if (direction == null) {
        request = this[_openCursor](key_OR_range);
      } else {
        request = this[_openCursor](key_OR_range, direction);
      }
      return dart.as(ObjectStore._cursorStreamFromResult(dart.as(request, exports.Request), autoAdvance), async.Stream$(CursorWithValue));
    }
    createIndex(name, keyPath, opts) {
      let unique = opts && 'unique' in opts ? opts.unique : null;
      let multiEntry = opts && 'multiEntry' in opts ? opts.multiEntry : null;
      let options = dart.map();
      if (unique != null) {
        dart.dsetindex(options, 'unique', unique);
      }
      if (multiEntry != null) {
        dart.dsetindex(options, 'multiEntry', multiEntry);
      }
      return this[_createIndex](name, keyPath, dart.as(options, core.Map));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    [_add](value, key) {
      if (key === void 0)
        key = null;
      if (key != null) {
        let value_1 = html_common.convertDartToNative_SerializedScriptValue(value);
        let key_2 = html_common.convertDartToNative_SerializedScriptValue(key);
        return this[_add_1](value_1, key_2);
      }
      let value_1 = html_common.convertDartToNative_SerializedScriptValue(value);
      return this[_add_2](value_1);
    }
    [_createIndex](name, keyPath, options) {
      if (options === void 0)
        options = null;
      if ((typeof keyPath == 'string' || keyPath == null) && options == null) {
        return this[_createIndex_1](name, dart.as(keyPath, core.String));
      }
      if (options != null && (typeof keyPath == 'string' || keyPath == null)) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return this[_createIndex_2](name, dart.as(keyPath, core.String), options_1);
      }
      if ((dart.is(keyPath, core.List$(core.String)) || keyPath == null) && options == null) {
        let keyPath_1 = html_common.convertDartToNative_StringArray(dart.as(keyPath, core.List$(core.String)));
        return this[_createIndex_3](name, keyPath_1);
      }
      if (options != null && (dart.is(keyPath, core.List$(core.String)) || keyPath == null)) {
        let keyPath_1 = html_common.convertDartToNative_StringArray(dart.as(keyPath, core.List$(core.String)));
        let options_2 = html_common.convertDartToNative_Dictionary(options);
        return this[_createIndex_4](name, keyPath_1, options_2);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    [_put](value, key) {
      if (key === void 0)
        key = null;
      if (key != null) {
        let value_1 = html_common.convertDartToNative_SerializedScriptValue(value);
        let key_2 = html_common.convertDartToNative_SerializedScriptValue(key);
        return this[_put_1](value_1, key_2);
      }
      let value_1 = html_common.convertDartToNative_SerializedScriptValue(value);
      return this[_put_2](value_1);
    }
    static _cursorStreamFromResult(request, autoAdvance) {
      let controller = async.StreamController.new({sync: true});
      request.onError.listen(dart.as(dart.dload(controller, 'addError'), dart.functionType(dart.void, [html.Event])));
      request.onSuccess.listen(dart.fn(e => {
        let cursor = dart.as(request.result, Cursor);
        if (cursor == null) {
          dart.dsend(controller, 'close');
        } else {
          dart.dsend(controller, 'add', cursor);
          if (autoAdvance == true && dart.notNull(dart.as(dart.dload(controller, 'hasListener'), core.bool))) {
            cursor.next();
          }
        }
      }));
      return dart.as(dart.dload(controller, 'stream'), async.Stream$(Cursor));
    }
  }
  dart.setSignature(ObjectStore, {
    constructors: () => ({_: [ObjectStore, []]}),
    methods: () => ({
      add: [async.Future, [dart.dynamic], [dart.dynamic]],
      clear: [async.Future, []],
      delete: [async.Future, [dart.dynamic]],
      count: [async.Future$(core.int), [], [dart.dynamic]],
      put: [async.Future, [dart.dynamic], [dart.dynamic]],
      getObject: [async.Future, [dart.dynamic]],
      openCursor: [async.Stream$(CursorWithValue), [], {key: dart.dynamic, range: KeyRange, direction: core.String, autoAdvance: core.bool}],
      createIndex: [Index, [core.String, dart.dynamic], {unique: core.bool, multiEntry: core.bool}],
      [_add]: [exports.Request, [dart.dynamic], [dart.dynamic]],
      [_add_1]: [exports.Request, [dart.dynamic, dart.dynamic]],
      [_add_2]: [exports.Request, [dart.dynamic]],
      [_clear]: [exports.Request, []],
      [_count]: [exports.Request, [core.Object]],
      [_createIndex]: [Index, [core.String, dart.dynamic], [core.Map]],
      [_createIndex_1]: [Index, [dart.dynamic, core.String]],
      [_createIndex_2]: [Index, [dart.dynamic, core.String, dart.dynamic]],
      [_createIndex_3]: [Index, [dart.dynamic, core.List]],
      [_createIndex_4]: [Index, [dart.dynamic, core.List, dart.dynamic]],
      [_delete]: [exports.Request, [core.Object]],
      deleteIndex: [dart.void, [core.String]],
      [_get]: [exports.Request, [core.Object]],
      index: [Index, [core.String]],
      [_openCursor]: [exports.Request, [core.Object], [core.String]],
      openKeyCursor: [exports.Request, [core.Object], [core.String]],
      [_put]: [exports.Request, [dart.dynamic], [dart.dynamic]],
      [_put_1]: [exports.Request, [dart.dynamic, dart.dynamic]],
      [_put_2]: [exports.Request, [dart.dynamic]]
    }),
    statics: () => ({_cursorStreamFromResult: [async.Stream$(Cursor), [exports.Request, core.bool]]}),
    names: ['_cursorStreamFromResult']
  });
  ObjectStore[dart.metadata] = () => [dart.const(new _metadata.DomName('IDBObjectStore')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBObjectStore"))];
  let _get_result = Symbol('_get_result');
  dart.defineLazyClass(exports, {
    get Request() {
      class Request extends html.EventTarget {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get result() {
          return _convertNativeToDart_IDBAny(this[_get_result]);
        }
        get onError() {
          return exports.Request.errorEvent.forTarget(this);
        }
        get onSuccess() {
          return exports.Request.successEvent.forTarget(this);
        }
      }
      dart.setSignature(Request, {
        constructors: () => ({_: [exports.Request, []]})
      });
      Request[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('IDBRequest')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBRequest"))];
      return Request;
    }
  });
  dart.defineLazyClass(exports, {
    get OpenDBRequest() {
      class OpenDBRequest extends exports.Request {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get onBlocked() {
          return exports.OpenDBRequest.blockedEvent.forTarget(this);
        }
        get onUpgradeNeeded() {
          return exports.OpenDBRequest.upgradeNeededEvent.forTarget(this);
        }
      }
      dart.setSignature(OpenDBRequest, {
        constructors: () => ({_: [exports.OpenDBRequest, []]})
      });
      OpenDBRequest[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('IDBOpenDBRequest')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBOpenDBRequest,IDBVersionChangeRequest"))];
      return OpenDBRequest;
    }
  });
  dart.defineLazyProperties(OpenDBRequest, {
    get blockedEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('blocked'));
    },
    set blockedEvent(_) {},
    get upgradeNeededEvent() {
      return dart.const(new (html.EventStreamProvider$(exports.VersionChangeEvent))('upgradeneeded'));
    },
    set upgradeNeededEvent(_) {}
  });
  dart.defineLazyProperties(Request, {
    get errorEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('error'));
    },
    set errorEvent(_) {},
    get successEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('success'));
    },
    set successEvent(_) {}
  });
  dart.defineLazyClass(exports, {
    get Transaction() {
      class Transaction extends html.EventTarget {
        get completed() {
          let completer = async.Completer$(exports.Database).new();
          this.onComplete.first.then(dart.fn(_ => {
            dart.dsend(completer, 'complete', this.db);
          }));
          this.onError.first.then(dart.fn(e => {
            dart.dsend(completer, 'completeError', e);
          }));
          this.onAbort.first.then(dart.fn(e => {
            if (!dart.notNull(dart.as(dart.dload(completer, 'isCompleted'), core.bool))) {
              dart.dsend(completer, 'completeError', e);
            }
          }));
          return dart.as(dart.dload(completer, 'future'), async.Future$(exports.Database));
        }
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get onAbort() {
          return exports.Transaction.abortEvent.forTarget(this);
        }
        get onComplete() {
          return exports.Transaction.completeEvent.forTarget(this);
        }
        get onError() {
          return exports.Transaction.errorEvent.forTarget(this);
        }
      }
      dart.setSignature(Transaction, {
        constructors: () => ({_: [exports.Transaction, []]}),
        methods: () => ({
          abort: [dart.void, []],
          objectStore: [ObjectStore, [core.String]]
        })
      });
      Transaction[dart.metadata] = () => [dart.const(new _metadata.DomName('IDBTransaction')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("IDBTransaction"))];
      return Transaction;
    }
  });
  dart.defineLazyProperties(Transaction, {
    get abortEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('abort'));
    },
    set abortEvent(_) {},
    get completeEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('complete'));
    },
    set completeEvent(_) {},
    get errorEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('error'));
    },
    set errorEvent(_) {}
  });
  let __CastType0 = dart.typedef('__CastType0', () => dart.functionType(dart.void, [html.Event]));
  // Exports:
  exports.Cursor = Cursor;
  exports.CursorWithValue = CursorWithValue;
  exports.IdbFactory = IdbFactory;
  exports.Index = Index;
  exports.KeyRange = KeyRange;
  exports.ObjectStore = ObjectStore;
});
