dart_library.library('dart/svg', null, /* Imports */[
  "dart_runtime/dart",
  'dart/core',
  'dart/html_common',
  'dart/_metadata',
  'dart/_js_helper',
  'dart/_interceptors',
  'dart/collection'
], /* Lazy imports */[
  'dart/html'
], function(exports, dart, core, html_common, _metadata, _js_helper, _interceptors, collection, html$) {
  'use strict';
  let dartx = dart.dartx;
  class _SvgElementFactoryProvider extends core.Object {
    static createSvgElement_tag(tag) {
      let temp = html$.document.createElementNS("http://www.w3.org/2000/svg", tag);
      return dart.as(temp, exports.SvgElement);
    }
  }
  dart.setSignature(_SvgElementFactoryProvider, {
    statics: () => ({createSvgElement_tag: [exports.SvgElement, [core.String]]}),
    names: ['createSvgElement_tag']
  });
  let _children = Symbol('_children');
  let _svgClassName = Symbol('_svgClassName');
  dart.defineLazyClass(exports, {
    get SvgElement() {
      class SvgElement extends html$.Element {
        static tag(tag) {
          return dart.as(html$.document.createElementNS("http://www.w3.org/2000/svg", tag), exports.SvgElement);
        }
        static svg(svg, opts) {
          let validator = opts && 'validator' in opts ? opts.validator : null;
          let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
          if (validator == null && treeSanitizer == null) {
            validator = new html$.NodeValidatorBuilder.common();
            validator.allowSvg();
          }
          let match = dart.dsend(exports.SvgElement._START_TAG_REGEXP, 'firstMatch', svg);
          let parentElement = null;
          if (match != null && dart.equals(dart.dsend(dart.dsend(match, 'group', 1), 'toLowerCase'), 'svg')) {
            parentElement = html$.document.body;
          } else {
            parentElement = exports.SvgSvgElement.new();
          }
          let fragment = dart.dsend(parentElement, 'createFragment', svg, {validator: validator, treeSanitizer: treeSanitizer});
          return dart.as(dart.dload(dart.dsend(dart.dload(fragment, 'nodes'), 'where', dart.fn(e => dart.is(e, exports.SvgElement), core.bool, [dart.dynamic])), 'single'), exports.SvgElement);
        }
        get classes() {
          return new _AttributeClassSet(this);
        }
        get children() {
          return new html_common.FilteredElementList(this);
        }
        set children(value) {
          let children = this.children;
          dart.dsend(children, 'clear');
          dart.dsend(children, 'addAll', value);
        }
        get outerHtml() {
          let container = html$.Element.tag("div");
          let cloned = dart.as(this.clone(true), exports.SvgElement);
          dart.dsend(dart.dload(container, 'children'), 'add', cloned);
          return dart.as(dart.dload(container, 'innerHtml'), core.String);
        }
        get innerHtml() {
          let container = html$.Element.tag("div");
          let cloned = dart.as(this.clone(true), exports.SvgElement);
          dart.dsend(dart.dload(container, 'children'), 'addAll', cloned.children);
          return dart.as(dart.dload(container, 'innerHtml'), core.String);
        }
        set innerHtml(value) {
          this.setInnerHtml(value);
        }
        createFragment(svg, opts) {
          let validator = opts && 'validator' in opts ? opts.validator : null;
          let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
          if (treeSanitizer == null) {
            if (validator == null) {
              validator = new html$.NodeValidatorBuilder.common();
              validator.allowSvg();
            }
            treeSanitizer = html$.NodeTreeSanitizer.new(validator);
          }
          let html = `<svg version="1.1">${svg}</svg>`;
          let fragment = html$.document.body.createFragment(dart.as(html, core.String), {treeSanitizer: treeSanitizer});
          let svgFragment = html$.DocumentFragment.new();
          let root = dart.dload(dart.dload(fragment, 'nodes'), 'single');
          while (dart.dload(root, 'firstChild') != null) {
            dart.dsend(svgFragment, 'append', dart.dload(root, 'firstChild'));
          }
          return dart.as(svgFragment, html$.DocumentFragment);
        }
        insertAdjacentText(where, text) {
          dart.throw(new core.UnsupportedError("Cannot invoke insertAdjacentText on SVG."));
        }
        insertAdjacentHtml(where, text, opts) {
          let validator = opts && 'validator' in opts ? opts.validator : null;
          let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
          dart.throw(new core.UnsupportedError("Cannot invoke insertAdjacentHtml on SVG."));
        }
        insertAdjacentElement(where, element) {
          dart.throw(new core.UnsupportedError("Cannot invoke insertAdjacentElement on SVG."));
        }
        get [_children]() {
          dart.throw(new core.UnsupportedError("Cannot get _children on SVG."));
        }
        get isContentEditable() {
          return false;
        }
        click() {
          dart.throw(new core.UnsupportedError("Cannot invoke click SVG."));
        }
        static isTagSupported(tag) {
          let e = exports.SvgElement.tag(tag);
          return dart.is(e, exports.SvgElement) && !dart.is(e, html$.UnknownElement);
        }
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.ownerSvgElement = null;
          this.viewportElement = null;
          this.xmlbase = null;
          this.xmllang = null;
          this.xmlspace = null;
          super.created();
        }
        get [_svgClassName]() {
          return dart.as(this.className, AnimatedString);
        }
        get tabIndex() {
          return dart.as(this.tabIndex, core.int);
        }
        set tabIndex(value) {
          this.tabIndex = value;
        }
        get onAbort() {
          return exports.SvgElement.abortEvent.forElement(this);
        }
        get onBlur() {
          return exports.SvgElement.blurEvent.forElement(this);
        }
        get onCanPlay() {
          return exports.SvgElement.canPlayEvent.forElement(this);
        }
        get onCanPlayThrough() {
          return exports.SvgElement.canPlayThroughEvent.forElement(this);
        }
        get onChange() {
          return exports.SvgElement.changeEvent.forElement(this);
        }
        get onClick() {
          return exports.SvgElement.clickEvent.forElement(this);
        }
        get onContextMenu() {
          return exports.SvgElement.contextMenuEvent.forElement(this);
        }
        get onDoubleClick() {
          return exports.SvgElement.doubleClickEvent.forElement(this);
        }
        get onDrag() {
          return exports.SvgElement.dragEvent.forElement(this);
        }
        get onDragEnd() {
          return exports.SvgElement.dragEndEvent.forElement(this);
        }
        get onDragEnter() {
          return exports.SvgElement.dragEnterEvent.forElement(this);
        }
        get onDragLeave() {
          return exports.SvgElement.dragLeaveEvent.forElement(this);
        }
        get onDragOver() {
          return exports.SvgElement.dragOverEvent.forElement(this);
        }
        get onDragStart() {
          return exports.SvgElement.dragStartEvent.forElement(this);
        }
        get onDrop() {
          return exports.SvgElement.dropEvent.forElement(this);
        }
        get onDurationChange() {
          return exports.SvgElement.durationChangeEvent.forElement(this);
        }
        get onEmptied() {
          return exports.SvgElement.emptiedEvent.forElement(this);
        }
        get onEnded() {
          return exports.SvgElement.endedEvent.forElement(this);
        }
        get onError() {
          return exports.SvgElement.errorEvent.forElement(this);
        }
        get onFocus() {
          return exports.SvgElement.focusEvent.forElement(this);
        }
        get onInput() {
          return exports.SvgElement.inputEvent.forElement(this);
        }
        get onInvalid() {
          return exports.SvgElement.invalidEvent.forElement(this);
        }
        get onKeyDown() {
          return exports.SvgElement.keyDownEvent.forElement(this);
        }
        get onKeyPress() {
          return exports.SvgElement.keyPressEvent.forElement(this);
        }
        get onKeyUp() {
          return exports.SvgElement.keyUpEvent.forElement(this);
        }
        get onLoad() {
          return exports.SvgElement.loadEvent.forElement(this);
        }
        get onLoadedData() {
          return exports.SvgElement.loadedDataEvent.forElement(this);
        }
        get onLoadedMetadata() {
          return exports.SvgElement.loadedMetadataEvent.forElement(this);
        }
        get onMouseDown() {
          return exports.SvgElement.mouseDownEvent.forElement(this);
        }
        get onMouseEnter() {
          return exports.SvgElement.mouseEnterEvent.forElement(this);
        }
        get onMouseLeave() {
          return exports.SvgElement.mouseLeaveEvent.forElement(this);
        }
        get onMouseMove() {
          return exports.SvgElement.mouseMoveEvent.forElement(this);
        }
        get onMouseOut() {
          return exports.SvgElement.mouseOutEvent.forElement(this);
        }
        get onMouseOver() {
          return exports.SvgElement.mouseOverEvent.forElement(this);
        }
        get onMouseUp() {
          return exports.SvgElement.mouseUpEvent.forElement(this);
        }
        get onMouseWheel() {
          return exports.SvgElement.mouseWheelEvent.forElement(this);
        }
        get onPause() {
          return exports.SvgElement.pauseEvent.forElement(this);
        }
        get onPlay() {
          return exports.SvgElement.playEvent.forElement(this);
        }
        get onPlaying() {
          return exports.SvgElement.playingEvent.forElement(this);
        }
        get onRateChange() {
          return exports.SvgElement.rateChangeEvent.forElement(this);
        }
        get onReset() {
          return exports.SvgElement.resetEvent.forElement(this);
        }
        get onResize() {
          return exports.SvgElement.resizeEvent.forElement(this);
        }
        get onScroll() {
          return exports.SvgElement.scrollEvent.forElement(this);
        }
        get onSeeked() {
          return exports.SvgElement.seekedEvent.forElement(this);
        }
        get onSeeking() {
          return exports.SvgElement.seekingEvent.forElement(this);
        }
        get onSelect() {
          return exports.SvgElement.selectEvent.forElement(this);
        }
        get onStalled() {
          return exports.SvgElement.stalledEvent.forElement(this);
        }
        get onSubmit() {
          return exports.SvgElement.submitEvent.forElement(this);
        }
        get onSuspend() {
          return exports.SvgElement.suspendEvent.forElement(this);
        }
        get onTimeUpdate() {
          return exports.SvgElement.timeUpdateEvent.forElement(this);
        }
        get onVolumeChange() {
          return exports.SvgElement.volumeChangeEvent.forElement(this);
        }
        get onWaiting() {
          return exports.SvgElement.waitingEvent.forElement(this);
        }
      }
      SvgElement[dart.implements] = () => [html$.GlobalEventHandlers];
      dart.defineNamedConstructor(SvgElement, 'created');
      dart.setSignature(SvgElement, {
        constructors: () => ({
          tag: [exports.SvgElement, [core.String]],
          svg: [exports.SvgElement, [core.String], {validator: html$.NodeValidator, treeSanitizer: html$.NodeTreeSanitizer}],
          _: [exports.SvgElement, []],
          created: [exports.SvgElement, []]
        })
      });
      SvgElement[dart.metadata] = () => [dart.const(new _metadata.DomName('SVGElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGElement"))];
      return SvgElement;
    }
  });
  dart.defineLazyClass(exports, {
    get GraphicsElement() {
      class GraphicsElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.farthestViewportElement = null;
          this.nearestViewportElement = null;
          this.transform = null;
          this.requiredExtensions = null;
          this.requiredFeatures = null;
          this.systemLanguage = null;
          super.created();
        }
      }
      GraphicsElement[dart.implements] = () => [Tests];
      dart.defineNamedConstructor(GraphicsElement, 'created');
      dart.setSignature(GraphicsElement, {
        constructors: () => ({
          _: [exports.GraphicsElement, []],
          created: [exports.GraphicsElement, []]
        }),
        methods: () => ({
          getBBox: [Rect, []],
          getCtm: [Matrix, []],
          getScreenCtm: [Matrix, []],
          getTransformToElement: [Matrix, [exports.SvgElement]],
          hasExtension: [core.bool, [core.String]]
        })
      });
      GraphicsElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGGraphicsElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SVGGraphicsElement"))];
      return GraphicsElement;
    }
  });
  dart.defineLazyClass(exports, {
    get AElement() {
      class AElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("a"), exports.AElement);
        }
        created() {
          this.target = null;
          this.href = null;
          super.created();
        }
      }
      AElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(AElement, 'created');
      dart.setSignature(AElement, {
        constructors: () => ({
          _: [exports.AElement, []],
          new: [exports.AElement, []],
          created: [exports.AElement, []]
        })
      });
      AElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAElement"))];
      return AElement;
    }
  });
  dart.defineLazyClass(exports, {
    get TextContentElement() {
      class TextContentElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.lengthAdjust = null;
          this.textLength = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(TextContentElement, 'created');
      dart.setSignature(TextContentElement, {
        constructors: () => ({
          _: [exports.TextContentElement, []],
          created: [exports.TextContentElement, []]
        }),
        methods: () => ({
          getCharNumAtPosition: [core.int, [Point]],
          getComputedTextLength: [core.double, []],
          getEndPositionOfChar: [Point, [core.int]],
          getExtentOfChar: [Rect, [core.int]],
          getNumberOfChars: [core.int, []],
          getRotationOfChar: [core.double, [core.int]],
          getStartPositionOfChar: [Point, [core.int]],
          getSubStringLength: [core.double, [core.int, core.int]],
          selectSubString: [dart.void, [core.int, core.int]]
        })
      });
      TextContentElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTextContentElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTextContentElement"))];
      return TextContentElement;
    }
  });
  dart.defineLazyClass(exports, {
    get TextPositioningElement() {
      class TextPositioningElement extends exports.TextContentElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.dx = null;
          this.dy = null;
          this.rotate = null;
          this.x = null;
          this.y = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(TextPositioningElement, 'created');
      dart.setSignature(TextPositioningElement, {
        constructors: () => ({
          _: [exports.TextPositioningElement, []],
          created: [exports.TextPositioningElement, []]
        })
      });
      TextPositioningElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTextPositioningElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTextPositioningElement"))];
      return TextPositioningElement;
    }
  });
  dart.defineLazyClass(exports, {
    get AltGlyphElement() {
      class AltGlyphElement extends exports.TextPositioningElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("altGlyph"), exports.AltGlyphElement);
        }
        created() {
          this.format = null;
          this.glyphRef = null;
          this.href = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('altGlyph')) && dart.is(exports.SvgElement.tag('altGlyph'), exports.AltGlyphElement);
        }
      }
      AltGlyphElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(AltGlyphElement, 'created');
      dart.setSignature(AltGlyphElement, {
        constructors: () => ({
          _: [exports.AltGlyphElement, []],
          new: [exports.AltGlyphElement, []],
          created: [exports.AltGlyphElement, []]
        })
      });
      AltGlyphElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAltGlyphElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAltGlyphElement"))];
      return AltGlyphElement;
    }
  });
  class Angle extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Angle, {
    constructors: () => ({_: [Angle, []]}),
    methods: () => ({
      convertToSpecifiedUnits: [dart.void, [core.int]],
      newValueSpecifiedUnits: [dart.void, [core.int, core.num]]
    })
  });
  Angle[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAngle')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAngle"))];
  Angle.SVG_ANGLETYPE_DEG = 2;
  Angle.SVG_ANGLETYPE_GRAD = 4;
  Angle.SVG_ANGLETYPE_RAD = 3;
  Angle.SVG_ANGLETYPE_UNKNOWN = 0;
  Angle.SVG_ANGLETYPE_UNSPECIFIED = 1;
  dart.defineLazyClass(exports, {
    get AnimationElement() {
      class AnimationElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("animation"), exports.AnimationElement);
        }
        created() {
          this.targetElement = null;
          this.requiredExtensions = null;
          this.requiredFeatures = null;
          this.systemLanguage = null;
          super.created();
        }
      }
      AnimationElement[dart.implements] = () => [Tests];
      dart.defineNamedConstructor(AnimationElement, 'created');
      dart.setSignature(AnimationElement, {
        constructors: () => ({
          _: [exports.AnimationElement, []],
          new: [exports.AnimationElement, []],
          created: [exports.AnimationElement, []]
        }),
        methods: () => ({
          beginElement: [dart.void, []],
          beginElementAt: [dart.void, [core.num]],
          endElement: [dart.void, []],
          endElementAt: [dart.void, [core.num]],
          getCurrentTime: [core.double, []],
          getSimpleDuration: [core.double, []],
          getStartTime: [core.double, []],
          hasExtension: [core.bool, [core.String]]
        })
      });
      AnimationElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimationElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimationElement"))];
      return AnimationElement;
    }
  });
  dart.defineLazyClass(exports, {
    get AnimateElement() {
      class AnimateElement extends exports.AnimationElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("animate"), exports.AnimateElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('animate')) && dart.is(exports.SvgElement.tag('animate'), exports.AnimateElement);
        }
      }
      dart.defineNamedConstructor(AnimateElement, 'created');
      dart.setSignature(AnimateElement, {
        constructors: () => ({
          _: [exports.AnimateElement, []],
          new: [exports.AnimateElement, []],
          created: [exports.AnimateElement, []]
        })
      });
      AnimateElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimateElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimateElement"))];
      return AnimateElement;
    }
  });
  dart.defineLazyClass(exports, {
    get AnimateMotionElement() {
      class AnimateMotionElement extends exports.AnimationElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("animateMotion"), exports.AnimateMotionElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('animateMotion')) && dart.is(exports.SvgElement.tag('animateMotion'), exports.AnimateMotionElement);
        }
      }
      dart.defineNamedConstructor(AnimateMotionElement, 'created');
      dart.setSignature(AnimateMotionElement, {
        constructors: () => ({
          _: [exports.AnimateMotionElement, []],
          new: [exports.AnimateMotionElement, []],
          created: [exports.AnimateMotionElement, []]
        })
      });
      AnimateMotionElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimateMotionElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimateMotionElement"))];
      return AnimateMotionElement;
    }
  });
  dart.defineLazyClass(exports, {
    get AnimateTransformElement() {
      class AnimateTransformElement extends exports.AnimationElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("animateTransform"), exports.AnimateTransformElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('animateTransform')) && dart.is(exports.SvgElement.tag('animateTransform'), exports.AnimateTransformElement);
        }
      }
      dart.defineNamedConstructor(AnimateTransformElement, 'created');
      dart.setSignature(AnimateTransformElement, {
        constructors: () => ({
          _: [exports.AnimateTransformElement, []],
          new: [exports.AnimateTransformElement, []],
          created: [exports.AnimateTransformElement, []]
        })
      });
      AnimateTransformElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimateTransformElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimateTransformElement"))];
      return AnimateTransformElement;
    }
  });
  class AnimatedAngle extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedAngle, {
    constructors: () => ({_: [AnimatedAngle, []]})
  });
  AnimatedAngle[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedAngle')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedAngle"))];
  class AnimatedBoolean extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedBoolean, {
    constructors: () => ({_: [AnimatedBoolean, []]})
  });
  AnimatedBoolean[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedBoolean')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedBoolean"))];
  class AnimatedEnumeration extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedEnumeration, {
    constructors: () => ({_: [AnimatedEnumeration, []]})
  });
  AnimatedEnumeration[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedEnumeration')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedEnumeration"))];
  class AnimatedInteger extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedInteger, {
    constructors: () => ({_: [AnimatedInteger, []]})
  });
  AnimatedInteger[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedInteger')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedInteger"))];
  class AnimatedLength extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedLength, {
    constructors: () => ({_: [AnimatedLength, []]})
  });
  AnimatedLength[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedLength')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedLength"))];
  class AnimatedLengthList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedLengthList, {
    constructors: () => ({_: [AnimatedLengthList, []]})
  });
  AnimatedLengthList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedLengthList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedLengthList"))];
  class AnimatedNumber extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedNumber, {
    constructors: () => ({_: [AnimatedNumber, []]})
  });
  AnimatedNumber[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedNumber')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedNumber"))];
  class AnimatedNumberList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedNumberList, {
    constructors: () => ({_: [AnimatedNumberList, []]})
  });
  AnimatedNumberList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedNumberList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedNumberList"))];
  class AnimatedPreserveAspectRatio extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedPreserveAspectRatio, {
    constructors: () => ({_: [AnimatedPreserveAspectRatio, []]})
  });
  AnimatedPreserveAspectRatio[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedPreserveAspectRatio')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedPreserveAspectRatio"))];
  class AnimatedRect extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedRect, {
    constructors: () => ({_: [AnimatedRect, []]})
  });
  AnimatedRect[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedRect')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedRect"))];
  class AnimatedString extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedString, {
    constructors: () => ({_: [AnimatedString, []]})
  });
  AnimatedString[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedString')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedString"))];
  class AnimatedTransformList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimatedTransformList, {
    constructors: () => ({_: [AnimatedTransformList, []]})
  });
  AnimatedTransformList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAnimatedTransformList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAnimatedTransformList"))];
  dart.defineLazyClass(exports, {
    get GeometryElement() {
      class GeometryElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(GeometryElement, 'created');
      dart.setSignature(GeometryElement, {
        constructors: () => ({
          _: [exports.GeometryElement, []],
          created: [exports.GeometryElement, []]
        }),
        methods: () => ({
          isPointInFill: [core.bool, [Point]],
          isPointInStroke: [core.bool, [Point]]
        })
      });
      GeometryElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGGeometryElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SVGGeometryElement"))];
      return GeometryElement;
    }
  });
  dart.defineLazyClass(exports, {
    get CircleElement() {
      class CircleElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("circle"), exports.CircleElement);
        }
        created() {
          this.cx = null;
          this.cy = null;
          this.r = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(CircleElement, 'created');
      dart.setSignature(CircleElement, {
        constructors: () => ({
          _: [exports.CircleElement, []],
          new: [exports.CircleElement, []],
          created: [exports.CircleElement, []]
        })
      });
      CircleElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGCircleElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGCircleElement"))];
      return CircleElement;
    }
  });
  dart.defineLazyClass(exports, {
    get ClipPathElement() {
      class ClipPathElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("clipPath"), exports.ClipPathElement);
        }
        created() {
          this.clipPathUnits = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(ClipPathElement, 'created');
      dart.setSignature(ClipPathElement, {
        constructors: () => ({
          _: [exports.ClipPathElement, []],
          new: [exports.ClipPathElement, []],
          created: [exports.ClipPathElement, []]
        })
      });
      ClipPathElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGClipPathElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGClipPathElement"))];
      return ClipPathElement;
    }
  });
  dart.defineLazyClass(exports, {
    get DefsElement() {
      class DefsElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("defs"), exports.DefsElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(DefsElement, 'created');
      dart.setSignature(DefsElement, {
        constructors: () => ({
          _: [exports.DefsElement, []],
          new: [exports.DefsElement, []],
          created: [exports.DefsElement, []]
        })
      });
      DefsElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGDefsElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGDefsElement"))];
      return DefsElement;
    }
  });
  dart.defineLazyClass(exports, {
    get DescElement() {
      class DescElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("desc"), exports.DescElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(DescElement, 'created');
      dart.setSignature(DescElement, {
        constructors: () => ({
          _: [exports.DescElement, []],
          new: [exports.DescElement, []],
          created: [exports.DescElement, []]
        })
      });
      DescElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGDescElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGDescElement"))];
      return DescElement;
    }
  });
  dart.defineLazyClass(exports, {
    get DiscardElement() {
      class DiscardElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(DiscardElement, 'created');
      dart.setSignature(DiscardElement, {
        constructors: () => ({
          _: [exports.DiscardElement, []],
          created: [exports.DiscardElement, []]
        })
      });
      DiscardElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGDiscardElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SVGDiscardElement"))];
      return DiscardElement;
    }
  });
  dart.defineLazyClass(exports, {
    get EllipseElement() {
      class EllipseElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("ellipse"), exports.EllipseElement);
        }
        created() {
          this.cx = null;
          this.cy = null;
          this.rx = null;
          this.ry = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(EllipseElement, 'created');
      dart.setSignature(EllipseElement, {
        constructors: () => ({
          _: [exports.EllipseElement, []],
          new: [exports.EllipseElement, []],
          created: [exports.EllipseElement, []]
        })
      });
      EllipseElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGEllipseElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGEllipseElement"))];
      return EllipseElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEBlendElement() {
      class FEBlendElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feBlend"), exports.FEBlendElement);
        }
        created() {
          this.in1 = null;
          this.in2 = null;
          this.mode = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feBlend')) && dart.is(exports.SvgElement.tag('feBlend'), exports.FEBlendElement);
        }
      }
      FEBlendElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEBlendElement, 'created');
      dart.setSignature(FEBlendElement, {
        constructors: () => ({
          _: [exports.FEBlendElement, []],
          new: [exports.FEBlendElement, []],
          created: [exports.FEBlendElement, []]
        })
      });
      FEBlendElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEBlendElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEBlendElement"))];
      return FEBlendElement;
    }
  });
  exports.FEBlendElement.SVG_FEBLEND_MODE_DARKEN = 4;
  exports.FEBlendElement.SVG_FEBLEND_MODE_LIGHTEN = 5;
  exports.FEBlendElement.SVG_FEBLEND_MODE_MULTIPLY = 2;
  exports.FEBlendElement.SVG_FEBLEND_MODE_NORMAL = 1;
  exports.FEBlendElement.SVG_FEBLEND_MODE_SCREEN = 3;
  exports.FEBlendElement.SVG_FEBLEND_MODE_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get FEColorMatrixElement() {
      class FEColorMatrixElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feColorMatrix"), exports.FEColorMatrixElement);
        }
        created() {
          this.in1 = null;
          this.type = null;
          this.values = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feColorMatrix')) && dart.is(exports.SvgElement.tag('feColorMatrix'), exports.FEColorMatrixElement);
        }
      }
      FEColorMatrixElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEColorMatrixElement, 'created');
      dart.setSignature(FEColorMatrixElement, {
        constructors: () => ({
          _: [exports.FEColorMatrixElement, []],
          new: [exports.FEColorMatrixElement, []],
          created: [exports.FEColorMatrixElement, []]
        })
      });
      FEColorMatrixElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEColorMatrixElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEColorMatrixElement"))];
      return FEColorMatrixElement;
    }
  });
  exports.FEColorMatrixElement.SVG_FECOLORMATRIX_TYPE_HUEROTATE = 3;
  exports.FEColorMatrixElement.SVG_FECOLORMATRIX_TYPE_LUMINANCETOALPHA = 4;
  exports.FEColorMatrixElement.SVG_FECOLORMATRIX_TYPE_MATRIX = 1;
  exports.FEColorMatrixElement.SVG_FECOLORMATRIX_TYPE_SATURATE = 2;
  exports.FEColorMatrixElement.SVG_FECOLORMATRIX_TYPE_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get FEComponentTransferElement() {
      class FEComponentTransferElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feComponentTransfer"), exports.FEComponentTransferElement);
        }
        created() {
          this.in1 = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feComponentTransfer')) && dart.is(exports.SvgElement.tag('feComponentTransfer'), exports.FEComponentTransferElement);
        }
      }
      FEComponentTransferElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEComponentTransferElement, 'created');
      dart.setSignature(FEComponentTransferElement, {
        constructors: () => ({
          _: [exports.FEComponentTransferElement, []],
          new: [exports.FEComponentTransferElement, []],
          created: [exports.FEComponentTransferElement, []]
        })
      });
      FEComponentTransferElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEComponentTransferElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEComponentTransferElement"))];
      return FEComponentTransferElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FECompositeElement() {
      class FECompositeElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.in1 = null;
          this.in2 = null;
          this.k1 = null;
          this.k2 = null;
          this.k3 = null;
          this.k4 = null;
          this.operator = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
      }
      FECompositeElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FECompositeElement, 'created');
      dart.setSignature(FECompositeElement, {
        constructors: () => ({
          _: [exports.FECompositeElement, []],
          created: [exports.FECompositeElement, []]
        })
      });
      FECompositeElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFECompositeElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFECompositeElement"))];
      return FECompositeElement;
    }
  });
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_ARITHMETIC = 6;
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_ATOP = 4;
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_IN = 2;
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_OUT = 3;
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_OVER = 1;
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_UNKNOWN = 0;
  exports.FECompositeElement.SVG_FECOMPOSITE_OPERATOR_XOR = 5;
  dart.defineLazyClass(exports, {
    get FEConvolveMatrixElement() {
      class FEConvolveMatrixElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feConvolveMatrix"), exports.FEConvolveMatrixElement);
        }
        created() {
          this.bias = null;
          this.divisor = null;
          this.edgeMode = null;
          this.in1 = null;
          this.kernelMatrix = null;
          this.kernelUnitLengthX = null;
          this.kernelUnitLengthY = null;
          this.orderX = null;
          this.orderY = null;
          this.preserveAlpha = null;
          this.targetX = null;
          this.targetY = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feConvolveMatrix')) && dart.is(exports.SvgElement.tag('feConvolveMatrix'), exports.FEConvolveMatrixElement);
        }
      }
      FEConvolveMatrixElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEConvolveMatrixElement, 'created');
      dart.setSignature(FEConvolveMatrixElement, {
        constructors: () => ({
          _: [exports.FEConvolveMatrixElement, []],
          new: [exports.FEConvolveMatrixElement, []],
          created: [exports.FEConvolveMatrixElement, []]
        })
      });
      FEConvolveMatrixElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEConvolveMatrixElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEConvolveMatrixElement"))];
      return FEConvolveMatrixElement;
    }
  });
  exports.FEConvolveMatrixElement.SVG_EDGEMODE_DUPLICATE = 1;
  exports.FEConvolveMatrixElement.SVG_EDGEMODE_NONE = 3;
  exports.FEConvolveMatrixElement.SVG_EDGEMODE_UNKNOWN = 0;
  exports.FEConvolveMatrixElement.SVG_EDGEMODE_WRAP = 2;
  dart.defineLazyClass(exports, {
    get FEDiffuseLightingElement() {
      class FEDiffuseLightingElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feDiffuseLighting"), exports.FEDiffuseLightingElement);
        }
        created() {
          this.diffuseConstant = null;
          this.in1 = null;
          this.kernelUnitLengthX = null;
          this.kernelUnitLengthY = null;
          this.surfaceScale = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feDiffuseLighting')) && dart.is(exports.SvgElement.tag('feDiffuseLighting'), exports.FEDiffuseLightingElement);
        }
      }
      FEDiffuseLightingElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEDiffuseLightingElement, 'created');
      dart.setSignature(FEDiffuseLightingElement, {
        constructors: () => ({
          _: [exports.FEDiffuseLightingElement, []],
          new: [exports.FEDiffuseLightingElement, []],
          created: [exports.FEDiffuseLightingElement, []]
        })
      });
      FEDiffuseLightingElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEDiffuseLightingElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEDiffuseLightingElement"))];
      return FEDiffuseLightingElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEDisplacementMapElement() {
      class FEDisplacementMapElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feDisplacementMap"), exports.FEDisplacementMapElement);
        }
        created() {
          this.in1 = null;
          this.in2 = null;
          this.scale = null;
          this.xChannelSelector = null;
          this.yChannelSelector = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feDisplacementMap')) && dart.is(exports.SvgElement.tag('feDisplacementMap'), exports.FEDisplacementMapElement);
        }
      }
      FEDisplacementMapElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEDisplacementMapElement, 'created');
      dart.setSignature(FEDisplacementMapElement, {
        constructors: () => ({
          _: [exports.FEDisplacementMapElement, []],
          new: [exports.FEDisplacementMapElement, []],
          created: [exports.FEDisplacementMapElement, []]
        })
      });
      FEDisplacementMapElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEDisplacementMapElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEDisplacementMapElement"))];
      return FEDisplacementMapElement;
    }
  });
  exports.FEDisplacementMapElement.SVG_CHANNEL_A = 4;
  exports.FEDisplacementMapElement.SVG_CHANNEL_B = 3;
  exports.FEDisplacementMapElement.SVG_CHANNEL_G = 2;
  exports.FEDisplacementMapElement.SVG_CHANNEL_R = 1;
  exports.FEDisplacementMapElement.SVG_CHANNEL_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get FEDistantLightElement() {
      class FEDistantLightElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feDistantLight"), exports.FEDistantLightElement);
        }
        created() {
          this.azimuth = null;
          this.elevation = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feDistantLight')) && dart.is(exports.SvgElement.tag('feDistantLight'), exports.FEDistantLightElement);
        }
      }
      dart.defineNamedConstructor(FEDistantLightElement, 'created');
      dart.setSignature(FEDistantLightElement, {
        constructors: () => ({
          _: [exports.FEDistantLightElement, []],
          new: [exports.FEDistantLightElement, []],
          created: [exports.FEDistantLightElement, []]
        })
      });
      FEDistantLightElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEDistantLightElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEDistantLightElement"))];
      return FEDistantLightElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEFloodElement() {
      class FEFloodElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feFlood"), exports.FEFloodElement);
        }
        created() {
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feFlood')) && dart.is(exports.SvgElement.tag('feFlood'), exports.FEFloodElement);
        }
      }
      FEFloodElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEFloodElement, 'created');
      dart.setSignature(FEFloodElement, {
        constructors: () => ({
          _: [exports.FEFloodElement, []],
          new: [exports.FEFloodElement, []],
          created: [exports.FEFloodElement, []]
        })
      });
      FEFloodElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEFloodElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEFloodElement"))];
      return FEFloodElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGComponentTransferFunctionElement() {
      class _SVGComponentTransferFunctionElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGComponentTransferFunctionElement, 'created');
      dart.setSignature(_SVGComponentTransferFunctionElement, {
        constructors: () => ({
          _: [exports._SVGComponentTransferFunctionElement, []],
          created: [exports._SVGComponentTransferFunctionElement, []]
        })
      });
      _SVGComponentTransferFunctionElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGComponentTransferFunctionElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGComponentTransferFunctionElement"))];
      return _SVGComponentTransferFunctionElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEFuncAElement() {
      class FEFuncAElement extends exports._SVGComponentTransferFunctionElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feFuncA"), exports.FEFuncAElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feFuncA')) && dart.is(exports.SvgElement.tag('feFuncA'), exports.FEFuncAElement);
        }
      }
      dart.defineNamedConstructor(FEFuncAElement, 'created');
      dart.setSignature(FEFuncAElement, {
        constructors: () => ({
          _: [exports.FEFuncAElement, []],
          new: [exports.FEFuncAElement, []],
          created: [exports.FEFuncAElement, []]
        })
      });
      FEFuncAElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEFuncAElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEFuncAElement"))];
      return FEFuncAElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEFuncBElement() {
      class FEFuncBElement extends exports._SVGComponentTransferFunctionElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feFuncB"), exports.FEFuncBElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feFuncB')) && dart.is(exports.SvgElement.tag('feFuncB'), exports.FEFuncBElement);
        }
      }
      dart.defineNamedConstructor(FEFuncBElement, 'created');
      dart.setSignature(FEFuncBElement, {
        constructors: () => ({
          _: [exports.FEFuncBElement, []],
          new: [exports.FEFuncBElement, []],
          created: [exports.FEFuncBElement, []]
        })
      });
      FEFuncBElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEFuncBElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEFuncBElement"))];
      return FEFuncBElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEFuncGElement() {
      class FEFuncGElement extends exports._SVGComponentTransferFunctionElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feFuncG"), exports.FEFuncGElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feFuncG')) && dart.is(exports.SvgElement.tag('feFuncG'), exports.FEFuncGElement);
        }
      }
      dart.defineNamedConstructor(FEFuncGElement, 'created');
      dart.setSignature(FEFuncGElement, {
        constructors: () => ({
          _: [exports.FEFuncGElement, []],
          new: [exports.FEFuncGElement, []],
          created: [exports.FEFuncGElement, []]
        })
      });
      FEFuncGElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEFuncGElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEFuncGElement"))];
      return FEFuncGElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEFuncRElement() {
      class FEFuncRElement extends exports._SVGComponentTransferFunctionElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feFuncR"), exports.FEFuncRElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feFuncR')) && dart.is(exports.SvgElement.tag('feFuncR'), exports.FEFuncRElement);
        }
      }
      dart.defineNamedConstructor(FEFuncRElement, 'created');
      dart.setSignature(FEFuncRElement, {
        constructors: () => ({
          _: [exports.FEFuncRElement, []],
          new: [exports.FEFuncRElement, []],
          created: [exports.FEFuncRElement, []]
        })
      });
      FEFuncRElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEFuncRElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEFuncRElement"))];
      return FEFuncRElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEGaussianBlurElement() {
      class FEGaussianBlurElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feGaussianBlur"), exports.FEGaussianBlurElement);
        }
        created() {
          this.in1 = null;
          this.stdDeviationX = null;
          this.stdDeviationY = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feGaussianBlur')) && dart.is(exports.SvgElement.tag('feGaussianBlur'), exports.FEGaussianBlurElement);
        }
      }
      FEGaussianBlurElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEGaussianBlurElement, 'created');
      dart.setSignature(FEGaussianBlurElement, {
        constructors: () => ({
          _: [exports.FEGaussianBlurElement, []],
          new: [exports.FEGaussianBlurElement, []],
          created: [exports.FEGaussianBlurElement, []]
        }),
        methods: () => ({setStdDeviation: [dart.void, [core.num, core.num]]})
      });
      FEGaussianBlurElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEGaussianBlurElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEGaussianBlurElement"))];
      return FEGaussianBlurElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEImageElement() {
      class FEImageElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feImage"), exports.FEImageElement);
        }
        created() {
          this.preserveAspectRatio = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.href = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feImage')) && dart.is(exports.SvgElement.tag('feImage'), exports.FEImageElement);
        }
      }
      FEImageElement[dart.implements] = () => [FilterPrimitiveStandardAttributes, UriReference];
      dart.defineNamedConstructor(FEImageElement, 'created');
      dart.setSignature(FEImageElement, {
        constructors: () => ({
          _: [exports.FEImageElement, []],
          new: [exports.FEImageElement, []],
          created: [exports.FEImageElement, []]
        })
      });
      FEImageElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEImageElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEImageElement"))];
      return FEImageElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEMergeElement() {
      class FEMergeElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feMerge"), exports.FEMergeElement);
        }
        created() {
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feMerge')) && dart.is(exports.SvgElement.tag('feMerge'), exports.FEMergeElement);
        }
      }
      FEMergeElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEMergeElement, 'created');
      dart.setSignature(FEMergeElement, {
        constructors: () => ({
          _: [exports.FEMergeElement, []],
          new: [exports.FEMergeElement, []],
          created: [exports.FEMergeElement, []]
        })
      });
      FEMergeElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEMergeElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEMergeElement"))];
      return FEMergeElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEMergeNodeElement() {
      class FEMergeNodeElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feMergeNode"), exports.FEMergeNodeElement);
        }
        created() {
          this.in1 = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feMergeNode')) && dart.is(exports.SvgElement.tag('feMergeNode'), exports.FEMergeNodeElement);
        }
      }
      dart.defineNamedConstructor(FEMergeNodeElement, 'created');
      dart.setSignature(FEMergeNodeElement, {
        constructors: () => ({
          _: [exports.FEMergeNodeElement, []],
          new: [exports.FEMergeNodeElement, []],
          created: [exports.FEMergeNodeElement, []]
        })
      });
      FEMergeNodeElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEMergeNodeElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEMergeNodeElement"))];
      return FEMergeNodeElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEMorphologyElement() {
      class FEMorphologyElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.in1 = null;
          this.operator = null;
          this.radiusX = null;
          this.radiusY = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
      }
      FEMorphologyElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEMorphologyElement, 'created');
      dart.setSignature(FEMorphologyElement, {
        constructors: () => ({
          _: [exports.FEMorphologyElement, []],
          created: [exports.FEMorphologyElement, []]
        })
      });
      FEMorphologyElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEMorphologyElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEMorphologyElement"))];
      return FEMorphologyElement;
    }
  });
  exports.FEMorphologyElement.SVG_MORPHOLOGY_OPERATOR_DILATE = 2;
  exports.FEMorphologyElement.SVG_MORPHOLOGY_OPERATOR_ERODE = 1;
  exports.FEMorphologyElement.SVG_MORPHOLOGY_OPERATOR_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get FEOffsetElement() {
      class FEOffsetElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feOffset"), exports.FEOffsetElement);
        }
        created() {
          this.dx = null;
          this.dy = null;
          this.in1 = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feOffset')) && dart.is(exports.SvgElement.tag('feOffset'), exports.FEOffsetElement);
        }
      }
      FEOffsetElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FEOffsetElement, 'created');
      dart.setSignature(FEOffsetElement, {
        constructors: () => ({
          _: [exports.FEOffsetElement, []],
          new: [exports.FEOffsetElement, []],
          created: [exports.FEOffsetElement, []]
        })
      });
      FEOffsetElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEOffsetElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEOffsetElement"))];
      return FEOffsetElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FEPointLightElement() {
      class FEPointLightElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("fePointLight"), exports.FEPointLightElement);
        }
        created() {
          this.x = null;
          this.y = null;
          this.z = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('fePointLight')) && dart.is(exports.SvgElement.tag('fePointLight'), exports.FEPointLightElement);
        }
      }
      dart.defineNamedConstructor(FEPointLightElement, 'created');
      dart.setSignature(FEPointLightElement, {
        constructors: () => ({
          _: [exports.FEPointLightElement, []],
          new: [exports.FEPointLightElement, []],
          created: [exports.FEPointLightElement, []]
        })
      });
      FEPointLightElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEPointLightElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFEPointLightElement"))];
      return FEPointLightElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FESpecularLightingElement() {
      class FESpecularLightingElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feSpecularLighting"), exports.FESpecularLightingElement);
        }
        created() {
          this.in1 = null;
          this.specularConstant = null;
          this.specularExponent = null;
          this.surfaceScale = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feSpecularLighting')) && dart.is(exports.SvgElement.tag('feSpecularLighting'), exports.FESpecularLightingElement);
        }
      }
      FESpecularLightingElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FESpecularLightingElement, 'created');
      dart.setSignature(FESpecularLightingElement, {
        constructors: () => ({
          _: [exports.FESpecularLightingElement, []],
          new: [exports.FESpecularLightingElement, []],
          created: [exports.FESpecularLightingElement, []]
        })
      });
      FESpecularLightingElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFESpecularLightingElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFESpecularLightingElement"))];
      return FESpecularLightingElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FESpotLightElement() {
      class FESpotLightElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feSpotLight"), exports.FESpotLightElement);
        }
        created() {
          this.limitingConeAngle = null;
          this.pointsAtX = null;
          this.pointsAtY = null;
          this.pointsAtZ = null;
          this.specularExponent = null;
          this.x = null;
          this.y = null;
          this.z = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feSpotLight')) && dart.is(exports.SvgElement.tag('feSpotLight'), exports.FESpotLightElement);
        }
      }
      dart.defineNamedConstructor(FESpotLightElement, 'created');
      dart.setSignature(FESpotLightElement, {
        constructors: () => ({
          _: [exports.FESpotLightElement, []],
          new: [exports.FESpotLightElement, []],
          created: [exports.FESpotLightElement, []]
        })
      });
      FESpotLightElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFESpotLightElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFESpotLightElement"))];
      return FESpotLightElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FETileElement() {
      class FETileElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feTile"), exports.FETileElement);
        }
        created() {
          this.in1 = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feTile')) && dart.is(exports.SvgElement.tag('feTile'), exports.FETileElement);
        }
      }
      FETileElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FETileElement, 'created');
      dart.setSignature(FETileElement, {
        constructors: () => ({
          _: [exports.FETileElement, []],
          new: [exports.FETileElement, []],
          created: [exports.FETileElement, []]
        })
      });
      FETileElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFETileElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFETileElement"))];
      return FETileElement;
    }
  });
  dart.defineLazyClass(exports, {
    get FETurbulenceElement() {
      class FETurbulenceElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("feTurbulence"), exports.FETurbulenceElement);
        }
        created() {
          this.baseFrequencyX = null;
          this.baseFrequencyY = null;
          this.numOctaves = null;
          this.seed = null;
          this.stitchTiles = null;
          this.type = null;
          this.height = null;
          this.result = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('feTurbulence')) && dart.is(exports.SvgElement.tag('feTurbulence'), exports.FETurbulenceElement);
        }
      }
      FETurbulenceElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(FETurbulenceElement, 'created');
      dart.setSignature(FETurbulenceElement, {
        constructors: () => ({
          _: [exports.FETurbulenceElement, []],
          new: [exports.FETurbulenceElement, []],
          created: [exports.FETurbulenceElement, []]
        })
      });
      FETurbulenceElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFETurbulenceElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFETurbulenceElement"))];
      return FETurbulenceElement;
    }
  });
  exports.FETurbulenceElement.SVG_STITCHTYPE_NOSTITCH = 2;
  exports.FETurbulenceElement.SVG_STITCHTYPE_STITCH = 1;
  exports.FETurbulenceElement.SVG_STITCHTYPE_UNKNOWN = 0;
  exports.FETurbulenceElement.SVG_TURBULENCE_TYPE_FRACTALNOISE = 1;
  exports.FETurbulenceElement.SVG_TURBULENCE_TYPE_TURBULENCE = 2;
  exports.FETurbulenceElement.SVG_TURBULENCE_TYPE_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get FilterElement() {
      class FilterElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("filter"), exports.FilterElement);
        }
        created() {
          this.filterResX = null;
          this.filterResY = null;
          this.filterUnits = null;
          this.height = null;
          this.primitiveUnits = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.href = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('filter')) && dart.is(exports.SvgElement.tag('filter'), exports.FilterElement);
        }
      }
      FilterElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(FilterElement, 'created');
      dart.setSignature(FilterElement, {
        constructors: () => ({
          _: [exports.FilterElement, []],
          new: [exports.FilterElement, []],
          created: [exports.FilterElement, []]
        }),
        methods: () => ({setFilterRes: [dart.void, [core.int, core.int]]})
      });
      FilterElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFilterElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFilterElement"))];
      return FilterElement;
    }
  });
  class FilterPrimitiveStandardAttributes extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FilterPrimitiveStandardAttributes, {
    constructors: () => ({_: [FilterPrimitiveStandardAttributes, []]})
  });
  FilterPrimitiveStandardAttributes[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFilterPrimitiveStandardAttributes')), dart.const(new _metadata.Unstable())];
  class FitToViewBox extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FitToViewBox, {
    constructors: () => ({_: [FitToViewBox, []]})
  });
  FitToViewBox[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFitToViewBox')), dart.const(new _metadata.Unstable())];
  dart.defineLazyClass(exports, {
    get ForeignObjectElement() {
      class ForeignObjectElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("foreignObject"), exports.ForeignObjectElement);
        }
        created() {
          this.height = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('foreignObject')) && dart.is(exports.SvgElement.tag('foreignObject'), exports.ForeignObjectElement);
        }
      }
      dart.defineNamedConstructor(ForeignObjectElement, 'created');
      dart.setSignature(ForeignObjectElement, {
        constructors: () => ({
          _: [exports.ForeignObjectElement, []],
          new: [exports.ForeignObjectElement, []],
          created: [exports.ForeignObjectElement, []]
        })
      });
      ForeignObjectElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGForeignObjectElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGForeignObjectElement"))];
      return ForeignObjectElement;
    }
  });
  dart.defineLazyClass(exports, {
    get GElement() {
      class GElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("g"), exports.GElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(GElement, 'created');
      dart.setSignature(GElement, {
        constructors: () => ({
          _: [exports.GElement, []],
          new: [exports.GElement, []],
          created: [exports.GElement, []]
        })
      });
      GElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGGElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGGElement"))];
      return GElement;
    }
  });
  dart.defineLazyClass(exports, {
    get ImageElement() {
      class ImageElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("image"), exports.ImageElement);
        }
        created() {
          this.height = null;
          this.preserveAspectRatio = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.href = null;
          super.created();
        }
      }
      ImageElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(ImageElement, 'created');
      dart.setSignature(ImageElement, {
        constructors: () => ({
          _: [exports.ImageElement, []],
          new: [exports.ImageElement, []],
          created: [exports.ImageElement, []]
        })
      });
      ImageElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGImageElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGImageElement"))];
      return ImageElement;
    }
  });
  class Length extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Length, {
    constructors: () => ({_: [Length, []]}),
    methods: () => ({
      convertToSpecifiedUnits: [dart.void, [core.int]],
      newValueSpecifiedUnits: [dart.void, [core.int, core.num]]
    })
  });
  Length[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGLength')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGLength"))];
  Length.SVG_LENGTHTYPE_CM = 6;
  Length.SVG_LENGTHTYPE_EMS = 3;
  Length.SVG_LENGTHTYPE_EXS = 4;
  Length.SVG_LENGTHTYPE_IN = 8;
  Length.SVG_LENGTHTYPE_MM = 7;
  Length.SVG_LENGTHTYPE_NUMBER = 1;
  Length.SVG_LENGTHTYPE_PC = 10;
  Length.SVG_LENGTHTYPE_PERCENTAGE = 2;
  Length.SVG_LENGTHTYPE_PT = 9;
  Length.SVG_LENGTHTYPE_PX = 5;
  Length.SVG_LENGTHTYPE_UNKNOWN = 0;
  let __setter__ = Symbol('__setter__');
  dart.defineLazyClass(exports, {
    get LengthList() {
      class LengthList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Length), html$.ImmutableListMixin$(Length)) {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get length() {
          return dart.as(this.length, core.int);
        }
        get(index) {
          if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
            dart.throw(core.RangeError.index(index, this));
          return this.getItem(index);
        }
        set(index, value) {
          dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
          return value;
        }
        set length(value) {
          dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
        }
        get first() {
          if (dart.notNull(this.length) > 0) {
            return dart.as(this[0], Length);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get last() {
          let len = this.length;
          if (dart.notNull(len) > 0) {
            return dart.as(this[dart.notNull(len) - 1], Length);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get single() {
          let len = this.length;
          if (len == 1) {
            return dart.as(this[0], Length);
          }
          if (len == 0)
            dart.throw(new core.StateError("No elements"));
          dart.throw(new core.StateError("More than one element"));
        }
        elementAt(index) {
          return this.get(index);
        }
      }
      LengthList[dart.implements] = () => [core.List$(Length)];
      dart.setSignature(LengthList, {
        constructors: () => ({_: [exports.LengthList, []]}),
        methods: () => ({
          get: [Length, [core.int]],
          set: [dart.void, [core.int, Length]],
          elementAt: [Length, [core.int]],
          [__setter__]: [dart.void, [core.int, Length]],
          appendItem: [Length, [Length]],
          getItem: [Length, [core.int]],
          initialize: [Length, [Length]],
          insertItemBefore: [Length, [Length, core.int]],
          removeItem: [Length, [core.int]],
          replaceItem: [Length, [Length, core.int]]
        })
      });
      dart.defineExtensionMembers(LengthList, [
        'get',
        'set',
        'elementAt',
        'clear',
        'length',
        'length',
        'first',
        'last',
        'single'
      ]);
      LengthList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGLengthList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGLengthList"))];
      return LengthList;
    }
  });
  dart.defineLazyClass(exports, {
    get LineElement() {
      class LineElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("line"), exports.LineElement);
        }
        created() {
          this.x1 = null;
          this.x2 = null;
          this.y1 = null;
          this.y2 = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(LineElement, 'created');
      dart.setSignature(LineElement, {
        constructors: () => ({
          _: [exports.LineElement, []],
          new: [exports.LineElement, []],
          created: [exports.LineElement, []]
        })
      });
      LineElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGLineElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGLineElement"))];
      return LineElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _GradientElement() {
      class _GradientElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.gradientTransform = null;
          this.gradientUnits = null;
          this.spreadMethod = null;
          this.href = null;
          super.created();
        }
      }
      _GradientElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(_GradientElement, 'created');
      dart.setSignature(_GradientElement, {
        constructors: () => ({
          _: [exports._GradientElement, []],
          created: [exports._GradientElement, []]
        })
      });
      _GradientElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGGradientElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGGradientElement"))];
      return _GradientElement;
    }
  });
  dart.defineLazyClass(exports, {
    get LinearGradientElement() {
      class LinearGradientElement extends exports._GradientElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("linearGradient"), exports.LinearGradientElement);
        }
        created() {
          this.x1 = null;
          this.x2 = null;
          this.y1 = null;
          this.y2 = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(LinearGradientElement, 'created');
      dart.setSignature(LinearGradientElement, {
        constructors: () => ({
          _: [exports.LinearGradientElement, []],
          new: [exports.LinearGradientElement, []],
          created: [exports.LinearGradientElement, []]
        })
      });
      LinearGradientElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGLinearGradientElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGLinearGradientElement"))];
      return LinearGradientElement;
    }
  });
  dart.defineLazyClass(exports, {
    get MarkerElement() {
      class MarkerElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("marker"), exports.MarkerElement);
        }
        created() {
          this.markerHeight = null;
          this.markerUnits = null;
          this.markerWidth = null;
          this.orientAngle = null;
          this.orientType = null;
          this.refX = null;
          this.refY = null;
          this.preserveAspectRatio = null;
          this.viewBox = null;
          super.created();
        }
      }
      MarkerElement[dart.implements] = () => [FitToViewBox];
      dart.defineNamedConstructor(MarkerElement, 'created');
      dart.setSignature(MarkerElement, {
        constructors: () => ({
          _: [exports.MarkerElement, []],
          new: [exports.MarkerElement, []],
          created: [exports.MarkerElement, []]
        }),
        methods: () => ({
          setOrientToAngle: [dart.void, [Angle]],
          setOrientToAuto: [dart.void, []]
        })
      });
      MarkerElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGMarkerElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGMarkerElement"))];
      return MarkerElement;
    }
  });
  exports.MarkerElement.SVG_MARKERUNITS_STROKEWIDTH = 2;
  exports.MarkerElement.SVG_MARKERUNITS_UNKNOWN = 0;
  exports.MarkerElement.SVG_MARKERUNITS_USERSPACEONUSE = 1;
  exports.MarkerElement.SVG_MARKER_ORIENT_ANGLE = 2;
  exports.MarkerElement.SVG_MARKER_ORIENT_AUTO = 1;
  exports.MarkerElement.SVG_MARKER_ORIENT_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get MaskElement() {
      class MaskElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("mask"), exports.MaskElement);
        }
        created() {
          this.height = null;
          this.maskContentUnits = null;
          this.maskUnits = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.requiredExtensions = null;
          this.requiredFeatures = null;
          this.systemLanguage = null;
          super.created();
        }
      }
      MaskElement[dart.implements] = () => [Tests];
      dart.defineNamedConstructor(MaskElement, 'created');
      dart.setSignature(MaskElement, {
        constructors: () => ({
          _: [exports.MaskElement, []],
          new: [exports.MaskElement, []],
          created: [exports.MaskElement, []]
        }),
        methods: () => ({hasExtension: [core.bool, [core.String]]})
      });
      MaskElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGMaskElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGMaskElement"))];
      return MaskElement;
    }
  });
  class Matrix extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Matrix, {
    constructors: () => ({_: [Matrix, []]}),
    methods: () => ({
      flipX: [Matrix, []],
      flipY: [Matrix, []],
      inverse: [Matrix, []],
      multiply: [Matrix, [Matrix]],
      rotate: [Matrix, [core.num]],
      rotateFromVector: [Matrix, [core.num, core.num]],
      scale: [Matrix, [core.num]],
      scaleNonUniform: [Matrix, [core.num, core.num]],
      skewX: [Matrix, [core.num]],
      skewY: [Matrix, [core.num]],
      translate: [Matrix, [core.num, core.num]]
    })
  });
  Matrix[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGMatrix')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGMatrix"))];
  dart.defineLazyClass(exports, {
    get MetadataElement() {
      class MetadataElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(MetadataElement, 'created');
      dart.setSignature(MetadataElement, {
        constructors: () => ({
          _: [exports.MetadataElement, []],
          created: [exports.MetadataElement, []]
        })
      });
      MetadataElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGMetadataElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGMetadataElement"))];
      return MetadataElement;
    }
  });
  class Number extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Number, {
    constructors: () => ({_: [Number, []]})
  });
  Number[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGNumber')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGNumber"))];
  dart.defineLazyClass(exports, {
    get NumberList() {
      class NumberList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Number), html$.ImmutableListMixin$(Number)) {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get length() {
          return dart.as(this.length, core.int);
        }
        get(index) {
          if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
            dart.throw(core.RangeError.index(index, this));
          return this.getItem(index);
        }
        set(index, value) {
          dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
          return value;
        }
        set length(value) {
          dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
        }
        get first() {
          if (dart.notNull(this.length) > 0) {
            return dart.as(this[0], Number);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get last() {
          let len = this.length;
          if (dart.notNull(len) > 0) {
            return dart.as(this[dart.notNull(len) - 1], Number);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get single() {
          let len = this.length;
          if (len == 1) {
            return dart.as(this[0], Number);
          }
          if (len == 0)
            dart.throw(new core.StateError("No elements"));
          dart.throw(new core.StateError("More than one element"));
        }
        elementAt(index) {
          return this.get(index);
        }
      }
      NumberList[dart.implements] = () => [core.List$(Number)];
      dart.setSignature(NumberList, {
        constructors: () => ({_: [exports.NumberList, []]}),
        methods: () => ({
          get: [Number, [core.int]],
          set: [dart.void, [core.int, Number]],
          elementAt: [Number, [core.int]],
          [__setter__]: [dart.void, [core.int, Number]],
          appendItem: [Number, [Number]],
          getItem: [Number, [core.int]],
          initialize: [Number, [Number]],
          insertItemBefore: [Number, [Number, core.int]],
          removeItem: [Number, [core.int]],
          replaceItem: [Number, [Number, core.int]]
        })
      });
      dart.defineExtensionMembers(NumberList, [
        'get',
        'set',
        'elementAt',
        'clear',
        'length',
        'length',
        'first',
        'last',
        'single'
      ]);
      NumberList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGNumberList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGNumberList"))];
      return NumberList;
    }
  });
  dart.defineLazyClass(exports, {
    get PathElement() {
      class PathElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("path"), exports.PathElement);
        }
        created() {
          this.animatedNormalizedPathSegList = null;
          this.animatedPathSegList = null;
          this.normalizedPathSegList = null;
          this.pathLength = null;
          this.pathSegList = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(PathElement, 'created');
      dart.setSignature(PathElement, {
        constructors: () => ({
          _: [exports.PathElement, []],
          new: [exports.PathElement, []],
          created: [exports.PathElement, []]
        }),
        methods: () => ({
          createSvgPathSegArcAbs: [PathSegArcAbs, [core.num, core.num, core.num, core.num, core.num, core.bool, core.bool]],
          createSvgPathSegArcRel: [PathSegArcRel, [core.num, core.num, core.num, core.num, core.num, core.bool, core.bool]],
          createSvgPathSegClosePath: [PathSegClosePath, []],
          createSvgPathSegCurvetoCubicAbs: [PathSegCurvetoCubicAbs, [core.num, core.num, core.num, core.num, core.num, core.num]],
          createSvgPathSegCurvetoCubicRel: [PathSegCurvetoCubicRel, [core.num, core.num, core.num, core.num, core.num, core.num]],
          createSvgPathSegCurvetoCubicSmoothAbs: [PathSegCurvetoCubicSmoothAbs, [core.num, core.num, core.num, core.num]],
          createSvgPathSegCurvetoCubicSmoothRel: [PathSegCurvetoCubicSmoothRel, [core.num, core.num, core.num, core.num]],
          createSvgPathSegCurvetoQuadraticAbs: [PathSegCurvetoQuadraticAbs, [core.num, core.num, core.num, core.num]],
          createSvgPathSegCurvetoQuadraticRel: [PathSegCurvetoQuadraticRel, [core.num, core.num, core.num, core.num]],
          createSvgPathSegCurvetoQuadraticSmoothAbs: [PathSegCurvetoQuadraticSmoothAbs, [core.num, core.num]],
          createSvgPathSegCurvetoQuadraticSmoothRel: [PathSegCurvetoQuadraticSmoothRel, [core.num, core.num]],
          createSvgPathSegLinetoAbs: [PathSegLinetoAbs, [core.num, core.num]],
          createSvgPathSegLinetoHorizontalAbs: [PathSegLinetoHorizontalAbs, [core.num]],
          createSvgPathSegLinetoHorizontalRel: [PathSegLinetoHorizontalRel, [core.num]],
          createSvgPathSegLinetoRel: [PathSegLinetoRel, [core.num, core.num]],
          createSvgPathSegLinetoVerticalAbs: [PathSegLinetoVerticalAbs, [core.num]],
          createSvgPathSegLinetoVerticalRel: [PathSegLinetoVerticalRel, [core.num]],
          createSvgPathSegMovetoAbs: [PathSegMovetoAbs, [core.num, core.num]],
          createSvgPathSegMovetoRel: [PathSegMovetoRel, [core.num, core.num]],
          getPathSegAtLength: [core.int, [core.num]],
          getPointAtLength: [Point, [core.num]],
          getTotalLength: [core.double, []]
        })
      });
      PathElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathElement"))];
      return PathElement;
    }
  });
  class PathSeg extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSeg, {
    constructors: () => ({_: [PathSeg, []]})
  });
  PathSeg[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSeg')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSeg"))];
  PathSeg.PATHSEG_ARC_ABS = 10;
  PathSeg.PATHSEG_ARC_REL = 11;
  PathSeg.PATHSEG_CLOSEPATH = 1;
  PathSeg.PATHSEG_CURVETO_CUBIC_ABS = 6;
  PathSeg.PATHSEG_CURVETO_CUBIC_REL = 7;
  PathSeg.PATHSEG_CURVETO_CUBIC_SMOOTH_ABS = 16;
  PathSeg.PATHSEG_CURVETO_CUBIC_SMOOTH_REL = 17;
  PathSeg.PATHSEG_CURVETO_QUADRATIC_ABS = 8;
  PathSeg.PATHSEG_CURVETO_QUADRATIC_REL = 9;
  PathSeg.PATHSEG_CURVETO_QUADRATIC_SMOOTH_ABS = 18;
  PathSeg.PATHSEG_CURVETO_QUADRATIC_SMOOTH_REL = 19;
  PathSeg.PATHSEG_LINETO_ABS = 4;
  PathSeg.PATHSEG_LINETO_HORIZONTAL_ABS = 12;
  PathSeg.PATHSEG_LINETO_HORIZONTAL_REL = 13;
  PathSeg.PATHSEG_LINETO_REL = 5;
  PathSeg.PATHSEG_LINETO_VERTICAL_ABS = 14;
  PathSeg.PATHSEG_LINETO_VERTICAL_REL = 15;
  PathSeg.PATHSEG_MOVETO_ABS = 2;
  PathSeg.PATHSEG_MOVETO_REL = 3;
  PathSeg.PATHSEG_UNKNOWN = 0;
  class PathSegArcAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegArcAbs, {
    constructors: () => ({_: [PathSegArcAbs, []]})
  });
  PathSegArcAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegArcAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegArcAbs"))];
  class PathSegArcRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegArcRel, {
    constructors: () => ({_: [PathSegArcRel, []]})
  });
  PathSegArcRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegArcRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegArcRel"))];
  class PathSegClosePath extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegClosePath, {
    constructors: () => ({_: [PathSegClosePath, []]})
  });
  PathSegClosePath[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegClosePath')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegClosePath"))];
  class PathSegCurvetoCubicAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoCubicAbs, {
    constructors: () => ({_: [PathSegCurvetoCubicAbs, []]})
  });
  PathSegCurvetoCubicAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoCubicAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoCubicAbs"))];
  class PathSegCurvetoCubicRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoCubicRel, {
    constructors: () => ({_: [PathSegCurvetoCubicRel, []]})
  });
  PathSegCurvetoCubicRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoCubicRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoCubicRel"))];
  class PathSegCurvetoCubicSmoothAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoCubicSmoothAbs, {
    constructors: () => ({_: [PathSegCurvetoCubicSmoothAbs, []]})
  });
  PathSegCurvetoCubicSmoothAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoCubicSmoothAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoCubicSmoothAbs"))];
  class PathSegCurvetoCubicSmoothRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoCubicSmoothRel, {
    constructors: () => ({_: [PathSegCurvetoCubicSmoothRel, []]})
  });
  PathSegCurvetoCubicSmoothRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoCubicSmoothRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoCubicSmoothRel"))];
  class PathSegCurvetoQuadraticAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoQuadraticAbs, {
    constructors: () => ({_: [PathSegCurvetoQuadraticAbs, []]})
  });
  PathSegCurvetoQuadraticAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoQuadraticAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoQuadraticAbs"))];
  class PathSegCurvetoQuadraticRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoQuadraticRel, {
    constructors: () => ({_: [PathSegCurvetoQuadraticRel, []]})
  });
  PathSegCurvetoQuadraticRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoQuadraticRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoQuadraticRel"))];
  class PathSegCurvetoQuadraticSmoothAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoQuadraticSmoothAbs, {
    constructors: () => ({_: [PathSegCurvetoQuadraticSmoothAbs, []]})
  });
  PathSegCurvetoQuadraticSmoothAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoQuadraticSmoothAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoQuadraticSmoothAbs"))];
  class PathSegCurvetoQuadraticSmoothRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegCurvetoQuadraticSmoothRel, {
    constructors: () => ({_: [PathSegCurvetoQuadraticSmoothRel, []]})
  });
  PathSegCurvetoQuadraticSmoothRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegCurvetoQuadraticSmoothRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegCurvetoQuadraticSmoothRel"))];
  class PathSegLinetoAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegLinetoAbs, {
    constructors: () => ({_: [PathSegLinetoAbs, []]})
  });
  PathSegLinetoAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegLinetoAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegLinetoAbs"))];
  class PathSegLinetoHorizontalAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegLinetoHorizontalAbs, {
    constructors: () => ({_: [PathSegLinetoHorizontalAbs, []]})
  });
  PathSegLinetoHorizontalAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegLinetoHorizontalAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegLinetoHorizontalAbs"))];
  class PathSegLinetoHorizontalRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegLinetoHorizontalRel, {
    constructors: () => ({_: [PathSegLinetoHorizontalRel, []]})
  });
  PathSegLinetoHorizontalRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegLinetoHorizontalRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegLinetoHorizontalRel"))];
  class PathSegLinetoRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegLinetoRel, {
    constructors: () => ({_: [PathSegLinetoRel, []]})
  });
  PathSegLinetoRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegLinetoRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegLinetoRel"))];
  class PathSegLinetoVerticalAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegLinetoVerticalAbs, {
    constructors: () => ({_: [PathSegLinetoVerticalAbs, []]})
  });
  PathSegLinetoVerticalAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegLinetoVerticalAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegLinetoVerticalAbs"))];
  class PathSegLinetoVerticalRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegLinetoVerticalRel, {
    constructors: () => ({_: [PathSegLinetoVerticalRel, []]})
  });
  PathSegLinetoVerticalRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegLinetoVerticalRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegLinetoVerticalRel"))];
  dart.defineLazyClass(exports, {
    get PathSegList() {
      class PathSegList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(PathSeg), html$.ImmutableListMixin$(PathSeg)) {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get length() {
          return dart.as(this.length, core.int);
        }
        get(index) {
          if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
            dart.throw(core.RangeError.index(index, this));
          return this.getItem(index);
        }
        set(index, value) {
          dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
          return value;
        }
        set length(value) {
          dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
        }
        get first() {
          if (dart.notNull(this.length) > 0) {
            return dart.as(this[0], PathSeg);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get last() {
          let len = this.length;
          if (dart.notNull(len) > 0) {
            return dart.as(this[dart.notNull(len) - 1], PathSeg);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get single() {
          let len = this.length;
          if (len == 1) {
            return dart.as(this[0], PathSeg);
          }
          if (len == 0)
            dart.throw(new core.StateError("No elements"));
          dart.throw(new core.StateError("More than one element"));
        }
        elementAt(index) {
          return this.get(index);
        }
      }
      PathSegList[dart.implements] = () => [core.List$(PathSeg)];
      dart.setSignature(PathSegList, {
        constructors: () => ({_: [exports.PathSegList, []]}),
        methods: () => ({
          get: [PathSeg, [core.int]],
          set: [dart.void, [core.int, PathSeg]],
          elementAt: [PathSeg, [core.int]],
          [__setter__]: [dart.void, [core.int, PathSeg]],
          appendItem: [PathSeg, [PathSeg]],
          getItem: [PathSeg, [core.int]],
          initialize: [PathSeg, [PathSeg]],
          insertItemBefore: [PathSeg, [PathSeg, core.int]],
          removeItem: [PathSeg, [core.int]],
          replaceItem: [PathSeg, [PathSeg, core.int]]
        })
      });
      dart.defineExtensionMembers(PathSegList, [
        'get',
        'set',
        'elementAt',
        'clear',
        'length',
        'length',
        'first',
        'last',
        'single'
      ]);
      PathSegList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegList"))];
      return PathSegList;
    }
  });
  class PathSegMovetoAbs extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegMovetoAbs, {
    constructors: () => ({_: [PathSegMovetoAbs, []]})
  });
  PathSegMovetoAbs[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegMovetoAbs')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegMovetoAbs"))];
  class PathSegMovetoRel extends PathSeg {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PathSegMovetoRel, {
    constructors: () => ({_: [PathSegMovetoRel, []]})
  });
  PathSegMovetoRel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPathSegMovetoRel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPathSegMovetoRel"))];
  dart.defineLazyClass(exports, {
    get PatternElement() {
      class PatternElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("pattern"), exports.PatternElement);
        }
        created() {
          this.height = null;
          this.patternContentUnits = null;
          this.patternTransform = null;
          this.patternUnits = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.preserveAspectRatio = null;
          this.viewBox = null;
          this.requiredExtensions = null;
          this.requiredFeatures = null;
          this.systemLanguage = null;
          this.href = null;
          super.created();
        }
      }
      PatternElement[dart.implements] = () => [FitToViewBox, UriReference, Tests];
      dart.defineNamedConstructor(PatternElement, 'created');
      dart.setSignature(PatternElement, {
        constructors: () => ({
          _: [exports.PatternElement, []],
          new: [exports.PatternElement, []],
          created: [exports.PatternElement, []]
        }),
        methods: () => ({hasExtension: [core.bool, [core.String]]})
      });
      PatternElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPatternElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPatternElement"))];
      return PatternElement;
    }
  });
  class Point extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Point, {
    constructors: () => ({_: [Point, []]}),
    methods: () => ({matrixTransform: [Point, [Matrix]]})
  });
  Point[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPoint')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPoint"))];
  class PointList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PointList, {
    constructors: () => ({_: [PointList, []]}),
    methods: () => ({
      [__setter__]: [dart.void, [core.int, Point]],
      appendItem: [Point, [Point]],
      clear: [dart.void, []],
      getItem: [Point, [core.int]],
      initialize: [Point, [Point]],
      insertItemBefore: [Point, [Point, core.int]],
      removeItem: [Point, [core.int]],
      replaceItem: [Point, [Point, core.int]]
    })
  });
  PointList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPointList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPointList"))];
  dart.defineLazyClass(exports, {
    get PolygonElement() {
      class PolygonElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("polygon"), exports.PolygonElement);
        }
        created() {
          this.animatedPoints = null;
          this.points = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(PolygonElement, 'created');
      dart.setSignature(PolygonElement, {
        constructors: () => ({
          _: [exports.PolygonElement, []],
          new: [exports.PolygonElement, []],
          created: [exports.PolygonElement, []]
        })
      });
      PolygonElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPolygonElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPolygonElement"))];
      return PolygonElement;
    }
  });
  dart.defineLazyClass(exports, {
    get PolylineElement() {
      class PolylineElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("polyline"), exports.PolylineElement);
        }
        created() {
          this.animatedPoints = null;
          this.points = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(PolylineElement, 'created');
      dart.setSignature(PolylineElement, {
        constructors: () => ({
          _: [exports.PolylineElement, []],
          new: [exports.PolylineElement, []],
          created: [exports.PolylineElement, []]
        })
      });
      PolylineElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPolylineElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPolylineElement"))];
      return PolylineElement;
    }
  });
  class PreserveAspectRatio extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PreserveAspectRatio, {
    constructors: () => ({_: [PreserveAspectRatio, []]})
  });
  PreserveAspectRatio[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGPreserveAspectRatio')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGPreserveAspectRatio"))];
  PreserveAspectRatio.SVG_MEETORSLICE_MEET = 1;
  PreserveAspectRatio.SVG_MEETORSLICE_SLICE = 2;
  PreserveAspectRatio.SVG_MEETORSLICE_UNKNOWN = 0;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_NONE = 1;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_UNKNOWN = 0;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMAXYMAX = 10;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMAXYMID = 7;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMAXYMIN = 4;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMIDYMAX = 9;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMIDYMID = 6;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMIDYMIN = 3;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMINYMAX = 8;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMINYMID = 5;
  PreserveAspectRatio.SVG_PRESERVEASPECTRATIO_XMINYMIN = 2;
  dart.defineLazyClass(exports, {
    get RadialGradientElement() {
      class RadialGradientElement extends exports._GradientElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("radialGradient"), exports.RadialGradientElement);
        }
        created() {
          this.cx = null;
          this.cy = null;
          this.fr = null;
          this.fx = null;
          this.fy = null;
          this.r = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(RadialGradientElement, 'created');
      dart.setSignature(RadialGradientElement, {
        constructors: () => ({
          _: [exports.RadialGradientElement, []],
          new: [exports.RadialGradientElement, []],
          created: [exports.RadialGradientElement, []]
        })
      });
      RadialGradientElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGRadialGradientElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGRadialGradientElement"))];
      return RadialGradientElement;
    }
  });
  class Rect extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Rect, {
    constructors: () => ({_: [Rect, []]})
  });
  Rect[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGRect')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGRect"))];
  dart.defineLazyClass(exports, {
    get RectElement() {
      class RectElement extends exports.GeometryElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("rect"), exports.RectElement);
        }
        created() {
          this.height = null;
          this.rx = null;
          this.ry = null;
          this.width = null;
          this.x = null;
          this.y = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(RectElement, 'created');
      dart.setSignature(RectElement, {
        constructors: () => ({
          _: [exports.RectElement, []],
          new: [exports.RectElement, []],
          created: [exports.RectElement, []]
        })
      });
      RectElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGRectElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGRectElement"))];
      return RectElement;
    }
  });
  class RenderingIntent extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RenderingIntent, {
    constructors: () => ({_: [RenderingIntent, []]})
  });
  RenderingIntent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGRenderingIntent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGRenderingIntent"))];
  RenderingIntent.RENDERING_INTENT_ABSOLUTE_COLORIMETRIC = 5;
  RenderingIntent.RENDERING_INTENT_AUTO = 1;
  RenderingIntent.RENDERING_INTENT_PERCEPTUAL = 2;
  RenderingIntent.RENDERING_INTENT_RELATIVE_COLORIMETRIC = 3;
  RenderingIntent.RENDERING_INTENT_SATURATION = 4;
  RenderingIntent.RENDERING_INTENT_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get ScriptElement() {
      class ScriptElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("script"), exports.ScriptElement);
        }
        created() {
          this.type = null;
          this.href = null;
          super.created();
        }
      }
      ScriptElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(ScriptElement, 'created');
      dart.setSignature(ScriptElement, {
        constructors: () => ({
          _: [exports.ScriptElement, []],
          new: [exports.ScriptElement, []],
          created: [exports.ScriptElement, []]
        })
      });
      ScriptElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGScriptElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGScriptElement"))];
      return ScriptElement;
    }
  });
  dart.defineLazyClass(exports, {
    get SetElement() {
      class SetElement extends exports.AnimationElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("set"), exports.SetElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('set')) && dart.is(exports.SvgElement.tag('set'), exports.SetElement);
        }
      }
      dart.defineNamedConstructor(SetElement, 'created');
      dart.setSignature(SetElement, {
        constructors: () => ({
          _: [exports.SetElement, []],
          new: [exports.SetElement, []],
          created: [exports.SetElement, []]
        })
      });
      SetElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGSetElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGSetElement"))];
      return SetElement;
    }
  });
  dart.defineLazyClass(exports, {
    get StopElement() {
      class StopElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("stop"), exports.StopElement);
        }
        created() {
          this.gradientOffset = null;
          super.created();
        }
      }
      dart.defineNamedConstructor(StopElement, 'created');
      dart.setSignature(StopElement, {
        constructors: () => ({
          _: [exports.StopElement, []],
          new: [exports.StopElement, []],
          created: [exports.StopElement, []]
        })
      });
      StopElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGStopElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGStopElement"))];
      return StopElement;
    }
  });
  dart.defineLazyClass(exports, {
    get StringList() {
      class StringList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(core.String), html$.ImmutableListMixin$(core.String)) {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get length() {
          return dart.as(this.length, core.int);
        }
        get(index) {
          if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
            dart.throw(core.RangeError.index(index, this));
          return this.getItem(index);
        }
        set(index, value) {
          dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
          return value;
        }
        set length(value) {
          dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
        }
        get first() {
          if (dart.notNull(this.length) > 0) {
            return dart.as(this[0], core.String);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get last() {
          let len = this.length;
          if (dart.notNull(len) > 0) {
            return dart.as(this[dart.notNull(len) - 1], core.String);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get single() {
          let len = this.length;
          if (len == 1) {
            return dart.as(this[0], core.String);
          }
          if (len == 0)
            dart.throw(new core.StateError("No elements"));
          dart.throw(new core.StateError("More than one element"));
        }
        elementAt(index) {
          return this.get(index);
        }
      }
      StringList[dart.implements] = () => [core.List$(core.String)];
      dart.setSignature(StringList, {
        constructors: () => ({_: [exports.StringList, []]}),
        methods: () => ({
          get: [core.String, [core.int]],
          set: [dart.void, [core.int, core.String]],
          elementAt: [core.String, [core.int]],
          [__setter__]: [dart.void, [core.int, core.String]],
          appendItem: [core.String, [core.String]],
          getItem: [core.String, [core.int]],
          initialize: [core.String, [core.String]],
          insertItemBefore: [core.String, [core.String, core.int]],
          removeItem: [core.String, [core.int]],
          replaceItem: [core.String, [core.String, core.int]]
        })
      });
      dart.defineExtensionMembers(StringList, [
        'get',
        'set',
        'elementAt',
        'clear',
        'length',
        'length',
        'first',
        'last',
        'single'
      ]);
      StringList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGStringList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGStringList"))];
      return StringList;
    }
  });
  dart.defineLazyClass(exports, {
    get StyleElement() {
      class StyleElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("style"), exports.StyleElement);
        }
        created() {
          this.disabled = null;
          this.media = null;
          this.sheet = null;
          this.type = null;
          super.created();
        }
        get title() {
          return dart.as(this.title, core.String);
        }
        set title(value) {
          this.title = value;
        }
      }
      dart.defineNamedConstructor(StyleElement, 'created');
      dart.setSignature(StyleElement, {
        constructors: () => ({
          _: [exports.StyleElement, []],
          new: [exports.StyleElement, []],
          created: [exports.StyleElement, []]
        })
      });
      StyleElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGStyleElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SVGStyleElement"))];
      return StyleElement;
    }
  });
  let _element = Symbol('_element');
  class _AttributeClassSet extends html_common.CssClassSetImpl {
    _AttributeClassSet(element) {
      this[_element] = element;
    }
    readClasses() {
      let classname = this[_element].attributes.get('class');
      let s = collection.LinkedHashSet$(core.String).new();
      if (classname == null) {
        return s;
      }
      for (let name of dart.as(dart.dsend(classname, 'split', ' '), core.Iterable$(core.String))) {
        let trimmed = name[dartx.trim]();
        if (!dart.notNull(trimmed[dartx.isEmpty])) {
          s.add(trimmed);
        }
      }
      return s;
    }
    writeClasses(s) {
      this[_element].attributes.set('class', s.join(' '));
    }
  }
  dart.setSignature(_AttributeClassSet, {
    constructors: () => ({_AttributeClassSet: [_AttributeClassSet, [html$.Element]]}),
    methods: () => ({
      readClasses: [core.Set$(core.String), []],
      writeClasses: [dart.void, [core.Set]]
    })
  });
  dart.defineLazyProperties(SvgElement, {
    get _START_TAG_REGEXP() {
      return core.RegExp.new('<(\\w+)');
    },
    get abortEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('abort'));
    },
    set abortEvent(_) {},
    get blurEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('blur'));
    },
    set blurEvent(_) {},
    get canPlayEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('canplay'));
    },
    set canPlayEvent(_) {},
    get canPlayThroughEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('canplaythrough'));
    },
    set canPlayThroughEvent(_) {},
    get changeEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('change'));
    },
    set changeEvent(_) {},
    get clickEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('click'));
    },
    set clickEvent(_) {},
    get contextMenuEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('contextmenu'));
    },
    set contextMenuEvent(_) {},
    get doubleClickEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('dblclick'));
    },
    set doubleClickEvent(_) {},
    get dragEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('drag'));
    },
    set dragEvent(_) {},
    get dragEndEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('dragend'));
    },
    set dragEndEvent(_) {},
    get dragEnterEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('dragenter'));
    },
    set dragEnterEvent(_) {},
    get dragLeaveEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('dragleave'));
    },
    set dragLeaveEvent(_) {},
    get dragOverEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('dragover'));
    },
    set dragOverEvent(_) {},
    get dragStartEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('dragstart'));
    },
    set dragStartEvent(_) {},
    get dropEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('drop'));
    },
    set dropEvent(_) {},
    get durationChangeEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('durationchange'));
    },
    set durationChangeEvent(_) {},
    get emptiedEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('emptied'));
    },
    set emptiedEvent(_) {},
    get endedEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('ended'));
    },
    set endedEvent(_) {},
    get errorEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('error'));
    },
    set errorEvent(_) {},
    get focusEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('focus'));
    },
    set focusEvent(_) {},
    get inputEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('input'));
    },
    set inputEvent(_) {},
    get invalidEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('invalid'));
    },
    set invalidEvent(_) {},
    get keyDownEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.KeyboardEvent))('keydown'));
    },
    set keyDownEvent(_) {},
    get keyPressEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.KeyboardEvent))('keypress'));
    },
    set keyPressEvent(_) {},
    get keyUpEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.KeyboardEvent))('keyup'));
    },
    set keyUpEvent(_) {},
    get loadEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('load'));
    },
    set loadEvent(_) {},
    get loadedDataEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('loadeddata'));
    },
    set loadedDataEvent(_) {},
    get loadedMetadataEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('loadedmetadata'));
    },
    set loadedMetadataEvent(_) {},
    get mouseDownEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mousedown'));
    },
    set mouseDownEvent(_) {},
    get mouseEnterEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mouseenter'));
    },
    set mouseEnterEvent(_) {},
    get mouseLeaveEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mouseleave'));
    },
    set mouseLeaveEvent(_) {},
    get mouseMoveEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mousemove'));
    },
    set mouseMoveEvent(_) {},
    get mouseOutEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mouseout'));
    },
    set mouseOutEvent(_) {},
    get mouseOverEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mouseover'));
    },
    set mouseOverEvent(_) {},
    get mouseUpEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.MouseEvent))('mouseup'));
    },
    set mouseUpEvent(_) {},
    get mouseWheelEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.WheelEvent))('mousewheel'));
    },
    set mouseWheelEvent(_) {},
    get pauseEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('pause'));
    },
    set pauseEvent(_) {},
    get playEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('play'));
    },
    set playEvent(_) {},
    get playingEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('playing'));
    },
    set playingEvent(_) {},
    get rateChangeEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('ratechange'));
    },
    set rateChangeEvent(_) {},
    get resetEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('reset'));
    },
    set resetEvent(_) {},
    get resizeEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('resize'));
    },
    set resizeEvent(_) {},
    get scrollEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('scroll'));
    },
    set scrollEvent(_) {},
    get seekedEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('seeked'));
    },
    set seekedEvent(_) {},
    get seekingEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('seeking'));
    },
    set seekingEvent(_) {},
    get selectEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('select'));
    },
    set selectEvent(_) {},
    get stalledEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('stalled'));
    },
    set stalledEvent(_) {},
    get submitEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('submit'));
    },
    set submitEvent(_) {},
    get suspendEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('suspend'));
    },
    set suspendEvent(_) {},
    get timeUpdateEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('timeupdate'));
    },
    set timeUpdateEvent(_) {},
    get volumeChangeEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('volumechange'));
    },
    set volumeChangeEvent(_) {},
    get waitingEvent() {
      return dart.const(new (html$.EventStreamProvider$(html$.Event))('waiting'));
    },
    set waitingEvent(_) {}
  });
  dart.defineLazyClass(exports, {
    get SvgSvgElement() {
      class SvgSvgElement extends exports.GraphicsElement {
        static new() {
          let el = exports.SvgElement.tag("svg");
          dart.dsetindex(dart.dload(el, 'attributes'), 'version', "1.1");
          return dart.as(el, exports.SvgSvgElement);
        }
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.currentScale = null;
          this.currentTranslate = null;
          this.currentView = null;
          this.height = null;
          this.pixelUnitToMillimeterX = null;
          this.pixelUnitToMillimeterY = null;
          this.screenPixelToMillimeterX = null;
          this.screenPixelToMillimeterY = null;
          this.useCurrentView = null;
          this.viewport = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.preserveAspectRatio = null;
          this.viewBox = null;
          this.zoomAndPan = null;
          super.created();
        }
      }
      SvgSvgElement[dart.implements] = () => [FitToViewBox, ZoomAndPan];
      dart.defineNamedConstructor(SvgSvgElement, 'created');
      dart.setSignature(SvgSvgElement, {
        constructors: () => ({
          new: [exports.SvgSvgElement, []],
          _: [exports.SvgSvgElement, []],
          created: [exports.SvgSvgElement, []]
        }),
        methods: () => ({
          animationsPaused: [core.bool, []],
          checkEnclosure: [core.bool, [exports.SvgElement, Rect]],
          checkIntersection: [core.bool, [exports.SvgElement, Rect]],
          createSvgAngle: [Angle, []],
          createSvgLength: [Length, []],
          createSvgMatrix: [Matrix, []],
          createSvgNumber: [Number, []],
          createSvgPoint: [Point, []],
          createSvgRect: [Rect, []],
          createSvgTransform: [Transform, []],
          createSvgTransformFromMatrix: [Transform, [Matrix]],
          deselectAll: [dart.void, []],
          forceRedraw: [dart.void, []],
          getCurrentTime: [core.double, []],
          getElementById: [html$.Element, [core.String]],
          getEnclosureList: [core.List$(html$.Node), [Rect, exports.SvgElement]],
          getIntersectionList: [core.List$(html$.Node), [Rect, exports.SvgElement]],
          pauseAnimations: [dart.void, []],
          setCurrentTime: [dart.void, [core.num]],
          suspendRedraw: [core.int, [core.int]],
          unpauseAnimations: [dart.void, []],
          unsuspendRedraw: [dart.void, [core.int]],
          unsuspendRedrawAll: [dart.void, []]
        })
      });
      SvgSvgElement[dart.metadata] = () => [dart.const(new _metadata.DomName('SVGSVGElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGSVGElement"))];
      return SvgSvgElement;
    }
  });
  dart.defineLazyClass(exports, {
    get SwitchElement() {
      class SwitchElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("switch"), exports.SwitchElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(SwitchElement, 'created');
      dart.setSignature(SwitchElement, {
        constructors: () => ({
          _: [exports.SwitchElement, []],
          new: [exports.SwitchElement, []],
          created: [exports.SwitchElement, []]
        })
      });
      SwitchElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGSwitchElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGSwitchElement"))];
      return SwitchElement;
    }
  });
  dart.defineLazyClass(exports, {
    get SymbolElement() {
      class SymbolElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("symbol"), exports.SymbolElement);
        }
        created() {
          this.preserveAspectRatio = null;
          this.viewBox = null;
          super.created();
        }
      }
      SymbolElement[dart.implements] = () => [FitToViewBox];
      dart.defineNamedConstructor(SymbolElement, 'created');
      dart.setSignature(SymbolElement, {
        constructors: () => ({
          _: [exports.SymbolElement, []],
          new: [exports.SymbolElement, []],
          created: [exports.SymbolElement, []]
        })
      });
      SymbolElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGSymbolElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGSymbolElement"))];
      return SymbolElement;
    }
  });
  dart.defineLazyClass(exports, {
    get TSpanElement() {
      class TSpanElement extends exports.TextPositioningElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("tspan"), exports.TSpanElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(TSpanElement, 'created');
      dart.setSignature(TSpanElement, {
        constructors: () => ({
          _: [exports.TSpanElement, []],
          new: [exports.TSpanElement, []],
          created: [exports.TSpanElement, []]
        })
      });
      TSpanElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTSpanElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTSpanElement"))];
      return TSpanElement;
    }
  });
  class Tests extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Tests, {
    constructors: () => ({_: [Tests, []]})
  });
  Tests[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTests')), dart.const(new _metadata.Unstable())];
  exports.TextContentElement.LENGTHADJUST_SPACING = 1;
  exports.TextContentElement.LENGTHADJUST_SPACINGANDGLYPHS = 2;
  exports.TextContentElement.LENGTHADJUST_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get TextElement() {
      class TextElement extends exports.TextPositioningElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("text"), exports.TextElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(TextElement, 'created');
      dart.setSignature(TextElement, {
        constructors: () => ({
          _: [exports.TextElement, []],
          new: [exports.TextElement, []],
          created: [exports.TextElement, []]
        })
      });
      TextElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTextElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTextElement"))];
      return TextElement;
    }
  });
  dart.defineLazyClass(exports, {
    get TextPathElement() {
      class TextPathElement extends exports.TextContentElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          this.method = null;
          this.spacing = null;
          this.startOffset = null;
          this.href = null;
          super.created();
        }
      }
      TextPathElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(TextPathElement, 'created');
      dart.setSignature(TextPathElement, {
        constructors: () => ({
          _: [exports.TextPathElement, []],
          created: [exports.TextPathElement, []]
        })
      });
      TextPathElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTextPathElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTextPathElement"))];
      return TextPathElement;
    }
  });
  exports.TextPathElement.TEXTPATH_METHODTYPE_ALIGN = 1;
  exports.TextPathElement.TEXTPATH_METHODTYPE_STRETCH = 2;
  exports.TextPathElement.TEXTPATH_METHODTYPE_UNKNOWN = 0;
  exports.TextPathElement.TEXTPATH_SPACINGTYPE_AUTO = 1;
  exports.TextPathElement.TEXTPATH_SPACINGTYPE_EXACT = 2;
  exports.TextPathElement.TEXTPATH_SPACINGTYPE_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get TitleElement() {
      class TitleElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("title"), exports.TitleElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(TitleElement, 'created');
      dart.setSignature(TitleElement, {
        constructors: () => ({
          _: [exports.TitleElement, []],
          new: [exports.TitleElement, []],
          created: [exports.TitleElement, []]
        })
      });
      TitleElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTitleElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTitleElement"))];
      return TitleElement;
    }
  });
  class Transform extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Transform, {
    constructors: () => ({_: [Transform, []]}),
    methods: () => ({
      setMatrix: [dart.void, [Matrix]],
      setRotate: [dart.void, [core.num, core.num, core.num]],
      setScale: [dart.void, [core.num, core.num]],
      setSkewX: [dart.void, [core.num]],
      setSkewY: [dart.void, [core.num]],
      setTranslate: [dart.void, [core.num, core.num]]
    })
  });
  Transform[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTransform')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTransform"))];
  Transform.SVG_TRANSFORM_MATRIX = 1;
  Transform.SVG_TRANSFORM_ROTATE = 4;
  Transform.SVG_TRANSFORM_SCALE = 3;
  Transform.SVG_TRANSFORM_SKEWX = 5;
  Transform.SVG_TRANSFORM_SKEWY = 6;
  Transform.SVG_TRANSFORM_TRANSLATE = 2;
  Transform.SVG_TRANSFORM_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get TransformList() {
      class TransformList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Transform), html$.ImmutableListMixin$(Transform)) {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get length() {
          return dart.as(this.length, core.int);
        }
        get(index) {
          if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
            dart.throw(core.RangeError.index(index, this));
          return this.getItem(index);
        }
        set(index, value) {
          dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
          return value;
        }
        set length(value) {
          dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
        }
        get first() {
          if (dart.notNull(this.length) > 0) {
            return dart.as(this[0], Transform);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get last() {
          let len = this.length;
          if (dart.notNull(len) > 0) {
            return dart.as(this[dart.notNull(len) - 1], Transform);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get single() {
          let len = this.length;
          if (len == 1) {
            return dart.as(this[0], Transform);
          }
          if (len == 0)
            dart.throw(new core.StateError("No elements"));
          dart.throw(new core.StateError("More than one element"));
        }
        elementAt(index) {
          return this.get(index);
        }
      }
      TransformList[dart.implements] = () => [core.List$(Transform)];
      dart.setSignature(TransformList, {
        constructors: () => ({_: [exports.TransformList, []]}),
        methods: () => ({
          get: [Transform, [core.int]],
          set: [dart.void, [core.int, Transform]],
          elementAt: [Transform, [core.int]],
          [__setter__]: [dart.void, [core.int, Transform]],
          appendItem: [Transform, [Transform]],
          consolidate: [Transform, []],
          createSvgTransformFromMatrix: [Transform, [Matrix]],
          getItem: [Transform, [core.int]],
          initialize: [Transform, [Transform]],
          insertItemBefore: [Transform, [Transform, core.int]],
          removeItem: [Transform, [core.int]],
          replaceItem: [Transform, [Transform, core.int]]
        })
      });
      dart.defineExtensionMembers(TransformList, [
        'get',
        'set',
        'elementAt',
        'clear',
        'length',
        'length',
        'first',
        'last',
        'single'
      ]);
      TransformList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGTransformList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGTransformList"))];
      return TransformList;
    }
  });
  class UnitTypes extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(UnitTypes, {
    constructors: () => ({_: [UnitTypes, []]})
  });
  UnitTypes[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGUnitTypes')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGUnitTypes"))];
  UnitTypes.SVG_UNIT_TYPE_OBJECTBOUNDINGBOX = 2;
  UnitTypes.SVG_UNIT_TYPE_UNKNOWN = 0;
  UnitTypes.SVG_UNIT_TYPE_USERSPACEONUSE = 1;
  class UriReference extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(UriReference, {
    constructors: () => ({_: [UriReference, []]})
  });
  UriReference[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGURIReference')), dart.const(new _metadata.Unstable())];
  dart.defineLazyClass(exports, {
    get UseElement() {
      class UseElement extends exports.GraphicsElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("use"), exports.UseElement);
        }
        created() {
          this.height = null;
          this.width = null;
          this.x = null;
          this.y = null;
          this.href = null;
          super.created();
        }
      }
      UseElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(UseElement, 'created');
      dart.setSignature(UseElement, {
        constructors: () => ({
          _: [exports.UseElement, []],
          new: [exports.UseElement, []],
          created: [exports.UseElement, []]
        })
      });
      UseElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGUseElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGUseElement"))];
      return UseElement;
    }
  });
  dart.defineLazyClass(exports, {
    get ViewElement() {
      class ViewElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("view"), exports.ViewElement);
        }
        created() {
          this.viewTarget = null;
          this.preserveAspectRatio = null;
          this.viewBox = null;
          this.zoomAndPan = null;
          super.created();
        }
      }
      ViewElement[dart.implements] = () => [FitToViewBox, ZoomAndPan];
      dart.defineNamedConstructor(ViewElement, 'created');
      dart.setSignature(ViewElement, {
        constructors: () => ({
          _: [exports.ViewElement, []],
          new: [exports.ViewElement, []],
          created: [exports.ViewElement, []]
        })
      });
      ViewElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGViewElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGViewElement"))];
      return ViewElement;
    }
  });
  class ViewSpec extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  ViewSpec[dart.implements] = () => [FitToViewBox, ZoomAndPan];
  dart.setSignature(ViewSpec, {
    constructors: () => ({_: [ViewSpec, []]})
  });
  ViewSpec[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGViewSpec')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGViewSpec"))];
  class ZoomAndPan extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ZoomAndPan, {
    constructors: () => ({_: [ZoomAndPan, []]})
  });
  ZoomAndPan[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGZoomAndPan')), dart.const(new _metadata.Unstable())];
  ZoomAndPan.SVG_ZOOMANDPAN_DISABLE = 1;
  ZoomAndPan.SVG_ZOOMANDPAN_MAGNIFY = 2;
  ZoomAndPan.SVG_ZOOMANDPAN_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get ZoomEvent() {
      class ZoomEvent extends html$.UIEvent {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(ZoomEvent, {
        constructors: () => ({_: [exports.ZoomEvent, []]})
      });
      ZoomEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGZoomEvent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGZoomEvent"))];
      return ZoomEvent;
    }
  });
  exports._GradientElement.SVG_SPREADMETHOD_PAD = 1;
  exports._GradientElement.SVG_SPREADMETHOD_REFLECT = 2;
  exports._GradientElement.SVG_SPREADMETHOD_REPEAT = 3;
  exports._GradientElement.SVG_SPREADMETHOD_UNKNOWN = 0;
  dart.defineLazyClass(exports, {
    get _SVGAltGlyphDefElement() {
      class _SVGAltGlyphDefElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGAltGlyphDefElement, 'created');
      dart.setSignature(_SVGAltGlyphDefElement, {
        constructors: () => ({
          _: [exports._SVGAltGlyphDefElement, []],
          created: [exports._SVGAltGlyphDefElement, []]
        })
      });
      _SVGAltGlyphDefElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAltGlyphDefElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAltGlyphDefElement"))];
      return _SVGAltGlyphDefElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGAltGlyphItemElement() {
      class _SVGAltGlyphItemElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGAltGlyphItemElement, 'created');
      dart.setSignature(_SVGAltGlyphItemElement, {
        constructors: () => ({
          _: [exports._SVGAltGlyphItemElement, []],
          created: [exports._SVGAltGlyphItemElement, []]
        })
      });
      _SVGAltGlyphItemElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGAltGlyphItemElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGAltGlyphItemElement"))];
      return _SVGAltGlyphItemElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGCursorElement() {
      class _SVGCursorElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("cursor"), exports._SVGCursorElement);
        }
        created() {
          super.created();
        }
        static get supported() {
          return dart.notNull(exports.SvgElement.isTagSupported('cursor')) && dart.is(exports.SvgElement.tag('cursor'), exports._SVGCursorElement);
        }
      }
      _SVGCursorElement[dart.implements] = () => [UriReference, Tests];
      dart.defineNamedConstructor(_SVGCursorElement, 'created');
      dart.setSignature(_SVGCursorElement, {
        constructors: () => ({
          _: [exports._SVGCursorElement, []],
          new: [exports._SVGCursorElement, []],
          created: [exports._SVGCursorElement, []]
        })
      });
      _SVGCursorElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGCursorElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGCursorElement"))];
      return _SVGCursorElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFEDropShadowElement() {
      class _SVGFEDropShadowElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      _SVGFEDropShadowElement[dart.implements] = () => [FilterPrimitiveStandardAttributes];
      dart.defineNamedConstructor(_SVGFEDropShadowElement, 'created');
      dart.setSignature(_SVGFEDropShadowElement, {
        constructors: () => ({
          _: [exports._SVGFEDropShadowElement, []],
          created: [exports._SVGFEDropShadowElement, []]
        })
      });
      _SVGFEDropShadowElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFEDropShadowElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SVGFEDropShadowElement"))];
      return _SVGFEDropShadowElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFontElement() {
      class _SVGFontElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGFontElement, 'created');
      dart.setSignature(_SVGFontElement, {
        constructors: () => ({
          _: [exports._SVGFontElement, []],
          created: [exports._SVGFontElement, []]
        })
      });
      _SVGFontElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFontElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFontElement"))];
      return _SVGFontElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFontFaceElement() {
      class _SVGFontFaceElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGFontFaceElement, 'created');
      dart.setSignature(_SVGFontFaceElement, {
        constructors: () => ({
          _: [exports._SVGFontFaceElement, []],
          created: [exports._SVGFontFaceElement, []]
        })
      });
      _SVGFontFaceElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFontFaceElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFontFaceElement"))];
      return _SVGFontFaceElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFontFaceFormatElement() {
      class _SVGFontFaceFormatElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGFontFaceFormatElement, 'created');
      dart.setSignature(_SVGFontFaceFormatElement, {
        constructors: () => ({
          _: [exports._SVGFontFaceFormatElement, []],
          created: [exports._SVGFontFaceFormatElement, []]
        })
      });
      _SVGFontFaceFormatElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFontFaceFormatElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFontFaceFormatElement"))];
      return _SVGFontFaceFormatElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFontFaceNameElement() {
      class _SVGFontFaceNameElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGFontFaceNameElement, 'created');
      dart.setSignature(_SVGFontFaceNameElement, {
        constructors: () => ({
          _: [exports._SVGFontFaceNameElement, []],
          created: [exports._SVGFontFaceNameElement, []]
        })
      });
      _SVGFontFaceNameElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFontFaceNameElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFontFaceNameElement"))];
      return _SVGFontFaceNameElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFontFaceSrcElement() {
      class _SVGFontFaceSrcElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGFontFaceSrcElement, 'created');
      dart.setSignature(_SVGFontFaceSrcElement, {
        constructors: () => ({
          _: [exports._SVGFontFaceSrcElement, []],
          created: [exports._SVGFontFaceSrcElement, []]
        })
      });
      _SVGFontFaceSrcElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFontFaceSrcElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFontFaceSrcElement"))];
      return _SVGFontFaceSrcElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGFontFaceUriElement() {
      class _SVGFontFaceUriElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGFontFaceUriElement, 'created');
      dart.setSignature(_SVGFontFaceUriElement, {
        constructors: () => ({
          _: [exports._SVGFontFaceUriElement, []],
          created: [exports._SVGFontFaceUriElement, []]
        })
      });
      _SVGFontFaceUriElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGFontFaceUriElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGFontFaceUriElement"))];
      return _SVGFontFaceUriElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGGlyphElement() {
      class _SVGGlyphElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("glyph"), exports._SVGGlyphElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGGlyphElement, 'created');
      dart.setSignature(_SVGGlyphElement, {
        constructors: () => ({
          _: [exports._SVGGlyphElement, []],
          new: [exports._SVGGlyphElement, []],
          created: [exports._SVGGlyphElement, []]
        })
      });
      _SVGGlyphElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGGlyphElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGGlyphElement"))];
      return _SVGGlyphElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGGlyphRefElement() {
      class _SVGGlyphRefElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      _SVGGlyphRefElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(_SVGGlyphRefElement, 'created');
      dart.setSignature(_SVGGlyphRefElement, {
        constructors: () => ({
          _: [exports._SVGGlyphRefElement, []],
          created: [exports._SVGGlyphRefElement, []]
        })
      });
      _SVGGlyphRefElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGGlyphRefElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGGlyphRefElement"))];
      return _SVGGlyphRefElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGHKernElement() {
      class _SVGHKernElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("hkern"), exports._SVGHKernElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGHKernElement, 'created');
      dart.setSignature(_SVGHKernElement, {
        constructors: () => ({
          _: [exports._SVGHKernElement, []],
          new: [exports._SVGHKernElement, []],
          created: [exports._SVGHKernElement, []]
        })
      });
      _SVGHKernElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGHKernElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGHKernElement"))];
      return _SVGHKernElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGMPathElement() {
      class _SVGMPathElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("mpath"), exports._SVGMPathElement);
        }
        created() {
          super.created();
        }
      }
      _SVGMPathElement[dart.implements] = () => [UriReference];
      dart.defineNamedConstructor(_SVGMPathElement, 'created');
      dart.setSignature(_SVGMPathElement, {
        constructors: () => ({
          _: [exports._SVGMPathElement, []],
          new: [exports._SVGMPathElement, []],
          created: [exports._SVGMPathElement, []]
        })
      });
      _SVGMPathElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGMPathElement')), dart.const(new _js_helper.Native("SVGMPathElement"))];
      return _SVGMPathElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGMissingGlyphElement() {
      class _SVGMissingGlyphElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGMissingGlyphElement, 'created');
      dart.setSignature(_SVGMissingGlyphElement, {
        constructors: () => ({
          _: [exports._SVGMissingGlyphElement, []],
          created: [exports._SVGMissingGlyphElement, []]
        })
      });
      _SVGMissingGlyphElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGMissingGlyphElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGMissingGlyphElement"))];
      return _SVGMissingGlyphElement;
    }
  });
  dart.defineLazyClass(exports, {
    get _SVGVKernElement() {
      class _SVGVKernElement extends exports.SvgElement {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new() {
          return dart.as(_SvgElementFactoryProvider.createSvgElement_tag("vkern"), exports._SVGVKernElement);
        }
        created() {
          super.created();
        }
      }
      dart.defineNamedConstructor(_SVGVKernElement, 'created');
      dart.setSignature(_SVGVKernElement, {
        constructors: () => ({
          _: [exports._SVGVKernElement, []],
          new: [exports._SVGVKernElement, []],
          created: [exports._SVGVKernElement, []]
        })
      });
      _SVGVKernElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SVGVKernElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("SVGVKernElement"))];
      return _SVGVKernElement;
    }
  });
  // Exports:
  exports.Angle = Angle;
  exports.AnimatedAngle = AnimatedAngle;
  exports.AnimatedBoolean = AnimatedBoolean;
  exports.AnimatedEnumeration = AnimatedEnumeration;
  exports.AnimatedInteger = AnimatedInteger;
  exports.AnimatedLength = AnimatedLength;
  exports.AnimatedLengthList = AnimatedLengthList;
  exports.AnimatedNumber = AnimatedNumber;
  exports.AnimatedNumberList = AnimatedNumberList;
  exports.AnimatedPreserveAspectRatio = AnimatedPreserveAspectRatio;
  exports.AnimatedRect = AnimatedRect;
  exports.AnimatedString = AnimatedString;
  exports.AnimatedTransformList = AnimatedTransformList;
  exports.FilterPrimitiveStandardAttributes = FilterPrimitiveStandardAttributes;
  exports.FitToViewBox = FitToViewBox;
  exports.Length = Length;
  exports.Matrix = Matrix;
  exports.Number = Number;
  exports.PathSeg = PathSeg;
  exports.PathSegArcAbs = PathSegArcAbs;
  exports.PathSegArcRel = PathSegArcRel;
  exports.PathSegClosePath = PathSegClosePath;
  exports.PathSegCurvetoCubicAbs = PathSegCurvetoCubicAbs;
  exports.PathSegCurvetoCubicRel = PathSegCurvetoCubicRel;
  exports.PathSegCurvetoCubicSmoothAbs = PathSegCurvetoCubicSmoothAbs;
  exports.PathSegCurvetoCubicSmoothRel = PathSegCurvetoCubicSmoothRel;
  exports.PathSegCurvetoQuadraticAbs = PathSegCurvetoQuadraticAbs;
  exports.PathSegCurvetoQuadraticRel = PathSegCurvetoQuadraticRel;
  exports.PathSegCurvetoQuadraticSmoothAbs = PathSegCurvetoQuadraticSmoothAbs;
  exports.PathSegCurvetoQuadraticSmoothRel = PathSegCurvetoQuadraticSmoothRel;
  exports.PathSegLinetoAbs = PathSegLinetoAbs;
  exports.PathSegLinetoHorizontalAbs = PathSegLinetoHorizontalAbs;
  exports.PathSegLinetoHorizontalRel = PathSegLinetoHorizontalRel;
  exports.PathSegLinetoRel = PathSegLinetoRel;
  exports.PathSegLinetoVerticalAbs = PathSegLinetoVerticalAbs;
  exports.PathSegLinetoVerticalRel = PathSegLinetoVerticalRel;
  exports.PathSegMovetoAbs = PathSegMovetoAbs;
  exports.PathSegMovetoRel = PathSegMovetoRel;
  exports.Point = Point;
  exports.PointList = PointList;
  exports.PreserveAspectRatio = PreserveAspectRatio;
  exports.Rect = Rect;
  exports.RenderingIntent = RenderingIntent;
  exports.Tests = Tests;
  exports.Transform = Transform;
  exports.UnitTypes = UnitTypes;
  exports.UriReference = UriReference;
  exports.ViewSpec = ViewSpec;
  exports.ZoomAndPan = ZoomAndPan;
});
