dart_library.library('dart/web_audio', null, /* Imports */[
  "dart_runtime/dart",
  'dart/core',
  'dart/_metadata',
  'dart/_js_helper',
  'dart/typed_data',
  'dart/_interceptors',
  'dart/async'
], /* Lazy imports */[
  'dart/html'
], function(exports, dart, core, _metadata, _js_helper, typed_data, _interceptors, async, html) {
  'use strict';
  let dartx = dart.dartx;
  let _connect = Symbol('_connect');
  dart.defineLazyClass(exports, {
    get AudioNode() {
      class AudioNode extends html.EventTarget {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        connectNode(destination, output, input) {
          if (output === void 0)
            output = 0;
          if (input === void 0)
            input = 0;
          return this[_connect](destination, output, input);
        }
        connectParam(destination, output) {
          if (output === void 0)
            output = 0;
          return this[_connect](destination, output);
        }
      }
      dart.setSignature(AudioNode, {
        constructors: () => ({_: [exports.AudioNode, []]}),
        methods: () => ({
          [_connect]: [dart.void, [dart.dynamic, core.int], [core.int]],
          disconnect: [dart.void, [core.int]],
          connectNode: [dart.void, [exports.AudioNode], [core.int, core.int]],
          connectParam: [dart.void, [AudioParam], [core.int]]
        })
      });
      AudioNode[dart.metadata] = () => [dart.const(new _metadata.DomName('AudioNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioNode"))];
      return AudioNode;
    }
  });
  dart.defineLazyClass(exports, {
    get AnalyserNode() {
      class AnalyserNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(AnalyserNode, {
        constructors: () => ({_: [exports.AnalyserNode, []]}),
        methods: () => ({
          getByteFrequencyData: [dart.void, [typed_data.Uint8List]],
          getByteTimeDomainData: [dart.void, [typed_data.Uint8List]],
          getFloatFrequencyData: [dart.void, [typed_data.Float32List]],
          getFloatTimeDomainData: [dart.void, [typed_data.Float32List]]
        })
      });
      AnalyserNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AnalyserNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AnalyserNode,RealtimeAnalyserNode"))];
      return AnalyserNode;
    }
  });
  class AudioBuffer extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AudioBuffer, {
    constructors: () => ({_: [AudioBuffer, []]}),
    methods: () => ({getChannelData: [typed_data.Float32List, [core.int]]})
  });
  AudioBuffer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioBuffer')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioBuffer"))];
  let AudioBufferCallback = dart.typedef('AudioBufferCallback', () => dart.functionType(dart.void, [AudioBuffer]));
  dart.defineLazyClass(exports, {
    get AudioSourceNode() {
      class AudioSourceNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(AudioSourceNode, {
        constructors: () => ({_: [exports.AudioSourceNode, []]})
      });
      AudioSourceNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioSourceNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioSourceNode"))];
      return AudioSourceNode;
    }
  });
  dart.defineLazyClass(exports, {
    get AudioBufferSourceNode() {
      class AudioBufferSourceNode extends exports.AudioSourceNode {
        start(when, grainOffset, grainDuration) {
          if (grainOffset === void 0)
            grainOffset = null;
          if (grainDuration === void 0)
            grainDuration = null;
          if (dart.notNull(dart.as(!!this.start, core.bool))) {
            if (grainDuration != null) {
              this.start(when, grainOffset, grainDuration);
            } else if (grainOffset != null) {
              this.start(when, grainOffset);
            } else {
              this.start(when);
            }
          } else {
            if (grainDuration != null) {
              this.noteOn(when, grainOffset, grainDuration);
            } else if (grainOffset != null) {
              this.noteOn(when, grainOffset);
            } else {
              this.noteOn(when);
            }
          }
        }
        stop(when) {
          if (dart.notNull(dart.as(!!this.stop, core.bool))) {
            this.stop(when);
          } else {
            this.noteOff(when);
          }
        }
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get onEnded() {
          return exports.AudioBufferSourceNode.endedEvent.forTarget(this);
        }
      }
      dart.setSignature(AudioBufferSourceNode, {
        constructors: () => ({_: [exports.AudioBufferSourceNode, []]}),
        methods: () => ({
          start: [dart.void, [core.num], [core.num, core.num]],
          stop: [dart.void, [core.num]]
        })
      });
      AudioBufferSourceNode[dart.metadata] = () => [dart.const(new _metadata.DomName('AudioBufferSourceNode')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioBufferSourceNode"))];
      return AudioBufferSourceNode;
    }
  });
  dart.defineLazyProperties(AudioBufferSourceNode, {
    get endedEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('ended'));
    },
    set endedEvent(_) {}
  });
  let _decodeAudioData = Symbol('_decodeAudioData');
  dart.defineLazyClass(exports, {
    get AudioContext() {
      class AudioContext extends html.EventTarget {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static get supported() {
          return dart.as(!!(window.AudioContext || window.webkitAudioContext), core.bool);
        }
        get onComplete() {
          return exports.AudioContext.completeEvent.forTarget(this);
        }
        static new() {
          return dart.as(new (window.AudioContext || window.webkitAudioContext)(), exports.AudioContext);
        }
        createGain() {
          if (dart.notNull(dart.as(this.createGain !== undefined, core.bool))) {
            return dart.as(this.createGain(), exports.GainNode);
          } else {
            return dart.as(this.createGainNode(), exports.GainNode);
          }
        }
        createScriptProcessor(bufferSize, numberOfInputChannels, numberOfOutputChannels) {
          if (numberOfInputChannels === void 0)
            numberOfInputChannels = null;
          if (numberOfOutputChannels === void 0)
            numberOfOutputChannels = null;
          let func = this.createScriptProcessor || this.createJavaScriptNode;
          if (numberOfOutputChannels != null) {
            return dart.as(func.call(this, bufferSize, numberOfInputChannels, numberOfOutputChannels), exports.ScriptProcessorNode);
          } else if (numberOfInputChannels != null) {
            return dart.as(func.call(this, bufferSize, numberOfInputChannels), exports.ScriptProcessorNode);
          } else {
            return dart.as(func.call(this, bufferSize), exports.ScriptProcessorNode);
          }
        }
        decodeAudioData(audioData) {
          let completer = async.Completer$(AudioBuffer).new();
          this[_decodeAudioData](audioData, dart.fn(value => {
            dart.dsend(completer, 'complete', value);
          }), dart.fn(error => {
            if (error == null) {
              dart.dsend(completer, 'completeError', '');
            } else {
              dart.dsend(completer, 'completeError', error);
            }
          }));
          return dart.as(dart.dload(completer, 'future'), async.Future$(AudioBuffer));
        }
      }
      dart.setSignature(AudioContext, {
        constructors: () => ({
          _: [exports.AudioContext, []],
          new: [exports.AudioContext, []]
        }),
        methods: () => ({
          createAnalyser: [exports.AnalyserNode, []],
          createBiquadFilter: [exports.BiquadFilterNode, []],
          createBuffer: [AudioBuffer, [core.int, core.int, core.num]],
          createBufferSource: [exports.AudioBufferSourceNode, []],
          createChannelMerger: [exports.ChannelMergerNode, [], [core.int]],
          createChannelSplitter: [exports.ChannelSplitterNode, [], [core.int]],
          createConvolver: [exports.ConvolverNode, []],
          createDelay: [exports.DelayNode, [], [core.num]],
          createDynamicsCompressor: [exports.DynamicsCompressorNode, []],
          createMediaElementSource: [exports.MediaElementAudioSourceNode, [html.MediaElement]],
          createMediaStreamDestination: [exports.MediaStreamAudioDestinationNode, []],
          createMediaStreamSource: [exports.MediaStreamAudioSourceNode, [html.MediaStream]],
          createOscillator: [exports.OscillatorNode, []],
          createPanner: [exports.PannerNode, []],
          createPeriodicWave: [PeriodicWave, [typed_data.Float32List, typed_data.Float32List]],
          createWaveShaper: [exports.WaveShaperNode, []],
          [_decodeAudioData]: [dart.void, [typed_data.ByteBuffer, AudioBufferCallback], [AudioBufferCallback]],
          startRendering: [dart.void, []],
          createGain: [exports.GainNode, []],
          createScriptProcessor: [exports.ScriptProcessorNode, [core.int], [core.int, core.int]],
          decodeAudioData: [async.Future$(AudioBuffer), [typed_data.ByteBuffer]]
        })
      });
      AudioContext[dart.metadata] = () => [dart.const(new _metadata.DomName('AudioContext')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioContext,webkitAudioContext"))];
      return AudioContext;
    }
  });
  dart.defineLazyProperties(AudioContext, {
    get completeEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('complete'));
    },
    set completeEvent(_) {}
  });
  dart.defineLazyClass(exports, {
    get AudioDestinationNode() {
      class AudioDestinationNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(AudioDestinationNode, {
        constructors: () => ({_: [exports.AudioDestinationNode, []]})
      });
      AudioDestinationNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioDestinationNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioDestinationNode"))];
      return AudioDestinationNode;
    }
  });
  class AudioListener extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AudioListener, {
    constructors: () => ({_: [AudioListener, []]}),
    methods: () => ({
      setOrientation: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num]],
      setPosition: [dart.void, [core.num, core.num, core.num]],
      setVelocity: [dart.void, [core.num, core.num, core.num]]
    })
  });
  AudioListener[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioListener')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioListener"))];
  class AudioParam extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AudioParam, {
    constructors: () => ({_: [AudioParam, []]}),
    methods: () => ({
      cancelScheduledValues: [dart.void, [core.num]],
      exponentialRampToValueAtTime: [dart.void, [core.num, core.num]],
      linearRampToValueAtTime: [dart.void, [core.num, core.num]],
      setTargetAtTime: [dart.void, [core.num, core.num, core.num]],
      setValueAtTime: [dart.void, [core.num, core.num]],
      setValueCurveAtTime: [dart.void, [typed_data.Float32List, core.num, core.num]]
    })
  });
  AudioParam[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioParam')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioParam"))];
  dart.defineLazyClass(exports, {
    get AudioProcessingEvent() {
      class AudioProcessingEvent extends html.Event {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(AudioProcessingEvent, {
        constructors: () => ({_: [exports.AudioProcessingEvent, []]})
      });
      AudioProcessingEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioProcessingEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioProcessingEvent"))];
      return AudioProcessingEvent;
    }
  });
  dart.defineLazyClass(exports, {
    get BiquadFilterNode() {
      class BiquadFilterNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(BiquadFilterNode, {
        constructors: () => ({_: [exports.BiquadFilterNode, []]}),
        methods: () => ({getFrequencyResponse: [dart.void, [typed_data.Float32List, typed_data.Float32List, typed_data.Float32List]]})
      });
      BiquadFilterNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('BiquadFilterNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("BiquadFilterNode"))];
      return BiquadFilterNode;
    }
  });
  dart.defineLazyClass(exports, {
    get ChannelMergerNode() {
      class ChannelMergerNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(ChannelMergerNode, {
        constructors: () => ({_: [exports.ChannelMergerNode, []]})
      });
      ChannelMergerNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ChannelMergerNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ChannelMergerNode,AudioChannelMerger"))];
      return ChannelMergerNode;
    }
  });
  dart.defineLazyClass(exports, {
    get ChannelSplitterNode() {
      class ChannelSplitterNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(ChannelSplitterNode, {
        constructors: () => ({_: [exports.ChannelSplitterNode, []]})
      });
      ChannelSplitterNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ChannelSplitterNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ChannelSplitterNode,AudioChannelSplitter"))];
      return ChannelSplitterNode;
    }
  });
  dart.defineLazyClass(exports, {
    get ConvolverNode() {
      class ConvolverNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(ConvolverNode, {
        constructors: () => ({_: [exports.ConvolverNode, []]})
      });
      ConvolverNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ConvolverNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ConvolverNode"))];
      return ConvolverNode;
    }
  });
  dart.defineLazyClass(exports, {
    get DelayNode() {
      class DelayNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(DelayNode, {
        constructors: () => ({_: [exports.DelayNode, []]})
      });
      DelayNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DelayNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DelayNode"))];
      return DelayNode;
    }
  });
  dart.defineLazyClass(exports, {
    get DynamicsCompressorNode() {
      class DynamicsCompressorNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(DynamicsCompressorNode, {
        constructors: () => ({_: [exports.DynamicsCompressorNode, []]})
      });
      DynamicsCompressorNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DynamicsCompressorNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DynamicsCompressorNode"))];
      return DynamicsCompressorNode;
    }
  });
  dart.defineLazyClass(exports, {
    get GainNode() {
      class GainNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(GainNode, {
        constructors: () => ({_: [exports.GainNode, []]})
      });
      GainNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('GainNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("GainNode,AudioGainNode"))];
      return GainNode;
    }
  });
  dart.defineLazyClass(exports, {
    get MediaElementAudioSourceNode() {
      class MediaElementAudioSourceNode extends exports.AudioSourceNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(MediaElementAudioSourceNode, {
        constructors: () => ({_: [exports.MediaElementAudioSourceNode, []]})
      });
      MediaElementAudioSourceNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaElementAudioSourceNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaElementAudioSourceNode"))];
      return MediaElementAudioSourceNode;
    }
  });
  dart.defineLazyClass(exports, {
    get MediaStreamAudioDestinationNode() {
      class MediaStreamAudioDestinationNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(MediaStreamAudioDestinationNode, {
        constructors: () => ({_: [exports.MediaStreamAudioDestinationNode, []]})
      });
      MediaStreamAudioDestinationNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaStreamAudioDestinationNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaStreamAudioDestinationNode"))];
      return MediaStreamAudioDestinationNode;
    }
  });
  dart.defineLazyClass(exports, {
    get MediaStreamAudioSourceNode() {
      class MediaStreamAudioSourceNode extends exports.AudioSourceNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(MediaStreamAudioSourceNode, {
        constructors: () => ({_: [exports.MediaStreamAudioSourceNode, []]})
      });
      MediaStreamAudioSourceNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaStreamAudioSourceNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaStreamAudioSourceNode"))];
      return MediaStreamAudioSourceNode;
    }
  });
  dart.defineLazyClass(exports, {
    get OfflineAudioCompletionEvent() {
      class OfflineAudioCompletionEvent extends html.Event {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(OfflineAudioCompletionEvent, {
        constructors: () => ({_: [exports.OfflineAudioCompletionEvent, []]})
      });
      OfflineAudioCompletionEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('OfflineAudioCompletionEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("OfflineAudioCompletionEvent"))];
      return OfflineAudioCompletionEvent;
    }
  });
  dart.defineLazyClass(exports, {
    get OfflineAudioContext() {
      class OfflineAudioContext extends exports.AudioContext {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        static new(numberOfChannels, numberOfFrames, sampleRate) {
          return exports.OfflineAudioContext._create_1(numberOfChannels, numberOfFrames, sampleRate);
        }
        static _create_1(numberOfChannels, numberOfFrames, sampleRate) {
          return dart.as(new OfflineAudioContext(numberOfChannels, numberOfFrames, sampleRate), exports.OfflineAudioContext);
        }
      }
      dart.setSignature(OfflineAudioContext, {
        constructors: () => ({
          _: [exports.OfflineAudioContext, []],
          new: [exports.OfflineAudioContext, [core.int, core.int, core.num]]
        }),
        statics: () => ({_create_1: [exports.OfflineAudioContext, [dart.dynamic, dart.dynamic, dart.dynamic]]}),
        names: ['_create_1']
      });
      OfflineAudioContext[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('OfflineAudioContext')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("OfflineAudioContext"))];
      return OfflineAudioContext;
    }
  });
  dart.defineLazyClass(exports, {
    get OscillatorNode() {
      class OscillatorNode extends exports.AudioSourceNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get onEnded() {
          return exports.OscillatorNode.endedEvent.forTarget(this);
        }
      }
      dart.setSignature(OscillatorNode, {
        constructors: () => ({_: [exports.OscillatorNode, []]}),
        methods: () => ({
          noteOff: [dart.void, [core.num]],
          noteOn: [dart.void, [core.num]],
          setPeriodicWave: [dart.void, [PeriodicWave]],
          start: [dart.void, [], [core.num]],
          stop: [dart.void, [], [core.num]]
        })
      });
      OscillatorNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('OscillatorNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("OscillatorNode,Oscillator"))];
      return OscillatorNode;
    }
  });
  dart.defineLazyProperties(OscillatorNode, {
    get endedEvent() {
      return dart.const(new (html.EventStreamProvider$(html.Event))('ended'));
    },
    set endedEvent(_) {}
  });
  dart.defineLazyClass(exports, {
    get PannerNode() {
      class PannerNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(PannerNode, {
        constructors: () => ({_: [exports.PannerNode, []]}),
        methods: () => ({
          setOrientation: [dart.void, [core.num, core.num, core.num]],
          setPosition: [dart.void, [core.num, core.num, core.num]],
          setVelocity: [dart.void, [core.num, core.num, core.num]]
        })
      });
      PannerNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PannerNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PannerNode,AudioPannerNode,webkitAudioPannerNode"))];
      return PannerNode;
    }
  });
  class PeriodicWave extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PeriodicWave, {
    constructors: () => ({_: [PeriodicWave, []]})
  });
  PeriodicWave[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PeriodicWave')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PeriodicWave"))];
  dart.defineLazyClass(exports, {
    get ScriptProcessorNode() {
      class ScriptProcessorNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get onAudioProcess() {
          return exports.ScriptProcessorNode.audioProcessEvent.forTarget(this);
        }
      }
      dart.setSignature(ScriptProcessorNode, {
        constructors: () => ({_: [exports.ScriptProcessorNode, []]}),
        methods: () => ({setEventListener: [dart.void, [html.EventListener]]})
      });
      ScriptProcessorNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ScriptProcessorNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ScriptProcessorNode,JavaScriptAudioNode"))];
      return ScriptProcessorNode;
    }
  });
  dart.defineLazyProperties(ScriptProcessorNode, {
    get audioProcessEvent() {
      return dart.const(new (html.EventStreamProvider$(exports.AudioProcessingEvent))('audioprocess'));
    },
    set audioProcessEvent(_) {}
  });
  dart.defineLazyClass(exports, {
    get WaveShaperNode() {
      class WaveShaperNode extends exports.AudioNode {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
      }
      dart.setSignature(WaveShaperNode, {
        constructors: () => ({_: [exports.WaveShaperNode, []]})
      });
      WaveShaperNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WaveShaperNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WaveShaperNode"))];
      return WaveShaperNode;
    }
  });
  // Exports:
  exports.AudioBuffer = AudioBuffer;
  exports.AudioBufferCallback = AudioBufferCallback;
  exports.AudioListener = AudioListener;
  exports.AudioParam = AudioParam;
  exports.PeriodicWave = PeriodicWave;
});
