dart_library.library('dart/web_sql', null, /* Imports */[
  "dart_runtime/dart",
  'dart/_interceptors',
  'dart/core',
  'dart/_metadata',
  'dart/_js_helper',
  'dart/collection',
  'dart/html_common'
], /* Lazy imports */[
  'dart/html'
], function(exports, dart, _interceptors, core, _metadata, _js_helper, collection, html_common, html) {
  'use strict';
  let dartx = dart.dartx;
  let SqlStatementCallback = dart.typedef('SqlStatementCallback', () => dart.functionType(dart.void, [SqlTransaction, SqlResultSet]));
  let SqlStatementErrorCallback = dart.typedef('SqlStatementErrorCallback', () => dart.functionType(dart.void, [SqlTransaction, SqlError]));
  let SqlTransactionCallback = dart.typedef('SqlTransactionCallback', () => dart.functionType(dart.void, [SqlTransaction]));
  let SqlTransactionErrorCallback = dart.typedef('SqlTransactionErrorCallback', () => dart.functionType(dart.void, [SqlError]));
  class SqlDatabase extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!window.openDatabase, core.bool);
    }
  }
  dart.setSignature(SqlDatabase, {
    constructors: () => ({_: [SqlDatabase, []]}),
    methods: () => ({
      changeVersion: [dart.void, [core.String, core.String], [SqlTransactionCallback, SqlTransactionErrorCallback, html.VoidCallback]],
      readTransaction: [dart.void, [SqlTransactionCallback], [SqlTransactionErrorCallback, html.VoidCallback]],
      transaction: [dart.void, [SqlTransactionCallback], [SqlTransactionErrorCallback, html.VoidCallback]]
    })
  });
  SqlDatabase[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Database')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Database"))];
  class SqlError extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SqlError, {
    constructors: () => ({_: [SqlError, []]})
  });
  SqlError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SQLError')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SQLError"))];
  SqlError.CONSTRAINT_ERR = 6;
  SqlError.DATABASE_ERR = 1;
  SqlError.QUOTA_ERR = 4;
  SqlError.SYNTAX_ERR = 5;
  SqlError.TIMEOUT_ERR = 7;
  SqlError.TOO_LARGE_ERR = 3;
  SqlError.UNKNOWN_ERR = 0;
  SqlError.VERSION_ERR = 2;
  class SqlResultSet extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SqlResultSet, {
    constructors: () => ({_: [SqlResultSet, []]})
  });
  SqlResultSet[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SQLResultSet')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SQLResultSet"))];
  let _item_1 = Symbol('_item_1');
  dart.defineLazyClass(exports, {
    get SqlResultSetRowList() {
      class SqlResultSetRowList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(core.Map), html.ImmutableListMixin$(core.Map)) {
        static _() {
          dart.throw(new core.UnsupportedError("Not supported"));
        }
        get length() {
          return dart.as(this.length, core.int);
        }
        get(index) {
          if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
            dart.throw(core.RangeError.index(index, this));
          return this.item(index);
        }
        set(index, value) {
          dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
          return value;
        }
        set length(value) {
          dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
        }
        get first() {
          if (dart.notNull(this.length) > 0) {
            return dart.as(this[0], core.Map);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get last() {
          let len = this.length;
          if (dart.notNull(len) > 0) {
            return dart.as(this[dart.notNull(len) - 1], core.Map);
          }
          dart.throw(new core.StateError("No elements"));
        }
        get single() {
          let len = this.length;
          if (len == 1) {
            return dart.as(this[0], core.Map);
          }
          if (len == 0)
            dart.throw(new core.StateError("No elements"));
          dart.throw(new core.StateError("More than one element"));
        }
        elementAt(index) {
          return this.get(index);
        }
        item(index) {
          return html_common.convertNativeToDart_Dictionary(this[_item_1](index));
        }
      }
      SqlResultSetRowList[dart.implements] = () => [core.List$(core.Map)];
      dart.setSignature(SqlResultSetRowList, {
        constructors: () => ({_: [exports.SqlResultSetRowList, []]}),
        methods: () => ({
          get: [core.Map, [core.int]],
          set: [dart.void, [core.int, core.Map]],
          elementAt: [core.Map, [core.int]],
          item: [core.Map, [core.int]],
          [_item_1]: [dart.dynamic, [dart.dynamic]]
        })
      });
      dart.defineExtensionMembers(SqlResultSetRowList, [
        'get',
        'set',
        'elementAt',
        'length',
        'length',
        'first',
        'last',
        'single'
      ]);
      SqlResultSetRowList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SQLResultSetRowList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SQLResultSetRowList"))];
      return SqlResultSetRowList;
    }
  });
  class SqlTransaction extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SqlTransaction, {
    constructors: () => ({_: [SqlTransaction, []]}),
    methods: () => ({executeSql: [dart.void, [core.String, core.List$(core.Object)], [SqlStatementCallback, SqlStatementErrorCallback]]})
  });
  SqlTransaction[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SQLTransaction')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), core.deprecated, dart.const(new _js_helper.Native("SQLTransaction"))];
  // Exports:
  exports.SqlStatementCallback = SqlStatementCallback;
  exports.SqlStatementErrorCallback = SqlStatementErrorCallback;
  exports.SqlTransactionCallback = SqlTransactionCallback;
  exports.SqlTransactionErrorCallback = SqlTransactionErrorCallback;
  exports.SqlDatabase = SqlDatabase;
  exports.SqlError = SqlError;
  exports.SqlResultSet = SqlResultSet;
  exports.SqlTransaction = SqlTransaction;
});
