dart_library.library('dart/html', null, /* Imports */[
  "dart_runtime/dart",
  'dart/math',
  'dart/_interceptors',
  'dart/core',
  'dart/_metadata',
  'dart/_js_helper',
  'dart/async',
  'dart/isolate',
  'dart/typed_data',
  'dart/_foreign_helper',
  'dart/collection'
], /* Lazy imports */[
  'dart/html_common',
  'dart/web_gl',
  'dart/svg',
  'dart/web_sql',
  'dart/indexed_db'
], function(exports, dart, math, _interceptors, core, _metadata, _js_helper, async, isolate, typed_data, _foreign_helper, collection, html_common, web_gl, svg, web_sql, indexed_db) {
  'use strict';
  let dartx = dart.dartx;
  dart.export(exports, math, ['Rectangle', 'Point'], []);
  dart.copyProperties(exports, {
    get window() {
      return dart.as(window, Window);
    },
    get document() {
      return dart.as(document, HtmlDocument);
    }
  });
  let _addEventListener = Symbol('_addEventListener');
  let _removeEventListener = Symbol('_removeEventListener');
  class EventTarget extends _interceptors.Interceptor {
    _created() {
      super.Interceptor();
    }
    get on() {
      return new Events(this);
    }
    addEventListener(type, listener, useCapture) {
      if (useCapture === void 0)
        useCapture = null;
      if (listener != null) {
        this[_addEventListener](type, listener, useCapture);
      }
    }
    removeEventListener(type, listener, useCapture) {
      if (useCapture === void 0)
        useCapture = null;
      if (listener != null) {
        this[_removeEventListener](type, listener, useCapture);
      }
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.defineNamedConstructor(EventTarget, '_created');
  dart.setSignature(EventTarget, {
    constructors: () => ({
      _created: [EventTarget, []],
      _: [EventTarget, []]
    }),
    methods: () => ({
      addEventListener: [dart.void, [core.String, EventListener], [core.bool]],
      removeEventListener: [dart.void, [core.String, EventListener], [core.bool]],
      [_addEventListener]: [dart.void, [], [core.String, EventListener, core.bool]],
      dispatchEvent: [core.bool, [Event]],
      [_removeEventListener]: [dart.void, [], [core.String, EventListener, core.bool]]
    })
  });
  EventTarget[dart.metadata] = () => [dart.const(new _metadata.DomName('EventTarget')), dart.const(new _js_helper.Native("EventTarget"))];
  let _localName = Symbol('_localName');
  let _namespaceUri = Symbol('_namespaceUri');
  let _removeChild = Symbol('_removeChild');
  let _replaceChild = Symbol('_replaceChild');
  let _this = Symbol('_this');
  let _clearChildren = Symbol('_clearChildren');
  class Node extends EventTarget {
    _created() {
      this.childNodes = null;
      this.baseUri = null;
      this.firstChild = null;
      this.lastChild = null;
      this[_localName] = null;
      this[_namespaceUri] = null;
      this.nextNode = null;
      this.nodeName = null;
      this.nodeType = null;
      this.nodeValue = null;
      this.ownerDocument = null;
      this.parent = null;
      this.parentNode = null;
      this.previousNode = null;
      this.text = null;
      super._created();
    }
    get nodes() {
      return new _ChildNodeListLazy(this);
    }
    set nodes(value) {
      let copy = core.List.from(value);
      this.text = '';
      for (let node of dart.as(copy, core.Iterable$(Node))) {
        this.append(node);
      }
    }
    remove() {
      if (this.parentNode != null) {
        let parent = this.parentNode;
        this.parentNode[_removeChild](this);
      }
    }
    replaceWith(otherNode) {
      try {
        let parent = this.parentNode;
        parent[_replaceChild](otherNode, this);
      } catch (e) {
      }

      ;
      return this;
    }
    insertAllBefore(newNodes, refChild) {
      if (dart.is(newNodes, _ChildNodeListLazy)) {
        let otherList = newNodes;
        if (dart.notNull(core.identical(otherList[_this], this))) {
          dart.throw(new core.ArgumentError(newNodes));
        }
        for (let i = 0, len = otherList.length; dart.notNull(dart.as(dart.dsend(i, '<', len), core.bool)); i = dart.dsend(i, '+', 1)) {
          this.insertBefore(otherList[_this].firstChild, refChild);
        }
      } else {
        for (let node of newNodes) {
          this.insertBefore(dart.as(node, Node), refChild);
        }
      }
    }
    [_clearChildren]() {
      while (this.firstChild != null) {
        this[_removeChild](this.firstChild);
      }
    }
    toString() {
      let value = this.nodeValue;
      return value == null ? super.toString() : value;
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.defineNamedConstructor(Node, '_created');
  dart.setSignature(Node, {
    constructors: () => ({
      _created: [Node, []],
      _: [Node, []]
    }),
    methods: () => ({
      remove: [dart.void, []],
      replaceWith: [Node, [Node]],
      insertAllBefore: [Node, [core.Iterable$(Node), Node]],
      [_clearChildren]: [dart.void, []],
      append: [Node, [Node]],
      clone: [Node, [core.bool]],
      contains: [core.bool, [Node]],
      hasChildNodes: [core.bool, []],
      insertBefore: [Node, [Node, Node]],
      [_removeChild]: [Node, [Node]],
      [_replaceChild]: [Node, [Node, Node]]
    })
  });
  dart.defineExtensionMembers(Node, ['toString']);
  Node[dart.metadata] = () => [dart.const(new _metadata.DomName('Node')), dart.const(new _js_helper.Native("Node"))];
  let _xtag = Symbol('_xtag');
  let _attributes = Symbol('_attributes');
  let _clientHeight = Symbol('_clientHeight');
  let _clientLeft = Symbol('_clientLeft');
  let _clientTop = Symbol('_clientTop');
  let _clientWidth = Symbol('_clientWidth');
  let _innerHtml = Symbol('_innerHtml');
  let _offsetHeight = Symbol('_offsetHeight');
  let _offsetLeft = Symbol('_offsetLeft');
  let _offsetTop = Symbol('_offsetTop');
  let _offsetWidth = Symbol('_offsetWidth');
  let _scrollHeight = Symbol('_scrollHeight');
  let _scrollLeft = Symbol('_scrollLeft');
  let _scrollTop = Symbol('_scrollTop');
  let _scrollWidth = Symbol('_scrollWidth');
  let _childElementCount = Symbol('_childElementCount');
  let _children = Symbol('_children');
  let _firstElementChild = Symbol('_firstElementChild');
  let _lastElementChild = Symbol('_lastElementChild');
  let _querySelectorAll = Symbol('_querySelectorAll');
  let _getComputedStyle = Symbol('_getComputedStyle');
  let _animate = Symbol('_animate');
  let _scrollIntoView = Symbol('_scrollIntoView');
  let _scrollIntoViewIfNeeded = Symbol('_scrollIntoViewIfNeeded');
  let _insertAdjacentText = Symbol('_insertAdjacentText');
  let _insertAdjacentNode = Symbol('_insertAdjacentNode');
  let _insertAdjacentHtml = Symbol('_insertAdjacentHtml');
  let _insertAdjacentElement = Symbol('_insertAdjacentElement');
  let _canBeUsedToCreateContextualFragment = Symbol('_canBeUsedToCreateContextualFragment');
  let _cannotBeUsedToCreateContextualFragment = Symbol('_cannotBeUsedToCreateContextualFragment');
  let _getElementsByTagName = Symbol('_getElementsByTagName');
  let _hasAttribute = Symbol('_hasAttribute');
  let _hasAttributeNS = Symbol('_hasAttributeNS');
  let _removeAttribute = Symbol('_removeAttribute');
  let _removeAttributeNS = Symbol('_removeAttributeNS');
  class Element extends Node {
    static html(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      let fragment = exports.document.body.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer});
      return dart.as(dart.dload(dart.dsend(dart.dload(fragment, 'nodes'), 'where', dart.fn(e => dart.is(e, Element), core.bool, [dart.dynamic])), 'single'), Element);
    }
    created() {
      this[_xtag] = null;
      this.contentEditable = null;
      this.contextMenu = null;
      this.dir = null;
      this.draggable = null;
      this.hidden = null;
      this.isContentEditable = null;
      this.lang = null;
      this.spellcheck = null;
      this.tabIndex = null;
      this.title = null;
      this.translate = null;
      this.dropzone = null;
      this[_attributes] = null;
      this.className = null;
      this[_clientHeight] = null;
      this[_clientLeft] = null;
      this[_clientTop] = null;
      this[_clientWidth] = null;
      this.id = null;
      this[_innerHtml] = null;
      this[_offsetHeight] = null;
      this[_offsetLeft] = null;
      this.offsetParent = null;
      this[_offsetTop] = null;
      this[_offsetWidth] = null;
      this.outerHtml = null;
      this[_scrollHeight] = null;
      this[_scrollLeft] = null;
      this[_scrollTop] = null;
      this[_scrollWidth] = null;
      this.style = null;
      this.tagName = null;
      this.nextElementSibling = null;
      this.previousElementSibling = null;
      this[_childElementCount] = null;
      this[_children] = null;
      this[_firstElementChild] = null;
      this[_lastElementChild] = null;
      super._created();
      _initializeCustomElement(this);
    }
    static tag(tag, typeExtention) {
      if (typeExtention === void 0)
        typeExtention = null;
      return dart.as(_ElementFactoryProvider.createElement_tag(tag, typeExtention), Element);
    }
    static a() {
      return Element.tag('a');
    }
    static article() {
      return Element.tag('article');
    }
    static aside() {
      return Element.tag('aside');
    }
    static audio() {
      return Element.tag('audio');
    }
    static br() {
      return Element.tag('br');
    }
    static canvas() {
      return Element.tag('canvas');
    }
    static div() {
      return Element.tag('div');
    }
    static footer() {
      return Element.tag('footer');
    }
    static header() {
      return Element.tag('header');
    }
    static hr() {
      return Element.tag('hr');
    }
    static iframe() {
      return Element.tag('iframe');
    }
    static img() {
      return Element.tag('img');
    }
    static li() {
      return Element.tag('li');
    }
    static nav() {
      return Element.tag('nav');
    }
    static ol() {
      return Element.tag('ol');
    }
    static option() {
      return Element.tag('option');
    }
    static p() {
      return Element.tag('p');
    }
    static pre() {
      return Element.tag('pre');
    }
    static section() {
      return Element.tag('section');
    }
    static select() {
      return Element.tag('select');
    }
    static span() {
      return Element.tag('span');
    }
    static svg() {
      return Element.tag('svg');
    }
    static table() {
      return Element.tag('table');
    }
    static td() {
      return Element.tag('td');
    }
    static textarea() {
      return Element.tag('textarea');
    }
    static th() {
      return Element.tag('th');
    }
    static tr() {
      return Element.tag('tr');
    }
    static ul() {
      return Element.tag('ul');
    }
    static video() {
      return Element.tag('video');
    }
    get attributes() {
      return new _ElementAttributeMap(this);
    }
    set attributes(value) {
      let attributes = this.attributes;
      attributes.clear();
      for (let key of value.keys) {
        attributes.set(key, value.get(key));
      }
    }
    get children() {
      return new _ChildrenElementList._wrap(this);
    }
    set children(value) {
      let copy = core.List.from(value);
      let children = this.children;
      dart.dsend(children, 'clear');
      dart.dsend(children, 'addAll', copy);
    }
    querySelectorAll(selectors) {
      return new _FrozenElementList._wrap(this[_querySelectorAll](selectors));
    }
    query(relativeSelectors) {
      return this.querySelector(relativeSelectors);
    }
    queryAll(relativeSelectors) {
      return this.querySelectorAll(relativeSelectors);
    }
    get classes() {
      return new exports._ElementCssClassSet(this);
    }
    set classes(value) {
      let classSet = this.classes;
      classSet.clear();
      classSet.addAll(value);
    }
    get dataset() {
      return new _DataAttributeMap(this.attributes);
    }
    set dataset(value) {
      let data = this.dataset;
      dart.dsend(data, 'clear');
      for (let key of value.keys) {
        dart.dsetindex(data, key, value.get(key));
      }
    }
    getNamespacedAttributes(namespace) {
      return new _NamespacedAttributeMap(this, namespace);
    }
    getComputedStyle(pseudoElement) {
      if (pseudoElement === void 0)
        pseudoElement = null;
      if (pseudoElement == null) {
        pseudoElement = '';
      }
      return exports.window[_getComputedStyle](this, pseudoElement);
    }
    get client() {
      return new math.Rectangle(this.clientLeft, this.clientTop, this.clientWidth, this.clientHeight);
    }
    get offset() {
      return new math.Rectangle(this.offsetLeft, this.offsetTop, this.offsetWidth, this.offsetHeight);
    }
    appendText(text) {
      this.append(Text.new(text));
    }
    appendHtml(text, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      this.insertAdjacentHtml('beforeend', text, {validator: validator, treeSanitizer: treeSanitizer});
    }
    static isTagSupported(tag) {
      let e = _ElementFactoryProvider.createElement_tag(tag, null);
      return dart.is(e, Element) && !dart.is(e, UnknownElement);
    }
    attached() {
      this.enteredView();
    }
    detached() {
      this.leftView();
    }
    enteredView() {}
    leftView() {}
    animate(frames, timing) {
      if (timing === void 0)
        timing = null;
      if (!dart.is(frames, core.Iterable) || !dart.notNull(frames[dartx.every](dart.fn(x => dart.is(x, core.Map), core.bool, [dart.dynamic])))) {
        dart.throw(new core.ArgumentError("The frames parameter should be a List of Maps " + "with frame information"));
      }
      let convertedFrames = frames;
      if (dart.is(convertedFrames, core.Iterable)) {
        convertedFrames = frames[dartx.map](html_common.convertDartToNative_Dictionary)[dartx.toList]();
      }
      let convertedTiming = timing;
      if (dart.is(convertedTiming, core.Map)) {
        convertedTiming = html_common.convertDartToNative_Dictionary(dart.as(convertedTiming, core.Map));
      }
      return convertedTiming == null ? this[_animate](convertedFrames) : this[_animate](convertedFrames, convertedTiming);
    }
    attributeChanged(name, oldValue, newValue) {}
    get xtag() {
      return this[_xtag] != null ? this[_xtag] : this;
    }
    set xtag(value) {
      this[_xtag] = value;
    }
    get localName() {
      return dart.as(this[_localName], core.String);
    }
    get namespaceUri() {
      return this[_namespaceUri];
    }
    toString() {
      return this.localName;
    }
    scrollIntoView(alignment) {
      if (alignment === void 0)
        alignment = null;
      let hasScrollIntoViewIfNeeded = true;
      hasScrollIntoViewIfNeeded = !!this.scrollIntoViewIfNeeded;
      if (dart.equals(alignment, ScrollAlignment.TOP)) {
        this[_scrollIntoView](true);
      } else if (dart.equals(alignment, ScrollAlignment.BOTTOM)) {
        this[_scrollIntoView](false);
      } else if (dart.notNull(dart.as(hasScrollIntoViewIfNeeded, core.bool))) {
        if (dart.equals(alignment, ScrollAlignment.CENTER)) {
          this[_scrollIntoViewIfNeeded](true);
        } else {
          this[_scrollIntoViewIfNeeded]();
        }
      } else {
        this[_scrollIntoView]();
      }
    }
    static _determineMouseWheelEventType(e) {
      return 'wheel';
    }
    static _determineTransitionEventType(e) {
      if (dart.notNull(html_common.Device.isWebKit)) {
        return 'webkitTransitionEnd';
      } else if (dart.notNull(html_common.Device.isOpera)) {
        return 'oTransitionEnd';
      }
      return 'transitionend';
    }
    insertAdjacentText(where, text) {
      if (dart.notNull(dart.as(!!this.insertAdjacentText, core.bool))) {
        this[_insertAdjacentText](where, text);
      } else {
        this[_insertAdjacentNode](where, Text.new(text));
      }
    }
    insertAdjacentHtml(where, html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      if (dart.is(treeSanitizer, _TrustedHtmlTreeSanitizer)) {
        this[_insertAdjacentHtml](where, html);
      } else {
        this[_insertAdjacentNode](where, this.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer}));
      }
    }
    insertAdjacentElement(where, element) {
      if (dart.notNull(dart.as(!!this.insertAdjacentElement, core.bool))) {
        this[_insertAdjacentElement](where, element);
      } else {
        this[_insertAdjacentNode](where, element);
      }
      return element;
    }
    [_insertAdjacentNode](where, node) {
      switch (where[dartx.toLowerCase]()) {
        case 'beforebegin':
        {
          this.parentNode.insertBefore(node, this);
          break;
        }
        case 'afterbegin':
        {
          let first = dart.notNull(this.nodes[dartx.length]) > 0 ? this.nodes[dartx.get](0) : null;
          this.insertBefore(node, dart.as(first, Node));
          break;
        }
        case 'beforeend':
        {
          this.append(node);
          break;
        }
        case 'afterend':
        {
          this.parentNode.insertBefore(node, this.nextNode);
          break;
        }
        default:
        {
          dart.throw(new core.ArgumentError(`Invalid position ${where}`));
        }
      }
    }
    matches(selectors) {
      if (dart.notNull(dart.as(!!this.matches, core.bool))) {
        return dart.as(this.matches(selectors), core.bool);
      } else if (dart.notNull(dart.as(!!this.webkitMatchesSelector, core.bool))) {
        return dart.as(this.webkitMatchesSelector(selectors), core.bool);
      } else if (dart.notNull(dart.as(!!this.mozMatchesSelector, core.bool))) {
        return dart.as(this.mozMatchesSelector(selectors), core.bool);
      } else if (dart.notNull(dart.as(!!this.msMatchesSelector, core.bool))) {
        return dart.as(this.msMatchesSelector(selectors), core.bool);
      } else if (dart.notNull(dart.as(!!this.oMatchesSelector, core.bool))) {
        return dart.as(this.oMatchesSelector(selectors), core.bool);
      } else {
        dart.throw(new core.UnsupportedError("Not supported on this platform"));
      }
    }
    matchesWithAncestors(selectors) {
      let elem = this;
      do {
        if (dart.notNull(dart.as(dart.dsend(elem, 'matches', selectors), core.bool)))
          return true;
        elem = dart.dload(elem, 'parent');
      } while (elem != null);
      return false;
    }
    createShadowRoot() {
      return dart.as((this.createShadowRoot || this.webkitCreateShadowRoot).call(this), ShadowRoot);
    }
    get shadowRoot() {
      return dart.as(this.shadowRoot || this.webkitShadowRoot, ShadowRoot);
    }
    get contentEdge() {
      return new _ContentCssRect(this);
    }
    get paddingEdge() {
      return new _PaddingCssRect(this);
    }
    get borderEdge() {
      return new _BorderCssRect(this);
    }
    get marginEdge() {
      return new _MarginCssRect(this);
    }
    get documentOffset() {
      return this.offsetTo(exports.document.documentElement);
    }
    offsetTo(parent) {
      return Element._offsetToHelper(this, parent);
    }
    static _offsetToHelper(current, parent) {
      let foundAsParent = dart.notNull(core.identical(current, parent)) || parent.tagName == 'HTML';
      if (current == null || dart.notNull(core.identical(current, parent))) {
        if (dart.notNull(foundAsParent))
          return new math.Point(0, 0);
        dart.throw(new core.ArgumentError("Specified element is not a transitive offset " + "parent of this element."));
      }
      let parentOffset = current.offsetParent;
      let p = Element._offsetToHelper(parentOffset, parent);
      return new math.Point(dart.dsend(p.x, '+', current.offsetLeft), dart.dsend(p.y, '+', current.offsetTop));
    }
    createFragment(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      if (treeSanitizer == null) {
        if (validator == null) {
          if (Element._defaultValidator == null) {
            Element._defaultValidator = new NodeValidatorBuilder.common();
          }
          validator = Element._defaultValidator;
        }
        if (Element._defaultSanitizer == null) {
          Element._defaultSanitizer = new _ValidatingTreeSanitizer(validator);
        } else {
          Element._defaultSanitizer.validator = validator;
        }
        treeSanitizer = Element._defaultSanitizer;
      } else if (validator != null) {
        dart.throw(new core.ArgumentError('validator can only be passed if treeSanitizer is null'));
      }
      if (Element._parseDocument == null) {
        Element._parseDocument = exports.document.implementation.createHtmlDocument('');
        Element._parseRange = Element._parseDocument.createRange();
        let base = Element._parseDocument.createElement('base');
        dart.dput(base, 'href', exports.document.baseUri);
        Element._parseDocument.head.append(dart.as(base, Node));
      }
      let contextElement = null;
      if (dart.is(this, BodyElement)) {
        contextElement = Element._parseDocument.body;
      } else {
        contextElement = Element._parseDocument.createElement(this.tagName);
        Element._parseDocument.body.append(dart.as(contextElement, Node));
      }
      let fragment = null;
      if (dart.notNull(Range.supportsCreateContextualFragment) && dart.notNull(this[_canBeUsedToCreateContextualFragment])) {
        Element._parseRange.selectNodeContents(dart.as(contextElement, Node));
        fragment = Element._parseRange.createContextualFragment(html);
      } else {
        dart.dput(contextElement, _innerHtml, html);
        fragment = Element._parseDocument.createDocumentFragment();
        while (dart.dload(contextElement, 'firstChild') != null) {
          dart.dsend(fragment, 'append', dart.dload(contextElement, 'firstChild'));
        }
      }
      if (!dart.equals(contextElement, Element._parseDocument.body)) {
        dart.dsend(contextElement, 'remove');
      }
      treeSanitizer.sanitizeTree(dart.as(fragment, Node));
      exports.document.adoptNode(dart.as(fragment, Node));
      return dart.as(fragment, DocumentFragment);
    }
    get [_canBeUsedToCreateContextualFragment]() {
      return !dart.notNull(this[_cannotBeUsedToCreateContextualFragment]);
    }
    get [_cannotBeUsedToCreateContextualFragment]() {
      return dart.as(dart.dsend(Element._tagsForWhichCreateContextualFragmentIsNotSupported, 'contains', this.tagName), core.bool);
    }
    set innerHtml(html) {
      this.setInnerHtml(html);
    }
    setInnerHtml(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      this.text = null;
      if (dart.is(treeSanitizer, _TrustedHtmlTreeSanitizer)) {
        this[_innerHtml] = html;
      } else {
        this.append(this.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer}));
      }
    }
    get innerHtml() {
      return this[_innerHtml];
    }
    get on() {
      return new ElementEvents(this);
    }
    static _hasCorruptedAttributes(element) {
      return dart.as((function(element) {
        if (!(element.attributes instanceof NamedNodeMap)) {
          return true;
        }
        var childNodes = element.childNodes;
        if (element.lastChild && element.lastChild !== childNodes[childNodes.length - 1]) {
          return true;
        }
        if (element.children) {
          if (!(element.children instanceof HTMLCollection || element.children instanceof NodeList)) {
            return true;
          }
        }
        return false;
      })(element), core.bool);
    }
    get offsetHeight() {
      return dart.as(dart.dsend(this.offsetHeight, 'round'), core.int);
    }
    get offsetLeft() {
      return dart.as(dart.dsend(this.offsetLeft, 'round'), core.int);
    }
    get offsetTop() {
      return dart.as(dart.dsend(this.offsetTop, 'round'), core.int);
    }
    get offsetWidth() {
      return dart.as(dart.dsend(this.offsetWidth, 'round'), core.int);
    }
    get clientHeight() {
      return dart.as(dart.dsend(this.clientHeight, 'round'), core.int);
    }
    get clientLeft() {
      return dart.as(dart.dsend(this.clientLeft, 'round'), core.int);
    }
    get clientTop() {
      return dart.as(dart.dsend(this.clientTop, 'round'), core.int);
    }
    get clientWidth() {
      return dart.as(dart.dsend(this.clientWidth, 'round'), core.int);
    }
    get scrollHeight() {
      return dart.as(dart.dsend(this.scrollHeight, 'round'), core.int);
    }
    get scrollLeft() {
      return dart.as(dart.dsend(this.scrollLeft, 'round'), core.int);
    }
    set scrollLeft(value) {
      this.scrollLeft = value[dartx.round]();
    }
    get scrollTop() {
      return dart.as(dart.dsend(this.scrollTop, 'round'), core.int);
    }
    set scrollTop(value) {
      this.scrollTop = value[dartx.round]();
    }
    get scrollWidth() {
      return dart.as(dart.dsend(this.scrollWidth, 'round'), core.int);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onAbort() {
      return Element.abortEvent.forElement(this);
    }
    get onBeforeCopy() {
      return Element.beforeCopyEvent.forElement(this);
    }
    get onBeforeCut() {
      return Element.beforeCutEvent.forElement(this);
    }
    get onBeforePaste() {
      return Element.beforePasteEvent.forElement(this);
    }
    get onBlur() {
      return Element.blurEvent.forElement(this);
    }
    get onCanPlay() {
      return Element.canPlayEvent.forElement(this);
    }
    get onCanPlayThrough() {
      return Element.canPlayThroughEvent.forElement(this);
    }
    get onChange() {
      return Element.changeEvent.forElement(this);
    }
    get onClick() {
      return Element.clickEvent.forElement(this);
    }
    get onContextMenu() {
      return Element.contextMenuEvent.forElement(this);
    }
    get onCopy() {
      return Element.copyEvent.forElement(this);
    }
    get onCut() {
      return Element.cutEvent.forElement(this);
    }
    get onDoubleClick() {
      return Element.doubleClickEvent.forElement(this);
    }
    get onDrag() {
      return Element.dragEvent.forElement(this);
    }
    get onDragEnd() {
      return Element.dragEndEvent.forElement(this);
    }
    get onDragEnter() {
      return Element.dragEnterEvent.forElement(this);
    }
    get onDragLeave() {
      return Element.dragLeaveEvent.forElement(this);
    }
    get onDragOver() {
      return Element.dragOverEvent.forElement(this);
    }
    get onDragStart() {
      return Element.dragStartEvent.forElement(this);
    }
    get onDrop() {
      return Element.dropEvent.forElement(this);
    }
    get onDurationChange() {
      return Element.durationChangeEvent.forElement(this);
    }
    get onEmptied() {
      return Element.emptiedEvent.forElement(this);
    }
    get onEnded() {
      return Element.endedEvent.forElement(this);
    }
    get onError() {
      return Element.errorEvent.forElement(this);
    }
    get onFocus() {
      return Element.focusEvent.forElement(this);
    }
    get onInput() {
      return Element.inputEvent.forElement(this);
    }
    get onInvalid() {
      return Element.invalidEvent.forElement(this);
    }
    get onKeyDown() {
      return Element.keyDownEvent.forElement(this);
    }
    get onKeyPress() {
      return Element.keyPressEvent.forElement(this);
    }
    get onKeyUp() {
      return Element.keyUpEvent.forElement(this);
    }
    get onLoad() {
      return Element.loadEvent.forElement(this);
    }
    get onLoadedData() {
      return Element.loadedDataEvent.forElement(this);
    }
    get onLoadedMetadata() {
      return Element.loadedMetadataEvent.forElement(this);
    }
    get onMouseDown() {
      return Element.mouseDownEvent.forElement(this);
    }
    get onMouseEnter() {
      return Element.mouseEnterEvent.forElement(this);
    }
    get onMouseLeave() {
      return Element.mouseLeaveEvent.forElement(this);
    }
    get onMouseMove() {
      return Element.mouseMoveEvent.forElement(this);
    }
    get onMouseOut() {
      return Element.mouseOutEvent.forElement(this);
    }
    get onMouseOver() {
      return Element.mouseOverEvent.forElement(this);
    }
    get onMouseUp() {
      return Element.mouseUpEvent.forElement(this);
    }
    get onMouseWheel() {
      return Element.mouseWheelEvent.forElement(this);
    }
    get onPaste() {
      return Element.pasteEvent.forElement(this);
    }
    get onPause() {
      return Element.pauseEvent.forElement(this);
    }
    get onPlay() {
      return Element.playEvent.forElement(this);
    }
    get onPlaying() {
      return Element.playingEvent.forElement(this);
    }
    get onRateChange() {
      return Element.rateChangeEvent.forElement(this);
    }
    get onReset() {
      return Element.resetEvent.forElement(this);
    }
    get onResize() {
      return Element.resizeEvent.forElement(this);
    }
    get onScroll() {
      return Element.scrollEvent.forElement(this);
    }
    get onSearch() {
      return Element.searchEvent.forElement(this);
    }
    get onSeeked() {
      return Element.seekedEvent.forElement(this);
    }
    get onSeeking() {
      return Element.seekingEvent.forElement(this);
    }
    get onSelect() {
      return Element.selectEvent.forElement(this);
    }
    get onSelectStart() {
      return Element.selectStartEvent.forElement(this);
    }
    get onStalled() {
      return Element.stalledEvent.forElement(this);
    }
    get onSubmit() {
      return Element.submitEvent.forElement(this);
    }
    get onSuspend() {
      return Element.suspendEvent.forElement(this);
    }
    get onTimeUpdate() {
      return Element.timeUpdateEvent.forElement(this);
    }
    get onTouchCancel() {
      return Element.touchCancelEvent.forElement(this);
    }
    get onTouchEnd() {
      return Element.touchEndEvent.forElement(this);
    }
    get onTouchEnter() {
      return Element.touchEnterEvent.forElement(this);
    }
    get onTouchLeave() {
      return Element.touchLeaveEvent.forElement(this);
    }
    get onTouchMove() {
      return Element.touchMoveEvent.forElement(this);
    }
    get onTouchStart() {
      return Element.touchStartEvent.forElement(this);
    }
    get onTransitionEnd() {
      return Element.transitionEndEvent.forElement(this);
    }
    get onVolumeChange() {
      return Element.volumeChangeEvent.forElement(this);
    }
    get onWaiting() {
      return Element.waitingEvent.forElement(this);
    }
    get onFullscreenChange() {
      return Element.fullscreenChangeEvent.forElement(this);
    }
    get onFullscreenError() {
      return Element.fullscreenErrorEvent.forElement(this);
    }
  }
  Element[dart.implements] = () => [GlobalEventHandlers, ParentNode, ChildNode];
  dart.defineNamedConstructor(Element, 'created');
  dart.setSignature(Element, {
    constructors: () => ({
      html: [Element, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      created: [Element, []],
      tag: [Element, [core.String], [core.String]],
      a: [Element, []],
      article: [Element, []],
      aside: [Element, []],
      audio: [Element, []],
      br: [Element, []],
      canvas: [Element, []],
      div: [Element, []],
      footer: [Element, []],
      header: [Element, []],
      hr: [Element, []],
      iframe: [Element, []],
      img: [Element, []],
      li: [Element, []],
      nav: [Element, []],
      ol: [Element, []],
      option: [Element, []],
      p: [Element, []],
      pre: [Element, []],
      section: [Element, []],
      select: [Element, []],
      span: [Element, []],
      svg: [Element, []],
      table: [Element, []],
      td: [Element, []],
      textarea: [Element, []],
      th: [Element, []],
      tr: [Element, []],
      ul: [Element, []],
      video: [Element, []],
      _: [Element, []]
    }),
    methods: () => ({
      querySelectorAll: [ElementList$(Element), [core.String]],
      query: [Element, [core.String]],
      queryAll: [ElementList$(Element), [core.String]],
      getNamespacedAttributes: [core.Map$(core.String, core.String), [core.String]],
      getComputedStyle: [CssStyleDeclaration, [], [core.String]],
      appendText: [dart.void, [core.String]],
      appendHtml: [dart.void, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      attached: [dart.void, []],
      detached: [dart.void, []],
      enteredView: [dart.void, []],
      leftView: [dart.void, []],
      animate: [AnimationPlayer, [core.Iterable$(core.Map$(core.String, dart.dynamic))], [dart.dynamic]],
      [_animate]: [AnimationPlayer, [core.Object], [dart.dynamic]],
      attributeChanged: [dart.void, [core.String, core.String, core.String]],
      scrollIntoView: [dart.void, [], [ScrollAlignment]],
      insertAdjacentText: [dart.void, [core.String, core.String]],
      [_insertAdjacentText]: [dart.void, [core.String, core.String]],
      insertAdjacentHtml: [dart.void, [core.String, core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      [_insertAdjacentHtml]: [dart.void, [core.String, core.String]],
      insertAdjacentElement: [Element, [core.String, Element]],
      [_insertAdjacentElement]: [dart.void, [core.String, Element]],
      [_insertAdjacentNode]: [dart.void, [core.String, Node]],
      matches: [core.bool, [core.String]],
      matchesWithAncestors: [core.bool, [core.String]],
      createShadowRoot: [ShadowRoot, []],
      offsetTo: [math.Point, [Element]],
      createFragment: [DocumentFragment, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      setInnerHtml: [dart.void, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      click: [dart.void, []],
      blur: [dart.void, []],
      focus: [dart.void, []],
      getAnimationPlayers: [core.List$(AnimationPlayer), []],
      getAttribute: [core.String, [core.String]],
      getAttributeNS: [core.String, [core.String, core.String]],
      getBoundingClientRect: [math.Rectangle, []],
      getClientRects: [core.List$(math.Rectangle), []],
      getDestinationInsertionPoints: [core.List$(Node), []],
      getElementsByClassName: [core.List$(Node), [core.String]],
      [_getElementsByTagName]: [core.List$(Node), [core.String]],
      [_hasAttribute]: [core.bool, [core.String]],
      [_hasAttributeNS]: [core.bool, [core.String, core.String]],
      [_removeAttribute]: [dart.void, [core.String]],
      [_removeAttributeNS]: [dart.void, [core.String, core.String]],
      requestFullscreen: [dart.void, []],
      requestPointerLock: [dart.void, []],
      [_scrollIntoView]: [dart.void, [], [core.bool]],
      [_scrollIntoViewIfNeeded]: [dart.void, [], [core.bool]],
      setAttribute: [dart.void, [core.String, core.String]],
      setAttributeNS: [dart.void, [core.String, core.String, core.String]],
      querySelector: [Element, [core.String]],
      [_querySelectorAll]: [core.List$(Node), [core.String]]
    }),
    statics: () => ({
      isTagSupported: [core.bool, [core.String]],
      _determineMouseWheelEventType: [core.String, [EventTarget]],
      _determineTransitionEventType: [core.String, [EventTarget]],
      _offsetToHelper: [math.Point, [Element, Element]],
      _hasCorruptedAttributes: [core.bool, [Element]]
    }),
    names: ['isTagSupported', '_determineMouseWheelEventType', '_determineTransitionEventType', '_offsetToHelper', '_hasCorruptedAttributes']
  });
  dart.defineExtensionMembers(Element, ['toString']);
  Element[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Element')), dart.const(new _js_helper.Native("Element"))];
  class HtmlElement extends Element {
    static new() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(HtmlElement, 'created');
  dart.setSignature(HtmlElement, {
    constructors: () => ({
      new: [HtmlElement, []],
      created: [HtmlElement, []]
    })
  });
  HtmlElement[dart.metadata] = () => [dart.const(new _js_helper.Native("HTMLElement"))];
  class _EntryArray extends core.Object {}
  _EntryArray[dart.implements] = () => [core.List$(Entry)];
  _EntryArray[dart.metadata] = () => [dart.const(new _js_helper.Native("EntryArray"))];
  function spawnDomUri(uri, args, message) {
    dart.throw(new core.UnimplementedError());
  }
  dart.fn(spawnDomUri, async.Future$(isolate.Isolate), [core.Uri, core.List$(core.String), dart.dynamic]);
  class AbstractWorker extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onError() {
      return AbstractWorker.errorEvent.forTarget(this);
    }
  }
  AbstractWorker[dart.implements] = () => [EventTarget];
  dart.setSignature(AbstractWorker, {
    constructors: () => ({_: [AbstractWorker, []]})
  });
  AbstractWorker[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AbstractWorker'))];
  let _eventType = Symbol('_eventType');
  let _forElementList = Symbol('_forElementList');
  let EventStreamProvider$ = dart.generic(function(T) {
    class EventStreamProvider extends core.Object {
      EventStreamProvider(eventType) {
        this[_eventType] = eventType;
      }
      forTarget(e, opts) {
        let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
        return new (_EventStream$(T))(e, this[_eventType], useCapture);
      }
      forElement(e, opts) {
        let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
        return new (_ElementEventStreamImpl$(T))(e, this[_eventType], useCapture);
      }
      [_forElementList](e, opts) {
        let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
        return new _ElementListEventStreamImpl(dart.as(e, core.Iterable$(Element)), this[_eventType], useCapture);
      }
      getEventType(target) {
        return this[_eventType];
      }
    }
    dart.setSignature(EventStreamProvider, {
      constructors: () => ({EventStreamProvider: [EventStreamProvider$(T), [core.String]]}),
      methods: () => ({
        forTarget: [async.Stream$(T), [EventTarget], {useCapture: core.bool}],
        forElement: [ElementStream$(T), [Element], {useCapture: core.bool}],
        [_forElementList]: [ElementStream$(T), [ElementList], {useCapture: core.bool}],
        getEventType: [core.String, [EventTarget]]
      })
    });
    return EventStreamProvider;
  });
  let EventStreamProvider = EventStreamProvider$();
  let _createEvent = Symbol('_createEvent');
  let _initEvent = Symbol('_initEvent');
  let _selector = Symbol('_selector');
  let _get_currentTarget = Symbol('_get_currentTarget');
  let _get_target = Symbol('_get_target');
  class Event extends _interceptors.Interceptor {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      return Event.eventType('Event', type, {canBubble: canBubble, cancelable: cancelable});
    }
    static eventType(type, name, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let e = exports.document[_createEvent](type);
      e[_initEvent](name, canBubble, cancelable);
      return e;
    }
    get matchingTarget() {
      if (this[_selector] == null) {
        dart.throw(new core.UnsupportedError('Cannot call matchingTarget if this Event did' + ' not arise as a result of event delegation.'));
      }
      let currentTarget = this.currentTarget;
      let target = this.target;
      let matchedTarget = null;
      do {
        if (dart.notNull(dart.as(dart.dsend(target, 'matches', this[_selector]), core.bool)))
          return dart.as(target, Element);
        target = dart.dload(target, 'parent');
      } while (target != null && !dart.equals(target, dart.dload(currentTarget, 'parent')));
      dart.throw(new core.StateError('No selector matched for populating matchedTarget.'));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get currentTarget() {
      return _convertNativeToDart_EventTarget(this[_get_currentTarget]);
    }
    get target() {
      return _convertNativeToDart_EventTarget(this[_get_target]);
    }
  }
  dart.setSignature(Event, {
    constructors: () => ({
      new: [Event, [core.String], {canBubble: core.bool, cancelable: core.bool}],
      eventType: [Event, [core.String, core.String], {canBubble: core.bool, cancelable: core.bool}],
      _: [Event, []]
    }),
    methods: () => ({
      [_initEvent]: [dart.void, [core.String, core.bool, core.bool]],
      preventDefault: [dart.void, []],
      stopImmediatePropagation: [dart.void, []],
      stopPropagation: [dart.void, []]
    })
  });
  Event[dart.metadata] = () => [dart.const(new _metadata.DomName('Event')), dart.const(new _js_helper.Native("Event,InputEvent,ClipboardEvent"))];
  class ErrorEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ErrorEvent, {
    constructors: () => ({_: [ErrorEvent, []]})
  });
  ErrorEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ErrorEvent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("ErrorEvent"))];
  AbstractWorker.errorEvent = dart.const(new (EventStreamProvider$(ErrorEvent))('error'));
  class AnchorElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(opts) {
      let href = opts && 'href' in opts ? opts.href : null;
      let e = exports.document.createElement("a");
      if (href != null)
        dart.dput(e, 'href', href);
      return dart.as(e, AnchorElement);
    }
    created() {
      this.download = null;
      this.hreflang = null;
      this.integrity = null;
      this.rel = null;
      this.target = null;
      this.type = null;
      this.hash = null;
      this.host = null;
      this.hostname = null;
      this.href = null;
      this.origin = null;
      this.password = null;
      this.pathname = null;
      this.port = null;
      this.protocol = null;
      this.search = null;
      this.username = null;
      super.created();
    }
    toString() {
      return dart.as(String(this), core.String);
    }
  }
  AnchorElement[dart.implements] = () => [UrlUtils];
  dart.defineNamedConstructor(AnchorElement, 'created');
  dart.setSignature(AnchorElement, {
    constructors: () => ({
      _: [AnchorElement, []],
      new: [AnchorElement, [], {href: core.String}],
      created: [AnchorElement, []]
    })
  });
  dart.defineExtensionMembers(AnchorElement, ['toString']);
  AnchorElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLAnchorElement')), dart.const(new _js_helper.Native("HTMLAnchorElement"))];
  class AnimationNode extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimationNode, {
    constructors: () => ({_: [AnimationNode, []]})
  });
  AnimationNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AnimationNode')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AnimationNode"))];
  class Animation extends AnimationNode {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(target, keyframes, timingInput) {
      if (timingInput === void 0)
        timingInput = null;
      if ((dart.is(keyframes, core.List$(core.Map)) || keyframes == null) && (dart.is(target, Element) || target == null) && timingInput == null) {
        return Animation._create_1(target, keyframes);
      }
      if ((typeof timingInput == 'number' || timingInput == null) && (dart.is(keyframes, core.List$(core.Map)) || keyframes == null) && (dart.is(target, Element) || target == null)) {
        return Animation._create_2(target, keyframes, timingInput);
      }
      if ((dart.is(timingInput, core.Map) || timingInput == null) && (dart.is(keyframes, core.List$(core.Map)) || keyframes == null) && (dart.is(target, Element) || target == null)) {
        let timingInput_1 = html_common.convertDartToNative_Dictionary(dart.as(timingInput, core.Map));
        return Animation._create_3(target, keyframes, timingInput_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1(target, keyframes) {
      return dart.as(new Animation(target, keyframes), Animation);
    }
    static _create_2(target, keyframes, timingInput) {
      return dart.as(new Animation(target, keyframes, timingInput), Animation);
    }
    static _create_3(target, keyframes, timingInput) {
      return dart.as(new Animation(target, keyframes, timingInput), Animation);
    }
  }
  dart.setSignature(Animation, {
    constructors: () => ({
      _: [Animation, []],
      new: [Animation, [Element, core.List$(core.Map)], [dart.dynamic]]
    }),
    statics: () => ({
      _create_1: [Animation, [dart.dynamic, dart.dynamic]],
      _create_2: [Animation, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_3: [Animation, [dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3']
  });
  Animation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Animation')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Animation"))];
  class AnimationEffect extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimationEffect, {
    constructors: () => ({_: [AnimationEffect, []]})
  });
  AnimationEffect[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AnimationEffect')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AnimationEffect"))];
  class AnimationEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimationEvent, {
    constructors: () => ({_: [AnimationEvent, []]})
  });
  AnimationEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WebKitAnimationEvent')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WebKitAnimationEvent"))];
  class AnimationPlayer extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!document.body.animate, core.bool);
    }
  }
  dart.setSignature(AnimationPlayer, {
    constructors: () => ({_: [AnimationPlayer, []]}),
    methods: () => ({
      cancel: [dart.void, []],
      finish: [dart.void, []],
      pause: [dart.void, []],
      play: [dart.void, []],
      reverse: [dart.void, []]
    })
  });
  AnimationPlayer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AnimationPlayer')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AnimationPlayer"))];
  class AnimationPlayerEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimationPlayerEvent, {
    constructors: () => ({_: [AnimationPlayerEvent, []]})
  });
  AnimationPlayerEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AnimationPlayerEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AnimationPlayerEvent"))];
  class AnimationTimeline extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AnimationTimeline, {
    constructors: () => ({_: [AnimationTimeline, []]}),
    methods: () => ({
      getAnimationPlayers: [core.List$(AnimationPlayer), []],
      play: [AnimationPlayer, [AnimationNode]]
    })
  });
  AnimationTimeline[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AnimationTimeline')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AnimationTimeline"))];
  class ApplicationCache extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!window.applicationCache, core.bool);
    }
    get onCached() {
      return ApplicationCache.cachedEvent.forTarget(this);
    }
    get onChecking() {
      return ApplicationCache.checkingEvent.forTarget(this);
    }
    get onDownloading() {
      return ApplicationCache.downloadingEvent.forTarget(this);
    }
    get onError() {
      return ApplicationCache.errorEvent.forTarget(this);
    }
    get onNoUpdate() {
      return ApplicationCache.noUpdateEvent.forTarget(this);
    }
    get onObsolete() {
      return ApplicationCache.obsoleteEvent.forTarget(this);
    }
    get onProgress() {
      return ApplicationCache.progressEvent.forTarget(this);
    }
    get onUpdateReady() {
      return ApplicationCache.updateReadyEvent.forTarget(this);
    }
  }
  dart.setSignature(ApplicationCache, {
    constructors: () => ({_: [ApplicationCache, []]}),
    methods: () => ({
      abort: [dart.void, []],
      swapCache: [dart.void, []],
      update: [dart.void, []]
    })
  });
  ApplicationCache[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ApplicationCache')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.OPERA)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("ApplicationCache,DOMApplicationCache,OfflineResourceList"))];
  ApplicationCache.cachedEvent = dart.const(new (EventStreamProvider$(Event))('cached'));
  ApplicationCache.checkingEvent = dart.const(new (EventStreamProvider$(Event))('checking'));
  ApplicationCache.downloadingEvent = dart.const(new (EventStreamProvider$(Event))('downloading'));
  ApplicationCache.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  ApplicationCache.noUpdateEvent = dart.const(new (EventStreamProvider$(Event))('noupdate'));
  ApplicationCache.obsoleteEvent = dart.const(new (EventStreamProvider$(Event))('obsolete'));
  class ProgressEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ProgressEvent, {
    constructors: () => ({_: [ProgressEvent, []]})
  });
  ProgressEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ProgressEvent')), dart.const(new _js_helper.Native("ProgressEvent"))];
  ApplicationCache.progressEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('progress'));
  ApplicationCache.updateReadyEvent = dart.const(new (EventStreamProvider$(Event))('updateready'));
  ApplicationCache.CHECKING = 2;
  ApplicationCache.DOWNLOADING = 3;
  ApplicationCache.IDLE = 1;
  ApplicationCache.OBSOLETE = 5;
  ApplicationCache.UNCACHED = 0;
  ApplicationCache.UPDATEREADY = 4;
  class ApplicationCacheErrorEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ApplicationCacheErrorEvent, {
    constructors: () => ({_: [ApplicationCacheErrorEvent, []]})
  });
  ApplicationCacheErrorEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ApplicationCacheErrorEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ApplicationCacheErrorEvent"))];
  class AreaElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("area"), AreaElement);
    }
    created() {
      this.alt = null;
      this.coords = null;
      this.shape = null;
      this.target = null;
      this.hash = null;
      this.host = null;
      this.hostname = null;
      this.href = null;
      this.origin = null;
      this.password = null;
      this.pathname = null;
      this.port = null;
      this.protocol = null;
      this.search = null;
      this.username = null;
      super.created();
    }
    toString() {
      return dart.as(String(this), core.String);
    }
  }
  AreaElement[dart.implements] = () => [UrlUtils];
  dart.defineNamedConstructor(AreaElement, 'created');
  dart.setSignature(AreaElement, {
    constructors: () => ({
      _: [AreaElement, []],
      new: [AreaElement, []],
      created: [AreaElement, []]
    })
  });
  dart.defineExtensionMembers(AreaElement, ['toString']);
  AreaElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLAreaElement')), dart.const(new _js_helper.Native("HTMLAreaElement"))];
  class MediaElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this.audioTracks = null;
      this.autoplay = null;
      this.buffered = null;
      this.controller = null;
      this.controls = null;
      this.crossOrigin = null;
      this.currentSrc = null;
      this.currentTime = null;
      this.defaultMuted = null;
      this.defaultPlaybackRate = null;
      this.duration = null;
      this.ended = null;
      this.error = null;
      this.integrity = null;
      this.loop = null;
      this.mediaGroup = null;
      this.mediaKeys = null;
      this.muted = null;
      this.networkState = null;
      this.paused = null;
      this.playbackRate = null;
      this.played = null;
      this.preload = null;
      this.readyState = null;
      this.seekable = null;
      this.seeking = null;
      this.src = null;
      this.textTracks = null;
      this.videoTracks = null;
      this.volume = null;
      this.audioDecodedByteCount = null;
      this.videoDecodedByteCount = null;
      super.created();
    }
    get onKeyAdded() {
      return MediaElement.keyAddedEvent.forElement(this);
    }
    get onKeyError() {
      return MediaElement.keyErrorEvent.forElement(this);
    }
    get onKeyMessage() {
      return MediaElement.keyMessageEvent.forElement(this);
    }
    get onNeedKey() {
      return MediaElement.needKeyEvent.forElement(this);
    }
  }
  dart.defineNamedConstructor(MediaElement, 'created');
  dart.setSignature(MediaElement, {
    constructors: () => ({
      _: [MediaElement, []],
      created: [MediaElement, []]
    }),
    methods: () => ({
      addTextTrack: [TextTrack, [core.String], [core.String, core.String]],
      canPlayType: [core.String, [core.String], [core.String]],
      load: [dart.void, []],
      pause: [dart.void, []],
      play: [dart.void, []],
      setMediaKeys: [async.Future, [MediaKeys]],
      addKey: [dart.void, [core.String, typed_data.Uint8List], [typed_data.Uint8List, core.String]],
      cancelKeyRequest: [dart.void, [core.String, core.String]],
      generateKeyRequest: [dart.void, [core.String], [typed_data.Uint8List]]
    })
  });
  MediaElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMediaElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLMediaElement"))];
  class AudioElement extends MediaElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(src) {
      if (src === void 0)
        src = null;
      if (src != null) {
        return AudioElement._create_1(src);
      }
      return AudioElement._create_2();
    }
    static _create_1(src) {
      return dart.as(new Audio(src), AudioElement);
    }
    static _create_2() {
      return dart.as(new Audio(), AudioElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(AudioElement, 'created');
  dart.setSignature(AudioElement, {
    constructors: () => ({
      _: [AudioElement, []],
      new: [AudioElement, [], [core.String]],
      created: [AudioElement, []]
    }),
    statics: () => ({
      _create_1: [AudioElement, [dart.dynamic]],
      _create_2: [AudioElement, []]
    }),
    names: ['_create_1', '_create_2']
  });
  AudioElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLAudioElement')), dart.const(new _js_helper.Native("HTMLAudioElement"))];
  class AudioTrack extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AudioTrack, {
    constructors: () => ({_: [AudioTrack, []]})
  });
  AudioTrack[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioTrack')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioTrack"))];
  let __getter__ = Symbol('__getter__');
  class AudioTrackList extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onChange() {
      return AudioTrackList.changeEvent.forTarget(this);
    }
  }
  dart.setSignature(AudioTrackList, {
    constructors: () => ({_: [AudioTrackList, []]}),
    methods: () => ({
      [__getter__]: [AudioTrack, [core.int]],
      getTrackById: [AudioTrack, [core.String]]
    })
  });
  AudioTrackList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AudioTrackList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AudioTrackList"))];
  AudioTrackList.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  class AutocompleteErrorEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(AutocompleteErrorEvent, {
    constructors: () => ({_: [AutocompleteErrorEvent, []]})
  });
  AutocompleteErrorEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('AutocompleteErrorEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("AutocompleteErrorEvent"))];
  class BRElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("br"), BRElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(BRElement, 'created');
  dart.setSignature(BRElement, {
    constructors: () => ({
      _: [BRElement, []],
      new: [BRElement, []],
      created: [BRElement, []]
    })
  });
  BRElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLBRElement')), dart.const(new _js_helper.Native("HTMLBRElement"))];
  class BarProp extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(BarProp, {
    constructors: () => ({_: [BarProp, []]})
  });
  BarProp[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('BarProp')), core.deprecated, dart.const(new _js_helper.Native("BarProp"))];
  class BaseElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("base"), BaseElement);
    }
    created() {
      this.href = null;
      this.target = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(BaseElement, 'created');
  dart.setSignature(BaseElement, {
    constructors: () => ({
      _: [BaseElement, []],
      new: [BaseElement, []],
      created: [BaseElement, []]
    })
  });
  BaseElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLBaseElement')), dart.const(new _js_helper.Native("HTMLBaseElement"))];
  class BatteryManager extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(BatteryManager, {
    constructors: () => ({_: [BatteryManager, []]})
  });
  BatteryManager[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('BatteryManager')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("BatteryManager"))];
  class BeforeUnloadEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get returnValue() {
      return dart.as(this.returnValue, core.String);
    }
    set returnValue(value) {
      this.returnValue = value;
    }
  }
  dart.setSignature(BeforeUnloadEvent, {
    constructors: () => ({_: [BeforeUnloadEvent, []]})
  });
  BeforeUnloadEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('BeforeUnloadEvent')), dart.const(new _js_helper.Native("BeforeUnloadEvent"))];
  class Blob extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(blobParts, type, endings) {
      if (type === void 0)
        type = null;
      if (endings === void 0)
        endings = null;
      if (type == null && endings == null) {
        return dart.as(Blob._create_1(blobParts), Blob);
      }
      let bag = Blob._create_bag();
      if (type != null)
        Blob._bag_set(bag, 'type', type);
      if (endings != null)
        Blob._bag_set(bag, 'endings', endings);
      return dart.as(Blob._create_2(blobParts, bag), Blob);
    }
    static _create_1(parts) {
      return new Blob(parts);
    }
    static _create_2(parts, bag) {
      return new Blob(parts, bag);
    }
    static _create_bag() {
      return {};
    }
    static _bag_set(bag, key, value) {
      bag[key] = value;
    }
  }
  dart.setSignature(Blob, {
    constructors: () => ({
      _: [Blob, []],
      new: [Blob, [core.List], [core.String, core.String]]
    }),
    methods: () => ({
      close: [dart.void, []],
      slice: [Blob, [], [core.int, core.int, core.String]]
    }),
    statics: () => ({
      _create_1: [dart.dynamic, [dart.dynamic]],
      _create_2: [dart.dynamic, [dart.dynamic, dart.dynamic]],
      _create_bag: [dart.dynamic, []],
      _bag_set: [dart.dynamic, [dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_bag', '_bag_set']
  });
  Blob[dart.metadata] = () => [dart.const(new _metadata.DomName('Blob')), dart.const(new _js_helper.Native("Blob"))];
  class Body extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Body, {
    constructors: () => ({_: [Body, []]}),
    methods: () => ({
      arrayBuffer: [async.Future, []],
      blob: [async.Future, []],
      json: [async.Future, []],
      text: [async.Future, []]
    })
  });
  Body[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Body')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Body"))];
  class BodyElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("body"), BodyElement);
    }
    created() {
      super.created();
    }
    get onBlur() {
      return BodyElement.blurEvent.forElement(this);
    }
    get onError() {
      return BodyElement.errorEvent.forElement(this);
    }
    get onFocus() {
      return BodyElement.focusEvent.forElement(this);
    }
    get onHashChange() {
      return BodyElement.hashChangeEvent.forElement(this);
    }
    get onLoad() {
      return BodyElement.loadEvent.forElement(this);
    }
    get onMessage() {
      return BodyElement.messageEvent.forElement(this);
    }
    get onOffline() {
      return BodyElement.offlineEvent.forElement(this);
    }
    get onOnline() {
      return BodyElement.onlineEvent.forElement(this);
    }
    get onPopState() {
      return BodyElement.popStateEvent.forElement(this);
    }
    get onResize() {
      return BodyElement.resizeEvent.forElement(this);
    }
    get onScroll() {
      return BodyElement.scrollEvent.forElement(this);
    }
    get onStorage() {
      return BodyElement.storageEvent.forElement(this);
    }
    get onUnload() {
      return BodyElement.unloadEvent.forElement(this);
    }
  }
  BodyElement[dart.implements] = () => [WindowEventHandlers];
  dart.defineNamedConstructor(BodyElement, 'created');
  dart.setSignature(BodyElement, {
    constructors: () => ({
      _: [BodyElement, []],
      new: [BodyElement, []],
      created: [BodyElement, []]
    })
  });
  BodyElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLBodyElement')), dart.const(new _js_helper.Native("HTMLBodyElement"))];
  BodyElement.blurEvent = dart.const(new (EventStreamProvider$(Event))('blur'));
  BodyElement.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  BodyElement.focusEvent = dart.const(new (EventStreamProvider$(Event))('focus'));
  BodyElement.hashChangeEvent = dart.const(new (EventStreamProvider$(Event))('hashchange'));
  BodyElement.loadEvent = dart.const(new (EventStreamProvider$(Event))('load'));
  let _initMessageEvent = Symbol('_initMessageEvent');
  let _get_data = Symbol('_get_data');
  let _get_source = Symbol('_get_source');
  class MessageEvent extends Event {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : false;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : false;
      let data = opts && 'data' in opts ? opts.data : null;
      let origin = opts && 'origin' in opts ? opts.origin : null;
      let lastEventId = opts && 'lastEventId' in opts ? opts.lastEventId : null;
      let source = opts && 'source' in opts ? opts.source : null;
      let messagePorts = opts && 'messagePorts' in opts ? opts.messagePorts : null;
      if (source == null) {
        source = exports.window;
      }
      if (!dart.notNull(html_common.Device.isIE)) {
        return dart.as(new MessageEvent(type, {bubbles: canBubble, cancelable: cancelable, data: data, origin: origin, lastEventId: lastEventId, source: source, ports: messagePorts}), MessageEvent);
      }
      let event = exports.document[_createEvent]("MessageEvent");
      dart.dsend(event, _initMessageEvent, type, canBubble, cancelable, data, origin, lastEventId, source, messagePorts);
      return dart.as(event, MessageEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get data() {
      return html_common.convertNativeToDart_SerializedScriptValue(this[_get_data]);
    }
    get source() {
      return _convertNativeToDart_EventTarget(this[_get_source]);
    }
  }
  dart.setSignature(MessageEvent, {
    constructors: () => ({
      new: [MessageEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, data: core.Object, origin: core.String, lastEventId: core.String, source: Window, messagePorts: core.List}],
      _: [MessageEvent, []]
    }),
    methods: () => ({[_initMessageEvent]: [dart.void, [core.String, core.bool, core.bool, core.Object, core.String, core.String, Window, core.List$(MessagePort)]]})
  });
  MessageEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('MessageEvent')), dart.const(new _js_helper.Native("MessageEvent"))];
  BodyElement.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  BodyElement.offlineEvent = dart.const(new (EventStreamProvider$(Event))('offline'));
  BodyElement.onlineEvent = dart.const(new (EventStreamProvider$(Event))('online'));
  let _get_state = Symbol('_get_state');
  class PopStateEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get state() {
      return html_common.convertNativeToDart_SerializedScriptValue(this[_get_state]);
    }
  }
  dart.setSignature(PopStateEvent, {
    constructors: () => ({_: [PopStateEvent, []]})
  });
  PopStateEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PopStateEvent')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _js_helper.Native("PopStateEvent"))];
  BodyElement.popStateEvent = dart.const(new (EventStreamProvider$(PopStateEvent))('popstate'));
  BodyElement.resizeEvent = dart.const(new (EventStreamProvider$(Event))('resize'));
  BodyElement.scrollEvent = dart.const(new (EventStreamProvider$(Event))('scroll'));
  let _initStorageEvent = Symbol('_initStorageEvent');
  class StorageEvent extends Event {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : false;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : false;
      let key = opts && 'key' in opts ? opts.key : null;
      let oldValue = opts && 'oldValue' in opts ? opts.oldValue : null;
      let newValue = opts && 'newValue' in opts ? opts.newValue : null;
      let url = opts && 'url' in opts ? opts.url : null;
      let storageArea = opts && 'storageArea' in opts ? opts.storageArea : null;
      let e = exports.document[_createEvent]("StorageEvent");
      dart.dsend(e, _initStorageEvent, type, canBubble, cancelable, key, oldValue, newValue, url, storageArea);
      return dart.as(e, StorageEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(StorageEvent, {
    constructors: () => ({
      new: [StorageEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, key: core.String, oldValue: core.String, newValue: core.String, url: core.String, storageArea: Storage}],
      _: [StorageEvent, []]
    }),
    methods: () => ({[_initStorageEvent]: [dart.void, [core.String, core.bool, core.bool, core.String, core.String, core.String, core.String, Storage]]})
  });
  StorageEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('StorageEvent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("StorageEvent"))];
  BodyElement.storageEvent = dart.const(new (EventStreamProvider$(StorageEvent))('storage'));
  BodyElement.unloadEvent = dart.const(new (EventStreamProvider$(Event))('unload'));
  class ButtonElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("button"), ButtonElement);
    }
    created() {
      this.autofocus = null;
      this.disabled = null;
      this.form = null;
      this.formAction = null;
      this.formEnctype = null;
      this.formMethod = null;
      this.formNoValidate = null;
      this.formTarget = null;
      this.labels = null;
      this.name = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.value = null;
      this.willValidate = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(ButtonElement, 'created');
  dart.setSignature(ButtonElement, {
    constructors: () => ({
      _: [ButtonElement, []],
      new: [ButtonElement, []],
      created: [ButtonElement, []]
    }),
    methods: () => ({
      checkValidity: [core.bool, []],
      setCustomValidity: [dart.void, [core.String]]
    })
  });
  ButtonElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLButtonElement')), dart.const(new _js_helper.Native("HTMLButtonElement"))];
  class CharacterData extends Node {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  CharacterData[dart.implements] = () => [ChildNode];
  dart.setSignature(CharacterData, {
    constructors: () => ({_: [CharacterData, []]}),
    methods: () => ({
      appendData: [dart.void, [core.String]],
      deleteData: [dart.void, [core.int, core.int]],
      insertData: [dart.void, [core.int, core.String]],
      replaceData: [dart.void, [core.int, core.int, core.String]],
      substringData: [core.String, [core.int, core.int]]
    })
  });
  CharacterData[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CharacterData')), dart.const(new _js_helper.Native("CharacterData"))];
  let _createTextNode = Symbol('_createTextNode');
  class Text extends CharacterData {
    static new(data) {
      return exports.document[_createTextNode](data);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Text, {
    constructors: () => ({
      new: [Text, [core.String]],
      _: [Text, []]
    }),
    methods: () => ({
      getDestinationInsertionPoints: [core.List$(Node), []],
      splitText: [Text, [core.int]]
    })
  });
  Text[dart.metadata] = () => [dart.const(new _metadata.DomName('Text')), dart.const(new _js_helper.Native("Text"))];
  class CDataSection extends Text {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CDataSection, {
    constructors: () => ({_: [CDataSection, []]})
  });
  CDataSection[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CDATASection')), core.deprecated, dart.const(new _js_helper.Native("CDATASection"))];
  class CacheStorage extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CacheStorage, {
    constructors: () => ({_: [CacheStorage, []]}),
    methods: () => ({
      create: [async.Future, [core.String]],
      delete: [async.Future, [core.String]],
      get: [async.Future, [core.String]],
      has: [async.Future, [core.String]],
      keys: [async.Future, []]
    })
  });
  CacheStorage[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CacheStorage')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CacheStorage"))];
  class Canvas2DContextAttributes extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Canvas2DContextAttributes, {
    constructors: () => ({_: [Canvas2DContextAttributes, []]})
  });
  Canvas2DContextAttributes[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Canvas2DContextAttributes')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Canvas2DContextAttributes"))];
  let _getContext_1 = Symbol('_getContext_1');
  let _getContext_2 = Symbol('_getContext_2');
  let _toDataUrl = Symbol('_toDataUrl');
  class CanvasElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(opts) {
      let width = opts && 'width' in opts ? opts.width : null;
      let height = opts && 'height' in opts ? opts.height : null;
      let e = exports.document.createElement("canvas");
      if (width != null)
        dart.dput(e, 'width', width);
      if (height != null)
        dart.dput(e, 'height', height);
      return dart.as(e, CanvasElement);
    }
    created() {
      this.height = null;
      this.width = null;
      super.created();
    }
    getContext(contextId, attrs) {
      if (attrs === void 0)
        attrs = null;
      if (attrs != null) {
        let attrs_1 = html_common.convertDartToNative_Dictionary(attrs);
        return this[_getContext_1](contextId, attrs_1);
      }
      return this[_getContext_2](contextId);
    }
    get onWebGlContextLost() {
      return CanvasElement.webGlContextLostEvent.forElement(this);
    }
    get onWebGlContextRestored() {
      return CanvasElement.webGlContextRestoredEvent.forElement(this);
    }
    get context2D() {
      return dart.as(this.getContext('2d'), CanvasRenderingContext2D);
    }
    getContext3d(opts) {
      let alpha = opts && 'alpha' in opts ? opts.alpha : true;
      let depth = opts && 'depth' in opts ? opts.depth : true;
      let stencil = opts && 'stencil' in opts ? opts.stencil : false;
      let antialias = opts && 'antialias' in opts ? opts.antialias : true;
      let premultipliedAlpha = opts && 'premultipliedAlpha' in opts ? opts.premultipliedAlpha : true;
      let preserveDrawingBuffer = opts && 'preserveDrawingBuffer' in opts ? opts.preserveDrawingBuffer : false;
      let options = dart.map({alpha: alpha, depth: depth, stencil: stencil, antialias: antialias, premultipliedAlpha: premultipliedAlpha, preserveDrawingBuffer: preserveDrawingBuffer});
      let context = this.getContext('webgl', dart.as(options, core.Map));
      if (context == null) {
        context = this.getContext('experimental-webgl', dart.as(options, core.Map));
      }
      return dart.as(context, web_gl.RenderingContext);
    }
    toDataUrl(type, quality) {
      if (type === void 0)
        type = 'image/png';
      if (quality === void 0)
        quality = null;
      return this[_toDataUrl](type, quality);
    }
  }
  CanvasElement[dart.implements] = () => [CanvasImageSource];
  dart.defineNamedConstructor(CanvasElement, 'created');
  dart.setSignature(CanvasElement, {
    constructors: () => ({
      _: [CanvasElement, []],
      new: [CanvasElement, [], {width: core.int, height: core.int}],
      created: [CanvasElement, []]
    }),
    methods: () => ({
      getContext: [core.Object, [core.String], [core.Map]],
      [_getContext_1]: [core.Object, [dart.dynamic, dart.dynamic]],
      [_getContext_2]: [core.Object, [dart.dynamic]],
      [_toDataUrl]: [core.String, [core.String], [core.num]],
      getContext3d: [web_gl.RenderingContext, [], {alpha: dart.dynamic, depth: dart.dynamic, stencil: dart.dynamic, antialias: dart.dynamic, premultipliedAlpha: dart.dynamic, preserveDrawingBuffer: dart.dynamic}],
      toDataUrl: [core.String, [], [core.String, core.num]]
    })
  });
  CanvasElement[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLCanvasElement')), dart.const(new _js_helper.Native("HTMLCanvasElement"))];
  dart.defineLazyProperties(CanvasElement, {
    get webGlContextLostEvent() {
      return dart.const(new (EventStreamProvider$(web_gl.ContextEvent))('webglcontextlost'));
    },
    set webGlContextLostEvent(_) {},
    get webGlContextRestoredEvent() {
      return dart.const(new (EventStreamProvider$(web_gl.ContextEvent))('webglcontextrestored'));
    },
    set webGlContextRestoredEvent(_) {}
  });
  class CanvasGradient extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CanvasGradient, {
    constructors: () => ({_: [CanvasGradient, []]}),
    methods: () => ({addColorStop: [dart.void, [core.num, core.String]]})
  });
  CanvasGradient[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CanvasGradient')), dart.const(new _js_helper.Native("CanvasGradient"))];
  class CanvasPattern extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CanvasPattern, {
    constructors: () => ({_: [CanvasPattern, []]}),
    methods: () => ({setTransform: [dart.void, [svg.Matrix]]})
  });
  CanvasPattern[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CanvasPattern')), dart.const(new _js_helper.Native("CanvasPattern"))];
  class CanvasRenderingContext extends core.Object {}
  let _addHitRegion_1 = Symbol('_addHitRegion_1');
  let _addHitRegion_2 = Symbol('_addHitRegion_2');
  let _createImageData_1 = Symbol('_createImageData_1');
  let _createImageDataFromImageData_1 = Symbol('_createImageDataFromImageData_1');
  let _getImageData_1 = Symbol('_getImageData_1');
  let _putImageData_1 = Symbol('_putImageData_1');
  let _putImageData_2 = Symbol('_putImageData_2');
  let _getLineDash = Symbol('_getLineDash');
  let _arc = Symbol('_arc');
  class CanvasRenderingContext2D extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    addHitRegion(options) {
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[_addHitRegion_1](options_1);
        return;
      }
      this[_addHitRegion_2]();
      return;
    }
    createImageData(sw, sh) {
      return html_common.convertNativeToDart_ImageData(this[_createImageData_1](sw, sh));
    }
    createImageDataFromImageData(imagedata) {
      let imagedata_1 = html_common.convertDartToNative_ImageData(imagedata);
      return html_common.convertNativeToDart_ImageData(this[_createImageDataFromImageData_1](imagedata_1));
    }
    getImageData(sx, sy, sw, sh) {
      return html_common.convertNativeToDart_ImageData(this[_getImageData_1](sx, sy, sw, sh));
    }
    putImageData(imagedata, dx, dy, dirtyX, dirtyY, dirtyWidth, dirtyHeight) {
      if (dirtyX === void 0)
        dirtyX = null;
      if (dirtyY === void 0)
        dirtyY = null;
      if (dirtyWidth === void 0)
        dirtyWidth = null;
      if (dirtyHeight === void 0)
        dirtyHeight = null;
      if (dirtyX == null && dirtyY == null && dirtyWidth == null && dirtyHeight == null) {
        let imagedata_1 = html_common.convertDartToNative_ImageData(imagedata);
        this[_putImageData_1](imagedata_1, dx, dy);
        return;
      }
      if (dirtyHeight != null && dirtyWidth != null && dirtyY != null && dirtyX != null) {
        let imagedata_1 = html_common.convertDartToNative_ImageData(imagedata);
        this[_putImageData_2](imagedata_1, dx, dy, dirtyX, dirtyY, dirtyWidth, dirtyHeight);
        return;
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    setFillColorRgb(r, g, b, a) {
      if (a === void 0)
        a = 1;
      this.fillStyle = `rgba(${r}, ${g}, ${b}, ${a})`;
    }
    setFillColorHsl(h, s, l, a) {
      if (a === void 0)
        a = 1;
      this.fillStyle = `hsla(${h}, ${s}%, ${l}%, ${a})`;
    }
    setStrokeColorRgb(r, g, b, a) {
      if (a === void 0)
        a = 1;
      this.strokeStyle = `rgba(${r}, ${g}, ${b}, ${a})`;
    }
    setStrokeColorHsl(h, s, l, a) {
      if (a === void 0)
        a = 1;
      this.strokeStyle = `hsla(${h}, ${s}%, ${l}%, ${a})`;
    }
    arc(x, y, radius, startAngle, endAngle, anticlockwise) {
      if (anticlockwise === void 0)
        anticlockwise = false;
      this.arc(x, y, radius, startAngle, endAngle, anticlockwise);
    }
    drawImageToRect(source, destRect, opts) {
      let sourceRect = opts && 'sourceRect' in opts ? opts.sourceRect : null;
      if (sourceRect == null) {
        this.drawImageScaled(source, dart.as(destRect.left, core.num), dart.as(destRect.top, core.num), dart.as(destRect.width, core.num), dart.as(destRect.height, core.num));
      } else {
        this.drawImageScaledFromSource(source, dart.as(sourceRect.left, core.num), dart.as(sourceRect.top, core.num), dart.as(sourceRect.width, core.num), dart.as(sourceRect.height, core.num), dart.as(destRect.left, core.num), dart.as(destRect.top, core.num), dart.as(destRect.width, core.num), dart.as(destRect.height, core.num));
      }
    }
    get lineDashOffset() {
      return dart.as(this.lineDashOffset || this.webkitLineDashOffset, core.num);
    }
    set lineDashOffset(value) {
      typeof this.lineDashOffset != "undefined" ? this.lineDashOffset = value : this.webkitLineDashOffset = value;
    }
    getLineDash() {
      if (dart.notNull(dart.as(!!this.getLineDash, core.bool))) {
        return dart.as(this.getLineDash(), core.List$(core.num));
      } else if (dart.notNull(dart.as(!!this.webkitLineDash, core.bool))) {
        return dart.as(this.webkitLineDash, core.List$(core.num));
      }
    }
    setLineDash(dash) {
      if (dart.notNull(dart.as(!!this.setLineDash, core.bool))) {
        this.setLineDash(dash);
      } else if (dart.notNull(dart.as(!!this.webkitLineDash, core.bool))) {
        this.webkitLineDash = dash;
      }
    }
    fillText(text, x, y, maxWidth) {
      if (maxWidth === void 0)
        maxWidth = null;
      if (maxWidth != null) {
        this.fillText(text, x, y, maxWidth);
      } else {
        this.fillText(text, x, y);
      }
    }
    fill(winding) {
      if (winding === void 0)
        winding = 'nonzero';
      this.fill(winding);
    }
    get backingStorePixelRatio() {
      return 1.0;
    }
  }
  CanvasRenderingContext2D[dart.implements] = () => [CanvasRenderingContext];
  dart.setSignature(CanvasRenderingContext2D, {
    constructors: () => ({_: [CanvasRenderingContext2D, []]}),
    methods: () => ({
      addHitRegion: [dart.void, [], [core.Map]],
      [_addHitRegion_1]: [dart.void, [dart.dynamic]],
      [_addHitRegion_2]: [dart.void, []],
      beginPath: [dart.void, []],
      clearHitRegions: [dart.void, []],
      clearRect: [dart.void, [core.num, core.num, core.num, core.num]],
      clip: [dart.void, [], [dart.dynamic, core.String]],
      createImageData: [ImageData, [core.num, core.num]],
      [_createImageData_1]: [dart.dynamic, [dart.dynamic, dart.dynamic]],
      createImageDataFromImageData: [ImageData, [ImageData]],
      [_createImageDataFromImageData_1]: [dart.dynamic, [dart.dynamic]],
      createLinearGradient: [CanvasGradient, [core.num, core.num, core.num, core.num]],
      createPattern: [CanvasPattern, [dart.dynamic, core.String]],
      createPatternFromImage: [CanvasPattern, [ImageElement, core.String]],
      createRadialGradient: [CanvasGradient, [core.num, core.num, core.num, core.num, core.num, core.num]],
      drawFocusIfNeeded: [dart.void, [dart.dynamic], [Element]],
      fillRect: [dart.void, [core.num, core.num, core.num, core.num]],
      getContextAttributes: [Canvas2DContextAttributes, []],
      getImageData: [ImageData, [core.num, core.num, core.num, core.num]],
      [_getImageData_1]: [dart.dynamic, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]],
      [_getLineDash]: [core.List$(core.num), []],
      isContextLost: [core.bool, []],
      isPointInPath: [core.bool, [dart.dynamic, core.num], [dart.dynamic, core.String]],
      isPointInStroke: [core.bool, [dart.dynamic, core.num], [core.num]],
      measureText: [TextMetrics, [core.String]],
      putImageData: [dart.void, [ImageData, core.num, core.num], [core.num, core.num, core.num, core.num]],
      [_putImageData_1]: [dart.void, [dart.dynamic, dart.dynamic, dart.dynamic]],
      [_putImageData_2]: [dart.void, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]],
      removeHitRegion: [dart.void, [core.String]],
      resetTransform: [dart.void, []],
      restore: [dart.void, []],
      rotate: [dart.void, [core.num]],
      save: [dart.void, []],
      scale: [dart.void, [core.num, core.num]],
      scrollPathIntoView: [dart.void, [], [Path2D]],
      setTransform: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num]],
      stroke: [dart.void, [], [Path2D]],
      strokeRect: [dart.void, [core.num, core.num, core.num, core.num]],
      strokeText: [dart.void, [core.String, core.num, core.num], [core.num]],
      transform: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num]],
      translate: [dart.void, [core.num, core.num]],
      [_arc]: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.bool]],
      arcTo: [dart.void, [core.num, core.num, core.num, core.num, core.num]],
      bezierCurveTo: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num]],
      closePath: [dart.void, []],
      ellipse: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num, core.num, core.bool]],
      lineTo: [dart.void, [core.num, core.num]],
      moveTo: [dart.void, [core.num, core.num]],
      quadraticCurveTo: [dart.void, [core.num, core.num, core.num, core.num]],
      rect: [dart.void, [core.num, core.num, core.num, core.num]],
      setFillColorRgb: [dart.void, [core.int, core.int, core.int], [core.num]],
      setFillColorHsl: [dart.void, [core.int, core.num, core.num], [core.num]],
      setStrokeColorRgb: [dart.void, [core.int, core.int, core.int], [core.num]],
      setStrokeColorHsl: [dart.void, [core.int, core.num, core.num], [core.num]],
      arc: [dart.void, [core.num, core.num, core.num, core.num, core.num], [core.bool]],
      drawImageToRect: [dart.void, [CanvasImageSource, math.Rectangle], {sourceRect: math.Rectangle}],
      drawImage: [dart.void, [CanvasImageSource, core.num, core.num]],
      drawImageScaled: [dart.void, [CanvasImageSource, core.num, core.num, core.num, core.num]],
      drawImageScaledFromSource: [dart.void, [CanvasImageSource, core.num, core.num, core.num, core.num, core.num, core.num, core.num, core.num]],
      getLineDash: [core.List$(core.num), []],
      setLineDash: [dart.void, [core.List$(core.num)]],
      fillText: [dart.void, [core.String, core.num, core.num], [core.num]],
      fill: [dart.void, [], [core.String]]
    })
  });
  CanvasRenderingContext2D[dart.metadata] = () => [dart.const(new _metadata.DomName('CanvasRenderingContext2D')), dart.const(new _js_helper.Native("CanvasRenderingContext2D"))];
  class ChildNode extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ChildNode, {
    constructors: () => ({_: [ChildNode, []]})
  });
  ChildNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ChildNode')), dart.const(new _metadata.Experimental())];
  class GeofencingRegion extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(GeofencingRegion, {
    constructors: () => ({_: [GeofencingRegion, []]})
  });
  GeofencingRegion[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('GeofencingRegion')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("GeofencingRegion"))];
  class CircularGeofencingRegion extends GeofencingRegion {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(init) {
      let init_1 = html_common.convertDartToNative_Dictionary(init);
      return CircularGeofencingRegion._create_1(init_1);
    }
    static _create_1(init) {
      return dart.as(new CircularGeofencingRegion(init), CircularGeofencingRegion);
    }
  }
  dart.setSignature(CircularGeofencingRegion, {
    constructors: () => ({
      _: [CircularGeofencingRegion, []],
      new: [CircularGeofencingRegion, [core.Map]]
    }),
    statics: () => ({_create_1: [CircularGeofencingRegion, [dart.dynamic]]}),
    names: ['_create_1']
  });
  CircularGeofencingRegion[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CircularGeofencingRegion')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CircularGeofencingRegion"))];
  CircularGeofencingRegion.MAX_RADIUS = 100.0;
  CircularGeofencingRegion.MIN_RADIUS = 1.0;
  class CloseEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CloseEvent, {
    constructors: () => ({_: [CloseEvent, []]})
  });
  CloseEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CloseEvent')), dart.const(new _js_helper.Native("CloseEvent"))];
  class Comment extends CharacterData {
    static new(data) {
      if (data === void 0)
        data = null;
      if (data != null) {
        return dart.as(exports.document.createComment(data), Comment);
      }
      return dart.as(exports.document.createComment(""), Comment);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Comment, {
    constructors: () => ({
      new: [Comment, [], [core.String]],
      _: [Comment, []]
    })
  });
  Comment[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Comment')), dart.const(new _js_helper.Native("Comment"))];
  let _initUIEvent = Symbol('_initUIEvent');
  let _get_view = Symbol('_get_view');
  let _layerX = Symbol('_layerX');
  let _layerY = Symbol('_layerY');
  let _pageX = Symbol('_pageX');
  let _pageY = Symbol('_pageY');
  class UIEvent extends Event {
    static new(type, opts) {
      let view = opts && 'view' in opts ? opts.view : null;
      let detail = opts && 'detail' in opts ? opts.detail : 0;
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      if (view == null) {
        view = exports.window;
      }
      let e = exports.document[_createEvent]("UIEvent");
      dart.dsend(e, _initUIEvent, type, canBubble, cancelable, view, detail);
      return dart.as(e, UIEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get view() {
      return _convertNativeToDart_Window(this[_get_view]);
    }
    get layer() {
      return new math.Point(this[_layerX], this[_layerY]);
    }
    get page() {
      return new math.Point(this[_pageX], this[_pageY]);
    }
  }
  dart.setSignature(UIEvent, {
    constructors: () => ({
      new: [UIEvent, [core.String], {view: Window, detail: core.int, canBubble: core.bool, cancelable: core.bool}],
      _: [UIEvent, []]
    }),
    methods: () => ({[_initUIEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.int]]})
  });
  UIEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('UIEvent')), dart.const(new _js_helper.Native("UIEvent"))];
  let _initCompositionEvent = Symbol('_initCompositionEvent');
  class CompositionEvent extends UIEvent {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : false;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : false;
      let view = opts && 'view' in opts ? opts.view : null;
      let data = opts && 'data' in opts ? opts.data : null;
      let locale = opts && 'locale' in opts ? opts.locale : null;
      if (view == null) {
        view = exports.window;
      }
      let e = exports.document[_createEvent]("CompositionEvent");
      if (dart.notNull(html_common.Device.isFirefox)) {
        e.initCompositionEvent(type, canBubble, cancelable, view, data, locale);
      } else {
        dart.dsend(e, _initCompositionEvent, type, canBubble, cancelable, view, data);
      }
      return dart.as(e, CompositionEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CompositionEvent, {
    constructors: () => ({
      new: [CompositionEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, view: Window, data: core.String, locale: core.String}],
      _: [CompositionEvent, []]
    }),
    methods: () => ({
      getSegments: [core.List$(core.int), []],
      [_initCompositionEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.String]]
    })
  });
  CompositionEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('CompositionEvent')), dart.const(new _js_helper.Native("CompositionEvent"))];
  let _isConsoleDefined = Symbol('_isConsoleDefined');
  class Console extends core.Object {
    _safe() {
    }
    get [_isConsoleDefined]() {
      return dart.as(typeof console != "undefined", core.bool);
    }
    get memory() {
      return dart.notNull(this[_isConsoleDefined]) ? dart.as(console.memory, MemoryInfo) : null;
    }
    assertCondition(condition, arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.assertCondition(condition, arg) : null;
    }
    clear(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.clear(arg) : null;
    }
    count(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.count(arg) : null;
    }
    debug(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.debug(arg) : null;
    }
    dir(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.dir(arg) : null;
    }
    dirxml(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.dirxml(arg) : null;
    }
    error(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.error(arg) : null;
    }
    group(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.group(arg) : null;
    }
    groupCollapsed(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.groupCollapsed(arg) : null;
    }
    groupEnd() {
      return dart.notNull(this[_isConsoleDefined]) ? console.groupEnd() : null;
    }
    info(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.info(arg) : null;
    }
    log(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.log(arg) : null;
    }
    markTimeline(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.markTimeline(arg) : null;
    }
    profile(title) {
      return dart.notNull(this[_isConsoleDefined]) ? console.profile(title) : null;
    }
    profileEnd(title) {
      return dart.notNull(this[_isConsoleDefined]) ? console.profileEnd(title) : null;
    }
    table(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.table(arg) : null;
    }
    time(title) {
      return dart.notNull(this[_isConsoleDefined]) ? console.time(title) : null;
    }
    timeEnd(title) {
      return dart.notNull(this[_isConsoleDefined]) ? console.timeEnd(title) : null;
    }
    timeStamp(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.timeStamp(arg) : null;
    }
    trace(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.trace(arg) : null;
    }
    warn(arg) {
      return dart.notNull(this[_isConsoleDefined]) ? console.warn(arg) : null;
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.defineNamedConstructor(Console, '_safe');
  dart.setSignature(Console, {
    constructors: () => ({
      _safe: [Console, []],
      _: [Console, []]
    }),
    methods: () => ({
      assertCondition: [dart.void, [core.bool, core.Object]],
      clear: [dart.void, [core.Object]],
      count: [dart.void, [core.Object]],
      debug: [dart.void, [core.Object]],
      dir: [dart.void, [core.Object]],
      dirxml: [dart.void, [core.Object]],
      error: [dart.void, [core.Object]],
      group: [dart.void, [core.Object]],
      groupCollapsed: [dart.void, [core.Object]],
      groupEnd: [dart.void, []],
      info: [dart.void, [core.Object]],
      log: [dart.void, [core.Object]],
      markTimeline: [dart.void, [core.Object]],
      profile: [dart.void, [core.String]],
      profileEnd: [dart.void, [core.String]],
      table: [dart.void, [core.Object]],
      time: [dart.void, [core.String]],
      timeEnd: [dart.void, [core.String]],
      timeStamp: [dart.void, [core.Object]],
      trace: [dart.void, [core.Object]],
      warn: [dart.void, [core.Object]]
    })
  });
  Console[dart.metadata] = () => [dart.const(new _metadata.DomName('Console'))];
  Console._safeConsole = dart.const(new Console._safe());
  class ConsoleBase extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ConsoleBase, {
    constructors: () => ({_: [ConsoleBase, []]}),
    methods: () => ({
      timeline: [dart.void, [core.String]],
      timelineEnd: [dart.void, [core.String]]
    })
  });
  ConsoleBase[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ConsoleBase')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ConsoleBase"))];
  class ContentElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("content"), ContentElement);
    }
    created() {
      this.select = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('content');
    }
  }
  dart.defineNamedConstructor(ContentElement, 'created');
  dart.setSignature(ContentElement, {
    constructors: () => ({
      _: [ContentElement, []],
      new: [ContentElement, []],
      created: [ContentElement, []]
    }),
    methods: () => ({getDistributedNodes: [core.List$(Node), []]})
  });
  ContentElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLContentElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '26')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLContentElement"))];
  class Coordinates extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Coordinates, {
    constructors: () => ({_: [Coordinates, []]})
  });
  Coordinates[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Coordinates')), dart.const(new _js_helper.Native("Coordinates"))];
  class Credential extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Credential, {
    constructors: () => ({_: [Credential, []]})
  });
  Credential[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Credential')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Credential"))];
  let _request_1 = Symbol('_request_1');
  let _request_2 = Symbol('_request_2');
  class CredentialsContainer extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    request(options) {
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return this[_request_1](options_1);
      }
      return this[_request_2]();
    }
  }
  dart.setSignature(CredentialsContainer, {
    constructors: () => ({_: [CredentialsContainer, []]}),
    methods: () => ({
      notifyFailedSignIn: [async.Future, [Credential]],
      notifySignedIn: [async.Future, [Credential]],
      notifySignedOut: [async.Future, []],
      request: [async.Future, [], [core.Map]],
      [_request_1]: [async.Future, [dart.dynamic]],
      [_request_2]: [async.Future, []]
    })
  });
  CredentialsContainer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CredentialsContainer')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CredentialsContainer"))];
  class Crypto extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!(window.crypto && window.crypto.getRandomValues), core.bool);
    }
  }
  dart.setSignature(Crypto, {
    constructors: () => ({_: [Crypto, []]}),
    methods: () => ({getRandomValues: [typed_data.TypedData, [typed_data.TypedData]]})
  });
  Crypto[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Crypto')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Crypto"))];
  class CryptoKey extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CryptoKey, {
    constructors: () => ({_: [CryptoKey, []]})
  });
  CryptoKey[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CryptoKey')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CryptoKey"))];
  class Css extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Css, {
    constructors: () => ({_: [Css, []]}),
    methods: () => ({
      supports: [core.bool, [core.String, core.String]],
      supportsCondition: [core.bool, [core.String]]
    })
  });
  Css[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSS')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CSS"))];
  class CssRule extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssRule, {
    constructors: () => ({_: [CssRule, []]})
  });
  CssRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSRule')), dart.const(new _js_helper.Native("CSSRule"))];
  class CssCharsetRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssCharsetRule, {
    constructors: () => ({_: [CssCharsetRule, []]})
  });
  CssCharsetRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSCharsetRule')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CSSCharsetRule"))];
  class CssFilterRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssFilterRule, {
    constructors: () => ({_: [CssFilterRule, []]})
  });
  CssFilterRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WebKitCSSFilterRule')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WebKitCSSFilterRule"))];
  class CssFontFaceRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssFontFaceRule, {
    constructors: () => ({_: [CssFontFaceRule, []]})
  });
  CssFontFaceRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSFontFaceRule')), dart.const(new _js_helper.Native("CSSFontFaceRule"))];
  class CssImportRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssImportRule, {
    constructors: () => ({_: [CssImportRule, []]})
  });
  CssImportRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSImportRule')), dart.const(new _js_helper.Native("CSSImportRule"))];
  class CssKeyframeRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssKeyframeRule, {
    constructors: () => ({_: [CssKeyframeRule, []]})
  });
  CssKeyframeRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSKeyframeRule')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CSSKeyframeRule,MozCSSKeyframeRule,WebKitCSSKeyframeRule"))];
  class CssKeyframesRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssKeyframesRule, {
    constructors: () => ({_: [CssKeyframesRule, []]}),
    methods: () => ({
      [__getter__]: [CssKeyframeRule, [core.int]],
      deleteRule: [dart.void, [core.String]],
      findRule: [CssKeyframeRule, [core.String]],
      appendRule: [dart.void, [core.String]]
    })
  });
  CssKeyframesRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSKeyframesRule')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CSSKeyframesRule,MozCSSKeyframesRule,WebKitCSSKeyframesRule"))];
  class CssMediaRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssMediaRule, {
    constructors: () => ({_: [CssMediaRule, []]}),
    methods: () => ({
      deleteRule: [dart.void, [core.int]],
      insertRule: [core.int, [core.String, core.int]]
    })
  });
  CssMediaRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSMediaRule')), dart.const(new _js_helper.Native("CSSMediaRule"))];
  class CssPageRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssPageRule, {
    constructors: () => ({_: [CssPageRule, []]})
  });
  CssPageRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSPageRule')), dart.const(new _js_helper.Native("CSSPageRule"))];
  CssRule.CHARSET_RULE = 2;
  CssRule.FONT_FACE_RULE = 5;
  CssRule.IMPORT_RULE = 3;
  CssRule.KEYFRAMES_RULE = 7;
  CssRule.KEYFRAME_RULE = 8;
  CssRule.MEDIA_RULE = 4;
  CssRule.PAGE_RULE = 6;
  CssRule.STYLE_RULE = 1;
  CssRule.SUPPORTS_RULE = 12;
  CssRule.VIEWPORT_RULE = 15;
  CssRule.WEBKIT_FILTER_RULE = 17;
  CssRule.WEBKIT_KEYFRAMES_RULE = 7;
  CssRule.WEBKIT_KEYFRAME_RULE = 8;
  class CssStyleDeclarationBase extends core.Object {
    get alignContent() {
      return this.getPropertyValue('align-content');
    }
    set alignContent(value) {
      this.setProperty('align-content', value, '');
    }
    get alignItems() {
      return this.getPropertyValue('align-items');
    }
    set alignItems(value) {
      this.setProperty('align-items', value, '');
    }
    get alignSelf() {
      return this.getPropertyValue('align-self');
    }
    set alignSelf(value) {
      this.setProperty('align-self', value, '');
    }
    get animation() {
      return this.getPropertyValue('animation');
    }
    set animation(value) {
      this.setProperty('animation', value, '');
    }
    get animationDelay() {
      return this.getPropertyValue('animation-delay');
    }
    set animationDelay(value) {
      this.setProperty('animation-delay', value, '');
    }
    get animationDirection() {
      return this.getPropertyValue('animation-direction');
    }
    set animationDirection(value) {
      this.setProperty('animation-direction', value, '');
    }
    get animationDuration() {
      return this.getPropertyValue('animation-duration');
    }
    set animationDuration(value) {
      this.setProperty('animation-duration', value, '');
    }
    get animationFillMode() {
      return this.getPropertyValue('animation-fill-mode');
    }
    set animationFillMode(value) {
      this.setProperty('animation-fill-mode', value, '');
    }
    get animationIterationCount() {
      return this.getPropertyValue('animation-iteration-count');
    }
    set animationIterationCount(value) {
      this.setProperty('animation-iteration-count', value, '');
    }
    get animationName() {
      return this.getPropertyValue('animation-name');
    }
    set animationName(value) {
      this.setProperty('animation-name', value, '');
    }
    get animationPlayState() {
      return this.getPropertyValue('animation-play-state');
    }
    set animationPlayState(value) {
      this.setProperty('animation-play-state', value, '');
    }
    get animationTimingFunction() {
      return this.getPropertyValue('animation-timing-function');
    }
    set animationTimingFunction(value) {
      this.setProperty('animation-timing-function', value, '');
    }
    get appRegion() {
      return this.getPropertyValue('app-region');
    }
    set appRegion(value) {
      this.setProperty('app-region', value, '');
    }
    get appearance() {
      return this.getPropertyValue('appearance');
    }
    set appearance(value) {
      this.setProperty('appearance', value, '');
    }
    get aspectRatio() {
      return this.getPropertyValue('aspect-ratio');
    }
    set aspectRatio(value) {
      this.setProperty('aspect-ratio', value, '');
    }
    get backfaceVisibility() {
      return this.getPropertyValue('backface-visibility');
    }
    set backfaceVisibility(value) {
      this.setProperty('backface-visibility', value, '');
    }
    get background() {
      return this.getPropertyValue('background');
    }
    set background(value) {
      this.setProperty('background', value, '');
    }
    get backgroundAttachment() {
      return this.getPropertyValue('background-attachment');
    }
    set backgroundAttachment(value) {
      this.setProperty('background-attachment', value, '');
    }
    get backgroundBlendMode() {
      return this.getPropertyValue('background-blend-mode');
    }
    set backgroundBlendMode(value) {
      this.setProperty('background-blend-mode', value, '');
    }
    get backgroundClip() {
      return this.getPropertyValue('background-clip');
    }
    set backgroundClip(value) {
      this.setProperty('background-clip', value, '');
    }
    get backgroundColor() {
      return this.getPropertyValue('background-color');
    }
    set backgroundColor(value) {
      this.setProperty('background-color', value, '');
    }
    get backgroundComposite() {
      return this.getPropertyValue('background-composite');
    }
    set backgroundComposite(value) {
      this.setProperty('background-composite', value, '');
    }
    get backgroundImage() {
      return this.getPropertyValue('background-image');
    }
    set backgroundImage(value) {
      this.setProperty('background-image', value, '');
    }
    get backgroundOrigin() {
      return this.getPropertyValue('background-origin');
    }
    set backgroundOrigin(value) {
      this.setProperty('background-origin', value, '');
    }
    get backgroundPosition() {
      return this.getPropertyValue('background-position');
    }
    set backgroundPosition(value) {
      this.setProperty('background-position', value, '');
    }
    get backgroundPositionX() {
      return this.getPropertyValue('background-position-x');
    }
    set backgroundPositionX(value) {
      this.setProperty('background-position-x', value, '');
    }
    get backgroundPositionY() {
      return this.getPropertyValue('background-position-y');
    }
    set backgroundPositionY(value) {
      this.setProperty('background-position-y', value, '');
    }
    get backgroundRepeat() {
      return this.getPropertyValue('background-repeat');
    }
    set backgroundRepeat(value) {
      this.setProperty('background-repeat', value, '');
    }
    get backgroundRepeatX() {
      return this.getPropertyValue('background-repeat-x');
    }
    set backgroundRepeatX(value) {
      this.setProperty('background-repeat-x', value, '');
    }
    get backgroundRepeatY() {
      return this.getPropertyValue('background-repeat-y');
    }
    set backgroundRepeatY(value) {
      this.setProperty('background-repeat-y', value, '');
    }
    get backgroundSize() {
      return this.getPropertyValue('background-size');
    }
    set backgroundSize(value) {
      this.setProperty('background-size', value, '');
    }
    get border() {
      return this.getPropertyValue('border');
    }
    set border(value) {
      this.setProperty('border', value, '');
    }
    get borderAfter() {
      return this.getPropertyValue('border-after');
    }
    set borderAfter(value) {
      this.setProperty('border-after', value, '');
    }
    get borderAfterColor() {
      return this.getPropertyValue('border-after-color');
    }
    set borderAfterColor(value) {
      this.setProperty('border-after-color', value, '');
    }
    get borderAfterStyle() {
      return this.getPropertyValue('border-after-style');
    }
    set borderAfterStyle(value) {
      this.setProperty('border-after-style', value, '');
    }
    get borderAfterWidth() {
      return this.getPropertyValue('border-after-width');
    }
    set borderAfterWidth(value) {
      this.setProperty('border-after-width', value, '');
    }
    get borderBefore() {
      return this.getPropertyValue('border-before');
    }
    set borderBefore(value) {
      this.setProperty('border-before', value, '');
    }
    get borderBeforeColor() {
      return this.getPropertyValue('border-before-color');
    }
    set borderBeforeColor(value) {
      this.setProperty('border-before-color', value, '');
    }
    get borderBeforeStyle() {
      return this.getPropertyValue('border-before-style');
    }
    set borderBeforeStyle(value) {
      this.setProperty('border-before-style', value, '');
    }
    get borderBeforeWidth() {
      return this.getPropertyValue('border-before-width');
    }
    set borderBeforeWidth(value) {
      this.setProperty('border-before-width', value, '');
    }
    get borderBottom() {
      return this.getPropertyValue('border-bottom');
    }
    set borderBottom(value) {
      this.setProperty('border-bottom', value, '');
    }
    get borderBottomColor() {
      return this.getPropertyValue('border-bottom-color');
    }
    set borderBottomColor(value) {
      this.setProperty('border-bottom-color', value, '');
    }
    get borderBottomLeftRadius() {
      return this.getPropertyValue('border-bottom-left-radius');
    }
    set borderBottomLeftRadius(value) {
      this.setProperty('border-bottom-left-radius', value, '');
    }
    get borderBottomRightRadius() {
      return this.getPropertyValue('border-bottom-right-radius');
    }
    set borderBottomRightRadius(value) {
      this.setProperty('border-bottom-right-radius', value, '');
    }
    get borderBottomStyle() {
      return this.getPropertyValue('border-bottom-style');
    }
    set borderBottomStyle(value) {
      this.setProperty('border-bottom-style', value, '');
    }
    get borderBottomWidth() {
      return this.getPropertyValue('border-bottom-width');
    }
    set borderBottomWidth(value) {
      this.setProperty('border-bottom-width', value, '');
    }
    get borderCollapse() {
      return this.getPropertyValue('border-collapse');
    }
    set borderCollapse(value) {
      this.setProperty('border-collapse', value, '');
    }
    get borderColor() {
      return this.getPropertyValue('border-color');
    }
    set borderColor(value) {
      this.setProperty('border-color', value, '');
    }
    get borderEnd() {
      return this.getPropertyValue('border-end');
    }
    set borderEnd(value) {
      this.setProperty('border-end', value, '');
    }
    get borderEndColor() {
      return this.getPropertyValue('border-end-color');
    }
    set borderEndColor(value) {
      this.setProperty('border-end-color', value, '');
    }
    get borderEndStyle() {
      return this.getPropertyValue('border-end-style');
    }
    set borderEndStyle(value) {
      this.setProperty('border-end-style', value, '');
    }
    get borderEndWidth() {
      return this.getPropertyValue('border-end-width');
    }
    set borderEndWidth(value) {
      this.setProperty('border-end-width', value, '');
    }
    get borderFit() {
      return this.getPropertyValue('border-fit');
    }
    set borderFit(value) {
      this.setProperty('border-fit', value, '');
    }
    get borderHorizontalSpacing() {
      return this.getPropertyValue('border-horizontal-spacing');
    }
    set borderHorizontalSpacing(value) {
      this.setProperty('border-horizontal-spacing', value, '');
    }
    get borderImage() {
      return this.getPropertyValue('border-image');
    }
    set borderImage(value) {
      this.setProperty('border-image', value, '');
    }
    get borderImageOutset() {
      return this.getPropertyValue('border-image-outset');
    }
    set borderImageOutset(value) {
      this.setProperty('border-image-outset', value, '');
    }
    get borderImageRepeat() {
      return this.getPropertyValue('border-image-repeat');
    }
    set borderImageRepeat(value) {
      this.setProperty('border-image-repeat', value, '');
    }
    get borderImageSlice() {
      return this.getPropertyValue('border-image-slice');
    }
    set borderImageSlice(value) {
      this.setProperty('border-image-slice', value, '');
    }
    get borderImageSource() {
      return this.getPropertyValue('border-image-source');
    }
    set borderImageSource(value) {
      this.setProperty('border-image-source', value, '');
    }
    get borderImageWidth() {
      return this.getPropertyValue('border-image-width');
    }
    set borderImageWidth(value) {
      this.setProperty('border-image-width', value, '');
    }
    get borderLeft() {
      return this.getPropertyValue('border-left');
    }
    set borderLeft(value) {
      this.setProperty('border-left', value, '');
    }
    get borderLeftColor() {
      return this.getPropertyValue('border-left-color');
    }
    set borderLeftColor(value) {
      this.setProperty('border-left-color', value, '');
    }
    get borderLeftStyle() {
      return this.getPropertyValue('border-left-style');
    }
    set borderLeftStyle(value) {
      this.setProperty('border-left-style', value, '');
    }
    get borderLeftWidth() {
      return this.getPropertyValue('border-left-width');
    }
    set borderLeftWidth(value) {
      this.setProperty('border-left-width', value, '');
    }
    get borderRadius() {
      return this.getPropertyValue('border-radius');
    }
    set borderRadius(value) {
      this.setProperty('border-radius', value, '');
    }
    get borderRight() {
      return this.getPropertyValue('border-right');
    }
    set borderRight(value) {
      this.setProperty('border-right', value, '');
    }
    get borderRightColor() {
      return this.getPropertyValue('border-right-color');
    }
    set borderRightColor(value) {
      this.setProperty('border-right-color', value, '');
    }
    get borderRightStyle() {
      return this.getPropertyValue('border-right-style');
    }
    set borderRightStyle(value) {
      this.setProperty('border-right-style', value, '');
    }
    get borderRightWidth() {
      return this.getPropertyValue('border-right-width');
    }
    set borderRightWidth(value) {
      this.setProperty('border-right-width', value, '');
    }
    get borderSpacing() {
      return this.getPropertyValue('border-spacing');
    }
    set borderSpacing(value) {
      this.setProperty('border-spacing', value, '');
    }
    get borderStart() {
      return this.getPropertyValue('border-start');
    }
    set borderStart(value) {
      this.setProperty('border-start', value, '');
    }
    get borderStartColor() {
      return this.getPropertyValue('border-start-color');
    }
    set borderStartColor(value) {
      this.setProperty('border-start-color', value, '');
    }
    get borderStartStyle() {
      return this.getPropertyValue('border-start-style');
    }
    set borderStartStyle(value) {
      this.setProperty('border-start-style', value, '');
    }
    get borderStartWidth() {
      return this.getPropertyValue('border-start-width');
    }
    set borderStartWidth(value) {
      this.setProperty('border-start-width', value, '');
    }
    get borderStyle() {
      return this.getPropertyValue('border-style');
    }
    set borderStyle(value) {
      this.setProperty('border-style', value, '');
    }
    get borderTop() {
      return this.getPropertyValue('border-top');
    }
    set borderTop(value) {
      this.setProperty('border-top', value, '');
    }
    get borderTopColor() {
      return this.getPropertyValue('border-top-color');
    }
    set borderTopColor(value) {
      this.setProperty('border-top-color', value, '');
    }
    get borderTopLeftRadius() {
      return this.getPropertyValue('border-top-left-radius');
    }
    set borderTopLeftRadius(value) {
      this.setProperty('border-top-left-radius', value, '');
    }
    get borderTopRightRadius() {
      return this.getPropertyValue('border-top-right-radius');
    }
    set borderTopRightRadius(value) {
      this.setProperty('border-top-right-radius', value, '');
    }
    get borderTopStyle() {
      return this.getPropertyValue('border-top-style');
    }
    set borderTopStyle(value) {
      this.setProperty('border-top-style', value, '');
    }
    get borderTopWidth() {
      return this.getPropertyValue('border-top-width');
    }
    set borderTopWidth(value) {
      this.setProperty('border-top-width', value, '');
    }
    get borderVerticalSpacing() {
      return this.getPropertyValue('border-vertical-spacing');
    }
    set borderVerticalSpacing(value) {
      this.setProperty('border-vertical-spacing', value, '');
    }
    get borderWidth() {
      return this.getPropertyValue('border-width');
    }
    set borderWidth(value) {
      this.setProperty('border-width', value, '');
    }
    get bottom() {
      return this.getPropertyValue('bottom');
    }
    set bottom(value) {
      this.setProperty('bottom', value, '');
    }
    get boxAlign() {
      return this.getPropertyValue('box-align');
    }
    set boxAlign(value) {
      this.setProperty('box-align', value, '');
    }
    get boxDecorationBreak() {
      return this.getPropertyValue('box-decoration-break');
    }
    set boxDecorationBreak(value) {
      this.setProperty('box-decoration-break', value, '');
    }
    get boxDirection() {
      return this.getPropertyValue('box-direction');
    }
    set boxDirection(value) {
      this.setProperty('box-direction', value, '');
    }
    get boxFlex() {
      return this.getPropertyValue('box-flex');
    }
    set boxFlex(value) {
      this.setProperty('box-flex', value, '');
    }
    get boxFlexGroup() {
      return this.getPropertyValue('box-flex-group');
    }
    set boxFlexGroup(value) {
      this.setProperty('box-flex-group', value, '');
    }
    get boxLines() {
      return this.getPropertyValue('box-lines');
    }
    set boxLines(value) {
      this.setProperty('box-lines', value, '');
    }
    get boxOrdinalGroup() {
      return this.getPropertyValue('box-ordinal-group');
    }
    set boxOrdinalGroup(value) {
      this.setProperty('box-ordinal-group', value, '');
    }
    get boxOrient() {
      return this.getPropertyValue('box-orient');
    }
    set boxOrient(value) {
      this.setProperty('box-orient', value, '');
    }
    get boxPack() {
      return this.getPropertyValue('box-pack');
    }
    set boxPack(value) {
      this.setProperty('box-pack', value, '');
    }
    get boxReflect() {
      return this.getPropertyValue('box-reflect');
    }
    set boxReflect(value) {
      this.setProperty('box-reflect', value, '');
    }
    get boxShadow() {
      return this.getPropertyValue('box-shadow');
    }
    set boxShadow(value) {
      this.setProperty('box-shadow', value, '');
    }
    get boxSizing() {
      return this.getPropertyValue('box-sizing');
    }
    set boxSizing(value) {
      this.setProperty('box-sizing', value, '');
    }
    get captionSide() {
      return this.getPropertyValue('caption-side');
    }
    set captionSide(value) {
      this.setProperty('caption-side', value, '');
    }
    get clear() {
      return this.getPropertyValue('clear');
    }
    set clear(value) {
      this.setProperty('clear', value, '');
    }
    get clip() {
      return this.getPropertyValue('clip');
    }
    set clip(value) {
      this.setProperty('clip', value, '');
    }
    get clipPath() {
      return this.getPropertyValue('clip-path');
    }
    set clipPath(value) {
      this.setProperty('clip-path', value, '');
    }
    get color() {
      return this.getPropertyValue('color');
    }
    set color(value) {
      this.setProperty('color', value, '');
    }
    get columnBreakAfter() {
      return this.getPropertyValue('column-break-after');
    }
    set columnBreakAfter(value) {
      this.setProperty('column-break-after', value, '');
    }
    get columnBreakBefore() {
      return this.getPropertyValue('column-break-before');
    }
    set columnBreakBefore(value) {
      this.setProperty('column-break-before', value, '');
    }
    get columnBreakInside() {
      return this.getPropertyValue('column-break-inside');
    }
    set columnBreakInside(value) {
      this.setProperty('column-break-inside', value, '');
    }
    get columnCount() {
      return this.getPropertyValue('column-count');
    }
    set columnCount(value) {
      this.setProperty('column-count', value, '');
    }
    get columnFill() {
      return this.getPropertyValue('column-fill');
    }
    set columnFill(value) {
      this.setProperty('column-fill', value, '');
    }
    get columnGap() {
      return this.getPropertyValue('column-gap');
    }
    set columnGap(value) {
      this.setProperty('column-gap', value, '');
    }
    get columnRule() {
      return this.getPropertyValue('column-rule');
    }
    set columnRule(value) {
      this.setProperty('column-rule', value, '');
    }
    get columnRuleColor() {
      return this.getPropertyValue('column-rule-color');
    }
    set columnRuleColor(value) {
      this.setProperty('column-rule-color', value, '');
    }
    get columnRuleStyle() {
      return this.getPropertyValue('column-rule-style');
    }
    set columnRuleStyle(value) {
      this.setProperty('column-rule-style', value, '');
    }
    get columnRuleWidth() {
      return this.getPropertyValue('column-rule-width');
    }
    set columnRuleWidth(value) {
      this.setProperty('column-rule-width', value, '');
    }
    get columnSpan() {
      return this.getPropertyValue('column-span');
    }
    set columnSpan(value) {
      this.setProperty('column-span', value, '');
    }
    get columnWidth() {
      return this.getPropertyValue('column-width');
    }
    set columnWidth(value) {
      this.setProperty('column-width', value, '');
    }
    get columns() {
      return this.getPropertyValue('columns');
    }
    set columns(value) {
      this.setProperty('columns', value, '');
    }
    get content() {
      return this.getPropertyValue('content');
    }
    set content(value) {
      this.setProperty('content', value, '');
    }
    get counterIncrement() {
      return this.getPropertyValue('counter-increment');
    }
    set counterIncrement(value) {
      this.setProperty('counter-increment', value, '');
    }
    get counterReset() {
      return this.getPropertyValue('counter-reset');
    }
    set counterReset(value) {
      this.setProperty('counter-reset', value, '');
    }
    get cursor() {
      return this.getPropertyValue('cursor');
    }
    set cursor(value) {
      this.setProperty('cursor', value, '');
    }
    get direction() {
      return this.getPropertyValue('direction');
    }
    set direction(value) {
      this.setProperty('direction', value, '');
    }
    get display() {
      return this.getPropertyValue('display');
    }
    set display(value) {
      this.setProperty('display', value, '');
    }
    get emptyCells() {
      return this.getPropertyValue('empty-cells');
    }
    set emptyCells(value) {
      this.setProperty('empty-cells', value, '');
    }
    get filter() {
      return this.getPropertyValue('filter');
    }
    set filter(value) {
      this.setProperty('filter', value, '');
    }
    get flex() {
      return this.getPropertyValue('flex');
    }
    set flex(value) {
      this.setProperty('flex', value, '');
    }
    get flexBasis() {
      return this.getPropertyValue('flex-basis');
    }
    set flexBasis(value) {
      this.setProperty('flex-basis', value, '');
    }
    get flexDirection() {
      return this.getPropertyValue('flex-direction');
    }
    set flexDirection(value) {
      this.setProperty('flex-direction', value, '');
    }
    get flexFlow() {
      return this.getPropertyValue('flex-flow');
    }
    set flexFlow(value) {
      this.setProperty('flex-flow', value, '');
    }
    get flexGrow() {
      return this.getPropertyValue('flex-grow');
    }
    set flexGrow(value) {
      this.setProperty('flex-grow', value, '');
    }
    get flexShrink() {
      return this.getPropertyValue('flex-shrink');
    }
    set flexShrink(value) {
      this.setProperty('flex-shrink', value, '');
    }
    get flexWrap() {
      return this.getPropertyValue('flex-wrap');
    }
    set flexWrap(value) {
      this.setProperty('flex-wrap', value, '');
    }
    get float() {
      return this.getPropertyValue('float');
    }
    set float(value) {
      this.setProperty('float', value, '');
    }
    get font() {
      return this.getPropertyValue('font');
    }
    set font(value) {
      this.setProperty('font', value, '');
    }
    get fontFamily() {
      return this.getPropertyValue('font-family');
    }
    set fontFamily(value) {
      this.setProperty('font-family', value, '');
    }
    get fontFeatureSettings() {
      return this.getPropertyValue('font-feature-settings');
    }
    set fontFeatureSettings(value) {
      this.setProperty('font-feature-settings', value, '');
    }
    get fontKerning() {
      return this.getPropertyValue('font-kerning');
    }
    set fontKerning(value) {
      this.setProperty('font-kerning', value, '');
    }
    get fontSize() {
      return this.getPropertyValue('font-size');
    }
    set fontSize(value) {
      this.setProperty('font-size', value, '');
    }
    get fontSizeDelta() {
      return this.getPropertyValue('font-size-delta');
    }
    set fontSizeDelta(value) {
      this.setProperty('font-size-delta', value, '');
    }
    get fontSmoothing() {
      return this.getPropertyValue('font-smoothing');
    }
    set fontSmoothing(value) {
      this.setProperty('font-smoothing', value, '');
    }
    get fontStretch() {
      return this.getPropertyValue('font-stretch');
    }
    set fontStretch(value) {
      this.setProperty('font-stretch', value, '');
    }
    get fontStyle() {
      return this.getPropertyValue('font-style');
    }
    set fontStyle(value) {
      this.setProperty('font-style', value, '');
    }
    get fontVariant() {
      return this.getPropertyValue('font-variant');
    }
    set fontVariant(value) {
      this.setProperty('font-variant', value, '');
    }
    get fontVariantLigatures() {
      return this.getPropertyValue('font-variant-ligatures');
    }
    set fontVariantLigatures(value) {
      this.setProperty('font-variant-ligatures', value, '');
    }
    get fontWeight() {
      return this.getPropertyValue('font-weight');
    }
    set fontWeight(value) {
      this.setProperty('font-weight', value, '');
    }
    get grid() {
      return this.getPropertyValue('grid');
    }
    set grid(value) {
      this.setProperty('grid', value, '');
    }
    get gridArea() {
      return this.getPropertyValue('grid-area');
    }
    set gridArea(value) {
      this.setProperty('grid-area', value, '');
    }
    get gridAutoColumns() {
      return this.getPropertyValue('grid-auto-columns');
    }
    set gridAutoColumns(value) {
      this.setProperty('grid-auto-columns', value, '');
    }
    get gridAutoFlow() {
      return this.getPropertyValue('grid-auto-flow');
    }
    set gridAutoFlow(value) {
      this.setProperty('grid-auto-flow', value, '');
    }
    get gridAutoRows() {
      return this.getPropertyValue('grid-auto-rows');
    }
    set gridAutoRows(value) {
      this.setProperty('grid-auto-rows', value, '');
    }
    get gridColumn() {
      return this.getPropertyValue('grid-column');
    }
    set gridColumn(value) {
      this.setProperty('grid-column', value, '');
    }
    get gridColumnEnd() {
      return this.getPropertyValue('grid-column-end');
    }
    set gridColumnEnd(value) {
      this.setProperty('grid-column-end', value, '');
    }
    get gridColumnStart() {
      return this.getPropertyValue('grid-column-start');
    }
    set gridColumnStart(value) {
      this.setProperty('grid-column-start', value, '');
    }
    get gridRow() {
      return this.getPropertyValue('grid-row');
    }
    set gridRow(value) {
      this.setProperty('grid-row', value, '');
    }
    get gridRowEnd() {
      return this.getPropertyValue('grid-row-end');
    }
    set gridRowEnd(value) {
      this.setProperty('grid-row-end', value, '');
    }
    get gridRowStart() {
      return this.getPropertyValue('grid-row-start');
    }
    set gridRowStart(value) {
      this.setProperty('grid-row-start', value, '');
    }
    get gridTemplate() {
      return this.getPropertyValue('grid-template');
    }
    set gridTemplate(value) {
      this.setProperty('grid-template', value, '');
    }
    get gridTemplateAreas() {
      return this.getPropertyValue('grid-template-areas');
    }
    set gridTemplateAreas(value) {
      this.setProperty('grid-template-areas', value, '');
    }
    get gridTemplateColumns() {
      return this.getPropertyValue('grid-template-columns');
    }
    set gridTemplateColumns(value) {
      this.setProperty('grid-template-columns', value, '');
    }
    get gridTemplateRows() {
      return this.getPropertyValue('grid-template-rows');
    }
    set gridTemplateRows(value) {
      this.setProperty('grid-template-rows', value, '');
    }
    get height() {
      return this.getPropertyValue('height');
    }
    set height(value) {
      this.setProperty('height', value, '');
    }
    get highlight() {
      return this.getPropertyValue('highlight');
    }
    set highlight(value) {
      this.setProperty('highlight', value, '');
    }
    get hyphenateCharacter() {
      return this.getPropertyValue('hyphenate-character');
    }
    set hyphenateCharacter(value) {
      this.setProperty('hyphenate-character', value, '');
    }
    get imageRendering() {
      return this.getPropertyValue('image-rendering');
    }
    set imageRendering(value) {
      this.setProperty('image-rendering', value, '');
    }
    get isolation() {
      return this.getPropertyValue('isolation');
    }
    set isolation(value) {
      this.setProperty('isolation', value, '');
    }
    get justifyContent() {
      return this.getPropertyValue('justify-content');
    }
    set justifyContent(value) {
      this.setProperty('justify-content', value, '');
    }
    get justifySelf() {
      return this.getPropertyValue('justify-self');
    }
    set justifySelf(value) {
      this.setProperty('justify-self', value, '');
    }
    get left() {
      return this.getPropertyValue('left');
    }
    set left(value) {
      this.setProperty('left', value, '');
    }
    get letterSpacing() {
      return this.getPropertyValue('letter-spacing');
    }
    set letterSpacing(value) {
      this.setProperty('letter-spacing', value, '');
    }
    get lineBoxContain() {
      return this.getPropertyValue('line-box-contain');
    }
    set lineBoxContain(value) {
      this.setProperty('line-box-contain', value, '');
    }
    get lineBreak() {
      return this.getPropertyValue('line-break');
    }
    set lineBreak(value) {
      this.setProperty('line-break', value, '');
    }
    get lineClamp() {
      return this.getPropertyValue('line-clamp');
    }
    set lineClamp(value) {
      this.setProperty('line-clamp', value, '');
    }
    get lineHeight() {
      return this.getPropertyValue('line-height');
    }
    set lineHeight(value) {
      this.setProperty('line-height', value, '');
    }
    get listStyle() {
      return this.getPropertyValue('list-style');
    }
    set listStyle(value) {
      this.setProperty('list-style', value, '');
    }
    get listStyleImage() {
      return this.getPropertyValue('list-style-image');
    }
    set listStyleImage(value) {
      this.setProperty('list-style-image', value, '');
    }
    get listStylePosition() {
      return this.getPropertyValue('list-style-position');
    }
    set listStylePosition(value) {
      this.setProperty('list-style-position', value, '');
    }
    get listStyleType() {
      return this.getPropertyValue('list-style-type');
    }
    set listStyleType(value) {
      this.setProperty('list-style-type', value, '');
    }
    get locale() {
      return this.getPropertyValue('locale');
    }
    set locale(value) {
      this.setProperty('locale', value, '');
    }
    get logicalHeight() {
      return this.getPropertyValue('logical-height');
    }
    set logicalHeight(value) {
      this.setProperty('logical-height', value, '');
    }
    get logicalWidth() {
      return this.getPropertyValue('logical-width');
    }
    set logicalWidth(value) {
      this.setProperty('logical-width', value, '');
    }
    get margin() {
      return this.getPropertyValue('margin');
    }
    set margin(value) {
      this.setProperty('margin', value, '');
    }
    get marginAfter() {
      return this.getPropertyValue('margin-after');
    }
    set marginAfter(value) {
      this.setProperty('margin-after', value, '');
    }
    get marginAfterCollapse() {
      return this.getPropertyValue('margin-after-collapse');
    }
    set marginAfterCollapse(value) {
      this.setProperty('margin-after-collapse', value, '');
    }
    get marginBefore() {
      return this.getPropertyValue('margin-before');
    }
    set marginBefore(value) {
      this.setProperty('margin-before', value, '');
    }
    get marginBeforeCollapse() {
      return this.getPropertyValue('margin-before-collapse');
    }
    set marginBeforeCollapse(value) {
      this.setProperty('margin-before-collapse', value, '');
    }
    get marginBottom() {
      return this.getPropertyValue('margin-bottom');
    }
    set marginBottom(value) {
      this.setProperty('margin-bottom', value, '');
    }
    get marginBottomCollapse() {
      return this.getPropertyValue('margin-bottom-collapse');
    }
    set marginBottomCollapse(value) {
      this.setProperty('margin-bottom-collapse', value, '');
    }
    get marginCollapse() {
      return this.getPropertyValue('margin-collapse');
    }
    set marginCollapse(value) {
      this.setProperty('margin-collapse', value, '');
    }
    get marginEnd() {
      return this.getPropertyValue('margin-end');
    }
    set marginEnd(value) {
      this.setProperty('margin-end', value, '');
    }
    get marginLeft() {
      return this.getPropertyValue('margin-left');
    }
    set marginLeft(value) {
      this.setProperty('margin-left', value, '');
    }
    get marginRight() {
      return this.getPropertyValue('margin-right');
    }
    set marginRight(value) {
      this.setProperty('margin-right', value, '');
    }
    get marginStart() {
      return this.getPropertyValue('margin-start');
    }
    set marginStart(value) {
      this.setProperty('margin-start', value, '');
    }
    get marginTop() {
      return this.getPropertyValue('margin-top');
    }
    set marginTop(value) {
      this.setProperty('margin-top', value, '');
    }
    get marginTopCollapse() {
      return this.getPropertyValue('margin-top-collapse');
    }
    set marginTopCollapse(value) {
      this.setProperty('margin-top-collapse', value, '');
    }
    get mask() {
      return this.getPropertyValue('mask');
    }
    set mask(value) {
      this.setProperty('mask', value, '');
    }
    get maskBoxImage() {
      return this.getPropertyValue('mask-box-image');
    }
    set maskBoxImage(value) {
      this.setProperty('mask-box-image', value, '');
    }
    get maskBoxImageOutset() {
      return this.getPropertyValue('mask-box-image-outset');
    }
    set maskBoxImageOutset(value) {
      this.setProperty('mask-box-image-outset', value, '');
    }
    get maskBoxImageRepeat() {
      return this.getPropertyValue('mask-box-image-repeat');
    }
    set maskBoxImageRepeat(value) {
      this.setProperty('mask-box-image-repeat', value, '');
    }
    get maskBoxImageSlice() {
      return this.getPropertyValue('mask-box-image-slice');
    }
    set maskBoxImageSlice(value) {
      this.setProperty('mask-box-image-slice', value, '');
    }
    get maskBoxImageSource() {
      return this.getPropertyValue('mask-box-image-source');
    }
    set maskBoxImageSource(value) {
      this.setProperty('mask-box-image-source', value, '');
    }
    get maskBoxImageWidth() {
      return this.getPropertyValue('mask-box-image-width');
    }
    set maskBoxImageWidth(value) {
      this.setProperty('mask-box-image-width', value, '');
    }
    get maskClip() {
      return this.getPropertyValue('mask-clip');
    }
    set maskClip(value) {
      this.setProperty('mask-clip', value, '');
    }
    get maskComposite() {
      return this.getPropertyValue('mask-composite');
    }
    set maskComposite(value) {
      this.setProperty('mask-composite', value, '');
    }
    get maskImage() {
      return this.getPropertyValue('mask-image');
    }
    set maskImage(value) {
      this.setProperty('mask-image', value, '');
    }
    get maskOrigin() {
      return this.getPropertyValue('mask-origin');
    }
    set maskOrigin(value) {
      this.setProperty('mask-origin', value, '');
    }
    get maskPosition() {
      return this.getPropertyValue('mask-position');
    }
    set maskPosition(value) {
      this.setProperty('mask-position', value, '');
    }
    get maskPositionX() {
      return this.getPropertyValue('mask-position-x');
    }
    set maskPositionX(value) {
      this.setProperty('mask-position-x', value, '');
    }
    get maskPositionY() {
      return this.getPropertyValue('mask-position-y');
    }
    set maskPositionY(value) {
      this.setProperty('mask-position-y', value, '');
    }
    get maskRepeat() {
      return this.getPropertyValue('mask-repeat');
    }
    set maskRepeat(value) {
      this.setProperty('mask-repeat', value, '');
    }
    get maskRepeatX() {
      return this.getPropertyValue('mask-repeat-x');
    }
    set maskRepeatX(value) {
      this.setProperty('mask-repeat-x', value, '');
    }
    get maskRepeatY() {
      return this.getPropertyValue('mask-repeat-y');
    }
    set maskRepeatY(value) {
      this.setProperty('mask-repeat-y', value, '');
    }
    get maskSize() {
      return this.getPropertyValue('mask-size');
    }
    set maskSize(value) {
      this.setProperty('mask-size', value, '');
    }
    get maskSourceType() {
      return this.getPropertyValue('mask-source-type');
    }
    set maskSourceType(value) {
      this.setProperty('mask-source-type', value, '');
    }
    get maxHeight() {
      return this.getPropertyValue('max-height');
    }
    set maxHeight(value) {
      this.setProperty('max-height', value, '');
    }
    get maxLogicalHeight() {
      return this.getPropertyValue('max-logical-height');
    }
    set maxLogicalHeight(value) {
      this.setProperty('max-logical-height', value, '');
    }
    get maxLogicalWidth() {
      return this.getPropertyValue('max-logical-width');
    }
    set maxLogicalWidth(value) {
      this.setProperty('max-logical-width', value, '');
    }
    get maxWidth() {
      return this.getPropertyValue('max-width');
    }
    set maxWidth(value) {
      this.setProperty('max-width', value, '');
    }
    get maxZoom() {
      return this.getPropertyValue('max-zoom');
    }
    set maxZoom(value) {
      this.setProperty('max-zoom', value, '');
    }
    get minHeight() {
      return this.getPropertyValue('min-height');
    }
    set minHeight(value) {
      this.setProperty('min-height', value, '');
    }
    get minLogicalHeight() {
      return this.getPropertyValue('min-logical-height');
    }
    set minLogicalHeight(value) {
      this.setProperty('min-logical-height', value, '');
    }
    get minLogicalWidth() {
      return this.getPropertyValue('min-logical-width');
    }
    set minLogicalWidth(value) {
      this.setProperty('min-logical-width', value, '');
    }
    get minWidth() {
      return this.getPropertyValue('min-width');
    }
    set minWidth(value) {
      this.setProperty('min-width', value, '');
    }
    get minZoom() {
      return this.getPropertyValue('min-zoom');
    }
    set minZoom(value) {
      this.setProperty('min-zoom', value, '');
    }
    get mixBlendMode() {
      return this.getPropertyValue('mix-blend-mode');
    }
    set mixBlendMode(value) {
      this.setProperty('mix-blend-mode', value, '');
    }
    get objectFit() {
      return this.getPropertyValue('object-fit');
    }
    set objectFit(value) {
      this.setProperty('object-fit', value, '');
    }
    get objectPosition() {
      return this.getPropertyValue('object-position');
    }
    set objectPosition(value) {
      this.setProperty('object-position', value, '');
    }
    get opacity() {
      return this.getPropertyValue('opacity');
    }
    set opacity(value) {
      this.setProperty('opacity', value, '');
    }
    get order() {
      return this.getPropertyValue('order');
    }
    set order(value) {
      this.setProperty('order', value, '');
    }
    get orientation() {
      return this.getPropertyValue('orientation');
    }
    set orientation(value) {
      this.setProperty('orientation', value, '');
    }
    get orphans() {
      return this.getPropertyValue('orphans');
    }
    set orphans(value) {
      this.setProperty('orphans', value, '');
    }
    get outline() {
      return this.getPropertyValue('outline');
    }
    set outline(value) {
      this.setProperty('outline', value, '');
    }
    get outlineColor() {
      return this.getPropertyValue('outline-color');
    }
    set outlineColor(value) {
      this.setProperty('outline-color', value, '');
    }
    get outlineOffset() {
      return this.getPropertyValue('outline-offset');
    }
    set outlineOffset(value) {
      this.setProperty('outline-offset', value, '');
    }
    get outlineStyle() {
      return this.getPropertyValue('outline-style');
    }
    set outlineStyle(value) {
      this.setProperty('outline-style', value, '');
    }
    get outlineWidth() {
      return this.getPropertyValue('outline-width');
    }
    set outlineWidth(value) {
      this.setProperty('outline-width', value, '');
    }
    get overflow() {
      return this.getPropertyValue('overflow');
    }
    set overflow(value) {
      this.setProperty('overflow', value, '');
    }
    get overflowWrap() {
      return this.getPropertyValue('overflow-wrap');
    }
    set overflowWrap(value) {
      this.setProperty('overflow-wrap', value, '');
    }
    get overflowX() {
      return this.getPropertyValue('overflow-x');
    }
    set overflowX(value) {
      this.setProperty('overflow-x', value, '');
    }
    get overflowY() {
      return this.getPropertyValue('overflow-y');
    }
    set overflowY(value) {
      this.setProperty('overflow-y', value, '');
    }
    get padding() {
      return this.getPropertyValue('padding');
    }
    set padding(value) {
      this.setProperty('padding', value, '');
    }
    get paddingAfter() {
      return this.getPropertyValue('padding-after');
    }
    set paddingAfter(value) {
      this.setProperty('padding-after', value, '');
    }
    get paddingBefore() {
      return this.getPropertyValue('padding-before');
    }
    set paddingBefore(value) {
      this.setProperty('padding-before', value, '');
    }
    get paddingBottom() {
      return this.getPropertyValue('padding-bottom');
    }
    set paddingBottom(value) {
      this.setProperty('padding-bottom', value, '');
    }
    get paddingEnd() {
      return this.getPropertyValue('padding-end');
    }
    set paddingEnd(value) {
      this.setProperty('padding-end', value, '');
    }
    get paddingLeft() {
      return this.getPropertyValue('padding-left');
    }
    set paddingLeft(value) {
      this.setProperty('padding-left', value, '');
    }
    get paddingRight() {
      return this.getPropertyValue('padding-right');
    }
    set paddingRight(value) {
      this.setProperty('padding-right', value, '');
    }
    get paddingStart() {
      return this.getPropertyValue('padding-start');
    }
    set paddingStart(value) {
      this.setProperty('padding-start', value, '');
    }
    get paddingTop() {
      return this.getPropertyValue('padding-top');
    }
    set paddingTop(value) {
      this.setProperty('padding-top', value, '');
    }
    get page() {
      return this.getPropertyValue('page');
    }
    set page(value) {
      this.setProperty('page', value, '');
    }
    get pageBreakAfter() {
      return this.getPropertyValue('page-break-after');
    }
    set pageBreakAfter(value) {
      this.setProperty('page-break-after', value, '');
    }
    get pageBreakBefore() {
      return this.getPropertyValue('page-break-before');
    }
    set pageBreakBefore(value) {
      this.setProperty('page-break-before', value, '');
    }
    get pageBreakInside() {
      return this.getPropertyValue('page-break-inside');
    }
    set pageBreakInside(value) {
      this.setProperty('page-break-inside', value, '');
    }
    get perspective() {
      return this.getPropertyValue('perspective');
    }
    set perspective(value) {
      this.setProperty('perspective', value, '');
    }
    get perspectiveOrigin() {
      return this.getPropertyValue('perspective-origin');
    }
    set perspectiveOrigin(value) {
      this.setProperty('perspective-origin', value, '');
    }
    get perspectiveOriginX() {
      return this.getPropertyValue('perspective-origin-x');
    }
    set perspectiveOriginX(value) {
      this.setProperty('perspective-origin-x', value, '');
    }
    get perspectiveOriginY() {
      return this.getPropertyValue('perspective-origin-y');
    }
    set perspectiveOriginY(value) {
      this.setProperty('perspective-origin-y', value, '');
    }
    get pointerEvents() {
      return this.getPropertyValue('pointer-events');
    }
    set pointerEvents(value) {
      this.setProperty('pointer-events', value, '');
    }
    get position() {
      return this.getPropertyValue('position');
    }
    set position(value) {
      this.setProperty('position', value, '');
    }
    get printColorAdjust() {
      return this.getPropertyValue('print-color-adjust');
    }
    set printColorAdjust(value) {
      this.setProperty('print-color-adjust', value, '');
    }
    get quotes() {
      return this.getPropertyValue('quotes');
    }
    set quotes(value) {
      this.setProperty('quotes', value, '');
    }
    get resize() {
      return this.getPropertyValue('resize');
    }
    set resize(value) {
      this.setProperty('resize', value, '');
    }
    get right() {
      return this.getPropertyValue('right');
    }
    set right(value) {
      this.setProperty('right', value, '');
    }
    get rtlOrdering() {
      return this.getPropertyValue('rtl-ordering');
    }
    set rtlOrdering(value) {
      this.setProperty('rtl-ordering', value, '');
    }
    get rubyPosition() {
      return this.getPropertyValue('ruby-position');
    }
    set rubyPosition(value) {
      this.setProperty('ruby-position', value, '');
    }
    get scrollBehavior() {
      return this.getPropertyValue('scroll-behavior');
    }
    set scrollBehavior(value) {
      this.setProperty('scroll-behavior', value, '');
    }
    get shapeImageThreshold() {
      return this.getPropertyValue('shape-image-threshold');
    }
    set shapeImageThreshold(value) {
      this.setProperty('shape-image-threshold', value, '');
    }
    get shapeMargin() {
      return this.getPropertyValue('shape-margin');
    }
    set shapeMargin(value) {
      this.setProperty('shape-margin', value, '');
    }
    get shapeOutside() {
      return this.getPropertyValue('shape-outside');
    }
    set shapeOutside(value) {
      this.setProperty('shape-outside', value, '');
    }
    get size() {
      return this.getPropertyValue('size');
    }
    set size(value) {
      this.setProperty('size', value, '');
    }
    get speak() {
      return this.getPropertyValue('speak');
    }
    set speak(value) {
      this.setProperty('speak', value, '');
    }
    get src() {
      return this.getPropertyValue('src');
    }
    set src(value) {
      this.setProperty('src', value, '');
    }
    get tabSize() {
      return this.getPropertyValue('tab-size');
    }
    set tabSize(value) {
      this.setProperty('tab-size', value, '');
    }
    get tableLayout() {
      return this.getPropertyValue('table-layout');
    }
    set tableLayout(value) {
      this.setProperty('table-layout', value, '');
    }
    get tapHighlightColor() {
      return this.getPropertyValue('tap-highlight-color');
    }
    set tapHighlightColor(value) {
      this.setProperty('tap-highlight-color', value, '');
    }
    get textAlign() {
      return this.getPropertyValue('text-align');
    }
    set textAlign(value) {
      this.setProperty('text-align', value, '');
    }
    get textAlignLast() {
      return this.getPropertyValue('text-align-last');
    }
    set textAlignLast(value) {
      this.setProperty('text-align-last', value, '');
    }
    get textCombine() {
      return this.getPropertyValue('text-combine');
    }
    set textCombine(value) {
      this.setProperty('text-combine', value, '');
    }
    get textDecoration() {
      return this.getPropertyValue('text-decoration');
    }
    set textDecoration(value) {
      this.setProperty('text-decoration', value, '');
    }
    get textDecorationColor() {
      return this.getPropertyValue('text-decoration-color');
    }
    set textDecorationColor(value) {
      this.setProperty('text-decoration-color', value, '');
    }
    get textDecorationLine() {
      return this.getPropertyValue('text-decoration-line');
    }
    set textDecorationLine(value) {
      this.setProperty('text-decoration-line', value, '');
    }
    get textDecorationStyle() {
      return this.getPropertyValue('text-decoration-style');
    }
    set textDecorationStyle(value) {
      this.setProperty('text-decoration-style', value, '');
    }
    get textDecorationsInEffect() {
      return this.getPropertyValue('text-decorations-in-effect');
    }
    set textDecorationsInEffect(value) {
      this.setProperty('text-decorations-in-effect', value, '');
    }
    get textEmphasis() {
      return this.getPropertyValue('text-emphasis');
    }
    set textEmphasis(value) {
      this.setProperty('text-emphasis', value, '');
    }
    get textEmphasisColor() {
      return this.getPropertyValue('text-emphasis-color');
    }
    set textEmphasisColor(value) {
      this.setProperty('text-emphasis-color', value, '');
    }
    get textEmphasisPosition() {
      return this.getPropertyValue('text-emphasis-position');
    }
    set textEmphasisPosition(value) {
      this.setProperty('text-emphasis-position', value, '');
    }
    get textEmphasisStyle() {
      return this.getPropertyValue('text-emphasis-style');
    }
    set textEmphasisStyle(value) {
      this.setProperty('text-emphasis-style', value, '');
    }
    get textFillColor() {
      return this.getPropertyValue('text-fill-color');
    }
    set textFillColor(value) {
      this.setProperty('text-fill-color', value, '');
    }
    get textIndent() {
      return this.getPropertyValue('text-indent');
    }
    set textIndent(value) {
      this.setProperty('text-indent', value, '');
    }
    get textJustify() {
      return this.getPropertyValue('text-justify');
    }
    set textJustify(value) {
      this.setProperty('text-justify', value, '');
    }
    get textLineThroughColor() {
      return this.getPropertyValue('text-line-through-color');
    }
    set textLineThroughColor(value) {
      this.setProperty('text-line-through-color', value, '');
    }
    get textLineThroughMode() {
      return this.getPropertyValue('text-line-through-mode');
    }
    set textLineThroughMode(value) {
      this.setProperty('text-line-through-mode', value, '');
    }
    get textLineThroughStyle() {
      return this.getPropertyValue('text-line-through-style');
    }
    set textLineThroughStyle(value) {
      this.setProperty('text-line-through-style', value, '');
    }
    get textLineThroughWidth() {
      return this.getPropertyValue('text-line-through-width');
    }
    set textLineThroughWidth(value) {
      this.setProperty('text-line-through-width', value, '');
    }
    get textOrientation() {
      return this.getPropertyValue('text-orientation');
    }
    set textOrientation(value) {
      this.setProperty('text-orientation', value, '');
    }
    get textOverflow() {
      return this.getPropertyValue('text-overflow');
    }
    set textOverflow(value) {
      this.setProperty('text-overflow', value, '');
    }
    get textOverlineColor() {
      return this.getPropertyValue('text-overline-color');
    }
    set textOverlineColor(value) {
      this.setProperty('text-overline-color', value, '');
    }
    get textOverlineMode() {
      return this.getPropertyValue('text-overline-mode');
    }
    set textOverlineMode(value) {
      this.setProperty('text-overline-mode', value, '');
    }
    get textOverlineStyle() {
      return this.getPropertyValue('text-overline-style');
    }
    set textOverlineStyle(value) {
      this.setProperty('text-overline-style', value, '');
    }
    get textOverlineWidth() {
      return this.getPropertyValue('text-overline-width');
    }
    set textOverlineWidth(value) {
      this.setProperty('text-overline-width', value, '');
    }
    get textRendering() {
      return this.getPropertyValue('text-rendering');
    }
    set textRendering(value) {
      this.setProperty('text-rendering', value, '');
    }
    get textSecurity() {
      return this.getPropertyValue('text-security');
    }
    set textSecurity(value) {
      this.setProperty('text-security', value, '');
    }
    get textShadow() {
      return this.getPropertyValue('text-shadow');
    }
    set textShadow(value) {
      this.setProperty('text-shadow', value, '');
    }
    get textStroke() {
      return this.getPropertyValue('text-stroke');
    }
    set textStroke(value) {
      this.setProperty('text-stroke', value, '');
    }
    get textStrokeColor() {
      return this.getPropertyValue('text-stroke-color');
    }
    set textStrokeColor(value) {
      this.setProperty('text-stroke-color', value, '');
    }
    get textStrokeWidth() {
      return this.getPropertyValue('text-stroke-width');
    }
    set textStrokeWidth(value) {
      this.setProperty('text-stroke-width', value, '');
    }
    get textTransform() {
      return this.getPropertyValue('text-transform');
    }
    set textTransform(value) {
      this.setProperty('text-transform', value, '');
    }
    get textUnderlineColor() {
      return this.getPropertyValue('text-underline-color');
    }
    set textUnderlineColor(value) {
      this.setProperty('text-underline-color', value, '');
    }
    get textUnderlineMode() {
      return this.getPropertyValue('text-underline-mode');
    }
    set textUnderlineMode(value) {
      this.setProperty('text-underline-mode', value, '');
    }
    get textUnderlinePosition() {
      return this.getPropertyValue('text-underline-position');
    }
    set textUnderlinePosition(value) {
      this.setProperty('text-underline-position', value, '');
    }
    get textUnderlineStyle() {
      return this.getPropertyValue('text-underline-style');
    }
    set textUnderlineStyle(value) {
      this.setProperty('text-underline-style', value, '');
    }
    get textUnderlineWidth() {
      return this.getPropertyValue('text-underline-width');
    }
    set textUnderlineWidth(value) {
      this.setProperty('text-underline-width', value, '');
    }
    get top() {
      return this.getPropertyValue('top');
    }
    set top(value) {
      this.setProperty('top', value, '');
    }
    get touchAction() {
      return this.getPropertyValue('touch-action');
    }
    set touchAction(value) {
      this.setProperty('touch-action', value, '');
    }
    get touchActionDelay() {
      return this.getPropertyValue('touch-action-delay');
    }
    set touchActionDelay(value) {
      this.setProperty('touch-action-delay', value, '');
    }
    get transform() {
      return this.getPropertyValue('transform');
    }
    set transform(value) {
      this.setProperty('transform', value, '');
    }
    get transformOrigin() {
      return this.getPropertyValue('transform-origin');
    }
    set transformOrigin(value) {
      this.setProperty('transform-origin', value, '');
    }
    get transformOriginX() {
      return this.getPropertyValue('transform-origin-x');
    }
    set transformOriginX(value) {
      this.setProperty('transform-origin-x', value, '');
    }
    get transformOriginY() {
      return this.getPropertyValue('transform-origin-y');
    }
    set transformOriginY(value) {
      this.setProperty('transform-origin-y', value, '');
    }
    get transformOriginZ() {
      return this.getPropertyValue('transform-origin-z');
    }
    set transformOriginZ(value) {
      this.setProperty('transform-origin-z', value, '');
    }
    get transformStyle() {
      return this.getPropertyValue('transform-style');
    }
    set transformStyle(value) {
      this.setProperty('transform-style', value, '');
    }
    get transition() {
      return this.getPropertyValue('transition');
    }
    set transition(value) {
      this.setProperty('transition', value, '');
    }
    get transitionDelay() {
      return this.getPropertyValue('transition-delay');
    }
    set transitionDelay(value) {
      this.setProperty('transition-delay', value, '');
    }
    get transitionDuration() {
      return this.getPropertyValue('transition-duration');
    }
    set transitionDuration(value) {
      this.setProperty('transition-duration', value, '');
    }
    get transitionProperty() {
      return this.getPropertyValue('transition-property');
    }
    set transitionProperty(value) {
      this.setProperty('transition-property', value, '');
    }
    get transitionTimingFunction() {
      return this.getPropertyValue('transition-timing-function');
    }
    set transitionTimingFunction(value) {
      this.setProperty('transition-timing-function', value, '');
    }
    get unicodeBidi() {
      return this.getPropertyValue('unicode-bidi');
    }
    set unicodeBidi(value) {
      this.setProperty('unicode-bidi', value, '');
    }
    get unicodeRange() {
      return this.getPropertyValue('unicode-range');
    }
    set unicodeRange(value) {
      this.setProperty('unicode-range', value, '');
    }
    get userDrag() {
      return this.getPropertyValue('user-drag');
    }
    set userDrag(value) {
      this.setProperty('user-drag', value, '');
    }
    get userModify() {
      return this.getPropertyValue('user-modify');
    }
    set userModify(value) {
      this.setProperty('user-modify', value, '');
    }
    get userSelect() {
      return this.getPropertyValue('user-select');
    }
    set userSelect(value) {
      this.setProperty('user-select', value, '');
    }
    get userZoom() {
      return this.getPropertyValue('user-zoom');
    }
    set userZoom(value) {
      this.setProperty('user-zoom', value, '');
    }
    get verticalAlign() {
      return this.getPropertyValue('vertical-align');
    }
    set verticalAlign(value) {
      this.setProperty('vertical-align', value, '');
    }
    get visibility() {
      return this.getPropertyValue('visibility');
    }
    set visibility(value) {
      this.setProperty('visibility', value, '');
    }
    get whiteSpace() {
      return this.getPropertyValue('white-space');
    }
    set whiteSpace(value) {
      this.setProperty('white-space', value, '');
    }
    get widows() {
      return this.getPropertyValue('widows');
    }
    set widows(value) {
      this.setProperty('widows', value, '');
    }
    get width() {
      return this.getPropertyValue('width');
    }
    set width(value) {
      this.setProperty('width', value, '');
    }
    get willChange() {
      return this.getPropertyValue('will-change');
    }
    set willChange(value) {
      this.setProperty('will-change', value, '');
    }
    get wordBreak() {
      return this.getPropertyValue('word-break');
    }
    set wordBreak(value) {
      this.setProperty('word-break', value, '');
    }
    get wordSpacing() {
      return this.getPropertyValue('word-spacing');
    }
    set wordSpacing(value) {
      this.setProperty('word-spacing', value, '');
    }
    get wordWrap() {
      return this.getPropertyValue('word-wrap');
    }
    set wordWrap(value) {
      this.setProperty('word-wrap', value, '');
    }
    get wrapFlow() {
      return this.getPropertyValue('wrap-flow');
    }
    set wrapFlow(value) {
      this.setProperty('wrap-flow', value, '');
    }
    get wrapThrough() {
      return this.getPropertyValue('wrap-through');
    }
    set wrapThrough(value) {
      this.setProperty('wrap-through', value, '');
    }
    get writingMode() {
      return this.getPropertyValue('writing-mode');
    }
    set writingMode(value) {
      this.setProperty('writing-mode', value, '');
    }
    get zIndex() {
      return this.getPropertyValue('z-index');
    }
    set zIndex(value) {
      this.setProperty('z-index', value, '');
    }
    get zoom() {
      return this.getPropertyValue('zoom');
    }
    set zoom(value) {
      this.setProperty('zoom', value, '');
    }
  }
  let _getPropertyValueHelper = Symbol('_getPropertyValueHelper');
  let _supportsProperty = Symbol('_supportsProperty');
  let _getPropertyValue = Symbol('_getPropertyValue');
  let _setPropertyHelper = Symbol('_setPropertyHelper');
  let _browserPropertyName = Symbol('_browserPropertyName');
  let _background = Symbol('_background');
  let _backgroundAttachment = Symbol('_backgroundAttachment');
  let _backgroundColor = Symbol('_backgroundColor');
  let _backgroundImage = Symbol('_backgroundImage');
  let _backgroundPosition = Symbol('_backgroundPosition');
  let _backgroundRepeat = Symbol('_backgroundRepeat');
  let _border = Symbol('_border');
  let _borderBottom = Symbol('_borderBottom');
  let _borderBottomColor = Symbol('_borderBottomColor');
  let _borderBottomStyle = Symbol('_borderBottomStyle');
  let _borderBottomWidth = Symbol('_borderBottomWidth');
  let _borderCollapse = Symbol('_borderCollapse');
  let _borderColor = Symbol('_borderColor');
  let _borderLeft = Symbol('_borderLeft');
  let _borderLeftColor = Symbol('_borderLeftColor');
  let _borderLeftStyle = Symbol('_borderLeftStyle');
  let _borderLeftWidth = Symbol('_borderLeftWidth');
  let _borderRight = Symbol('_borderRight');
  let _borderRightColor = Symbol('_borderRightColor');
  let _borderRightStyle = Symbol('_borderRightStyle');
  let _borderRightWidth = Symbol('_borderRightWidth');
  let _borderSpacing = Symbol('_borderSpacing');
  let _borderStyle = Symbol('_borderStyle');
  let _borderTop = Symbol('_borderTop');
  let _borderTopColor = Symbol('_borderTopColor');
  let _borderTopStyle = Symbol('_borderTopStyle');
  let _borderTopWidth = Symbol('_borderTopWidth');
  let _borderWidth = Symbol('_borderWidth');
  let _bottom = Symbol('_bottom');
  let _captionSide = Symbol('_captionSide');
  let _clear = Symbol('_clear');
  let _clip = Symbol('_clip');
  let _color = Symbol('_color');
  let _content = Symbol('_content');
  let _cursor = Symbol('_cursor');
  let _direction = Symbol('_direction');
  let _display = Symbol('_display');
  let _emptyCells = Symbol('_emptyCells');
  let _font = Symbol('_font');
  let _fontFamily = Symbol('_fontFamily');
  let _fontSize = Symbol('_fontSize');
  let _fontStyle = Symbol('_fontStyle');
  let _fontVariant = Symbol('_fontVariant');
  let _fontWeight = Symbol('_fontWeight');
  let _height = Symbol('_height');
  let _left = Symbol('_left');
  let _letterSpacing = Symbol('_letterSpacing');
  let _lineHeight = Symbol('_lineHeight');
  let _listStyle = Symbol('_listStyle');
  let _listStyleImage = Symbol('_listStyleImage');
  let _listStylePosition = Symbol('_listStylePosition');
  let _listStyleType = Symbol('_listStyleType');
  let _margin = Symbol('_margin');
  let _marginBottom = Symbol('_marginBottom');
  let _marginLeft = Symbol('_marginLeft');
  let _marginRight = Symbol('_marginRight');
  let _marginTop = Symbol('_marginTop');
  let _maxHeight = Symbol('_maxHeight');
  let _maxWidth = Symbol('_maxWidth');
  let _minHeight = Symbol('_minHeight');
  let _minWidth = Symbol('_minWidth');
  let _outline = Symbol('_outline');
  let _outlineColor = Symbol('_outlineColor');
  let _outlineStyle = Symbol('_outlineStyle');
  let _outlineWidth = Symbol('_outlineWidth');
  let _overflow = Symbol('_overflow');
  let _padding = Symbol('_padding');
  let _paddingBottom = Symbol('_paddingBottom');
  let _paddingLeft = Symbol('_paddingLeft');
  let _paddingRight = Symbol('_paddingRight');
  let _paddingTop = Symbol('_paddingTop');
  let _pageBreakAfter = Symbol('_pageBreakAfter');
  let _pageBreakBefore = Symbol('_pageBreakBefore');
  let _pageBreakInside = Symbol('_pageBreakInside');
  let _position = Symbol('_position');
  let _quotes = Symbol('_quotes');
  let _right = Symbol('_right');
  let _tableLayout = Symbol('_tableLayout');
  let _textAlign = Symbol('_textAlign');
  let _textDecoration = Symbol('_textDecoration');
  let _textIndent = Symbol('_textIndent');
  let _textTransform = Symbol('_textTransform');
  let _top = Symbol('_top');
  let _unicodeBidi = Symbol('_unicodeBidi');
  let _verticalAlign = Symbol('_verticalAlign');
  let _visibility = Symbol('_visibility');
  let _whiteSpace = Symbol('_whiteSpace');
  let _width = Symbol('_width');
  let _wordSpacing = Symbol('_wordSpacing');
  let _zIndex = Symbol('_zIndex');
  let __setter__ = Symbol('__setter__');
  class CssStyleDeclaration extends dart.mixin(_interceptors.Interceptor, CssStyleDeclarationBase) {
    static new() {
      return CssStyleDeclaration.css('');
    }
    static css(css) {
      let style = Element.tag('div').style;
      dart.dput(style, 'cssText', css);
      return dart.as(style, CssStyleDeclaration);
    }
    getPropertyValue(propertyName) {
      let propValue = this[_getPropertyValueHelper](propertyName);
      return propValue != null ? dart.as(propValue, core.String) : '';
    }
    [_getPropertyValueHelper](propertyName) {
      if (dart.notNull(this[_supportsProperty](CssStyleDeclaration._camelCase(propertyName)))) {
        return this[_getPropertyValue](propertyName);
      } else {
        return this[_getPropertyValue](dart.notNull(html_common.Device.cssPrefix) + dart.notNull(propertyName));
      }
    }
    supportsProperty(propertyName) {
      return dart.notNull(this[_supportsProperty](propertyName)) || dart.notNull(this[_supportsProperty](CssStyleDeclaration._camelCase(dart.notNull(html_common.Device.cssPrefix) + dart.notNull(propertyName))));
    }
    [_supportsProperty](propertyName) {
      return dart.as(propertyName in this, core.bool);
    }
    setProperty(propertyName, value, priority) {
      if (priority === void 0)
        priority = null;
      return this[_setPropertyHelper](this[_browserPropertyName](propertyName), value, priority);
    }
    [_browserPropertyName](propertyName) {
      let name = CssStyleDeclaration._readCache(propertyName);
      if (typeof name == 'string')
        return name;
      if (dart.notNull(this[_supportsProperty](CssStyleDeclaration._camelCase(propertyName)))) {
        name = propertyName;
      } else {
        name = dart.notNull(html_common.Device.cssPrefix) + dart.notNull(propertyName);
      }
      CssStyleDeclaration._writeCache(propertyName, name);
      return name;
    }
    static _readCache(key) {
      return dart.as(CssStyleDeclaration._propertyCache[key], core.String);
    }
    static _writeCache(key, value) {
      CssStyleDeclaration._propertyCache[key] = value;
    }
    static _camelCase(hyphenated) {
      let replacedMs = hyphenated.replace(/^-ms-/, "ms-");
      let fToUpper = dart.const(new _foreign_helper.JS_CONST('function(_, letter) { return letter.toUpperCase(); }'));
      return dart.as(replacedMs.replace(/-([\da-z])/ig, fToUpper), core.String);
    }
    [_setPropertyHelper](propertyName, value, priority) {
      if (priority === void 0)
        priority = null;
      if (value == null)
        value = '';
      if (priority == null)
        priority = '';
      this.setProperty(propertyName, value, priority);
    }
    static get supportsTransitions() {
      return exports.document.body.style.supportsProperty('transition');
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get background() {
      return this[_background];
    }
    set background(value) {
      this[_background] = value == null ? '' : value;
    }
    get backgroundAttachment() {
      return this[_backgroundAttachment];
    }
    set backgroundAttachment(value) {
      this[_backgroundAttachment] = value == null ? '' : value;
    }
    get backgroundColor() {
      return this[_backgroundColor];
    }
    set backgroundColor(value) {
      this[_backgroundColor] = value == null ? '' : value;
    }
    get backgroundImage() {
      return this[_backgroundImage];
    }
    set backgroundImage(value) {
      this[_backgroundImage] = value == null ? '' : value;
    }
    get backgroundPosition() {
      return this[_backgroundPosition];
    }
    set backgroundPosition(value) {
      this[_backgroundPosition] = value == null ? '' : value;
    }
    get backgroundRepeat() {
      return this[_backgroundRepeat];
    }
    set backgroundRepeat(value) {
      this[_backgroundRepeat] = value == null ? '' : value;
    }
    get border() {
      return this[_border];
    }
    set border(value) {
      this[_border] = value == null ? '' : value;
    }
    get borderBottom() {
      return this[_borderBottom];
    }
    set borderBottom(value) {
      this[_borderBottom] = value == null ? '' : value;
    }
    get borderBottomColor() {
      return this[_borderBottomColor];
    }
    set borderBottomColor(value) {
      this[_borderBottomColor] = value == null ? '' : value;
    }
    get borderBottomStyle() {
      return this[_borderBottomStyle];
    }
    set borderBottomStyle(value) {
      this[_borderBottomStyle] = value == null ? '' : value;
    }
    get borderBottomWidth() {
      return this[_borderBottomWidth];
    }
    set borderBottomWidth(value) {
      this[_borderBottomWidth] = value == null ? '' : value;
    }
    get borderCollapse() {
      return this[_borderCollapse];
    }
    set borderCollapse(value) {
      this[_borderCollapse] = value == null ? '' : value;
    }
    get borderColor() {
      return this[_borderColor];
    }
    set borderColor(value) {
      this[_borderColor] = value == null ? '' : value;
    }
    get borderLeft() {
      return this[_borderLeft];
    }
    set borderLeft(value) {
      this[_borderLeft] = value == null ? '' : value;
    }
    get borderLeftColor() {
      return this[_borderLeftColor];
    }
    set borderLeftColor(value) {
      this[_borderLeftColor] = value == null ? '' : value;
    }
    get borderLeftStyle() {
      return this[_borderLeftStyle];
    }
    set borderLeftStyle(value) {
      this[_borderLeftStyle] = value == null ? '' : value;
    }
    get borderLeftWidth() {
      return this[_borderLeftWidth];
    }
    set borderLeftWidth(value) {
      this[_borderLeftWidth] = value == null ? '' : value;
    }
    get borderRight() {
      return this[_borderRight];
    }
    set borderRight(value) {
      this[_borderRight] = value == null ? '' : value;
    }
    get borderRightColor() {
      return this[_borderRightColor];
    }
    set borderRightColor(value) {
      this[_borderRightColor] = value == null ? '' : value;
    }
    get borderRightStyle() {
      return this[_borderRightStyle];
    }
    set borderRightStyle(value) {
      this[_borderRightStyle] = value == null ? '' : value;
    }
    get borderRightWidth() {
      return this[_borderRightWidth];
    }
    set borderRightWidth(value) {
      this[_borderRightWidth] = value == null ? '' : value;
    }
    get borderSpacing() {
      return this[_borderSpacing];
    }
    set borderSpacing(value) {
      this[_borderSpacing] = value == null ? '' : value;
    }
    get borderStyle() {
      return this[_borderStyle];
    }
    set borderStyle(value) {
      this[_borderStyle] = value == null ? '' : value;
    }
    get borderTop() {
      return this[_borderTop];
    }
    set borderTop(value) {
      this[_borderTop] = value == null ? '' : value;
    }
    get borderTopColor() {
      return this[_borderTopColor];
    }
    set borderTopColor(value) {
      this[_borderTopColor] = value == null ? '' : value;
    }
    get borderTopStyle() {
      return this[_borderTopStyle];
    }
    set borderTopStyle(value) {
      this[_borderTopStyle] = value == null ? '' : value;
    }
    get borderTopWidth() {
      return this[_borderTopWidth];
    }
    set borderTopWidth(value) {
      this[_borderTopWidth] = value == null ? '' : value;
    }
    get borderWidth() {
      return this[_borderWidth];
    }
    set borderWidth(value) {
      this[_borderWidth] = value == null ? '' : value;
    }
    get bottom() {
      return this[_bottom];
    }
    set bottom(value) {
      this[_bottom] = value == null ? '' : value;
    }
    get captionSide() {
      return this[_captionSide];
    }
    set captionSide(value) {
      this[_captionSide] = value == null ? '' : value;
    }
    get clear() {
      return this[_clear];
    }
    set clear(value) {
      this[_clear] = value == null ? '' : value;
    }
    get clip() {
      return this[_clip];
    }
    set clip(value) {
      this[_clip] = value == null ? '' : value;
    }
    get color() {
      return this[_color];
    }
    set color(value) {
      this[_color] = value == null ? '' : value;
    }
    get content() {
      return this[_content];
    }
    set content(value) {
      this[_content] = value == null ? '' : value;
    }
    get cursor() {
      return this[_cursor];
    }
    set cursor(value) {
      this[_cursor] = value == null ? '' : value;
    }
    get direction() {
      return this[_direction];
    }
    set direction(value) {
      this[_direction] = value == null ? '' : value;
    }
    get display() {
      return this[_display];
    }
    set display(value) {
      this[_display] = value == null ? '' : value;
    }
    get emptyCells() {
      return this[_emptyCells];
    }
    set emptyCells(value) {
      this[_emptyCells] = value == null ? '' : value;
    }
    get font() {
      return this[_font];
    }
    set font(value) {
      this[_font] = value == null ? '' : value;
    }
    get fontFamily() {
      return this[_fontFamily];
    }
    set fontFamily(value) {
      this[_fontFamily] = value == null ? '' : value;
    }
    get fontSize() {
      return this[_fontSize];
    }
    set fontSize(value) {
      this[_fontSize] = value == null ? '' : value;
    }
    get fontStyle() {
      return this[_fontStyle];
    }
    set fontStyle(value) {
      this[_fontStyle] = value == null ? '' : value;
    }
    get fontVariant() {
      return this[_fontVariant];
    }
    set fontVariant(value) {
      this[_fontVariant] = value == null ? '' : value;
    }
    get fontWeight() {
      return this[_fontWeight];
    }
    set fontWeight(value) {
      this[_fontWeight] = value == null ? '' : value;
    }
    get height() {
      return this[_height];
    }
    set height(value) {
      this[_height] = value == null ? '' : value;
    }
    get left() {
      return this[_left];
    }
    set left(value) {
      this[_left] = value == null ? '' : value;
    }
    get letterSpacing() {
      return this[_letterSpacing];
    }
    set letterSpacing(value) {
      this[_letterSpacing] = value == null ? '' : value;
    }
    get lineHeight() {
      return this[_lineHeight];
    }
    set lineHeight(value) {
      this[_lineHeight] = value == null ? '' : value;
    }
    get listStyle() {
      return this[_listStyle];
    }
    set listStyle(value) {
      this[_listStyle] = value == null ? '' : value;
    }
    get listStyleImage() {
      return this[_listStyleImage];
    }
    set listStyleImage(value) {
      this[_listStyleImage] = value == null ? '' : value;
    }
    get listStylePosition() {
      return this[_listStylePosition];
    }
    set listStylePosition(value) {
      this[_listStylePosition] = value == null ? '' : value;
    }
    get listStyleType() {
      return this[_listStyleType];
    }
    set listStyleType(value) {
      this[_listStyleType] = value == null ? '' : value;
    }
    get margin() {
      return this[_margin];
    }
    set margin(value) {
      this[_margin] = value == null ? '' : value;
    }
    get marginBottom() {
      return this[_marginBottom];
    }
    set marginBottom(value) {
      this[_marginBottom] = value == null ? '' : value;
    }
    get marginLeft() {
      return this[_marginLeft];
    }
    set marginLeft(value) {
      this[_marginLeft] = value == null ? '' : value;
    }
    get marginRight() {
      return this[_marginRight];
    }
    set marginRight(value) {
      this[_marginRight] = value == null ? '' : value;
    }
    get marginTop() {
      return this[_marginTop];
    }
    set marginTop(value) {
      this[_marginTop] = value == null ? '' : value;
    }
    get maxHeight() {
      return this[_maxHeight];
    }
    set maxHeight(value) {
      this[_maxHeight] = value == null ? '' : value;
    }
    get maxWidth() {
      return this[_maxWidth];
    }
    set maxWidth(value) {
      this[_maxWidth] = value == null ? '' : value;
    }
    get minHeight() {
      return this[_minHeight];
    }
    set minHeight(value) {
      this[_minHeight] = value == null ? '' : value;
    }
    get minWidth() {
      return this[_minWidth];
    }
    set minWidth(value) {
      this[_minWidth] = value == null ? '' : value;
    }
    get outline() {
      return this[_outline];
    }
    set outline(value) {
      this[_outline] = value == null ? '' : value;
    }
    get outlineColor() {
      return this[_outlineColor];
    }
    set outlineColor(value) {
      this[_outlineColor] = value == null ? '' : value;
    }
    get outlineStyle() {
      return this[_outlineStyle];
    }
    set outlineStyle(value) {
      this[_outlineStyle] = value == null ? '' : value;
    }
    get outlineWidth() {
      return this[_outlineWidth];
    }
    set outlineWidth(value) {
      this[_outlineWidth] = value == null ? '' : value;
    }
    get overflow() {
      return this[_overflow];
    }
    set overflow(value) {
      this[_overflow] = value == null ? '' : value;
    }
    get padding() {
      return this[_padding];
    }
    set padding(value) {
      this[_padding] = value == null ? '' : value;
    }
    get paddingBottom() {
      return this[_paddingBottom];
    }
    set paddingBottom(value) {
      this[_paddingBottom] = value == null ? '' : value;
    }
    get paddingLeft() {
      return this[_paddingLeft];
    }
    set paddingLeft(value) {
      this[_paddingLeft] = value == null ? '' : value;
    }
    get paddingRight() {
      return this[_paddingRight];
    }
    set paddingRight(value) {
      this[_paddingRight] = value == null ? '' : value;
    }
    get paddingTop() {
      return this[_paddingTop];
    }
    set paddingTop(value) {
      this[_paddingTop] = value == null ? '' : value;
    }
    get pageBreakAfter() {
      return this[_pageBreakAfter];
    }
    set pageBreakAfter(value) {
      this[_pageBreakAfter] = value == null ? '' : value;
    }
    get pageBreakBefore() {
      return this[_pageBreakBefore];
    }
    set pageBreakBefore(value) {
      this[_pageBreakBefore] = value == null ? '' : value;
    }
    get pageBreakInside() {
      return this[_pageBreakInside];
    }
    set pageBreakInside(value) {
      this[_pageBreakInside] = value == null ? '' : value;
    }
    get position() {
      return this[_position];
    }
    set position(value) {
      this[_position] = value == null ? '' : value;
    }
    get quotes() {
      return this[_quotes];
    }
    set quotes(value) {
      this[_quotes] = value == null ? '' : value;
    }
    get right() {
      return this[_right];
    }
    set right(value) {
      this[_right] = value == null ? '' : value;
    }
    get tableLayout() {
      return this[_tableLayout];
    }
    set tableLayout(value) {
      this[_tableLayout] = value == null ? '' : value;
    }
    get textAlign() {
      return this[_textAlign];
    }
    set textAlign(value) {
      this[_textAlign] = value == null ? '' : value;
    }
    get textDecoration() {
      return this[_textDecoration];
    }
    set textDecoration(value) {
      this[_textDecoration] = value == null ? '' : value;
    }
    get textIndent() {
      return this[_textIndent];
    }
    set textIndent(value) {
      this[_textIndent] = value == null ? '' : value;
    }
    get textTransform() {
      return this[_textTransform];
    }
    set textTransform(value) {
      this[_textTransform] = value == null ? '' : value;
    }
    get top() {
      return this[_top];
    }
    set top(value) {
      this[_top] = value == null ? '' : value;
    }
    get unicodeBidi() {
      return this[_unicodeBidi];
    }
    set unicodeBidi(value) {
      this[_unicodeBidi] = value == null ? '' : value;
    }
    get verticalAlign() {
      return this[_verticalAlign];
    }
    set verticalAlign(value) {
      this[_verticalAlign] = value == null ? '' : value;
    }
    get visibility() {
      return this[_visibility];
    }
    set visibility(value) {
      this[_visibility] = value == null ? '' : value;
    }
    get whiteSpace() {
      return this[_whiteSpace];
    }
    set whiteSpace(value) {
      this[_whiteSpace] = value == null ? '' : value;
    }
    get width() {
      return this[_width];
    }
    set width(value) {
      this[_width] = value == null ? '' : value;
    }
    get wordSpacing() {
      return this[_wordSpacing];
    }
    set wordSpacing(value) {
      this[_wordSpacing] = value == null ? '' : value;
    }
    get zIndex() {
      return this[_zIndex];
    }
    set zIndex(value) {
      this[_zIndex] = value == null ? '' : value;
    }
  }
  dart.setSignature(CssStyleDeclaration, {
    constructors: () => ({
      new: [CssStyleDeclaration, []],
      css: [CssStyleDeclaration, [core.String]],
      _: [CssStyleDeclaration, []]
    }),
    methods: () => ({
      getPropertyValue: [core.String, [core.String]],
      [_getPropertyValueHelper]: [core.String, [core.String]],
      supportsProperty: [core.bool, [core.String]],
      [_supportsProperty]: [core.bool, [core.String]],
      setProperty: [dart.void, [core.String, core.String], [core.String]],
      [_browserPropertyName]: [core.String, [core.String]],
      [_setPropertyHelper]: [dart.void, [core.String, core.String], [core.String]],
      [__getter__]: [core.Object, [core.String]],
      [__setter__]: [dart.void, [core.String, core.String]],
      getPropertyPriority: [core.String, [core.String]],
      [_getPropertyValue]: [core.String, [core.String]],
      item: [core.String, [core.int]],
      removeProperty: [core.String, [core.String]]
    }),
    statics: () => ({
      _readCache: [core.String, [core.String]],
      _writeCache: [dart.void, [core.String, core.String]],
      _camelCase: [core.String, [core.String]]
    }),
    names: ['_readCache', '_writeCache', '_camelCase']
  });
  CssStyleDeclaration[dart.metadata] = () => [dart.const(new _metadata.DomName('CSSStyleDeclaration')), dart.const(new _js_helper.Native("CSSStyleDeclaration,MSStyleCSSProperties,CSS2Properties"))];
  dart.defineLazyProperties(CssStyleDeclaration, {
    get _propertyCache() {
      return {};
    }
  });
  let _elementIterable = Symbol('_elementIterable');
  let _elementCssStyleDeclarationSetIterable = Symbol('_elementCssStyleDeclarationSetIterable');
  let _setAll = Symbol('_setAll');
  class _CssStyleDeclarationSet extends dart.mixin(core.Object, CssStyleDeclarationBase) {
    _CssStyleDeclarationSet(elementIterable) {
      this[_elementIterable] = elementIterable;
      this[_elementCssStyleDeclarationSetIterable] = null;
      this[_elementCssStyleDeclarationSetIterable] = dart.as(core.List.from(this[_elementIterable])[dartx.map](dart.fn(e => dart.dload(e, 'style'))), core.Iterable$(CssStyleDeclaration));
    }
    getPropertyValue(propertyName) {
      return this[_elementCssStyleDeclarationSetIterable][dartx.first].getPropertyValue(propertyName);
    }
    setProperty(propertyName, value, priority) {
      if (priority === void 0)
        priority = null;
      this[_elementCssStyleDeclarationSetIterable][dartx.forEach](dart.fn(e => dart.dsend(e, 'setProperty', propertyName, value, priority)));
    }
    [_setAll](propertyName, value) {
      value = value == null ? '' : value;
      for (let element of this[_elementIterable]) {
        element.style[propertyName] = value;
      }
    }
    set background(value) {
      this[_setAll]('background', value);
    }
    set backgroundAttachment(value) {
      this[_setAll]('backgroundAttachment', value);
    }
    set backgroundColor(value) {
      this[_setAll]('backgroundColor', value);
    }
    set backgroundImage(value) {
      this[_setAll]('backgroundImage', value);
    }
    set backgroundPosition(value) {
      this[_setAll]('backgroundPosition', value);
    }
    set backgroundRepeat(value) {
      this[_setAll]('backgroundRepeat', value);
    }
    set border(value) {
      this[_setAll]('border', value);
    }
    set borderBottom(value) {
      this[_setAll]('borderBottom', value);
    }
    set borderBottomColor(value) {
      this[_setAll]('borderBottomColor', value);
    }
    set borderBottomStyle(value) {
      this[_setAll]('borderBottomStyle', value);
    }
    set borderBottomWidth(value) {
      this[_setAll]('borderBottomWidth', value);
    }
    set borderCollapse(value) {
      this[_setAll]('borderCollapse', value);
    }
    set borderColor(value) {
      this[_setAll]('borderColor', value);
    }
    set borderLeft(value) {
      this[_setAll]('borderLeft', value);
    }
    set borderLeftColor(value) {
      this[_setAll]('borderLeftColor', value);
    }
    set borderLeftStyle(value) {
      this[_setAll]('borderLeftStyle', value);
    }
    set borderLeftWidth(value) {
      this[_setAll]('borderLeftWidth', value);
    }
    set borderRight(value) {
      this[_setAll]('borderRight', value);
    }
    set borderRightColor(value) {
      this[_setAll]('borderRightColor', value);
    }
    set borderRightStyle(value) {
      this[_setAll]('borderRightStyle', value);
    }
    set borderRightWidth(value) {
      this[_setAll]('borderRightWidth', value);
    }
    set borderSpacing(value) {
      this[_setAll]('borderSpacing', value);
    }
    set borderStyle(value) {
      this[_setAll]('borderStyle', value);
    }
    set borderTop(value) {
      this[_setAll]('borderTop', value);
    }
    set borderTopColor(value) {
      this[_setAll]('borderTopColor', value);
    }
    set borderTopStyle(value) {
      this[_setAll]('borderTopStyle', value);
    }
    set borderTopWidth(value) {
      this[_setAll]('borderTopWidth', value);
    }
    set borderWidth(value) {
      this[_setAll]('borderWidth', value);
    }
    set bottom(value) {
      this[_setAll]('bottom', value);
    }
    set captionSide(value) {
      this[_setAll]('captionSide', value);
    }
    set clear(value) {
      this[_setAll]('clear', value);
    }
    set clip(value) {
      this[_setAll]('clip', value);
    }
    set color(value) {
      this[_setAll]('color', value);
    }
    set content(value) {
      this[_setAll]('content', value);
    }
    set cursor(value) {
      this[_setAll]('cursor', value);
    }
    set direction(value) {
      this[_setAll]('direction', value);
    }
    set display(value) {
      this[_setAll]('display', value);
    }
    set emptyCells(value) {
      this[_setAll]('emptyCells', value);
    }
    set font(value) {
      this[_setAll]('font', value);
    }
    set fontFamily(value) {
      this[_setAll]('fontFamily', value);
    }
    set fontSize(value) {
      this[_setAll]('fontSize', value);
    }
    set fontStyle(value) {
      this[_setAll]('fontStyle', value);
    }
    set fontVariant(value) {
      this[_setAll]('fontVariant', value);
    }
    set fontWeight(value) {
      this[_setAll]('fontWeight', value);
    }
    set height(value) {
      this[_setAll]('height', value);
    }
    set left(value) {
      this[_setAll]('left', value);
    }
    set letterSpacing(value) {
      this[_setAll]('letterSpacing', value);
    }
    set lineHeight(value) {
      this[_setAll]('lineHeight', value);
    }
    set listStyle(value) {
      this[_setAll]('listStyle', value);
    }
    set listStyleImage(value) {
      this[_setAll]('listStyleImage', value);
    }
    set listStylePosition(value) {
      this[_setAll]('listStylePosition', value);
    }
    set listStyleType(value) {
      this[_setAll]('listStyleType', value);
    }
    set margin(value) {
      this[_setAll]('margin', value);
    }
    set marginBottom(value) {
      this[_setAll]('marginBottom', value);
    }
    set marginLeft(value) {
      this[_setAll]('marginLeft', value);
    }
    set marginRight(value) {
      this[_setAll]('marginRight', value);
    }
    set marginTop(value) {
      this[_setAll]('marginTop', value);
    }
    set maxHeight(value) {
      this[_setAll]('maxHeight', value);
    }
    set maxWidth(value) {
      this[_setAll]('maxWidth', value);
    }
    set minHeight(value) {
      this[_setAll]('minHeight', value);
    }
    set minWidth(value) {
      this[_setAll]('minWidth', value);
    }
    set outline(value) {
      this[_setAll]('outline', value);
    }
    set outlineColor(value) {
      this[_setAll]('outlineColor', value);
    }
    set outlineStyle(value) {
      this[_setAll]('outlineStyle', value);
    }
    set outlineWidth(value) {
      this[_setAll]('outlineWidth', value);
    }
    set overflow(value) {
      this[_setAll]('overflow', value);
    }
    set padding(value) {
      this[_setAll]('padding', value);
    }
    set paddingBottom(value) {
      this[_setAll]('paddingBottom', value);
    }
    set paddingLeft(value) {
      this[_setAll]('paddingLeft', value);
    }
    set paddingRight(value) {
      this[_setAll]('paddingRight', value);
    }
    set paddingTop(value) {
      this[_setAll]('paddingTop', value);
    }
    set pageBreakAfter(value) {
      this[_setAll]('pageBreakAfter', value);
    }
    set pageBreakBefore(value) {
      this[_setAll]('pageBreakBefore', value);
    }
    set pageBreakInside(value) {
      this[_setAll]('pageBreakInside', value);
    }
    set position(value) {
      this[_setAll]('position', value);
    }
    set quotes(value) {
      this[_setAll]('quotes', value);
    }
    set right(value) {
      this[_setAll]('right', value);
    }
    set tableLayout(value) {
      this[_setAll]('tableLayout', value);
    }
    set textAlign(value) {
      this[_setAll]('textAlign', value);
    }
    set textDecoration(value) {
      this[_setAll]('textDecoration', value);
    }
    set textIndent(value) {
      this[_setAll]('textIndent', value);
    }
    set textTransform(value) {
      this[_setAll]('textTransform', value);
    }
    set top(value) {
      this[_setAll]('top', value);
    }
    set unicodeBidi(value) {
      this[_setAll]('unicodeBidi', value);
    }
    set verticalAlign(value) {
      this[_setAll]('verticalAlign', value);
    }
    set visibility(value) {
      this[_setAll]('visibility', value);
    }
    set whiteSpace(value) {
      this[_setAll]('whiteSpace', value);
    }
    set width(value) {
      this[_setAll]('width', value);
    }
    set wordSpacing(value) {
      this[_setAll]('wordSpacing', value);
    }
    set zIndex(value) {
      this[_setAll]('zIndex', value);
    }
  }
  dart.setSignature(_CssStyleDeclarationSet, {
    constructors: () => ({_CssStyleDeclarationSet: [_CssStyleDeclarationSet, [core.Iterable$(Element)]]}),
    methods: () => ({
      getPropertyValue: [core.String, [core.String]],
      setProperty: [dart.void, [core.String, core.String], [core.String]],
      [_setAll]: [dart.void, [core.String, core.String]]
    })
  });
  class CssStyleRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssStyleRule, {
    constructors: () => ({_: [CssStyleRule, []]})
  });
  CssStyleRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSStyleRule')), dart.const(new _js_helper.Native("CSSStyleRule"))];
  class StyleSheet extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(StyleSheet, {
    constructors: () => ({_: [StyleSheet, []]})
  });
  StyleSheet[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('StyleSheet')), dart.const(new _js_helper.Native("StyleSheet"))];
  class CssStyleSheet extends StyleSheet {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssStyleSheet, {
    constructors: () => ({_: [CssStyleSheet, []]}),
    methods: () => ({
      addRule: [core.int, [core.String, core.String], [core.int]],
      deleteRule: [dart.void, [core.int]],
      insertRule: [core.int, [core.String], [core.int]],
      removeRule: [dart.void, [core.int]]
    })
  });
  CssStyleSheet[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSStyleSheet')), dart.const(new _js_helper.Native("CSSStyleSheet"))];
  class CssSupportsRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssSupportsRule, {
    constructors: () => ({_: [CssSupportsRule, []]}),
    methods: () => ({
      deleteRule: [dart.void, [core.int]],
      insertRule: [core.int, [core.String, core.int]]
    })
  });
  CssSupportsRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSSupportsRule')), dart.const(new _js_helper.Native("CSSSupportsRule"))];
  class CssViewportRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(CssViewportRule, {
    constructors: () => ({_: [CssViewportRule, []]})
  });
  CssViewportRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSViewportRule')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("CSSViewportRule"))];
  let _dartDetail = Symbol('_dartDetail');
  let _initCustomEvent = Symbol('_initCustomEvent');
  let _detail = Symbol('_detail');
  let _get__detail = Symbol('_get__detail');
  class CustomEvent extends Event {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let detail = opts && 'detail' in opts ? opts.detail : null;
      let e = dart.as(exports.document[_createEvent]('CustomEvent'), CustomEvent);
      e[_dartDetail] = detail;
      if (dart.is(detail, core.List) || dart.is(detail, core.Map) || typeof detail == 'string' || typeof detail == 'number') {
        try {
          detail = html_common.convertDartToNative_SerializedScriptValue(detail);
          e[_initCustomEvent](type, canBubble, cancelable, detail);
        } catch (_) {
          e[_initCustomEvent](type, canBubble, cancelable, null);
        }

      } else {
        e[_initCustomEvent](type, canBubble, cancelable, null);
      }
      return e;
    }
    get detail() {
      if (this[_dartDetail] != null) {
        return this[_dartDetail];
      }
      return this[_detail];
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get [_detail]() {
      return html_common.convertNativeToDart_SerializedScriptValue(this[_get__detail]);
    }
  }
  dart.setSignature(CustomEvent, {
    constructors: () => ({
      new: [CustomEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, detail: core.Object}],
      _: [CustomEvent, []]
    }),
    methods: () => ({[_initCustomEvent]: [dart.void, [core.String, core.bool, core.bool, core.Object]]})
  });
  CustomEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('CustomEvent')), dart.const(new _js_helper.Native("CustomEvent"))];
  class DListElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("dl"), DListElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(DListElement, 'created');
  dart.setSignature(DListElement, {
    constructors: () => ({
      _: [DListElement, []],
      new: [DListElement, []],
      created: [DListElement, []]
    })
  });
  DListElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLDListElement')), dart.const(new _js_helper.Native("HTMLDListElement"))];
  class DataListElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("datalist"), DataListElement);
    }
    created() {
      this.options = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('datalist');
    }
  }
  dart.defineNamedConstructor(DataListElement, 'created');
  dart.setSignature(DataListElement, {
    constructors: () => ({
      _: [DataListElement, []],
      new: [DataListElement, []],
      created: [DataListElement, []]
    })
  });
  DataListElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLDataListElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _js_helper.Native("HTMLDataListElement"))];
  class DataTransfer extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DataTransfer, {
    constructors: () => ({_: [DataTransfer, []]}),
    methods: () => ({
      clearData: [dart.void, [], [core.String]],
      getData: [core.String, [core.String]],
      setData: [dart.void, [core.String, core.String]],
      setDragImage: [dart.void, [Element, core.int, core.int]]
    })
  });
  DataTransfer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DataTransfer')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DataTransfer"))];
  let _getAsString = Symbol('_getAsString');
  class DataTransferItem extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    getAsString() {
      let completer = async.Completer$(core.String).new();
      this[_getAsString](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(core.String));
    }
  }
  dart.setSignature(DataTransferItem, {
    constructors: () => ({_: [DataTransferItem, []]}),
    methods: () => ({
      getAsFile: [Blob, []],
      [_getAsString]: [dart.void, [_StringCallback]],
      getAsString: [async.Future$(core.String), []],
      getAsEntry: [Entry, []]
    })
  });
  DataTransferItem[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DataTransferItem')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DataTransferItem"))];
  class DataTransferItemList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get(index) {
      return dart.as(this[index], DataTransferItem);
    }
  }
  dart.setSignature(DataTransferItemList, {
    constructors: () => ({_: [DataTransferItemList, []]}),
    methods: () => ({
      [__getter__]: [DataTransferItem, [core.int]],
      add: [DataTransferItem, [dart.dynamic], [core.String]],
      addData: [DataTransferItem, [core.String, core.String]],
      addFile: [DataTransferItem, [File]],
      clear: [dart.void, []],
      remove: [dart.void, [core.int]],
      get: [DataTransferItem, [core.int]]
    })
  });
  DataTransferItemList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DataTransferItemList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DataTransferItemList"))];
  let DatabaseCallback = dart.typedef('DatabaseCallback', () => dart.functionType(dart.void, [web_sql.SqlDatabase]));
  let _webkitRequestFileSystem = Symbol('_webkitRequestFileSystem');
  let _webkitResolveLocalFileSystemUrl = Symbol('_webkitResolveLocalFileSystemUrl');
  let _clearInterval = Symbol('_clearInterval');
  let _clearTimeout = Symbol('_clearTimeout');
  let _setInterval = Symbol('_setInterval');
  let _setTimeout = Symbol('_setTimeout');
  class WorkerGlobalScope extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    webkitRequestFileSystem(type, size) {
      let completer = async.Completer$(FileSystem).new();
      this[_webkitRequestFileSystem](type, size, dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(FileSystem));
    }
    webkitResolveLocalFileSystemUrl(url) {
      let completer = async.Completer$(Entry).new();
      this[_webkitResolveLocalFileSystemUrl](url, dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    get onError() {
      return WorkerGlobalScope.errorEvent.forTarget(this);
    }
  }
  WorkerGlobalScope[dart.implements] = () => [_WindowTimers, WindowBase64];
  dart.setSignature(WorkerGlobalScope, {
    constructors: () => ({_: [WorkerGlobalScope, []]}),
    methods: () => ({
      close: [dart.void, []],
      importScripts: [dart.void, [core.String]],
      [_webkitRequestFileSystem]: [dart.void, [core.int, core.int], [_FileSystemCallback, _ErrorCallback]],
      webkitRequestFileSystem: [async.Future$(FileSystem), [core.int, core.int]],
      requestFileSystemSync: [_DOMFileSystemSync, [core.int, core.int]],
      resolveLocalFileSystemSyncUrl: [_EntrySync, [core.String]],
      [_webkitResolveLocalFileSystemUrl]: [dart.void, [core.String, _EntryCallback], [_ErrorCallback]],
      webkitResolveLocalFileSystemUrl: [async.Future$(Entry), [core.String]],
      atob: [core.String, [core.String]],
      btoa: [core.String, [core.String]],
      [_clearInterval]: [dart.void, [core.int]],
      [_clearTimeout]: [dart.void, [core.int]],
      [_setInterval]: [core.int, [core.Object, core.int]],
      [_setTimeout]: [core.int, [core.Object, core.int]]
    })
  });
  WorkerGlobalScope[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WorkerGlobalScope')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WorkerGlobalScope"))];
  class DedicatedWorkerGlobalScope extends WorkerGlobalScope {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onMessage() {
      return DedicatedWorkerGlobalScope.messageEvent.forTarget(this);
    }
  }
  dart.setSignature(DedicatedWorkerGlobalScope, {
    constructors: () => ({_: [DedicatedWorkerGlobalScope, []]}),
    methods: () => ({postMessage: [dart.void, [core.Object], [core.List$(MessagePort)]]})
  });
  DedicatedWorkerGlobalScope[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DedicatedWorkerGlobalScope')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DedicatedWorkerGlobalScope"))];
  DedicatedWorkerGlobalScope.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  class DeprecatedStorageInfo extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeprecatedStorageInfo, {
    constructors: () => ({_: [DeprecatedStorageInfo, []]}),
    methods: () => ({
      queryUsageAndQuota: [dart.void, [core.int], [StorageUsageCallback, StorageErrorCallback]],
      requestQuota: [dart.void, [core.int, core.int], [StorageQuotaCallback, StorageErrorCallback]]
    })
  });
  DeprecatedStorageInfo[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DeprecatedStorageInfo')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeprecatedStorageInfo"))];
  DeprecatedStorageInfo.PERSISTENT = 1;
  DeprecatedStorageInfo.TEMPORARY = 0;
  class DeprecatedStorageQuota extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeprecatedStorageQuota, {
    constructors: () => ({_: [DeprecatedStorageQuota, []]}),
    methods: () => ({
      queryUsageAndQuota: [dart.void, [StorageUsageCallback], [StorageErrorCallback]],
      requestQuota: [dart.void, [core.int], [StorageQuotaCallback, StorageErrorCallback]]
    })
  });
  DeprecatedStorageQuota[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DeprecatedStorageQuota')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeprecatedStorageQuota"))];
  class DetailsElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("details"), DetailsElement);
    }
    created() {
      this.open = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('details');
    }
  }
  dart.defineNamedConstructor(DetailsElement, 'created');
  dart.setSignature(DetailsElement, {
    constructors: () => ({
      _: [DetailsElement, []],
      new: [DetailsElement, []],
      created: [DetailsElement, []]
    })
  });
  DetailsElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLDetailsElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLDetailsElement"))];
  class DeviceAcceleration extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeviceAcceleration, {
    constructors: () => ({_: [DeviceAcceleration, []]})
  });
  DeviceAcceleration[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DeviceAcceleration')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeviceAcceleration"))];
  class DeviceLightEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeviceLightEvent, {
    constructors: () => ({_: [DeviceLightEvent, []]})
  });
  DeviceLightEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DeviceLightEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeviceLightEvent"))];
  class DeviceMotionEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeviceMotionEvent, {
    constructors: () => ({_: [DeviceMotionEvent, []]}),
    methods: () => ({initDeviceMotionEvent: [dart.void, [core.String, core.bool, core.bool, DeviceAcceleration, DeviceAcceleration, DeviceRotationRate, core.num]]})
  });
  DeviceMotionEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DeviceMotionEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeviceMotionEvent"))];
  let _initDeviceOrientationEvent = Symbol('_initDeviceOrientationEvent');
  class DeviceOrientationEvent extends Event {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let alpha = opts && 'alpha' in opts ? opts.alpha : 0;
      let beta = opts && 'beta' in opts ? opts.beta : 0;
      let gamma = opts && 'gamma' in opts ? opts.gamma : 0;
      let absolute = opts && 'absolute' in opts ? opts.absolute : false;
      let e = exports.document[_createEvent]("DeviceOrientationEvent");
      dart.dsend(e, _initDeviceOrientationEvent, type, canBubble, cancelable, alpha, beta, gamma, absolute);
      return dart.as(e, DeviceOrientationEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeviceOrientationEvent, {
    constructors: () => ({
      new: [DeviceOrientationEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, alpha: core.num, beta: core.num, gamma: core.num, absolute: core.bool}],
      _: [DeviceOrientationEvent, []]
    }),
    methods: () => ({[_initDeviceOrientationEvent]: [dart.void, [core.String, core.bool, core.bool, core.num, core.num, core.num, core.bool]]})
  });
  DeviceOrientationEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('DeviceOrientationEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeviceOrientationEvent"))];
  class DeviceRotationRate extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DeviceRotationRate, {
    constructors: () => ({_: [DeviceRotationRate, []]})
  });
  DeviceRotationRate[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DeviceRotationRate')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DeviceRotationRate"))];
  class DialogElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this.open = null;
      this.returnValue = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(DialogElement, 'created');
  dart.setSignature(DialogElement, {
    constructors: () => ({
      _: [DialogElement, []],
      created: [DialogElement, []]
    }),
    methods: () => ({
      close: [dart.void, [core.String]],
      show: [dart.void, []],
      showModal: [dart.void, []]
    })
  });
  DialogElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLDialogElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLDialogElement"))];
  let _copyTo = Symbol('_copyTo');
  let _getMetadata = Symbol('_getMetadata');
  let _getParent = Symbol('_getParent');
  let _moveTo = Symbol('_moveTo');
  let _remove = Symbol('_remove');
  class Entry extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    copyTo(parent, opts) {
      let name = opts && 'name' in opts ? opts.name : null;
      let completer = async.Completer$(Entry).new();
      this[_copyTo](parent, {name: name, successCallback: dart.fn(value => {
          dart.dsend(completer, 'complete', value);
        }), errorCallback: dart.fn(error => {
          dart.dsend(completer, 'completeError', error);
        })});
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    getMetadata() {
      let completer = async.Completer$(Metadata).new();
      this[_getMetadata](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(Metadata));
    }
    getParent() {
      let completer = async.Completer$(Entry).new();
      this[_getParent](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    moveTo(parent, opts) {
      let name = opts && 'name' in opts ? opts.name : null;
      let completer = async.Completer$(Entry).new();
      this[_moveTo](parent, {name: name, successCallback: dart.fn(value => {
          dart.dsend(completer, 'complete', value);
        }), errorCallback: dart.fn(error => {
          dart.dsend(completer, 'completeError', error);
        })});
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    remove() {
      let completer = async.Completer.new();
      this[_remove](dart.fn(() => {
        dart.dsend(completer, 'complete');
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future);
    }
  }
  dart.setSignature(Entry, {
    constructors: () => ({_: [Entry, []]}),
    methods: () => ({
      [_copyTo]: [dart.void, [DirectoryEntry], {name: core.String, successCallback: _EntryCallback, errorCallback: _ErrorCallback}],
      copyTo: [async.Future$(Entry), [DirectoryEntry], {name: core.String}],
      [_getMetadata]: [dart.void, [MetadataCallback], [_ErrorCallback]],
      getMetadata: [async.Future$(Metadata), []],
      [_getParent]: [dart.void, [], [_EntryCallback, _ErrorCallback]],
      getParent: [async.Future$(Entry), []],
      [_moveTo]: [dart.void, [DirectoryEntry], {name: core.String, successCallback: _EntryCallback, errorCallback: _ErrorCallback}],
      moveTo: [async.Future$(Entry), [DirectoryEntry], {name: core.String}],
      [_remove]: [dart.void, [VoidCallback], [_ErrorCallback]],
      remove: [async.Future, []],
      toUrl: [core.String, []]
    })
  });
  Entry[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Entry')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Entry"))];
  let _getDirectory = Symbol('_getDirectory');
  let _getFile = Symbol('_getFile');
  let __getDirectory_1 = Symbol('__getDirectory_1');
  let __getDirectory_2 = Symbol('__getDirectory_2');
  let __getDirectory_3 = Symbol('__getDirectory_3');
  let __getDirectory_4 = Symbol('__getDirectory_4');
  let __getDirectory = Symbol('__getDirectory');
  let __getFile_1 = Symbol('__getFile_1');
  let __getFile_2 = Symbol('__getFile_2');
  let __getFile_3 = Symbol('__getFile_3');
  let __getFile_4 = Symbol('__getFile_4');
  let __getFile = Symbol('__getFile');
  let _removeRecursively = Symbol('_removeRecursively');
  class DirectoryEntry extends Entry {
    createDirectory(path, opts) {
      let exclusive = opts && 'exclusive' in opts ? opts.exclusive : false;
      return this[_getDirectory](path, {options: dart.map({create: true, exclusive: exclusive})});
    }
    getDirectory(path) {
      return this[_getDirectory](path);
    }
    createFile(path, opts) {
      let exclusive = opts && 'exclusive' in opts ? opts.exclusive : false;
      return this[_getFile](path, {options: dart.map({create: true, exclusive: exclusive})});
    }
    getFile(path) {
      return this[_getFile](path);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    [__getDirectory](path, opts) {
      let options = opts && 'options' in opts ? opts.options : null;
      let successCallback = opts && 'successCallback' in opts ? opts.successCallback : null;
      let errorCallback = opts && 'errorCallback' in opts ? opts.errorCallback : null;
      if (errorCallback != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[__getDirectory_1](path, options_1, successCallback, errorCallback);
        return;
      }
      if (successCallback != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[__getDirectory_2](path, options_1, successCallback);
        return;
      }
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[__getDirectory_3](path, options_1);
        return;
      }
      this[__getDirectory_4](path);
      return;
    }
    [_getDirectory](path, opts) {
      let options = opts && 'options' in opts ? opts.options : null;
      let completer = async.Completer$(Entry).new();
      this[__getDirectory](path, {options: options, successCallback: dart.fn(value => {
          dart.dsend(completer, 'complete', value);
        }), errorCallback: dart.fn(error => {
          dart.dsend(completer, 'completeError', error);
        })});
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    [__getFile](path, opts) {
      let options = opts && 'options' in opts ? opts.options : null;
      let successCallback = opts && 'successCallback' in opts ? opts.successCallback : null;
      let errorCallback = opts && 'errorCallback' in opts ? opts.errorCallback : null;
      if (errorCallback != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[__getFile_1](path, options_1, successCallback, errorCallback);
        return;
      }
      if (successCallback != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[__getFile_2](path, options_1, successCallback);
        return;
      }
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[__getFile_3](path, options_1);
        return;
      }
      this[__getFile_4](path);
      return;
    }
    [_getFile](path, opts) {
      let options = opts && 'options' in opts ? opts.options : null;
      let completer = async.Completer$(Entry).new();
      this[__getFile](path, {options: options, successCallback: dart.fn(value => {
          dart.dsend(completer, 'complete', value);
        }), errorCallback: dart.fn(error => {
          dart.dsend(completer, 'completeError', error);
        })});
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    removeRecursively() {
      let completer = async.Completer.new();
      this[_removeRecursively](dart.fn(() => {
        dart.dsend(completer, 'complete');
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future);
    }
  }
  dart.setSignature(DirectoryEntry, {
    constructors: () => ({_: [DirectoryEntry, []]}),
    methods: () => ({
      createDirectory: [async.Future$(Entry), [core.String], {exclusive: core.bool}],
      getDirectory: [async.Future$(Entry), [core.String]],
      createFile: [async.Future$(Entry), [core.String], {exclusive: core.bool}],
      getFile: [async.Future$(Entry), [core.String]],
      createReader: [DirectoryReader, []],
      [__getDirectory]: [dart.void, [core.String], {options: core.Map, successCallback: _EntryCallback, errorCallback: _ErrorCallback}],
      [__getDirectory_1]: [dart.void, [dart.dynamic, dart.dynamic, _EntryCallback, _ErrorCallback]],
      [__getDirectory_2]: [dart.void, [dart.dynamic, dart.dynamic, _EntryCallback]],
      [__getDirectory_3]: [dart.void, [dart.dynamic, dart.dynamic]],
      [__getDirectory_4]: [dart.void, [dart.dynamic]],
      [_getDirectory]: [async.Future$(Entry), [core.String], {options: core.Map}],
      [__getFile]: [dart.void, [core.String], {options: core.Map, successCallback: _EntryCallback, errorCallback: _ErrorCallback}],
      [__getFile_1]: [dart.void, [dart.dynamic, dart.dynamic, _EntryCallback, _ErrorCallback]],
      [__getFile_2]: [dart.void, [dart.dynamic, dart.dynamic, _EntryCallback]],
      [__getFile_3]: [dart.void, [dart.dynamic, dart.dynamic]],
      [__getFile_4]: [dart.void, [dart.dynamic]],
      [_getFile]: [async.Future$(Entry), [core.String], {options: core.Map}],
      [_removeRecursively]: [dart.void, [VoidCallback], [_ErrorCallback]],
      removeRecursively: [async.Future, []]
    })
  });
  DirectoryEntry[dart.metadata] = () => [dart.const(new _metadata.DomName('DirectoryEntry')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DirectoryEntry"))];
  let _readEntries = Symbol('_readEntries');
  class DirectoryReader extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    readEntries() {
      let completer = async.Completer$(core.List$(Entry)).new();
      this[_readEntries](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(core.List$(Entry)));
    }
  }
  dart.setSignature(DirectoryReader, {
    constructors: () => ({_: [DirectoryReader, []]}),
    methods: () => ({
      [_readEntries]: [dart.void, [_EntriesCallback], [_ErrorCallback]],
      readEntries: [async.Future$(core.List$(Entry)), []]
    })
  });
  DirectoryReader[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DirectoryReader')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DirectoryReader"))];
  class DivElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("div"), DivElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(DivElement, 'created');
  dart.setSignature(DivElement, {
    constructors: () => ({
      _: [DivElement, []],
      new: [DivElement, []],
      created: [DivElement, []]
    })
  });
  DivElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLDivElement')), dart.const(new _js_helper.Native("HTMLDivElement"))];
  let _get_window = Symbol('_get_window');
  let _createTouch_1 = Symbol('_createTouch_1');
  let _createTouch = Symbol('_createTouch');
  let _createElement = Symbol('_createElement');
  let _createNodeIterator = Symbol('_createNodeIterator');
  let _createTreeWalker = Symbol('_createTreeWalker');
  let _caretRangeFromPoint = Symbol('_caretRangeFromPoint');
  let _createTouchList = Symbol('_createTouchList');
  let _elementFromPoint = Symbol('_elementFromPoint');
  let _getCssCanvasContext = Symbol('_getCssCanvasContext');
  let _webkitExitFullscreen = Symbol('_webkitExitFullscreen');
  class Document extends Node {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get window() {
      return _convertNativeToDart_Window(this[_get_window]);
    }
    [_createTouch](window, target, identifier, pageX, pageY, screenX, screenY, webkitRadiusX, webkitRadiusY, webkitRotationAngle, webkitForce) {
      let target_1 = _convertDartToNative_EventTarget(target);
      return this[_createTouch_1](window, target_1, identifier, pageX, pageY, screenX, screenY, webkitRadiusX, webkitRadiusY, webkitRotationAngle, webkitForce);
    }
    get onAbort() {
      return Element.abortEvent.forTarget(this);
    }
    get onBeforeCopy() {
      return Element.beforeCopyEvent.forTarget(this);
    }
    get onBeforeCut() {
      return Element.beforeCutEvent.forTarget(this);
    }
    get onBeforePaste() {
      return Element.beforePasteEvent.forTarget(this);
    }
    get onBlur() {
      return Element.blurEvent.forTarget(this);
    }
    get onCanPlay() {
      return Element.canPlayEvent.forTarget(this);
    }
    get onCanPlayThrough() {
      return Element.canPlayThroughEvent.forTarget(this);
    }
    get onChange() {
      return Element.changeEvent.forTarget(this);
    }
    get onClick() {
      return Element.clickEvent.forTarget(this);
    }
    get onContextMenu() {
      return Element.contextMenuEvent.forTarget(this);
    }
    get onCopy() {
      return Element.copyEvent.forTarget(this);
    }
    get onCut() {
      return Element.cutEvent.forTarget(this);
    }
    get onDoubleClick() {
      return Element.doubleClickEvent.forTarget(this);
    }
    get onDrag() {
      return Element.dragEvent.forTarget(this);
    }
    get onDragEnd() {
      return Element.dragEndEvent.forTarget(this);
    }
    get onDragEnter() {
      return Element.dragEnterEvent.forTarget(this);
    }
    get onDragLeave() {
      return Element.dragLeaveEvent.forTarget(this);
    }
    get onDragOver() {
      return Element.dragOverEvent.forTarget(this);
    }
    get onDragStart() {
      return Element.dragStartEvent.forTarget(this);
    }
    get onDrop() {
      return Element.dropEvent.forTarget(this);
    }
    get onDurationChange() {
      return Element.durationChangeEvent.forTarget(this);
    }
    get onEmptied() {
      return Element.emptiedEvent.forTarget(this);
    }
    get onEnded() {
      return Element.endedEvent.forTarget(this);
    }
    get onError() {
      return Element.errorEvent.forTarget(this);
    }
    get onFocus() {
      return Element.focusEvent.forTarget(this);
    }
    get onInput() {
      return Element.inputEvent.forTarget(this);
    }
    get onInvalid() {
      return Element.invalidEvent.forTarget(this);
    }
    get onKeyDown() {
      return Element.keyDownEvent.forTarget(this);
    }
    get onKeyPress() {
      return Element.keyPressEvent.forTarget(this);
    }
    get onKeyUp() {
      return Element.keyUpEvent.forTarget(this);
    }
    get onLoad() {
      return Element.loadEvent.forTarget(this);
    }
    get onLoadedData() {
      return Element.loadedDataEvent.forTarget(this);
    }
    get onLoadedMetadata() {
      return Element.loadedMetadataEvent.forTarget(this);
    }
    get onMouseDown() {
      return Element.mouseDownEvent.forTarget(this);
    }
    get onMouseEnter() {
      return Element.mouseEnterEvent.forTarget(this);
    }
    get onMouseLeave() {
      return Element.mouseLeaveEvent.forTarget(this);
    }
    get onMouseMove() {
      return Element.mouseMoveEvent.forTarget(this);
    }
    get onMouseOut() {
      return Element.mouseOutEvent.forTarget(this);
    }
    get onMouseOver() {
      return Element.mouseOverEvent.forTarget(this);
    }
    get onMouseUp() {
      return Element.mouseUpEvent.forTarget(this);
    }
    get onMouseWheel() {
      return Element.mouseWheelEvent.forTarget(this);
    }
    get onPaste() {
      return Element.pasteEvent.forTarget(this);
    }
    get onPause() {
      return Element.pauseEvent.forTarget(this);
    }
    get onPlay() {
      return Element.playEvent.forTarget(this);
    }
    get onPlaying() {
      return Element.playingEvent.forTarget(this);
    }
    get onPointerLockChange() {
      return Document.pointerLockChangeEvent.forTarget(this);
    }
    get onPointerLockError() {
      return Document.pointerLockErrorEvent.forTarget(this);
    }
    get onRateChange() {
      return Element.rateChangeEvent.forTarget(this);
    }
    get onReadyStateChange() {
      return Document.readyStateChangeEvent.forTarget(this);
    }
    get onReset() {
      return Element.resetEvent.forTarget(this);
    }
    get onResize() {
      return Element.resizeEvent.forTarget(this);
    }
    get onScroll() {
      return Element.scrollEvent.forTarget(this);
    }
    get onSearch() {
      return Element.searchEvent.forTarget(this);
    }
    get onSecurityPolicyViolation() {
      return Document.securityPolicyViolationEvent.forTarget(this);
    }
    get onSeeked() {
      return Element.seekedEvent.forTarget(this);
    }
    get onSeeking() {
      return Element.seekingEvent.forTarget(this);
    }
    get onSelect() {
      return Element.selectEvent.forTarget(this);
    }
    get onSelectionChange() {
      return Document.selectionChangeEvent.forTarget(this);
    }
    get onSelectStart() {
      return Element.selectStartEvent.forTarget(this);
    }
    get onStalled() {
      return Element.stalledEvent.forTarget(this);
    }
    get onSubmit() {
      return Element.submitEvent.forTarget(this);
    }
    get onSuspend() {
      return Element.suspendEvent.forTarget(this);
    }
    get onTimeUpdate() {
      return Element.timeUpdateEvent.forTarget(this);
    }
    get onTouchCancel() {
      return Element.touchCancelEvent.forTarget(this);
    }
    get onTouchEnd() {
      return Element.touchEndEvent.forTarget(this);
    }
    get onTouchMove() {
      return Element.touchMoveEvent.forTarget(this);
    }
    get onTouchStart() {
      return Element.touchStartEvent.forTarget(this);
    }
    get onVolumeChange() {
      return Element.volumeChangeEvent.forTarget(this);
    }
    get onWaiting() {
      return Element.waitingEvent.forTarget(this);
    }
    get onFullscreenChange() {
      return Element.fullscreenChangeEvent.forTarget(this);
    }
    get onFullscreenError() {
      return Element.fullscreenErrorEvent.forTarget(this);
    }
    querySelectorAll(selectors) {
      return new _FrozenElementList._wrap(this[_querySelectorAll](selectors));
    }
    query(relativeSelectors) {
      return this.querySelector(relativeSelectors);
    }
    queryAll(relativeSelectors) {
      return this.querySelectorAll(relativeSelectors);
    }
    get supportsRegisterElement() {
      return dart.as("registerElement" in this, core.bool);
    }
    get supportsRegister() {
      return this.supportsRegisterElement;
    }
    createElement(tagName, typeExtension) {
      if (typeExtension === void 0)
        typeExtension = null;
      return this[_createElement](tagName, typeExtension);
    }
    [_createNodeIterator](root, whatToShow, filter) {
      if (whatToShow === void 0)
        whatToShow = null;
      if (filter === void 0)
        filter = null;
      return dart.as(this.createNodeIterator(root, whatToShow, filter, false), NodeIterator);
    }
    [_createTreeWalker](root, whatToShow, filter) {
      if (whatToShow === void 0)
        whatToShow = null;
      if (filter === void 0)
        filter = null;
      return dart.as(this.createTreeWalker(root, whatToShow, filter, false), TreeWalker);
    }
  }
  dart.setSignature(Document, {
    constructors: () => ({_: [Document, []]}),
    methods: () => ({
      adoptNode: [Node, [Node]],
      [_caretRangeFromPoint]: [Range, [core.int, core.int]],
      createDocumentFragment: [DocumentFragment, []],
      [_createElement]: [Element, [core.String], [core.String]],
      createElementNS: [Element, [core.String, core.String], [core.String]],
      [_createEvent]: [Event, [core.String]],
      createRange: [Range, []],
      [_createTextNode]: [Text, [core.String]],
      [_createTouch]: [Touch, [Window, EventTarget, core.int, core.num, core.num, core.num, core.num, core.num, core.num, core.num, core.num]],
      [_createTouch_1]: [Touch, [Window, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]],
      [_createTouchList]: [TouchList, [Touch]],
      [_elementFromPoint]: [Element, [core.int, core.int]],
      execCommand: [core.bool, [core.String, core.bool, core.String]],
      exitFullscreen: [dart.void, []],
      exitPointerLock: [dart.void, []],
      [_getCssCanvasContext]: [core.Object, [core.String, core.String, core.int, core.int]],
      getElementById: [Element, [core.String]],
      getElementsByClassName: [core.List$(Node), [core.String]],
      getElementsByName: [core.List$(Node), [core.String]],
      getElementsByTagName: [core.List$(Node), [core.String]],
      importNode: [Node, [Node], [core.bool]],
      queryCommandEnabled: [core.bool, [core.String]],
      queryCommandIndeterm: [core.bool, [core.String]],
      queryCommandState: [core.bool, [core.String]],
      queryCommandSupported: [core.bool, [core.String]],
      queryCommandValue: [core.String, [core.String]],
      transformDocumentToTreeView: [dart.void, [core.String]],
      [_webkitExitFullscreen]: [dart.void, []],
      querySelector: [Element, [core.String]],
      [_querySelectorAll]: [core.List$(Node), [core.String]],
      querySelectorAll: [ElementList$(Element), [core.String]],
      query: [Element, [core.String]],
      queryAll: [ElementList$(Element), [core.String]],
      createElement: [Element, [core.String], [core.String]],
      [_createNodeIterator]: [NodeIterator, [Node], [core.int, NodeFilter]],
      [_createTreeWalker]: [TreeWalker, [Node], [core.int, NodeFilter]]
    })
  });
  Document[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Document')), dart.const(new _js_helper.Native("Document"))];
  Document.pointerLockChangeEvent = dart.const(new (EventStreamProvider$(Event))('pointerlockchange'));
  Document.pointerLockErrorEvent = dart.const(new (EventStreamProvider$(Event))('pointerlockerror'));
  Document.readyStateChangeEvent = dart.const(new (EventStreamProvider$(Event))('readystatechange'));
  class SecurityPolicyViolationEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SecurityPolicyViolationEvent, {
    constructors: () => ({_: [SecurityPolicyViolationEvent, []]})
  });
  SecurityPolicyViolationEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SecurityPolicyViolationEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SecurityPolicyViolationEvent"))];
  Document.securityPolicyViolationEvent = dart.const(new (EventStreamProvider$(SecurityPolicyViolationEvent))('securitypolicyviolation'));
  Document.selectionChangeEvent = dart.const(new (EventStreamProvider$(Event))('selectionchange'));
  let _docChildren = Symbol('_docChildren');
  class DocumentFragment extends Node {
    static new() {
      return exports.document.createDocumentFragment();
    }
    static html(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      return exports.document.body.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer});
    }
    static svg(svgContent, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      return svg.SvgSvgElement.new().createFragment(svgContent, {validator: validator, treeSanitizer: treeSanitizer});
    }
    get [_children]() {
      return dart.throw(new core.UnimplementedError('Use _docChildren instead'));
    }
    get children() {
      if (this[_docChildren] == null) {
        this[_docChildren] = new html_common.FilteredElementList(this);
      }
      return this[_docChildren];
    }
    set children(value) {
      let copy = core.List.from(value);
      let children = this.children;
      dart.dsend(children, 'clear');
      dart.dsend(children, 'addAll', copy);
    }
    querySelectorAll(selectors) {
      return new _FrozenElementList._wrap(this[_querySelectorAll](selectors));
    }
    get innerHtml() {
      let e = Element.tag("div");
      dart.dsend(e, 'append', this.clone(true));
      return dart.as(dart.dload(e, 'innerHtml'), core.String);
    }
    set innerHtml(value) {
      this.setInnerHtml(value);
    }
    setInnerHtml(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      this.nodes[dartx.clear]();
      this.append(exports.document.body.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer}));
    }
    appendText(text) {
      this.append(Text.new(text));
    }
    appendHtml(text, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let NodeTreeSanitizer = opts && 'NodeTreeSanitizer' in opts ? opts.NodeTreeSanitizer : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      this.append(DocumentFragment.html(text, {validator: validator, treeSanitizer: dart.as(treeSanitizer, NodeTreeSanitizer)}));
    }
    query(relativeSelectors) {
      return this.querySelector(relativeSelectors);
    }
    queryAll(relativeSelectors) {
      return this.querySelectorAll(relativeSelectors);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  DocumentFragment[dart.implements] = () => [ParentNode];
  dart.setSignature(DocumentFragment, {
    constructors: () => ({
      new: [DocumentFragment, []],
      html: [DocumentFragment, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      svg: [DocumentFragment, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      _: [DocumentFragment, []]
    }),
    methods: () => ({
      querySelectorAll: [ElementList$(Element), [core.String]],
      setInnerHtml: [dart.void, [core.String], {validator: NodeValidator, treeSanitizer: NodeTreeSanitizer}],
      appendText: [dart.void, [core.String]],
      appendHtml: [dart.void, [core.String], {validator: NodeValidator, NodeTreeSanitizer: dart.dynamic, treeSanitizer: dart.dynamic}],
      query: [Element, [core.String]],
      queryAll: [ElementList$(Element), [core.String]],
      getElementById: [Element, [core.String]],
      querySelector: [Element, [core.String]],
      [_querySelectorAll]: [core.List$(Node), [core.String]]
    })
  });
  DocumentFragment[dart.metadata] = () => [dart.const(new _metadata.DomName('DocumentFragment')), dart.const(new _js_helper.Native("DocumentFragment"))];
  class DomError extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(name, message) {
      if (message === void 0)
        message = null;
      if (message != null) {
        return DomError._create_1(name, message);
      }
      return DomError._create_2(name);
    }
    static _create_1(name, message) {
      return dart.as(new DOMError(name, message), DomError);
    }
    static _create_2(name) {
      return dart.as(new DOMError(name), DomError);
    }
  }
  dart.setSignature(DomError, {
    constructors: () => ({
      _: [DomError, []],
      new: [DomError, [core.String], [core.String]]
    }),
    statics: () => ({
      _create_1: [DomError, [dart.dynamic, dart.dynamic]],
      _create_2: [DomError, [dart.dynamic]]
    }),
    names: ['_create_1', '_create_2']
  });
  DomError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMError')), dart.const(new _js_helper.Native("DOMError"))];
  class DomException extends _interceptors.Interceptor {
    get name() {
      let errorName = this.name;
      if (dart.notNull(html_common.Device.isWebKit) && dart.equals(errorName, 'SECURITY_ERR'))
        return 'SecurityError';
      if (dart.notNull(html_common.Device.isWebKit) && dart.equals(errorName, 'SYNTAX_ERR'))
        return 'SyntaxError';
      return dart.as(errorName, core.String);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    toString() {
      return dart.as(String(this), core.String);
    }
  }
  dart.setSignature(DomException, {
    constructors: () => ({_: [DomException, []]})
  });
  dart.defineExtensionMembers(DomException, ['toString']);
  DomException[dart.metadata] = () => [dart.const(new _metadata.DomName('DOMException')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("DOMException"))];
  DomException.INDEX_SIZE = 'IndexSizeError';
  DomException.HIERARCHY_REQUEST = 'HierarchyRequestError';
  DomException.WRONG_DOCUMENT = 'WrongDocumentError';
  DomException.INVALID_CHARACTER = 'InvalidCharacterError';
  DomException.NO_MODIFICATION_ALLOWED = 'NoModificationAllowedError';
  DomException.NOT_FOUND = 'NotFoundError';
  DomException.NOT_SUPPORTED = 'NotSupportedError';
  DomException.INVALID_STATE = 'InvalidStateError';
  DomException.SYNTAX = 'SyntaxError';
  DomException.INVALID_MODIFICATION = 'InvalidModificationError';
  DomException.NAMESPACE = 'NamespaceError';
  DomException.INVALID_ACCESS = 'InvalidAccessError';
  DomException.TYPE_MISMATCH = 'TypeMismatchError';
  DomException.SECURITY = 'SecurityError';
  DomException.NETWORK = 'NetworkError';
  DomException.ABORT = 'AbortError';
  DomException.URL_MISMATCH = 'URLMismatchError';
  DomException.QUOTA_EXCEEDED = 'QuotaExceededError';
  DomException.TIMEOUT = 'TimeoutError';
  DomException.INVALID_NODE_TYPE = 'InvalidNodeTypeError';
  DomException.DATA_CLONE = 'DataCloneError';
  class DomImplementation extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DomImplementation, {
    constructors: () => ({_: [DomImplementation, []]}),
    methods: () => ({
      createDocument: [XmlDocument, [core.String, core.String, _DocumentType]],
      createDocumentType: [_DocumentType, [core.String, core.String, core.String]],
      createHtmlDocument: [HtmlDocument, [core.String]],
      hasFeature: [core.bool, [core.String, core.String]]
    })
  });
  DomImplementation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMImplementation')), dart.const(new _js_helper.Native("DOMImplementation"))];
  class DomIterator extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DomIterator, {
    constructors: () => ({_: [DomIterator, []]}),
    methods: () => ({next: [core.Object, [], [core.Object]]})
  });
  DomIterator[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Iterator')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Iterator"))];
  class DomMatrixReadOnly extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DomMatrixReadOnly, {
    constructors: () => ({_: [DomMatrixReadOnly, []]}),
    methods: () => ({
      multiply: [DomMatrix, [DomMatrix]],
      scale: [DomMatrix, [core.num], [core.num, core.num]],
      scale3d: [DomMatrix, [core.num], [core.num, core.num, core.num]],
      scaleNonUniform: [DomMatrix, [core.num], [core.num, core.num, core.num, core.num, core.num]],
      toFloat32Array: [typed_data.Float32List, []],
      toFloat64Array: [typed_data.Float64List, []],
      translate: [DomMatrix, [core.num, core.num], [core.num]]
    })
  });
  DomMatrixReadOnly[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMMatrixReadOnly')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMMatrixReadOnly"))];
  class DomMatrix extends DomMatrixReadOnly {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(other) {
      if (other === void 0)
        other = null;
      if (other == null) {
        return DomMatrix._create_1();
      }
      if (dart.is(other, DomMatrixReadOnly) || other == null) {
        return DomMatrix._create_2(other);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1() {
      return dart.as(new DOMMatrix(), DomMatrix);
    }
    static _create_2(other) {
      return dart.as(new DOMMatrix(other), DomMatrix);
    }
    get a() {
      return dart.as(this.a, core.num);
    }
    set a(value) {
      this.a = value;
    }
    get b() {
      return dart.as(this.b, core.num);
    }
    set b(value) {
      this.b = value;
    }
    get c() {
      return dart.as(this.c, core.num);
    }
    set c(value) {
      this.c = value;
    }
    get d() {
      return dart.as(this.d, core.num);
    }
    set d(value) {
      this.d = value;
    }
    get e() {
      return dart.as(this.e, core.num);
    }
    set e(value) {
      this.e = value;
    }
    get f() {
      return dart.as(this.f, core.num);
    }
    set f(value) {
      this.f = value;
    }
    get m11() {
      return dart.as(this.m11, core.num);
    }
    set m11(value) {
      this.m11 = value;
    }
    get m12() {
      return dart.as(this.m12, core.num);
    }
    set m12(value) {
      this.m12 = value;
    }
    get m13() {
      return dart.as(this.m13, core.num);
    }
    set m13(value) {
      this.m13 = value;
    }
    get m14() {
      return dart.as(this.m14, core.num);
    }
    set m14(value) {
      this.m14 = value;
    }
    get m21() {
      return dart.as(this.m21, core.num);
    }
    set m21(value) {
      this.m21 = value;
    }
    get m22() {
      return dart.as(this.m22, core.num);
    }
    set m22(value) {
      this.m22 = value;
    }
    get m23() {
      return dart.as(this.m23, core.num);
    }
    set m23(value) {
      this.m23 = value;
    }
    get m24() {
      return dart.as(this.m24, core.num);
    }
    set m24(value) {
      this.m24 = value;
    }
    get m31() {
      return dart.as(this.m31, core.num);
    }
    set m31(value) {
      this.m31 = value;
    }
    get m32() {
      return dart.as(this.m32, core.num);
    }
    set m32(value) {
      this.m32 = value;
    }
    get m33() {
      return dart.as(this.m33, core.num);
    }
    set m33(value) {
      this.m33 = value;
    }
    get m34() {
      return dart.as(this.m34, core.num);
    }
    set m34(value) {
      this.m34 = value;
    }
    get m41() {
      return dart.as(this.m41, core.num);
    }
    set m41(value) {
      this.m41 = value;
    }
    get m42() {
      return dart.as(this.m42, core.num);
    }
    set m42(value) {
      this.m42 = value;
    }
    get m43() {
      return dart.as(this.m43, core.num);
    }
    set m43(value) {
      this.m43 = value;
    }
    get m44() {
      return dart.as(this.m44, core.num);
    }
    set m44(value) {
      this.m44 = value;
    }
  }
  dart.setSignature(DomMatrix, {
    constructors: () => ({
      _: [DomMatrix, []],
      new: [DomMatrix, [], [DomMatrixReadOnly]]
    }),
    methods: () => ({
      multiplySelf: [DomMatrix, [DomMatrix]],
      preMultiplySelf: [DomMatrix, [DomMatrix]],
      scale3dSelf: [DomMatrix, [core.num], [core.num, core.num, core.num]],
      scaleNonUniformSelf: [DomMatrix, [core.num], [core.num, core.num, core.num, core.num, core.num]],
      scaleSelf: [DomMatrix, [core.num], [core.num, core.num]],
      translateSelf: [DomMatrix, [core.num, core.num], [core.num]]
    }),
    statics: () => ({
      _create_1: [DomMatrix, []],
      _create_2: [DomMatrix, [dart.dynamic]]
    }),
    names: ['_create_1', '_create_2']
  });
  DomMatrix[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMMatrix')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMMatrix"))];
  class DomParser extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return DomParser._create_1();
    }
    static _create_1() {
      return dart.as(new DOMParser(), DomParser);
    }
  }
  dart.setSignature(DomParser, {
    constructors: () => ({
      _: [DomParser, []],
      new: [DomParser, []]
    }),
    methods: () => ({parseFromString: [Document, [core.String, core.String]]}),
    statics: () => ({_create_1: [DomParser, []]}),
    names: ['_create_1']
  });
  DomParser[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMParser')), dart.const(new _js_helper.Native("DOMParser"))];
  class DomPointReadOnly extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(x, y, z, w) {
      return DomPointReadOnly._create_1(x, y, z, w);
    }
    static _create_1(x, y, z, w) {
      return dart.as(new DOMPointReadOnly(x, y, z, w), DomPointReadOnly);
    }
  }
  dart.setSignature(DomPointReadOnly, {
    constructors: () => ({
      _: [DomPointReadOnly, []],
      new: [DomPointReadOnly, [core.num, core.num, core.num, core.num]]
    }),
    statics: () => ({_create_1: [DomPointReadOnly, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]}),
    names: ['_create_1']
  });
  DomPointReadOnly[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMPointReadOnly')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMPointReadOnly"))];
  class DomPoint extends DomPointReadOnly {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(point_OR_x, y, z, w) {
      if (point_OR_x === void 0)
        point_OR_x = null;
      if (y === void 0)
        y = null;
      if (z === void 0)
        z = null;
      if (w === void 0)
        w = null;
      if (point_OR_x == null && y == null && z == null && w == null) {
        return DomPoint._create_1();
      }
      if ((dart.is(point_OR_x, core.Map) || point_OR_x == null) && y == null && z == null && w == null) {
        let point_1 = html_common.convertDartToNative_Dictionary(dart.as(point_OR_x, core.Map));
        return DomPoint._create_2(point_1);
      }
      if ((typeof y == 'number' || y == null) && (typeof point_OR_x == 'number' || point_OR_x == null) && z == null && w == null) {
        return DomPoint._create_3(point_OR_x, y);
      }
      if ((typeof z == 'number' || z == null) && (typeof y == 'number' || y == null) && (typeof point_OR_x == 'number' || point_OR_x == null) && w == null) {
        return DomPoint._create_4(point_OR_x, y, z);
      }
      if ((typeof w == 'number' || w == null) && (typeof z == 'number' || z == null) && (typeof y == 'number' || y == null) && (typeof point_OR_x == 'number' || point_OR_x == null)) {
        return DomPoint._create_5(point_OR_x, y, z, w);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1() {
      return dart.as(new DOMPoint(), DomPoint);
    }
    static _create_2(point_OR_x) {
      return dart.as(new DOMPoint(point_OR_x), DomPoint);
    }
    static _create_3(point_OR_x, y) {
      return dart.as(new DOMPoint(point_OR_x, y), DomPoint);
    }
    static _create_4(point_OR_x, y, z) {
      return dart.as(new DOMPoint(point_OR_x, y, z), DomPoint);
    }
    static _create_5(point_OR_x, y, z, w) {
      return dart.as(new DOMPoint(point_OR_x, y, z, w), DomPoint);
    }
    static get supported() {
      return dart.as(!!window.DOMPoint || !!window.WebKitPoint, core.bool);
    }
    get w() {
      return dart.as(this.w, core.num);
    }
    set w(value) {
      this.w = value;
    }
    get x() {
      return dart.as(this.x, core.num);
    }
    set x(value) {
      this.x = value;
    }
    get y() {
      return dart.as(this.y, core.num);
    }
    set y(value) {
      this.y = value;
    }
    get z() {
      return dart.as(this.z, core.num);
    }
    set z(value) {
      this.z = value;
    }
  }
  dart.setSignature(DomPoint, {
    constructors: () => ({
      _: [DomPoint, []],
      new: [DomPoint, [], [dart.dynamic, core.num, core.num, core.num]]
    }),
    statics: () => ({
      _create_1: [DomPoint, []],
      _create_2: [DomPoint, [dart.dynamic]],
      _create_3: [DomPoint, [dart.dynamic, dart.dynamic]],
      _create_4: [DomPoint, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_5: [DomPoint, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3', '_create_4', '_create_5']
  });
  DomPoint[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMPoint')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMPoint"))];
  class DomRectReadOnly extends _interceptors.Interceptor {
    toString() {
      return `Rectangle (${this.left}, ${this.top}) ${this.width} x ${this.height}`;
    }
    ['=='](other) {
      if (!dart.is(other, math.Rectangle))
        return false;
      return dart.equals(this.left, dart.dload(other, 'left')) && dart.equals(this.top, dart.dload(other, 'top')) && dart.equals(this.width, dart.dload(other, 'width')) && dart.equals(this.height, dart.dload(other, 'height'));
    }
    get hashCode() {
      return _JenkinsSmiHash.hash4(dart.hashCode(this.left), dart.hashCode(this.top), dart.hashCode(this.width), dart.hashCode(this.height));
    }
    intersection(other) {
      let x0 = math.max(this.left, dart.as(other.left, core.num));
      let x1 = math.min(dart.notNull(this.left) + dart.notNull(this.width), dart.as(dart.dsend(other.left, '+', other.width), core.num));
      if (dart.notNull(dart.as(dart.dsend(x0, '<=', x1), core.bool))) {
        let y0 = math.max(this.top, dart.as(other.top, core.num));
        let y1 = math.min(dart.notNull(this.top) + dart.notNull(this.height), dart.as(dart.dsend(other.top, '+', other.height), core.num));
        if (dart.notNull(dart.as(dart.dsend(y0, '<=', y1), core.bool))) {
          return new math.Rectangle(x0, y0, dart.dsend(x1, '-', x0), dart.dsend(y1, '-', y0));
        }
      }
      return null;
    }
    intersects(other) {
      return dart.notNull(this.left) <= dart.notNull(other.left) + dart.notNull(other.width) && dart.notNull(other.left) <= dart.notNull(this.left) + dart.notNull(this.width) && dart.notNull(this.top) <= dart.notNull(other.top) + dart.notNull(other.height) && dart.notNull(other.top) <= dart.notNull(this.top) + dart.notNull(this.height);
    }
    boundingBox(other) {
      let right = math.max(dart.notNull(this.left) + dart.notNull(this.width), dart.as(dart.dsend(other.left, '+', other.width), core.num));
      let bottom = math.max(dart.notNull(this.top) + dart.notNull(this.height), dart.as(dart.dsend(other.top, '+', other.height), core.num));
      let left = math.min(this.left, dart.as(other.left, core.num));
      let top = math.min(this.top, dart.as(other.top, core.num));
      return new math.Rectangle(left, top, dart.dsend(right, '-', left), dart.dsend(bottom, '-', top));
    }
    containsRectangle(another) {
      return dart.notNull(this.left) <= dart.notNull(another.left) && dart.notNull(this.left) + dart.notNull(this.width) >= dart.notNull(another.left) + dart.notNull(another.width) && dart.notNull(this.top) <= dart.notNull(another.top) && dart.notNull(this.top) + dart.notNull(this.height) >= dart.notNull(another.top) + dart.notNull(another.height);
    }
    containsPoint(another) {
      return dart.notNull(another.x) >= dart.notNull(this.left) && dart.notNull(another.x) <= dart.notNull(this.left) + dart.notNull(this.width) && dart.notNull(another.y) >= dart.notNull(this.top) && dart.notNull(another.y) <= dart.notNull(this.top) + dart.notNull(this.height);
    }
    get topLeft() {
      return new math.Point(this.left, this.top);
    }
    get topRight() {
      return new math.Point(dart.notNull(this.left) + dart.notNull(this.width), this.top);
    }
    get bottomRight() {
      return new math.Point(dart.notNull(this.left) + dart.notNull(this.width), dart.notNull(this.top) + dart.notNull(this.height));
    }
    get bottomLeft() {
      return new math.Point(this.left, dart.notNull(this.top) + dart.notNull(this.height));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(x, y, width, height) {
      return DomRectReadOnly._create_1(x, y, width, height);
    }
    static _create_1(x, y, width, height) {
      return dart.as(new DOMRectReadOnly(x, y, width, height), DomRectReadOnly);
    }
  }
  DomRectReadOnly[dart.implements] = () => [math.Rectangle];
  dart.setSignature(DomRectReadOnly, {
    constructors: () => ({
      _: [DomRectReadOnly, []],
      new: [DomRectReadOnly, [core.num, core.num, core.num, core.num]]
    }),
    methods: () => ({
      intersection: [math.Rectangle, [math.Rectangle]],
      intersects: [core.bool, [math.Rectangle$(core.num)]],
      boundingBox: [math.Rectangle, [math.Rectangle]],
      containsRectangle: [core.bool, [math.Rectangle$(core.num)]],
      containsPoint: [core.bool, [math.Point$(core.num)]]
    }),
    statics: () => ({_create_1: [DomRectReadOnly, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]}),
    names: ['_create_1']
  });
  dart.defineExtensionMembers(DomRectReadOnly, ['toString', '==', 'hashCode']);
  DomRectReadOnly[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMRectReadOnly')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMRectReadOnly"))];
  class DomTokenList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DomTokenList, {
    constructors: () => ({_: [DomTokenList, []]}),
    methods: () => ({
      add: [dart.void, [core.String]],
      contains: [core.bool, [core.String]],
      item: [core.String, [core.int]],
      remove: [dart.void, [core.String]],
      toggle: [core.bool, [core.String], [core.bool]]
    })
  });
  DomTokenList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMTokenList')), dart.const(new _js_helper.Native("DOMTokenList"))];
  class DomSettableTokenList extends DomTokenList {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DomSettableTokenList, {
    constructors: () => ({_: [DomSettableTokenList, []]}),
    methods: () => ({[__getter__]: [core.String, [core.int]]})
  });
  DomSettableTokenList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMSettableTokenList')), dart.const(new _js_helper.Native("DOMSettableTokenList"))];
  let ImmutableListMixin$ = dart.generic(function(E) {
    class ImmutableListMixin extends core.Object {
      get iterator() {
        return new (FixedSizeListIterator$(E))(this);
      }
      [Symbol.iterator]() {
        return new dart.JsIterator(this.iterator);
      }
      add(value) {
        dart.as(value, E);
        dart.throw(new core.UnsupportedError("Cannot add to immutable List."));
      }
      addAll(iterable) {
        dart.as(iterable, core.Iterable$(E));
        dart.throw(new core.UnsupportedError("Cannot add to immutable List."));
      }
      sort(compare) {
        if (compare === void 0)
          compare = null;
        dart.as(compare, dart.functionType(core.int, [E, E]));
        dart.throw(new core.UnsupportedError("Cannot sort immutable List."));
      }
      shuffle(random) {
        if (random === void 0)
          random = null;
        dart.throw(new core.UnsupportedError("Cannot shuffle immutable List."));
      }
      insert(index, element) {
        dart.as(element, E);
        dart.throw(new core.UnsupportedError("Cannot add to immutable List."));
      }
      insertAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        dart.throw(new core.UnsupportedError("Cannot add to immutable List."));
      }
      setAll(index, iterable) {
        dart.as(iterable, core.Iterable$(E));
        dart.throw(new core.UnsupportedError("Cannot modify an immutable List."));
      }
      removeAt(pos) {
        dart.throw(new core.UnsupportedError("Cannot remove from immutable List."));
      }
      removeLast() {
        dart.throw(new core.UnsupportedError("Cannot remove from immutable List."));
      }
      remove(object) {
        dart.throw(new core.UnsupportedError("Cannot remove from immutable List."));
      }
      removeWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        dart.throw(new core.UnsupportedError("Cannot remove from immutable List."));
      }
      retainWhere(test) {
        dart.as(test, dart.functionType(core.bool, [E]));
        dart.throw(new core.UnsupportedError("Cannot remove from immutable List."));
      }
      setRange(start, end, iterable, skipCount) {
        dart.as(iterable, core.Iterable$(E));
        if (skipCount === void 0)
          skipCount = 0;
        dart.throw(new core.UnsupportedError("Cannot setRange on immutable List."));
      }
      removeRange(start, end) {
        dart.throw(new core.UnsupportedError("Cannot removeRange on immutable List."));
      }
      replaceRange(start, end, iterable) {
        dart.as(iterable, core.Iterable$(E));
        dart.throw(new core.UnsupportedError("Cannot modify an immutable List."));
      }
      fillRange(start, end, fillValue) {
        if (fillValue === void 0)
          fillValue = null;
        dart.as(fillValue, E);
        dart.throw(new core.UnsupportedError("Cannot modify an immutable List."));
      }
    }
    ImmutableListMixin[dart.implements] = () => [core.List$(E)];
    dart.setSignature(ImmutableListMixin, {
      methods: () => ({
        add: [dart.void, [E]],
        addAll: [dart.void, [core.Iterable$(E)]],
        sort: [dart.void, [], [dart.functionType(core.int, [E, E])]],
        shuffle: [dart.void, [], [math.Random]],
        insert: [dart.void, [core.int, E]],
        insertAll: [dart.void, [core.int, core.Iterable$(E)]],
        setAll: [dart.void, [core.int, core.Iterable$(E)]],
        removeAt: [E, [core.int]],
        removeLast: [E, []],
        remove: [core.bool, [core.Object]],
        removeWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        retainWhere: [dart.void, [dart.functionType(core.bool, [E])]],
        setRange: [dart.void, [core.int, core.int, core.Iterable$(E)], [core.int]],
        removeRange: [dart.void, [core.int, core.int]],
        replaceRange: [dart.void, [core.int, core.int, core.Iterable$(E)]],
        fillRange: [dart.void, [core.int, core.int], [E]]
      })
    });
    dart.defineExtensionMembers(ImmutableListMixin, [
      'add',
      'addAll',
      'sort',
      'shuffle',
      'insert',
      'insertAll',
      'setAll',
      'removeAt',
      'removeLast',
      'remove',
      'removeWhere',
      'retainWhere',
      'setRange',
      'removeRange',
      'replaceRange',
      'fillRange',
      'iterator'
    ]);
    return ImmutableListMixin;
  });
  let ImmutableListMixin = ImmutableListMixin$();
  class DomStringList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(core.String), ImmutableListMixin$(core.String)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], core.String);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], core.String);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], core.String);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], core.String);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  DomStringList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(core.String)];
  dart.setSignature(DomStringList, {
    constructors: () => ({_: [DomStringList, []]}),
    methods: () => ({
      get: [core.String, [core.int]],
      set: [dart.void, [core.int, core.String]],
      elementAt: [core.String, [core.int]],
      contains: [core.bool, [core.String]],
      item: [core.String, [core.int]]
    })
  });
  dart.defineExtensionMembers(DomStringList, [
    'get',
    'set',
    'elementAt',
    'contains',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  DomStringList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMStringList')), dart.const(new _js_helper.Native("DOMStringList"))];
  class DomStringMap extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(DomStringMap, {
    constructors: () => ({_: [DomStringMap, []]})
  });
  DomStringMap[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMStringMap'))];
  let _childElements = Symbol('_childElements');
  let _element = Symbol('_element');
  let _filter = Symbol('_filter');
  class _ChildrenElementList extends collection.ListBase$(Element) {
    _wrap(element) {
      this[_childElements] = dart.as(element[_children], HtmlCollection);
      this[_element] = element;
    }
    contains(element) {
      return this[_childElements].contains(element);
    }
    get isEmpty() {
      return this[_element][_firstElementChild] == null;
    }
    get length() {
      return this[_childElements].length;
    }
    get(index) {
      return dart.as(this[_childElements].get(index), Element);
    }
    set(index, value) {
      this[_element][_replaceChild](value, this[_childElements].get(index));
      return value;
    }
    set length(newLength) {
      dart.throw(new core.UnsupportedError('Cannot resize element lists'));
    }
    add(value) {
      this[_element].append(value);
      return value;
    }
    get iterator() {
      return this.toList()[dartx.iterator];
    }
    addAll(iterable) {
      if (dart.is(iterable, _ChildNodeListLazy)) {
        iterable = core.List$(Element).from(iterable);
      }
      for (let element of iterable) {
        this[_element].append(element);
      }
    }
    sort(compare) {
      if (compare === void 0)
        compare = null;
      dart.throw(new core.UnsupportedError('Cannot sort element lists'));
    }
    shuffle(random) {
      if (random === void 0)
        random = null;
      dart.throw(new core.UnsupportedError('Cannot shuffle element lists'));
    }
    removeWhere(test) {
      this[_filter](test, false);
    }
    retainWhere(test) {
      this[_filter](test, true);
    }
    [_filter](test, retainMatching) {
      let removed = null;
      if (dart.notNull(retainMatching)) {
        removed = this[_element].children[dartx.where](dart.fn(e => !dart.notNull(dart.dcall(test, e)), core.bool, [dart.dynamic]));
      } else {
        removed = this[_element].children[dartx.where](dart.as(test, __CastType0));
      }
      for (let e of dart.as(removed, core.Iterable))
        dart.dsend(e, 'remove');
    }
    setRange(start, end, iterable, skipCount) {
      if (skipCount === void 0)
        skipCount = 0;
      dart.throw(new core.UnimplementedError());
    }
    replaceRange(start, end, iterable) {
      dart.throw(new core.UnimplementedError());
    }
    fillRange(start, end, fillValue) {
      if (fillValue === void 0)
        fillValue = null;
      dart.throw(new core.UnimplementedError());
    }
    remove(object) {
      if (dart.is(object, Element)) {
        let element = object;
        if (dart.notNull(core.identical(element.parentNode, this[_element]))) {
          this[_element][_removeChild](element);
          return true;
        }
      }
      return false;
    }
    insert(index, element) {
      if (dart.notNull(index) < 0 || dart.notNull(index) > dart.notNull(this.length)) {
        dart.throw(new core.RangeError.range(index, 0, this.length));
      }
      if (index == this.length) {
        this[_element].append(element);
      } else {
        this[_element].insertBefore(element, this.get(index));
      }
    }
    setAll(index, iterable) {
      dart.throw(new core.UnimplementedError());
    }
    clear() {
      this[_element][_clearChildren]();
    }
    removeAt(index) {
      let result = this.get(index);
      if (result != null) {
        this[_element][_removeChild](dart.as(result, Node));
      }
      return dart.as(result, Element);
    }
    removeLast() {
      let result = this.last;
      if (result != null) {
        this[_element][_removeChild](dart.as(result, Node));
      }
      return dart.as(result, Element);
    }
    get first() {
      let result = this[_element][_firstElementChild];
      if (result == null)
        dart.throw(new core.StateError("No elements"));
      return result;
    }
    get last() {
      let result = this[_element][_lastElementChild];
      if (result == null)
        dart.throw(new core.StateError("No elements"));
      return result;
    }
    get single() {
      if (dart.notNull(this.length) > 1)
        dart.throw(new core.StateError("More than one element"));
      return this.first;
    }
    get rawList() {
      return this[_childElements];
    }
  }
  _ChildrenElementList[dart.implements] = () => [html_common.NodeListWrapper];
  dart.defineNamedConstructor(_ChildrenElementList, '_wrap');
  dart.setSignature(_ChildrenElementList, {
    constructors: () => ({_wrap: [_ChildrenElementList, [Element]]}),
    methods: () => ({
      get: [Element, [core.int]],
      set: [dart.void, [core.int, Element]],
      add: [Element, [Element]],
      addAll: [dart.void, [core.Iterable$(Element)]],
      sort: [dart.void, [], [dart.functionType(core.int, [Element, Element])]],
      removeWhere: [dart.void, [dart.functionType(core.bool, [Element])]],
      retainWhere: [dart.void, [dart.functionType(core.bool, [Element])]],
      [_filter]: [dart.void, [dart.functionType(core.bool, [dart.dynamic]), core.bool]],
      setRange: [dart.void, [core.int, core.int, core.Iterable$(Element)], [core.int]],
      replaceRange: [dart.void, [core.int, core.int, core.Iterable$(Element)]],
      fillRange: [dart.void, [core.int, core.int], [Element]],
      insert: [dart.void, [core.int, Element]],
      setAll: [dart.void, [core.int, core.Iterable$(Element)]],
      removeAt: [Element, [core.int]],
      removeLast: [Element, []]
    })
  });
  dart.defineExtensionMembers(_ChildrenElementList, [
    'contains',
    'get',
    'set',
    'add',
    'addAll',
    'sort',
    'shuffle',
    'removeWhere',
    'retainWhere',
    'setRange',
    'replaceRange',
    'fillRange',
    'remove',
    'insert',
    'setAll',
    'clear',
    'removeAt',
    'removeLast',
    'isEmpty',
    'length',
    'length',
    'iterator',
    'first',
    'last',
    'single'
  ]);
  let ElementList$ = dart.generic(function(T) {
    class ElementList extends collection.ListBase$(T) {}
    return ElementList;
  });
  let ElementList = ElementList$();
  let _nodeList = Symbol('_nodeList');
  class _FrozenElementList extends collection.ListBase {
    _wrap(nodeList) {
      this[_nodeList] = nodeList;
    }
    get length() {
      return this[_nodeList][dartx.length];
    }
    get(index) {
      return dart.as(this[_nodeList][dartx.get](index), Element);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError('Cannot modify list'));
      return value;
    }
    set length(newLength) {
      dart.throw(new core.UnsupportedError('Cannot modify list'));
    }
    sort(compare) {
      if (compare === void 0)
        compare = null;
      dart.throw(new core.UnsupportedError('Cannot sort list'));
    }
    shuffle(random) {
      if (random === void 0)
        random = null;
      dart.throw(new core.UnsupportedError('Cannot shuffle list'));
    }
    get first() {
      return dart.as(this[_nodeList][dartx.first], Element);
    }
    get last() {
      return dart.as(this[_nodeList][dartx.last], Element);
    }
    get single() {
      return dart.as(this[_nodeList][dartx.single], Element);
    }
    get classes() {
      return exports._MultiElementCssClassSet.new(dart.as(this, core.Iterable$(Element)));
    }
    get style() {
      return new _CssStyleDeclarationSet(dart.as(this, core.Iterable$(Element)));
    }
    set classes(value) {
      this[_nodeList][dartx.forEach](dart.fn(e => dart.dput(e, 'classes', value), core.Iterable$(core.String), [dart.dynamic]));
    }
    get contentEdge() {
      return new _ContentCssListRect(this);
    }
    get paddingEdge() {
      return this.first.paddingEdge;
    }
    get borderEdge() {
      return this.first.borderEdge;
    }
    get marginEdge() {
      return this.first.marginEdge;
    }
    get rawList() {
      return this[_nodeList];
    }
    get onAbort() {
      return Element.abortEvent[_forElementList](this);
    }
    get onBeforeCopy() {
      return Element.beforeCopyEvent[_forElementList](this);
    }
    get onBeforeCut() {
      return Element.beforeCutEvent[_forElementList](this);
    }
    get onBeforePaste() {
      return Element.beforePasteEvent[_forElementList](this);
    }
    get onBlur() {
      return Element.blurEvent[_forElementList](this);
    }
    get onCanPlay() {
      return Element.canPlayEvent[_forElementList](this);
    }
    get onCanPlayThrough() {
      return Element.canPlayThroughEvent[_forElementList](this);
    }
    get onChange() {
      return Element.changeEvent[_forElementList](this);
    }
    get onClick() {
      return Element.clickEvent[_forElementList](this);
    }
    get onContextMenu() {
      return Element.contextMenuEvent[_forElementList](this);
    }
    get onCopy() {
      return Element.copyEvent[_forElementList](this);
    }
    get onCut() {
      return Element.cutEvent[_forElementList](this);
    }
    get onDoubleClick() {
      return Element.doubleClickEvent[_forElementList](this);
    }
    get onDrag() {
      return Element.dragEvent[_forElementList](this);
    }
    get onDragEnd() {
      return Element.dragEndEvent[_forElementList](this);
    }
    get onDragEnter() {
      return Element.dragEnterEvent[_forElementList](this);
    }
    get onDragLeave() {
      return Element.dragLeaveEvent[_forElementList](this);
    }
    get onDragOver() {
      return Element.dragOverEvent[_forElementList](this);
    }
    get onDragStart() {
      return Element.dragStartEvent[_forElementList](this);
    }
    get onDrop() {
      return Element.dropEvent[_forElementList](this);
    }
    get onDurationChange() {
      return Element.durationChangeEvent[_forElementList](this);
    }
    get onEmptied() {
      return Element.emptiedEvent[_forElementList](this);
    }
    get onEnded() {
      return Element.endedEvent[_forElementList](this);
    }
    get onError() {
      return Element.errorEvent[_forElementList](this);
    }
    get onFocus() {
      return Element.focusEvent[_forElementList](this);
    }
    get onInput() {
      return Element.inputEvent[_forElementList](this);
    }
    get onInvalid() {
      return Element.invalidEvent[_forElementList](this);
    }
    get onKeyDown() {
      return Element.keyDownEvent[_forElementList](this);
    }
    get onKeyPress() {
      return Element.keyPressEvent[_forElementList](this);
    }
    get onKeyUp() {
      return Element.keyUpEvent[_forElementList](this);
    }
    get onLoad() {
      return Element.loadEvent[_forElementList](this);
    }
    get onLoadedData() {
      return Element.loadedDataEvent[_forElementList](this);
    }
    get onLoadedMetadata() {
      return Element.loadedMetadataEvent[_forElementList](this);
    }
    get onMouseDown() {
      return Element.mouseDownEvent[_forElementList](this);
    }
    get onMouseEnter() {
      return Element.mouseEnterEvent[_forElementList](this);
    }
    get onMouseLeave() {
      return Element.mouseLeaveEvent[_forElementList](this);
    }
    get onMouseMove() {
      return Element.mouseMoveEvent[_forElementList](this);
    }
    get onMouseOut() {
      return Element.mouseOutEvent[_forElementList](this);
    }
    get onMouseOver() {
      return Element.mouseOverEvent[_forElementList](this);
    }
    get onMouseUp() {
      return Element.mouseUpEvent[_forElementList](this);
    }
    get onMouseWheel() {
      return Element.mouseWheelEvent[_forElementList](this);
    }
    get onPaste() {
      return Element.pasteEvent[_forElementList](this);
    }
    get onPause() {
      return Element.pauseEvent[_forElementList](this);
    }
    get onPlay() {
      return Element.playEvent[_forElementList](this);
    }
    get onPlaying() {
      return Element.playingEvent[_forElementList](this);
    }
    get onRateChange() {
      return Element.rateChangeEvent[_forElementList](this);
    }
    get onReset() {
      return Element.resetEvent[_forElementList](this);
    }
    get onResize() {
      return Element.resizeEvent[_forElementList](this);
    }
    get onScroll() {
      return Element.scrollEvent[_forElementList](this);
    }
    get onSearch() {
      return Element.searchEvent[_forElementList](this);
    }
    get onSeeked() {
      return Element.seekedEvent[_forElementList](this);
    }
    get onSeeking() {
      return Element.seekingEvent[_forElementList](this);
    }
    get onSelect() {
      return Element.selectEvent[_forElementList](this);
    }
    get onSelectStart() {
      return Element.selectStartEvent[_forElementList](this);
    }
    get onStalled() {
      return Element.stalledEvent[_forElementList](this);
    }
    get onSubmit() {
      return Element.submitEvent[_forElementList](this);
    }
    get onSuspend() {
      return Element.suspendEvent[_forElementList](this);
    }
    get onTimeUpdate() {
      return Element.timeUpdateEvent[_forElementList](this);
    }
    get onTouchCancel() {
      return Element.touchCancelEvent[_forElementList](this);
    }
    get onTouchEnd() {
      return Element.touchEndEvent[_forElementList](this);
    }
    get onTouchEnter() {
      return Element.touchEnterEvent[_forElementList](this);
    }
    get onTouchLeave() {
      return Element.touchLeaveEvent[_forElementList](this);
    }
    get onTouchMove() {
      return Element.touchMoveEvent[_forElementList](this);
    }
    get onTouchStart() {
      return Element.touchStartEvent[_forElementList](this);
    }
    get onTransitionEnd() {
      return Element.transitionEndEvent[_forElementList](this);
    }
    get onVolumeChange() {
      return Element.volumeChangeEvent[_forElementList](this);
    }
    get onWaiting() {
      return Element.waitingEvent[_forElementList](this);
    }
    get onFullscreenChange() {
      return Element.fullscreenChangeEvent[_forElementList](this);
    }
    get onFullscreenError() {
      return Element.fullscreenErrorEvent[_forElementList](this);
    }
  }
  _FrozenElementList[dart.implements] = () => [ElementList, html_common.NodeListWrapper];
  dart.defineNamedConstructor(_FrozenElementList, '_wrap');
  dart.setSignature(_FrozenElementList, {
    constructors: () => ({_wrap: [_FrozenElementList, [core.List$(Node)]]}),
    methods: () => ({
      get: [Element, [core.int]],
      set: [dart.void, [core.int, Element]],
      sort: [dart.void, [], [core.Comparator$(Element)]]
    })
  });
  dart.defineExtensionMembers(_FrozenElementList, [
    'get',
    'set',
    'sort',
    'shuffle',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  let _eventTypeGetter = Symbol('_eventTypeGetter');
  let _CustomEventStreamProvider$ = dart.generic(function(T) {
    class _CustomEventStreamProvider extends core.Object {
      _CustomEventStreamProvider(eventTypeGetter) {
        this[_eventTypeGetter] = eventTypeGetter;
      }
      forTarget(e, opts) {
        let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
        return new (_EventStream$(T))(e, dart.as(this[_eventTypeGetter](e), core.String), useCapture);
      }
      forElement(e, opts) {
        let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
        return new (_ElementEventStreamImpl$(T))(e, this[_eventTypeGetter](e), useCapture);
      }
      [_forElementList](e, opts) {
        let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
        return new _ElementListEventStreamImpl(dart.as(e, core.Iterable$(Element)), dart.as(this[_eventTypeGetter](e), core.String), useCapture);
      }
      getEventType(target) {
        return dart.as(this[_eventTypeGetter](target), core.String);
      }
      get [_eventType]() {
        return dart.throw(new core.UnsupportedError('Access type through getEventType method.'));
      }
    }
    _CustomEventStreamProvider[dart.implements] = () => [EventStreamProvider$(T)];
    dart.setSignature(_CustomEventStreamProvider, {
      constructors: () => ({_CustomEventStreamProvider: [_CustomEventStreamProvider$(T), [dart.dynamic]]}),
      methods: () => ({
        forTarget: [async.Stream$(T), [EventTarget], {useCapture: core.bool}],
        forElement: [ElementStream$(T), [Element], {useCapture: core.bool}],
        [_forElementList]: [ElementStream$(T), [ElementList], {useCapture: core.bool}],
        getEventType: [core.String, [EventTarget]]
      })
    });
    return _CustomEventStreamProvider;
  });
  let _CustomEventStreamProvider = _CustomEventStreamProvider$();
  let _initMouseEvent = Symbol('_initMouseEvent');
  let _get_relatedTarget = Symbol('_get_relatedTarget');
  let _initMouseEvent_1 = Symbol('_initMouseEvent_1');
  let _clientX = Symbol('_clientX');
  let _clientY = Symbol('_clientY');
  let _webkitMovementX = Symbol('_webkitMovementX');
  let _webkitMovementY = Symbol('_webkitMovementY');
  let _screenX = Symbol('_screenX');
  let _screenY = Symbol('_screenY');
  class MouseEvent extends UIEvent {
    static new(type, opts) {
      let view = opts && 'view' in opts ? opts.view : null;
      let detail = opts && 'detail' in opts ? opts.detail : 0;
      let screenX = opts && 'screenX' in opts ? opts.screenX : 0;
      let screenY = opts && 'screenY' in opts ? opts.screenY : 0;
      let clientX = opts && 'clientX' in opts ? opts.clientX : 0;
      let clientY = opts && 'clientY' in opts ? opts.clientY : 0;
      let button = opts && 'button' in opts ? opts.button : 0;
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let ctrlKey = opts && 'ctrlKey' in opts ? opts.ctrlKey : false;
      let altKey = opts && 'altKey' in opts ? opts.altKey : false;
      let shiftKey = opts && 'shiftKey' in opts ? opts.shiftKey : false;
      let metaKey = opts && 'metaKey' in opts ? opts.metaKey : false;
      let relatedTarget = opts && 'relatedTarget' in opts ? opts.relatedTarget : null;
      if (view == null) {
        view = exports.window;
      }
      let event = exports.document[_createEvent]('MouseEvent');
      dart.dsend(event, _initMouseEvent, type, canBubble, cancelable, view, detail, screenX, screenY, clientX, clientY, ctrlKey, altKey, shiftKey, metaKey, button, relatedTarget);
      return dart.as(event, MouseEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get relatedTarget() {
      return _convertNativeToDart_EventTarget(this[_get_relatedTarget]);
    }
    [_initMouseEvent](type, canBubble, cancelable, view, detail, screenX, screenY, clientX, clientY, ctrlKey, altKey, shiftKey, metaKey, button, relatedTarget) {
      let relatedTarget_1 = _convertDartToNative_EventTarget(relatedTarget);
      this[_initMouseEvent_1](type, canBubble, cancelable, view, detail, screenX, screenY, clientX, clientY, ctrlKey, altKey, shiftKey, metaKey, button, relatedTarget_1);
      return;
    }
    get client() {
      return new math.Point(this[_clientX], this[_clientY]);
    }
    get movement() {
      return new math.Point(this[_webkitMovementX], this[_webkitMovementY]);
    }
    get offset() {
      if (dart.notNull(dart.as(!!this.offsetX, core.bool))) {
        let x = this.offsetX;
        let y = this.offsetY;
        return new math.Point(x, y);
      } else {
        if (!dart.is(this.target, Element)) {
          dart.throw(new core.UnsupportedError('offsetX is only supported on elements'));
        }
        let target = dart.as(this.target, Element);
        let point = this.client['-'](target.getBoundingClientRect().topLeft);
        return new math.Point(dart.dsend(dart.dload(point, 'x'), 'toInt'), dart.dsend(dart.dload(point, 'y'), 'toInt'));
      }
    }
    get screen() {
      return new math.Point(this[_screenX], this[_screenY]);
    }
  }
  dart.setSignature(MouseEvent, {
    constructors: () => ({
      new: [MouseEvent, [core.String], {view: Window, detail: core.int, screenX: core.int, screenY: core.int, clientX: core.int, clientY: core.int, button: core.int, canBubble: core.bool, cancelable: core.bool, ctrlKey: core.bool, altKey: core.bool, shiftKey: core.bool, metaKey: core.bool, relatedTarget: EventTarget}],
      _: [MouseEvent, []]
    }),
    methods: () => ({
      [_initMouseEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.int, core.int, core.int, core.int, core.int, core.bool, core.bool, core.bool, core.bool, core.int, EventTarget]],
      [_initMouseEvent_1]: [dart.void, [dart.dynamic, dart.dynamic, dart.dynamic, Window, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]
    })
  });
  MouseEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('MouseEvent')), dart.const(new _js_helper.Native("MouseEvent,DragEvent,PointerEvent,MSPointerEvent"))];
  let _deltaY = Symbol('_deltaY');
  let _deltaX = Symbol('_deltaX');
  let _wheelDelta = Symbol('_wheelDelta');
  let _wheelDeltaX = Symbol('_wheelDeltaX');
  let _hasInitMouseScrollEvent = Symbol('_hasInitMouseScrollEvent');
  let _hasInitWheelEvent = Symbol('_hasInitWheelEvent');
  let _initMouseScrollEvent = Symbol('_initMouseScrollEvent');
  let _initWheelEvent = Symbol('_initWheelEvent');
  class WheelEvent extends MouseEvent {
    static new(type, opts) {
      let view = opts && 'view' in opts ? opts.view : null;
      let deltaX = opts && 'deltaX' in opts ? opts.deltaX : 0;
      let deltaY = opts && 'deltaY' in opts ? opts.deltaY : 0;
      let deltaZ = opts && 'deltaZ' in opts ? opts.deltaZ : 0;
      let deltaMode = opts && 'deltaMode' in opts ? opts.deltaMode : 0;
      let detail = opts && 'detail' in opts ? opts.detail : 0;
      let screenX = opts && 'screenX' in opts ? opts.screenX : 0;
      let screenY = opts && 'screenY' in opts ? opts.screenY : 0;
      let clientX = opts && 'clientX' in opts ? opts.clientX : 0;
      let clientY = opts && 'clientY' in opts ? opts.clientY : 0;
      let button = opts && 'button' in opts ? opts.button : 0;
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let ctrlKey = opts && 'ctrlKey' in opts ? opts.ctrlKey : false;
      let altKey = opts && 'altKey' in opts ? opts.altKey : false;
      let shiftKey = opts && 'shiftKey' in opts ? opts.shiftKey : false;
      let metaKey = opts && 'metaKey' in opts ? opts.metaKey : false;
      let relatedTarget = opts && 'relatedTarget' in opts ? opts.relatedTarget : null;
      let options = dart.map({view: view, deltaMode: deltaMode, deltaX: deltaX, deltaY: deltaY, deltaZ: deltaZ, detail: detail, screenX: screenX, screenY: screenY, clientX: clientX, clientY: clientY, button: button, bubbles: canBubble, cancelable: cancelable, ctrlKey: ctrlKey, altKey: altKey, shiftKey: shiftKey, metaKey: metaKey, relatedTarget: relatedTarget});
      if (view == null) {
        view = exports.window;
      }
      return dart.as(new WheelEvent(type, html_common.convertDartToNative_Dictionary(dart.as(options, core.Map))), WheelEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get deltaY() {
      if (dart.notNull(dart.as(this.deltaY !== undefined, core.bool))) {
        return this[_deltaY];
      }
      dart.throw(new core.UnsupportedError('deltaY is not supported'));
    }
    get deltaX() {
      if (dart.notNull(dart.as(this.deltaX !== undefined, core.bool))) {
        return this[_deltaX];
      }
      dart.throw(new core.UnsupportedError('deltaX is not supported'));
    }
    get deltaMode() {
      if (dart.notNull(dart.as(!!this.deltaMode, core.bool))) {
        return dart.as(this.deltaMode, core.int);
      }
      return 0;
    }
    get [_wheelDelta]() {
      return dart.as(this.wheelDelta, core.num);
    }
    get [_wheelDeltaX]() {
      return dart.as(this.wheelDeltaX, core.num);
    }
    get [_detail]() {
      return dart.as(this.detail, core.num);
    }
    get [_hasInitMouseScrollEvent]() {
      return dart.as(!!this.initMouseScrollEvent, core.bool);
    }
    get [_hasInitWheelEvent]() {
      return dart.as(!!this.initWheelEvent, core.bool);
    }
  }
  dart.setSignature(WheelEvent, {
    constructors: () => ({
      new: [WheelEvent, [core.String], {view: Window, deltaX: core.num, deltaY: core.num, deltaZ: core.num, deltaMode: core.int, detail: core.int, screenX: core.int, screenY: core.int, clientX: core.int, clientY: core.int, button: core.int, canBubble: core.bool, cancelable: core.bool, ctrlKey: core.bool, altKey: core.bool, shiftKey: core.bool, metaKey: core.bool, relatedTarget: EventTarget}],
      _: [WheelEvent, []]
    }),
    methods: () => ({
      [_initMouseScrollEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.int, core.int, core.int, core.int, core.int, core.bool, core.bool, core.bool, core.bool, core.int, EventTarget, core.int]],
      [_initWheelEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.int, core.int, core.int, core.int, core.int, core.int, EventTarget, core.String, core.int, core.int, core.int, core.int]]
    })
  });
  WheelEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('WheelEvent')), dart.const(new _js_helper.Native("WheelEvent"))];
  Element.mouseWheelEvent = dart.const(new (_CustomEventStreamProvider$(WheelEvent))(Element._determineMouseWheelEventType));
  class TransitionEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(TransitionEvent, {
    constructors: () => ({_: [TransitionEvent, []]})
  });
  TransitionEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TransitionEvent')), dart.const(new _js_helper.Native("TransitionEvent,WebKitTransitionEvent"))];
  Element.transitionEndEvent = dart.const(new (_CustomEventStreamProvider$(TransitionEvent))(Element._determineTransitionEventType));
  Element._parseDocument = null;
  Element._parseRange = null;
  Element._defaultValidator = null;
  Element._defaultSanitizer = null;
  Element._tagsForWhichCreateContextualFragmentIsNotSupported = dart.const(['HEAD', 'AREA', 'BASE', 'BASEFONT', 'BR', 'COL', 'COLGROUP', 'EMBED', 'FRAME', 'FRAMESET', 'HR', 'IMAGE', 'IMG', 'INPUT', 'ISINDEX', 'LINK', 'META', 'PARAM', 'SOURCE', 'STYLE', 'TITLE', 'WBR']);
  Element.abortEvent = dart.const(new (EventStreamProvider$(Event))('abort'));
  Element.beforeCopyEvent = dart.const(new (EventStreamProvider$(Event))('beforecopy'));
  Element.beforeCutEvent = dart.const(new (EventStreamProvider$(Event))('beforecut'));
  Element.beforePasteEvent = dart.const(new (EventStreamProvider$(Event))('beforepaste'));
  Element.blurEvent = dart.const(new (EventStreamProvider$(Event))('blur'));
  Element.canPlayEvent = dart.const(new (EventStreamProvider$(Event))('canplay'));
  Element.canPlayThroughEvent = dart.const(new (EventStreamProvider$(Event))('canplaythrough'));
  Element.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  Element.clickEvent = dart.const(new (EventStreamProvider$(MouseEvent))('click'));
  Element.contextMenuEvent = dart.const(new (EventStreamProvider$(MouseEvent))('contextmenu'));
  Element.copyEvent = dart.const(new (EventStreamProvider$(Event))('copy'));
  Element.cutEvent = dart.const(new (EventStreamProvider$(Event))('cut'));
  Element.doubleClickEvent = dart.const(new (EventStreamProvider$(Event))('dblclick'));
  Element.dragEvent = dart.const(new (EventStreamProvider$(MouseEvent))('drag'));
  Element.dragEndEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragend'));
  Element.dragEnterEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragenter'));
  Element.dragLeaveEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragleave'));
  Element.dragOverEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragover'));
  Element.dragStartEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragstart'));
  Element.dropEvent = dart.const(new (EventStreamProvider$(MouseEvent))('drop'));
  Element.durationChangeEvent = dart.const(new (EventStreamProvider$(Event))('durationchange'));
  Element.emptiedEvent = dart.const(new (EventStreamProvider$(Event))('emptied'));
  Element.endedEvent = dart.const(new (EventStreamProvider$(Event))('ended'));
  Element.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  Element.focusEvent = dart.const(new (EventStreamProvider$(Event))('focus'));
  Element.inputEvent = dart.const(new (EventStreamProvider$(Event))('input'));
  Element.invalidEvent = dart.const(new (EventStreamProvider$(Event))('invalid'));
  let _initKeyboardEvent = Symbol('_initKeyboardEvent');
  let _keyCode = Symbol('_keyCode');
  let _charCode = Symbol('_charCode');
  class KeyboardEvent extends UIEvent {
    static new(type, opts) {
      let view = opts && 'view' in opts ? opts.view : null;
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let keyLocation = opts && 'keyLocation' in opts ? opts.keyLocation : 1;
      let ctrlKey = opts && 'ctrlKey' in opts ? opts.ctrlKey : false;
      let altKey = opts && 'altKey' in opts ? opts.altKey : false;
      let shiftKey = opts && 'shiftKey' in opts ? opts.shiftKey : false;
      let metaKey = opts && 'metaKey' in opts ? opts.metaKey : false;
      if (view == null) {
        view = exports.window;
      }
      let e = exports.document[_createEvent]("KeyboardEvent");
      dart.dsend(e, _initKeyboardEvent, type, canBubble, cancelable, view, "", keyLocation, ctrlKey, altKey, shiftKey, metaKey);
      return dart.as(e, KeyboardEvent);
    }
    [_initKeyboardEvent](type, canBubble, cancelable, view, keyIdentifier, keyLocation, ctrlKey, altKey, shiftKey, metaKey) {
      if (dart.notNull(dart.as(typeof this.initKeyEvent == "function", core.bool))) {
        this.initKeyEvent(type, canBubble, cancelable, view, ctrlKey, altKey, shiftKey, metaKey, 0, 0);
      } else {
        this.initKeyboardEvent(type, canBubble, cancelable, view, keyIdentifier, keyLocation, ctrlKey, altKey, shiftKey, metaKey);
      }
    }
    get keyCode() {
      return this[_keyCode];
    }
    get charCode() {
      return this[_charCode];
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(KeyboardEvent, {
    constructors: () => ({
      new: [KeyboardEvent, [core.String], {view: Window, canBubble: core.bool, cancelable: core.bool, keyLocation: core.int, ctrlKey: core.bool, altKey: core.bool, shiftKey: core.bool, metaKey: core.bool}],
      _: [KeyboardEvent, []]
    }),
    methods: () => ({
      [_initKeyboardEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.String, core.int, core.bool, core.bool, core.bool, core.bool]],
      getModifierState: [core.bool, [core.String]]
    })
  });
  KeyboardEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('KeyboardEvent')), dart.const(new _js_helper.Native("KeyboardEvent"))];
  Element.keyDownEvent = dart.const(new (EventStreamProvider$(KeyboardEvent))('keydown'));
  Element.keyPressEvent = dart.const(new (EventStreamProvider$(KeyboardEvent))('keypress'));
  Element.keyUpEvent = dart.const(new (EventStreamProvider$(KeyboardEvent))('keyup'));
  Element.loadEvent = dart.const(new (EventStreamProvider$(Event))('load'));
  Element.loadedDataEvent = dart.const(new (EventStreamProvider$(Event))('loadeddata'));
  Element.loadedMetadataEvent = dart.const(new (EventStreamProvider$(Event))('loadedmetadata'));
  Element.mouseDownEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mousedown'));
  Element.mouseEnterEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseenter'));
  Element.mouseLeaveEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseleave'));
  Element.mouseMoveEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mousemove'));
  Element.mouseOutEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseout'));
  Element.mouseOverEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseover'));
  Element.mouseUpEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseup'));
  Element.pasteEvent = dart.const(new (EventStreamProvider$(Event))('paste'));
  Element.pauseEvent = dart.const(new (EventStreamProvider$(Event))('pause'));
  Element.playEvent = dart.const(new (EventStreamProvider$(Event))('play'));
  Element.playingEvent = dart.const(new (EventStreamProvider$(Event))('playing'));
  Element.rateChangeEvent = dart.const(new (EventStreamProvider$(Event))('ratechange'));
  Element.resetEvent = dart.const(new (EventStreamProvider$(Event))('reset'));
  Element.resizeEvent = dart.const(new (EventStreamProvider$(Event))('resize'));
  Element.scrollEvent = dart.const(new (EventStreamProvider$(Event))('scroll'));
  Element.searchEvent = dart.const(new (EventStreamProvider$(Event))('search'));
  Element.seekedEvent = dart.const(new (EventStreamProvider$(Event))('seeked'));
  Element.seekingEvent = dart.const(new (EventStreamProvider$(Event))('seeking'));
  Element.selectEvent = dart.const(new (EventStreamProvider$(Event))('select'));
  Element.selectStartEvent = dart.const(new (EventStreamProvider$(Event))('selectstart'));
  Element.stalledEvent = dart.const(new (EventStreamProvider$(Event))('stalled'));
  Element.submitEvent = dart.const(new (EventStreamProvider$(Event))('submit'));
  Element.suspendEvent = dart.const(new (EventStreamProvider$(Event))('suspend'));
  Element.timeUpdateEvent = dart.const(new (EventStreamProvider$(Event))('timeupdate'));
  let _initTouchEvent = Symbol('_initTouchEvent');
  class TouchEvent extends UIEvent {
    static new(touches, targetTouches, changedTouches, type, opts) {
      let view = opts && 'view' in opts ? opts.view : null;
      let screenX = opts && 'screenX' in opts ? opts.screenX : 0;
      let screenY = opts && 'screenY' in opts ? opts.screenY : 0;
      let clientX = opts && 'clientX' in opts ? opts.clientX : 0;
      let clientY = opts && 'clientY' in opts ? opts.clientY : 0;
      let ctrlKey = opts && 'ctrlKey' in opts ? opts.ctrlKey : false;
      let altKey = opts && 'altKey' in opts ? opts.altKey : false;
      let shiftKey = opts && 'shiftKey' in opts ? opts.shiftKey : false;
      let metaKey = opts && 'metaKey' in opts ? opts.metaKey : false;
      if (view == null) {
        view = exports.window;
      }
      let e = exports.document[_createEvent]("TouchEvent");
      dart.dsend(e, _initTouchEvent, touches, targetTouches, changedTouches, type, view, screenX, screenY, clientX, clientY, ctrlKey, altKey, shiftKey, metaKey);
      return dart.as(e, TouchEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return html_common.Device.isEventTypeSupported('TouchEvent');
    }
  }
  dart.setSignature(TouchEvent, {
    constructors: () => ({
      new: [TouchEvent, [TouchList, TouchList, TouchList, core.String], {view: Window, screenX: core.int, screenY: core.int, clientX: core.int, clientY: core.int, ctrlKey: core.bool, altKey: core.bool, shiftKey: core.bool, metaKey: core.bool}],
      _: [TouchEvent, []]
    }),
    methods: () => ({[_initTouchEvent]: [dart.void, [TouchList, TouchList, TouchList, core.String, Window, core.int, core.int, core.int, core.int, core.bool, core.bool, core.bool, core.bool]]})
  });
  TouchEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('TouchEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("TouchEvent"))];
  Element.touchCancelEvent = dart.const(new (EventStreamProvider$(TouchEvent))('touchcancel'));
  Element.touchEndEvent = dart.const(new (EventStreamProvider$(TouchEvent))('touchend'));
  Element.touchEnterEvent = dart.const(new (EventStreamProvider$(TouchEvent))('touchenter'));
  Element.touchLeaveEvent = dart.const(new (EventStreamProvider$(TouchEvent))('touchleave'));
  Element.touchMoveEvent = dart.const(new (EventStreamProvider$(TouchEvent))('touchmove'));
  Element.touchStartEvent = dart.const(new (EventStreamProvider$(TouchEvent))('touchstart'));
  Element.volumeChangeEvent = dart.const(new (EventStreamProvider$(Event))('volumechange'));
  Element.waitingEvent = dart.const(new (EventStreamProvider$(Event))('waiting'));
  Element.fullscreenChangeEvent = dart.const(new (EventStreamProvider$(Event))('webkitfullscreenchange'));
  Element.fullscreenErrorEvent = dart.const(new (EventStreamProvider$(Event))('webkitfullscreenerror'));
  class _ElementFactoryProvider extends core.Object {
    static createElement_tag(tag, typeExtension) {
      if (typeExtension != null) {
        return document.createElement(tag, typeExtension);
      }
      return document.createElement(tag);
    }
  }
  dart.setSignature(_ElementFactoryProvider, {
    statics: () => ({createElement_tag: [dart.dynamic, [core.String, core.String]]}),
    names: ['createElement_tag']
  });
  let _value = Symbol('_value');
  class ScrollAlignment extends core.Object {
    _internal(value) {
      this[_value] = value;
    }
    toString() {
      return `ScrollAlignment.${this[_value]}`;
    }
  }
  dart.defineNamedConstructor(ScrollAlignment, '_internal');
  dart.setSignature(ScrollAlignment, {
    constructors: () => ({_internal: [ScrollAlignment, [dart.dynamic]]})
  });
  ScrollAlignment.TOP = dart.const(new ScrollAlignment._internal('TOP'));
  ScrollAlignment.CENTER = dart.const(new ScrollAlignment._internal('CENTER'));
  ScrollAlignment.BOTTOM = dart.const(new ScrollAlignment._internal('BOTTOM'));
  class EmbedElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("embed"), EmbedElement);
    }
    created() {
      this.height = null;
      this.integrity = null;
      this.name = null;
      this.src = null;
      this.type = null;
      this.width = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('embed');
    }
  }
  dart.defineNamedConstructor(EmbedElement, 'created');
  dart.setSignature(EmbedElement, {
    constructors: () => ({
      _: [EmbedElement, []],
      new: [EmbedElement, []],
      created: [EmbedElement, []]
    }),
    methods: () => ({
      [__getter__]: [core.bool, [dart.dynamic]],
      [__setter__]: [dart.void, [dart.dynamic, Node]]
    })
  });
  EmbedElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLEmbedElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLEmbedElement"))];
  let _EntriesCallback = dart.typedef('_EntriesCallback', () => dart.functionType(dart.void, [core.List$(Entry)]));
  let _EntryCallback = dart.typedef('_EntryCallback', () => dart.functionType(dart.void, [Entry]));
  let _ErrorCallback = dart.typedef('_ErrorCallback', () => dart.functionType(dart.void, [FileError]));
  Event.AT_TARGET = 2;
  Event.BUBBLING_PHASE = 3;
  Event.CAPTURING_PHASE = 1;
  class EventSource extends EventTarget {
    static new(url, opts) {
      let withCredentials = opts && 'withCredentials' in opts ? opts.withCredentials : false;
      let parsedOptions = dart.map({withCredentials: withCredentials});
      return EventSource._factoryEventSource(url, dart.as(parsedOptions, core.Map));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static _factoryEventSource(url, eventSourceInit) {
      if (eventSourceInit === void 0)
        eventSourceInit = null;
      if (eventSourceInit != null) {
        let eventSourceInit_1 = html_common.convertDartToNative_Dictionary(eventSourceInit);
        return EventSource._create_1(url, eventSourceInit_1);
      }
      return EventSource._create_2(url);
    }
    static _create_1(url, eventSourceInit) {
      return dart.as(new EventSource(url, eventSourceInit), EventSource);
    }
    static _create_2(url) {
      return dart.as(new EventSource(url), EventSource);
    }
    get onError() {
      return EventSource.errorEvent.forTarget(this);
    }
    get onMessage() {
      return EventSource.messageEvent.forTarget(this);
    }
    get onOpen() {
      return EventSource.openEvent.forTarget(this);
    }
  }
  dart.setSignature(EventSource, {
    constructors: () => ({
      new: [EventSource, [core.String], {withCredentials: dart.dynamic}],
      _: [EventSource, []]
    }),
    methods: () => ({close: [dart.void, []]}),
    statics: () => ({
      _factoryEventSource: [EventSource, [core.String], [core.Map]],
      _create_1: [EventSource, [dart.dynamic, dart.dynamic]],
      _create_2: [EventSource, [dart.dynamic]]
    }),
    names: ['_factoryEventSource', '_create_1', '_create_2']
  });
  EventSource[dart.metadata] = () => [dart.const(new _metadata.DomName('EventSource')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("EventSource"))];
  EventSource.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  EventSource.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  EventSource.openEvent = dart.const(new (EventStreamProvider$(Event))('open'));
  EventSource.CLOSED = 2;
  EventSource.CONNECTING = 0;
  EventSource.OPEN = 1;
  let _ptr = Symbol('_ptr');
  class Events extends core.Object {
    Events(ptr) {
      this[_ptr] = ptr;
    }
    get(type) {
      return new _EventStream(this[_ptr], type, false);
    }
  }
  dart.virtualField(Events, _ptr);
  dart.setSignature(Events, {
    constructors: () => ({Events: [Events, [EventTarget]]}),
    methods: () => ({get: [async.Stream, [core.String]]})
  });
  class ElementEvents extends Events {
    ElementEvents(ptr) {
      this[_ptr] = ptr;
      super.Events(ptr);
    }
    get(type) {
      if (dart.notNull(dart.as(dart.dsend(dart.dload(ElementEvents.webkitEvents, 'keys'), 'contains', type[dartx.toLowerCase]()), core.bool))) {
        if (dart.notNull(html_common.Device.isWebKit)) {
          return new _ElementEventStreamImpl(this[_ptr], dart.dindex(ElementEvents.webkitEvents, type[dartx.toLowerCase]()), false);
        }
      }
      return new _ElementEventStreamImpl(this[_ptr], type, false);
    }
  }
  dart.virtualField(ElementEvents, _ptr);
  dart.setSignature(ElementEvents, {
    constructors: () => ({ElementEvents: [ElementEvents, [Element]]})
  });
  dart.defineLazyProperties(ElementEvents, {
    get webkitEvents() {
      return dart.map({animationend: 'webkitAnimationEnd', animationiteration: 'webkitAnimationIteration', animationstart: 'webkitAnimationStart', fullscreenchange: 'webkitfullscreenchange', fullscreenerror: 'webkitfullscreenerror', keyadded: 'webkitkeyadded', keyerror: 'webkitkeyerror', keymessage: 'webkitkeymessage', needkey: 'webkitneedkey', pointerlockchange: 'webkitpointerlockchange', pointerlockerror: 'webkitpointerlockerror', resourcetimingbufferfull: 'webkitresourcetimingbufferfull', transitionend: 'webkitTransitionEnd', speechchange: 'webkitSpeechChange'});
    }
  });
  class ExtendableEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ExtendableEvent, {
    constructors: () => ({_: [ExtendableEvent, []]}),
    methods: () => ({waitUntil: [dart.void, [core.Object]]})
  });
  ExtendableEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ExtendableEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ExtendableEvent"))];
  class FederatedCredential extends Credential {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(id, name, avatarURL, federation) {
      return FederatedCredential._create_1(id, name, avatarURL, federation);
    }
    static _create_1(id, name, avatarURL, federation) {
      return dart.as(new FederatedCredential(id, name, avatarURL, federation), FederatedCredential);
    }
  }
  dart.setSignature(FederatedCredential, {
    constructors: () => ({
      _: [FederatedCredential, []],
      new: [FederatedCredential, [core.String, core.String, core.String, core.String]]
    }),
    statics: () => ({_create_1: [FederatedCredential, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]}),
    names: ['_create_1']
  });
  FederatedCredential[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FederatedCredential')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FederatedCredential"))];
  class FetchEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FetchEvent, {
    constructors: () => ({_: [FetchEvent, []]}),
    methods: () => ({respondWith: [dart.void, [core.Object]]})
  });
  FetchEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FetchEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FetchEvent"))];
  class FieldSetElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("fieldset"), FieldSetElement);
    }
    created() {
      this.disabled = null;
      this.elements = null;
      this.form = null;
      this.name = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.willValidate = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(FieldSetElement, 'created');
  dart.setSignature(FieldSetElement, {
    constructors: () => ({
      _: [FieldSetElement, []],
      new: [FieldSetElement, []],
      created: [FieldSetElement, []]
    }),
    methods: () => ({
      checkValidity: [core.bool, []],
      setCustomValidity: [dart.void, [core.String]]
    })
  });
  FieldSetElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLFieldSetElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLFieldSetElement"))];
  let _get_lastModifiedDate = Symbol('_get_lastModifiedDate');
  class File extends Blob {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get lastModifiedDate() {
      return html_common.convertNativeToDart_DateTime(this[_get_lastModifiedDate]);
    }
  }
  dart.setSignature(File, {
    constructors: () => ({_: [File, []]})
  });
  File[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('File')), dart.const(new _js_helper.Native("File"))];
  let _FileCallback = dart.typedef('_FileCallback', () => dart.functionType(dart.void, [File]));
  let _createWriter = Symbol('_createWriter');
  let _file = Symbol('_file');
  class FileEntry extends Entry {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    createWriter() {
      let completer = async.Completer$(FileWriter).new();
      this[_createWriter](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(FileWriter));
    }
    file() {
      let completer = async.Completer$(File).new();
      this[_file](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(File));
    }
  }
  dart.setSignature(FileEntry, {
    constructors: () => ({_: [FileEntry, []]}),
    methods: () => ({
      [_createWriter]: [dart.void, [_FileWriterCallback], [_ErrorCallback]],
      createWriter: [async.Future$(FileWriter), []],
      [_file]: [dart.void, [_FileCallback], [_ErrorCallback]],
      file: [async.Future$(File), []]
    })
  });
  FileEntry[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileEntry')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FileEntry"))];
  class FileError extends DomError {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FileError, {
    constructors: () => ({_: [FileError, []]})
  });
  FileError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileError')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FileError"))];
  FileError.ABORT_ERR = 3;
  FileError.ENCODING_ERR = 5;
  FileError.INVALID_MODIFICATION_ERR = 9;
  FileError.INVALID_STATE_ERR = 7;
  FileError.NOT_FOUND_ERR = 1;
  FileError.NOT_READABLE_ERR = 4;
  FileError.NO_MODIFICATION_ALLOWED_ERR = 6;
  FileError.PATH_EXISTS_ERR = 12;
  FileError.QUOTA_EXCEEDED_ERR = 10;
  FileError.SECURITY_ERR = 2;
  FileError.SYNTAX_ERR = 8;
  FileError.TYPE_MISMATCH_ERR = 11;
  class FileList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(File), ImmutableListMixin$(File)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], File);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], File);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], File);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], File);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  FileList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(File)];
  dart.setSignature(FileList, {
    constructors: () => ({_: [FileList, []]}),
    methods: () => ({
      get: [File, [core.int]],
      set: [dart.void, [core.int, File]],
      elementAt: [File, [core.int]],
      item: [File, [core.int]]
    })
  });
  dart.defineExtensionMembers(FileList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  FileList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileList')), dart.const(new _js_helper.Native("FileList"))];
  class FileReader extends EventTarget {
    get result() {
      let res = this.result;
      if (dart.is(res, typed_data.ByteBuffer)) {
        return typed_data.Uint8List.view(dart.as(res, typed_data.ByteBuffer));
      }
      return res;
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return FileReader._create_1();
    }
    static _create_1() {
      return dart.as(new FileReader(), FileReader);
    }
    get onAbort() {
      return FileReader.abortEvent.forTarget(this);
    }
    get onError() {
      return FileReader.errorEvent.forTarget(this);
    }
    get onLoad() {
      return FileReader.loadEvent.forTarget(this);
    }
    get onLoadEnd() {
      return FileReader.loadEndEvent.forTarget(this);
    }
    get onLoadStart() {
      return FileReader.loadStartEvent.forTarget(this);
    }
    get onProgress() {
      return FileReader.progressEvent.forTarget(this);
    }
  }
  dart.setSignature(FileReader, {
    constructors: () => ({
      _: [FileReader, []],
      new: [FileReader, []]
    }),
    methods: () => ({
      abort: [dart.void, []],
      readAsArrayBuffer: [dart.void, [Blob]],
      readAsDataUrl: [dart.void, [Blob]],
      readAsText: [dart.void, [Blob], [core.String]]
    }),
    statics: () => ({_create_1: [FileReader, []]}),
    names: ['_create_1']
  });
  FileReader[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileReader')), dart.const(new _js_helper.Native("FileReader"))];
  FileReader.abortEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('abort'));
  FileReader.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  FileReader.loadEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('load'));
  FileReader.loadEndEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('loadend'));
  FileReader.loadStartEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('loadstart'));
  FileReader.progressEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('progress'));
  FileReader.DONE = 2;
  FileReader.EMPTY = 0;
  FileReader.LOADING = 1;
  class FileStream extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FileStream, {
    constructors: () => ({_: [FileStream, []]})
  });
  FileStream[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Stream')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Stream"))];
  class FileSystem extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!window.webkitRequestFileSystem, core.bool);
    }
  }
  dart.setSignature(FileSystem, {
    constructors: () => ({_: [FileSystem, []]})
  });
  FileSystem[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMFileSystem')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMFileSystem"))];
  let _FileSystemCallback = dart.typedef('_FileSystemCallback', () => dart.functionType(dart.void, [FileSystem]));
  class FileWriter extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onAbort() {
      return FileWriter.abortEvent.forTarget(this);
    }
    get onError() {
      return FileWriter.errorEvent.forTarget(this);
    }
    get onProgress() {
      return FileWriter.progressEvent.forTarget(this);
    }
    get onWrite() {
      return FileWriter.writeEvent.forTarget(this);
    }
    get onWriteEnd() {
      return FileWriter.writeEndEvent.forTarget(this);
    }
    get onWriteStart() {
      return FileWriter.writeStartEvent.forTarget(this);
    }
  }
  dart.setSignature(FileWriter, {
    constructors: () => ({_: [FileWriter, []]}),
    methods: () => ({
      abort: [dart.void, []],
      seek: [dart.void, [core.int]],
      truncate: [dart.void, [core.int]],
      write: [dart.void, [Blob]]
    })
  });
  FileWriter[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileWriter')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FileWriter"))];
  FileWriter.abortEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('abort'));
  FileWriter.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  FileWriter.progressEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('progress'));
  FileWriter.writeEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('write'));
  FileWriter.writeEndEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('writeend'));
  FileWriter.writeStartEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('writestart'));
  FileWriter.DONE = 2;
  FileWriter.INIT = 0;
  FileWriter.WRITING = 1;
  let _FileWriterCallback = dart.typedef('_FileWriterCallback', () => dart.functionType(dart.void, [FileWriter]));
  class FocusEvent extends UIEvent {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get relatedTarget() {
      return _convertNativeToDart_EventTarget(this[_get_relatedTarget]);
    }
  }
  dart.setSignature(FocusEvent, {
    constructors: () => ({_: [FocusEvent, []]})
  });
  FocusEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FocusEvent')), dart.const(new _js_helper.Native("FocusEvent"))];
  class FontFace extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(family, source, descriptors) {
      if (descriptors === void 0)
        descriptors = null;
      if ((typeof source == 'string' || source == null) && (typeof family == 'string' || family == null) && descriptors == null) {
        return FontFace._create_1(family, source);
      }
      if ((dart.is(descriptors, core.Map) || descriptors == null) && (typeof source == 'string' || source == null) && (typeof family == 'string' || family == null)) {
        let descriptors_1 = html_common.convertDartToNative_Dictionary(descriptors);
        return FontFace._create_2(family, source, descriptors_1);
      }
      if ((dart.is(source, typed_data.TypedData) || source == null) && (typeof family == 'string' || family == null) && descriptors == null) {
        return FontFace._create_3(family, source);
      }
      if ((dart.is(descriptors, core.Map) || descriptors == null) && (dart.is(source, typed_data.TypedData) || source == null) && (typeof family == 'string' || family == null)) {
        let descriptors_1 = html_common.convertDartToNative_Dictionary(descriptors);
        return FontFace._create_4(family, source, descriptors_1);
      }
      if ((dart.is(source, typed_data.ByteBuffer) || source == null) && (typeof family == 'string' || family == null) && descriptors == null) {
        return FontFace._create_5(family, source);
      }
      if ((dart.is(descriptors, core.Map) || descriptors == null) && (dart.is(source, typed_data.ByteBuffer) || source == null) && (typeof family == 'string' || family == null)) {
        let descriptors_1 = html_common.convertDartToNative_Dictionary(descriptors);
        return FontFace._create_6(family, source, descriptors_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1(family, source) {
      return dart.as(new FontFace(family, source), FontFace);
    }
    static _create_2(family, source, descriptors) {
      return dart.as(new FontFace(family, source, descriptors), FontFace);
    }
    static _create_3(family, source) {
      return dart.as(new FontFace(family, source), FontFace);
    }
    static _create_4(family, source, descriptors) {
      return dart.as(new FontFace(family, source, descriptors), FontFace);
    }
    static _create_5(family, source) {
      return dart.as(new FontFace(family, source), FontFace);
    }
    static _create_6(family, source, descriptors) {
      return dart.as(new FontFace(family, source, descriptors), FontFace);
    }
  }
  dart.setSignature(FontFace, {
    constructors: () => ({
      _: [FontFace, []],
      new: [FontFace, [core.String, dart.dynamic], [core.Map]]
    }),
    methods: () => ({load: [async.Future, []]}),
    statics: () => ({
      _create_1: [FontFace, [dart.dynamic, dart.dynamic]],
      _create_2: [FontFace, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_3: [FontFace, [dart.dynamic, dart.dynamic]],
      _create_4: [FontFace, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_5: [FontFace, [dart.dynamic, dart.dynamic]],
      _create_6: [FontFace, [dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3', '_create_4', '_create_5', '_create_6']
  });
  FontFace[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FontFace')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FontFace"))];
  class FontFaceSet extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FontFaceSet, {
    constructors: () => ({_: [FontFaceSet, []]}),
    methods: () => ({
      add: [dart.void, [FontFace]],
      check: [core.bool, [core.String], [core.String]],
      clear: [dart.void, []],
      delete: [core.bool, [FontFace]],
      forEach: [dart.void, [FontFaceSetForEachCallback], [core.Object]],
      has: [core.bool, [FontFace]]
    })
  });
  FontFaceSet[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FontFaceSet')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FontFaceSet"))];
  let FontFaceSetForEachCallback = dart.typedef('FontFaceSetForEachCallback', () => dart.functionType(dart.void, [FontFace, FontFace, FontFaceSet]));
  class FontFaceSetLoadEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(FontFaceSetLoadEvent, {
    constructors: () => ({_: [FontFaceSetLoadEvent, []]})
  });
  FontFaceSetLoadEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FontFaceSetLoadEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FontFaceSetLoadEvent"))];
  class FormData extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(form) {
      if (form === void 0)
        form = null;
      if (form != null) {
        return FormData._create_1(form);
      }
      return FormData._create_2();
    }
    static _create_1(form) {
      return dart.as(new FormData(form), FormData);
    }
    static _create_2() {
      return dart.as(new FormData(), FormData);
    }
    static get supported() {
      return dart.as(!!window.FormData, core.bool);
    }
  }
  dart.setSignature(FormData, {
    constructors: () => ({
      _: [FormData, []],
      new: [FormData, [], [FormElement]]
    }),
    methods: () => ({
      append: [dart.void, [core.String, core.String]],
      appendBlob: [dart.void, [core.String, Blob], [core.String]]
    }),
    statics: () => ({
      _create_1: [FormData, [dart.dynamic]],
      _create_2: [FormData, []]
    }),
    names: ['_create_1', '_create_2']
  });
  FormData[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FormData')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _js_helper.Native("FormData"))];
  let _requestAutocomplete_1 = Symbol('_requestAutocomplete_1');
  class FormElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("form"), FormElement);
    }
    created() {
      this.acceptCharset = null;
      this.action = null;
      this.autocomplete = null;
      this.encoding = null;
      this.enctype = null;
      this.length = null;
      this.method = null;
      this.name = null;
      this.noValidate = null;
      this.target = null;
      super.created();
    }
    requestAutocomplete(details) {
      let details_1 = html_common.convertDartToNative_Dictionary(details);
      this[_requestAutocomplete_1](details_1);
      return;
    }
  }
  dart.defineNamedConstructor(FormElement, 'created');
  dart.setSignature(FormElement, {
    constructors: () => ({
      _: [FormElement, []],
      new: [FormElement, []],
      created: [FormElement, []]
    }),
    methods: () => ({
      [__getter__]: [Element, [dart.dynamic]],
      checkValidity: [core.bool, []],
      requestAutocomplete: [dart.void, [core.Map]],
      [_requestAutocomplete_1]: [dart.void, [dart.dynamic]],
      reset: [dart.void, []],
      submit: [dart.void, []]
    })
  });
  FormElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLFormElement')), dart.const(new _js_helper.Native("HTMLFormElement"))];
  class Gamepad extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Gamepad, {
    constructors: () => ({_: [Gamepad, []]})
  });
  Gamepad[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Gamepad')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Gamepad"))];
  class GamepadButton extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(GamepadButton, {
    constructors: () => ({_: [GamepadButton, []]})
  });
  GamepadButton[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('GamepadButton')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("GamepadButton"))];
  class GamepadEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(GamepadEvent, {
    constructors: () => ({_: [GamepadEvent, []]})
  });
  GamepadEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('GamepadEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("GamepadEvent"))];
  class Geofencing extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Geofencing, {
    constructors: () => ({_: [Geofencing, []]}),
    methods: () => ({
      getRegisteredRegions: [async.Future, []],
      registerRegion: [async.Future, [GeofencingRegion]],
      unregisterRegion: [async.Future, [core.String]]
    })
  });
  Geofencing[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Geofencing')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Geofencing"))];
  let _getCurrentPosition = Symbol('_getCurrentPosition');
  let _ensurePosition = Symbol('_ensurePosition');
  let _watchPosition = Symbol('_watchPosition');
  let _clearWatch = Symbol('_clearWatch');
  let _getCurrentPosition_1 = Symbol('_getCurrentPosition_1');
  let _getCurrentPosition_2 = Symbol('_getCurrentPosition_2');
  let _getCurrentPosition_3 = Symbol('_getCurrentPosition_3');
  let _watchPosition_1 = Symbol('_watchPosition_1');
  let _watchPosition_2 = Symbol('_watchPosition_2');
  let _watchPosition_3 = Symbol('_watchPosition_3');
  class Geolocation extends _interceptors.Interceptor {
    getCurrentPosition(opts) {
      let enableHighAccuracy = opts && 'enableHighAccuracy' in opts ? opts.enableHighAccuracy : null;
      let timeout = opts && 'timeout' in opts ? opts.timeout : null;
      let maximumAge = opts && 'maximumAge' in opts ? opts.maximumAge : null;
      let options = dart.map();
      if (enableHighAccuracy != null) {
        dart.dsetindex(options, 'enableHighAccuracy', enableHighAccuracy);
      }
      if (timeout != null) {
        dart.dsetindex(options, 'timeout', timeout.inMilliseconds);
      }
      if (maximumAge != null) {
        dart.dsetindex(options, 'maximumAge', maximumAge.inMilliseconds);
      }
      let completer = async.Completer$(Geoposition).new();
      try {
        this[_getCurrentPosition](dart.fn(position => {
          dart.dsend(completer, 'complete', this[_ensurePosition](position));
        }), dart.fn(error => {
          dart.dsend(completer, 'completeError', error);
        }), dart.as(options, core.Map));
      } catch (e) {
        let stacktrace = dart.stackTrace(e);
        dart.dsend(completer, 'completeError', e, stacktrace);
      }

      return dart.as(dart.dload(completer, 'future'), async.Future$(Geoposition));
    }
    watchPosition(opts) {
      let enableHighAccuracy = opts && 'enableHighAccuracy' in opts ? opts.enableHighAccuracy : null;
      let timeout = opts && 'timeout' in opts ? opts.timeout : null;
      let maximumAge = opts && 'maximumAge' in opts ? opts.maximumAge : null;
      let options = dart.map();
      if (enableHighAccuracy != null) {
        dart.dsetindex(options, 'enableHighAccuracy', enableHighAccuracy);
      }
      if (timeout != null) {
        dart.dsetindex(options, 'timeout', timeout.inMilliseconds);
      }
      if (maximumAge != null) {
        dart.dsetindex(options, 'maximumAge', maximumAge.inMilliseconds);
      }
      let watchId = null;
      let controller = null;
      controller = async.StreamController$(Geoposition).new({sync: true, onListen: dart.fn(() => {
          dart.assert(watchId == null);
          watchId = this[_watchPosition](dart.fn(position => {
            dart.dsend(controller, 'add', this[_ensurePosition](position));
          }), dart.fn(error => {
            dart.dsend(controller, 'addError', error);
          }), dart.as(options, core.Map));
        }), onCancel: dart.fn(() => {
          dart.assert(watchId != null);
          this[_clearWatch](watchId);
        })});
      return dart.as(dart.dload(controller, 'stream'), async.Stream$(Geoposition));
    }
    [_ensurePosition](domPosition) {
      try {
        if (dart.is(domPosition, Geoposition)) {
          return dart.as(domPosition, Geoposition);
        }
      } catch (e) {
      }

      return new _GeopositionWrapper(domPosition);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    [_getCurrentPosition](successCallback, errorCallback, options) {
      if (errorCallback === void 0)
        errorCallback = null;
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        this[_getCurrentPosition_1](successCallback, errorCallback, options_1);
        return;
      }
      if (errorCallback != null) {
        this[_getCurrentPosition_2](successCallback, errorCallback);
        return;
      }
      this[_getCurrentPosition_3](successCallback);
      return;
    }
    [_watchPosition](successCallback, errorCallback, options) {
      if (errorCallback === void 0)
        errorCallback = null;
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return this[_watchPosition_1](successCallback, errorCallback, options_1);
      }
      if (errorCallback != null) {
        return this[_watchPosition_2](successCallback, errorCallback);
      }
      return this[_watchPosition_3](successCallback);
    }
  }
  dart.setSignature(Geolocation, {
    constructors: () => ({_: [Geolocation, []]}),
    methods: () => ({
      getCurrentPosition: [async.Future$(Geoposition), [], {enableHighAccuracy: core.bool, timeout: core.Duration, maximumAge: core.Duration}],
      watchPosition: [async.Stream$(Geoposition), [], {enableHighAccuracy: core.bool, timeout: core.Duration, maximumAge: core.Duration}],
      [_ensurePosition]: [Geoposition, [dart.dynamic]],
      [_clearWatch]: [dart.void, [core.int]],
      [_getCurrentPosition]: [dart.void, [_PositionCallback], [_PositionErrorCallback, core.Map]],
      [_getCurrentPosition_1]: [dart.void, [_PositionCallback, _PositionErrorCallback, dart.dynamic]],
      [_getCurrentPosition_2]: [dart.void, [_PositionCallback, _PositionErrorCallback]],
      [_getCurrentPosition_3]: [dart.void, [_PositionCallback]],
      [_watchPosition]: [core.int, [_PositionCallback], [_PositionErrorCallback, core.Map]],
      [_watchPosition_1]: [core.int, [_PositionCallback, _PositionErrorCallback, dart.dynamic]],
      [_watchPosition_2]: [core.int, [_PositionCallback, _PositionErrorCallback]],
      [_watchPosition_3]: [core.int, [_PositionCallback]]
    })
  });
  Geolocation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Geolocation')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("Geolocation"))];
  class _GeopositionWrapper extends core.Object {
    _GeopositionWrapper(ptr) {
      this[_ptr] = ptr;
    }
    get coords() {
      return dart.as(this[_ptr].coords, Coordinates);
    }
    get timestamp() {
      return dart.as(this[_ptr].timestamp, core.int);
    }
  }
  _GeopositionWrapper[dart.implements] = () => [Geoposition];
  dart.setSignature(_GeopositionWrapper, {
    constructors: () => ({_GeopositionWrapper: [_GeopositionWrapper, [dart.dynamic]]})
  });
  class Geoposition extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Geoposition, {
    constructors: () => ({_: [Geoposition, []]})
  });
  Geoposition[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Geoposition')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("Geoposition"))];
  class GlobalEventHandlers extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onAbort() {
      return GlobalEventHandlers.abortEvent.forTarget(this);
    }
    get onBlur() {
      return GlobalEventHandlers.blurEvent.forTarget(this);
    }
    get onCanPlay() {
      return GlobalEventHandlers.canPlayEvent.forTarget(this);
    }
    get onCanPlayThrough() {
      return GlobalEventHandlers.canPlayThroughEvent.forTarget(this);
    }
    get onChange() {
      return GlobalEventHandlers.changeEvent.forTarget(this);
    }
    get onClick() {
      return GlobalEventHandlers.clickEvent.forTarget(this);
    }
    get onContextMenu() {
      return GlobalEventHandlers.contextMenuEvent.forTarget(this);
    }
    get onDoubleClick() {
      return GlobalEventHandlers.doubleClickEvent.forTarget(this);
    }
    get onDrag() {
      return GlobalEventHandlers.dragEvent.forTarget(this);
    }
    get onDragEnd() {
      return GlobalEventHandlers.dragEndEvent.forTarget(this);
    }
    get onDragEnter() {
      return GlobalEventHandlers.dragEnterEvent.forTarget(this);
    }
    get onDragLeave() {
      return GlobalEventHandlers.dragLeaveEvent.forTarget(this);
    }
    get onDragOver() {
      return GlobalEventHandlers.dragOverEvent.forTarget(this);
    }
    get onDragStart() {
      return GlobalEventHandlers.dragStartEvent.forTarget(this);
    }
    get onDrop() {
      return GlobalEventHandlers.dropEvent.forTarget(this);
    }
    get onDurationChange() {
      return GlobalEventHandlers.durationChangeEvent.forTarget(this);
    }
    get onEmptied() {
      return GlobalEventHandlers.emptiedEvent.forTarget(this);
    }
    get onEnded() {
      return GlobalEventHandlers.endedEvent.forTarget(this);
    }
    get onError() {
      return GlobalEventHandlers.errorEvent.forTarget(this);
    }
    get onFocus() {
      return GlobalEventHandlers.focusEvent.forTarget(this);
    }
    get onInput() {
      return GlobalEventHandlers.inputEvent.forTarget(this);
    }
    get onInvalid() {
      return GlobalEventHandlers.invalidEvent.forTarget(this);
    }
    get onKeyDown() {
      return GlobalEventHandlers.keyDownEvent.forTarget(this);
    }
    get onKeyPress() {
      return GlobalEventHandlers.keyPressEvent.forTarget(this);
    }
    get onKeyUp() {
      return GlobalEventHandlers.keyUpEvent.forTarget(this);
    }
    get onLoad() {
      return GlobalEventHandlers.loadEvent.forTarget(this);
    }
    get onLoadedData() {
      return GlobalEventHandlers.loadedDataEvent.forTarget(this);
    }
    get onLoadedMetadata() {
      return GlobalEventHandlers.loadedMetadataEvent.forTarget(this);
    }
    get onMouseDown() {
      return GlobalEventHandlers.mouseDownEvent.forTarget(this);
    }
    get onMouseEnter() {
      return GlobalEventHandlers.mouseEnterEvent.forTarget(this);
    }
    get onMouseLeave() {
      return GlobalEventHandlers.mouseLeaveEvent.forTarget(this);
    }
    get onMouseMove() {
      return GlobalEventHandlers.mouseMoveEvent.forTarget(this);
    }
    get onMouseOut() {
      return GlobalEventHandlers.mouseOutEvent.forTarget(this);
    }
    get onMouseOver() {
      return GlobalEventHandlers.mouseOverEvent.forTarget(this);
    }
    get onMouseUp() {
      return GlobalEventHandlers.mouseUpEvent.forTarget(this);
    }
    get onMouseWheel() {
      return GlobalEventHandlers.mouseWheelEvent.forTarget(this);
    }
    get onPause() {
      return GlobalEventHandlers.pauseEvent.forTarget(this);
    }
    get onPlay() {
      return GlobalEventHandlers.playEvent.forTarget(this);
    }
    get onPlaying() {
      return GlobalEventHandlers.playingEvent.forTarget(this);
    }
    get onRateChange() {
      return GlobalEventHandlers.rateChangeEvent.forTarget(this);
    }
    get onReset() {
      return GlobalEventHandlers.resetEvent.forTarget(this);
    }
    get onResize() {
      return GlobalEventHandlers.resizeEvent.forTarget(this);
    }
    get onScroll() {
      return GlobalEventHandlers.scrollEvent.forTarget(this);
    }
    get onSeeked() {
      return GlobalEventHandlers.seekedEvent.forTarget(this);
    }
    get onSeeking() {
      return GlobalEventHandlers.seekingEvent.forTarget(this);
    }
    get onSelect() {
      return GlobalEventHandlers.selectEvent.forTarget(this);
    }
    get onStalled() {
      return GlobalEventHandlers.stalledEvent.forTarget(this);
    }
    get onSubmit() {
      return GlobalEventHandlers.submitEvent.forTarget(this);
    }
    get onSuspend() {
      return GlobalEventHandlers.suspendEvent.forTarget(this);
    }
    get onTimeUpdate() {
      return GlobalEventHandlers.timeUpdateEvent.forTarget(this);
    }
    get onVolumeChange() {
      return GlobalEventHandlers.volumeChangeEvent.forTarget(this);
    }
    get onWaiting() {
      return GlobalEventHandlers.waitingEvent.forTarget(this);
    }
  }
  dart.setSignature(GlobalEventHandlers, {
    constructors: () => ({_: [GlobalEventHandlers, []]})
  });
  GlobalEventHandlers[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('GlobalEventHandlers')), dart.const(new _metadata.Experimental())];
  GlobalEventHandlers.abortEvent = dart.const(new (EventStreamProvider$(Event))('abort'));
  GlobalEventHandlers.blurEvent = dart.const(new (EventStreamProvider$(Event))('blur'));
  GlobalEventHandlers.canPlayEvent = dart.const(new (EventStreamProvider$(Event))('canplay'));
  GlobalEventHandlers.canPlayThroughEvent = dart.const(new (EventStreamProvider$(Event))('canplaythrough'));
  GlobalEventHandlers.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  GlobalEventHandlers.clickEvent = dart.const(new (EventStreamProvider$(MouseEvent))('click'));
  GlobalEventHandlers.contextMenuEvent = dart.const(new (EventStreamProvider$(MouseEvent))('contextmenu'));
  GlobalEventHandlers.doubleClickEvent = dart.const(new (EventStreamProvider$(Event))('dblclick'));
  GlobalEventHandlers.dragEvent = dart.const(new (EventStreamProvider$(MouseEvent))('drag'));
  GlobalEventHandlers.dragEndEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragend'));
  GlobalEventHandlers.dragEnterEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragenter'));
  GlobalEventHandlers.dragLeaveEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragleave'));
  GlobalEventHandlers.dragOverEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragover'));
  GlobalEventHandlers.dragStartEvent = dart.const(new (EventStreamProvider$(MouseEvent))('dragstart'));
  GlobalEventHandlers.dropEvent = dart.const(new (EventStreamProvider$(MouseEvent))('drop'));
  GlobalEventHandlers.durationChangeEvent = dart.const(new (EventStreamProvider$(Event))('durationchange'));
  GlobalEventHandlers.emptiedEvent = dart.const(new (EventStreamProvider$(Event))('emptied'));
  GlobalEventHandlers.endedEvent = dart.const(new (EventStreamProvider$(Event))('ended'));
  GlobalEventHandlers.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  GlobalEventHandlers.focusEvent = dart.const(new (EventStreamProvider$(Event))('focus'));
  GlobalEventHandlers.inputEvent = dart.const(new (EventStreamProvider$(Event))('input'));
  GlobalEventHandlers.invalidEvent = dart.const(new (EventStreamProvider$(Event))('invalid'));
  GlobalEventHandlers.keyDownEvent = dart.const(new (EventStreamProvider$(KeyboardEvent))('keydown'));
  GlobalEventHandlers.keyPressEvent = dart.const(new (EventStreamProvider$(KeyboardEvent))('keypress'));
  GlobalEventHandlers.keyUpEvent = dart.const(new (EventStreamProvider$(KeyboardEvent))('keyup'));
  GlobalEventHandlers.loadEvent = dart.const(new (EventStreamProvider$(Event))('load'));
  GlobalEventHandlers.loadedDataEvent = dart.const(new (EventStreamProvider$(Event))('loadeddata'));
  GlobalEventHandlers.loadedMetadataEvent = dart.const(new (EventStreamProvider$(Event))('loadedmetadata'));
  GlobalEventHandlers.mouseDownEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mousedown'));
  GlobalEventHandlers.mouseEnterEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseenter'));
  GlobalEventHandlers.mouseLeaveEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseleave'));
  GlobalEventHandlers.mouseMoveEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mousemove'));
  GlobalEventHandlers.mouseOutEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseout'));
  GlobalEventHandlers.mouseOverEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseover'));
  GlobalEventHandlers.mouseUpEvent = dart.const(new (EventStreamProvider$(MouseEvent))('mouseup'));
  GlobalEventHandlers.mouseWheelEvent = dart.const(new (EventStreamProvider$(WheelEvent))('mousewheel'));
  GlobalEventHandlers.pauseEvent = dart.const(new (EventStreamProvider$(Event))('pause'));
  GlobalEventHandlers.playEvent = dart.const(new (EventStreamProvider$(Event))('play'));
  GlobalEventHandlers.playingEvent = dart.const(new (EventStreamProvider$(Event))('playing'));
  GlobalEventHandlers.rateChangeEvent = dart.const(new (EventStreamProvider$(Event))('ratechange'));
  GlobalEventHandlers.resetEvent = dart.const(new (EventStreamProvider$(Event))('reset'));
  GlobalEventHandlers.resizeEvent = dart.const(new (EventStreamProvider$(Event))('resize'));
  GlobalEventHandlers.scrollEvent = dart.const(new (EventStreamProvider$(Event))('scroll'));
  GlobalEventHandlers.seekedEvent = dart.const(new (EventStreamProvider$(Event))('seeked'));
  GlobalEventHandlers.seekingEvent = dart.const(new (EventStreamProvider$(Event))('seeking'));
  GlobalEventHandlers.selectEvent = dart.const(new (EventStreamProvider$(Event))('select'));
  GlobalEventHandlers.stalledEvent = dart.const(new (EventStreamProvider$(Event))('stalled'));
  GlobalEventHandlers.submitEvent = dart.const(new (EventStreamProvider$(Event))('submit'));
  GlobalEventHandlers.suspendEvent = dart.const(new (EventStreamProvider$(Event))('suspend'));
  GlobalEventHandlers.timeUpdateEvent = dart.const(new (EventStreamProvider$(Event))('timeupdate'));
  GlobalEventHandlers.volumeChangeEvent = dart.const(new (EventStreamProvider$(Event))('volumechange'));
  GlobalEventHandlers.waitingEvent = dart.const(new (EventStreamProvider$(Event))('waiting'));
  class HRElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("hr"), HRElement);
    }
    created() {
      this.color = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(HRElement, 'created');
  dart.setSignature(HRElement, {
    constructors: () => ({
      _: [HRElement, []],
      new: [HRElement, []],
      created: [HRElement, []]
    })
  });
  HRElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLHRElement')), dart.const(new _js_helper.Native("HTMLHRElement"))];
  let _initHashChangeEvent = Symbol('_initHashChangeEvent');
  class HashChangeEvent extends Event {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let oldUrl = opts && 'oldUrl' in opts ? opts.oldUrl : null;
      let newUrl = opts && 'newUrl' in opts ? opts.newUrl : null;
      let event = exports.document[_createEvent]("HashChangeEvent");
      dart.dsend(event, _initHashChangeEvent, type, canBubble, cancelable, oldUrl, newUrl);
      return dart.as(event, HashChangeEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return html_common.Device.isEventTypeSupported('HashChangeEvent');
    }
  }
  dart.setSignature(HashChangeEvent, {
    constructors: () => ({
      new: [HashChangeEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, oldUrl: core.String, newUrl: core.String}],
      _: [HashChangeEvent, []]
    }),
    methods: () => ({[_initHashChangeEvent]: [dart.void, [core.String, core.bool, core.bool, core.String, core.String]]})
  });
  HashChangeEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('HashChangeEvent')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HashChangeEvent"))];
  class HeadElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("head"), HeadElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(HeadElement, 'created');
  dart.setSignature(HeadElement, {
    constructors: () => ({
      _: [HeadElement, []],
      new: [HeadElement, []],
      created: [HeadElement, []]
    })
  });
  HeadElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLHeadElement')), dart.const(new _js_helper.Native("HTMLHeadElement"))];
  class Headers extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(input) {
      if (input === void 0)
        input = null;
      if (input == null) {
        return Headers._create_1();
      }
      if (dart.is(input, Headers) || input == null) {
        return Headers._create_2(input);
      }
      if (dart.is(input, core.Map) || input == null) {
        let input_1 = html_common.convertDartToNative_Dictionary(dart.as(input, core.Map));
        return Headers._create_3(input_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1() {
      return dart.as(new Headers(), Headers);
    }
    static _create_2(input) {
      return dart.as(new Headers(input), Headers);
    }
    static _create_3(input) {
      return dart.as(new Headers(input), Headers);
    }
  }
  dart.setSignature(Headers, {
    constructors: () => ({
      _: [Headers, []],
      new: [Headers, [], [dart.dynamic]]
    }),
    methods: () => ({forEach: [dart.void, [HeadersForEachCallback], [core.Object]]}),
    statics: () => ({
      _create_1: [Headers, []],
      _create_2: [Headers, [dart.dynamic]],
      _create_3: [Headers, [dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3']
  });
  Headers[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Headers')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Headers"))];
  let HeadersForEachCallback = dart.typedef('HeadersForEachCallback', () => dart.functionType(dart.void, [core.String, core.String, Headers]));
  class HeadingElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static h1() {
      return dart.as(exports.document.createElement("h1"), HeadingElement);
    }
    static h2() {
      return dart.as(exports.document.createElement("h2"), HeadingElement);
    }
    static h3() {
      return dart.as(exports.document.createElement("h3"), HeadingElement);
    }
    static h4() {
      return dart.as(exports.document.createElement("h4"), HeadingElement);
    }
    static h5() {
      return dart.as(exports.document.createElement("h5"), HeadingElement);
    }
    static h6() {
      return dart.as(exports.document.createElement("h6"), HeadingElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(HeadingElement, 'created');
  dart.setSignature(HeadingElement, {
    constructors: () => ({
      _: [HeadingElement, []],
      h1: [HeadingElement, []],
      h2: [HeadingElement, []],
      h3: [HeadingElement, []],
      h4: [HeadingElement, []],
      h5: [HeadingElement, []],
      h6: [HeadingElement, []],
      created: [HeadingElement, []]
    })
  });
  HeadingElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLHeadingElement')), dart.const(new _js_helper.Native("HTMLHeadingElement"))];
  class History extends _interceptors.Interceptor {
    static get supportsState() {
      return dart.as(!!window.history.pushState, core.bool);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get state() {
      return html_common.convertNativeToDart_SerializedScriptValue(this[_get_state]);
    }
  }
  History[dart.implements] = () => [HistoryBase];
  dart.setSignature(History, {
    constructors: () => ({_: [History, []]}),
    methods: () => ({
      back: [dart.void, []],
      forward: [dart.void, []],
      go: [dart.void, [core.int]],
      pushState: [dart.void, [core.Object, core.String], [core.String]],
      replaceState: [dart.void, [core.Object, core.String], [core.String]]
    })
  });
  History[dart.metadata] = () => [dart.const(new _metadata.DomName('History')), dart.const(new _js_helper.Native("History"))];
  class HtmlCollection extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Node), ImmutableListMixin$(Node)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], Node);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], Node);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], Node);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], Node);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  HtmlCollection[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(Node)];
  dart.setSignature(HtmlCollection, {
    constructors: () => ({_: [HtmlCollection, []]}),
    methods: () => ({
      get: [Node, [core.int]],
      set: [dart.void, [core.int, Node]],
      elementAt: [Node, [core.int]],
      item: [Element, [core.int]],
      namedItem: [Element, [core.String]]
    })
  });
  dart.defineExtensionMembers(HtmlCollection, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  HtmlCollection[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLCollection')), dart.const(new _js_helper.Native("HTMLCollection"))];
  let _head = Symbol('_head');
  let _lastModified = Symbol('_lastModified');
  let _preferredStylesheetSet = Symbol('_preferredStylesheetSet');
  let _referrer = Symbol('_referrer');
  let _selectedStylesheetSet = Symbol('_selectedStylesheetSet');
  let _styleSheets = Symbol('_styleSheets');
  let _title = Symbol('_title');
  let _webkitFullscreenElement = Symbol('_webkitFullscreenElement');
  let _webkitFullscreenEnabled = Symbol('_webkitFullscreenEnabled');
  let _webkitHidden = Symbol('_webkitHidden');
  class HtmlDocument extends Document {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    caretRangeFromPoint(x, y) {
      return this[_caretRangeFromPoint](x, y);
    }
    elementFromPoint(x, y) {
      return this[_elementFromPoint](x, y);
    }
    static get supportsCssCanvasContext() {
      return dart.as(!!document.getCSSCanvasContext, core.bool);
    }
    getCssCanvasContext(contextId, name, width, height) {
      return dart.as(this[_getCssCanvasContext](contextId, name, width, height), CanvasRenderingContext);
    }
    get head() {
      return this[_head];
    }
    get lastModified() {
      return this[_lastModified];
    }
    get preferredStylesheetSet() {
      return this[_preferredStylesheetSet];
    }
    get referrer() {
      return this[_referrer];
    }
    get selectedStylesheetSet() {
      return this[_selectedStylesheetSet];
    }
    set selectedStylesheetSet(value) {
      this[_selectedStylesheetSet] = value;
    }
    get styleSheets() {
      return this[_styleSheets];
    }
    get title() {
      return this[_title];
    }
    set title(value) {
      this[_title] = value;
    }
    exitFullscreen() {
      this[_webkitExitFullscreen]();
    }
    get fullscreenElement() {
      return this[_webkitFullscreenElement];
    }
    get fullscreenEnabled() {
      return this[_webkitFullscreenEnabled];
    }
    get hidden() {
      return this[_webkitHidden];
    }
    get visibilityState() {
      return dart.as(this.visibilityState || this.mozVisibilityState || this.msVisibilityState || this.webkitVisibilityState, core.String);
    }
    registerElement(tag, customElementClass, opts) {
      let extendsTag = opts && 'extendsTag' in opts ? opts.extendsTag : null;
      _registerCustomElement(window, this, tag, customElementClass, extendsTag);
    }
    register(tag, customElementClass, opts) {
      let extendsTag = opts && 'extendsTag' in opts ? opts.extendsTag : null;
      return this.registerElement(tag, customElementClass, {extendsTag: extendsTag});
    }
    static _determineVisibilityChangeEventType(e) {
      if (dart.notNull(dart.as(typeof e.hidden !== "undefined", core.bool))) {
        return 'visibilitychange';
      } else if (dart.notNull(dart.as(typeof e.mozHidden !== "undefined", core.bool))) {
        return 'mozvisibilitychange';
      } else if (dart.notNull(dart.as(typeof e.msHidden !== "undefined", core.bool))) {
        return 'msvisibilitychange';
      } else if (dart.notNull(dart.as(typeof e.webkitHidden !== "undefined", core.bool))) {
        return 'webkitvisibilitychange';
      }
      return 'visibilitychange';
    }
    get onVisibilityChange() {
      return HtmlDocument.visibilityChangeEvent.forTarget(this);
    }
    createElementUpgrader(type, opts) {
      let extendsTag = opts && 'extendsTag' in opts ? opts.extendsTag : null;
      return new _JSElementUpgrader(this, type, extendsTag);
    }
  }
  dart.setSignature(HtmlDocument, {
    constructors: () => ({_: [HtmlDocument, []]}),
    methods: () => ({
      caretRangeFromPoint: [Range, [core.int, core.int]],
      elementFromPoint: [Element, [core.int, core.int]],
      getCssCanvasContext: [CanvasRenderingContext, [core.String, core.String, core.int, core.int]],
      registerElement: [dart.void, [core.String, core.Type], {extendsTag: core.String}],
      register: [dart.void, [core.String, core.Type], {extendsTag: core.String}],
      createElementUpgrader: [ElementUpgrader, [core.Type], {extendsTag: core.String}]
    }),
    statics: () => ({_determineVisibilityChangeEventType: [core.String, [EventTarget]]}),
    names: ['_determineVisibilityChangeEventType']
  });
  HtmlDocument[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLDocument')), dart.const(new _js_helper.Native("HTMLDocument"))];
  HtmlDocument.visibilityChangeEvent = dart.const(new (_CustomEventStreamProvider$(Event))(HtmlDocument._determineVisibilityChangeEventType));
  class HtmlFormControlsCollection extends HtmlCollection {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(HtmlFormControlsCollection, {
    constructors: () => ({_: [HtmlFormControlsCollection, []]}),
    methods: () => ({namedItem: [core.Object, [core.String]]})
  });
  HtmlFormControlsCollection[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLFormControlsCollection')), dart.const(new _js_helper.Native("HTMLFormControlsCollection"))];
  class HtmlHtmlElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("html"), HtmlHtmlElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(HtmlHtmlElement, 'created');
  dart.setSignature(HtmlHtmlElement, {
    constructors: () => ({
      _: [HtmlHtmlElement, []],
      new: [HtmlHtmlElement, []],
      created: [HtmlHtmlElement, []]
    })
  });
  HtmlHtmlElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLHtmlElement')), dart.const(new _js_helper.Native("HTMLHtmlElement"))];
  class HtmlOptionsCollection extends HtmlCollection {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(HtmlOptionsCollection, {
    constructors: () => ({_: [HtmlOptionsCollection, []]})
  });
  HtmlOptionsCollection[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLOptionsCollection')), dart.const(new _js_helper.Native("HTMLOptionsCollection"))];
  class HttpRequestEventTarget extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onAbort() {
      return HttpRequestEventTarget.abortEvent.forTarget(this);
    }
    get onError() {
      return HttpRequestEventTarget.errorEvent.forTarget(this);
    }
    get onLoad() {
      return HttpRequestEventTarget.loadEvent.forTarget(this);
    }
    get onLoadEnd() {
      return HttpRequestEventTarget.loadEndEvent.forTarget(this);
    }
    get onLoadStart() {
      return HttpRequestEventTarget.loadStartEvent.forTarget(this);
    }
    get onProgress() {
      return HttpRequestEventTarget.progressEvent.forTarget(this);
    }
    get onTimeout() {
      return HttpRequestEventTarget.timeoutEvent.forTarget(this);
    }
  }
  dart.setSignature(HttpRequestEventTarget, {
    constructors: () => ({_: [HttpRequestEventTarget, []]})
  });
  HttpRequestEventTarget[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XMLHttpRequestEventTarget')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("XMLHttpRequestEventTarget"))];
  let _get_response = Symbol('_get_response');
  class HttpRequest extends HttpRequestEventTarget {
    static getString(url, opts) {
      let withCredentials = opts && 'withCredentials' in opts ? opts.withCredentials : null;
      let onProgress = opts && 'onProgress' in opts ? opts.onProgress : null;
      return dart.as(HttpRequest.request(url, {withCredentials: withCredentials, onProgress: onProgress}).then(dart.fn(xhr => xhr.responseText, core.String, [HttpRequest])), async.Future$(core.String));
    }
    static postFormData(url, data, opts) {
      let withCredentials = opts && 'withCredentials' in opts ? opts.withCredentials : null;
      let responseType = opts && 'responseType' in opts ? opts.responseType : null;
      let requestHeaders = opts && 'requestHeaders' in opts ? opts.requestHeaders : null;
      let onProgress = opts && 'onProgress' in opts ? opts.onProgress : null;
      let parts = [];
      data.forEach(dart.fn((key, value) => {
        dart.dsend(parts, 'add', `${core.Uri.encodeQueryComponent(dart.as(key, core.String))}=` + `${core.Uri.encodeQueryComponent(dart.as(value, core.String))}`);
      }));
      let formData = dart.dsend(parts, 'join', '&');
      if (requestHeaders == null) {
        requestHeaders = dart.map();
      }
      requestHeaders.putIfAbsent('Content-Type', dart.fn(() => 'application/x-www-form-urlencoded; charset=UTF-8', core.String, []));
      return HttpRequest.request(url, {method: 'POST', withCredentials: withCredentials, responseType: responseType, requestHeaders: requestHeaders, sendData: formData, onProgress: onProgress});
    }
    static request(url, opts) {
      let method = opts && 'method' in opts ? opts.method : null;
      let withCredentials = opts && 'withCredentials' in opts ? opts.withCredentials : null;
      let responseType = opts && 'responseType' in opts ? opts.responseType : null;
      let mimeType = opts && 'mimeType' in opts ? opts.mimeType : null;
      let requestHeaders = opts && 'requestHeaders' in opts ? opts.requestHeaders : null;
      let sendData = opts && 'sendData' in opts ? opts.sendData : null;
      let onProgress = opts && 'onProgress' in opts ? opts.onProgress : null;
      let completer = async.Completer$(HttpRequest).new();
      let xhr = HttpRequest.new();
      if (method == null) {
        method = 'GET';
      }
      dart.dsend(xhr, 'open', method, url, {async: true});
      if (withCredentials != null) {
        dart.dput(xhr, 'withCredentials', withCredentials);
      }
      if (responseType != null) {
        dart.dput(xhr, 'responseType', responseType);
      }
      if (mimeType != null) {
        dart.dsend(xhr, 'overrideMimeType', mimeType);
      }
      if (requestHeaders != null) {
        requestHeaders.forEach(dart.fn((header, value) => {
          dart.dsend(xhr, 'setRequestHeader', header, value);
        }));
      }
      if (onProgress != null) {
        dart.dsend(dart.dload(xhr, 'onProgress'), 'listen', onProgress);
      }
      dart.dsend(dart.dload(xhr, 'onLoad'), 'listen', dart.fn(e => {
        let accepted = dart.notNull(dart.as(dart.dsend(dart.dload(xhr, 'status'), '>=', 200), core.bool)) && dart.notNull(dart.as(dart.dsend(dart.dload(xhr, 'status'), '<', 300), core.bool));
        let fileUri = dart.equals(dart.dload(xhr, 'status'), 0);
        let notModified = dart.equals(dart.dload(xhr, 'status'), 304);
        let unknownRedirect = dart.notNull(dart.as(dart.dsend(dart.dload(xhr, 'status'), '>', 307), core.bool)) && dart.notNull(dart.as(dart.dsend(dart.dload(xhr, 'status'), '<', 400), core.bool));
        if (dart.notNull(dart.as(accepted, core.bool)) || dart.notNull(dart.as(fileUri, core.bool)) || dart.notNull(dart.as(notModified, core.bool)) || dart.notNull(dart.as(unknownRedirect, core.bool))) {
          dart.dsend(completer, 'complete', xhr);
        } else {
          dart.dsend(completer, 'completeError', e);
        }
      }));
      dart.dsend(dart.dload(xhr, 'onError'), 'listen', dart.dload(completer, 'completeError'));
      if (sendData != null) {
        dart.dsend(xhr, 'send', sendData);
      } else {
        dart.dsend(xhr, 'send');
      }
      return dart.as(dart.dload(completer, 'future'), async.Future$(HttpRequest));
    }
    static get supportsProgressEvent() {
      let xhr = HttpRequest.new();
      return dart.as("onprogress" in xhr, core.bool);
    }
    static get supportsCrossOrigin() {
      let xhr = HttpRequest.new();
      return dart.as("withCredentials" in xhr, core.bool);
    }
    static get supportsLoadEndEvent() {
      let xhr = HttpRequest.new();
      return dart.as("onloadend" in xhr, core.bool);
    }
    static get supportsOverrideMimeType() {
      let xhr = HttpRequest.new();
      return dart.as("overrideMimeType" in xhr, core.bool);
    }
    static requestCrossOrigin(url, opts) {
      let method = opts && 'method' in opts ? opts.method : null;
      let sendData = opts && 'sendData' in opts ? opts.sendData : null;
      if (dart.notNull(HttpRequest.supportsCrossOrigin)) {
        return dart.as(HttpRequest.request(url, {method: method, sendData: sendData}).then(dart.fn(xhr => {
          return dart.dload(xhr, 'responseText');
        })), async.Future$(core.String));
      }
      let completer = async.Completer$(core.String).new();
      if (method == null) {
        method = 'GET';
      }
      let xhr = new XDomainRequest();
      xhr.open(method, url);
      xhr.onload = _js_helper.convertDartClosureToJS(dart.fn(e => {
        let response = xhr.responseText;
        dart.dsend(completer, 'complete', response);
      }), 1);
      xhr.onerror = _js_helper.convertDartClosureToJS(dart.fn(e => {
        dart.dsend(completer, 'completeError', e);
      }), 1);
      xhr.onprogress = {};
      xhr.ontimeout = {};
      xhr.timeout = Number.MAX_VALUE;
      if (sendData != null) {
        xhr.send(sendData);
      } else {
        xhr.send();
      }
      return dart.as(dart.dload(completer, 'future'), async.Future$(core.String));
    }
    get responseHeaders() {
      let headers = dart.map();
      let headersString = this.getAllResponseHeaders();
      if (headersString == null) {
        return dart.as(headers, core.Map$(core.String, core.String));
      }
      let headersList = dart.dsend(headersString, 'split', '\r\n');
      for (let header of dart.as(headersList, core.Iterable)) {
        if (dart.notNull(dart.as(dart.dload(header, 'isEmpty'), core.bool))) {
          continue;
        }
        let splitIdx = dart.dsend(header, 'indexOf', ': ');
        if (dart.equals(splitIdx, -1)) {
          continue;
        }
        let key = dart.dsend(dart.dsend(header, 'substring', 0, splitIdx), 'toLowerCase');
        let value = dart.dsend(header, 'substring', dart.dsend(splitIdx, '+', 2));
        if (dart.notNull(dart.as(dart.dsend(headers, 'containsKey', key), core.bool))) {
          dart.dsetindex(headers, key, `${dart.dindex(headers, key)}, ${value}`);
        } else {
          dart.dsetindex(headers, key, value);
        }
      }
      return dart.as(headers, core.Map$(core.String, core.String));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return HttpRequest._create_1();
    }
    static _create_1() {
      return dart.as(new XMLHttpRequest(), HttpRequest);
    }
    get response() {
      return _convertNativeToDart_XHR_Response(this[_get_response]);
    }
    get onReadyStateChange() {
      return HttpRequest.readyStateChangeEvent.forTarget(this);
    }
  }
  dart.setSignature(HttpRequest, {
    constructors: () => ({
      _: [HttpRequest, []],
      new: [HttpRequest, []]
    }),
    methods: () => ({
      abort: [dart.void, []],
      getAllResponseHeaders: [core.String, []],
      getResponseHeader: [core.String, [core.String]],
      open: [dart.void, [core.String, core.String], {async: core.bool, user: core.String, password: core.String}],
      overrideMimeType: [dart.void, [core.String]],
      send: [dart.void, [], [dart.dynamic]],
      setRequestHeader: [dart.void, [core.String, core.String]]
    }),
    statics: () => ({
      getString: [async.Future$(core.String), [core.String], {withCredentials: core.bool, onProgress: dart.functionType(dart.void, [ProgressEvent])}],
      postFormData: [async.Future$(HttpRequest), [core.String, core.Map$(core.String, core.String)], {withCredentials: core.bool, responseType: core.String, requestHeaders: core.Map$(core.String, core.String), onProgress: dart.functionType(dart.void, [ProgressEvent])}],
      request: [async.Future$(HttpRequest), [core.String], {method: core.String, withCredentials: core.bool, responseType: core.String, mimeType: core.String, requestHeaders: core.Map$(core.String, core.String), sendData: dart.dynamic, onProgress: dart.functionType(dart.void, [ProgressEvent])}],
      requestCrossOrigin: [async.Future$(core.String), [core.String], {method: core.String, sendData: core.String}],
      _create_1: [HttpRequest, []]
    }),
    names: ['getString', 'postFormData', 'request', 'requestCrossOrigin', '_create_1']
  });
  HttpRequest[dart.metadata] = () => [dart.const(new _metadata.DomName('XMLHttpRequest')), dart.const(new _js_helper.Native("XMLHttpRequest"))];
  HttpRequest.readyStateChangeEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('readystatechange'));
  HttpRequest.DONE = 4;
  HttpRequest.HEADERS_RECEIVED = 2;
  HttpRequest.LOADING = 3;
  HttpRequest.OPENED = 1;
  HttpRequest.UNSENT = 0;
  HttpRequestEventTarget.abortEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('abort'));
  HttpRequestEventTarget.errorEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('error'));
  HttpRequestEventTarget.loadEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('load'));
  HttpRequestEventTarget.loadEndEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('loadend'));
  HttpRequestEventTarget.loadStartEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('loadstart'));
  HttpRequestEventTarget.progressEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('progress'));
  HttpRequestEventTarget.timeoutEvent = dart.const(new (EventStreamProvider$(ProgressEvent))('timeout'));
  class HttpRequestUpload extends HttpRequestEventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(HttpRequestUpload, {
    constructors: () => ({_: [HttpRequestUpload, []]})
  });
  HttpRequestUpload[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XMLHttpRequestUpload')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("XMLHttpRequestUpload"))];
  let _get_contentWindow = Symbol('_get_contentWindow');
  class IFrameElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("iframe"), IFrameElement);
    }
    created() {
      this.allowFullscreen = null;
      this[_get_contentWindow] = null;
      this.height = null;
      this.integrity = null;
      this.name = null;
      this.sandbox = null;
      this.src = null;
      this.srcdoc = null;
      this.width = null;
      super.created();
    }
    get contentWindow() {
      return _convertNativeToDart_Window(this[_get_contentWindow]);
    }
  }
  dart.defineNamedConstructor(IFrameElement, 'created');
  dart.setSignature(IFrameElement, {
    constructors: () => ({
      _: [IFrameElement, []],
      new: [IFrameElement, []],
      created: [IFrameElement, []]
    })
  });
  IFrameElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLIFrameElement')), dart.const(new _js_helper.Native("HTMLIFrameElement"))];
  class ImageBitmap extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ImageBitmap, {
    constructors: () => ({_: [ImageBitmap, []]})
  });
  ImageBitmap[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ImageBitmap')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ImageBitmap"))];
  class ImageData extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(data_OR_width, height_OR_width, height) {
      if (height === void 0)
        height = null;
      if ((typeof height_OR_width == 'number' || height_OR_width == null) && (typeof data_OR_width == 'number' || data_OR_width == null) && height == null) {
        return ImageData._create_1(data_OR_width, height_OR_width);
      }
      if ((typeof height_OR_width == 'number' || height_OR_width == null) && (dart.is(data_OR_width, typed_data.Uint8ClampedList) || data_OR_width == null) && height == null) {
        return ImageData._create_2(data_OR_width, height_OR_width);
      }
      if ((typeof height == 'number' || height == null) && (typeof height_OR_width == 'number' || height_OR_width == null) && (dart.is(data_OR_width, typed_data.Uint8ClampedList) || data_OR_width == null)) {
        return ImageData._create_3(data_OR_width, height_OR_width, height);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1(data_OR_width, height_OR_width) {
      return dart.as(new ImageData(data_OR_width, height_OR_width), ImageData);
    }
    static _create_2(data_OR_width, height_OR_width) {
      return dart.as(new ImageData(data_OR_width, height_OR_width), ImageData);
    }
    static _create_3(data_OR_width, height_OR_width, height) {
      return dart.as(new ImageData(data_OR_width, height_OR_width, height), ImageData);
    }
  }
  dart.setSignature(ImageData, {
    constructors: () => ({
      _: [ImageData, []],
      new: [ImageData, [dart.dynamic, core.int], [core.int]]
    }),
    statics: () => ({
      _create_1: [ImageData, [dart.dynamic, dart.dynamic]],
      _create_2: [ImageData, [dart.dynamic, dart.dynamic]],
      _create_3: [ImageData, [dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3']
  });
  ImageData[dart.metadata] = () => [dart.const(new _metadata.DomName('ImageData')), dart.const(new _js_helper.Native("ImageData"))];
  class ImageElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(opts) {
      let src = opts && 'src' in opts ? opts.src : null;
      let width = opts && 'width' in opts ? opts.width : null;
      let height = opts && 'height' in opts ? opts.height : null;
      let e = exports.document.createElement("img");
      if (src != null)
        dart.dput(e, 'src', src);
      if (width != null)
        dart.dput(e, 'width', width);
      if (height != null)
        dart.dput(e, 'height', height);
      return dart.as(e, ImageElement);
    }
    created() {
      this.alt = null;
      this.complete = null;
      this.crossOrigin = null;
      this.currentSrc = null;
      this.height = null;
      this.integrity = null;
      this.isMap = null;
      this.naturalHeight = null;
      this.naturalWidth = null;
      this.sizes = null;
      this.src = null;
      this.srcset = null;
      this.useMap = null;
      this.width = null;
      super.created();
    }
  }
  ImageElement[dart.implements] = () => [CanvasImageSource];
  dart.defineNamedConstructor(ImageElement, 'created');
  dart.setSignature(ImageElement, {
    constructors: () => ({
      _: [ImageElement, []],
      new: [ImageElement, [], {src: core.String, width: core.int, height: core.int}],
      created: [ImageElement, []]
    })
  });
  ImageElement[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLImageElement')), dart.const(new _js_helper.Native("HTMLImageElement"))];
  class InjectedScriptHost extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(InjectedScriptHost, {
    constructors: () => ({_: [InjectedScriptHost, []]}),
    methods: () => ({inspect: [dart.void, [core.Object, core.Object]]})
  });
  InjectedScriptHost[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('InjectedScriptHost')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("InjectedScriptHost"))];
  let _get_valueAsDate = Symbol('_get_valueAsDate');
  let _set_valueAsDate = Symbol('_set_valueAsDate');
  class InputElement extends HtmlElement {
    static new(opts) {
      let type = opts && 'type' in opts ? opts.type : null;
      let e = exports.document.createElement("input");
      if (type != null) {
        try {
          dart.dput(e, 'type', type);
        } catch (_) {
        }

      }
      return dart.as(e, InputElement);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this.accept = null;
      this.alt = null;
      this.autocomplete = null;
      this.autofocus = null;
      this.capture = null;
      this.checked = null;
      this.defaultChecked = null;
      this.defaultValue = null;
      this.dirName = null;
      this.disabled = null;
      this.files = null;
      this.form = null;
      this.formAction = null;
      this.formEnctype = null;
      this.formMethod = null;
      this.formNoValidate = null;
      this.formTarget = null;
      this.height = null;
      this.incremental = null;
      this.indeterminate = null;
      this.inputMode = null;
      this.labels = null;
      this.list = null;
      this.max = null;
      this.maxLength = null;
      this.min = null;
      this.multiple = null;
      this.name = null;
      this.pattern = null;
      this.placeholder = null;
      this.readOnly = null;
      this.required = null;
      this.selectionDirection = null;
      this.selectionEnd = null;
      this.selectionStart = null;
      this.size = null;
      this.src = null;
      this.step = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.value = null;
      this[_get_valueAsDate] = null;
      this.valueAsNumber = null;
      this.entries = null;
      this.directory = null;
      this.width = null;
      this.willValidate = null;
      super.created();
    }
    get valueAsDate() {
      return html_common.convertNativeToDart_DateTime(this[_get_valueAsDate]);
    }
    set valueAsDate(value) {
      this[_set_valueAsDate] = html_common.convertDartToNative_DateTime(value);
    }
    set [_set_valueAsDate](value) {
      this.valueAsDate = value;
    }
  }
  InputElement[dart.implements] = () => [HiddenInputElement, SearchInputElement, TextInputElement, UrlInputElement, TelephoneInputElement, EmailInputElement, PasswordInputElement, DateInputElement, MonthInputElement, WeekInputElement, TimeInputElement, LocalDateTimeInputElement, NumberInputElement, RangeInputElement, CheckboxInputElement, RadioButtonInputElement, FileUploadInputElement, SubmitButtonInputElement, ImageButtonInputElement, ResetButtonInputElement, ButtonInputElement];
  dart.defineNamedConstructor(InputElement, 'created');
  dart.setSignature(InputElement, {
    constructors: () => ({
      new: [InputElement, [], {type: core.String}],
      _: [InputElement, []],
      created: [InputElement, []]
    }),
    methods: () => ({
      checkValidity: [core.bool, []],
      select: [dart.void, []],
      setCustomValidity: [dart.void, [core.String]],
      setRangeText: [dart.void, [core.String], {start: core.int, end: core.int, selectionMode: core.String}],
      setSelectionRange: [dart.void, [core.int, core.int], [core.String]],
      stepDown: [dart.void, [], [core.int]],
      stepUp: [dart.void, [], [core.int]]
    })
  });
  InputElement[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLInputElement')), dart.const(new _js_helper.Native("HTMLInputElement"))];
  class InputElementBase extends core.Object {
    InputElementBase() {
      this.autofocus = null;
      this.disabled = null;
      this.incremental = null;
      this.indeterminate = null;
      this.name = null;
      this.value = null;
    }
  }
  InputElementBase[dart.implements] = () => [Element];
  class HiddenInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'hidden'});
    }
  }
  HiddenInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(HiddenInputElement, {
    constructors: () => ({new: [HiddenInputElement, []]})
  });
  class TextInputElementBase extends core.Object {
    TextInputElementBase() {
      this.autocomplete = null;
      this.maxLength = null;
      this.pattern = null;
      this.placeholder = null;
      this.readOnly = null;
      this.required = null;
      this.size = null;
      this.selectionDirection = null;
      this.selectionEnd = null;
      this.selectionStart = null;
    }
  }
  TextInputElementBase[dart.implements] = () => [InputElementBase];
  class SearchInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'search'});
    }
    static get supported() {
      return InputElement.new({type: 'search'}).type == 'search';
    }
  }
  SearchInputElement[dart.implements] = () => [TextInputElementBase];
  dart.setSignature(SearchInputElement, {
    constructors: () => ({new: [SearchInputElement, []]})
  });
  SearchInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI))];
  class TextInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'text'});
    }
  }
  TextInputElement[dart.implements] = () => [TextInputElementBase];
  dart.setSignature(TextInputElement, {
    constructors: () => ({new: [TextInputElement, []]})
  });
  class UrlInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'url'});
    }
    static get supported() {
      return InputElement.new({type: 'url'}).type == 'url';
    }
  }
  UrlInputElement[dart.implements] = () => [TextInputElementBase];
  dart.setSignature(UrlInputElement, {
    constructors: () => ({new: [UrlInputElement, []]})
  });
  UrlInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI))];
  class TelephoneInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'tel'});
    }
    static get supported() {
      return InputElement.new({type: 'tel'}).type == 'tel';
    }
  }
  TelephoneInputElement[dart.implements] = () => [TextInputElementBase];
  dart.setSignature(TelephoneInputElement, {
    constructors: () => ({new: [TelephoneInputElement, []]})
  });
  TelephoneInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI))];
  class EmailInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'email'});
    }
    static get supported() {
      return InputElement.new({type: 'email'}).type == 'email';
    }
  }
  EmailInputElement[dart.implements] = () => [TextInputElementBase];
  dart.setSignature(EmailInputElement, {
    constructors: () => ({new: [EmailInputElement, []]})
  });
  EmailInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI))];
  class PasswordInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'password'});
    }
  }
  PasswordInputElement[dart.implements] = () => [TextInputElementBase];
  dart.setSignature(PasswordInputElement, {
    constructors: () => ({new: [PasswordInputElement, []]})
  });
  class RangeInputElementBase extends core.Object {
    RangeInputElementBase() {
      this.max = null;
      this.min = null;
      this.step = null;
      this.valueAsNumber = null;
    }
  }
  RangeInputElementBase[dart.implements] = () => [InputElementBase];
  class DateInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'date'});
    }
    static get supported() {
      return InputElement.new({type: 'date'}).type == 'date';
    }
  }
  DateInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(DateInputElement, {
    constructors: () => ({new: [DateInputElement, []]})
  });
  DateInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental())];
  class MonthInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'month'});
    }
    static get supported() {
      return InputElement.new({type: 'month'}).type == 'month';
    }
  }
  MonthInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(MonthInputElement, {
    constructors: () => ({new: [MonthInputElement, []]})
  });
  MonthInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental())];
  class WeekInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'week'});
    }
    static get supported() {
      return InputElement.new({type: 'week'}).type == 'week';
    }
  }
  WeekInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(WeekInputElement, {
    constructors: () => ({new: [WeekInputElement, []]})
  });
  WeekInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental())];
  class TimeInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'time'});
    }
    static get supported() {
      return InputElement.new({type: 'time'}).type == 'time';
    }
  }
  TimeInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(TimeInputElement, {
    constructors: () => ({new: [TimeInputElement, []]})
  });
  TimeInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental())];
  class LocalDateTimeInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'datetime-local'});
    }
    static get supported() {
      return InputElement.new({type: 'datetime-local'}).type == 'datetime-local';
    }
  }
  LocalDateTimeInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(LocalDateTimeInputElement, {
    constructors: () => ({new: [LocalDateTimeInputElement, []]})
  });
  LocalDateTimeInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental())];
  class NumberInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'number'});
    }
    static get supported() {
      return InputElement.new({type: 'number'}).type == 'number';
    }
  }
  NumberInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(NumberInputElement, {
    constructors: () => ({new: [NumberInputElement, []]})
  });
  NumberInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental())];
  class RangeInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'range'});
    }
    static get supported() {
      return InputElement.new({type: 'range'}).type == 'range';
    }
  }
  RangeInputElement[dart.implements] = () => [RangeInputElementBase];
  dart.setSignature(RangeInputElement, {
    constructors: () => ({new: [RangeInputElement, []]})
  });
  RangeInputElement[dart.metadata] = () => [dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.Experimental())];
  class CheckboxInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'checkbox'});
    }
  }
  CheckboxInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(CheckboxInputElement, {
    constructors: () => ({new: [CheckboxInputElement, []]})
  });
  class RadioButtonInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'radio'});
    }
  }
  RadioButtonInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(RadioButtonInputElement, {
    constructors: () => ({new: [RadioButtonInputElement, []]})
  });
  class FileUploadInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'file'});
    }
  }
  FileUploadInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(FileUploadInputElement, {
    constructors: () => ({new: [FileUploadInputElement, []]})
  });
  class SubmitButtonInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'submit'});
    }
  }
  SubmitButtonInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(SubmitButtonInputElement, {
    constructors: () => ({new: [SubmitButtonInputElement, []]})
  });
  class ImageButtonInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'image'});
    }
  }
  ImageButtonInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(ImageButtonInputElement, {
    constructors: () => ({new: [ImageButtonInputElement, []]})
  });
  class ResetButtonInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'reset'});
    }
  }
  ResetButtonInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(ResetButtonInputElement, {
    constructors: () => ({new: [ResetButtonInputElement, []]})
  });
  class ButtonInputElement extends core.Object {
    static new() {
      return InputElement.new({type: 'button'});
    }
  }
  ButtonInputElement[dart.implements] = () => [InputElementBase];
  dart.setSignature(ButtonInputElement, {
    constructors: () => ({new: [ButtonInputElement, []]})
  });
  class InputMethodContext extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(InputMethodContext, {
    constructors: () => ({_: [InputMethodContext, []]}),
    methods: () => ({confirmComposition: [dart.void, []]})
  });
  InputMethodContext[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('InputMethodContext')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("InputMethodContext"))];
  class InstallEvent extends ExtendableEvent {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(InstallEvent, {
    constructors: () => ({_: [InstallEvent, []]}),
    methods: () => ({
      reloadAll: [async.Future, []],
      replace: [dart.void, []]
    })
  });
  InstallEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('InstallEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("InstallEvent"))];
  KeyboardEvent.DOM_KEY_LOCATION_LEFT = 1;
  KeyboardEvent.DOM_KEY_LOCATION_NUMPAD = 3;
  KeyboardEvent.DOM_KEY_LOCATION_RIGHT = 2;
  KeyboardEvent.DOM_KEY_LOCATION_STANDARD = 0;
  class KeygenElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("keygen"), KeygenElement);
    }
    created() {
      this.autofocus = null;
      this.challenge = null;
      this.disabled = null;
      this.form = null;
      this.keytype = null;
      this.labels = null;
      this.name = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.willValidate = null;
      super.created();
    }
    static get supported() {
      return dart.notNull(Element.isTagSupported('keygen')) && dart.is(Element.tag('keygen'), KeygenElement);
    }
  }
  dart.defineNamedConstructor(KeygenElement, 'created');
  dart.setSignature(KeygenElement, {
    constructors: () => ({
      _: [KeygenElement, []],
      new: [KeygenElement, []],
      created: [KeygenElement, []]
    }),
    methods: () => ({
      checkValidity: [core.bool, []],
      setCustomValidity: [dart.void, [core.String]]
    })
  });
  KeygenElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLKeygenElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLKeygenElement"))];
  class LIElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("li"), LIElement);
    }
    created() {
      this.value = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(LIElement, 'created');
  dart.setSignature(LIElement, {
    constructors: () => ({
      _: [LIElement, []],
      new: [LIElement, []],
      created: [LIElement, []]
    })
  });
  LIElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLLIElement')), dart.const(new _js_helper.Native("HTMLLIElement"))];
  class LabelElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("label"), LabelElement);
    }
    created() {
      this.control = null;
      this.form = null;
      this.htmlFor = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(LabelElement, 'created');
  dart.setSignature(LabelElement, {
    constructors: () => ({
      _: [LabelElement, []],
      new: [LabelElement, []],
      created: [LabelElement, []]
    })
  });
  LabelElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLLabelElement')), dart.const(new _js_helper.Native("HTMLLabelElement"))];
  class LegendElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("legend"), LegendElement);
    }
    created() {
      this.form = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(LegendElement, 'created');
  dart.setSignature(LegendElement, {
    constructors: () => ({
      _: [LegendElement, []],
      new: [LegendElement, []],
      created: [LegendElement, []]
    })
  });
  LegendElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLLegendElement')), dart.const(new _js_helper.Native("HTMLLegendElement"))];
  class LinkElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("link"), LinkElement);
    }
    created() {
      this.crossOrigin = null;
      this.disabled = null;
      this.href = null;
      this.hreflang = null;
      this.import = null;
      this.integrity = null;
      this.media = null;
      this.rel = null;
      this.sheet = null;
      this.sizes = null;
      this.type = null;
      super.created();
    }
    get supportsImport() {
      return dart.as("import" in this, core.bool);
    }
  }
  dart.defineNamedConstructor(LinkElement, 'created');
  dart.setSignature(LinkElement, {
    constructors: () => ({
      _: [LinkElement, []],
      new: [LinkElement, []],
      created: [LinkElement, []]
    })
  });
  LinkElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLLinkElement')), dart.const(new _js_helper.Native("HTMLLinkElement"))];
  class LocalCredential extends Credential {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(id, name, avatarURL, password) {
      return LocalCredential._create_1(id, name, avatarURL, password);
    }
    static _create_1(id, name, avatarURL, password) {
      return dart.as(new LocalCredential(id, name, avatarURL, password), LocalCredential);
    }
  }
  dart.setSignature(LocalCredential, {
    constructors: () => ({
      _: [LocalCredential, []],
      new: [LocalCredential, [core.String, core.String, core.String, core.String]]
    }),
    statics: () => ({_create_1: [LocalCredential, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]}),
    names: ['_create_1']
  });
  LocalCredential[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('LocalCredential')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("LocalCredential"))];
  class Location extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get origin() {
      if (dart.notNull(dart.as("origin" in this, core.bool))) {
        return dart.as(this.origin, core.String);
      }
      return `${this.protocol}//${this.host}`;
    }
    toString() {
      return dart.as(String(this), core.String);
    }
  }
  Location[dart.implements] = () => [LocationBase];
  dart.setSignature(Location, {
    constructors: () => ({_: [Location, []]}),
    methods: () => ({
      assign: [dart.void, [], [core.String]],
      reload: [dart.void, []],
      replace: [dart.void, [core.String]]
    })
  });
  dart.defineExtensionMembers(Location, ['toString']);
  Location[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Location')), dart.const(new _js_helper.Native("Location"))];
  let MidiErrorCallback = dart.typedef('MidiErrorCallback', () => dart.functionType(dart.void, [DomError]));
  let MidiSuccessCallback = dart.typedef('MidiSuccessCallback', () => dart.functionType(dart.void, [MidiAccess, core.bool]));
  class MapElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("map"), MapElement);
    }
    created() {
      this.areas = null;
      this.name = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(MapElement, 'created');
  dart.setSignature(MapElement, {
    constructors: () => ({
      _: [MapElement, []],
      new: [MapElement, []],
      created: [MapElement, []]
    })
  });
  MapElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMapElement')), dart.const(new _js_helper.Native("HTMLMapElement"))];
  class MediaController extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return MediaController._create_1();
    }
    static _create_1() {
      return dart.as(new MediaController(), MediaController);
    }
  }
  dart.setSignature(MediaController, {
    constructors: () => ({
      _: [MediaController, []],
      new: [MediaController, []]
    }),
    methods: () => ({
      pause: [dart.void, []],
      play: [dart.void, []],
      unpause: [dart.void, []]
    }),
    statics: () => ({_create_1: [MediaController, []]}),
    names: ['_create_1']
  });
  MediaController[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaController')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaController"))];
  class MediaDeviceInfo extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaDeviceInfo, {
    constructors: () => ({_: [MediaDeviceInfo, []]})
  });
  MediaDeviceInfo[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaDeviceInfo')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaDeviceInfo"))];
  let MediaDeviceInfoCallback = dart.typedef('MediaDeviceInfoCallback', () => dart.functionType(dart.void, [core.List$(MediaDeviceInfo)]));
  class MediaKeyEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaKeyEvent, {
    constructors: () => ({_: [MediaKeyEvent, []]})
  });
  MediaKeyEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaKeyEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaKeyEvent"))];
  MediaElement.keyAddedEvent = dart.const(new (EventStreamProvider$(MediaKeyEvent))('webkitkeyadded'));
  MediaElement.keyErrorEvent = dart.const(new (EventStreamProvider$(MediaKeyEvent))('webkitkeyerror'));
  MediaElement.keyMessageEvent = dart.const(new (EventStreamProvider$(MediaKeyEvent))('webkitkeymessage'));
  MediaElement.needKeyEvent = dart.const(new (EventStreamProvider$(MediaKeyEvent))('webkitneedkey'));
  MediaElement.HAVE_CURRENT_DATA = 2;
  MediaElement.HAVE_ENOUGH_DATA = 4;
  MediaElement.HAVE_FUTURE_DATA = 3;
  MediaElement.HAVE_METADATA = 1;
  MediaElement.HAVE_NOTHING = 0;
  MediaElement.NETWORK_EMPTY = 0;
  MediaElement.NETWORK_IDLE = 1;
  MediaElement.NETWORK_LOADING = 2;
  MediaElement.NETWORK_NO_SOURCE = 3;
  class MediaError extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaError, {
    constructors: () => ({_: [MediaError, []]})
  });
  MediaError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaError')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("MediaError"))];
  MediaError.MEDIA_ERR_ABORTED = 1;
  MediaError.MEDIA_ERR_DECODE = 3;
  MediaError.MEDIA_ERR_ENCRYPTED = 5;
  MediaError.MEDIA_ERR_NETWORK = 2;
  MediaError.MEDIA_ERR_SRC_NOT_SUPPORTED = 4;
  class MediaKeyError extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaKeyError, {
    constructors: () => ({_: [MediaKeyError, []]})
  });
  MediaKeyError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaKeyError')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaKeyError"))];
  MediaKeyError.MEDIA_KEYERR_CLIENT = 2;
  MediaKeyError.MEDIA_KEYERR_DOMAIN = 6;
  MediaKeyError.MEDIA_KEYERR_HARDWARECHANGE = 5;
  MediaKeyError.MEDIA_KEYERR_OUTPUT = 4;
  MediaKeyError.MEDIA_KEYERR_SERVICE = 3;
  MediaKeyError.MEDIA_KEYERR_UNKNOWN = 1;
  class MediaKeyMessageEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaKeyMessageEvent, {
    constructors: () => ({_: [MediaKeyMessageEvent, []]})
  });
  MediaKeyMessageEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaKeyMessageEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaKeyMessageEvent"))];
  class MediaKeyNeededEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaKeyNeededEvent, {
    constructors: () => ({_: [MediaKeyNeededEvent, []]})
  });
  MediaKeyNeededEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaKeyNeededEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaKeyNeededEvent"))];
  let _update = Symbol('_update');
  class MediaKeySession extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaKeySession, {
    constructors: () => ({_: [MediaKeySession, []]}),
    methods: () => ({
      generateRequest: [async.Future, [core.String, dart.dynamic]],
      release: [async.Future, []],
      [_update]: [async.Future, [dart.dynamic]]
    })
  });
  MediaKeySession[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaKeySession')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaKeySession"))];
  let _createSession = Symbol('_createSession');
  class MediaKeys extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaKeys, {
    constructors: () => ({_: [MediaKeys, []]}),
    methods: () => ({[_createSession]: [MediaKeySession, [], [core.String]]}),
    statics: () => ({
      create: [async.Future, [core.String]],
      isTypeSupported: [core.bool, [core.String, core.String]]
    }),
    names: ['create', 'isTypeSupported']
  });
  MediaKeys[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaKeys')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaKeys"))];
  class MediaList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaList, {
    constructors: () => ({_: [MediaList, []]}),
    methods: () => ({
      appendMedium: [dart.void, [core.String]],
      deleteMedium: [dart.void, [core.String]],
      item: [core.String, [core.int]]
    })
  });
  MediaList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("MediaList"))];
  class MediaQueryList extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onChange() {
      return MediaQueryList.changeEvent.forTarget(this);
    }
  }
  dart.setSignature(MediaQueryList, {
    constructors: () => ({_: [MediaQueryList, []]}),
    methods: () => ({
      addListener: [dart.void, [EventListener]],
      removeListener: [dart.void, [EventListener]]
    })
  });
  MediaQueryList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaQueryList')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("MediaQueryList"))];
  MediaQueryList.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  class MediaQueryListEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MediaQueryListEvent, {
    constructors: () => ({_: [MediaQueryListEvent, []]})
  });
  MediaQueryListEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaQueryListEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaQueryListEvent"))];
  class MediaSource extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return MediaSource._create_1();
    }
    static _create_1() {
      return dart.as(new MediaSource(), MediaSource);
    }
    static get supported() {
      return dart.as(!!window.MediaSource, core.bool);
    }
  }
  dart.setSignature(MediaSource, {
    constructors: () => ({
      _: [MediaSource, []],
      new: [MediaSource, []]
    }),
    methods: () => ({
      addSourceBuffer: [SourceBuffer, [core.String]],
      endOfStream: [dart.void, [], [core.String]],
      removeSourceBuffer: [dart.void, [SourceBuffer]]
    }),
    statics: () => ({
      _create_1: [MediaSource, []],
      isTypeSupported: [core.bool, [core.String]]
    }),
    names: ['_create_1', 'isTypeSupported']
  });
  MediaSource[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaSource')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '11')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaSource"))];
  class MediaStream extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(stream_OR_tracks) {
      if (stream_OR_tracks === void 0)
        stream_OR_tracks = null;
      if (stream_OR_tracks == null) {
        return MediaStream._create_1();
      }
      if (dart.is(stream_OR_tracks, MediaStream) || stream_OR_tracks == null) {
        return MediaStream._create_2(stream_OR_tracks);
      }
      if (dart.is(stream_OR_tracks, core.List$(MediaStreamTrack)) || stream_OR_tracks == null) {
        return MediaStream._create_3(stream_OR_tracks);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1() {
      return dart.as(new MediaStream(), MediaStream);
    }
    static _create_2(stream_OR_tracks) {
      return dart.as(new MediaStream(stream_OR_tracks), MediaStream);
    }
    static _create_3(stream_OR_tracks) {
      return dart.as(new MediaStream(stream_OR_tracks), MediaStream);
    }
    get onAddTrack() {
      return MediaStream.addTrackEvent.forTarget(this);
    }
    get onEnded() {
      return MediaStream.endedEvent.forTarget(this);
    }
    get onRemoveTrack() {
      return MediaStream.removeTrackEvent.forTarget(this);
    }
    static get supported() {
      return dart.as(!!(exports.window.navigator.getUserMedia || exports.window.navigator.webkitGetUserMedia || exports.window.navigator.mozGetUserMedia || exports.window.navigator.msGetUserMedia), core.bool);
    }
  }
  dart.setSignature(MediaStream, {
    constructors: () => ({
      _: [MediaStream, []],
      new: [MediaStream, [], [dart.dynamic]]
    }),
    methods: () => ({
      addTrack: [dart.void, [MediaStreamTrack]],
      clone: [MediaStream, []],
      getAudioTracks: [core.List$(MediaStreamTrack), []],
      getTrackById: [MediaStreamTrack, [core.String]],
      getTracks: [core.List$(MediaStreamTrack), []],
      getVideoTracks: [core.List$(MediaStreamTrack), []],
      removeTrack: [dart.void, [MediaStreamTrack]],
      stop: [dart.void, []]
    }),
    statics: () => ({
      _create_1: [MediaStream, []],
      _create_2: [MediaStream, [dart.dynamic]],
      _create_3: [MediaStream, [dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3']
  });
  MediaStream[dart.metadata] = () => [dart.const(new _metadata.DomName('MediaStream')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaStream"))];
  MediaStream.addTrackEvent = dart.const(new (EventStreamProvider$(Event))('addtrack'));
  MediaStream.endedEvent = dart.const(new (EventStreamProvider$(Event))('ended'));
  MediaStream.removeTrackEvent = dart.const(new (EventStreamProvider$(Event))('removetrack'));
  class MediaStreamEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return html_common.Device.isEventTypeSupported('MediaStreamEvent');
    }
  }
  dart.setSignature(MediaStreamEvent, {
    constructors: () => ({_: [MediaStreamEvent, []]})
  });
  MediaStreamEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaStreamEvent')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaStreamEvent"))];
  class MediaStreamTrack extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static getSources() {
      let completer = async.Completer$(core.List$(SourceInfo)).new();
      MediaStreamTrack._getSources(dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(core.List$(SourceInfo)));
    }
    get onEnded() {
      return MediaStreamTrack.endedEvent.forTarget(this);
    }
    get onMute() {
      return MediaStreamTrack.muteEvent.forTarget(this);
    }
    get onUnmute() {
      return MediaStreamTrack.unmuteEvent.forTarget(this);
    }
  }
  dart.setSignature(MediaStreamTrack, {
    constructors: () => ({_: [MediaStreamTrack, []]}),
    methods: () => ({
      clone: [MediaStreamTrack, []],
      stop: [dart.void, []]
    }),
    statics: () => ({
      _getSources: [dart.void, [MediaStreamTrackSourcesCallback]],
      getSources: [async.Future$(core.List$(SourceInfo)), []]
    }),
    names: ['_getSources', 'getSources']
  });
  MediaStreamTrack[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaStreamTrack')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaStreamTrack"))];
  MediaStreamTrack.endedEvent = dart.const(new (EventStreamProvider$(Event))('ended'));
  MediaStreamTrack.muteEvent = dart.const(new (EventStreamProvider$(Event))('mute'));
  MediaStreamTrack.unmuteEvent = dart.const(new (EventStreamProvider$(Event))('unmute'));
  class MediaStreamTrackEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return html_common.Device.isEventTypeSupported('MediaStreamTrackEvent');
    }
  }
  dart.setSignature(MediaStreamTrackEvent, {
    constructors: () => ({_: [MediaStreamTrackEvent, []]})
  });
  MediaStreamTrackEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MediaStreamTrackEvent')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MediaStreamTrackEvent"))];
  let MediaStreamTrackSourcesCallback = dart.typedef('MediaStreamTrackSourcesCallback', () => dart.functionType(dart.void, [core.List$(SourceInfo)]));
  class MemoryInfo extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MemoryInfo, {
    constructors: () => ({_: [MemoryInfo, []]})
  });
  MemoryInfo[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MemoryInfo')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MemoryInfo"))];
  class MenuElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("menu"), MenuElement);
    }
    created() {
      this.label = null;
      this.type = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(MenuElement, 'created');
  dart.setSignature(MenuElement, {
    constructors: () => ({
      _: [MenuElement, []],
      new: [MenuElement, []],
      created: [MenuElement, []]
    })
  });
  MenuElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMenuElement')), dart.const(new _js_helper.Native("HTMLMenuElement"))];
  class MenuItemElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this.checked = null;
      this.defaultValue = null;
      this.disabled = null;
      this.label = null;
      this.type = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(MenuItemElement, 'created');
  dart.setSignature(MenuItemElement, {
    constructors: () => ({
      _: [MenuItemElement, []],
      created: [MenuItemElement, []]
    })
  });
  MenuItemElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMenuItemElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLMenuItemElement"))];
  class MessageChannel extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MessageChannel, {
    constructors: () => ({_: [MessageChannel, []]})
  });
  MessageChannel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MessageChannel')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("MessageChannel"))];
  let _postMessage_1 = Symbol('_postMessage_1');
  let _postMessage_2 = Symbol('_postMessage_2');
  class MessagePort extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    postMessage(message, transfer) {
      if (transfer === void 0)
        transfer = null;
      if (transfer != null) {
        let message_1 = html_common.convertDartToNative_SerializedScriptValue(message);
        this[_postMessage_1](message_1, transfer);
        return;
      }
      let message_1 = html_common.convertDartToNative_SerializedScriptValue(message);
      this[_postMessage_2](message_1);
      return;
    }
    get onMessage() {
      return MessagePort.messageEvent.forTarget(this);
    }
  }
  dart.setSignature(MessagePort, {
    constructors: () => ({_: [MessagePort, []]}),
    methods: () => ({
      close: [dart.void, []],
      postMessage: [dart.void, [dart.dynamic], [core.List$(MessagePort)]],
      [_postMessage_1]: [dart.void, [dart.dynamic, core.List$(MessagePort)]],
      [_postMessage_2]: [dart.void, [dart.dynamic]],
      start: [dart.void, []]
    })
  });
  MessagePort[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MessagePort')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("MessagePort"))];
  MessagePort.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  class MetaElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("meta"), MetaElement);
    }
    created() {
      this.content = null;
      this.httpEquiv = null;
      this.name = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(MetaElement, 'created');
  dart.setSignature(MetaElement, {
    constructors: () => ({
      _: [MetaElement, []],
      new: [MetaElement, []],
      created: [MetaElement, []]
    })
  });
  MetaElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMetaElement')), dart.const(new _js_helper.Native("HTMLMetaElement"))];
  let _get_modificationTime = Symbol('_get_modificationTime');
  class Metadata extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get modificationTime() {
      return html_common.convertNativeToDart_DateTime(this[_get_modificationTime]);
    }
  }
  dart.setSignature(Metadata, {
    constructors: () => ({_: [Metadata, []]})
  });
  Metadata[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Metadata')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Metadata"))];
  let MetadataCallback = dart.typedef('MetadataCallback', () => dart.functionType(dart.void, [Metadata]));
  class MeterElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("meter"), MeterElement);
    }
    created() {
      this.high = null;
      this.labels = null;
      this.low = null;
      this.max = null;
      this.min = null;
      this.optimum = null;
      this.value = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('meter');
    }
  }
  dart.defineNamedConstructor(MeterElement, 'created');
  dart.setSignature(MeterElement, {
    constructors: () => ({
      _: [MeterElement, []],
      new: [MeterElement, []],
      created: [MeterElement, []]
    })
  });
  MeterElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMeterElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLMeterElement"))];
  class MidiAccess extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onConnect() {
      return MidiAccess.connectEvent.forTarget(this);
    }
    get onDisconnect() {
      return MidiAccess.disconnectEvent.forTarget(this);
    }
  }
  dart.setSignature(MidiAccess, {
    constructors: () => ({_: [MidiAccess, []]})
  });
  MidiAccess[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIAccess')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIAccess"))];
  class MidiConnectionEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MidiConnectionEvent, {
    constructors: () => ({_: [MidiConnectionEvent, []]})
  });
  MidiConnectionEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIConnectionEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIConnectionEvent"))];
  MidiAccess.connectEvent = dart.const(new (EventStreamProvider$(MidiConnectionEvent))('connect'));
  MidiAccess.disconnectEvent = dart.const(new (EventStreamProvider$(MidiConnectionEvent))('disconnect'));
  class MidiPort extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onDisconnect() {
      return MidiPort.disconnectEvent.forTarget(this);
    }
  }
  dart.setSignature(MidiPort, {
    constructors: () => ({_: [MidiPort, []]})
  });
  MidiPort[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIPort')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIPort"))];
  class MidiInput extends MidiPort {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onMidiMessage() {
      return MidiInput.midiMessageEvent.forTarget(this);
    }
  }
  dart.setSignature(MidiInput, {
    constructors: () => ({_: [MidiInput, []]})
  });
  MidiInput[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIInput')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIInput"))];
  class MidiMessageEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MidiMessageEvent, {
    constructors: () => ({_: [MidiMessageEvent, []]})
  });
  MidiMessageEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIMessageEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIMessageEvent"))];
  MidiInput.midiMessageEvent = dart.const(new (EventStreamProvider$(MidiMessageEvent))('midimessage'));
  class MidiInputMap extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MidiInputMap, {
    constructors: () => ({_: [MidiInputMap, []]}),
    methods: () => ({
      entries: [DomIterator, []],
      get: [core.Object, [core.String]],
      has: [core.bool, [core.String]],
      keys: [DomIterator, []],
      values: [DomIterator, []]
    })
  });
  MidiInputMap[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIInputMap')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIInputMap"))];
  class MidiOutput extends MidiPort {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MidiOutput, {
    constructors: () => ({_: [MidiOutput, []]}),
    methods: () => ({send: [dart.void, [typed_data.Uint8List], [core.num]]})
  });
  MidiOutput[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIOutput')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIOutput"))];
  class MidiOutputMap extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MidiOutputMap, {
    constructors: () => ({_: [MidiOutputMap, []]}),
    methods: () => ({
      entries: [DomIterator, []],
      get: [core.Object, [core.String]],
      has: [core.bool, [core.String]],
      keys: [DomIterator, []],
      values: [DomIterator, []]
    })
  });
  MidiOutputMap[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MIDIOutputMap')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MIDIOutputMap"))];
  MidiPort.disconnectEvent = dart.const(new (EventStreamProvider$(MidiConnectionEvent))('disconnect'));
  class MimeType extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MimeType, {
    constructors: () => ({_: [MimeType, []]})
  });
  MimeType[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MimeType')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MimeType"))];
  class MimeTypeArray extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(MimeType), ImmutableListMixin$(MimeType)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], MimeType);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], MimeType);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], MimeType);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], MimeType);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  MimeTypeArray[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(MimeType)];
  dart.setSignature(MimeTypeArray, {
    constructors: () => ({_: [MimeTypeArray, []]}),
    methods: () => ({
      get: [MimeType, [core.int]],
      set: [dart.void, [core.int, MimeType]],
      elementAt: [MimeType, [core.int]],
      [__getter__]: [MimeType, [core.String]],
      item: [MimeType, [core.int]],
      namedItem: [MimeType, [core.String]]
    })
  });
  dart.defineExtensionMembers(MimeTypeArray, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  MimeTypeArray[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MimeTypeArray')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MimeTypeArray"))];
  class ModElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this.cite = null;
      this.dateTime = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(ModElement, 'created');
  dart.setSignature(ModElement, {
    constructors: () => ({
      _: [ModElement, []],
      created: [ModElement, []]
    })
  });
  ModElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLModElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLModElement"))];
  let MutationCallback = dart.typedef('MutationCallback', () => dart.functionType(dart.void, [core.List$(MutationRecord), MutationObserver]));
  let _observe_1 = Symbol('_observe_1');
  let _observe = Symbol('_observe');
  let _call = Symbol('_call');
  class MutationObserver extends _interceptors.Interceptor {
    [_observe](target, options) {
      let options_1 = html_common.convertDartToNative_Dictionary(options);
      this[_observe_1](target, options_1);
      return;
    }
    static get supported() {
      return dart.as(!!(window.MutationObserver || window.WebKitMutationObserver), core.bool);
    }
    observe(target, opts) {
      let childList = opts && 'childList' in opts ? opts.childList : null;
      let attributes = opts && 'attributes' in opts ? opts.attributes : null;
      let characterData = opts && 'characterData' in opts ? opts.characterData : null;
      let subtree = opts && 'subtree' in opts ? opts.subtree : null;
      let attributeOldValue = opts && 'attributeOldValue' in opts ? opts.attributeOldValue : null;
      let characterDataOldValue = opts && 'characterDataOldValue' in opts ? opts.characterDataOldValue : null;
      let attributeFilter = opts && 'attributeFilter' in opts ? opts.attributeFilter : null;
      let parsedOptions = MutationObserver._createDict();
      function override(key, value) {
        if (value != null)
          MutationObserver._add(parsedOptions, dart.as(key, core.String), value);
      }
      dart.fn(override);
      override('childList', childList);
      override('attributes', attributes);
      override('characterData', characterData);
      override('subtree', subtree);
      override('attributeOldValue', attributeOldValue);
      override('characterDataOldValue', characterDataOldValue);
      if (attributeFilter != null) {
        override('attributeFilter', MutationObserver._fixupList(attributeFilter));
      }
      this[_call](target, parsedOptions);
    }
    static _createDict() {
      return {};
    }
    static _add(m, key, value) {
      m[key] = value;
    }
    static _fixupList(list) {
      return list;
    }
    static new(callback) {
      0;
      return dart.as(new (window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver)(_js_helper.convertDartClosureToJS(_wrapBinaryZone(callback), 2)), MutationObserver);
    }
  }
  dart.setSignature(MutationObserver, {
    constructors: () => ({new: [MutationObserver, [MutationCallback]]}),
    methods: () => ({
      disconnect: [dart.void, []],
      [_observe]: [dart.void, [Node, core.Map]],
      [_observe_1]: [dart.void, [Node, dart.dynamic]],
      takeRecords: [core.List$(MutationRecord), []],
      observe: [dart.void, [Node], {childList: core.bool, attributes: core.bool, characterData: core.bool, subtree: core.bool, attributeOldValue: core.bool, characterDataOldValue: core.bool, attributeFilter: core.List$(core.String)}],
      [_call]: [dart.void, [dart.dynamic, dart.dynamic]]
    }),
    statics: () => ({
      _createDict: [dart.dynamic, []],
      _add: [dart.dynamic, [dart.dynamic, core.String, dart.dynamic]],
      _fixupList: [dart.dynamic, [dart.dynamic]]
    }),
    names: ['_createDict', '_add', '_fixupList']
  });
  MutationObserver[dart.metadata] = () => [dart.const(new _metadata.DomName('MutationObserver')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("MutationObserver,WebKitMutationObserver"))];
  MutationObserver._boolKeys = dart.const(dart.map({childList: true, attributes: true, characterData: true, subtree: true, attributeOldValue: true, characterDataOldValue: true}));
  class MutationRecord extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(MutationRecord, {
    constructors: () => ({_: [MutationRecord, []]})
  });
  MutationRecord[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('MutationRecord')), dart.const(new _js_helper.Native("MutationRecord"))];
  let _ensureGetUserMedia = Symbol('_ensureGetUserMedia');
  let _getUserMedia = Symbol('_getUserMedia');
  class Navigator extends _interceptors.Interceptor {
    get language() {
      return dart.as(this.language || this.userLanguage, core.String);
    }
    getUserMedia(opts) {
      let audio = opts && 'audio' in opts ? opts.audio : false;
      let video = opts && 'video' in opts ? opts.video : false;
      let completer = async.Completer$(MediaStream).new();
      let options = dart.map({audio: audio, video: video});
      this[_ensureGetUserMedia]();
      this[_getUserMedia](html_common.convertDartToNative_SerializedScriptValue(options), dart.fn(stream => {
        dart.dsend(completer, 'complete', stream);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(MediaStream));
    }
    [_ensureGetUserMedia]() {
      if (dart.notNull(dart.as(!this.getUserMedia, core.bool))) {
        this.getUserMedia = this.getUserMedia || this.webkitGetUserMedia || this.mozGetUserMedia || this.msGetUserMedia;
      }
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  Navigator[dart.implements] = () => [NavigatorCpu, NavigatorLanguage, NavigatorOnLine, NavigatorID];
  dart.setSignature(Navigator, {
    constructors: () => ({_: [Navigator, []]}),
    methods: () => ({
      getUserMedia: [async.Future$(MediaStream), [], {audio: dart.dynamic, video: dart.dynamic}],
      [_ensureGetUserMedia]: [dart.dynamic, []],
      [_getUserMedia]: [dart.void, [dart.dynamic, _NavigatorUserMediaSuccessCallback, _NavigatorUserMediaErrorCallback]],
      getBattery: [async.Future, []],
      getGamepads: [core.List$(Gamepad), []],
      getStorageUpdates: [dart.void, []],
      isProtocolHandlerRegistered: [core.String, [core.String, core.String]],
      registerProtocolHandler: [dart.void, [core.String, core.String, core.String]],
      sendBeacon: [core.bool, [core.String, dart.dynamic]],
      unregisterProtocolHandler: [dart.void, [core.String, core.String]]
    })
  });
  Navigator[dart.metadata] = () => [dart.const(new _metadata.DomName('Navigator')), dart.const(new _js_helper.Native("Navigator"))];
  class NavigatorCpu extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NavigatorCpu, {
    constructors: () => ({_: [NavigatorCpu, []]})
  });
  NavigatorCpu[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NavigatorCPU')), dart.const(new _metadata.Experimental())];
  class NavigatorID extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NavigatorID, {
    constructors: () => ({_: [NavigatorID, []]})
  });
  NavigatorID[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NavigatorID')), dart.const(new _metadata.Experimental())];
  class NavigatorLanguage extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NavigatorLanguage, {
    constructors: () => ({_: [NavigatorLanguage, []]})
  });
  NavigatorLanguage[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NavigatorLanguage')), dart.const(new _metadata.Experimental())];
  class NavigatorOnLine extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NavigatorOnLine, {
    constructors: () => ({_: [NavigatorOnLine, []]})
  });
  NavigatorOnLine[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NavigatorOnLine')), dart.const(new _metadata.Experimental())];
  class NavigatorUserMediaError extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NavigatorUserMediaError, {
    constructors: () => ({_: [NavigatorUserMediaError, []]})
  });
  NavigatorUserMediaError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NavigatorUserMediaError')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("NavigatorUserMediaError"))];
  let _NavigatorUserMediaErrorCallback = dart.typedef('_NavigatorUserMediaErrorCallback', () => dart.functionType(dart.void, [NavigatorUserMediaError]));
  let _NavigatorUserMediaSuccessCallback = dart.typedef('_NavigatorUserMediaSuccessCallback', () => dart.functionType(dart.void, [MediaStream]));
  class NetworkInformation extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NetworkInformation, {
    constructors: () => ({_: [NetworkInformation, []]})
  });
  NetworkInformation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NetworkInformation')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("NetworkInformation"))];
  class _ChildNodeListLazy extends collection.ListBase$(Node) {
    _ChildNodeListLazy(this$) {
      this[_this] = this$;
    }
    get first() {
      let result = dart.as(this[_this].firstChild, Node);
      if (result == null)
        dart.throw(new core.StateError("No elements"));
      return result;
    }
    get last() {
      let result = dart.as(this[_this].lastChild, Node);
      if (result == null)
        dart.throw(new core.StateError("No elements"));
      return result;
    }
    get single() {
      let l = this.length;
      if (l == 0)
        dart.throw(new core.StateError("No elements"));
      if (dart.notNull(l) > 1)
        dart.throw(new core.StateError("More than one element"));
      return dart.as(this[_this].firstChild, Node);
    }
    add(value) {
      this[_this].append(value);
    }
    addAll(iterable) {
      if (dart.is(iterable, _ChildNodeListLazy)) {
        let otherList = iterable;
        if (!dart.notNull(core.identical(otherList[_this], this[_this]))) {
          for (let i = 0, len = otherList.length; dart.notNull(dart.as(dart.dsend(i, '<', len), core.bool)); i = dart.dsend(i, '+', 1)) {
            this[_this].append(otherList[_this].firstChild);
          }
        }
        return;
      }
      for (let node of iterable) {
        this[_this].append(node);
      }
    }
    insert(index, node) {
      if (dart.notNull(index) < 0 || dart.notNull(index) > dart.notNull(this.length)) {
        dart.throw(new core.RangeError.range(index, 0, this.length));
      }
      if (index == this.length) {
        this[_this].append(node);
      } else {
        this[_this].insertBefore(node, this.get(index));
      }
    }
    insertAll(index, iterable) {
      if (index == this.length) {
        this.addAll(iterable);
      } else {
        let item = this.get(index);
        this[_this].insertAllBefore(iterable, dart.as(item, Node));
      }
    }
    setAll(index, iterable) {
      dart.throw(new core.UnsupportedError("Cannot setAll on Node list"));
    }
    removeLast() {
      let result = this.last;
      if (result != null) {
        this[_this][_removeChild](dart.as(result, Node));
      }
      return dart.as(result, Node);
    }
    removeAt(index) {
      let result = this.get(index);
      if (result != null) {
        this[_this][_removeChild](dart.as(result, Node));
      }
      return dart.as(result, Node);
    }
    remove(object) {
      if (!dart.is(object, Node))
        return false;
      let node = dart.as(object, Node);
      if (!dart.notNull(core.identical(this[_this], node.parentNode)))
        return false;
      this[_this][_removeChild](node);
      return true;
    }
    [_filter](test, removeMatching) {
      let child = this[_this].firstChild;
      while (child != null) {
        let nextChild = child.nextNode;
        if (test(child) == removeMatching) {
          this[_this][_removeChild](child);
        }
        child = nextChild;
      }
    }
    removeWhere(test) {
      this[_filter](test, true);
    }
    retainWhere(test) {
      this[_filter](test, false);
    }
    clear() {
      this[_this][_clearChildren]();
    }
    set(index, value) {
      this[_this][_replaceChild](value, this.get(index));
      return value;
    }
    get iterator() {
      return this[_this].childNodes[dartx.iterator];
    }
    sort(compare) {
      if (compare === void 0)
        compare = null;
      dart.throw(new core.UnsupportedError("Cannot sort Node list"));
    }
    shuffle(random) {
      if (random === void 0)
        random = null;
      dart.throw(new core.UnsupportedError("Cannot shuffle Node list"));
    }
    setRange(start, end, iterable, skipCount) {
      if (skipCount === void 0)
        skipCount = 0;
      dart.throw(new core.UnsupportedError("Cannot setRange on Node list"));
    }
    fillRange(start, end, fill) {
      if (fill === void 0)
        fill = null;
      dart.throw(new core.UnsupportedError("Cannot fillRange on Node list"));
    }
    get length() {
      return this[_this].childNodes[dartx.length];
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot set length on immutable List."));
    }
    get(index) {
      return this[_this].childNodes[dartx.get](index);
    }
    get rawList() {
      return this[_this].childNodes;
    }
  }
  _ChildNodeListLazy[dart.implements] = () => [html_common.NodeListWrapper];
  dart.setSignature(_ChildNodeListLazy, {
    constructors: () => ({_ChildNodeListLazy: [_ChildNodeListLazy, [Node]]}),
    methods: () => ({
      add: [dart.void, [Node]],
      addAll: [dart.void, [core.Iterable$(Node)]],
      insert: [dart.void, [core.int, Node]],
      insertAll: [dart.void, [core.int, core.Iterable$(Node)]],
      setAll: [dart.void, [core.int, core.Iterable$(Node)]],
      removeLast: [Node, []],
      removeAt: [Node, [core.int]],
      [_filter]: [dart.void, [dart.functionType(core.bool, [Node]), core.bool]],
      removeWhere: [dart.void, [dart.functionType(core.bool, [Node])]],
      retainWhere: [dart.void, [dart.functionType(core.bool, [Node])]],
      set: [dart.void, [core.int, Node]],
      sort: [dart.void, [], [core.Comparator$(Node)]],
      setRange: [dart.void, [core.int, core.int, core.Iterable$(Node)], [core.int]],
      fillRange: [dart.void, [core.int, core.int], [Node]],
      get: [Node, [core.int]]
    })
  });
  dart.defineExtensionMembers(_ChildNodeListLazy, [
    'add',
    'addAll',
    'insert',
    'insertAll',
    'setAll',
    'removeLast',
    'removeAt',
    'remove',
    'removeWhere',
    'retainWhere',
    'clear',
    'set',
    'sort',
    'shuffle',
    'setRange',
    'fillRange',
    'get',
    'first',
    'last',
    'single',
    'iterator',
    'length',
    'length'
  ]);
  Node.ATTRIBUTE_NODE = 2;
  Node.CDATA_SECTION_NODE = 4;
  Node.COMMENT_NODE = 8;
  Node.DOCUMENT_FRAGMENT_NODE = 11;
  Node.DOCUMENT_NODE = 9;
  Node.DOCUMENT_TYPE_NODE = 10;
  Node.ELEMENT_NODE = 1;
  Node.ENTITY_NODE = 6;
  Node.ENTITY_REFERENCE_NODE = 5;
  Node.NOTATION_NODE = 12;
  Node.PROCESSING_INSTRUCTION_NODE = 7;
  Node.TEXT_NODE = 3;
  class NodeFilter extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NodeFilter, {
    constructors: () => ({_: [NodeFilter, []]})
  });
  NodeFilter[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NodeFilter')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("NodeFilter"))];
  NodeFilter.FILTER_ACCEPT = 1;
  NodeFilter.FILTER_REJECT = 2;
  NodeFilter.FILTER_SKIP = 3;
  NodeFilter.SHOW_ALL = 4294967295;
  NodeFilter.SHOW_COMMENT = 128;
  NodeFilter.SHOW_DOCUMENT = 256;
  NodeFilter.SHOW_DOCUMENT_FRAGMENT = 1024;
  NodeFilter.SHOW_DOCUMENT_TYPE = 512;
  NodeFilter.SHOW_ELEMENT = 1;
  NodeFilter.SHOW_PROCESSING_INSTRUCTION = 64;
  NodeFilter.SHOW_TEXT = 4;
  class NodeIterator extends _interceptors.Interceptor {
    static new(root, whatToShow) {
      return exports.document[_createNodeIterator](root, whatToShow, null);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(NodeIterator, {
    constructors: () => ({
      new: [NodeIterator, [Node, core.int]],
      _: [NodeIterator, []]
    }),
    methods: () => ({
      detach: [dart.void, []],
      nextNode: [Node, []],
      previousNode: [Node, []]
    })
  });
  NodeIterator[dart.metadata] = () => [dart.const(new _metadata.DomName('NodeIterator')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("NodeIterator"))];
  let _item = Symbol('_item');
  class NodeList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Node), ImmutableListMixin$(Node)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], Node);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], Node);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], Node);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], Node);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  NodeList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(Node)];
  dart.setSignature(NodeList, {
    constructors: () => ({_: [NodeList, []]}),
    methods: () => ({
      get: [Node, [core.int]],
      set: [dart.void, [core.int, Node]],
      elementAt: [Node, [core.int]],
      [_item]: [Node, [core.int]]
    })
  });
  dart.defineExtensionMembers(NodeList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  NodeList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NodeList')), dart.const(new _js_helper.Native("NodeList,RadioNodeList"))];
  class Notification extends EventTarget {
    static new(title, opts) {
      let dir = opts && 'dir' in opts ? opts.dir : null;
      let body = opts && 'body' in opts ? opts.body : null;
      let lang = opts && 'lang' in opts ? opts.lang : null;
      let tag = opts && 'tag' in opts ? opts.tag : null;
      let icon = opts && 'icon' in opts ? opts.icon : null;
      let parsedOptions = dart.map();
      if (dir != null)
        dart.dsetindex(parsedOptions, 'dir', dir);
      if (body != null)
        dart.dsetindex(parsedOptions, 'body', body);
      if (lang != null)
        dart.dsetindex(parsedOptions, 'lang', lang);
      if (tag != null)
        dart.dsetindex(parsedOptions, 'tag', tag);
      if (icon != null)
        dart.dsetindex(parsedOptions, 'icon', icon);
      return Notification._factoryNotification(title, dart.as(parsedOptions, core.Map));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static _factoryNotification(title, options) {
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return Notification._create_1(title, options_1);
      }
      return Notification._create_2(title);
    }
    static _create_1(title, options) {
      return dart.as(new Notification(title, options), Notification);
    }
    static _create_2(title) {
      return dart.as(new Notification(title), Notification);
    }
    static get supported() {
      return dart.as(!!window.Notification, core.bool);
    }
    static requestPermission() {
      let completer = async.Completer$(core.String).new();
      Notification._requestPermission(dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(core.String));
    }
    get onClick() {
      return Notification.clickEvent.forTarget(this);
    }
    get onClose() {
      return Notification.closeEvent.forTarget(this);
    }
    get onError() {
      return Notification.errorEvent.forTarget(this);
    }
    get onShow() {
      return Notification.showEvent.forTarget(this);
    }
  }
  dart.setSignature(Notification, {
    constructors: () => ({
      new: [Notification, [core.String], {dir: core.String, body: core.String, lang: core.String, tag: core.String, icon: core.String}],
      _: [Notification, []]
    }),
    methods: () => ({close: [dart.void, []]}),
    statics: () => ({
      _factoryNotification: [Notification, [core.String], [core.Map]],
      _create_1: [Notification, [dart.dynamic, dart.dynamic]],
      _create_2: [Notification, [dart.dynamic]],
      _requestPermission: [dart.void, [], [_NotificationPermissionCallback]],
      requestPermission: [async.Future$(core.String), []]
    }),
    names: ['_factoryNotification', '_create_1', '_create_2', '_requestPermission', 'requestPermission']
  });
  Notification[dart.metadata] = () => [dart.const(new _metadata.DomName('Notification')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Notification"))];
  Notification.clickEvent = dart.const(new (EventStreamProvider$(Event))('click'));
  Notification.closeEvent = dart.const(new (EventStreamProvider$(Event))('close'));
  Notification.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  Notification.showEvent = dart.const(new (EventStreamProvider$(Event))('show'));
  let _NotificationPermissionCallback = dart.typedef('_NotificationPermissionCallback', () => dart.functionType(dart.void, [core.String]));
  class OListElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("ol"), OListElement);
    }
    created() {
      this.reversed = null;
      this.start = null;
      this.type = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(OListElement, 'created');
  dart.setSignature(OListElement, {
    constructors: () => ({
      _: [OListElement, []],
      new: [OListElement, []],
      created: [OListElement, []]
    })
  });
  OListElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLOListElement')), dart.const(new _js_helper.Native("HTMLOListElement"))];
  class ObjectElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("object"), ObjectElement);
    }
    created() {
      this.data = null;
      this.form = null;
      this.height = null;
      this.integrity = null;
      this.name = null;
      this.type = null;
      this.useMap = null;
      this.validationMessage = null;
      this.validity = null;
      this.width = null;
      this.willValidate = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('object');
    }
  }
  dart.defineNamedConstructor(ObjectElement, 'created');
  dart.setSignature(ObjectElement, {
    constructors: () => ({
      _: [ObjectElement, []],
      new: [ObjectElement, []],
      created: [ObjectElement, []]
    }),
    methods: () => ({
      [__getter__]: [core.bool, [dart.dynamic]],
      [__setter__]: [dart.void, [dart.dynamic, Node]],
      checkValidity: [core.bool, []],
      setCustomValidity: [dart.void, [core.String]]
    })
  });
  ObjectElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLObjectElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLObjectElement"))];
  class OptGroupElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("optgroup"), OptGroupElement);
    }
    created() {
      this.disabled = null;
      this.label = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(OptGroupElement, 'created');
  dart.setSignature(OptGroupElement, {
    constructors: () => ({
      _: [OptGroupElement, []],
      new: [OptGroupElement, []],
      created: [OptGroupElement, []]
    })
  });
  OptGroupElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLOptGroupElement')), dart.const(new _js_helper.Native("HTMLOptGroupElement"))];
  class OptionElement extends HtmlElement {
    static new(opts) {
      let data = opts && 'data' in opts ? opts.data : '';
      let value = opts && 'value' in opts ? opts.value : '';
      let selected = opts && 'selected' in opts ? opts.selected : false;
      return OptionElement._(data, value, null, selected);
    }
    static _(data, value, defaultSelected, selected) {
      if (data === void 0)
        data = null;
      if (value === void 0)
        value = null;
      if (defaultSelected === void 0)
        defaultSelected = null;
      if (selected === void 0)
        selected = null;
      if (selected != null) {
        return OptionElement._create_1(data, value, defaultSelected, selected);
      }
      if (defaultSelected != null) {
        return OptionElement._create_2(data, value, defaultSelected);
      }
      if (value != null) {
        return OptionElement._create_3(data, value);
      }
      if (data != null) {
        return OptionElement._create_4(data);
      }
      return OptionElement._create_5();
    }
    static _create_1(data, value, defaultSelected, selected) {
      return dart.as(new Option(data, value, defaultSelected, selected), OptionElement);
    }
    static _create_2(data, value, defaultSelected) {
      return dart.as(new Option(data, value, defaultSelected), OptionElement);
    }
    static _create_3(data, value) {
      return dart.as(new Option(data, value), OptionElement);
    }
    static _create_4(data) {
      return dart.as(new Option(data), OptionElement);
    }
    static _create_5() {
      return dart.as(new Option(), OptionElement);
    }
    created() {
      this.defaultSelected = null;
      this.disabled = null;
      this.form = null;
      this.index = null;
      this.label = null;
      this.selected = null;
      this.value = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(OptionElement, 'created');
  dart.setSignature(OptionElement, {
    constructors: () => ({
      new: [OptionElement, [], {data: core.String, value: core.String, selected: core.bool}],
      _: [OptionElement, [], [core.String, core.String, core.bool, core.bool]],
      created: [OptionElement, []]
    }),
    statics: () => ({
      _create_1: [OptionElement, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_2: [OptionElement, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_3: [OptionElement, [dart.dynamic, dart.dynamic]],
      _create_4: [OptionElement, [dart.dynamic]],
      _create_5: [OptionElement, []]
    }),
    names: ['_create_1', '_create_2', '_create_3', '_create_4', '_create_5']
  });
  OptionElement[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLOptionElement')), dart.const(new _js_helper.Native("HTMLOptionElement"))];
  class OutputElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("output"), OutputElement);
    }
    created() {
      this.defaultValue = null;
      this.form = null;
      this.htmlFor = null;
      this.labels = null;
      this.name = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.value = null;
      this.willValidate = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('output');
    }
  }
  dart.defineNamedConstructor(OutputElement, 'created');
  dart.setSignature(OutputElement, {
    constructors: () => ({
      _: [OutputElement, []],
      new: [OutputElement, []],
      created: [OutputElement, []]
    }),
    methods: () => ({
      checkValidity: [core.bool, []],
      setCustomValidity: [dart.void, [core.String]]
    })
  });
  OutputElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLOutputElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _js_helper.Native("HTMLOutputElement"))];
  class OverflowEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(OverflowEvent, {
    constructors: () => ({_: [OverflowEvent, []]})
  });
  OverflowEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('OverflowEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("OverflowEvent"))];
  OverflowEvent.BOTH = 2;
  OverflowEvent.HORIZONTAL = 0;
  OverflowEvent.VERTICAL = 1;
  class PageTransitionEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PageTransitionEvent, {
    constructors: () => ({_: [PageTransitionEvent, []]})
  });
  PageTransitionEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PageTransitionEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PageTransitionEvent"))];
  class ParagraphElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("p"), ParagraphElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(ParagraphElement, 'created');
  dart.setSignature(ParagraphElement, {
    constructors: () => ({
      _: [ParagraphElement, []],
      new: [ParagraphElement, []],
      created: [ParagraphElement, []]
    })
  });
  ParagraphElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLParagraphElement')), dart.const(new _js_helper.Native("HTMLParagraphElement"))];
  class ParamElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("param"), ParamElement);
    }
    created() {
      this.name = null;
      this.value = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(ParamElement, 'created');
  dart.setSignature(ParamElement, {
    constructors: () => ({
      _: [ParamElement, []],
      new: [ParamElement, []],
      created: [ParamElement, []]
    })
  });
  ParamElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLParamElement')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("HTMLParamElement"))];
  class ParentNode extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ParentNode, {
    constructors: () => ({_: [ParentNode, []]})
  });
  ParentNode[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ParentNode')), dart.const(new _metadata.Experimental())];
  class Path2D extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(path_OR_text) {
      if (path_OR_text === void 0)
        path_OR_text = null;
      if (path_OR_text == null) {
        return Path2D._create_1();
      }
      if (dart.is(path_OR_text, Path2D) || path_OR_text == null) {
        return Path2D._create_2(path_OR_text);
      }
      if (typeof path_OR_text == 'string' || path_OR_text == null) {
        return Path2D._create_3(path_OR_text);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1() {
      return dart.as(new Path2D(), Path2D);
    }
    static _create_2(path_OR_text) {
      return dart.as(new Path2D(path_OR_text), Path2D);
    }
    static _create_3(path_OR_text) {
      return dart.as(new Path2D(path_OR_text), Path2D);
    }
  }
  Path2D[dart.implements] = () => [_CanvasPathMethods];
  dart.setSignature(Path2D, {
    constructors: () => ({
      _: [Path2D, []],
      new: [Path2D, [], [dart.dynamic]]
    }),
    methods: () => ({
      addPath: [dart.void, [Path2D], [svg.Matrix]],
      arc: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.bool]],
      arcTo: [dart.void, [core.num, core.num, core.num, core.num, core.num]],
      bezierCurveTo: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num]],
      closePath: [dart.void, []],
      ellipse: [dart.void, [core.num, core.num, core.num, core.num, core.num, core.num, core.num, core.bool]],
      lineTo: [dart.void, [core.num, core.num]],
      moveTo: [dart.void, [core.num, core.num]],
      quadraticCurveTo: [dart.void, [core.num, core.num, core.num, core.num]],
      rect: [dart.void, [core.num, core.num, core.num, core.num]]
    }),
    statics: () => ({
      _create_1: [Path2D, []],
      _create_2: [Path2D, [dart.dynamic]],
      _create_3: [Path2D, [dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3']
  });
  Path2D[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Path2D')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Path2D"))];
  class Performance extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!window.performance, core.bool);
    }
    get onResourceTimingBufferFull() {
      return Performance.resourceTimingBufferFullEvent.forTarget(this);
    }
  }
  dart.setSignature(Performance, {
    constructors: () => ({_: [Performance, []]}),
    methods: () => ({
      clearMarks: [dart.void, [core.String]],
      clearMeasures: [dart.void, [core.String]],
      getEntries: [core.List$(PerformanceEntry), []],
      getEntriesByName: [core.List$(PerformanceEntry), [core.String, core.String]],
      getEntriesByType: [core.List$(PerformanceEntry), [core.String]],
      mark: [dart.void, [core.String]],
      measure: [dart.void, [core.String, core.String, core.String]],
      now: [core.double, []],
      clearResourceTimings: [dart.void, []],
      setResourceTimingBufferSize: [dart.void, [core.int]]
    })
  });
  Performance[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Performance')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE)), dart.const(new _js_helper.Native("Performance"))];
  Performance.resourceTimingBufferFullEvent = dart.const(new (EventStreamProvider$(Event))('webkitresourcetimingbufferfull'));
  class PerformanceEntry extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PerformanceEntry, {
    constructors: () => ({_: [PerformanceEntry, []]})
  });
  PerformanceEntry[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PerformanceEntry')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PerformanceEntry"))];
  class PerformanceMark extends PerformanceEntry {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PerformanceMark, {
    constructors: () => ({_: [PerformanceMark, []]})
  });
  PerformanceMark[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PerformanceMark')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PerformanceMark"))];
  class PerformanceMeasure extends PerformanceEntry {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PerformanceMeasure, {
    constructors: () => ({_: [PerformanceMeasure, []]})
  });
  PerformanceMeasure[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PerformanceMeasure')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PerformanceMeasure"))];
  class PerformanceNavigation extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PerformanceNavigation, {
    constructors: () => ({_: [PerformanceNavigation, []]})
  });
  PerformanceNavigation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PerformanceNavigation')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("PerformanceNavigation"))];
  PerformanceNavigation.TYPE_BACK_FORWARD = 2;
  PerformanceNavigation.TYPE_NAVIGATE = 0;
  PerformanceNavigation.TYPE_RELOAD = 1;
  PerformanceNavigation.TYPE_RESERVED = 255;
  class PerformanceResourceTiming extends PerformanceEntry {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PerformanceResourceTiming, {
    constructors: () => ({_: [PerformanceResourceTiming, []]})
  });
  PerformanceResourceTiming[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PerformanceResourceTiming')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PerformanceResourceTiming"))];
  class PerformanceTiming extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PerformanceTiming, {
    constructors: () => ({_: [PerformanceTiming, []]})
  });
  PerformanceTiming[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PerformanceTiming')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("PerformanceTiming"))];
  class PictureElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(PictureElement, 'created');
  dart.setSignature(PictureElement, {
    constructors: () => ({
      _: [PictureElement, []],
      created: [PictureElement, []]
    })
  });
  PictureElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLPictureElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLPictureElement"))];
  class Plugin extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Plugin, {
    constructors: () => ({_: [Plugin, []]}),
    methods: () => ({
      [__getter__]: [MimeType, [core.String]],
      item: [MimeType, [core.int]],
      namedItem: [MimeType, [core.String]]
    })
  });
  Plugin[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Plugin')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Plugin"))];
  class PluginArray extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Plugin), ImmutableListMixin$(Plugin)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], Plugin);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], Plugin);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], Plugin);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], Plugin);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  PluginArray[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(Plugin)];
  dart.setSignature(PluginArray, {
    constructors: () => ({_: [PluginArray, []]}),
    methods: () => ({
      get: [Plugin, [core.int]],
      set: [dart.void, [core.int, Plugin]],
      elementAt: [Plugin, [core.int]],
      [__getter__]: [Plugin, [core.String]],
      item: [Plugin, [core.int]],
      namedItem: [Plugin, [core.String]],
      refresh: [dart.void, [core.bool]]
    })
  });
  dart.defineExtensionMembers(PluginArray, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  PluginArray[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PluginArray')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PluginArray"))];
  class PluginPlaceholderElement extends DivElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this.message = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(PluginPlaceholderElement, 'created');
  dart.setSignature(PluginPlaceholderElement, {
    constructors: () => ({
      _: [PluginPlaceholderElement, []],
      created: [PluginPlaceholderElement, []]
    }),
    methods: () => ({createdCallback: [dart.void, []]})
  });
  PluginPlaceholderElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PluginPlaceholderElement')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PluginPlaceholderElement"))];
  let _PositionCallback = dart.typedef('_PositionCallback', () => dart.functionType(dart.void, [Geoposition]));
  class PositionError extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PositionError, {
    constructors: () => ({_: [PositionError, []]})
  });
  PositionError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PositionError')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("PositionError"))];
  PositionError.PERMISSION_DENIED = 1;
  PositionError.POSITION_UNAVAILABLE = 2;
  PositionError.TIMEOUT = 3;
  let _PositionErrorCallback = dart.typedef('_PositionErrorCallback', () => dart.functionType(dart.void, [PositionError]));
  class PreElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("pre"), PreElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(PreElement, 'created');
  dart.setSignature(PreElement, {
    constructors: () => ({
      _: [PreElement, []],
      new: [PreElement, []],
      created: [PreElement, []]
    })
  });
  PreElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLPreElement')), dart.const(new _js_helper.Native("HTMLPreElement"))];
  class Presentation extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Presentation, {
    constructors: () => ({_: [Presentation, []]})
  });
  Presentation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Presentation')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Presentation"))];
  class ProcessingInstruction extends CharacterData {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ProcessingInstruction, {
    constructors: () => ({_: [ProcessingInstruction, []]})
  });
  ProcessingInstruction[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ProcessingInstruction')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("ProcessingInstruction"))];
  class ProgressElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("progress"), ProgressElement);
    }
    created() {
      this.labels = null;
      this.max = null;
      this.position = null;
      this.value = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('progress');
    }
  }
  dart.defineNamedConstructor(ProgressElement, 'created');
  dart.setSignature(ProgressElement, {
    constructors: () => ({
      _: [ProgressElement, []],
      new: [ProgressElement, []],
      created: [ProgressElement, []]
    })
  });
  ProgressElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLProgressElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _js_helper.Native("HTMLProgressElement"))];
  class PushEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PushEvent, {
    constructors: () => ({_: [PushEvent, []]})
  });
  PushEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PushEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PushEvent"))];
  class PushManager extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PushManager, {
    constructors: () => ({_: [PushManager, []]}),
    methods: () => ({register: [async.Future, [core.String]]})
  });
  PushManager[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PushManager')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PushManager"))];
  class PushRegistration extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(PushRegistration, {
    constructors: () => ({_: [PushRegistration, []]})
  });
  PushRegistration[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PushRegistration')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("PushRegistration"))];
  class QuoteElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("q"), QuoteElement);
    }
    created() {
      this.cite = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(QuoteElement, 'created');
  dart.setSignature(QuoteElement, {
    constructors: () => ({
      _: [QuoteElement, []],
      new: [QuoteElement, []],
      created: [QuoteElement, []]
    })
  });
  QuoteElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLQuoteElement')), dart.const(new _js_helper.Native("HTMLQuoteElement"))];
  let _RtcErrorCallback = dart.typedef('_RtcErrorCallback', () => dart.functionType(dart.void, [core.String]));
  let _RtcSessionDescriptionCallback = dart.typedef('_RtcSessionDescriptionCallback', () => dart.functionType(dart.void, [RtcSessionDescription]));
  let RtcStatsCallback = dart.typedef('RtcStatsCallback', () => dart.functionType(dart.void, [RtcStatsResponse]));
  class Range extends _interceptors.Interceptor {
    static new() {
      return exports.document.createRange();
    }
    static fromPoint(point) {
      return exports.document[_caretRangeFromPoint](dart.as(point.x, core.int), dart.as(point.y, core.int));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supportsCreateContextualFragment() {
      return dart.as("createContextualFragment" in window.Range.prototype, core.bool);
    }
  }
  dart.setSignature(Range, {
    constructors: () => ({
      new: [Range, []],
      fromPoint: [Range, [math.Point]],
      _: [Range, []]
    }),
    methods: () => ({
      cloneContents: [DocumentFragment, []],
      cloneRange: [Range, []],
      collapse: [dart.void, [], [core.bool]],
      compareBoundaryPoints: [core.int, [core.int, Range]],
      comparePoint: [core.int, [Node, core.int]],
      createContextualFragment: [DocumentFragment, [core.String]],
      deleteContents: [dart.void, []],
      detach: [dart.void, []],
      expand: [dart.void, [core.String]],
      extractContents: [DocumentFragment, []],
      getBoundingClientRect: [math.Rectangle, []],
      getClientRects: [core.List$(math.Rectangle), []],
      insertNode: [dart.void, [Node]],
      isPointInRange: [core.bool, [Node, core.int]],
      selectNode: [dart.void, [Node]],
      selectNodeContents: [dart.void, [Node]],
      setEnd: [dart.void, [Node, core.int]],
      setEndAfter: [dart.void, [Node]],
      setEndBefore: [dart.void, [Node]],
      setStart: [dart.void, [Node, core.int]],
      setStartAfter: [dart.void, [Node]],
      setStartBefore: [dart.void, [Node]],
      surroundContents: [dart.void, [Node]]
    })
  });
  Range[dart.metadata] = () => [dart.const(new _metadata.DomName('Range')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("Range"))];
  Range.END_TO_END = 2;
  Range.END_TO_START = 3;
  Range.NODE_AFTER = 1;
  Range.NODE_BEFORE = 0;
  Range.NODE_BEFORE_AND_AFTER = 2;
  Range.NODE_INSIDE = 3;
  Range.START_TO_END = 1;
  Range.START_TO_START = 0;
  class ReadableStream extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ReadableStream, {
    constructors: () => ({_: [ReadableStream, []]}),
    methods: () => ({
      cancel: [async.Future, [core.Object]],
      read: [core.Object, []],
      wait: [async.Future, []]
    })
  });
  ReadableStream[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ReadableStream')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ReadableStream"))];
  class RelatedEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get relatedTarget() {
      return _convertNativeToDart_EventTarget(this[_get_relatedTarget]);
    }
  }
  dart.setSignature(RelatedEvent, {
    constructors: () => ({_: [RelatedEvent, []]})
  });
  RelatedEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RelatedEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RelatedEvent"))];
  let RequestAnimationFrameCallback = dart.typedef('RequestAnimationFrameCallback', () => dart.functionType(dart.void, [core.num]));
  class ResourceProgressEvent extends ProgressEvent {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ResourceProgressEvent, {
    constructors: () => ({_: [ResourceProgressEvent, []]})
  });
  ResourceProgressEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ResourceProgressEvent')), core.deprecated, dart.const(new _js_helper.Native("ResourceProgressEvent"))];
  class RtcDataChannel extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onClose() {
      return RtcDataChannel.closeEvent.forTarget(this);
    }
    get onError() {
      return RtcDataChannel.errorEvent.forTarget(this);
    }
    get onMessage() {
      return RtcDataChannel.messageEvent.forTarget(this);
    }
    get onOpen() {
      return RtcDataChannel.openEvent.forTarget(this);
    }
  }
  dart.setSignature(RtcDataChannel, {
    constructors: () => ({_: [RtcDataChannel, []]}),
    methods: () => ({
      close: [dart.void, []],
      send: [dart.void, [dart.dynamic]],
      sendBlob: [dart.void, [Blob]],
      sendByteBuffer: [dart.void, [typed_data.ByteBuffer]],
      sendString: [dart.void, [core.String]],
      sendTypedData: [dart.void, [typed_data.TypedData]]
    })
  });
  RtcDataChannel[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCDataChannel')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCDataChannel,DataChannel"))];
  RtcDataChannel.closeEvent = dart.const(new (EventStreamProvider$(Event))('close'));
  RtcDataChannel.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  RtcDataChannel.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  RtcDataChannel.openEvent = dart.const(new (EventStreamProvider$(Event))('open'));
  class RtcDataChannelEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RtcDataChannelEvent, {
    constructors: () => ({_: [RtcDataChannelEvent, []]})
  });
  RtcDataChannelEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCDataChannelEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCDataChannelEvent"))];
  class RtcDtmfSender extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onToneChange() {
      return RtcDtmfSender.toneChangeEvent.forTarget(this);
    }
  }
  dart.setSignature(RtcDtmfSender, {
    constructors: () => ({_: [RtcDtmfSender, []]}),
    methods: () => ({insertDtmf: [dart.void, [core.String], [core.int, core.int]]})
  });
  RtcDtmfSender[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCDTMFSender')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCDTMFSender"))];
  class RtcDtmfToneChangeEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RtcDtmfToneChangeEvent, {
    constructors: () => ({_: [RtcDtmfToneChangeEvent, []]})
  });
  RtcDtmfToneChangeEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCDTMFToneChangeEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCDTMFToneChangeEvent"))];
  RtcDtmfSender.toneChangeEvent = dart.const(new (EventStreamProvider$(RtcDtmfToneChangeEvent))('tonechange'));
  class RtcIceCandidate extends _interceptors.Interceptor {
    static new(dictionary) {
      let constructorName = window[dart.notNull(html_common.Device.isFirefox) ? `${html_common.Device.propertyPrefix}RTCIceCandidate` : 'RTCIceCandidate'];
      return dart.as(new constructorName(html_common.convertDartToNative_SerializedScriptValue(dictionary)), RtcIceCandidate);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RtcIceCandidate, {
    constructors: () => ({
      new: [RtcIceCandidate, [core.Map]],
      _: [RtcIceCandidate, []]
    })
  });
  RtcIceCandidate[dart.metadata] = () => [dart.const(new _metadata.DomName('RTCIceCandidate')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCIceCandidate,mozRTCIceCandidate"))];
  class RtcIceCandidateEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RtcIceCandidateEvent, {
    constructors: () => ({_: [RtcIceCandidateEvent, []]})
  });
  RtcIceCandidateEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCIceCandidateEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCIceCandidateEvent,RTCPeerConnectionIceEvent"))];
  let _createOffer = Symbol('_createOffer');
  let _createAnswer = Symbol('_createAnswer');
  let _getStats = Symbol('_getStats');
  let _addStream_1 = Symbol('_addStream_1');
  let _addStream_2 = Symbol('_addStream_2');
  let _createAnswer_1 = Symbol('_createAnswer_1');
  let _createAnswer_2 = Symbol('_createAnswer_2');
  let _createDataChannel_1 = Symbol('_createDataChannel_1');
  let _createDataChannel_2 = Symbol('_createDataChannel_2');
  let _createOffer_1 = Symbol('_createOffer_1');
  let _createOffer_2 = Symbol('_createOffer_2');
  let _setLocalDescription = Symbol('_setLocalDescription');
  let _setRemoteDescription = Symbol('_setRemoteDescription');
  let _updateIce_1 = Symbol('_updateIce_1');
  let _updateIce_2 = Symbol('_updateIce_2');
  let _updateIce_3 = Symbol('_updateIce_3');
  class RtcPeerConnection extends EventTarget {
    static new(rtcIceServers, mediaConstraints) {
      if (mediaConstraints === void 0)
        mediaConstraints = null;
      let constructorName = window[`${html_common.Device.propertyPrefix}RTCPeerConnection`];
      if (mediaConstraints != null) {
        return dart.as(new constructorName(html_common.convertDartToNative_SerializedScriptValue(rtcIceServers), html_common.convertDartToNative_SerializedScriptValue(mediaConstraints)), RtcPeerConnection);
      } else {
        return dart.as(new constructorName(html_common.convertDartToNative_SerializedScriptValue(rtcIceServers)), RtcPeerConnection);
      }
    }
    static get supported() {
      try {
        RtcPeerConnection.new(dart.map({iceServers: [dart.map({url: "stun:localhost"})]}));
        return true;
      } catch (_) {
        return false;
      }

      return false;
    }
    createOffer(mediaConstraints) {
      if (mediaConstraints === void 0)
        mediaConstraints = null;
      let completer = async.Completer$(RtcSessionDescription).new();
      this[_createOffer](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }), mediaConstraints);
      return dart.as(dart.dload(completer, 'future'), async.Future$(RtcSessionDescription));
    }
    createAnswer(mediaConstraints) {
      if (mediaConstraints === void 0)
        mediaConstraints = null;
      let completer = async.Completer$(RtcSessionDescription).new();
      this[_createAnswer](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }), mediaConstraints);
      return dart.as(dart.dload(completer, 'future'), async.Future$(RtcSessionDescription));
    }
    getStats(selector) {
      let completer = async.Completer$(RtcStatsResponse).new();
      this[_getStats](dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), selector);
      return dart.as(dart.dload(completer, 'future'), async.Future$(RtcStatsResponse));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    addStream(stream, mediaConstraints) {
      if (mediaConstraints === void 0)
        mediaConstraints = null;
      if (mediaConstraints != null) {
        let mediaConstraints_1 = html_common.convertDartToNative_Dictionary(mediaConstraints);
        this[_addStream_1](stream, mediaConstraints_1);
        return;
      }
      this[_addStream_2](stream);
      return;
    }
    [_createAnswer](successCallback, failureCallback, mediaConstraints) {
      if (failureCallback === void 0)
        failureCallback = null;
      if (mediaConstraints === void 0)
        mediaConstraints = null;
      if (mediaConstraints != null) {
        let mediaConstraints_1 = html_common.convertDartToNative_Dictionary(mediaConstraints);
        this[_createAnswer_1](successCallback, failureCallback, mediaConstraints_1);
        return;
      }
      this[_createAnswer_2](successCallback, failureCallback);
      return;
    }
    createDataChannel(label, options) {
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return this[_createDataChannel_1](label, options_1);
      }
      return this[_createDataChannel_2](label);
    }
    [_createOffer](successCallback, failureCallback, rtcOfferOptions) {
      if (failureCallback === void 0)
        failureCallback = null;
      if (rtcOfferOptions === void 0)
        rtcOfferOptions = null;
      if (rtcOfferOptions != null) {
        let rtcOfferOptions_1 = html_common.convertDartToNative_Dictionary(rtcOfferOptions);
        this[_createOffer_1](successCallback, failureCallback, rtcOfferOptions_1);
        return;
      }
      this[_createOffer_2](successCallback, failureCallback);
      return;
    }
    setLocalDescription(description) {
      let completer = async.Completer.new();
      this[_setLocalDescription](description, dart.fn(() => {
        dart.dsend(completer, 'complete');
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future);
    }
    setRemoteDescription(description) {
      let completer = async.Completer.new();
      this[_setRemoteDescription](description, dart.fn(() => {
        dart.dsend(completer, 'complete');
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future);
    }
    updateIce(configuration, mediaConstraints) {
      if (configuration === void 0)
        configuration = null;
      if (mediaConstraints === void 0)
        mediaConstraints = null;
      if (mediaConstraints != null) {
        let configuration_1 = html_common.convertDartToNative_Dictionary(configuration);
        let mediaConstraints_2 = html_common.convertDartToNative_Dictionary(mediaConstraints);
        this[_updateIce_1](configuration_1, mediaConstraints_2);
        return;
      }
      if (configuration != null) {
        let configuration_1 = html_common.convertDartToNative_Dictionary(configuration);
        this[_updateIce_2](configuration_1);
        return;
      }
      this[_updateIce_3]();
      return;
    }
    get onAddStream() {
      return RtcPeerConnection.addStreamEvent.forTarget(this);
    }
    get onDataChannel() {
      return RtcPeerConnection.dataChannelEvent.forTarget(this);
    }
    get onIceCandidate() {
      return RtcPeerConnection.iceCandidateEvent.forTarget(this);
    }
    get onIceConnectionStateChange() {
      return RtcPeerConnection.iceConnectionStateChangeEvent.forTarget(this);
    }
    get onNegotiationNeeded() {
      return RtcPeerConnection.negotiationNeededEvent.forTarget(this);
    }
    get onRemoveStream() {
      return RtcPeerConnection.removeStreamEvent.forTarget(this);
    }
    get onSignalingStateChange() {
      return RtcPeerConnection.signalingStateChangeEvent.forTarget(this);
    }
  }
  dart.setSignature(RtcPeerConnection, {
    constructors: () => ({
      new: [RtcPeerConnection, [core.Map], [core.Map]],
      _: [RtcPeerConnection, []]
    }),
    methods: () => ({
      createOffer: [async.Future$(RtcSessionDescription), [], [core.Map]],
      createAnswer: [async.Future$(RtcSessionDescription), [], [core.Map]],
      getStats: [async.Future$(RtcStatsResponse), [MediaStreamTrack]],
      addIceCandidate: [dart.void, [RtcIceCandidate, VoidCallback, _RtcErrorCallback]],
      addStream: [dart.void, [MediaStream], [core.Map]],
      [_addStream_1]: [dart.void, [MediaStream, dart.dynamic]],
      [_addStream_2]: [dart.void, [MediaStream]],
      close: [dart.void, []],
      [_createAnswer]: [dart.void, [_RtcSessionDescriptionCallback], [_RtcErrorCallback, core.Map]],
      [_createAnswer_1]: [dart.void, [_RtcSessionDescriptionCallback, _RtcErrorCallback, dart.dynamic]],
      [_createAnswer_2]: [dart.void, [_RtcSessionDescriptionCallback, _RtcErrorCallback]],
      createDtmfSender: [RtcDtmfSender, [MediaStreamTrack]],
      createDataChannel: [RtcDataChannel, [core.String], [core.Map]],
      [_createDataChannel_1]: [RtcDataChannel, [dart.dynamic, dart.dynamic]],
      [_createDataChannel_2]: [RtcDataChannel, [dart.dynamic]],
      [_createOffer]: [dart.void, [_RtcSessionDescriptionCallback], [_RtcErrorCallback, core.Map]],
      [_createOffer_1]: [dart.void, [_RtcSessionDescriptionCallback, _RtcErrorCallback, dart.dynamic]],
      [_createOffer_2]: [dart.void, [_RtcSessionDescriptionCallback, _RtcErrorCallback]],
      getLocalStreams: [core.List$(MediaStream), []],
      getRemoteStreams: [core.List$(MediaStream), []],
      [_getStats]: [dart.void, [RtcStatsCallback, MediaStreamTrack]],
      getStreamById: [MediaStream, [core.String]],
      removeStream: [dart.void, [MediaStream]],
      [_setLocalDescription]: [dart.void, [RtcSessionDescription], [VoidCallback, _RtcErrorCallback]],
      setLocalDescription: [async.Future, [RtcSessionDescription]],
      [_setRemoteDescription]: [dart.void, [RtcSessionDescription], [VoidCallback, _RtcErrorCallback]],
      setRemoteDescription: [async.Future, [RtcSessionDescription]],
      updateIce: [dart.void, [], [core.Map, core.Map]],
      [_updateIce_1]: [dart.void, [dart.dynamic, dart.dynamic]],
      [_updateIce_2]: [dart.void, [dart.dynamic]],
      [_updateIce_3]: [dart.void, []]
    })
  });
  RtcPeerConnection[dart.metadata] = () => [dart.const(new _metadata.DomName('RTCPeerConnection')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCPeerConnection,mozRTCPeerConnection"))];
  RtcPeerConnection.addStreamEvent = dart.const(new (EventStreamProvider$(MediaStreamEvent))('addstream'));
  RtcPeerConnection.dataChannelEvent = dart.const(new (EventStreamProvider$(RtcDataChannelEvent))('datachannel'));
  RtcPeerConnection.iceCandidateEvent = dart.const(new (EventStreamProvider$(RtcIceCandidateEvent))('icecandidate'));
  RtcPeerConnection.iceConnectionStateChangeEvent = dart.const(new (EventStreamProvider$(Event))('iceconnectionstatechange'));
  RtcPeerConnection.negotiationNeededEvent = dart.const(new (EventStreamProvider$(Event))('negotiationneeded'));
  RtcPeerConnection.removeStreamEvent = dart.const(new (EventStreamProvider$(MediaStreamEvent))('removestream'));
  RtcPeerConnection.signalingStateChangeEvent = dart.const(new (EventStreamProvider$(Event))('signalingstatechange'));
  class RtcSessionDescription extends _interceptors.Interceptor {
    static new(dictionary) {
      let constructorName = window[dart.notNull(html_common.Device.isFirefox) ? `${html_common.Device.propertyPrefix}RTCSessionDescription` : 'RTCSessionDescription'];
      return dart.as(new constructorName(html_common.convertDartToNative_SerializedScriptValue(dictionary)), RtcSessionDescription);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RtcSessionDescription, {
    constructors: () => ({
      new: [RtcSessionDescription, [core.Map]],
      _: [RtcSessionDescription, []]
    })
  });
  RtcSessionDescription[dart.metadata] = () => [dart.const(new _metadata.DomName('RTCSessionDescription')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCSessionDescription,mozRTCSessionDescription"))];
  let _get_timestamp = Symbol('_get_timestamp');
  class RtcStatsReport extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get timestamp() {
      return html_common.convertNativeToDart_DateTime(this[_get_timestamp]);
    }
  }
  dart.setSignature(RtcStatsReport, {
    constructors: () => ({_: [RtcStatsReport, []]}),
    methods: () => ({
      names: [core.List$(core.String), []],
      stat: [core.String, [core.String]]
    })
  });
  RtcStatsReport[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCStatsReport')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCStatsReport"))];
  class RtcStatsResponse extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(RtcStatsResponse, {
    constructors: () => ({_: [RtcStatsResponse, []]}),
    methods: () => ({
      [__getter__]: [RtcStatsReport, [core.String]],
      namedItem: [RtcStatsReport, [core.String]],
      result: [core.List$(RtcStatsReport), []]
    })
  });
  RtcStatsResponse[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RTCStatsResponse')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("RTCStatsResponse"))];
  let _availLeft = Symbol('_availLeft');
  let _availTop = Symbol('_availTop');
  let _availWidth = Symbol('_availWidth');
  let _availHeight = Symbol('_availHeight');
  class Screen extends _interceptors.Interceptor {
    get available() {
      return new math.Rectangle(this[_availLeft], this[_availTop], this[_availWidth], this[_availHeight]);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Screen, {
    constructors: () => ({_: [Screen, []]})
  });
  Screen[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Screen')), dart.const(new _js_helper.Native("Screen"))];
  class ScreenOrientation extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onChange() {
      return ScreenOrientation.changeEvent.forTarget(this);
    }
  }
  dart.setSignature(ScreenOrientation, {
    constructors: () => ({_: [ScreenOrientation, []]}),
    methods: () => ({
      lock: [async.Future, [core.String]],
      unlock: [dart.void, []]
    })
  });
  ScreenOrientation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ScreenOrientation')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ScreenOrientation"))];
  ScreenOrientation.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  class ScriptElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("script"), ScriptElement);
    }
    created() {
      this.async = null;
      this.charset = null;
      this.crossOrigin = null;
      this.defer = null;
      this.integrity = null;
      this.nonce = null;
      this.src = null;
      this.type = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(ScriptElement, 'created');
  dart.setSignature(ScriptElement, {
    constructors: () => ({
      _: [ScriptElement, []],
      new: [ScriptElement, []],
      created: [ScriptElement, []]
    })
  });
  ScriptElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLScriptElement')), dart.const(new _js_helper.Native("HTMLScriptElement"))];
  class SelectElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("select"), SelectElement);
    }
    created() {
      this.autofocus = null;
      this.disabled = null;
      this.form = null;
      this.labels = null;
      this.length = null;
      this.multiple = null;
      this.name = null;
      this.required = null;
      this.selectedIndex = null;
      this.size = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.value = null;
      this.willValidate = null;
      super.created();
    }
    get options() {
      let options = this.querySelectorAll('option').where(dart.fn(e => dart.is(e, OptionElement), core.bool, [dart.dynamic]))[dartx.toList]();
      return new (collection.UnmodifiableListView$(OptionElement))(dart.as(options, core.Iterable$(OptionElement)));
    }
    get selectedOptions() {
      if (dart.notNull(this.multiple)) {
        let options = this.options[dartx.where](dart.fn(o => dart.as(dart.dload(o, 'selected'), core.bool), core.bool, [dart.dynamic]))[dartx.toList]();
        return new (collection.UnmodifiableListView$(OptionElement))(dart.as(options, core.Iterable$(OptionElement)));
      } else {
        return dart.list([this.options[dartx.get](this.selectedIndex)], OptionElement);
      }
    }
  }
  dart.defineNamedConstructor(SelectElement, 'created');
  dart.setSignature(SelectElement, {
    constructors: () => ({
      _: [SelectElement, []],
      new: [SelectElement, []],
      created: [SelectElement, []]
    }),
    methods: () => ({
      [__setter__]: [dart.void, [core.int, OptionElement]],
      add: [dart.void, [HtmlElement, core.int]],
      checkValidity: [core.bool, []],
      item: [Element, [core.int]],
      namedItem: [Element, [core.String]],
      setCustomValidity: [dart.void, [core.String]]
    })
  });
  SelectElement[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLSelectElement')), dart.const(new _js_helper.Native("HTMLSelectElement"))];
  class Selection extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Selection, {
    constructors: () => ({_: [Selection, []]}),
    methods: () => ({
      addRange: [dart.void, [Range]],
      collapse: [dart.void, [Node], [core.int]],
      collapseToEnd: [dart.void, []],
      collapseToStart: [dart.void, []],
      containsNode: [core.bool, [Node, core.bool]],
      deleteFromDocument: [dart.void, []],
      empty: [dart.void, []],
      extend: [dart.void, [Node], [core.int]],
      getRangeAt: [Range, [core.int]],
      modify: [dart.void, [core.String, core.String, core.String]],
      removeAllRanges: [dart.void, []],
      selectAllChildren: [dart.void, [Node]],
      setBaseAndExtent: [dart.void, [Node, core.int, Node, core.int]],
      setPosition: [dart.void, [Node], [core.int]]
    })
  });
  Selection[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Selection')), dart.const(new _js_helper.Native("Selection"))];
  class ServiceWorkerClient extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ServiceWorkerClient, {
    constructors: () => ({_: [ServiceWorkerClient, []]}),
    methods: () => ({postMessage: [dart.void, [dart.dynamic], [core.List$(MessagePort)]]})
  });
  ServiceWorkerClient[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ServiceWorkerClient')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ServiceWorkerClient"))];
  let _getAll_1 = Symbol('_getAll_1');
  let _getAll_2 = Symbol('_getAll_2');
  class ServiceWorkerClients extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    getAll(options) {
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return this[_getAll_1](options_1);
      }
      return this[_getAll_2]();
    }
  }
  dart.setSignature(ServiceWorkerClients, {
    constructors: () => ({_: [ServiceWorkerClients, []]}),
    methods: () => ({
      getAll: [async.Future, [], [core.Map]],
      [_getAll_1]: [async.Future, [dart.dynamic]],
      [_getAll_2]: [async.Future, []]
    })
  });
  ServiceWorkerClients[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ServiceWorkerClients')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ServiceWorkerClients"))];
  let _register_1 = Symbol('_register_1');
  let _register_2 = Symbol('_register_2');
  class ServiceWorkerContainer extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    register(url, options) {
      if (options === void 0)
        options = null;
      if (options != null) {
        let options_1 = html_common.convertDartToNative_Dictionary(options);
        return this[_register_1](url, options_1);
      }
      return this[_register_2](url);
    }
  }
  dart.setSignature(ServiceWorkerContainer, {
    constructors: () => ({_: [ServiceWorkerContainer, []]}),
    methods: () => ({
      getRegistration: [async.Future, [], [core.String]],
      register: [async.Future, [core.String], [core.Map]],
      [_register_1]: [async.Future, [dart.dynamic, dart.dynamic]],
      [_register_2]: [async.Future, [dart.dynamic]]
    })
  });
  ServiceWorkerContainer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ServiceWorkerContainer')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ServiceWorkerContainer"))];
  let _fetch_1 = Symbol('_fetch_1');
  let _fetch_2 = Symbol('_fetch_2');
  let _fetch_3 = Symbol('_fetch_3');
  let _fetch_4 = Symbol('_fetch_4');
  let _fetch = Symbol('_fetch');
  class ServiceWorkerGlobalScope extends WorkerGlobalScope {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    [_fetch](request, requestInitDict) {
      if (requestInitDict === void 0)
        requestInitDict = null;
      if ((typeof request == 'string' || request == null) && requestInitDict == null) {
        return this[_fetch_1](dart.as(request, core.String));
      }
      if (requestInitDict != null && (typeof request == 'string' || request == null)) {
        let requestInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict);
        return this[_fetch_2](dart.as(request, core.String), requestInitDict_1);
      }
      if ((dart.is(request, _Request) || request == null) && requestInitDict == null) {
        return this[_fetch_3](dart.as(request, _Request));
      }
      if (requestInitDict != null && (dart.is(request, _Request) || request == null)) {
        let requestInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict);
        return this[_fetch_4](dart.as(request, _Request), requestInitDict_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    get onMessage() {
      return ServiceWorkerGlobalScope.messageEvent.forTarget(this);
    }
  }
  dart.setSignature(ServiceWorkerGlobalScope, {
    constructors: () => ({_: [ServiceWorkerGlobalScope, []]}),
    methods: () => ({
      [_fetch]: [async.Future, [dart.dynamic], [core.Map]],
      [_fetch_1]: [async.Future, [core.String]],
      [_fetch_2]: [async.Future, [core.String, dart.dynamic]],
      [_fetch_3]: [async.Future, [_Request]],
      [_fetch_4]: [async.Future, [_Request, dart.dynamic]]
    })
  });
  ServiceWorkerGlobalScope[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ServiceWorkerGlobalScope')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ServiceWorkerGlobalScope"))];
  ServiceWorkerGlobalScope.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  class ServiceWorkerRegistration extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ServiceWorkerRegistration, {
    constructors: () => ({_: [ServiceWorkerRegistration, []]}),
    methods: () => ({unregister: [async.Future, []]})
  });
  ServiceWorkerRegistration[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ServiceWorkerRegistration')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ServiceWorkerRegistration"))];
  class ShadowElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("shadow"), ShadowElement);
    }
    created() {
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('shadow');
    }
  }
  dart.defineNamedConstructor(ShadowElement, 'created');
  dart.setSignature(ShadowElement, {
    constructors: () => ({
      _: [ShadowElement, []],
      new: [ShadowElement, []],
      created: [ShadowElement, []]
    }),
    methods: () => ({getDistributedNodes: [core.List$(Node), []]})
  });
  ShadowElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLShadowElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '26')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLShadowElement"))];
  class ShadowRoot extends DocumentFragment {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!(Element.prototype.createShadowRoot || Element.prototype.webkitCreateShadowRoot), core.bool);
    }
    static _shadowRootDeprecationReport() {
      if (!dart.notNull(ShadowRoot._shadowRootDeprecationReported)) {
        exports.window.console.warn('ShadowRoot.resetStyleInheritance and ShadowRoot.applyAuthorStyles now deprecated in dart:html.\nPlease remove them from your code.\n');
        ShadowRoot._shadowRootDeprecationReported = true;
      }
    }
    get resetStyleInheritance() {
      ShadowRoot._shadowRootDeprecationReport();
      return false;
    }
    set resetStyleInheritance(value) {
      ShadowRoot._shadowRootDeprecationReport();
    }
    get applyAuthorStyles() {
      ShadowRoot._shadowRootDeprecationReport();
      return false;
    }
    set applyAuthorStyles(value) {
      ShadowRoot._shadowRootDeprecationReport();
    }
  }
  dart.virtualField(ShadowRoot, 'innerHtml');
  dart.setSignature(ShadowRoot, {
    constructors: () => ({_: [ShadowRoot, []]}),
    methods: () => ({
      elementFromPoint: [Element, [core.int, core.int]],
      getElementsByClassName: [core.List$(Node), [core.String]],
      getElementsByTagName: [core.List$(Node), [core.String]],
      getSelection: [Selection, []]
    }),
    statics: () => ({_shadowRootDeprecationReport: [dart.void, []]}),
    names: ['_shadowRootDeprecationReport']
  });
  ShadowRoot[dart.metadata] = () => [dart.const(new _metadata.DomName('ShadowRoot')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '26')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ShadowRoot"))];
  ShadowRoot._shadowRootDeprecationReported = false;
  class SharedWorker extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(scriptURL, name) {
      if (name === void 0)
        name = null;
      if (name != null) {
        return SharedWorker._create_1(scriptURL, name);
      }
      return SharedWorker._create_2(scriptURL);
    }
    static _create_1(scriptURL, name) {
      return dart.as(new SharedWorker(scriptURL, name), SharedWorker);
    }
    static _create_2(scriptURL) {
      return dart.as(new SharedWorker(scriptURL), SharedWorker);
    }
    get onError() {
      return SharedWorker.errorEvent.forTarget(this);
    }
  }
  SharedWorker[dart.implements] = () => [AbstractWorker];
  dart.setSignature(SharedWorker, {
    constructors: () => ({
      _: [SharedWorker, []],
      new: [SharedWorker, [core.String], [core.String]]
    }),
    statics: () => ({
      _create_1: [SharedWorker, [dart.dynamic, dart.dynamic]],
      _create_2: [SharedWorker, [dart.dynamic]]
    }),
    names: ['_create_1', '_create_2']
  });
  SharedWorker[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SharedWorker')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SharedWorker"))];
  SharedWorker.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  class SharedWorkerGlobalScope extends WorkerGlobalScope {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onConnect() {
      return SharedWorkerGlobalScope.connectEvent.forTarget(this);
    }
  }
  dart.setSignature(SharedWorkerGlobalScope, {
    constructors: () => ({_: [SharedWorkerGlobalScope, []]})
  });
  SharedWorkerGlobalScope[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SharedWorkerGlobalScope')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SharedWorkerGlobalScope"))];
  SharedWorkerGlobalScope.connectEvent = dart.const(new (EventStreamProvider$(Event))('connect'));
  class SourceBuffer extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SourceBuffer, {
    constructors: () => ({_: [SourceBuffer, []]}),
    methods: () => ({
      abort: [dart.void, []],
      appendBuffer: [dart.void, [typed_data.ByteBuffer]],
      appendStream: [dart.void, [FileStream], [core.int]],
      appendTypedData: [dart.void, [typed_data.TypedData]],
      remove: [dart.void, [core.num, core.num]]
    })
  });
  SourceBuffer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SourceBuffer')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SourceBuffer"))];
  class SourceBufferList extends dart.mixin(EventTarget, collection.ListMixin$(SourceBuffer), ImmutableListMixin$(SourceBuffer)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], SourceBuffer);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], SourceBuffer);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], SourceBuffer);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], SourceBuffer);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  SourceBufferList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(SourceBuffer)];
  dart.setSignature(SourceBufferList, {
    constructors: () => ({_: [SourceBufferList, []]}),
    methods: () => ({
      get: [SourceBuffer, [core.int]],
      set: [dart.void, [core.int, SourceBuffer]],
      elementAt: [SourceBuffer, [core.int]],
      item: [SourceBuffer, [core.int]]
    })
  });
  dart.defineExtensionMembers(SourceBufferList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  SourceBufferList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SourceBufferList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SourceBufferList"))];
  class SourceElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("source"), SourceElement);
    }
    created() {
      this.integrity = null;
      this.media = null;
      this.sizes = null;
      this.src = null;
      this.srcset = null;
      this.type = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(SourceElement, 'created');
  dart.setSignature(SourceElement, {
    constructors: () => ({
      _: [SourceElement, []],
      new: [SourceElement, []],
      created: [SourceElement, []]
    })
  });
  SourceElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLSourceElement')), dart.const(new _js_helper.Native("HTMLSourceElement"))];
  class SourceInfo extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SourceInfo, {
    constructors: () => ({_: [SourceInfo, []]})
  });
  SourceInfo[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SourceInfo')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SourceInfo"))];
  class SpanElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("span"), SpanElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(SpanElement, 'created');
  dart.setSignature(SpanElement, {
    constructors: () => ({
      _: [SpanElement, []],
      new: [SpanElement, []],
      created: [SpanElement, []]
    })
  });
  SpanElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLSpanElement')), dart.const(new _js_helper.Native("HTMLSpanElement"))];
  class SpeechGrammar extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return SpeechGrammar._create_1();
    }
    static _create_1() {
      return dart.as(new SpeechGrammar(), SpeechGrammar);
    }
  }
  dart.setSignature(SpeechGrammar, {
    constructors: () => ({
      _: [SpeechGrammar, []],
      new: [SpeechGrammar, []]
    }),
    statics: () => ({_create_1: [SpeechGrammar, []]}),
    names: ['_create_1']
  });
  SpeechGrammar[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechGrammar')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechGrammar"))];
  class SpeechGrammarList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(SpeechGrammar), ImmutableListMixin$(SpeechGrammar)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return SpeechGrammarList._create_1();
    }
    static _create_1() {
      return dart.as(new SpeechGrammarList(), SpeechGrammarList);
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], SpeechGrammar);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], SpeechGrammar);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], SpeechGrammar);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], SpeechGrammar);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  SpeechGrammarList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(SpeechGrammar)];
  dart.setSignature(SpeechGrammarList, {
    constructors: () => ({
      _: [SpeechGrammarList, []],
      new: [SpeechGrammarList, []]
    }),
    methods: () => ({
      get: [SpeechGrammar, [core.int]],
      set: [dart.void, [core.int, SpeechGrammar]],
      elementAt: [SpeechGrammar, [core.int]],
      addFromString: [dart.void, [core.String], [core.num]],
      addFromUri: [dart.void, [core.String], [core.num]],
      item: [SpeechGrammar, [core.int]]
    }),
    statics: () => ({_create_1: [SpeechGrammarList, []]}),
    names: ['_create_1']
  });
  dart.defineExtensionMembers(SpeechGrammarList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  SpeechGrammarList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechGrammarList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechGrammarList"))];
  class SpeechRecognition extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!(window.SpeechRecognition || window.webkitSpeechRecognition), core.bool);
    }
    get onAudioEnd() {
      return SpeechRecognition.audioEndEvent.forTarget(this);
    }
    get onAudioStart() {
      return SpeechRecognition.audioStartEvent.forTarget(this);
    }
    get onEnd() {
      return SpeechRecognition.endEvent.forTarget(this);
    }
    get onError() {
      return SpeechRecognition.errorEvent.forTarget(this);
    }
    get onNoMatch() {
      return SpeechRecognition.noMatchEvent.forTarget(this);
    }
    get onResult() {
      return SpeechRecognition.resultEvent.forTarget(this);
    }
    get onSoundEnd() {
      return SpeechRecognition.soundEndEvent.forTarget(this);
    }
    get onSoundStart() {
      return SpeechRecognition.soundStartEvent.forTarget(this);
    }
    get onSpeechEnd() {
      return SpeechRecognition.speechEndEvent.forTarget(this);
    }
    get onSpeechStart() {
      return SpeechRecognition.speechStartEvent.forTarget(this);
    }
    get onStart() {
      return SpeechRecognition.startEvent.forTarget(this);
    }
    static new() {
      return dart.as(new (window.SpeechRecognition || window.webkitSpeechRecognition)(), SpeechRecognition);
    }
  }
  dart.setSignature(SpeechRecognition, {
    constructors: () => ({
      _: [SpeechRecognition, []],
      new: [SpeechRecognition, []]
    }),
    methods: () => ({
      abort: [dart.void, []],
      start: [dart.void, []],
      stop: [dart.void, []]
    })
  });
  SpeechRecognition[dart.metadata] = () => [dart.const(new _metadata.DomName('SpeechRecognition')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechRecognition"))];
  SpeechRecognition.audioEndEvent = dart.const(new (EventStreamProvider$(Event))('audioend'));
  SpeechRecognition.audioStartEvent = dart.const(new (EventStreamProvider$(Event))('audiostart'));
  SpeechRecognition.endEvent = dart.const(new (EventStreamProvider$(Event))('end'));
  class SpeechRecognitionError extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechRecognitionError, {
    constructors: () => ({_: [SpeechRecognitionError, []]})
  });
  SpeechRecognitionError[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechRecognitionError')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechRecognitionError"))];
  SpeechRecognition.errorEvent = dart.const(new (EventStreamProvider$(SpeechRecognitionError))('error'));
  class SpeechRecognitionEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechRecognitionEvent, {
    constructors: () => ({_: [SpeechRecognitionEvent, []]})
  });
  SpeechRecognitionEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechRecognitionEvent')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechRecognitionEvent"))];
  SpeechRecognition.noMatchEvent = dart.const(new (EventStreamProvider$(SpeechRecognitionEvent))('nomatch'));
  SpeechRecognition.resultEvent = dart.const(new (EventStreamProvider$(SpeechRecognitionEvent))('result'));
  SpeechRecognition.soundEndEvent = dart.const(new (EventStreamProvider$(Event))('soundend'));
  SpeechRecognition.soundStartEvent = dart.const(new (EventStreamProvider$(Event))('soundstart'));
  SpeechRecognition.speechEndEvent = dart.const(new (EventStreamProvider$(Event))('speechend'));
  SpeechRecognition.speechStartEvent = dart.const(new (EventStreamProvider$(Event))('speechstart'));
  SpeechRecognition.startEvent = dart.const(new (EventStreamProvider$(Event))('start'));
  class SpeechRecognitionAlternative extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechRecognitionAlternative, {
    constructors: () => ({_: [SpeechRecognitionAlternative, []]})
  });
  SpeechRecognitionAlternative[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechRecognitionAlternative')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechRecognitionAlternative"))];
  class SpeechRecognitionResult extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechRecognitionResult, {
    constructors: () => ({_: [SpeechRecognitionResult, []]}),
    methods: () => ({item: [SpeechRecognitionAlternative, [core.int]]})
  });
  SpeechRecognitionResult[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechRecognitionResult')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME, '25')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechRecognitionResult"))];
  class SpeechSynthesis extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechSynthesis, {
    constructors: () => ({_: [SpeechSynthesis, []]}),
    methods: () => ({
      cancel: [dart.void, []],
      getVoices: [core.List$(SpeechSynthesisVoice), []],
      pause: [dart.void, []],
      resume: [dart.void, []],
      speak: [dart.void, [SpeechSynthesisUtterance]]
    })
  });
  SpeechSynthesis[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechSynthesis')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechSynthesis"))];
  class SpeechSynthesisEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechSynthesisEvent, {
    constructors: () => ({_: [SpeechSynthesisEvent, []]})
  });
  SpeechSynthesisEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechSynthesisEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechSynthesisEvent"))];
  class SpeechSynthesisUtterance extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(text) {
      if (text === void 0)
        text = null;
      if (text != null) {
        return SpeechSynthesisUtterance._create_1(text);
      }
      return SpeechSynthesisUtterance._create_2();
    }
    static _create_1(text) {
      return dart.as(new SpeechSynthesisUtterance(text), SpeechSynthesisUtterance);
    }
    static _create_2() {
      return dart.as(new SpeechSynthesisUtterance(), SpeechSynthesisUtterance);
    }
    get onBoundary() {
      return SpeechSynthesisUtterance.boundaryEvent.forTarget(this);
    }
    get onEnd() {
      return SpeechSynthesisUtterance.endEvent.forTarget(this);
    }
    get onError() {
      return SpeechSynthesisUtterance.errorEvent.forTarget(this);
    }
    get onMark() {
      return SpeechSynthesisUtterance.markEvent.forTarget(this);
    }
    get onPause() {
      return SpeechSynthesisUtterance.pauseEvent.forTarget(this);
    }
    get onResume() {
      return SpeechSynthesisUtterance.resumeEvent.forTarget(this);
    }
    get onStart() {
      return SpeechSynthesisUtterance.startEvent.forTarget(this);
    }
  }
  dart.setSignature(SpeechSynthesisUtterance, {
    constructors: () => ({
      _: [SpeechSynthesisUtterance, []],
      new: [SpeechSynthesisUtterance, [], [core.String]]
    }),
    statics: () => ({
      _create_1: [SpeechSynthesisUtterance, [dart.dynamic]],
      _create_2: [SpeechSynthesisUtterance, []]
    }),
    names: ['_create_1', '_create_2']
  });
  SpeechSynthesisUtterance[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechSynthesisUtterance')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechSynthesisUtterance"))];
  SpeechSynthesisUtterance.boundaryEvent = dart.const(new (EventStreamProvider$(SpeechSynthesisEvent))('boundary'));
  SpeechSynthesisUtterance.endEvent = dart.const(new (EventStreamProvider$(SpeechSynthesisEvent))('end'));
  SpeechSynthesisUtterance.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  SpeechSynthesisUtterance.markEvent = dart.const(new (EventStreamProvider$(SpeechSynthesisEvent))('mark'));
  SpeechSynthesisUtterance.pauseEvent = dart.const(new (EventStreamProvider$(Event))('pause'));
  SpeechSynthesisUtterance.resumeEvent = dart.const(new (EventStreamProvider$(SpeechSynthesisEvent))('resume'));
  SpeechSynthesisUtterance.startEvent = dart.const(new (EventStreamProvider$(SpeechSynthesisEvent))('start'));
  class SpeechSynthesisVoice extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(SpeechSynthesisVoice, {
    constructors: () => ({_: [SpeechSynthesisVoice, []]})
  });
  SpeechSynthesisVoice[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechSynthesisVoice')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechSynthesisVoice"))];
  let _getItem = Symbol('_getItem');
  let _setItem = Symbol('_setItem');
  let _removeItem = Symbol('_removeItem');
  let _key = Symbol('_key');
  let _length = Symbol('_length');
  let __delete__ = Symbol('__delete__');
  class Storage extends _interceptors.Interceptor {
    addAll(other) {
      other.forEach(dart.fn((k, v) => {
        this.set(dart.as(k, core.String), dart.as(v, core.String));
      }));
    }
    containsValue(value) {
      return this.values[dartx.any](dart.fn(e => dart.equals(e, value), core.bool, [dart.dynamic]));
    }
    containsKey(key) {
      return this[_getItem](key) != null;
    }
    get(key) {
      return this[_getItem](key);
    }
    set(key, value) {
      this[_setItem](key, value);
      return value;
    }
    putIfAbsent(key, ifAbsent) {
      if (!dart.notNull(this.containsKey(key)))
        this.set(key, ifAbsent());
      return this.get(key);
    }
    remove(key) {
      let value = this.get(key);
      this[_removeItem](key);
      return dart.as(value, core.String);
    }
    clear() {
      return this[_clear]();
    }
    forEach(f) {
      for (let i = 0; true; i = dart.dsend(i, '+', 1)) {
        let key = this[_key](dart.as(i, core.int));
        if (key == null)
          return;
        f(dart.as(key, core.String), this.get(dart.as(key, core.String)));
      }
    }
    get keys() {
      let keys = [];
      this.forEach(dart.fn((k, v) => dart.dsend(keys, 'add', k)));
      return dart.as(keys, core.Iterable$(core.String));
    }
    get values() {
      let values = [];
      this.forEach(dart.fn((k, v) => dart.dsend(values, 'add', v)));
      return dart.as(values, core.Iterable$(core.String));
    }
    get length() {
      return this[_length];
    }
    get isEmpty() {
      return this[_key](0) == null;
    }
    get isNotEmpty() {
      return !dart.notNull(this.isEmpty);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  Storage[dart.implements] = () => [core.Map$(core.String, core.String)];
  dart.setSignature(Storage, {
    constructors: () => ({_: [Storage, []]}),
    methods: () => ({
      addAll: [dart.void, [core.Map$(core.String, core.String)]],
      containsValue: [core.bool, [core.String]],
      containsKey: [core.bool, [core.String]],
      get: [core.String, [core.String]],
      set: [dart.void, [core.String, core.String]],
      putIfAbsent: [core.String, [core.String, dart.functionType(core.String, [])]],
      remove: [core.String, [core.String]],
      clear: [dart.void, []],
      forEach: [dart.void, [dart.functionType(dart.void, [core.String, core.String])]],
      [__delete__]: [core.bool, [dart.dynamic]],
      [__getter__]: [core.String, [dart.dynamic]],
      [__setter__]: [dart.void, [dart.dynamic, core.String]],
      [_clear]: [dart.void, []],
      [_getItem]: [core.String, [core.String]],
      [_key]: [core.String, [core.int]],
      [_removeItem]: [dart.void, [core.String]],
      [_setItem]: [dart.void, [core.String, core.String]]
    })
  });
  Storage[dart.metadata] = () => [dart.const(new _metadata.DomName('Storage')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("Storage"))];
  let StorageErrorCallback = dart.typedef('StorageErrorCallback', () => dart.functionType(dart.void, [DomError]));
  class StorageInfo extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(StorageInfo, {
    constructors: () => ({_: [StorageInfo, []]})
  });
  StorageInfo[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('StorageInfo')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("StorageInfo"))];
  class StorageQuota extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(StorageQuota, {
    constructors: () => ({_: [StorageQuota, []]}),
    methods: () => ({
      queryInfo: [async.Future, [core.String]],
      requestPersistentQuota: [async.Future, [core.int]]
    })
  });
  StorageQuota[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('StorageQuota')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("StorageQuota"))];
  let StorageQuotaCallback = dart.typedef('StorageQuotaCallback', () => dart.functionType(dart.void, [core.int]));
  let StorageUsageCallback = dart.typedef('StorageUsageCallback', () => dart.functionType(dart.void, [core.int, core.int]));
  let _StringCallback = dart.typedef('_StringCallback', () => dart.functionType(dart.void, [core.String]));
  class StyleElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("style"), StyleElement);
    }
    created() {
      this.disabled = null;
      this.media = null;
      this.sheet = null;
      this.type = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(StyleElement, 'created');
  dart.setSignature(StyleElement, {
    constructors: () => ({
      _: [StyleElement, []],
      new: [StyleElement, []],
      created: [StyleElement, []]
    })
  });
  StyleElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLStyleElement')), dart.const(new _js_helper.Native("HTMLStyleElement"))];
  class StyleMedia extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(StyleMedia, {
    constructors: () => ({_: [StyleMedia, []]}),
    methods: () => ({matchMedium: [core.bool, [core.String]]})
  });
  StyleMedia[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('StyleMedia')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("StyleMedia"))];
  class TableCaptionElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("caption"), TableCaptionElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(TableCaptionElement, 'created');
  dart.setSignature(TableCaptionElement, {
    constructors: () => ({
      _: [TableCaptionElement, []],
      new: [TableCaptionElement, []],
      created: [TableCaptionElement, []]
    })
  });
  TableCaptionElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTableCaptionElement')), dart.const(new _js_helper.Native("HTMLTableCaptionElement"))];
  class TableCellElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("td"), TableCellElement);
    }
    created() {
      this.cellIndex = null;
      this.colSpan = null;
      this.headers = null;
      this.rowSpan = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(TableCellElement, 'created');
  dart.setSignature(TableCellElement, {
    constructors: () => ({
      _: [TableCellElement, []],
      new: [TableCellElement, []],
      created: [TableCellElement, []]
    })
  });
  TableCellElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTableCellElement')), dart.const(new _js_helper.Native("HTMLTableCellElement,HTMLTableDataCellElement,HTMLTableHeaderCellElement"))];
  class TableColElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("col"), TableColElement);
    }
    created() {
      this.span = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(TableColElement, 'created');
  dart.setSignature(TableColElement, {
    constructors: () => ({
      _: [TableColElement, []],
      new: [TableColElement, []],
      created: [TableColElement, []]
    })
  });
  TableColElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTableColElement')), dart.const(new _js_helper.Native("HTMLTableColElement"))];
  let _tBodies = Symbol('_tBodies');
  let _rows = Symbol('_rows');
  let _createCaption = Symbol('_createCaption');
  let _createTBody = Symbol('_createTBody');
  let _createTFoot = Symbol('_createTFoot');
  let _createTHead = Symbol('_createTHead');
  let _insertRow = Symbol('_insertRow');
  let _nativeCreateTBody = Symbol('_nativeCreateTBody');
  class TableElement extends HtmlElement {
    get tBodies() {
      return new (_WrappedList$(TableSectionElement))(this[_tBodies]);
    }
    get rows() {
      return new (_WrappedList$(TableRowElement))(this[_rows]);
    }
    addRow() {
      return this.insertRow(-1);
    }
    createCaption() {
      return dart.as(this[_createCaption](), TableCaptionElement);
    }
    createTBody() {
      return this[_createTBody]();
    }
    createTFoot() {
      return dart.as(this[_createTFoot](), TableSectionElement);
    }
    createTHead() {
      return dart.as(this[_createTHead](), TableSectionElement);
    }
    insertRow(index) {
      return dart.as(this[_insertRow](index), TableRowElement);
    }
    [_createTBody]() {
      if (dart.notNull(dart.as(!!this.createTBody, core.bool))) {
        return this[_nativeCreateTBody]();
      }
      let tbody = Element.tag('tbody');
      this.children[dartx.add](dart.as(tbody, Element));
      return dart.as(tbody, TableSectionElement);
    }
    createFragment(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      if (dart.notNull(Range.supportsCreateContextualFragment)) {
        return super.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer});
      }
      let contextualHtml = `<table>${html}</table>`;
      let table = Element.html(dart.as(contextualHtml, core.String), {validator: validator, treeSanitizer: treeSanitizer});
      let fragment = DocumentFragment.new();
      dart.dsend(dart.dload(fragment, 'nodes'), 'addAll', dart.dload(table, 'nodes'));
      return dart.as(fragment, DocumentFragment);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("table"), TableElement);
    }
    created() {
      this.caption = null;
      this[_rows] = null;
      this[_tBodies] = null;
      this.tFoot = null;
      this.tHead = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(TableElement, 'created');
  dart.setSignature(TableElement, {
    constructors: () => ({
      _: [TableElement, []],
      new: [TableElement, []],
      created: [TableElement, []]
    }),
    methods: () => ({
      addRow: [TableRowElement, []],
      createCaption: [TableCaptionElement, []],
      createTBody: [TableSectionElement, []],
      createTFoot: [TableSectionElement, []],
      createTHead: [TableSectionElement, []],
      insertRow: [TableRowElement, [core.int]],
      [_createTBody]: [TableSectionElement, []],
      [_nativeCreateTBody]: [TableSectionElement, []],
      [_createCaption]: [HtmlElement, []],
      [_createTFoot]: [HtmlElement, []],
      [_createTHead]: [HtmlElement, []],
      deleteCaption: [dart.void, []],
      deleteRow: [dart.void, [core.int]],
      deleteTFoot: [dart.void, []],
      deleteTHead: [dart.void, []],
      [_insertRow]: [HtmlElement, [], [core.int]]
    })
  });
  TableElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTableElement')), dart.const(new _js_helper.Native("HTMLTableElement"))];
  let _cells = Symbol('_cells');
  let _insertCell = Symbol('_insertCell');
  class TableRowElement extends HtmlElement {
    get cells() {
      return new (_WrappedList$(TableCellElement))(this[_cells]);
    }
    addCell() {
      return this.insertCell(-1);
    }
    insertCell(index) {
      return dart.as(this[_insertCell](index), TableCellElement);
    }
    createFragment(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      if (dart.notNull(Range.supportsCreateContextualFragment)) {
        return super.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer});
      }
      let fragment = DocumentFragment.new();
      let section = TableElement.new().createFragment(html, {validator: validator, treeSanitizer: treeSanitizer}).nodes[dartx.single];
      let row = dart.dload(dart.dload(section, 'nodes'), 'single');
      dart.dsend(dart.dload(fragment, 'nodes'), 'addAll', dart.dload(row, 'nodes'));
      return dart.as(fragment, DocumentFragment);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("tr"), TableRowElement);
    }
    created() {
      this[_cells] = null;
      this.rowIndex = null;
      this.sectionRowIndex = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(TableRowElement, 'created');
  dart.setSignature(TableRowElement, {
    constructors: () => ({
      _: [TableRowElement, []],
      new: [TableRowElement, []],
      created: [TableRowElement, []]
    }),
    methods: () => ({
      addCell: [TableCellElement, []],
      insertCell: [TableCellElement, [core.int]],
      deleteCell: [dart.void, [core.int]],
      [_insertCell]: [HtmlElement, [], [core.int]]
    })
  });
  TableRowElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTableRowElement')), dart.const(new _js_helper.Native("HTMLTableRowElement"))];
  class TableSectionElement extends HtmlElement {
    get rows() {
      return new (_WrappedList$(TableRowElement))(this[_rows]);
    }
    addRow() {
      return this.insertRow(-1);
    }
    insertRow(index) {
      return dart.as(this[_insertRow](index), TableRowElement);
    }
    createFragment(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      if (dart.notNull(Range.supportsCreateContextualFragment)) {
        return super.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer});
      }
      let fragment = DocumentFragment.new();
      let section = TableElement.new().createFragment(html, {validator: validator, treeSanitizer: treeSanitizer}).nodes[dartx.single];
      dart.dsend(dart.dload(fragment, 'nodes'), 'addAll', dart.dload(section, 'nodes'));
      return dart.as(fragment, DocumentFragment);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      this[_rows] = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(TableSectionElement, 'created');
  dart.setSignature(TableSectionElement, {
    constructors: () => ({
      _: [TableSectionElement, []],
      created: [TableSectionElement, []]
    }),
    methods: () => ({
      addRow: [TableRowElement, []],
      insertRow: [TableRowElement, [core.int]],
      deleteRow: [dart.void, [core.int]],
      [_insertRow]: [HtmlElement, [], [core.int]]
    })
  });
  TableSectionElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTableSectionElement')), dart.const(new _js_helper.Native("HTMLTableSectionElement"))];
  class TemplateElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("template"), TemplateElement);
    }
    created() {
      this.content = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('template');
    }
    setInnerHtml(html, opts) {
      let validator = opts && 'validator' in opts ? opts.validator : null;
      let treeSanitizer = opts && 'treeSanitizer' in opts ? opts.treeSanitizer : null;
      this.text = null;
      let fragment = this.createFragment(html, {validator: validator, treeSanitizer: treeSanitizer});
      this.content.append(dart.as(fragment, Node));
    }
  }
  dart.defineNamedConstructor(TemplateElement, 'created');
  dart.setSignature(TemplateElement, {
    constructors: () => ({
      _: [TemplateElement, []],
      new: [TemplateElement, []],
      created: [TemplateElement, []]
    })
  });
  TemplateElement[dart.metadata] = () => [dart.const(new _metadata.Experimental()), dart.const(new _metadata.DomName('HTMLTemplateElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLTemplateElement"))];
  class TextAreaElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("textarea"), TextAreaElement);
    }
    created() {
      this.autofocus = null;
      this.cols = null;
      this.defaultValue = null;
      this.dirName = null;
      this.disabled = null;
      this.form = null;
      this.inputMode = null;
      this.labels = null;
      this.maxLength = null;
      this.name = null;
      this.placeholder = null;
      this.readOnly = null;
      this.required = null;
      this.rows = null;
      this.selectionDirection = null;
      this.selectionEnd = null;
      this.selectionStart = null;
      this.textLength = null;
      this.type = null;
      this.validationMessage = null;
      this.validity = null;
      this.value = null;
      this.willValidate = null;
      this.wrap = null;
      super.created();
    }
  }
  dart.defineNamedConstructor(TextAreaElement, 'created');
  dart.setSignature(TextAreaElement, {
    constructors: () => ({
      _: [TextAreaElement, []],
      new: [TextAreaElement, []],
      created: [TextAreaElement, []]
    }),
    methods: () => ({
      checkValidity: [core.bool, []],
      select: [dart.void, []],
      setCustomValidity: [dart.void, [core.String]],
      setRangeText: [dart.void, [core.String], {start: core.int, end: core.int, selectionMode: core.String}],
      setSelectionRange: [dart.void, [core.int, core.int], [core.String]]
    })
  });
  TextAreaElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTextAreaElement')), dart.const(new _js_helper.Native("HTMLTextAreaElement"))];
  let _initTextEvent = Symbol('_initTextEvent');
  class TextEvent extends UIEvent {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : false;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : false;
      let view = opts && 'view' in opts ? opts.view : null;
      let data = opts && 'data' in opts ? opts.data : null;
      if (view == null) {
        view = exports.window;
      }
      let e = exports.document[_createEvent]("TextEvent");
      dart.dsend(e, _initTextEvent, type, canBubble, cancelable, view, data);
      return dart.as(e, TextEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(TextEvent, {
    constructors: () => ({
      new: [TextEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, view: Window, data: core.String}],
      _: [TextEvent, []]
    }),
    methods: () => ({[_initTextEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.String]]})
  });
  TextEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('TextEvent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("TextEvent"))];
  class TextMetrics extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(TextMetrics, {
    constructors: () => ({_: [TextMetrics, []]})
  });
  TextMetrics[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TextMetrics')), dart.const(new _js_helper.Native("TextMetrics"))];
  class TextTrack extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onCueChange() {
      return TextTrack.cueChangeEvent.forTarget(this);
    }
  }
  dart.setSignature(TextTrack, {
    constructors: () => ({_: [TextTrack, []]}),
    methods: () => ({
      addCue: [dart.void, [TextTrackCue]],
      addRegion: [dart.void, [VttRegion]],
      removeCue: [dart.void, [TextTrackCue]],
      removeRegion: [dart.void, [VttRegion]]
    })
  });
  TextTrack[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TextTrack')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("TextTrack"))];
  TextTrack.cueChangeEvent = dart.const(new (EventStreamProvider$(Event))('cuechange'));
  class TextTrackCue extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onEnter() {
      return TextTrackCue.enterEvent.forTarget(this);
    }
    get onExit() {
      return TextTrackCue.exitEvent.forTarget(this);
    }
  }
  dart.setSignature(TextTrackCue, {
    constructors: () => ({_: [TextTrackCue, []]})
  });
  TextTrackCue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TextTrackCue')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("TextTrackCue"))];
  TextTrackCue.enterEvent = dart.const(new (EventStreamProvider$(Event))('enter'));
  TextTrackCue.exitEvent = dart.const(new (EventStreamProvider$(Event))('exit'));
  class TextTrackCueList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(TextTrackCue), ImmutableListMixin$(TextTrackCue)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], TextTrackCue);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], TextTrackCue);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], TextTrackCue);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], TextTrackCue);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  TextTrackCueList[dart.implements] = () => [core.List$(TextTrackCue), _js_helper.JavaScriptIndexingBehavior];
  dart.setSignature(TextTrackCueList, {
    constructors: () => ({_: [TextTrackCueList, []]}),
    methods: () => ({
      get: [TextTrackCue, [core.int]],
      set: [dart.void, [core.int, TextTrackCue]],
      elementAt: [TextTrackCue, [core.int]],
      getCueById: [TextTrackCue, [core.String]],
      item: [TextTrackCue, [core.int]]
    })
  });
  dart.defineExtensionMembers(TextTrackCueList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  TextTrackCueList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TextTrackCueList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("TextTrackCueList"))];
  class TextTrackList extends dart.mixin(EventTarget, collection.ListMixin$(TextTrack), ImmutableListMixin$(TextTrack)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], TextTrack);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], TextTrack);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], TextTrack);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], TextTrack);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
    get onAddTrack() {
      return TextTrackList.addTrackEvent.forTarget(this);
    }
    get onChange() {
      return TextTrackList.changeEvent.forTarget(this);
    }
  }
  TextTrackList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(TextTrack)];
  dart.setSignature(TextTrackList, {
    constructors: () => ({_: [TextTrackList, []]}),
    methods: () => ({
      get: [TextTrack, [core.int]],
      set: [dart.void, [core.int, TextTrack]],
      elementAt: [TextTrack, [core.int]],
      getTrackById: [TextTrack, [core.String]],
      item: [TextTrack, [core.int]]
    })
  });
  dart.defineExtensionMembers(TextTrackList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  TextTrackList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TextTrackList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("TextTrackList"))];
  class TrackEvent extends Event {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(TrackEvent, {
    constructors: () => ({_: [TrackEvent, []]})
  });
  TrackEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TrackEvent')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("TrackEvent"))];
  TextTrackList.addTrackEvent = dart.const(new (EventStreamProvider$(TrackEvent))('addtrack'));
  TextTrackList.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  class TimeRanges extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(TimeRanges, {
    constructors: () => ({_: [TimeRanges, []]}),
    methods: () => ({
      end: [core.double, [core.int]],
      start: [core.double, [core.int]]
    })
  });
  TimeRanges[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('TimeRanges')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("TimeRanges"))];
  let TimeoutHandler = dart.typedef('TimeoutHandler', () => dart.functionType(dart.void, []));
  class Timing extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(Timing, {
    constructors: () => ({_: [Timing, []]}),
    methods: () => ({
      [__getter__]: [core.Object, [core.String]],
      [__setter__]: [dart.void, [core.String, core.num]]
    })
  });
  Timing[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Timing')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Timing"))];
  class TitleElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("title"), TitleElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(TitleElement, 'created');
  dart.setSignature(TitleElement, {
    constructors: () => ({
      _: [TitleElement, []],
      new: [TitleElement, []],
      created: [TitleElement, []]
    })
  });
  TitleElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTitleElement')), dart.const(new _js_helper.Native("HTMLTitleElement"))];
  let __clientX = Symbol('__clientX');
  let __clientY = Symbol('__clientY');
  let __screenX = Symbol('__screenX');
  let __screenY = Symbol('__screenY');
  let __pageX = Symbol('__pageX');
  let __pageY = Symbol('__pageY');
  let __radiusX = Symbol('__radiusX');
  let __radiusY = Symbol('__radiusY');
  class Touch extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get target() {
      return _convertNativeToDart_EventTarget(this[_get_target]);
    }
    get [__clientX]() {
      return dart.as(dart.dsend(this.clientX, 'round'), core.int);
    }
    get [__clientY]() {
      return dart.as(dart.dsend(this.clientY, 'round'), core.int);
    }
    get [__screenX]() {
      return dart.as(dart.dsend(this.screenX, 'round'), core.int);
    }
    get [__screenY]() {
      return dart.as(dart.dsend(this.screenY, 'round'), core.int);
    }
    get [__pageX]() {
      return dart.as(dart.dsend(this.pageX, 'round'), core.int);
    }
    get [__pageY]() {
      return dart.as(dart.dsend(this.pageY, 'round'), core.int);
    }
    get [__radiusX]() {
      return dart.as(dart.dsend(this.radiusX, 'round'), core.int);
    }
    get [__radiusY]() {
      return dart.as(dart.dsend(this.radiusY, 'round'), core.int);
    }
    get client() {
      return new math.Point(this[__clientX], this[__clientY]);
    }
    get page() {
      return new math.Point(this[__pageX], this[__pageY]);
    }
    get screen() {
      return new math.Point(this[__screenX], this[__screenY]);
    }
    get radiusX() {
      return this[__radiusX];
    }
    get radiusY() {
      return this[__radiusY];
    }
  }
  dart.setSignature(Touch, {
    constructors: () => ({_: [Touch, []]})
  });
  Touch[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Touch')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Touch"))];
  class TouchList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Touch), ImmutableListMixin$(Touch)) {
    static new() {
      return null;
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static get supported() {
      return dart.as(!!document.createTouchList, core.bool);
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], Touch);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], Touch);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], Touch);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], Touch);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  TouchList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(Touch)];
  dart.setSignature(TouchList, {
    constructors: () => ({
      new: [TouchList, []],
      _: [TouchList, []]
    }),
    methods: () => ({
      get: [Touch, [core.int]],
      set: [dart.void, [core.int, Touch]],
      elementAt: [Touch, [core.int]],
      item: [Touch, [core.int]]
    })
  });
  dart.defineExtensionMembers(TouchList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  TouchList[dart.metadata] = () => [dart.const(new _metadata.DomName('TouchList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("TouchList"))];
  class TrackElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("track"), TrackElement);
    }
    created() {
      this.defaultValue = null;
      this.integrity = null;
      this.kind = null;
      this.label = null;
      this.readyState = null;
      this.src = null;
      this.srclang = null;
      this.track = null;
      super.created();
    }
    static get supported() {
      return Element.isTagSupported('track');
    }
  }
  dart.defineNamedConstructor(TrackElement, 'created');
  dart.setSignature(TrackElement, {
    constructors: () => ({
      _: [TrackElement, []],
      new: [TrackElement, []],
      created: [TrackElement, []]
    })
  });
  TrackElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLTrackElement')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("HTMLTrackElement"))];
  TrackElement.ERROR = 3;
  TrackElement.LOADED = 2;
  TrackElement.LOADING = 1;
  TrackElement.NONE = 0;
  class TreeWalker extends _interceptors.Interceptor {
    static new(root, whatToShow) {
      return exports.document[_createTreeWalker](root, whatToShow, null);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(TreeWalker, {
    constructors: () => ({
      new: [TreeWalker, [Node, core.int]],
      _: [TreeWalker, []]
    }),
    methods: () => ({
      firstChild: [Node, []],
      lastChild: [Node, []],
      nextNode: [Node, []],
      nextSibling: [Node, []],
      parentNode: [Node, []],
      previousNode: [Node, []],
      previousSibling: [Node, []]
    })
  });
  TreeWalker[dart.metadata] = () => [dart.const(new _metadata.DomName('TreeWalker')), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("TreeWalker"))];
  class UListElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("ul"), UListElement);
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(UListElement, 'created');
  dart.setSignature(UListElement, {
    constructors: () => ({
      _: [UListElement, []],
      new: [UListElement, []],
      created: [UListElement, []]
    })
  });
  UListElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLUListElement')), dart.const(new _js_helper.Native("HTMLUListElement"))];
  class UnknownElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(UnknownElement, 'created');
  dart.setSignature(UnknownElement, {
    constructors: () => ({
      _: [UnknownElement, []],
      created: [UnknownElement, []]
    })
  });
  UnknownElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLUnknownElement')), dart.const(new _js_helper.Native("HTMLUnknownElement"))];
  class Url extends _interceptors.Interceptor {
    static createObjectUrl(blob_OR_source_OR_stream) {
      return dart.as((self.URL || self.webkitURL).createObjectURL(blob_OR_source_OR_stream), core.String);
    }
    static createObjectUrlFromSource(source) {
      return dart.as((self.URL || self.webkitURL).createObjectURL(source), core.String);
    }
    static createObjectUrlFromStream(stream) {
      return dart.as((self.URL || self.webkitURL).createObjectURL(stream), core.String);
    }
    static createObjectUrlFromBlob(blob) {
      return dart.as((self.URL || self.webkitURL).createObjectURL(blob), core.String);
    }
    static revokeObjectUrl(url) {
      return (self.URL || self.webkitURL).revokeObjectURL(url);
    }
    toString() {
      return dart.as(String(this), core.String);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  Url[dart.implements] = () => [UrlUtils];
  dart.setSignature(Url, {
    constructors: () => ({_: [Url, []]}),
    statics: () => ({
      createObjectUrl: [core.String, [dart.dynamic]],
      createObjectUrlFromSource: [core.String, [MediaSource]],
      createObjectUrlFromStream: [core.String, [MediaStream]],
      createObjectUrlFromBlob: [core.String, [Blob]],
      revokeObjectUrl: [dart.void, [core.String]]
    }),
    names: ['createObjectUrl', 'createObjectUrlFromSource', 'createObjectUrlFromStream', 'createObjectUrlFromBlob', 'revokeObjectUrl']
  });
  dart.defineExtensionMembers(Url, ['toString']);
  Url[dart.metadata] = () => [dart.const(new _metadata.DomName('URL')), dart.const(new _js_helper.Native("URL"))];
  class UrlUtils extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(UrlUtils, {
    constructors: () => ({_: [UrlUtils, []]})
  });
  UrlUtils[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('URLUtils')), dart.const(new _metadata.Experimental())];
  class UrlUtilsReadOnly extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(UrlUtilsReadOnly, {
    constructors: () => ({_: [UrlUtilsReadOnly, []]})
  });
  UrlUtilsReadOnly[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('URLUtilsReadOnly')), dart.const(new _metadata.Experimental())];
  class ValidityState extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(ValidityState, {
    constructors: () => ({_: [ValidityState, []]})
  });
  ValidityState[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ValidityState')), dart.const(new _js_helper.Native("ValidityState"))];
  class VideoElement extends MediaElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return dart.as(exports.document.createElement("video"), VideoElement);
    }
    created() {
      this.height = null;
      this.poster = null;
      this.videoHeight = null;
      this.videoWidth = null;
      this.decodedFrameCount = null;
      this.droppedFrameCount = null;
      this.width = null;
      super.created();
    }
  }
  VideoElement[dart.implements] = () => [CanvasImageSource];
  dart.defineNamedConstructor(VideoElement, 'created');
  dart.setSignature(VideoElement, {
    constructors: () => ({
      _: [VideoElement, []],
      new: [VideoElement, []],
      created: [VideoElement, []]
    }),
    methods: () => ({
      getVideoPlaybackQuality: [VideoPlaybackQuality, []],
      enterFullscreen: [dart.void, []],
      exitFullscreen: [dart.void, []]
    })
  });
  VideoElement[dart.metadata] = () => [dart.const(new _metadata.DomName('HTMLVideoElement')), dart.const(new _js_helper.Native("HTMLVideoElement"))];
  class VideoPlaybackQuality extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(VideoPlaybackQuality, {
    constructors: () => ({_: [VideoPlaybackQuality, []]})
  });
  VideoPlaybackQuality[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('VideoPlaybackQuality')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("VideoPlaybackQuality"))];
  class VideoTrack extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(VideoTrack, {
    constructors: () => ({_: [VideoTrack, []]})
  });
  VideoTrack[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('VideoTrack')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("VideoTrack"))];
  class VideoTrackList extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onChange() {
      return VideoTrackList.changeEvent.forTarget(this);
    }
  }
  dart.setSignature(VideoTrackList, {
    constructors: () => ({_: [VideoTrackList, []]}),
    methods: () => ({
      [__getter__]: [VideoTrack, [core.int]],
      getTrackById: [VideoTrack, [core.String]]
    })
  });
  VideoTrackList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('VideoTrackList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("VideoTrackList"))];
  VideoTrackList.changeEvent = dart.const(new (EventStreamProvider$(Event))('change'));
  let VoidCallback = dart.typedef('VoidCallback', () => dart.functionType(dart.void, []));
  class VttCue extends TextTrackCue {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(startTime, endTime, text) {
      return VttCue._create_1(startTime, endTime, text);
    }
    static _create_1(startTime, endTime, text) {
      return dart.as(new VTTCue(startTime, endTime, text), VttCue);
    }
  }
  dart.setSignature(VttCue, {
    constructors: () => ({
      _: [VttCue, []],
      new: [VttCue, [core.num, core.num, core.String]]
    }),
    methods: () => ({getCueAsHtml: [DocumentFragment, []]}),
    statics: () => ({_create_1: [VttCue, [dart.dynamic, dart.dynamic, dart.dynamic]]}),
    names: ['_create_1']
  });
  VttCue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('VTTCue')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("VTTCue"))];
  class VttRegion extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return VttRegion._create_1();
    }
    static _create_1() {
      return dart.as(new VTTRegion(), VttRegion);
    }
  }
  dart.setSignature(VttRegion, {
    constructors: () => ({
      _: [VttRegion, []],
      new: [VttRegion, []]
    }),
    statics: () => ({_create_1: [VttRegion, []]}),
    names: ['_create_1']
  });
  VttRegion[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('VTTRegion')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("VTTRegion"))];
  class VttRegionList extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(VttRegionList, {
    constructors: () => ({_: [VttRegionList, []]}),
    methods: () => ({
      getRegionById: [VttRegion, [core.String]],
      item: [VttRegion, [core.int]]
    })
  });
  VttRegionList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('VTTRegionList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("VTTRegionList"))];
  class WebSocket extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(url, protocol_OR_protocols) {
      if (protocol_OR_protocols === void 0)
        protocol_OR_protocols = null;
      if ((typeof url == 'string' || url == null) && protocol_OR_protocols == null) {
        return WebSocket._create_1(url);
      }
      if ((typeof protocol_OR_protocols == 'string' || protocol_OR_protocols == null) && (typeof url == 'string' || url == null)) {
        return WebSocket._create_2(url, protocol_OR_protocols);
      }
      if ((dart.is(protocol_OR_protocols, core.List$(core.String)) || protocol_OR_protocols == null) && (typeof url == 'string' || url == null)) {
        let protocols_1 = html_common.convertDartToNative_StringArray(dart.as(protocol_OR_protocols, core.List$(core.String)));
        return WebSocket._create_3(url, protocols_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1(url) {
      return dart.as(new WebSocket(url), WebSocket);
    }
    static _create_2(url, protocol_OR_protocols) {
      return dart.as(new WebSocket(url, protocol_OR_protocols), WebSocket);
    }
    static _create_3(url, protocol_OR_protocols) {
      return dart.as(new WebSocket(url, protocol_OR_protocols), WebSocket);
    }
    static get supported() {
      return dart.as(typeof window.WebSocket != "undefined", core.bool);
    }
    get onClose() {
      return WebSocket.closeEvent.forTarget(this);
    }
    get onError() {
      return WebSocket.errorEvent.forTarget(this);
    }
    get onMessage() {
      return WebSocket.messageEvent.forTarget(this);
    }
    get onOpen() {
      return WebSocket.openEvent.forTarget(this);
    }
  }
  dart.setSignature(WebSocket, {
    constructors: () => ({
      _: [WebSocket, []],
      new: [WebSocket, [core.String], [dart.dynamic]]
    }),
    methods: () => ({
      close: [dart.void, [], [core.int, core.String]],
      send: [dart.void, [dart.dynamic]],
      sendBlob: [dart.void, [Blob]],
      sendByteBuffer: [dart.void, [typed_data.ByteBuffer]],
      sendString: [dart.void, [core.String]],
      sendTypedData: [dart.void, [typed_data.TypedData]]
    }),
    statics: () => ({
      _create_1: [WebSocket, [dart.dynamic]],
      _create_2: [WebSocket, [dart.dynamic, dart.dynamic]],
      _create_3: [WebSocket, [dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3']
  });
  WebSocket[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WebSocket')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Unstable()), dart.const(new _js_helper.Native("WebSocket"))];
  WebSocket.closeEvent = dart.const(new (EventStreamProvider$(CloseEvent))('close'));
  WebSocket.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  WebSocket.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  WebSocket.openEvent = dart.const(new (EventStreamProvider$(Event))('open'));
  WebSocket.CLOSED = 3;
  WebSocket.CLOSING = 2;
  WebSocket.CONNECTING = 0;
  WebSocket.OPEN = 1;
  WheelEvent.DOM_DELTA_LINE = 1;
  WheelEvent.DOM_DELTA_PAGE = 2;
  WheelEvent.DOM_DELTA_PIXEL = 0;
  let _open2 = Symbol('_open2');
  let _open3 = Symbol('_open3');
  let _location = Symbol('_location');
  let _ensureRequestAnimationFrame = Symbol('_ensureRequestAnimationFrame');
  let _requestAnimationFrame = Symbol('_requestAnimationFrame');
  let _cancelAnimationFrame = Symbol('_cancelAnimationFrame');
  let _requestFileSystem = Symbol('_requestFileSystem');
  let _get_opener = Symbol('_get_opener');
  let _get_parent = Symbol('_get_parent');
  let _get_self = Symbol('_get_self');
  let _get_top = Symbol('_get_top');
  let __getter___1 = Symbol('__getter___1');
  let __getter___2 = Symbol('__getter___2');
  let _scroll_1 = Symbol('_scroll_1');
  let _scroll_2 = Symbol('_scroll_2');
  let _scroll_3 = Symbol('_scroll_3');
  let _scroll_4 = Symbol('_scroll_4');
  let _scrollBy_1 = Symbol('_scrollBy_1');
  let _scrollBy_2 = Symbol('_scrollBy_2');
  let _scrollBy_3 = Symbol('_scrollBy_3');
  let _scrollBy_4 = Symbol('_scrollBy_4');
  let _scrollTo_1 = Symbol('_scrollTo_1');
  let _scrollTo_2 = Symbol('_scrollTo_2');
  let _scrollTo_3 = Symbol('_scrollTo_3');
  let _scrollTo_4 = Symbol('_scrollTo_4');
  let __requestFileSystem = Symbol('__requestFileSystem');
  let _resolveLocalFileSystemUrl = Symbol('_resolveLocalFileSystemUrl');
  class Window extends EventTarget {
    get animationFrame() {
      let completer = async.Completer$(core.num).sync();
      this.requestAnimationFrame(dart.fn(time => {
        dart.dsend(completer, 'complete', time);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(core.num));
    }
    get document() {
      return dart.as(this.document, Document);
    }
    [_open2](url, name) {
      return dart.as(this.open(url, name), WindowBase);
    }
    [_open3](url, name, options) {
      return dart.as(this.open(url, name, options), WindowBase);
    }
    open(url, name, options) {
      if (options === void 0)
        options = null;
      if (options == null) {
        return _DOMWindowCrossFrame._createSafe(this[_open2](url, name));
      } else {
        return _DOMWindowCrossFrame._createSafe(this[_open3](url, name, options));
      }
    }
    get location() {
      return dart.as(this[_location], Location);
    }
    set location(value) {
      this[_location] = value;
    }
    get [_location]() {
      return this.location;
    }
    set [_location](value) {
      this.location = value;
    }
    requestAnimationFrame(callback) {
      this[_ensureRequestAnimationFrame]();
      return this[_requestAnimationFrame](dart.as(_wrapZone(callback), RequestAnimationFrameCallback));
    }
    cancelAnimationFrame(id) {
      this[_ensureRequestAnimationFrame]();
      this[_cancelAnimationFrame](id);
    }
    [_ensureRequestAnimationFrame]() {
      if (dart.notNull(dart.as(!!(this.requestAnimationFrame && this.cancelAnimationFrame), core.bool)))
        return;
      (function($this) {
        var vendors = ['ms', 'moz', 'webkit', 'o'];
        for (var i = 0; i < vendors.length && !$this.requestAnimationFrame; ++i) {
          $this.requestAnimationFrame = $this[vendors[i] + 'RequestAnimationFrame'];
          $this.cancelAnimationFrame = $this[vendors[i] + 'CancelAnimationFrame'] || $this[vendors[i] + 'CancelRequestAnimationFrame'];
        }
        if ($this.requestAnimationFrame && $this.cancelAnimationFrame)
          return;
        $this.requestAnimationFrame = function(callback) {
          return window.setTimeout(function() {
            callback(Date.now());
          }, 16);
        };
        $this.cancelAnimationFrame = function(id) {
          clearTimeout(id);
        };
      })(this);
    }
    get indexedDB() {
      return dart.as(this.indexedDB || this.webkitIndexedDB || this.mozIndexedDB, indexed_db.IdbFactory);
    }
    get console() {
      return Console._safeConsole;
    }
    requestFileSystem(size, opts) {
      let persistent = opts && 'persistent' in opts ? opts.persistent : false;
      return this[_requestFileSystem](dart.notNull(persistent) ? 1 : 0, size);
    }
    static get supportsPointConversions() {
      return DomPoint.supported;
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get opener() {
      return _convertNativeToDart_Window(this[_get_opener]);
    }
    set opener(value) {
      this.opener = value;
    }
    get parent() {
      return _convertNativeToDart_Window(this[_get_parent]);
    }
    get self() {
      return _convertNativeToDart_Window(this[_get_self]);
    }
    get top() {
      return _convertNativeToDart_Window(this[_get_top]);
    }
    get window() {
      return _convertNativeToDart_Window(this[_get_window]);
    }
    [__getter__](index_OR_name) {
      if (typeof index_OR_name == 'number') {
        return _convertNativeToDart_Window(this[__getter___1](dart.as(index_OR_name, core.int)));
      }
      if (typeof index_OR_name == 'string') {
        return _convertNativeToDart_Window(this[__getter___2](dart.as(index_OR_name, core.String)));
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    postMessage(message, targetOrigin, transfer) {
      if (transfer === void 0)
        transfer = null;
      if (transfer != null) {
        let message_1 = html_common.convertDartToNative_SerializedScriptValue(message);
        this[_postMessage_1](message_1, targetOrigin, transfer);
        return;
      }
      let message_1 = html_common.convertDartToNative_SerializedScriptValue(message);
      this[_postMessage_2](message_1, targetOrigin);
      return;
    }
    scroll(x, y, scrollOptions) {
      if (scrollOptions === void 0)
        scrollOptions = null;
      if (typeof y == 'number' && typeof x == 'number' && scrollOptions == null) {
        this[_scroll_1](dart.as(x, core.num), dart.as(y, core.num));
        return;
      }
      if (scrollOptions != null && typeof y == 'number' && typeof x == 'number') {
        let scrollOptions_1 = html_common.convertDartToNative_Dictionary(scrollOptions);
        this[_scroll_2](dart.as(x, core.num), dart.as(y, core.num), scrollOptions_1);
        return;
      }
      if (typeof y == 'number' && typeof x == 'number' && scrollOptions == null) {
        this[_scroll_3](dart.as(x, core.int), dart.as(y, core.int));
        return;
      }
      if (scrollOptions != null && typeof y == 'number' && typeof x == 'number') {
        let scrollOptions_1 = html_common.convertDartToNative_Dictionary(scrollOptions);
        this[_scroll_4](dart.as(x, core.int), dart.as(y, core.int), scrollOptions_1);
        return;
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    scrollBy(x, y, scrollOptions) {
      if (scrollOptions === void 0)
        scrollOptions = null;
      if (typeof y == 'number' && typeof x == 'number' && scrollOptions == null) {
        this[_scrollBy_1](dart.as(x, core.num), dart.as(y, core.num));
        return;
      }
      if (scrollOptions != null && typeof y == 'number' && typeof x == 'number') {
        let scrollOptions_1 = html_common.convertDartToNative_Dictionary(scrollOptions);
        this[_scrollBy_2](dart.as(x, core.num), dart.as(y, core.num), scrollOptions_1);
        return;
      }
      if (typeof y == 'number' && typeof x == 'number' && scrollOptions == null) {
        this[_scrollBy_3](dart.as(x, core.int), dart.as(y, core.int));
        return;
      }
      if (scrollOptions != null && typeof y == 'number' && typeof x == 'number') {
        let scrollOptions_1 = html_common.convertDartToNative_Dictionary(scrollOptions);
        this[_scrollBy_4](dart.as(x, core.int), dart.as(y, core.int), scrollOptions_1);
        return;
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    scrollTo(x, y, scrollOptions) {
      if (scrollOptions === void 0)
        scrollOptions = null;
      if (typeof y == 'number' && typeof x == 'number' && scrollOptions == null) {
        this[_scrollTo_1](dart.as(x, core.num), dart.as(y, core.num));
        return;
      }
      if (scrollOptions != null && typeof y == 'number' && typeof x == 'number') {
        let scrollOptions_1 = html_common.convertDartToNative_Dictionary(scrollOptions);
        this[_scrollTo_2](dart.as(x, core.num), dart.as(y, core.num), scrollOptions_1);
        return;
      }
      if (typeof y == 'number' && typeof x == 'number' && scrollOptions == null) {
        this[_scrollTo_3](dart.as(x, core.int), dart.as(y, core.int));
        return;
      }
      if (scrollOptions != null && typeof y == 'number' && typeof x == 'number') {
        let scrollOptions_1 = html_common.convertDartToNative_Dictionary(scrollOptions);
        this[_scrollTo_4](dart.as(x, core.int), dart.as(y, core.int), scrollOptions_1);
        return;
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    [_requestFileSystem](type, size) {
      let completer = async.Completer$(FileSystem).new();
      this[__requestFileSystem](type, size, dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(FileSystem));
    }
    resolveLocalFileSystemUrl(url) {
      let completer = async.Completer$(Entry).new();
      this[_resolveLocalFileSystemUrl](url, dart.fn(value => {
        dart.dsend(completer, 'complete', value);
      }), dart.fn(error => {
        dart.dsend(completer, 'completeError', error);
      }));
      return dart.as(dart.dload(completer, 'future'), async.Future$(Entry));
    }
    get onContentLoaded() {
      return Window.contentLoadedEvent.forTarget(this);
    }
    get onAbort() {
      return Element.abortEvent.forTarget(this);
    }
    get onBlur() {
      return Element.blurEvent.forTarget(this);
    }
    get onCanPlay() {
      return Element.canPlayEvent.forTarget(this);
    }
    get onCanPlayThrough() {
      return Element.canPlayThroughEvent.forTarget(this);
    }
    get onChange() {
      return Element.changeEvent.forTarget(this);
    }
    get onClick() {
      return Element.clickEvent.forTarget(this);
    }
    get onContextMenu() {
      return Element.contextMenuEvent.forTarget(this);
    }
    get onDoubleClick() {
      return Element.doubleClickEvent.forTarget(this);
    }
    get onDeviceMotion() {
      return Window.deviceMotionEvent.forTarget(this);
    }
    get onDeviceOrientation() {
      return Window.deviceOrientationEvent.forTarget(this);
    }
    get onDrag() {
      return Element.dragEvent.forTarget(this);
    }
    get onDragEnd() {
      return Element.dragEndEvent.forTarget(this);
    }
    get onDragEnter() {
      return Element.dragEnterEvent.forTarget(this);
    }
    get onDragLeave() {
      return Element.dragLeaveEvent.forTarget(this);
    }
    get onDragOver() {
      return Element.dragOverEvent.forTarget(this);
    }
    get onDragStart() {
      return Element.dragStartEvent.forTarget(this);
    }
    get onDrop() {
      return Element.dropEvent.forTarget(this);
    }
    get onDurationChange() {
      return Element.durationChangeEvent.forTarget(this);
    }
    get onEmptied() {
      return Element.emptiedEvent.forTarget(this);
    }
    get onEnded() {
      return Element.endedEvent.forTarget(this);
    }
    get onError() {
      return Element.errorEvent.forTarget(this);
    }
    get onFocus() {
      return Element.focusEvent.forTarget(this);
    }
    get onHashChange() {
      return Window.hashChangeEvent.forTarget(this);
    }
    get onInput() {
      return Element.inputEvent.forTarget(this);
    }
    get onInvalid() {
      return Element.invalidEvent.forTarget(this);
    }
    get onKeyDown() {
      return Element.keyDownEvent.forTarget(this);
    }
    get onKeyPress() {
      return Element.keyPressEvent.forTarget(this);
    }
    get onKeyUp() {
      return Element.keyUpEvent.forTarget(this);
    }
    get onLoad() {
      return Element.loadEvent.forTarget(this);
    }
    get onLoadedData() {
      return Element.loadedDataEvent.forTarget(this);
    }
    get onLoadedMetadata() {
      return Element.loadedMetadataEvent.forTarget(this);
    }
    get onLoadStart() {
      return Window.loadStartEvent.forTarget(this);
    }
    get onMessage() {
      return Window.messageEvent.forTarget(this);
    }
    get onMouseDown() {
      return Element.mouseDownEvent.forTarget(this);
    }
    get onMouseEnter() {
      return Element.mouseEnterEvent.forTarget(this);
    }
    get onMouseLeave() {
      return Element.mouseLeaveEvent.forTarget(this);
    }
    get onMouseMove() {
      return Element.mouseMoveEvent.forTarget(this);
    }
    get onMouseOut() {
      return Element.mouseOutEvent.forTarget(this);
    }
    get onMouseOver() {
      return Element.mouseOverEvent.forTarget(this);
    }
    get onMouseUp() {
      return Element.mouseUpEvent.forTarget(this);
    }
    get onMouseWheel() {
      return Element.mouseWheelEvent.forTarget(this);
    }
    get onOffline() {
      return Window.offlineEvent.forTarget(this);
    }
    get onOnline() {
      return Window.onlineEvent.forTarget(this);
    }
    get onPageHide() {
      return Window.pageHideEvent.forTarget(this);
    }
    get onPageShow() {
      return Window.pageShowEvent.forTarget(this);
    }
    get onPause() {
      return Element.pauseEvent.forTarget(this);
    }
    get onPlay() {
      return Element.playEvent.forTarget(this);
    }
    get onPlaying() {
      return Element.playingEvent.forTarget(this);
    }
    get onPopState() {
      return Window.popStateEvent.forTarget(this);
    }
    get onProgress() {
      return Window.progressEvent.forTarget(this);
    }
    get onRateChange() {
      return Element.rateChangeEvent.forTarget(this);
    }
    get onReset() {
      return Element.resetEvent.forTarget(this);
    }
    get onResize() {
      return Element.resizeEvent.forTarget(this);
    }
    get onScroll() {
      return Element.scrollEvent.forTarget(this);
    }
    get onSearch() {
      return Element.searchEvent.forTarget(this);
    }
    get onSeeked() {
      return Element.seekedEvent.forTarget(this);
    }
    get onSeeking() {
      return Element.seekingEvent.forTarget(this);
    }
    get onSelect() {
      return Element.selectEvent.forTarget(this);
    }
    get onStalled() {
      return Element.stalledEvent.forTarget(this);
    }
    get onStorage() {
      return Window.storageEvent.forTarget(this);
    }
    get onSubmit() {
      return Element.submitEvent.forTarget(this);
    }
    get onSuspend() {
      return Element.suspendEvent.forTarget(this);
    }
    get onTimeUpdate() {
      return Element.timeUpdateEvent.forTarget(this);
    }
    get onTouchCancel() {
      return Element.touchCancelEvent.forTarget(this);
    }
    get onTouchEnd() {
      return Element.touchEndEvent.forTarget(this);
    }
    get onTouchMove() {
      return Element.touchMoveEvent.forTarget(this);
    }
    get onTouchStart() {
      return Element.touchStartEvent.forTarget(this);
    }
    get onTransitionEnd() {
      return Element.transitionEndEvent.forTarget(this);
    }
    get onUnload() {
      return Window.unloadEvent.forTarget(this);
    }
    get onVolumeChange() {
      return Element.volumeChangeEvent.forTarget(this);
    }
    get onWaiting() {
      return Element.waitingEvent.forTarget(this);
    }
    get onAnimationEnd() {
      return Window.animationEndEvent.forTarget(this);
    }
    get onAnimationIteration() {
      return Window.animationIterationEvent.forTarget(this);
    }
    get onAnimationStart() {
      return Window.animationStartEvent.forTarget(this);
    }
    get onBeforeUnload() {
      return Window.beforeUnloadEvent.forTarget(this);
    }
    moveTo(p) {
      this[_moveTo](dart.as(p.x, core.num), dart.as(p.y, core.num));
    }
    get pageXOffset() {
      return dart.as(dart.dsend(this.pageXOffset, 'round'), core.int);
    }
    get pageYOffset() {
      return dart.as(dart.dsend(this.pageYOffset, 'round'), core.int);
    }
    get scrollX() {
      return dart.notNull(dart.as("scrollX" in this, core.bool)) ? dart.as(dart.dsend(this.scrollX, 'round'), core.int) : this.document.documentElement.scrollLeft;
    }
    get scrollY() {
      return dart.notNull(dart.as("scrollY" in this, core.bool)) ? dart.as(dart.dsend(this.scrollY, 'round'), core.int) : this.document.documentElement.scrollTop;
    }
  }
  Window[dart.implements] = () => [WindowEventHandlers, WindowBase, GlobalEventHandlers, _WindowTimers, WindowBase64];
  dart.setSignature(Window, {
    constructors: () => ({_: [Window, []]}),
    methods: () => ({
      [_open2]: [WindowBase, [dart.dynamic, dart.dynamic]],
      [_open3]: [WindowBase, [dart.dynamic, dart.dynamic, dart.dynamic]],
      open: [WindowBase, [core.String, core.String], [core.String]],
      requestAnimationFrame: [core.int, [RequestAnimationFrameCallback]],
      cancelAnimationFrame: [dart.void, [core.int]],
      [_requestAnimationFrame]: [core.int, [RequestAnimationFrameCallback]],
      [_cancelAnimationFrame]: [dart.void, [core.int]],
      [_ensureRequestAnimationFrame]: [dart.dynamic, []],
      requestFileSystem: [async.Future$(FileSystem), [core.int], {persistent: core.bool}],
      [__getter__]: [WindowBase, [dart.dynamic]],
      [__getter___1]: [dart.dynamic, [core.int]],
      [__getter___2]: [dart.dynamic, [core.String]],
      alert: [dart.void, [], [core.String]],
      close: [dart.void, []],
      confirm: [core.bool, [], [core.String]],
      find: [core.bool, [core.String, core.bool, core.bool, core.bool, core.bool, core.bool, core.bool]],
      [_getComputedStyle]: [CssStyleDeclaration, [Element, core.String]],
      getMatchedCssRules: [core.List$(CssRule), [Element, core.String]],
      getSelection: [Selection, []],
      matchMedia: [MediaQueryList, [core.String]],
      moveBy: [dart.void, [core.num, core.num]],
      [_moveTo]: [dart.void, [core.num, core.num]],
      openDatabase: [web_sql.SqlDatabase, [core.String, core.String, core.String, core.int], [DatabaseCallback]],
      postMessage: [dart.void, [dart.dynamic, core.String], [core.List$(MessagePort)]],
      [_postMessage_1]: [dart.void, [dart.dynamic, dart.dynamic, core.List$(MessagePort)]],
      [_postMessage_2]: [dart.void, [dart.dynamic, dart.dynamic]],
      print: [dart.void, []],
      resizeBy: [dart.void, [core.num, core.num]],
      resizeTo: [dart.void, [core.num, core.num]],
      scroll: [dart.void, [dart.dynamic, dart.dynamic], [core.Map]],
      [_scroll_1]: [dart.void, [core.num, core.num]],
      [_scroll_2]: [dart.void, [core.num, core.num, dart.dynamic]],
      [_scroll_3]: [dart.void, [core.int, core.int]],
      [_scroll_4]: [dart.void, [core.int, core.int, dart.dynamic]],
      scrollBy: [dart.void, [dart.dynamic, dart.dynamic], [core.Map]],
      [_scrollBy_1]: [dart.void, [core.num, core.num]],
      [_scrollBy_2]: [dart.void, [core.num, core.num, dart.dynamic]],
      [_scrollBy_3]: [dart.void, [core.int, core.int]],
      [_scrollBy_4]: [dart.void, [core.int, core.int, dart.dynamic]],
      scrollTo: [dart.void, [dart.dynamic, dart.dynamic], [core.Map]],
      [_scrollTo_1]: [dart.void, [core.num, core.num]],
      [_scrollTo_2]: [dart.void, [core.num, core.num, dart.dynamic]],
      [_scrollTo_3]: [dart.void, [core.int, core.int]],
      [_scrollTo_4]: [dart.void, [core.int, core.int, dart.dynamic]],
      showModalDialog: [core.Object, [core.String], [core.Object, core.String]],
      stop: [dart.void, []],
      [__requestFileSystem]: [dart.void, [core.int, core.int, _FileSystemCallback], [_ErrorCallback]],
      [_requestFileSystem]: [async.Future$(FileSystem), [core.int, core.int]],
      [_resolveLocalFileSystemUrl]: [dart.void, [core.String, _EntryCallback], [_ErrorCallback]],
      resolveLocalFileSystemUrl: [async.Future$(Entry), [core.String]],
      atob: [core.String, [core.String]],
      btoa: [core.String, [core.String]],
      [_clearInterval]: [dart.void, [core.int]],
      [_clearTimeout]: [dart.void, [core.int]],
      [_setInterval]: [core.int, [core.Object, core.int]],
      [_setTimeout]: [core.int, [core.Object, core.int]],
      moveTo: [dart.void, [math.Point]]
    })
  });
  Window[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Window')), dart.const(new _js_helper.Native("Window,DOMWindow"))];
  Window.contentLoadedEvent = dart.const(new (EventStreamProvider$(Event))('DOMContentLoaded'));
  Window.deviceMotionEvent = dart.const(new (EventStreamProvider$(DeviceMotionEvent))('devicemotion'));
  Window.deviceOrientationEvent = dart.const(new (EventStreamProvider$(DeviceOrientationEvent))('deviceorientation'));
  Window.hashChangeEvent = dart.const(new (EventStreamProvider$(Event))('hashchange'));
  Window.loadStartEvent = dart.const(new (EventStreamProvider$(Event))('loadstart'));
  Window.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  Window.offlineEvent = dart.const(new (EventStreamProvider$(Event))('offline'));
  Window.onlineEvent = dart.const(new (EventStreamProvider$(Event))('online'));
  Window.pageHideEvent = dart.const(new (EventStreamProvider$(Event))('pagehide'));
  Window.pageShowEvent = dart.const(new (EventStreamProvider$(Event))('pageshow'));
  Window.popStateEvent = dart.const(new (EventStreamProvider$(PopStateEvent))('popstate'));
  Window.progressEvent = dart.const(new (EventStreamProvider$(Event))('progress'));
  Window.storageEvent = dart.const(new (EventStreamProvider$(StorageEvent))('storage'));
  Window.unloadEvent = dart.const(new (EventStreamProvider$(Event))('unload'));
  Window.animationEndEvent = dart.const(new (EventStreamProvider$(AnimationEvent))('webkitAnimationEnd'));
  Window.animationIterationEvent = dart.const(new (EventStreamProvider$(AnimationEvent))('webkitAnimationIteration'));
  Window.animationStartEvent = dart.const(new (EventStreamProvider$(AnimationEvent))('webkitAnimationStart'));
  Window.PERSISTENT = 1;
  Window.TEMPORARY = 0;
  class _BeforeUnloadEventStreamProvider extends core.Object {
    _BeforeUnloadEventStreamProvider(eventType) {
      this[_eventType] = eventType;
    }
    forTarget(e, opts) {
      let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
      let stream = new _EventStream(e, this[_eventType], useCapture);
      let controller = async.StreamController.new({sync: true});
      dart.dsend(stream, 'listen', dart.fn(event => {
        let wrapped = new _BeforeUnloadEvent(dart.as(event, Event));
        dart.dsend(controller, 'add', wrapped);
        return dart.dload(wrapped, 'returnValue');
      }));
      return dart.as(dart.dload(controller, 'stream'), async.Stream$(BeforeUnloadEvent));
    }
    getEventType(target) {
      return this[_eventType];
    }
    forElement(e, opts) {
      let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
      return new (_ElementEventStreamImpl$(BeforeUnloadEvent))(e, this[_eventType], useCapture);
    }
    [_forElementList](e, opts) {
      let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
      return new _ElementListEventStreamImpl(dart.as(e, core.Iterable$(Element)), this[_eventType], useCapture);
    }
  }
  _BeforeUnloadEventStreamProvider[dart.implements] = () => [EventStreamProvider$(BeforeUnloadEvent)];
  dart.setSignature(_BeforeUnloadEventStreamProvider, {
    constructors: () => ({_BeforeUnloadEventStreamProvider: [_BeforeUnloadEventStreamProvider, [core.String]]}),
    methods: () => ({
      forTarget: [async.Stream$(BeforeUnloadEvent), [EventTarget], {useCapture: core.bool}],
      getEventType: [core.String, [EventTarget]],
      forElement: [ElementStream$(BeforeUnloadEvent), [Element], {useCapture: core.bool}],
      [_forElementList]: [ElementStream$(BeforeUnloadEvent), [ElementList], {useCapture: core.bool}]
    })
  });
  Window.beforeUnloadEvent = dart.const(new _BeforeUnloadEventStreamProvider('beforeunload'));
  class _WrappedEvent extends core.Object {
    _WrappedEvent(wrapped) {
      this.wrapped = wrapped;
      this[_selector] = null;
    }
    get bubbles() {
      return this.wrapped.bubbles;
    }
    get cancelable() {
      return this.wrapped.cancelable;
    }
    get clipboardData() {
      return this.wrapped.clipboardData;
    }
    get currentTarget() {
      return this.wrapped.currentTarget;
    }
    get defaultPrevented() {
      return this.wrapped.defaultPrevented;
    }
    get eventPhase() {
      return this.wrapped.eventPhase;
    }
    get target() {
      return this.wrapped.target;
    }
    get timeStamp() {
      return this.wrapped.timeStamp;
    }
    get type() {
      return this.wrapped.type;
    }
    [_initEvent](eventTypeArg, canBubbleArg, cancelableArg) {
      dart.throw(new core.UnsupportedError('Cannot initialize this Event.'));
    }
    preventDefault() {
      this.wrapped.preventDefault();
    }
    stopImmediatePropagation() {
      this.wrapped.stopImmediatePropagation();
    }
    stopPropagation() {
      this.wrapped.stopPropagation();
    }
    get matchingTarget() {
      if (this[_selector] == null) {
        dart.throw(new core.UnsupportedError('Cannot call matchingTarget if this Event did' + ' not arise as a result of event delegation.'));
      }
      let currentTarget = this.currentTarget;
      let target = this.target;
      let matchedTarget = null;
      do {
        if (dart.notNull(dart.as(dart.dsend(target, 'matches', this[_selector]), core.bool)))
          return dart.as(target, Element);
        target = dart.dload(target, 'parent');
      } while (target != null && !dart.equals(target, dart.dload(currentTarget, 'parent')));
      dart.throw(new core.StateError('No selector matched for populating matchedTarget.'));
    }
    get path() {
      return this.wrapped.path;
    }
    get [_get_currentTarget]() {
      return this.wrapped[_get_currentTarget];
    }
    get [_get_target]() {
      return this.wrapped[_get_target];
    }
  }
  _WrappedEvent[dart.implements] = () => [Event];
  dart.setSignature(_WrappedEvent, {
    constructors: () => ({_WrappedEvent: [_WrappedEvent, [Event]]}),
    methods: () => ({
      [_initEvent]: [dart.void, [core.String, core.bool, core.bool]],
      preventDefault: [dart.void, []],
      stopImmediatePropagation: [dart.void, []],
      stopPropagation: [dart.void, []]
    })
  });
  let _returnValue = Symbol('_returnValue');
  class _BeforeUnloadEvent extends _WrappedEvent {
    _BeforeUnloadEvent(base) {
      this[_returnValue] = null;
      super._WrappedEvent(base);
    }
    get returnValue() {
      return this[_returnValue];
    }
    set returnValue(value) {
      this[_returnValue] = value;
      if (dart.notNull(dart.as("returnValue" in this.wrapped, core.bool))) {
        this.wrapped.returnValue = value;
      }
    }
  }
  _BeforeUnloadEvent[dart.implements] = () => [BeforeUnloadEvent];
  dart.setSignature(_BeforeUnloadEvent, {
    constructors: () => ({_BeforeUnloadEvent: [_BeforeUnloadEvent, [Event]]})
  });
  class WindowBase64 extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(WindowBase64, {
    constructors: () => ({_: [WindowBase64, []]})
  });
  WindowBase64[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WindowBase64')), dart.const(new _metadata.Experimental())];
  class WindowEventHandlers extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get onHashChange() {
      return WindowEventHandlers.hashChangeEvent.forTarget(this);
    }
    get onMessage() {
      return WindowEventHandlers.messageEvent.forTarget(this);
    }
    get onOffline() {
      return WindowEventHandlers.offlineEvent.forTarget(this);
    }
    get onOnline() {
      return WindowEventHandlers.onlineEvent.forTarget(this);
    }
    get onPopState() {
      return WindowEventHandlers.popStateEvent.forTarget(this);
    }
    get onStorage() {
      return WindowEventHandlers.storageEvent.forTarget(this);
    }
    get onUnload() {
      return WindowEventHandlers.unloadEvent.forTarget(this);
    }
  }
  dart.setSignature(WindowEventHandlers, {
    constructors: () => ({_: [WindowEventHandlers, []]})
  });
  WindowEventHandlers[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WindowEventHandlers')), dart.const(new _metadata.Experimental())];
  WindowEventHandlers.hashChangeEvent = dart.const(new (EventStreamProvider$(Event))('hashchange'));
  WindowEventHandlers.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  WindowEventHandlers.offlineEvent = dart.const(new (EventStreamProvider$(Event))('offline'));
  WindowEventHandlers.onlineEvent = dart.const(new (EventStreamProvider$(Event))('online'));
  WindowEventHandlers.popStateEvent = dart.const(new (EventStreamProvider$(PopStateEvent))('popstate'));
  WindowEventHandlers.storageEvent = dart.const(new (EventStreamProvider$(StorageEvent))('storage'));
  WindowEventHandlers.unloadEvent = dart.const(new (EventStreamProvider$(Event))('unload'));
  class Worker extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(scriptUrl) {
      return Worker._create_1(scriptUrl);
    }
    static _create_1(scriptUrl) {
      return dart.as(new Worker(scriptUrl), Worker);
    }
    static get supported() {
      return dart.as(typeof window.Worker != "undefined", core.bool);
    }
    get onError() {
      return Worker.errorEvent.forTarget(this);
    }
    get onMessage() {
      return Worker.messageEvent.forTarget(this);
    }
  }
  Worker[dart.implements] = () => [AbstractWorker];
  dart.setSignature(Worker, {
    constructors: () => ({
      _: [Worker, []],
      new: [Worker, [core.String]]
    }),
    methods: () => ({
      postMessage: [dart.void, [dart.dynamic], [core.List$(MessagePort)]],
      terminate: [dart.void, []]
    }),
    statics: () => ({_create_1: [Worker, [dart.dynamic]]}),
    names: ['_create_1']
  });
  Worker[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Worker')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.IE, '10')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Worker"))];
  Worker.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  Worker.messageEvent = dart.const(new (EventStreamProvider$(MessageEvent))('message'));
  class WorkerConsole extends ConsoleBase {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(WorkerConsole, {
    constructors: () => ({_: [WorkerConsole, []]})
  });
  WorkerConsole[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WorkerConsole')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WorkerConsole"))];
  WorkerGlobalScope.errorEvent = dart.const(new (EventStreamProvider$(Event))('error'));
  WorkerGlobalScope.PERSISTENT = 1;
  WorkerGlobalScope.TEMPORARY = 0;
  class WorkerPerformance extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(WorkerPerformance, {
    constructors: () => ({_: [WorkerPerformance, []]}),
    methods: () => ({now: [core.double, []]})
  });
  WorkerPerformance[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WorkerPerformance')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WorkerPerformance"))];
  class XPathEvaluator extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return XPathEvaluator._create_1();
    }
    static _create_1() {
      return dart.as(new XPathEvaluator(), XPathEvaluator);
    }
  }
  dart.setSignature(XPathEvaluator, {
    constructors: () => ({
      _: [XPathEvaluator, []],
      new: [XPathEvaluator, []]
    }),
    methods: () => ({
      createExpression: [XPathExpression, [core.String, XPathNSResolver]],
      createNSResolver: [XPathNSResolver, [Node]],
      evaluate: [XPathResult, [core.String, Node, XPathNSResolver, core.int, XPathResult]]
    }),
    statics: () => ({_create_1: [XPathEvaluator, []]}),
    names: ['_create_1']
  });
  XPathEvaluator[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XPathEvaluator')), core.deprecated, dart.const(new _js_helper.Native("XPathEvaluator"))];
  class XPathExpression extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(XPathExpression, {
    constructors: () => ({_: [XPathExpression, []]}),
    methods: () => ({evaluate: [XPathResult, [Node, core.int, XPathResult]]})
  });
  XPathExpression[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XPathExpression')), core.deprecated, dart.const(new _js_helper.Native("XPathExpression"))];
  class XPathNSResolver extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(XPathNSResolver, {
    constructors: () => ({_: [XPathNSResolver, []]}),
    methods: () => ({lookupNamespaceUri: [core.String, [core.String]]})
  });
  XPathNSResolver[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XPathNSResolver')), core.deprecated, dart.const(new _js_helper.Native("XPathNSResolver"))];
  class XPathResult extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(XPathResult, {
    constructors: () => ({_: [XPathResult, []]}),
    methods: () => ({
      iterateNext: [Node, []],
      snapshotItem: [Node, [core.int]]
    })
  });
  XPathResult[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XPathResult')), core.deprecated, dart.const(new _js_helper.Native("XPathResult"))];
  XPathResult.ANY_TYPE = 0;
  XPathResult.ANY_UNORDERED_NODE_TYPE = 8;
  XPathResult.BOOLEAN_TYPE = 3;
  XPathResult.FIRST_ORDERED_NODE_TYPE = 9;
  XPathResult.NUMBER_TYPE = 1;
  XPathResult.ORDERED_NODE_ITERATOR_TYPE = 5;
  XPathResult.ORDERED_NODE_SNAPSHOT_TYPE = 7;
  XPathResult.STRING_TYPE = 2;
  XPathResult.UNORDERED_NODE_ITERATOR_TYPE = 4;
  XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE = 6;
  class XmlDocument extends Document {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(XmlDocument, {
    constructors: () => ({_: [XmlDocument, []]})
  });
  XmlDocument[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XMLDocument')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("XMLDocument"))];
  class XmlSerializer extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return XmlSerializer._create_1();
    }
    static _create_1() {
      return dart.as(new XMLSerializer(), XmlSerializer);
    }
  }
  dart.setSignature(XmlSerializer, {
    constructors: () => ({
      _: [XmlSerializer, []],
      new: [XmlSerializer, []]
    }),
    methods: () => ({serializeToString: [core.String, [Node]]}),
    statics: () => ({_create_1: [XmlSerializer, []]}),
    names: ['_create_1']
  });
  XmlSerializer[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XMLSerializer')), core.deprecated, dart.const(new _js_helper.Native("XMLSerializer"))];
  class XsltProcessor extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return XsltProcessor._create_1();
    }
    static _create_1() {
      return dart.as(new XSLTProcessor(), XsltProcessor);
    }
    static get supported() {
      return dart.as(!!window.XSLTProcessor, core.bool);
    }
  }
  dart.setSignature(XsltProcessor, {
    constructors: () => ({
      _: [XsltProcessor, []],
      new: [XsltProcessor, []]
    }),
    methods: () => ({
      clearParameters: [dart.void, []],
      getParameter: [core.String, [core.String, core.String]],
      importStylesheet: [dart.void, [Node]],
      removeParameter: [dart.void, [core.String, core.String]],
      reset: [dart.void, []],
      setParameter: [dart.void, [core.String, core.String, core.String]],
      transformToDocument: [Document, [Node]],
      transformToFragment: [DocumentFragment, [Node, Document]]
    }),
    statics: () => ({_create_1: [XsltProcessor, []]}),
    names: ['_create_1']
  });
  XsltProcessor[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XSLTProcessor')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.FIREFOX)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), core.deprecated, dart.const(new _js_helper.Native("XSLTProcessor"))];
  class _Attr extends Node {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get text() {
      return dart.as(this.textContent, core.String);
    }
    set text(value) {
      this.textContent = value;
    }
  }
  dart.setSignature(_Attr, {
    constructors: () => ({_: [_Attr, []]})
  });
  _Attr[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Attr')), dart.const(new _js_helper.Native("Attr"))];
  class _CSSValue extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_CSSValue, {
    constructors: () => ({_: [_CSSValue, []]})
  });
  _CSSValue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSValue')), core.deprecated, dart.const(new _js_helper.Native("CSSValue"))];
  class _CSSPrimitiveValue extends _CSSValue {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_CSSPrimitiveValue, {
    constructors: () => ({_: [_CSSPrimitiveValue, []]})
  });
  _CSSPrimitiveValue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSPrimitiveValue')), core.deprecated, dart.const(new _js_helper.Native("CSSPrimitiveValue"))];
  class _CSSUnknownRule extends CssRule {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_CSSUnknownRule, {
    constructors: () => ({_: [_CSSUnknownRule, []]})
  });
  _CSSUnknownRule[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSUnknownRule')), core.deprecated, dart.const(new _js_helper.Native("CSSUnknownRule"))];
  class _Cache extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_Cache, {
    constructors: () => ({_: [_Cache, []]})
  });
  _Cache[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Cache')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Cache"))];
  class _CanvasPathMethods extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_CanvasPathMethods, {
    constructors: () => ({_: [_CanvasPathMethods, []]})
  });
  _CanvasPathMethods[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CanvasPathMethods')), dart.const(new _metadata.Experimental())];
  class _ClientRect extends _interceptors.Interceptor {
    toString() {
      return `Rectangle (${this.left}, ${this.top}) ${this.width} x ${this.height}`;
    }
    ['=='](other) {
      if (!dart.is(other, math.Rectangle))
        return false;
      return dart.equals(this.left, dart.dload(other, 'left')) && dart.equals(this.top, dart.dload(other, 'top')) && dart.equals(this.width, dart.dload(other, 'width')) && dart.equals(this.height, dart.dload(other, 'height'));
    }
    get hashCode() {
      return _JenkinsSmiHash.hash4(dart.hashCode(this.left), dart.hashCode(this.top), dart.hashCode(this.width), dart.hashCode(this.height));
    }
    intersection(other) {
      let x0 = math.max(this.left, dart.as(other.left, core.num));
      let x1 = math.min(dart.notNull(this.left) + dart.notNull(this.width), dart.as(dart.dsend(other.left, '+', other.width), core.num));
      if (dart.notNull(dart.as(dart.dsend(x0, '<=', x1), core.bool))) {
        let y0 = math.max(this.top, dart.as(other.top, core.num));
        let y1 = math.min(dart.notNull(this.top) + dart.notNull(this.height), dart.as(dart.dsend(other.top, '+', other.height), core.num));
        if (dart.notNull(dart.as(dart.dsend(y0, '<=', y1), core.bool))) {
          return new math.Rectangle(x0, y0, dart.dsend(x1, '-', x0), dart.dsend(y1, '-', y0));
        }
      }
      return null;
    }
    intersects(other) {
      return dart.notNull(this.left) <= dart.notNull(other.left) + dart.notNull(other.width) && dart.notNull(other.left) <= dart.notNull(this.left) + dart.notNull(this.width) && dart.notNull(this.top) <= dart.notNull(other.top) + dart.notNull(other.height) && dart.notNull(other.top) <= dart.notNull(this.top) + dart.notNull(this.height);
    }
    boundingBox(other) {
      let right = math.max(dart.notNull(this.left) + dart.notNull(this.width), dart.as(dart.dsend(other.left, '+', other.width), core.num));
      let bottom = math.max(dart.notNull(this.top) + dart.notNull(this.height), dart.as(dart.dsend(other.top, '+', other.height), core.num));
      let left = math.min(this.left, dart.as(other.left, core.num));
      let top = math.min(this.top, dart.as(other.top, core.num));
      return new math.Rectangle(left, top, dart.dsend(right, '-', left), dart.dsend(bottom, '-', top));
    }
    containsRectangle(another) {
      return dart.notNull(this.left) <= dart.notNull(another.left) && dart.notNull(this.left) + dart.notNull(this.width) >= dart.notNull(another.left) + dart.notNull(another.width) && dart.notNull(this.top) <= dart.notNull(another.top) && dart.notNull(this.top) + dart.notNull(this.height) >= dart.notNull(another.top) + dart.notNull(another.height);
    }
    containsPoint(another) {
      return dart.notNull(another.x) >= dart.notNull(this.left) && dart.notNull(another.x) <= dart.notNull(this.left) + dart.notNull(this.width) && dart.notNull(another.y) >= dart.notNull(this.top) && dart.notNull(another.y) <= dart.notNull(this.top) + dart.notNull(this.height);
    }
    get topLeft() {
      return new math.Point(this.left, this.top);
    }
    get topRight() {
      return new math.Point(dart.notNull(this.left) + dart.notNull(this.width), this.top);
    }
    get bottomRight() {
      return new math.Point(dart.notNull(this.left) + dart.notNull(this.width), dart.notNull(this.top) + dart.notNull(this.height));
    }
    get bottomLeft() {
      return new math.Point(this.left, dart.notNull(this.top) + dart.notNull(this.height));
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  _ClientRect[dart.implements] = () => [math.Rectangle];
  dart.setSignature(_ClientRect, {
    constructors: () => ({_: [_ClientRect, []]}),
    methods: () => ({
      intersection: [math.Rectangle, [math.Rectangle]],
      intersects: [core.bool, [math.Rectangle$(core.num)]],
      boundingBox: [math.Rectangle, [math.Rectangle]],
      containsRectangle: [core.bool, [math.Rectangle$(core.num)]],
      containsPoint: [core.bool, [math.Point$(core.num)]]
    })
  });
  dart.defineExtensionMembers(_ClientRect, ['toString', '==', 'hashCode']);
  _ClientRect[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ClientRect')), dart.const(new _js_helper.Native("ClientRect"))];
  class _JenkinsSmiHash extends core.Object {
    static combine(hash, value) {
      hash = 536870911 & dart.notNull(hash) + dart.notNull(value);
      hash = 536870911 & dart.notNull(hash) + ((524287 & dart.notNull(hash)) << 10);
      return dart.notNull(hash) ^ dart.notNull(hash) >> 6;
    }
    static finish(hash) {
      hash = 536870911 & dart.notNull(hash) + ((67108863 & dart.notNull(hash)) << 3);
      hash = dart.notNull(hash) ^ dart.notNull(hash) >> 11;
      return 536870911 & dart.notNull(hash) + ((16383 & dart.notNull(hash)) << 15);
    }
    static hash2(a, b) {
      return _JenkinsSmiHash.finish(_JenkinsSmiHash.combine(_JenkinsSmiHash.combine(0, dart.as(a, core.int)), dart.as(b, core.int)));
    }
    static hash4(a, b, c, d) {
      return _JenkinsSmiHash.finish(_JenkinsSmiHash.combine(_JenkinsSmiHash.combine(_JenkinsSmiHash.combine(_JenkinsSmiHash.combine(0, dart.as(a, core.int)), dart.as(b, core.int)), dart.as(c, core.int)), dart.as(d, core.int)));
    }
  }
  dart.setSignature(_JenkinsSmiHash, {
    statics: () => ({
      combine: [core.int, [core.int, core.int]],
      finish: [core.int, [core.int]],
      hash2: [core.int, [dart.dynamic, dart.dynamic]],
      hash4: [core.int, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]]
    }),
    names: ['combine', 'finish', 'hash2', 'hash4']
  });
  class _ClientRectList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(math.Rectangle), ImmutableListMixin$(math.Rectangle)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], math.Rectangle);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], math.Rectangle);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], math.Rectangle);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], math.Rectangle);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _ClientRectList[dart.implements] = () => [core.List$(math.Rectangle), _js_helper.JavaScriptIndexingBehavior];
  dart.setSignature(_ClientRectList, {
    constructors: () => ({_: [_ClientRectList, []]}),
    methods: () => ({
      get: [math.Rectangle, [core.int]],
      set: [dart.void, [core.int, math.Rectangle]],
      elementAt: [math.Rectangle, [core.int]],
      item: [math.Rectangle, [core.int]]
    })
  });
  dart.defineExtensionMembers(_ClientRectList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _ClientRectList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ClientRectList')), dart.const(new _js_helper.Native("ClientRectList,DOMRectList"))];
  class _Counter extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_Counter, {
    constructors: () => ({_: [_Counter, []]})
  });
  _Counter[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Counter')), core.deprecated, dart.const(new _js_helper.Native("Counter"))];
  class _CssRuleList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(CssRule), ImmutableListMixin$(CssRule)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], CssRule);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], CssRule);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], CssRule);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], CssRule);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _CssRuleList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(CssRule)];
  dart.setSignature(_CssRuleList, {
    constructors: () => ({_: [_CssRuleList, []]}),
    methods: () => ({
      get: [CssRule, [core.int]],
      set: [dart.void, [core.int, CssRule]],
      elementAt: [CssRule, [core.int]],
      item: [CssRule, [core.int]]
    })
  });
  dart.defineExtensionMembers(_CssRuleList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _CssRuleList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSRuleList')), dart.const(new _js_helper.Native("CSSRuleList"))];
  class _CssValueList extends dart.mixin(_CSSValue, collection.ListMixin$(_CSSValue), ImmutableListMixin$(_CSSValue)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], _CSSValue);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], _CSSValue);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], _CSSValue);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], _CSSValue);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _CssValueList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(_CSSValue)];
  dart.setSignature(_CssValueList, {
    constructors: () => ({_: [_CssValueList, []]}),
    methods: () => ({
      get: [_CSSValue, [core.int]],
      set: [dart.void, [core.int, _CSSValue]],
      elementAt: [_CSSValue, [core.int]],
      item: [_CSSValue, [core.int]]
    })
  });
  dart.defineExtensionMembers(_CssValueList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _CssValueList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('CSSValueList')), core.deprecated, dart.const(new _js_helper.Native("CSSValueList"))];
  class _DOMFileSystemSync extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_DOMFileSystemSync, {
    constructors: () => ({_: [_DOMFileSystemSync, []]})
  });
  _DOMFileSystemSync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMFileSystemSync')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMFileSystemSync"))];
  class _EntrySync extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_EntrySync, {
    constructors: () => ({_: [_EntrySync, []]})
  });
  _EntrySync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('EntrySync')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("EntrySync"))];
  class _DirectoryEntrySync extends _EntrySync {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_DirectoryEntrySync, {
    constructors: () => ({_: [_DirectoryEntrySync, []]})
  });
  _DirectoryEntrySync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DirectoryEntrySync')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DirectoryEntrySync"))];
  class _DirectoryReaderSync extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_DirectoryReaderSync, {
    constructors: () => ({_: [_DirectoryReaderSync, []]})
  });
  _DirectoryReaderSync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DirectoryReaderSync')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DirectoryReaderSync"))];
  class _DocumentType extends Node {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  _DocumentType[dart.implements] = () => [ChildNode];
  dart.setSignature(_DocumentType, {
    constructors: () => ({_: [_DocumentType, []]})
  });
  _DocumentType[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DocumentType')), core.deprecated, dart.const(new _js_helper.Native("DocumentType"))];
  class _DomRect extends DomRectReadOnly {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(x, y, width, height) {
      if (x === void 0)
        x = null;
      if (y === void 0)
        y = null;
      if (width === void 0)
        width = null;
      if (height === void 0)
        height = null;
      if (height != null) {
        return _DomRect._create_1(x, y, width, height);
      }
      if (width != null) {
        return _DomRect._create_2(x, y, width);
      }
      if (y != null) {
        return _DomRect._create_3(x, y);
      }
      if (x != null) {
        return _DomRect._create_4(x);
      }
      return _DomRect._create_5();
    }
    static _create_1(x, y, width, height) {
      return dart.as(new DOMRect(x, y, width, height), _DomRect);
    }
    static _create_2(x, y, width) {
      return dart.as(new DOMRect(x, y, width), _DomRect);
    }
    static _create_3(x, y) {
      return dart.as(new DOMRect(x, y), _DomRect);
    }
    static _create_4(x) {
      return dart.as(new DOMRect(x), _DomRect);
    }
    static _create_5() {
      return dart.as(new DOMRect(), _DomRect);
    }
    get height() {
      return dart.as(this.height, core.num);
    }
    set height(value) {
      this.height = value;
    }
    get width() {
      return dart.as(this.width, core.num);
    }
    set width(value) {
      this.width = value;
    }
    get x() {
      return dart.as(this.x, core.num);
    }
    set x(value) {
      this.x = value;
    }
    get y() {
      return dart.as(this.y, core.num);
    }
    set y(value) {
      this.y = value;
    }
  }
  dart.setSignature(_DomRect, {
    constructors: () => ({
      _: [_DomRect, []],
      new: [_DomRect, [], [core.num, core.num, core.num, core.num]]
    }),
    statics: () => ({
      _create_1: [_DomRect, [dart.dynamic, dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_2: [_DomRect, [dart.dynamic, dart.dynamic, dart.dynamic]],
      _create_3: [_DomRect, [dart.dynamic, dart.dynamic]],
      _create_4: [_DomRect, [dart.dynamic]],
      _create_5: [_DomRect, []]
    }),
    names: ['_create_1', '_create_2', '_create_3', '_create_4', '_create_5']
  });
  _DomRect[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('DOMRect')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("DOMRect"))];
  class _FileEntrySync extends _EntrySync {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_FileEntrySync, {
    constructors: () => ({_: [_FileEntrySync, []]})
  });
  _FileEntrySync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileEntrySync')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FileEntrySync"))];
  class _FileReaderSync extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new() {
      return _FileReaderSync._create_1();
    }
    static _create_1() {
      return dart.as(new FileReaderSync(), _FileReaderSync);
    }
  }
  dart.setSignature(_FileReaderSync, {
    constructors: () => ({
      _: [_FileReaderSync, []],
      new: [_FileReaderSync, []]
    }),
    statics: () => ({_create_1: [_FileReaderSync, []]}),
    names: ['_create_1']
  });
  _FileReaderSync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileReaderSync')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FileReaderSync"))];
  class _FileWriterSync extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_FileWriterSync, {
    constructors: () => ({_: [_FileWriterSync, []]})
  });
  _FileWriterSync[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('FileWriterSync')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("FileWriterSync"))];
  class _GamepadList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Gamepad), ImmutableListMixin$(Gamepad)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], Gamepad);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], Gamepad);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], Gamepad);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], Gamepad);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _GamepadList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(Gamepad)];
  dart.setSignature(_GamepadList, {
    constructors: () => ({_: [_GamepadList, []]}),
    methods: () => ({
      get: [Gamepad, [core.int]],
      set: [dart.void, [core.int, Gamepad]],
      elementAt: [Gamepad, [core.int]],
      item: [Gamepad, [core.int]]
    })
  });
  dart.defineExtensionMembers(_GamepadList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _GamepadList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('GamepadList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("GamepadList"))];
  class _HTMLAllCollection extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_HTMLAllCollection, {
    constructors: () => ({_: [_HTMLAllCollection, []]}),
    methods: () => ({[_item]: [Element, [core.int]]})
  });
  _HTMLAllCollection[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLAllCollection')), core.deprecated, dart.const(new _js_helper.Native("HTMLAllCollection"))];
  class _HTMLAppletElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(_HTMLAppletElement, 'created');
  dart.setSignature(_HTMLAppletElement, {
    constructors: () => ({
      _: [_HTMLAppletElement, []],
      created: [_HTMLAppletElement, []]
    })
  });
  _HTMLAppletElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLAppletElement')), core.deprecated, dart.const(new _js_helper.Native("HTMLAppletElement"))];
  class _HTMLDirectoryElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(_HTMLDirectoryElement, 'created');
  dart.setSignature(_HTMLDirectoryElement, {
    constructors: () => ({
      _: [_HTMLDirectoryElement, []],
      created: [_HTMLDirectoryElement, []]
    })
  });
  _HTMLDirectoryElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLDirectoryElement')), core.deprecated, dart.const(new _js_helper.Native("HTMLDirectoryElement"))];
  class _HTMLFontElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(_HTMLFontElement, 'created');
  dart.setSignature(_HTMLFontElement, {
    constructors: () => ({
      _: [_HTMLFontElement, []],
      created: [_HTMLFontElement, []]
    })
  });
  _HTMLFontElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLFontElement')), core.deprecated, dart.const(new _js_helper.Native("HTMLFontElement"))];
  class _HTMLFrameElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(_HTMLFrameElement, 'created');
  dart.setSignature(_HTMLFrameElement, {
    constructors: () => ({
      _: [_HTMLFrameElement, []],
      created: [_HTMLFrameElement, []]
    })
  });
  _HTMLFrameElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLFrameElement')), core.deprecated, dart.const(new _js_helper.Native("HTMLFrameElement"))];
  class _HTMLFrameSetElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  _HTMLFrameSetElement[dart.implements] = () => [WindowEventHandlers];
  dart.defineNamedConstructor(_HTMLFrameSetElement, 'created');
  dart.setSignature(_HTMLFrameSetElement, {
    constructors: () => ({
      _: [_HTMLFrameSetElement, []],
      created: [_HTMLFrameSetElement, []]
    })
  });
  _HTMLFrameSetElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLFrameSetElement')), core.deprecated, dart.const(new _js_helper.Native("HTMLFrameSetElement"))];
  class _HTMLMarqueeElement extends HtmlElement {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    created() {
      super.created();
    }
  }
  dart.defineNamedConstructor(_HTMLMarqueeElement, 'created');
  dart.setSignature(_HTMLMarqueeElement, {
    constructors: () => ({
      _: [_HTMLMarqueeElement, []],
      created: [_HTMLMarqueeElement, []]
    })
  });
  _HTMLMarqueeElement[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('HTMLMarqueeElement')), core.deprecated, dart.const(new _js_helper.Native("HTMLMarqueeElement"))];
  let _initMutationEvent = Symbol('_initMutationEvent');
  class _MutationEvent extends Event {
    static new(type, opts) {
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : false;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : false;
      let relatedNode = opts && 'relatedNode' in opts ? opts.relatedNode : null;
      let prevValue = opts && 'prevValue' in opts ? opts.prevValue : null;
      let newValue = opts && 'newValue' in opts ? opts.newValue : null;
      let attrName = opts && 'attrName' in opts ? opts.attrName : null;
      let attrChange = opts && 'attrChange' in opts ? opts.attrChange : 0;
      let event = exports.document[_createEvent]('MutationEvent');
      dart.dsend(event, _initMutationEvent, type, canBubble, cancelable, relatedNode, prevValue, newValue, attrName, attrChange);
      return dart.as(event, _MutationEvent);
    }
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_MutationEvent, {
    constructors: () => ({
      new: [_MutationEvent, [core.String], {canBubble: core.bool, cancelable: core.bool, relatedNode: Node, prevValue: core.String, newValue: core.String, attrName: core.String, attrChange: core.int}],
      _: [_MutationEvent, []]
    })
  });
  _MutationEvent[dart.metadata] = () => [dart.const(new _metadata.DomName('MutationEvent')), core.deprecated, dart.const(new _js_helper.Native("MutationEvent"))];
  class _NamedNodeMap extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(Node), ImmutableListMixin$(Node)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], Node);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], Node);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], Node);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], Node);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _NamedNodeMap[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(Node)];
  dart.setSignature(_NamedNodeMap, {
    constructors: () => ({_: [_NamedNodeMap, []]}),
    methods: () => ({
      get: [Node, [core.int]],
      set: [dart.void, [core.int, Node]],
      elementAt: [Node, [core.int]],
      [__getter__]: [Node, [core.String]],
      getNamedItem: [Node, [core.String]],
      getNamedItemNS: [Node, [core.String, core.String]],
      item: [Node, [core.int]],
      removeNamedItem: [Node, [core.String]],
      removeNamedItemNS: [Node, [core.String, core.String]],
      setNamedItem: [Node, [Node]],
      setNamedItemNS: [Node, [Node]]
    })
  });
  dart.defineExtensionMembers(_NamedNodeMap, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _NamedNodeMap[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('NamedNodeMap')), core.deprecated, dart.const(new _js_helper.Native("NamedNodeMap,MozNamedAttrMap"))];
  class _PagePopupController extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_PagePopupController, {
    constructors: () => ({_: [_PagePopupController, []]})
  });
  _PagePopupController[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('PagePopupController')), core.deprecated, dart.const(new _js_helper.Native("PagePopupController"))];
  class _RGBColor extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_RGBColor, {
    constructors: () => ({_: [_RGBColor, []]})
  });
  _RGBColor[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('RGBColor')), core.deprecated, dart.const(new _js_helper.Native("RGBColor"))];
  class _Rect extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_Rect, {
    constructors: () => ({_: [_Rect, []]})
  });
  _Rect[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Rect')), core.deprecated, dart.const(new _js_helper.Native("Rect"))];
  class _Request extends Body {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(input, requestInitDict) {
      if (requestInitDict === void 0)
        requestInitDict = null;
      if ((typeof input == 'string' || input == null) && requestInitDict == null) {
        return _Request._create_1(input);
      }
      if ((dart.is(requestInitDict, core.Map) || requestInitDict == null) && (typeof input == 'string' || input == null)) {
        let requestInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict);
        return _Request._create_2(input, requestInitDict_1);
      }
      if ((dart.is(input, _Request) || input == null) && requestInitDict == null) {
        return _Request._create_3(input);
      }
      if ((dart.is(requestInitDict, core.Map) || requestInitDict == null) && (dart.is(input, _Request) || input == null)) {
        let requestInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict);
        return _Request._create_4(input, requestInitDict_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1(input) {
      return dart.as(new Request(input), _Request);
    }
    static _create_2(input, requestInitDict) {
      return dart.as(new Request(input, requestInitDict), _Request);
    }
    static _create_3(input) {
      return dart.as(new Request(input), _Request);
    }
    static _create_4(input, requestInitDict) {
      return dart.as(new Request(input, requestInitDict), _Request);
    }
  }
  dart.setSignature(_Request, {
    constructors: () => ({
      _: [_Request, []],
      new: [_Request, [dart.dynamic], [core.Map]]
    }),
    methods: () => ({clone: [_Request, []]}),
    statics: () => ({
      _create_1: [_Request, [dart.dynamic]],
      _create_2: [_Request, [dart.dynamic, dart.dynamic]],
      _create_3: [_Request, [dart.dynamic]],
      _create_4: [_Request, [dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3', '_create_4']
  });
  _Request[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Request')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Request"))];
  class _Response extends Body {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(body_OR_input, requestInitDict_OR_responseInitDict) {
      if (requestInitDict_OR_responseInitDict === void 0)
        requestInitDict_OR_responseInitDict = null;
      if ((typeof body_OR_input == 'string' || body_OR_input == null) && requestInitDict_OR_responseInitDict == null) {
        return _Response._create_1(body_OR_input);
      }
      if ((dart.is(requestInitDict_OR_responseInitDict, core.Map) || requestInitDict_OR_responseInitDict == null) && (typeof body_OR_input == 'string' || body_OR_input == null)) {
        let responseInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict_OR_responseInitDict);
        return _Response._create_2(body_OR_input, responseInitDict_1);
      }
      if ((dart.is(body_OR_input, Blob) || body_OR_input == null) && requestInitDict_OR_responseInitDict == null) {
        return _Response._create_3(body_OR_input);
      }
      if ((dart.is(requestInitDict_OR_responseInitDict, core.Map) || requestInitDict_OR_responseInitDict == null) && (dart.is(body_OR_input, Blob) || body_OR_input == null)) {
        let responseInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict_OR_responseInitDict);
        return _Response._create_4(body_OR_input, responseInitDict_1);
      }
      if ((dart.is(body_OR_input, typed_data.TypedData) || body_OR_input == null) && requestInitDict_OR_responseInitDict == null) {
        return _Response._create_5(body_OR_input);
      }
      if ((dart.is(requestInitDict_OR_responseInitDict, core.Map) || requestInitDict_OR_responseInitDict == null) && (dart.is(body_OR_input, typed_data.TypedData) || body_OR_input == null)) {
        let requestInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict_OR_responseInitDict);
        return _Response._create_6(body_OR_input, requestInitDict_1);
      }
      if ((dart.is(body_OR_input, typed_data.ByteBuffer) || body_OR_input == null) && requestInitDict_OR_responseInitDict == null) {
        return _Response._create_7(body_OR_input);
      }
      if ((dart.is(requestInitDict_OR_responseInitDict, core.Map) || requestInitDict_OR_responseInitDict == null) && (dart.is(body_OR_input, typed_data.ByteBuffer) || body_OR_input == null)) {
        let requestInitDict_1 = html_common.convertDartToNative_Dictionary(requestInitDict_OR_responseInitDict);
        return _Response._create_8(body_OR_input, requestInitDict_1);
      }
      dart.throw(new core.ArgumentError("Incorrect number or type of arguments"));
    }
    static _create_1(body_OR_input) {
      return dart.as(new Response(body_OR_input), _Response);
    }
    static _create_2(body_OR_input, requestInitDict_OR_responseInitDict) {
      return dart.as(new Response(body_OR_input, requestInitDict_OR_responseInitDict), _Response);
    }
    static _create_3(body_OR_input) {
      return dart.as(new Response(body_OR_input), _Response);
    }
    static _create_4(body_OR_input, requestInitDict_OR_responseInitDict) {
      return dart.as(new Response(body_OR_input, requestInitDict_OR_responseInitDict), _Response);
    }
    static _create_5(body_OR_input) {
      return dart.as(new Response(body_OR_input), _Response);
    }
    static _create_6(body_OR_input, requestInitDict_OR_responseInitDict) {
      return dart.as(new Response(body_OR_input, requestInitDict_OR_responseInitDict), _Response);
    }
    static _create_7(body_OR_input) {
      return dart.as(new Response(body_OR_input), _Response);
    }
    static _create_8(body_OR_input, requestInitDict_OR_responseInitDict) {
      return dart.as(new Response(body_OR_input, requestInitDict_OR_responseInitDict), _Response);
    }
  }
  dart.setSignature(_Response, {
    constructors: () => ({
      _: [_Response, []],
      new: [_Response, [dart.dynamic], [core.Map]]
    }),
    statics: () => ({
      _create_1: [_Response, [dart.dynamic]],
      _create_2: [_Response, [dart.dynamic, dart.dynamic]],
      _create_3: [_Response, [dart.dynamic]],
      _create_4: [_Response, [dart.dynamic, dart.dynamic]],
      _create_5: [_Response, [dart.dynamic]],
      _create_6: [_Response, [dart.dynamic, dart.dynamic]],
      _create_7: [_Response, [dart.dynamic]],
      _create_8: [_Response, [dart.dynamic, dart.dynamic]]
    }),
    names: ['_create_1', '_create_2', '_create_3', '_create_4', '_create_5', '_create_6', '_create_7', '_create_8']
  });
  _Response[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('Response')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("Response"))];
  class _ServiceWorker extends EventTarget {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  _ServiceWorker[dart.implements] = () => [AbstractWorker];
  dart.setSignature(_ServiceWorker, {
    constructors: () => ({_: [_ServiceWorker, []]})
  });
  _ServiceWorker[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('ServiceWorker')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("ServiceWorker"))];
  class _SpeechRecognitionResultList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(SpeechRecognitionResult), ImmutableListMixin$(SpeechRecognitionResult)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], SpeechRecognitionResult);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], SpeechRecognitionResult);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], SpeechRecognitionResult);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], SpeechRecognitionResult);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _SpeechRecognitionResultList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(SpeechRecognitionResult)];
  dart.setSignature(_SpeechRecognitionResultList, {
    constructors: () => ({_: [_SpeechRecognitionResultList, []]}),
    methods: () => ({
      get: [SpeechRecognitionResult, [core.int]],
      set: [dart.void, [core.int, SpeechRecognitionResult]],
      elementAt: [SpeechRecognitionResult, [core.int]],
      item: [SpeechRecognitionResult, [core.int]]
    })
  });
  dart.defineExtensionMembers(_SpeechRecognitionResultList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _SpeechRecognitionResultList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SpeechRecognitionResultList')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SpeechRecognitionResultList"))];
  class _StyleSheetList extends dart.mixin(_interceptors.Interceptor, collection.ListMixin$(StyleSheet), ImmutableListMixin$(StyleSheet)) {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    get length() {
      return dart.as(this.length, core.int);
    }
    get(index) {
      if (dart.notNull(dart.as(index >>> 0 !== index || index >= this.length, core.bool)))
        dart.throw(core.RangeError.index(index, this));
      return dart.as(this[index], StyleSheet);
    }
    set(index, value) {
      dart.throw(new core.UnsupportedError("Cannot assign element of immutable List."));
      return value;
    }
    set length(value) {
      dart.throw(new core.UnsupportedError("Cannot resize immutable List."));
    }
    get first() {
      if (dart.notNull(this.length) > 0) {
        return dart.as(this[0], StyleSheet);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get last() {
      let len = this.length;
      if (dart.notNull(len) > 0) {
        return dart.as(this[dart.notNull(len) - 1], StyleSheet);
      }
      dart.throw(new core.StateError("No elements"));
    }
    get single() {
      let len = this.length;
      if (len == 1) {
        return dart.as(this[0], StyleSheet);
      }
      if (len == 0)
        dart.throw(new core.StateError("No elements"));
      dart.throw(new core.StateError("More than one element"));
    }
    elementAt(index) {
      return this.get(index);
    }
  }
  _StyleSheetList[dart.implements] = () => [_js_helper.JavaScriptIndexingBehavior, core.List$(StyleSheet)];
  dart.setSignature(_StyleSheetList, {
    constructors: () => ({_: [_StyleSheetList, []]}),
    methods: () => ({
      get: [StyleSheet, [core.int]],
      set: [dart.void, [core.int, StyleSheet]],
      elementAt: [StyleSheet, [core.int]],
      [__getter__]: [CssStyleSheet, [core.String]],
      item: [StyleSheet, [core.int]]
    })
  });
  dart.defineExtensionMembers(_StyleSheetList, [
    'get',
    'set',
    'elementAt',
    'length',
    'length',
    'first',
    'last',
    'single'
  ]);
  _StyleSheetList[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('StyleSheetList')), dart.const(new _js_helper.Native("StyleSheetList"))];
  class _SubtleCrypto extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_SubtleCrypto, {
    constructors: () => ({_: [_SubtleCrypto, []]})
  });
  _SubtleCrypto[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('SubtleCrypto')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("SubtleCrypto"))];
  class _WebKitCSSFilterValue extends _CssValueList {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_WebKitCSSFilterValue, {
    constructors: () => ({_: [_WebKitCSSFilterValue, []]})
  });
  _WebKitCSSFilterValue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WebKitCSSFilterValue')), core.deprecated, dart.const(new _js_helper.Native("WebKitCSSFilterValue"))];
  class _WebKitCSSMatrix extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
    static new(cssValue) {
      if (cssValue === void 0)
        cssValue = null;
      if (cssValue != null) {
        return _WebKitCSSMatrix._create_1(cssValue);
      }
      return _WebKitCSSMatrix._create_2();
    }
    static _create_1(cssValue) {
      return dart.as(new WebKitCSSMatrix(cssValue), _WebKitCSSMatrix);
    }
    static _create_2() {
      return dart.as(new WebKitCSSMatrix(), _WebKitCSSMatrix);
    }
  }
  dart.setSignature(_WebKitCSSMatrix, {
    constructors: () => ({
      _: [_WebKitCSSMatrix, []],
      new: [_WebKitCSSMatrix, [], [core.String]]
    }),
    statics: () => ({
      _create_1: [_WebKitCSSMatrix, [dart.dynamic]],
      _create_2: [_WebKitCSSMatrix, []]
    }),
    names: ['_create_1', '_create_2']
  });
  _WebKitCSSMatrix[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WebKitCSSMatrix')), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.CHROME)), dart.const(new _metadata.SupportedBrowser(_metadata.SupportedBrowser.SAFARI)), dart.const(new _metadata.Experimental()), core.deprecated, dart.const(new _js_helper.Native("WebKitCSSMatrix"))];
  class _WebKitCSSTransformValue extends _CssValueList {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_WebKitCSSTransformValue, {
    constructors: () => ({_: [_WebKitCSSTransformValue, []]})
  });
  _WebKitCSSTransformValue[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WebKitCSSTransformValue')), core.deprecated, dart.const(new _js_helper.Native("WebKitCSSTransformValue"))];
  class _WindowTimers extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_WindowTimers, {
    constructors: () => ({_: [_WindowTimers, []]})
  });
  _WindowTimers[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WindowTimers')), dart.const(new _metadata.Experimental())];
  class _WorkerLocation extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  _WorkerLocation[dart.implements] = () => [UrlUtilsReadOnly];
  dart.setSignature(_WorkerLocation, {
    constructors: () => ({_: [_WorkerLocation, []]})
  });
  _WorkerLocation[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WorkerLocation')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WorkerLocation"))];
  class _WorkerNavigator extends _interceptors.Interceptor {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  _WorkerNavigator[dart.implements] = () => [NavigatorCpu, NavigatorOnLine, NavigatorID];
  dart.setSignature(_WorkerNavigator, {
    constructors: () => ({_: [_WorkerNavigator, []]})
  });
  _WorkerNavigator[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('WorkerNavigator')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("WorkerNavigator"))];
  class _XMLHttpRequestProgressEvent extends ProgressEvent {
    static _() {
      dart.throw(new core.UnsupportedError("Not supported"));
    }
  }
  dart.setSignature(_XMLHttpRequestProgressEvent, {
    constructors: () => ({_: [_XMLHttpRequestProgressEvent, []]})
  });
  _XMLHttpRequestProgressEvent[dart.metadata] = () => [dart.const(new _metadata.DocsEditable()), dart.const(new _metadata.DomName('XMLHttpRequestProgressEvent')), dart.const(new _metadata.Experimental()), dart.const(new _js_helper.Native("XMLHttpRequestProgressEvent"))];
  let _matches = Symbol('_matches');
  class _AttributeMap extends core.Object {
    _AttributeMap(element) {
      this[_element] = element;
    }
    addAll(other) {
      other.forEach(dart.fn((k, v) => {
        this.set(dart.as(k, core.String), dart.as(v, core.String));
      }));
    }
    containsValue(value) {
      for (let v of this.values) {
        if (dart.equals(value, v)) {
          return true;
        }
      }
      return false;
    }
    putIfAbsent(key, ifAbsent) {
      if (!dart.notNull(this.containsKey(key))) {
        this.set(key, ifAbsent());
      }
      return this.get(key);
    }
    clear() {
      for (let key of this.keys) {
        this.remove(key);
      }
    }
    forEach(f) {
      for (let key of this.keys) {
        let value = this.get(key);
        f(dart.as(key, core.String), dart.as(value, core.String));
      }
    }
    get keys() {
      let attributes = this[_element][_attributes];
      let keys = core.List$(core.String).new();
      for (let i = 0, len = dart.as(dart.dload(attributes, 'length'), core.int); dart.notNull(i) < dart.notNull(len); i = dart.notNull(i) + 1) {
        if (dart.notNull(this[_matches](dart.as(dart.dindex(attributes, i), Node)))) {
          dart.dsend(keys, 'add', dart.dload(dart.dindex(attributes, i), 'name'));
        }
      }
      return dart.as(keys, core.Iterable$(core.String));
    }
    get values() {
      let attributes = this[_element][_attributes];
      let values = core.List$(core.String).new();
      for (let i = 0, len = dart.as(dart.dload(attributes, 'length'), core.int); dart.notNull(i) < dart.notNull(len); i = dart.notNull(i) + 1) {
        if (dart.notNull(this[_matches](dart.as(dart.dindex(attributes, i), Node)))) {
          dart.dsend(values, 'add', dart.dload(dart.dindex(attributes, i), 'value'));
        }
      }
      return dart.as(values, core.Iterable$(core.String));
    }
    get isEmpty() {
      return this.length == 0;
    }
    get isNotEmpty() {
      return !dart.notNull(this.isEmpty);
    }
  }
  _AttributeMap[dart.implements] = () => [core.Map$(core.String, core.String)];
  dart.setSignature(_AttributeMap, {
    constructors: () => ({_AttributeMap: [_AttributeMap, [Element]]}),
    methods: () => ({
      addAll: [dart.void, [core.Map$(core.String, core.String)]],
      containsValue: [core.bool, [core.String]],
      putIfAbsent: [core.String, [core.String, dart.functionType(core.String, [])]],
      clear: [dart.void, []],
      forEach: [dart.void, [dart.functionType(dart.void, [core.String, core.String])]]
    })
  });
  class _ElementAttributeMap extends _AttributeMap {
    _ElementAttributeMap(element) {
      super._AttributeMap(element);
    }
    containsKey(key) {
      return this[_element][_hasAttribute](key);
    }
    get(key) {
      return this[_element].getAttribute(key);
    }
    set(key, value) {
      this[_element].setAttribute(key, value);
      return value;
    }
    remove(key) {
      let value = this[_element].getAttribute(key);
      this[_element][_removeAttribute](key);
      return value;
    }
    get length() {
      return this.keys[dartx.length];
    }
    [_matches](node) {
      return node[_namespaceUri] == null;
    }
  }
  dart.setSignature(_ElementAttributeMap, {
    constructors: () => ({_ElementAttributeMap: [_ElementAttributeMap, [Element]]}),
    methods: () => ({
      containsKey: [core.bool, [core.String]],
      get: [core.String, [core.String]],
      set: [dart.void, [core.String, core.String]],
      remove: [core.String, [core.String]],
      [_matches]: [core.bool, [Node]]
    })
  });
  let _namespace = Symbol('_namespace');
  class _NamespacedAttributeMap extends _AttributeMap {
    _NamespacedAttributeMap(element, namespace) {
      this[_namespace] = namespace;
      super._AttributeMap(element);
    }
    containsKey(key) {
      return this[_element][_hasAttributeNS](this[_namespace], key);
    }
    get(key) {
      return this[_element].getAttributeNS(this[_namespace], key);
    }
    set(key, value) {
      this[_element].setAttributeNS(this[_namespace], key, value);
      return value;
    }
    remove(key) {
      let value = this.get(key);
      this[_element][_removeAttributeNS](this[_namespace], key);
      return value;
    }
    get length() {
      return this.keys[dartx.length];
    }
    [_matches](node) {
      return node[_namespaceUri] == this[_namespace];
    }
  }
  dart.setSignature(_NamespacedAttributeMap, {
    constructors: () => ({_NamespacedAttributeMap: [_NamespacedAttributeMap, [Element, core.String]]}),
    methods: () => ({
      containsKey: [core.bool, [core.String]],
      get: [core.String, [core.String]],
      set: [dart.void, [core.String, core.String]],
      remove: [core.String, [core.String]],
      [_matches]: [core.bool, [Node]]
    })
  });
  let _attr = Symbol('_attr');
  let _strip = Symbol('_strip');
  let _toHyphenedName = Symbol('_toHyphenedName');
  let _toCamelCase = Symbol('_toCamelCase');
  class _DataAttributeMap extends core.Object {
    _DataAttributeMap(attributes) {
      this[_attributes] = attributes;
    }
    addAll(other) {
      other.forEach(dart.fn((k, v) => {
        this.set(dart.as(k, core.String), dart.as(v, core.String));
      }));
    }
    containsValue(value) {
      return this.values[dartx.any](dart.fn(v => dart.equals(v, value), core.bool, [dart.dynamic]));
    }
    containsKey(key) {
      return this[_attributes].containsKey(this[_attr](key));
    }
    get(key) {
      return this[_attributes].get(this[_attr](key));
    }
    set(key, value) {
      this[_attributes].set(this[_attr](key), value);
      return value;
    }
    putIfAbsent(key, ifAbsent) {
      return this[_attributes].putIfAbsent(this[_attr](key), ifAbsent);
    }
    remove(key) {
      return this[_attributes].remove(this[_attr](key));
    }
    clear() {
      for (let key of this.keys) {
        this.remove(key);
      }
    }
    forEach(f) {
      this[_attributes].forEach(dart.fn((key, value) => {
        if (dart.notNull(this[_matches](key))) {
          f(this[_strip](key), value);
        }
      }, dart.dynamic, [core.String, core.String]));
    }
    get keys() {
      let keys = core.List$(core.String).new();
      this[_attributes].forEach(dart.fn((key, value) => {
        if (dart.notNull(this[_matches](key))) {
          dart.dsend(keys, 'add', this[_strip](key));
        }
      }, dart.dynamic, [core.String, core.String]));
      return dart.as(keys, core.Iterable$(core.String));
    }
    get values() {
      let values = core.List$(core.String).new();
      this[_attributes].forEach(dart.fn((key, value) => {
        if (dart.notNull(this[_matches](key))) {
          dart.dsend(values, 'add', value);
        }
      }, dart.dynamic, [core.String, core.String]));
      return dart.as(values, core.Iterable$(core.String));
    }
    get length() {
      return this.keys[dartx.length];
    }
    get isEmpty() {
      return this.length == 0;
    }
    get isNotEmpty() {
      return !dart.notNull(this.isEmpty);
    }
    [_attr](key) {
      return `data-${this[_toHyphenedName](key)}`;
    }
    [_matches](key) {
      return key[dartx.startsWith]('data-');
    }
    [_strip](key) {
      return this[_toCamelCase](key[dartx.substring](5));
    }
    [_toCamelCase](hyphenedName, opts) {
      let startUppercase = opts && 'startUppercase' in opts ? opts.startUppercase : false;
      let segments = hyphenedName[dartx.split]('-');
      let start = dart.notNull(startUppercase) ? 0 : 1;
      for (let i = start; dart.notNull(i) < dart.notNull(dart.as(dart.dload(segments, 'length'), core.num)); i = dart.notNull(i) + 1) {
        let segment = dart.dindex(segments, i);
        if (dart.notNull(dart.as(dart.dsend(dart.dload(segment, 'length'), '>', 0), core.bool))) {
          dart.dsetindex(segments, i, `${dart.dsend(dart.dindex(segment, 0), 'toUpperCase')}${dart.dsend(segment, 'substring', 1)}`);
        }
      }
      return dart.as(dart.dsend(segments, 'join', ''), core.String);
    }
    [_toHyphenedName](word) {
      let sb = new core.StringBuffer();
      for (let i = 0; dart.notNull(i) < dart.notNull(word[dartx.length]); i = dart.notNull(i) + 1) {
        let lower = word[dartx.get](i)[dartx.toLowerCase]();
        if (!dart.equals(word[dartx.get](i), lower) && dart.notNull(i) > 0)
          dart.dsend(sb, 'write', '-');
        dart.dsend(sb, 'write', lower);
      }
      return dart.as(dart.dsend(sb, 'toString'), core.String);
    }
  }
  _DataAttributeMap[dart.implements] = () => [core.Map$(core.String, core.String)];
  dart.setSignature(_DataAttributeMap, {
    constructors: () => ({_DataAttributeMap: [_DataAttributeMap, [core.Map$(core.String, core.String)]]}),
    methods: () => ({
      addAll: [dart.void, [core.Map$(core.String, core.String)]],
      containsValue: [core.bool, [core.String]],
      containsKey: [core.bool, [core.String]],
      get: [core.String, [core.String]],
      set: [dart.void, [core.String, core.String]],
      putIfAbsent: [core.String, [core.String, dart.functionType(core.String, [])]],
      remove: [core.String, [core.String]],
      clear: [dart.void, []],
      forEach: [dart.void, [dart.functionType(dart.void, [core.String, core.String])]],
      [_attr]: [core.String, [core.String]],
      [_matches]: [core.bool, [core.String]],
      [_strip]: [core.String, [core.String]],
      [_toCamelCase]: [core.String, [core.String], {startUppercase: core.bool}],
      [_toHyphenedName]: [core.String, [core.String]]
    })
  });
  class CanvasImageSource extends core.Object {}
  class WindowBase extends core.Object {}
  WindowBase[dart.implements] = () => [EventTarget];
  class LocationBase extends core.Object {}
  class HistoryBase extends core.Object {}
  class CssClassSet extends core.Object {}
  CssClassSet[dart.implements] = () => [core.Set$(core.String)];
  let _addOrSubtractToBoxModel = Symbol('_addOrSubtractToBoxModel');
  class CssRect extends math.MutableRectangle$(core.num) {
    CssRect(element) {
      this[_element] = element;
      super.MutableRectangle(0, 0, 0, 0);
    }
    set height(newHeight) {
      dart.throw(new core.UnsupportedError("Can only set height for content rect."));
    }
    set width(newWidth) {
      dart.throw(new core.UnsupportedError("Can only set width for content rect."));
    }
    [_addOrSubtractToBoxModel](dimensions, augmentingMeasurement) {
      let styles = this[_element].getComputedStyle();
      let val = 0;
      for (let measurement of dimensions) {
        if (dart.equals(augmentingMeasurement, exports._MARGIN)) {
          val = dart.dsend(val, '+', new Dimension.css(dart.as(dart.dsend(styles, 'getPropertyValue', `${augmentingMeasurement}-${measurement}`), core.String)).value);
        }
        if (dart.equals(augmentingMeasurement, exports._CONTENT)) {
          val = dart.dsend(val, '-', new Dimension.css(dart.as(dart.dsend(styles, 'getPropertyValue', `${exports._PADDING}-${measurement}`), core.String)).value);
        }
        if (!dart.equals(augmentingMeasurement, exports._MARGIN)) {
          val = dart.dsend(val, '-', new Dimension.css(dart.as(dart.dsend(styles, 'getPropertyValue', `border-${measurement}-width`), core.String)).value);
        }
      }
      return dart.as(val, core.num);
    }
  }
  dart.setSignature(CssRect, {
    constructors: () => ({CssRect: [CssRect, [Element]]}),
    methods: () => ({[_addOrSubtractToBoxModel]: [core.num, [core.List$(core.String), core.String]]})
  });
  class _ContentCssRect extends CssRect {
    _ContentCssRect(element) {
      super.CssRect(dart.as(element, Element));
    }
    get height() {
      return dart.notNull(this[_element].offsetHeight) + dart.notNull(this[_addOrSubtractToBoxModel](dart.as(exports._HEIGHT, core.List$(core.String)), dart.as(exports._CONTENT, core.String)));
    }
    get width() {
      return dart.notNull(this[_element].offsetWidth) + dart.notNull(this[_addOrSubtractToBoxModel](dart.as(exports._WIDTH, core.List$(core.String)), dart.as(exports._CONTENT, core.String)));
    }
    set height(newHeight) {
      if (dart.is(newHeight, Dimension)) {
        if (dart.notNull(dart.as(dart.dsend(dart.dload(newHeight, 'value'), '<', 0), core.bool)))
          newHeight = new Dimension.px(0);
        this[_element].style.height = dart.as(dart.dsend(newHeight, 'toString'), core.String);
      } else {
        if (dart.notNull(dart.as(dart.dsend(newHeight, '<', 0), core.bool)))
          newHeight = 0;
        this[_element].style.height = `${newHeight}px`;
      }
    }
    set width(newWidth) {
      if (dart.is(newWidth, Dimension)) {
        if (dart.notNull(dart.as(dart.dsend(dart.dload(newWidth, 'value'), '<', 0), core.bool)))
          newWidth = new Dimension.px(0);
        this[_element].style.width = dart.as(dart.dsend(newWidth, 'toString'), core.String);
      } else {
        if (dart.notNull(dart.as(dart.dsend(newWidth, '<', 0), core.bool)))
          newWidth = 0;
        this[_element].style.width = `${newWidth}px`;
      }
    }
    get left() {
      return dart.as(dart.dsend(this[_element].getBoundingClientRect().left, '-', this[_addOrSubtractToBoxModel](dart.list(['left'], core.String), dart.as(exports._CONTENT, core.String))), core.num);
    }
    get top() {
      return dart.as(dart.dsend(this[_element].getBoundingClientRect().top, '-', this[_addOrSubtractToBoxModel](dart.list(['top'], core.String), dart.as(exports._CONTENT, core.String))), core.num);
    }
  }
  dart.setSignature(_ContentCssRect, {
    constructors: () => ({_ContentCssRect: [_ContentCssRect, [dart.dynamic]]})
  });
  let _elementList = Symbol('_elementList');
  class _ContentCssListRect extends _ContentCssRect {
    _ContentCssListRect(elementList) {
      this[_elementList] = null;
      super._ContentCssRect(dart.dload(elementList, 'first'));
      this[_elementList] = dart.as(elementList, core.List$(Element));
    }
    set height(newHeight) {
      this[_elementList][dartx.forEach](dart.fn(e => dart.dput(dart.dload(e, 'contentEdge'), 'height', newHeight)));
    }
    set width(newWidth) {
      this[_elementList][dartx.forEach](dart.fn(e => dart.dput(dart.dload(e, 'contentEdge'), 'width', newWidth)));
    }
  }
  dart.setSignature(_ContentCssListRect, {
    constructors: () => ({_ContentCssListRect: [_ContentCssListRect, [dart.dynamic]]})
  });
  class _PaddingCssRect extends CssRect {
    _PaddingCssRect(element) {
      super.CssRect(dart.as(element, Element));
    }
    get height() {
      return dart.notNull(this[_element].offsetHeight) + dart.notNull(this[_addOrSubtractToBoxModel](dart.as(exports._HEIGHT, core.List$(core.String)), dart.as(exports._PADDING, core.String)));
    }
    get width() {
      return dart.notNull(this[_element].offsetWidth) + dart.notNull(this[_addOrSubtractToBoxModel](dart.as(exports._WIDTH, core.List$(core.String)), dart.as(exports._PADDING, core.String)));
    }
    get left() {
      return dart.as(dart.dsend(this[_element].getBoundingClientRect().left, '-', this[_addOrSubtractToBoxModel](dart.list(['left'], core.String), dart.as(exports._PADDING, core.String))), core.num);
    }
    get top() {
      return dart.as(dart.dsend(this[_element].getBoundingClientRect().top, '-', this[_addOrSubtractToBoxModel](dart.list(['top'], core.String), dart.as(exports._PADDING, core.String))), core.num);
    }
  }
  dart.setSignature(_PaddingCssRect, {
    constructors: () => ({_PaddingCssRect: [_PaddingCssRect, [dart.dynamic]]})
  });
  class _BorderCssRect extends CssRect {
    _BorderCssRect(element) {
      super.CssRect(dart.as(element, Element));
    }
    get height() {
      return this[_element].offsetHeight;
    }
    get width() {
      return this[_element].offsetWidth;
    }
    get left() {
      return dart.as(this[_element].getBoundingClientRect().left, core.num);
    }
    get top() {
      return dart.as(this[_element].getBoundingClientRect().top, core.num);
    }
  }
  dart.setSignature(_BorderCssRect, {
    constructors: () => ({_BorderCssRect: [_BorderCssRect, [dart.dynamic]]})
  });
  class _MarginCssRect extends CssRect {
    _MarginCssRect(element) {
      super.CssRect(dart.as(element, Element));
    }
    get height() {
      return dart.notNull(this[_element].offsetHeight) + dart.notNull(this[_addOrSubtractToBoxModel](dart.as(exports._HEIGHT, core.List$(core.String)), dart.as(exports._MARGIN, core.String)));
    }
    get width() {
      return dart.notNull(this[_element].offsetWidth) + dart.notNull(this[_addOrSubtractToBoxModel](dart.as(exports._WIDTH, core.List$(core.String)), dart.as(exports._MARGIN, core.String)));
    }
    get left() {
      return dart.as(dart.dsend(this[_element].getBoundingClientRect().left, '-', this[_addOrSubtractToBoxModel](dart.list(['left'], core.String), dart.as(exports._MARGIN, core.String))), core.num);
    }
    get top() {
      return dart.as(dart.dsend(this[_element].getBoundingClientRect().top, '-', this[_addOrSubtractToBoxModel](dart.list(['top'], core.String), dart.as(exports._MARGIN, core.String))), core.num);
    }
  }
  dart.setSignature(_MarginCssRect, {
    constructors: () => ({_MarginCssRect: [_MarginCssRect, [dart.dynamic]]})
  });
  exports._CONTENT = 'content';
  exports._PADDING = 'padding';
  exports._MARGIN = 'margin';
  dart.defineLazyProperties(exports, {
    get _HEIGHT() {
      return ['top', 'bottom'];
    },
    get _WIDTH() {
      return ['right', 'left'];
    }
  });
  let _sets = Symbol('_sets');
  dart.defineLazyClass(exports, {
    get _MultiElementCssClassSet() {
      class _MultiElementCssClassSet extends html_common.CssClassSetImpl {
        static new(elements) {
          return new exports._MultiElementCssClassSet._(elements, dart.as(elements[dartx.map](dart.fn(e => e.classes, CssClassSet, [Element]))[dartx.toList](), core.List$(html_common.CssClassSetImpl)));
        }
        _(elementIterable, sets) {
          this[_elementIterable] = elementIterable;
          this[_sets] = sets;
        }
        readClasses() {
          let s = collection.LinkedHashSet$(core.String).new();
          this[_sets][dartx.forEach](dart.fn(e => dart.dsend(s, 'addAll', e.readClasses()), dart.dynamic, [html_common.CssClassSetImpl]));
          return dart.as(s, core.Set$(core.String));
        }
        writeClasses(s) {
          let classes = s.join(' ');
          for (let e of this[_elementIterable]) {
            e.className = dart.as(classes, core.String);
          }
        }
        modify(f) {
          this[_sets][dartx.forEach](dart.fn(e => e.modify(f), dart.dynamic, [html_common.CssClassSetImpl]));
        }
        toggle(value, shouldAdd) {
          if (shouldAdd === void 0)
            shouldAdd = null;
          return dart.as(this[_sets][dartx.fold](false, dart.fn((changed, e) => dart.notNull(e.toggle(value, shouldAdd)) || dart.notNull(changed), core.bool, [core.bool, html_common.CssClassSetImpl])), core.bool);
        }
        remove(value) {
          return dart.as(this[_sets][dartx.fold](false, dart.fn((changed, e) => dart.notNull(e.remove(value)) || dart.notNull(changed), core.bool, [core.bool, html_common.CssClassSetImpl])), core.bool);
        }
      }
      dart.defineNamedConstructor(_MultiElementCssClassSet, '_');
      dart.setSignature(_MultiElementCssClassSet, {
        constructors: () => ({
          new: [exports._MultiElementCssClassSet, [core.Iterable$(Element)]],
          _: [exports._MultiElementCssClassSet, [core.Iterable$(Element), core.List$(html_common.CssClassSetImpl)]]
        }),
        methods: () => ({
          readClasses: [core.Set$(core.String), []],
          writeClasses: [dart.void, [core.Set$(core.String)]]
        })
      });
      return _MultiElementCssClassSet;
    }
  });
  dart.defineLazyClass(exports, {
    get _ElementCssClassSet() {
      class _ElementCssClassSet extends html_common.CssClassSetImpl {
        _ElementCssClassSet(element) {
          this[_element] = element;
        }
        readClasses() {
          let s = collection.LinkedHashSet$(core.String).new();
          let classname = this[_element].className;
          for (let name of dart.as(dart.dsend(classname, 'split', ' '), core.Iterable$(core.String))) {
            let trimmed = name[dartx.trim]();
            if (!dart.notNull(trimmed[dartx.isEmpty])) {
              dart.dsend(s, 'add', trimmed);
            }
          }
          return dart.as(s, core.Set$(core.String));
        }
        writeClasses(s) {
          this[_element].className = s.join(' ');
        }
        get length() {
          return exports._ElementCssClassSet._classListLength(exports._ElementCssClassSet._classListOf(this[_element]));
        }
        get isEmpty() {
          return this.length == 0;
        }
        get isNotEmpty() {
          return this.length != 0;
        }
        clear() {
          this[_element].className = '';
        }
        contains(value) {
          return exports._ElementCssClassSet._contains(this[_element], value);
        }
        add(value) {
          return exports._ElementCssClassSet._add(this[_element], value);
        }
        remove(value) {
          return typeof value == 'string' && dart.notNull(exports._ElementCssClassSet._remove(this[_element], value));
        }
        toggle(value, shouldAdd) {
          if (shouldAdd === void 0)
            shouldAdd = null;
          return exports._ElementCssClassSet._toggle(this[_element], value, shouldAdd);
        }
        addAll(iterable) {
          exports._ElementCssClassSet._addAll(this[_element], iterable);
        }
        removeAll(iterable) {
          exports._ElementCssClassSet._removeAll(this[_element], iterable);
        }
        retainAll(iterable) {
          exports._ElementCssClassSet._removeWhere(this[_element], dart.bind(iterable[dartx.toSet](), 'contains'), false);
        }
        removeWhere(test) {
          exports._ElementCssClassSet._removeWhere(this[_element], test, true);
        }
        retainWhere(test) {
          exports._ElementCssClassSet._removeWhere(this[_element], test, false);
        }
        static _contains(_element, value) {
          return typeof value == 'string' && dart.notNull(exports._ElementCssClassSet._classListContains(exports._ElementCssClassSet._classListOf(_element), value));
        }
        static _add(_element, value) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          let added = !dart.notNull(exports._ElementCssClassSet._classListContainsBeforeAddOrRemove(list, value));
          exports._ElementCssClassSet._classListAdd(list, value);
          return added;
        }
        static _remove(_element, value) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          let removed = exports._ElementCssClassSet._classListContainsBeforeAddOrRemove(list, value);
          exports._ElementCssClassSet._classListRemove(list, value);
          return removed;
        }
        static _toggle(_element, value, shouldAdd) {
          return shouldAdd == null ? exports._ElementCssClassSet._toggleDefault(_element, value) : exports._ElementCssClassSet._toggleOnOff(_element, value, shouldAdd);
        }
        static _toggleDefault(_element, value) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          return exports._ElementCssClassSet._classListToggle1(list, value);
        }
        static _toggleOnOff(_element, value, shouldAdd) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          if (dart.notNull(shouldAdd)) {
            exports._ElementCssClassSet._classListAdd(list, value);
            return true;
          } else {
            exports._ElementCssClassSet._classListRemove(list, value);
            return false;
          }
        }
        static _addAll(_element, iterable) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          for (let value of iterable) {
            exports._ElementCssClassSet._classListAdd(list, value);
          }
        }
        static _removeAll(_element, iterable) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          for (let value of iterable) {
            exports._ElementCssClassSet._classListRemove(list, dart.as(value, core.String));
          }
        }
        static _removeWhere(_element, test, doRemove) {
          let list = exports._ElementCssClassSet._classListOf(_element);
          let i = 0;
          while (dart.notNull(i) < dart.notNull(exports._ElementCssClassSet._classListLength(list))) {
            let item = list.item(i);
            if (doRemove == test(item)) {
              exports._ElementCssClassSet._classListRemove(list, item);
            } else {
              i = dart.notNull(i) + 1;
            }
          }
        }
        static _classListOf(e) {
          return dart.as(e.classList, DomTokenList);
        }
        static _classListLength(list) {
          return dart.as(list.length, core.int);
        }
        static _classListContains(list, value) {
          return dart.as(list.contains(value), core.bool);
        }
        static _classListContainsBeforeAddOrRemove(list, value) {
          return dart.as(list.contains(value), core.bool);
        }
        static _classListAdd(list, value) {
          list.add(value);
        }
        static _classListRemove(list, value) {
          list.remove(value);
        }
        static _classListToggle1(list, value) {
          return dart.as(list.toggle(value), core.bool);
        }
        static _classListToggle2(list, value, shouldAdd) {
          return dart.as(list.toggle(value, shouldAdd), core.bool);
        }
      }
      dart.setSignature(_ElementCssClassSet, {
        constructors: () => ({_ElementCssClassSet: [exports._ElementCssClassSet, [Element]]}),
        methods: () => ({
          readClasses: [core.Set$(core.String), []],
          writeClasses: [dart.void, [core.Set$(core.String)]],
          removeAll: [dart.void, [core.Iterable$(core.String)]],
          retainAll: [dart.void, [core.Iterable$(core.String)]]
        }),
        statics: () => ({
          _contains: [core.bool, [Element, core.Object]],
          _add: [core.bool, [Element, core.String]],
          _remove: [core.bool, [Element, core.String]],
          _toggle: [core.bool, [Element, core.String, core.bool]],
          _toggleDefault: [core.bool, [Element, core.String]],
          _toggleOnOff: [core.bool, [Element, core.String, core.bool]],
          _addAll: [dart.void, [Element, core.Iterable$(core.String)]],
          _removeAll: [dart.void, [Element, core.Iterable$(core.String)]],
          _removeWhere: [dart.void, [Element, dart.functionType(core.bool, [core.String]), core.bool]],
          _classListOf: [DomTokenList, [Element]],
          _classListLength: [core.int, [DomTokenList]],
          _classListContains: [core.bool, [DomTokenList, core.String]],
          _classListContainsBeforeAddOrRemove: [core.bool, [DomTokenList, core.String]],
          _classListAdd: [dart.void, [DomTokenList, core.String]],
          _classListRemove: [dart.void, [DomTokenList, core.String]],
          _classListToggle1: [core.bool, [DomTokenList, core.String]],
          _classListToggle2: [core.bool, [DomTokenList, core.String, core.bool]]
        }),
        names: ['_contains', '_add', '_remove', '_toggle', '_toggleDefault', '_toggleOnOff', '_addAll', '_removeAll', '_removeWhere', '_classListOf', '_classListLength', '_classListContains', '_classListContainsBeforeAddOrRemove', '_classListAdd', '_classListRemove', '_classListToggle1', '_classListToggle2']
      });
      dart.defineExtensionMembers(_ElementCssClassSet, ['contains', 'length', 'isEmpty', 'isNotEmpty']);
      return _ElementCssClassSet;
    }
  });
  let _unit = Symbol('_unit');
  class Dimension extends core.Object {
    percent(value) {
      this[_value] = value;
      this[_unit] = '%';
    }
    px(value) {
      this[_value] = value;
      this[_unit] = 'px';
    }
    pc(value) {
      this[_value] = value;
      this[_unit] = 'pc';
    }
    pt(value) {
      this[_value] = value;
      this[_unit] = 'pt';
    }
    inch(value) {
      this[_value] = value;
      this[_unit] = 'in';
    }
    cm(value) {
      this[_value] = value;
      this[_unit] = 'cm';
    }
    mm(value) {
      this[_value] = value;
      this[_unit] = 'mm';
    }
    em(value) {
      this[_value] = value;
      this[_unit] = 'em';
    }
    ex(value) {
      this[_value] = value;
      this[_unit] = 'ex';
    }
    css(cssValue) {
      this[_value] = null;
      this[_unit] = null;
      if (cssValue == '')
        cssValue = '0px';
      if (dart.notNull(cssValue[dartx.endsWith]('%'))) {
        this[_unit] = '%';
      } else {
        this[_unit] = cssValue[dartx.substring](dart.notNull(cssValue[dartx.length]) - 2);
      }
      if (dart.notNull(cssValue[dartx.contains]('.'))) {
        this[_value] = core.double.parse(cssValue[dartx.substring](0, dart.notNull(cssValue[dartx.length]) - dart.notNull(this[_unit][dartx.length])));
      } else {
        this[_value] = core.int.parse(cssValue[dartx.substring](0, dart.notNull(cssValue[dartx.length]) - dart.notNull(this[_unit][dartx.length])));
      }
    }
    toString() {
      return `${this[_value]}${this[_unit]}`;
    }
    get value() {
      return this[_value];
    }
  }
  dart.defineNamedConstructor(Dimension, 'percent');
  dart.defineNamedConstructor(Dimension, 'px');
  dart.defineNamedConstructor(Dimension, 'pc');
  dart.defineNamedConstructor(Dimension, 'pt');
  dart.defineNamedConstructor(Dimension, 'inch');
  dart.defineNamedConstructor(Dimension, 'cm');
  dart.defineNamedConstructor(Dimension, 'mm');
  dart.defineNamedConstructor(Dimension, 'em');
  dart.defineNamedConstructor(Dimension, 'ex');
  dart.defineNamedConstructor(Dimension, 'css');
  dart.setSignature(Dimension, {
    constructors: () => ({
      percent: [Dimension, [core.num]],
      px: [Dimension, [core.num]],
      pc: [Dimension, [core.num]],
      pt: [Dimension, [core.num]],
      inch: [Dimension, [core.num]],
      cm: [Dimension, [core.num]],
      mm: [Dimension, [core.num]],
      em: [Dimension, [core.num]],
      ex: [Dimension, [core.num]],
      css: [Dimension, [core.String]]
    })
  });
  Dimension[dart.metadata] = () => [dart.const(new _metadata.Experimental())];
  let EventListener = dart.typedef('EventListener', () => dart.functionType(dart.dynamic, [Event]));
  let ElementStream$ = dart.generic(function(T) {
    class ElementStream extends core.Object {}
    ElementStream[dart.implements] = () => [async.Stream$(T)];
    return ElementStream;
  });
  let ElementStream = ElementStream$();
  let _target = Symbol('_target');
  let _useCapture = Symbol('_useCapture');
  let _EventStream$ = dart.generic(function(T) {
    class _EventStream extends async.Stream$(T) {
      _EventStream(target, eventType, useCapture) {
        this[_target] = target;
        this[_eventType] = eventType;
        this[_useCapture] = useCapture;
        super.Stream();
      }
      asBroadcastStream(opts) {
        let onListen = opts && 'onListen' in opts ? opts.onListen : null;
        dart.as(onListen, dart.functionType(dart.void, [async.StreamSubscription]));
        let onCancel = opts && 'onCancel' in opts ? opts.onCancel : null;
        dart.as(onCancel, dart.functionType(dart.void, [async.StreamSubscription]));
        return this;
      }
      get isBroadcast() {
        return true;
      }
      listen(onData, opts) {
        dart.as(onData, dart.functionType(dart.void, [T]));
        let onError = opts && 'onError' in opts ? opts.onError : null;
        let onDone = opts && 'onDone' in opts ? opts.onDone : null;
        dart.as(onDone, dart.functionType(dart.void, []));
        let cancelOnError = opts && 'cancelOnError' in opts ? opts.cancelOnError : null;
        return new (_EventStreamSubscription$(T))(this[_target], this[_eventType], onData, this[_useCapture]);
      }
    }
    dart.setSignature(_EventStream, {
      constructors: () => ({_EventStream: [_EventStream$(T), [EventTarget, core.String, core.bool]]}),
      methods: () => ({
        asBroadcastStream: [async.Stream$(T), [], {onListen: dart.functionType(dart.void, [async.StreamSubscription]), onCancel: dart.functionType(dart.void, [async.StreamSubscription])}],
        listen: [async.StreamSubscription$(T), [dart.functionType(dart.void, [T])], {onError: core.Function, onDone: dart.functionType(dart.void, []), cancelOnError: core.bool}]
      })
    });
    return _EventStream;
  });
  let _EventStream = _EventStream$();
  let _ElementEventStreamImpl$ = dart.generic(function(T) {
    class _ElementEventStreamImpl extends _EventStream$(T) {
      _ElementEventStreamImpl(target, eventType, useCapture) {
        super._EventStream(dart.as(target, EventTarget), dart.as(eventType, core.String), dart.as(useCapture, core.bool));
      }
      matches(selector) {
        return dart.as(this.where(dart.fn(event => dart.as(dart.dsend(dart.dload(event, 'target'), 'matchesWithAncestors', selector), core.bool), core.bool, [dart.dynamic])).map(dart.fn(e => {
          dart.dput(e, _selector, selector);
          return e;
        })), async.Stream$(T));
      }
      capture(onData) {
        dart.as(onData, dart.functionType(dart.void, [T]));
        return new (_EventStreamSubscription$(T))(this[_target], this[_eventType], onData, true);
      }
    }
    _ElementEventStreamImpl[dart.implements] = () => [ElementStream$(T)];
    dart.setSignature(_ElementEventStreamImpl, {
      constructors: () => ({_ElementEventStreamImpl: [_ElementEventStreamImpl$(T), [dart.dynamic, dart.dynamic, dart.dynamic]]}),
      methods: () => ({
        matches: [async.Stream$(T), [core.String]],
        capture: [async.StreamSubscription$(T), [dart.functionType(dart.void, [T])]]
      })
    });
    return _ElementEventStreamImpl;
  });
  let _ElementEventStreamImpl = _ElementEventStreamImpl$();
  let _targetList = Symbol('_targetList');
  let _ElementListEventStreamImpl$ = dart.generic(function(T) {
    class _ElementListEventStreamImpl extends async.Stream$(T) {
      _ElementListEventStreamImpl(targetList, eventType, useCapture) {
        this[_targetList] = targetList;
        this[_eventType] = eventType;
        this[_useCapture] = useCapture;
        super.Stream();
      }
      matches(selector) {
        return dart.as(this.where(dart.fn(event => dart.as(dart.dsend(dart.dload(event, 'target'), 'matchesWithAncestors', selector), core.bool), core.bool, [dart.dynamic])).map(dart.fn(e => {
          dart.dput(e, _selector, selector);
          return e;
        })), async.Stream$(T));
      }
      listen(onData, opts) {
        dart.as(onData, dart.functionType(dart.void, [T]));
        let onError = opts && 'onError' in opts ? opts.onError : null;
        let onDone = opts && 'onDone' in opts ? opts.onDone : null;
        dart.as(onDone, dart.functionType(dart.void, []));
        let cancelOnError = opts && 'cancelOnError' in opts ? opts.cancelOnError : null;
        let pool = new _StreamPool.broadcast();
        for (let target of this[_targetList]) {
          dart.dsend(pool, 'add', new _EventStream(dart.as(target, EventTarget), this[_eventType], this[_useCapture]));
        }
        return dart.as(dart.dsend(dart.dload(pool, 'stream'), 'listen', onData, {onError: onError, onDone: onDone, cancelOnError: cancelOnError}), async.StreamSubscription$(T));
      }
      capture(onData) {
        dart.as(onData, dart.functionType(dart.void, [T]));
        let pool = new _StreamPool.broadcast();
        for (let target of this[_targetList]) {
          dart.dsend(pool, 'add', new _EventStream(dart.as(target, EventTarget), this[_eventType], true));
        }
        return dart.as(dart.dsend(dart.dload(pool, 'stream'), 'listen', onData), async.StreamSubscription$(T));
      }
      asBroadcastStream(opts) {
        let onListen = opts && 'onListen' in opts ? opts.onListen : null;
        dart.as(onListen, dart.functionType(dart.void, [async.StreamSubscription]));
        let onCancel = opts && 'onCancel' in opts ? opts.onCancel : null;
        dart.as(onCancel, dart.functionType(dart.void, [async.StreamSubscription]));
        return this;
      }
      get isBroadcast() {
        return true;
      }
    }
    _ElementListEventStreamImpl[dart.implements] = () => [ElementStream$(T)];
    dart.setSignature(_ElementListEventStreamImpl, {
      constructors: () => ({_ElementListEventStreamImpl: [_ElementListEventStreamImpl$(T), [core.Iterable$(Element), core.String, core.bool]]}),
      methods: () => ({
        matches: [async.Stream$(T), [core.String]],
        listen: [async.StreamSubscription$(T), [dart.functionType(dart.void, [T])], {onError: core.Function, onDone: dart.functionType(dart.void, []), cancelOnError: core.bool}],
        capture: [async.StreamSubscription$(T), [dart.functionType(dart.void, [T])]],
        asBroadcastStream: [async.Stream$(T), [], {onListen: dart.functionType(dart.void, [async.StreamSubscription]), onCancel: dart.functionType(dart.void, [async.StreamSubscription])}]
      })
    });
    return _ElementListEventStreamImpl;
  });
  let _ElementListEventStreamImpl = _ElementListEventStreamImpl$();
  let _onData = Symbol('_onData');
  let _pauseCount = Symbol('_pauseCount');
  let _tryResume = Symbol('_tryResume');
  let _canceled = Symbol('_canceled');
  let _unlisten = Symbol('_unlisten');
  let _EventStreamSubscription$ = dart.generic(function(T) {
    class _EventStreamSubscription extends async.StreamSubscription$(T) {
      _EventStreamSubscription(target, eventType, onData, useCapture) {
        this[_target] = target;
        this[_eventType] = eventType;
        this[_useCapture] = useCapture;
        this[_onData] = _wrapZone(dart.as(onData, __CastType2));
        this[_pauseCount] = 0;
        this[_tryResume]();
      }
      cancel() {
        if (dart.notNull(this[_canceled]))
          return null;
        this[_unlisten]();
        this[_target] = null;
        this[_onData] = null;
        return null;
      }
      get [_canceled]() {
        return this[_target] == null;
      }
      onData(handleData) {
        dart.as(handleData, dart.functionType(dart.void, [T]));
        if (dart.notNull(this[_canceled])) {
          dart.throw(new core.StateError("Subscription has been canceled."));
        }
        this[_unlisten]();
        this[_onData] = _wrapZone(handleData);
        this[_tryResume]();
      }
      onError(handleError) {}
      onDone(handleDone) {
        dart.as(handleDone, dart.functionType(dart.void, []));
      }
      pause(resumeSignal) {
        if (resumeSignal === void 0)
          resumeSignal = null;
        if (dart.notNull(this[_canceled]))
          return;
        this[_pauseCount] = dart.notNull(this[_pauseCount]) + 1;
        this[_unlisten]();
        if (resumeSignal != null) {
          resumeSignal.whenComplete(dart.bind(this, 'resume'));
        }
      }
      get isPaused() {
        return dart.notNull(this[_pauseCount]) > 0;
      }
      resume() {
        if (dart.notNull(this[_canceled]) || !dart.notNull(this.isPaused))
          return;
        this[_pauseCount] = dart.notNull(this[_pauseCount]) - 1;
        this[_tryResume]();
      }
      [_tryResume]() {
        if (this[_onData] != null && !dart.notNull(this.isPaused)) {
          this[_target].addEventListener(this[_eventType], dart.as(this[_onData], EventListener), this[_useCapture]);
        }
      }
      [_unlisten]() {
        if (this[_onData] != null) {
          this[_target].removeEventListener(this[_eventType], dart.as(this[_onData], EventListener), this[_useCapture]);
        }
      }
      asFuture(futureValue) {
        if (futureValue === void 0)
          futureValue = null;
        let completer = async.Completer.new();
        return completer.future;
      }
    }
    dart.setSignature(_EventStreamSubscription, {
      constructors: () => ({_EventStreamSubscription: [_EventStreamSubscription$(T), [EventTarget, core.String, dart.dynamic, core.bool]]}),
      methods: () => ({
        cancel: [async.Future, []],
        onData: [dart.void, [dart.functionType(dart.void, [T])]],
        onError: [dart.void, [core.Function]],
        onDone: [dart.void, [dart.functionType(dart.void, [])]],
        pause: [dart.void, [], [async.Future]],
        resume: [dart.void, []],
        [_tryResume]: [dart.void, []],
        [_unlisten]: [dart.void, []],
        asFuture: [async.Future, [], [dart.dynamic]]
      })
    });
    return _EventStreamSubscription;
  });
  let _EventStreamSubscription = _EventStreamSubscription$();
  let CustomStream$ = dart.generic(function(T) {
    class CustomStream extends core.Object {}
    CustomStream[dart.implements] = () => [async.Stream$(T)];
    return CustomStream;
  });
  let CustomStream = CustomStream$();
  let _streamController = Symbol('_streamController');
  let _type = Symbol('_type');
  let _CustomEventStreamImpl$ = dart.generic(function(T) {
    class _CustomEventStreamImpl extends async.Stream$(T) {
      _CustomEventStreamImpl(type) {
        this[_streamController] = null;
        this[_type] = null;
        super.Stream();
        this[_type] = type;
        this[_streamController] = async.StreamController$(T).broadcast({sync: true});
      }
      listen(onData, opts) {
        dart.as(onData, dart.functionType(dart.void, [T]));
        let onError = opts && 'onError' in opts ? opts.onError : null;
        let onDone = opts && 'onDone' in opts ? opts.onDone : null;
        dart.as(onDone, dart.functionType(dart.void, []));
        let cancelOnError = opts && 'cancelOnError' in opts ? opts.cancelOnError : null;
        return this[_streamController].stream.listen(onData, {onError: onError, onDone: onDone, cancelOnError: cancelOnError});
      }
      asBroadcastStream(opts) {
        let onListen = opts && 'onListen' in opts ? opts.onListen : null;
        dart.as(onListen, dart.functionType(dart.void, [async.StreamSubscription]));
        let onCancel = opts && 'onCancel' in opts ? opts.onCancel : null;
        dart.as(onCancel, dart.functionType(dart.void, [async.StreamSubscription]));
        return this[_streamController].stream;
      }
      get isBroadcast() {
        return true;
      }
      add(event) {
        dart.as(event, T);
        if (event.type == this[_type])
          this[_streamController].add(event);
      }
    }
    _CustomEventStreamImpl[dart.implements] = () => [CustomStream$(T)];
    dart.setSignature(_CustomEventStreamImpl, {
      constructors: () => ({_CustomEventStreamImpl: [_CustomEventStreamImpl$(T), [core.String]]}),
      methods: () => ({
        listen: [async.StreamSubscription$(T), [dart.functionType(dart.void, [T])], {onError: core.Function, onDone: dart.functionType(dart.void, []), cancelOnError: core.bool}],
        asBroadcastStream: [async.Stream$(T), [], {onListen: dart.functionType(dart.void, [async.StreamSubscription]), onCancel: dart.functionType(dart.void, [async.StreamSubscription])}],
        add: [dart.void, [T]]
      })
    });
    return _CustomEventStreamImpl;
  });
  let _CustomEventStreamImpl = _CustomEventStreamImpl$();
  let _shadowKeyCode = Symbol('_shadowKeyCode');
  let _shadowCharCode = Symbol('_shadowCharCode');
  let _shadowAltKey = Symbol('_shadowAltKey');
  let _parent = Symbol('_parent');
  let _realKeyCode = Symbol('_realKeyCode');
  let _realCharCode = Symbol('_realCharCode');
  let _realAltKey = Symbol('_realAltKey');
  let _currentTarget = Symbol('_currentTarget');
  let _shadowKeyIdentifier = Symbol('_shadowKeyIdentifier');
  let _keyIdentifier = Symbol('_keyIdentifier');
  class KeyEvent extends _WrappedEvent {
    get keyCode() {
      return this[_shadowKeyCode];
    }
    get charCode() {
      return this.type == 'keypress' ? this[_shadowCharCode] : 0;
    }
    get altKey() {
      return this[_shadowAltKey];
    }
    get which() {
      return this.keyCode;
    }
    get [_realKeyCode]() {
      return dart.as(this[_parent].keyCode, core.int);
    }
    get [_realCharCode]() {
      return dart.as(this[_parent].charCode, core.int);
    }
    get [_realAltKey]() {
      return dart.as(this[_parent].altKey, core.bool);
    }
    static _makeRecord() {
      let interceptor = _foreign_helper.JS_INTERCEPTOR_CONSTANT(KeyboardEvent);
      return _js_helper.makeLeafDispatchRecord(interceptor);
    }
    wrap(parent) {
      this[_parent] = null;
      this[_shadowAltKey] = null;
      this[_shadowCharCode] = null;
      this[_shadowKeyCode] = null;
      this[_currentTarget] = null;
      super._WrappedEvent(parent);
      this[_parent] = parent;
      this[_shadowAltKey] = this[_realAltKey];
      this[_shadowCharCode] = this[_realCharCode];
      this[_shadowKeyCode] = this[_realKeyCode];
      this[_currentTarget] = this[_parent].currentTarget;
    }
    static new(type, opts) {
      let view = opts && 'view' in opts ? opts.view : null;
      let canBubble = opts && 'canBubble' in opts ? opts.canBubble : true;
      let cancelable = opts && 'cancelable' in opts ? opts.cancelable : true;
      let keyCode = opts && 'keyCode' in opts ? opts.keyCode : 0;
      let charCode = opts && 'charCode' in opts ? opts.charCode : 0;
      let keyLocation = opts && 'keyLocation' in opts ? opts.keyLocation : 1;
      let ctrlKey = opts && 'ctrlKey' in opts ? opts.ctrlKey : false;
      let altKey = opts && 'altKey' in opts ? opts.altKey : false;
      let shiftKey = opts && 'shiftKey' in opts ? opts.shiftKey : false;
      let metaKey = opts && 'metaKey' in opts ? opts.metaKey : false;
      let currentTarget = opts && 'currentTarget' in opts ? opts.currentTarget : null;
      if (view == null) {
        view = exports.window;
      }
      let eventObj = null;
      if (dart.notNull(KeyEvent.canUseDispatchEvent)) {
        eventObj = Event.eventType('Event', type, {canBubble: canBubble, cancelable: cancelable});
        eventObj.keyCode = keyCode;
        eventObj.which = keyCode;
        eventObj.charCode = charCode;
        eventObj.keyLocation = keyLocation;
        eventObj.ctrlKey = ctrlKey;
        eventObj.altKey = altKey;
        eventObj.shiftKey = shiftKey;
        eventObj.metaKey = metaKey;
      } else {
        eventObj = Event.eventType('KeyboardEvent', type, {canBubble: canBubble, cancelable: cancelable});
        Object.defineProperty(eventObj, 'keyCode', {
          get: function() {
            return this.keyCodeVal;
          }
        });
        Object.defineProperty(eventObj, 'which', {
          get: function() {
            return this.keyCodeVal;
          }
        });
        Object.defineProperty(eventObj, 'charCode', {
          get: function() {
            return this.charCodeVal;
          }
        });
        let keyIdentifier = KeyEvent._convertToHexString(charCode, keyCode);
        dart.dsend(eventObj, _initKeyboardEvent, type, canBubble, cancelable, view, keyIdentifier, keyLocation, ctrlKey, altKey, shiftKey, metaKey);
        eventObj.keyCodeVal = keyCode;
        eventObj.charCodeVal = charCode;
      }
      _interceptors.setDispatchProperty(eventObj, KeyEvent._keyboardEventDispatchRecord);
      let keyEvent = new KeyEvent.wrap(dart.as(eventObj, KeyboardEvent));
      if (dart.dload(keyEvent, _currentTarget) == null) {
        dart.dput(keyEvent, _currentTarget, currentTarget == null ? exports.window : currentTarget);
      }
      return dart.as(keyEvent, KeyEvent);
    }
    static get canUseDispatchEvent() {
      return dart.as(typeof document.body.dispatchEvent == "function" && document.body.dispatchEvent.length > 0, core.bool);
    }
    get currentTarget() {
      return this[_currentTarget];
    }
    static _convertToHexString(charCode, keyCode) {
      if (charCode != -1) {
        let hex = charCode[dartx.toRadixString](16);
        let sb = new core.StringBuffer('U+');
        for (let i = 0; dart.notNull(i) < 4 - dart.notNull(dart.as(dart.dload(hex, 'length'), core.num)); i = dart.notNull(i) + 1)
          sb.write('0');
        sb.write(hex);
        return dart.toString(sb);
      } else {
        return KeyCode._convertKeyCodeToKeyName(keyCode);
      }
    }
    get clipboardData() {
      return this[_parent].clipboardData;
    }
    get ctrlKey() {
      return this[_parent].ctrlKey;
    }
    get detail() {
      return this[_parent].detail;
    }
    get keyLocation() {
      return this[_parent].keyLocation;
    }
    get layer() {
      return this[_parent].layer;
    }
    get metaKey() {
      return this[_parent].metaKey;
    }
    get page() {
      return this[_parent].page;
    }
    get shiftKey() {
      return this[_parent].shiftKey;
    }
    get view() {
      return dart.as(this[_parent].view, Window);
    }
    [_initUIEvent](type, canBubble, cancelable, view, detail) {
      dart.throw(new core.UnsupportedError("Cannot initialize a UI Event from a KeyEvent."));
    }
    get [_shadowKeyIdentifier]() {
      return dart.as(this[_parent].keyIdentifier, core.String);
    }
    get [_charCode]() {
      return this.charCode;
    }
    get [_keyCode]() {
      return this.keyCode;
    }
    get [_keyIdentifier]() {
      dart.throw(new core.UnsupportedError("keyIdentifier is unsupported."));
    }
    [_initKeyboardEvent](type, canBubble, cancelable, view, keyIdentifier, keyLocation, ctrlKey, altKey, shiftKey, metaKey) {
      dart.throw(new core.UnsupportedError("Cannot initialize a KeyboardEvent from a KeyEvent."));
    }
    get [_layerX]() {
      return dart.throw(new core.UnsupportedError('Not applicable to KeyEvent'));
    }
    get [_layerY]() {
      return dart.throw(new core.UnsupportedError('Not applicable to KeyEvent'));
    }
    get [_pageX]() {
      return dart.throw(new core.UnsupportedError('Not applicable to KeyEvent'));
    }
    get [_pageY]() {
      return dart.throw(new core.UnsupportedError('Not applicable to KeyEvent'));
    }
    getModifierState(keyArgument) {
      return dart.throw(new core.UnimplementedError());
    }
    get location() {
      return dart.throw(new core.UnimplementedError());
    }
    get repeat() {
      return dart.throw(new core.UnimplementedError());
    }
    get [_get_view]() {
      return dart.throw(new core.UnimplementedError());
    }
  }
  KeyEvent[dart.implements] = () => [KeyboardEvent];
  dart.defineNamedConstructor(KeyEvent, 'wrap');
  dart.setSignature(KeyEvent, {
    constructors: () => ({
      wrap: [KeyEvent, [KeyboardEvent]],
      new: [KeyEvent, [core.String], {view: Window, canBubble: core.bool, cancelable: core.bool, keyCode: core.int, charCode: core.int, keyLocation: core.int, ctrlKey: core.bool, altKey: core.bool, shiftKey: core.bool, metaKey: core.bool, currentTarget: EventTarget}]
    }),
    methods: () => ({
      [_initUIEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.int]],
      [_initKeyboardEvent]: [dart.void, [core.String, core.bool, core.bool, Window, core.String, core.int, core.bool, core.bool, core.bool, core.bool]],
      getModifierState: [core.bool, [core.String]]
    }),
    statics: () => ({
      _makeRecord: [dart.dynamic, []],
      _convertToHexString: [core.String, [core.int, core.int]]
    }),
    names: ['_makeRecord', '_convertToHexString']
  });
  KeyEvent[dart.metadata] = () => [dart.const(new _metadata.Experimental())];
  class _CustomKeyEventStreamImpl extends _CustomEventStreamImpl$(KeyEvent) {
    _CustomKeyEventStreamImpl(type) {
      super._CustomEventStreamImpl(type);
    }
    add(event) {
      if (event.type == this[_type]) {
        event.currentTarget.dispatchEvent(event[_parent]);
        this[_streamController].add(event);
      }
    }
  }
  _CustomKeyEventStreamImpl[dart.implements] = () => [CustomStream$(KeyEvent)];
  dart.setSignature(_CustomKeyEventStreamImpl, {
    constructors: () => ({_CustomKeyEventStreamImpl: [_CustomKeyEventStreamImpl, [core.String]]}),
    methods: () => ({add: [dart.void, [KeyEvent]]})
  });
  let _subscriptions = Symbol('_subscriptions');
  let _controller = Symbol('_controller');
  let _StreamPool$ = dart.generic(function(T) {
    class _StreamPool extends core.Object {
      broadcast() {
        this[_subscriptions] = core.Map$(async.Stream$(T), async.StreamSubscription$(T)).new();
        this[_controller] = null;
        this[_controller] = async.StreamController$(T).broadcast({sync: true, onCancel: dart.bind(this, 'close')});
      }
      get stream() {
        return this[_controller].stream;
      }
      add(stream) {
        dart.as(stream, async.Stream$(T));
        if (dart.notNull(this[_subscriptions].containsKey(stream)))
          return;
        this[_subscriptions].set(stream, stream.listen(dart.bind(this[_controller], 'add'), {onError: dart.bind(this[_controller], 'addError'), onDone: dart.fn(() => this.remove(stream), dart.void, [])}));
      }
      remove(stream) {
        dart.as(stream, async.Stream$(T));
        let subscription = this[_subscriptions].remove(stream);
        if (subscription != null)
          dart.dsend(subscription, 'cancel');
      }
      close() {
        for (let subscription of this[_subscriptions].values) {
          dart.dsend(subscription, 'cancel');
        }
        this[_subscriptions].clear();
        this[_controller].close();
      }
    }
    dart.defineNamedConstructor(_StreamPool, 'broadcast');
    dart.setSignature(_StreamPool, {
      constructors: () => ({broadcast: [_StreamPool$(T), []]}),
      methods: () => ({
        add: [dart.void, [async.Stream$(T)]],
        remove: [dart.void, [async.Stream$(T)]],
        close: [dart.void, []]
      })
    });
    return _StreamPool;
  });
  let _StreamPool = _StreamPool$();
  class _Html5NodeValidator extends core.Object {
    _Html5NodeValidator(opts) {
      let uriPolicy = opts && 'uriPolicy' in opts ? opts.uriPolicy : null;
      this.uriPolicy = uriPolicy != null ? uriPolicy : UriPolicy.new();
      if (dart.notNull(_Html5NodeValidator._attributeValidators.isEmpty)) {
        for (let attr of dart.as(_Html5NodeValidator._standardAttributes, core.Iterable)) {
          _Html5NodeValidator._attributeValidators.set(dart.as(attr, core.String), _Html5NodeValidator._standardAttributeValidator);
        }
        for (let attr of dart.as(_Html5NodeValidator._uriAttributes, core.Iterable)) {
          _Html5NodeValidator._attributeValidators.set(dart.as(attr, core.String), _Html5NodeValidator._uriAttributeValidator);
        }
      }
    }
    allowsElement(element) {
      return _Html5NodeValidator._allowedElements.contains(element.tagName);
    }
    allowsAttribute(element, attributeName, value) {
      let tagName = element.tagName;
      let validator = _Html5NodeValidator._attributeValidators.get(`${tagName}::${attributeName}`);
      if (validator == null) {
        validator = _Html5NodeValidator._attributeValidators.get(`*::${attributeName}`);
      }
      if (validator == null) {
        return false;
      }
      return dart.as(dart.dcall(validator, element, attributeName, value, this), core.bool);
    }
    static _standardAttributeValidator(element, attributeName, value, context) {
      return true;
    }
    static _uriAttributeValidator(element, attributeName, value, context) {
      return context.uriPolicy.allowsUri(value);
    }
  }
  _Html5NodeValidator[dart.implements] = () => [NodeValidator];
  dart.setSignature(_Html5NodeValidator, {
    constructors: () => ({_Html5NodeValidator: [_Html5NodeValidator, [], {uriPolicy: UriPolicy}]}),
    methods: () => ({
      allowsElement: [core.bool, [Element]],
      allowsAttribute: [core.bool, [Element, core.String, core.String]]
    }),
    statics: () => ({
      _standardAttributeValidator: [core.bool, [Element, core.String, core.String, _Html5NodeValidator]],
      _uriAttributeValidator: [core.bool, [Element, core.String, core.String, _Html5NodeValidator]]
    }),
    names: ['_standardAttributeValidator', '_uriAttributeValidator']
  });
  _Html5NodeValidator._standardAttributes = dart.const(dart.list(['*::class', '*::dir', '*::draggable', '*::hidden', '*::id', '*::inert', '*::itemprop', '*::itemref', '*::itemscope', '*::lang', '*::spellcheck', '*::title', '*::translate', 'A::accesskey', 'A::coords', 'A::hreflang', 'A::name', 'A::shape', 'A::tabindex', 'A::target', 'A::type', 'AREA::accesskey', 'AREA::alt', 'AREA::coords', 'AREA::nohref', 'AREA::shape', 'AREA::tabindex', 'AREA::target', 'AUDIO::controls', 'AUDIO::loop', 'AUDIO::mediagroup', 'AUDIO::muted', 'AUDIO::preload', 'BDO::dir', 'BODY::alink', 'BODY::bgcolor', 'BODY::link', 'BODY::text', 'BODY::vlink', 'BR::clear', 'BUTTON::accesskey', 'BUTTON::disabled', 'BUTTON::name', 'BUTTON::tabindex', 'BUTTON::type', 'BUTTON::value', 'CANVAS::height', 'CANVAS::width', 'CAPTION::align', 'COL::align', 'COL::char', 'COL::charoff', 'COL::span', 'COL::valign', 'COL::width', 'COLGROUP::align', 'COLGROUP::char', 'COLGROUP::charoff', 'COLGROUP::span', 'COLGROUP::valign', 'COLGROUP::width', 'COMMAND::checked', 'COMMAND::command', 'COMMAND::disabled', 'COMMAND::label', 'COMMAND::radiogroup', 'COMMAND::type', 'DATA::value', 'DEL::datetime', 'DETAILS::open', 'DIR::compact', 'DIV::align', 'DL::compact', 'FIELDSET::disabled', 'FONT::color', 'FONT::face', 'FONT::size', 'FORM::accept', 'FORM::autocomplete', 'FORM::enctype', 'FORM::method', 'FORM::name', 'FORM::novalidate', 'FORM::target', 'FRAME::name', 'H1::align', 'H2::align', 'H3::align', 'H4::align', 'H5::align', 'H6::align', 'HR::align', 'HR::noshade', 'HR::size', 'HR::width', 'HTML::version', 'IFRAME::align', 'IFRAME::frameborder', 'IFRAME::height', 'IFRAME::marginheight', 'IFRAME::marginwidth', 'IFRAME::width', 'IMG::align', 'IMG::alt', 'IMG::border', 'IMG::height', 'IMG::hspace', 'IMG::ismap', 'IMG::name', 'IMG::usemap', 'IMG::vspace', 'IMG::width', 'INPUT::accept', 'INPUT::accesskey', 'INPUT::align', 'INPUT::alt', 'INPUT::autocomplete', 'INPUT::checked', 'INPUT::disabled', 'INPUT::inputmode', 'INPUT::ismap', 'INPUT::list', 'INPUT::max', 'INPUT::maxlength', 'INPUT::min', 'INPUT::multiple', 'INPUT::name', 'INPUT::placeholder', 'INPUT::readonly', 'INPUT::required', 'INPUT::size', 'INPUT::step', 'INPUT::tabindex', 'INPUT::type', 'INPUT::usemap', 'INPUT::value', 'INS::datetime', 'KEYGEN::disabled', 'KEYGEN::keytype', 'KEYGEN::name', 'LABEL::accesskey', 'LABEL::for', 'LEGEND::accesskey', 'LEGEND::align', 'LI::type', 'LI::value', 'LINK::sizes', 'MAP::name', 'MENU::compact', 'MENU::label', 'MENU::type', 'METER::high', 'METER::low', 'METER::max', 'METER::min', 'METER::value', 'OBJECT::typemustmatch', 'OL::compact', 'OL::reversed', 'OL::start', 'OL::type', 'OPTGROUP::disabled', 'OPTGROUP::label', 'OPTION::disabled', 'OPTION::label', 'OPTION::selected', 'OPTION::value', 'OUTPUT::for', 'OUTPUT::name', 'P::align', 'PRE::width', 'PROGRESS::max', 'PROGRESS::min', 'PROGRESS::value', 'SELECT::autocomplete', 'SELECT::disabled', 'SELECT::multiple', 'SELECT::name', 'SELECT::required', 'SELECT::size', 'SELECT::tabindex', 'SOURCE::type', 'TABLE::align', 'TABLE::bgcolor', 'TABLE::border', 'TABLE::cellpadding', 'TABLE::cellspacing', 'TABLE::frame', 'TABLE::rules', 'TABLE::summary', 'TABLE::width', 'TBODY::align', 'TBODY::char', 'TBODY::charoff', 'TBODY::valign', 'TD::abbr', 'TD::align', 'TD::axis', 'TD::bgcolor', 'TD::char', 'TD::charoff', 'TD::colspan', 'TD::headers', 'TD::height', 'TD::nowrap', 'TD::rowspan', 'TD::scope', 'TD::valign', 'TD::width', 'TEXTAREA::accesskey', 'TEXTAREA::autocomplete', 'TEXTAREA::cols', 'TEXTAREA::disabled', 'TEXTAREA::inputmode', 'TEXTAREA::name', 'TEXTAREA::placeholder', 'TEXTAREA::readonly', 'TEXTAREA::required', 'TEXTAREA::rows', 'TEXTAREA::tabindex', 'TEXTAREA::wrap', 'TFOOT::align', 'TFOOT::char', 'TFOOT::charoff', 'TFOOT::valign', 'TH::abbr', 'TH::align', 'TH::axis', 'TH::bgcolor', 'TH::char', 'TH::charoff', 'TH::colspan', 'TH::headers', 'TH::height', 'TH::nowrap', 'TH::rowspan', 'TH::scope', 'TH::valign', 'TH::width', 'THEAD::align', 'THEAD::char', 'THEAD::charoff', 'THEAD::valign', 'TR::align', 'TR::bgcolor', 'TR::char', 'TR::charoff', 'TR::valign', 'TRACK::default', 'TRACK::kind', 'TRACK::label', 'TRACK::srclang', 'UL::compact', 'UL::type', 'VIDEO::controls', 'VIDEO::height', 'VIDEO::loop', 'VIDEO::mediagroup', 'VIDEO::muted', 'VIDEO::preload', 'VIDEO::width'], core.String));
  _Html5NodeValidator._uriAttributes = dart.const(dart.list(['A::href', 'AREA::href', 'BLOCKQUOTE::cite', 'BODY::background', 'COMMAND::icon', 'DEL::cite', 'FORM::action', 'IMG::src', 'INPUT::src', 'INS::cite', 'Q::cite', 'VIDEO::poster'], core.String));
  dart.defineLazyProperties(_Html5NodeValidator, {
    get _allowedElements() {
      return core.Set$(core.String).from(['A', 'ABBR', 'ACRONYM', 'ADDRESS', 'AREA', 'ARTICLE', 'ASIDE', 'AUDIO', 'B', 'BDI', 'BDO', 'BIG', 'BLOCKQUOTE', 'BR', 'BUTTON', 'CANVAS', 'CAPTION', 'CENTER', 'CITE', 'CODE', 'COL', 'COLGROUP', 'COMMAND', 'DATA', 'DATALIST', 'DD', 'DEL', 'DETAILS', 'DFN', 'DIR', 'DIV', 'DL', 'DT', 'EM', 'FIELDSET', 'FIGCAPTION', 'FIGURE', 'FONT', 'FOOTER', 'FORM', 'H1', 'H2', 'H3', 'H4', 'H5', 'H6', 'HEADER', 'HGROUP', 'HR', 'I', 'IFRAME', 'IMG', 'INPUT', 'INS', 'KBD', 'LABEL', 'LEGEND', 'LI', 'MAP', 'MARK', 'MENU', 'METER', 'NAV', 'NOBR', 'OL', 'OPTGROUP', 'OPTION', 'OUTPUT', 'P', 'PRE', 'PROGRESS', 'Q', 'S', 'SAMP', 'SECTION', 'SELECT', 'SMALL', 'SOURCE', 'SPAN', 'STRIKE', 'STRONG', 'SUB', 'SUMMARY', 'SUP', 'TABLE', 'TBODY', 'TD', 'TEXTAREA', 'TFOOT', 'TH', 'THEAD', 'TIME', 'TR', 'TRACK', 'TT', 'U', 'UL', 'VAR', 'VIDEO', 'WBR']);
    },
    get _attributeValidators() {
      return dart.map();
    }
  });
  class KeyCode extends core.Object {
    static isCharacterKey(keyCode) {
      if (dart.notNull(keyCode) >= dart.notNull(KeyCode.ZERO) && dart.notNull(keyCode) <= dart.notNull(KeyCode.NINE) || dart.notNull(keyCode) >= dart.notNull(KeyCode.NUM_ZERO) && dart.notNull(keyCode) <= dart.notNull(KeyCode.NUM_MULTIPLY) || dart.notNull(keyCode) >= dart.notNull(KeyCode.A) && dart.notNull(keyCode) <= dart.notNull(KeyCode.Z)) {
        return true;
      }
      if (dart.notNull(html_common.Device.isWebKit) && keyCode == 0) {
        return true;
      }
      return keyCode == KeyCode.SPACE || keyCode == KeyCode.QUESTION_MARK || keyCode == KeyCode.NUM_PLUS || keyCode == KeyCode.NUM_MINUS || keyCode == KeyCode.NUM_PERIOD || keyCode == KeyCode.NUM_DIVISION || keyCode == KeyCode.SEMICOLON || keyCode == KeyCode.FF_SEMICOLON || keyCode == KeyCode.DASH || keyCode == KeyCode.EQUALS || keyCode == KeyCode.FF_EQUALS || keyCode == KeyCode.COMMA || keyCode == KeyCode.PERIOD || keyCode == KeyCode.SLASH || keyCode == KeyCode.APOSTROPHE || keyCode == KeyCode.SINGLE_QUOTE || keyCode == KeyCode.OPEN_SQUARE_BRACKET || keyCode == KeyCode.BACKSLASH || keyCode == KeyCode.CLOSE_SQUARE_BRACKET;
    }
    static _convertKeyCodeToKeyName(keyCode) {
      switch (keyCode) {
        case KeyCode.ALT:
        {
          return _KeyName.ALT;
        }
        case KeyCode.BACKSPACE:
        {
          return _KeyName.BACKSPACE;
        }
        case KeyCode.CAPS_LOCK:
        {
          return _KeyName.CAPS_LOCK;
        }
        case KeyCode.CTRL:
        {
          return _KeyName.CONTROL;
        }
        case KeyCode.DELETE:
        {
          return _KeyName.DEL;
        }
        case KeyCode.DOWN:
        {
          return _KeyName.DOWN;
        }
        case KeyCode.END:
        {
          return _KeyName.END;
        }
        case KeyCode.ENTER:
        {
          return _KeyName.ENTER;
        }
        case KeyCode.ESC:
        {
          return _KeyName.ESC;
        }
        case KeyCode.F1:
        {
          return _KeyName.F1;
        }
        case KeyCode.F2:
        {
          return _KeyName.F2;
        }
        case KeyCode.F3:
        {
          return _KeyName.F3;
        }
        case KeyCode.F4:
        {
          return _KeyName.F4;
        }
        case KeyCode.F5:
        {
          return _KeyName.F5;
        }
        case KeyCode.F6:
        {
          return _KeyName.F6;
        }
        case KeyCode.F7:
        {
          return _KeyName.F7;
        }
        case KeyCode.F8:
        {
          return _KeyName.F8;
        }
        case KeyCode.F9:
        {
          return _KeyName.F9;
        }
        case KeyCode.F10:
        {
          return _KeyName.F10;
        }
        case KeyCode.F11:
        {
          return _KeyName.F11;
        }
        case KeyCode.F12:
        {
          return _KeyName.F12;
        }
        case KeyCode.HOME:
        {
          return _KeyName.HOME;
        }
        case KeyCode.INSERT:
        {
          return _KeyName.INSERT;
        }
        case KeyCode.LEFT:
        {
          return _KeyName.LEFT;
        }
        case KeyCode.META:
        {
          return _KeyName.META;
        }
        case KeyCode.NUMLOCK:
        {
          return _KeyName.NUM_LOCK;
        }
        case KeyCode.PAGE_DOWN:
        {
          return _KeyName.PAGE_DOWN;
        }
        case KeyCode.PAGE_UP:
        {
          return _KeyName.PAGE_UP;
        }
        case KeyCode.PAUSE:
        {
          return _KeyName.PAUSE;
        }
        case KeyCode.PRINT_SCREEN:
        {
          return _KeyName.PRINT_SCREEN;
        }
        case KeyCode.RIGHT:
        {
          return _KeyName.RIGHT;
        }
        case KeyCode.SCROLL_LOCK:
        {
          return _KeyName.SCROLL;
        }
        case KeyCode.SHIFT:
        {
          return _KeyName.SHIFT;
        }
        case KeyCode.SPACE:
        {
          return _KeyName.SPACEBAR;
        }
        case KeyCode.TAB:
        {
          return _KeyName.TAB;
        }
        case KeyCode.UP:
        {
          return _KeyName.UP;
        }
        case KeyCode.WIN_IME:
        case KeyCode.WIN_KEY:
        case KeyCode.WIN_KEY_LEFT:
        case KeyCode.WIN_KEY_RIGHT:
        {
          return _KeyName.WIN;
        }
        default:
        {
          return _KeyName.UNIDENTIFIED;
        }
      }
      return _KeyName.UNIDENTIFIED;
    }
  }
  dart.setSignature(KeyCode, {
    statics: () => ({
      isCharacterKey: [core.bool, [core.int]],
      _convertKeyCodeToKeyName: [core.String, [core.int]]
    }),
    names: ['isCharacterKey', '_convertKeyCodeToKeyName']
  });
  KeyCode.WIN_KEY_FF_LINUX = 0;
  KeyCode.MAC_ENTER = 3;
  KeyCode.BACKSPACE = 8;
  KeyCode.TAB = 9;
  KeyCode.NUM_CENTER = 12;
  KeyCode.ENTER = 13;
  KeyCode.SHIFT = 16;
  KeyCode.CTRL = 17;
  KeyCode.ALT = 18;
  KeyCode.PAUSE = 19;
  KeyCode.CAPS_LOCK = 20;
  KeyCode.ESC = 27;
  KeyCode.SPACE = 32;
  KeyCode.PAGE_UP = 33;
  KeyCode.PAGE_DOWN = 34;
  KeyCode.END = 35;
  KeyCode.HOME = 36;
  KeyCode.LEFT = 37;
  KeyCode.UP = 38;
  KeyCode.RIGHT = 39;
  KeyCode.DOWN = 40;
  KeyCode.NUM_NORTH_EAST = 33;
  KeyCode.NUM_SOUTH_EAST = 34;
  KeyCode.NUM_SOUTH_WEST = 35;
  KeyCode.NUM_NORTH_WEST = 36;
  KeyCode.NUM_WEST = 37;
  KeyCode.NUM_NORTH = 38;
  KeyCode.NUM_EAST = 39;
  KeyCode.NUM_SOUTH = 40;
  KeyCode.PRINT_SCREEN = 44;
  KeyCode.INSERT = 45;
  KeyCode.NUM_INSERT = 45;
  KeyCode.DELETE = 46;
  KeyCode.NUM_DELETE = 46;
  KeyCode.ZERO = 48;
  KeyCode.ONE = 49;
  KeyCode.TWO = 50;
  KeyCode.THREE = 51;
  KeyCode.FOUR = 52;
  KeyCode.FIVE = 53;
  KeyCode.SIX = 54;
  KeyCode.SEVEN = 55;
  KeyCode.EIGHT = 56;
  KeyCode.NINE = 57;
  KeyCode.FF_SEMICOLON = 59;
  KeyCode.FF_EQUALS = 61;
  KeyCode.QUESTION_MARK = 63;
  KeyCode.A = 65;
  KeyCode.B = 66;
  KeyCode.C = 67;
  KeyCode.D = 68;
  KeyCode.E = 69;
  KeyCode.F = 70;
  KeyCode.G = 71;
  KeyCode.H = 72;
  KeyCode.I = 73;
  KeyCode.J = 74;
  KeyCode.K = 75;
  KeyCode.L = 76;
  KeyCode.M = 77;
  KeyCode.N = 78;
  KeyCode.O = 79;
  KeyCode.P = 80;
  KeyCode.Q = 81;
  KeyCode.R = 82;
  KeyCode.S = 83;
  KeyCode.T = 84;
  KeyCode.U = 85;
  KeyCode.V = 86;
  KeyCode.W = 87;
  KeyCode.X = 88;
  KeyCode.Y = 89;
  KeyCode.Z = 90;
  KeyCode.META = 91;
  KeyCode.WIN_KEY_LEFT = 91;
  KeyCode.WIN_KEY_RIGHT = 92;
  KeyCode.CONTEXT_MENU = 93;
  KeyCode.NUM_ZERO = 96;
  KeyCode.NUM_ONE = 97;
  KeyCode.NUM_TWO = 98;
  KeyCode.NUM_THREE = 99;
  KeyCode.NUM_FOUR = 100;
  KeyCode.NUM_FIVE = 101;
  KeyCode.NUM_SIX = 102;
  KeyCode.NUM_SEVEN = 103;
  KeyCode.NUM_EIGHT = 104;
  KeyCode.NUM_NINE = 105;
  KeyCode.NUM_MULTIPLY = 106;
  KeyCode.NUM_PLUS = 107;
  KeyCode.NUM_MINUS = 109;
  KeyCode.NUM_PERIOD = 110;
  KeyCode.NUM_DIVISION = 111;
  KeyCode.F1 = 112;
  KeyCode.F2 = 113;
  KeyCode.F3 = 114;
  KeyCode.F4 = 115;
  KeyCode.F5 = 116;
  KeyCode.F6 = 117;
  KeyCode.F7 = 118;
  KeyCode.F8 = 119;
  KeyCode.F9 = 120;
  KeyCode.F10 = 121;
  KeyCode.F11 = 122;
  KeyCode.F12 = 123;
  KeyCode.NUMLOCK = 144;
  KeyCode.SCROLL_LOCK = 145;
  KeyCode.FIRST_MEDIA_KEY = 166;
  KeyCode.LAST_MEDIA_KEY = 183;
  KeyCode.SEMICOLON = 186;
  KeyCode.DASH = 189;
  KeyCode.EQUALS = 187;
  KeyCode.COMMA = 188;
  KeyCode.PERIOD = 190;
  KeyCode.SLASH = 191;
  KeyCode.APOSTROPHE = 192;
  KeyCode.TILDE = 192;
  KeyCode.SINGLE_QUOTE = 222;
  KeyCode.OPEN_SQUARE_BRACKET = 219;
  KeyCode.BACKSLASH = 220;
  KeyCode.CLOSE_SQUARE_BRACKET = 221;
  KeyCode.WIN_KEY = 224;
  KeyCode.MAC_FF_META = 224;
  KeyCode.WIN_IME = 229;
  KeyCode.UNKNOWN = -1;
  class KeyLocation extends core.Object {}
  KeyLocation.STANDARD = 0;
  KeyLocation.LEFT = 1;
  KeyLocation.RIGHT = 2;
  KeyLocation.NUMPAD = 3;
  KeyLocation.MOBILE = 4;
  KeyLocation.JOYSTICK = 5;
  class _KeyName extends core.Object {}
  _KeyName.ACCEPT = "Accept";
  _KeyName.ADD = "Add";
  _KeyName.AGAIN = "Again";
  _KeyName.ALL_CANDIDATES = "AllCandidates";
  _KeyName.ALPHANUMERIC = "Alphanumeric";
  _KeyName.ALT = "Alt";
  _KeyName.ALT_GRAPH = "AltGraph";
  _KeyName.APPS = "Apps";
  _KeyName.ATTN = "Attn";
  _KeyName.BROWSER_BACK = "BrowserBack";
  _KeyName.BROWSER_FAVORTIES = "BrowserFavorites";
  _KeyName.BROWSER_FORWARD = "BrowserForward";
  _KeyName.BROWSER_NAME = "BrowserHome";
  _KeyName.BROWSER_REFRESH = "BrowserRefresh";
  _KeyName.BROWSER_SEARCH = "BrowserSearch";
  _KeyName.BROWSER_STOP = "BrowserStop";
  _KeyName.CAMERA = "Camera";
  _KeyName.CAPS_LOCK = "CapsLock";
  _KeyName.CLEAR = "Clear";
  _KeyName.CODE_INPUT = "CodeInput";
  _KeyName.COMPOSE = "Compose";
  _KeyName.CONTROL = "Control";
  _KeyName.CRSEL = "Crsel";
  _KeyName.CONVERT = "Convert";
  _KeyName.COPY = "Copy";
  _KeyName.CUT = "Cut";
  _KeyName.DECIMAL = "Decimal";
  _KeyName.DIVIDE = "Divide";
  _KeyName.DOWN = "Down";
  _KeyName.DOWN_LEFT = "DownLeft";
  _KeyName.DOWN_RIGHT = "DownRight";
  _KeyName.EJECT = "Eject";
  _KeyName.END = "End";
  _KeyName.ENTER = "Enter";
  _KeyName.ERASE_EOF = "EraseEof";
  _KeyName.EXECUTE = "Execute";
  _KeyName.EXSEL = "Exsel";
  _KeyName.FN = "Fn";
  _KeyName.F1 = "F1";
  _KeyName.F2 = "F2";
  _KeyName.F3 = "F3";
  _KeyName.F4 = "F4";
  _KeyName.F5 = "F5";
  _KeyName.F6 = "F6";
  _KeyName.F7 = "F7";
  _KeyName.F8 = "F8";
  _KeyName.F9 = "F9";
  _KeyName.F10 = "F10";
  _KeyName.F11 = "F11";
  _KeyName.F12 = "F12";
  _KeyName.F13 = "F13";
  _KeyName.F14 = "F14";
  _KeyName.F15 = "F15";
  _KeyName.F16 = "F16";
  _KeyName.F17 = "F17";
  _KeyName.F18 = "F18";
  _KeyName.F19 = "F19";
  _KeyName.F20 = "F20";
  _KeyName.F21 = "F21";
  _KeyName.F22 = "F22";
  _KeyName.F23 = "F23";
  _KeyName.F24 = "F24";
  _KeyName.FINAL_MODE = "FinalMode";
  _KeyName.FIND = "Find";
  _KeyName.FULL_WIDTH = "FullWidth";
  _KeyName.HALF_WIDTH = "HalfWidth";
  _KeyName.HANGUL_MODE = "HangulMode";
  _KeyName.HANJA_MODE = "HanjaMode";
  _KeyName.HELP = "Help";
  _KeyName.HIRAGANA = "Hiragana";
  _KeyName.HOME = "Home";
  _KeyName.INSERT = "Insert";
  _KeyName.JAPANESE_HIRAGANA = "JapaneseHiragana";
  _KeyName.JAPANESE_KATAKANA = "JapaneseKatakana";
  _KeyName.JAPANESE_ROMAJI = "JapaneseRomaji";
  _KeyName.JUNJA_MODE = "JunjaMode";
  _KeyName.KANA_MODE = "KanaMode";
  _KeyName.KANJI_MODE = "KanjiMode";
  _KeyName.KATAKANA = "Katakana";
  _KeyName.LAUNCH_APPLICATION_1 = "LaunchApplication1";
  _KeyName.LAUNCH_APPLICATION_2 = "LaunchApplication2";
  _KeyName.LAUNCH_MAIL = "LaunchMail";
  _KeyName.LEFT = "Left";
  _KeyName.MENU = "Menu";
  _KeyName.META = "Meta";
  _KeyName.MEDIA_NEXT_TRACK = "MediaNextTrack";
  _KeyName.MEDIA_PAUSE_PLAY = "MediaPlayPause";
  _KeyName.MEDIA_PREVIOUS_TRACK = "MediaPreviousTrack";
  _KeyName.MEDIA_STOP = "MediaStop";
  _KeyName.MODE_CHANGE = "ModeChange";
  _KeyName.NEXT_CANDIDATE = "NextCandidate";
  _KeyName.NON_CONVERT = "Nonconvert";
  _KeyName.NUM_LOCK = "NumLock";
  _KeyName.PAGE_DOWN = "PageDown";
  _KeyName.PAGE_UP = "PageUp";
  _KeyName.PASTE = "Paste";
  _KeyName.PAUSE = "Pause";
  _KeyName.PLAY = "Play";
  _KeyName.POWER = "Power";
  _KeyName.PREVIOUS_CANDIDATE = "PreviousCandidate";
  _KeyName.PRINT_SCREEN = "PrintScreen";
  _KeyName.PROCESS = "Process";
  _KeyName.PROPS = "Props";
  _KeyName.RIGHT = "Right";
  _KeyName.ROMAN_CHARACTERS = "RomanCharacters";
  _KeyName.SCROLL = "Scroll";
  _KeyName.SELECT = "Select";
  _KeyName.SELECT_MEDIA = "SelectMedia";
  _KeyName.SEPARATOR = "Separator";
  _KeyName.SHIFT = "Shift";
  _KeyName.SOFT_1 = "Soft1";
  _KeyName.SOFT_2 = "Soft2";
  _KeyName.SOFT_3 = "Soft3";
  _KeyName.SOFT_4 = "Soft4";
  _KeyName.STOP = "Stop";
  _KeyName.SUBTRACT = "Subtract";
  _KeyName.SYMBOL_LOCK = "SymbolLock";
  _KeyName.UP = "Up";
  _KeyName.UP_LEFT = "UpLeft";
  _KeyName.UP_RIGHT = "UpRight";
  _KeyName.UNDO = "Undo";
  _KeyName.VOLUME_DOWN = "VolumeDown";
  _KeyName.VOLUMN_MUTE = "VolumeMute";
  _KeyName.VOLUMN_UP = "VolumeUp";
  _KeyName.WIN = "Win";
  _KeyName.ZOOM = "Zoom";
  _KeyName.BACKSPACE = "Backspace";
  _KeyName.TAB = "Tab";
  _KeyName.CANCEL = "Cancel";
  _KeyName.ESC = "Esc";
  _KeyName.SPACEBAR = "Spacebar";
  _KeyName.DEL = "Del";
  _KeyName.DEAD_GRAVE = "DeadGrave";
  _KeyName.DEAD_EACUTE = "DeadEacute";
  _KeyName.DEAD_CIRCUMFLEX = "DeadCircumflex";
  _KeyName.DEAD_TILDE = "DeadTilde";
  _KeyName.DEAD_MACRON = "DeadMacron";
  _KeyName.DEAD_BREVE = "DeadBreve";
  _KeyName.DEAD_ABOVE_DOT = "DeadAboveDot";
  _KeyName.DEAD_UMLAUT = "DeadUmlaut";
  _KeyName.DEAD_ABOVE_RING = "DeadAboveRing";
  _KeyName.DEAD_DOUBLEACUTE = "DeadDoubleacute";
  _KeyName.DEAD_CARON = "DeadCaron";
  _KeyName.DEAD_CEDILLA = "DeadCedilla";
  _KeyName.DEAD_OGONEK = "DeadOgonek";
  _KeyName.DEAD_IOTA = "DeadIota";
  _KeyName.DEAD_VOICED_SOUND = "DeadVoicedSound";
  _KeyName.DEC_SEMIVOICED_SOUND = "DeadSemivoicedSound";
  _KeyName.UNIDENTIFIED = "Unidentified";
  let _stream = Symbol('_stream');
  let _keyDownList = Symbol('_keyDownList');
  let _capsLockOn = Symbol('_capsLockOn');
  let _determineKeyCodeForKeypress = Symbol('_determineKeyCodeForKeypress');
  let _findCharCodeKeyDown = Symbol('_findCharCodeKeyDown');
  let _firesKeyPressEvent = Symbol('_firesKeyPressEvent');
  let _normalizeKeyCodes = Symbol('_normalizeKeyCodes');
  class _KeyboardEventHandler extends EventStreamProvider$(KeyEvent) {
    forTarget(e, opts) {
      let useCapture = opts && 'useCapture' in opts ? opts.useCapture : false;
      let handler = new _KeyboardEventHandler.initializeAllEventListeners(this[_type], e);
      return dart.as(dart.dload(handler, _stream), CustomStream$(KeyEvent));
    }
    _KeyboardEventHandler(type) {
      this[_keyDownList] = dart.list([], KeyboardEvent);
      this[_type] = type;
      this[_stream] = new _CustomKeyEventStreamImpl('event');
      this[_target] = null;
      super.EventStreamProvider(dart.as(_KeyboardEventHandler._EVENT_TYPE, core.String));
    }
    initializeAllEventListeners(type, target) {
      this[_keyDownList] = dart.list([], KeyboardEvent);
      this[_type] = type;
      this[_target] = target;
      this[_stream] = null;
      super.EventStreamProvider(dart.as(_KeyboardEventHandler._EVENT_TYPE, core.String));
      Element.keyDownEvent.forTarget(this[_target], {useCapture: true}).listen(dart.bind(this, 'processKeyDown'));
      Element.keyPressEvent.forTarget(this[_target], {useCapture: true}).listen(dart.bind(this, 'processKeyPress'));
      Element.keyUpEvent.forTarget(this[_target], {useCapture: true}).listen(dart.bind(this, 'processKeyUp'));
      this[_stream] = new _CustomKeyEventStreamImpl(this[_type]);
    }
    get [_capsLockOn]() {
      return this[_keyDownList][dartx.any](dart.fn(element => dart.equals(dart.dload(element, 'keyCode'), KeyCode.CAPS_LOCK), core.bool, [dart.dynamic]));
    }
    [_determineKeyCodeForKeypress](event) {
      for (let prevEvent of this[_keyDownList]) {
        if (dart.equals(dart.dload(prevEvent, _shadowCharCode), event.charCode)) {
          return dart.as(dart.dload(prevEvent, 'keyCode'), core.int);
        }
        if ((dart.notNull(event.shiftKey) || dart.notNull(this[_capsLockOn])) && dart.notNull(event.charCode) >= dart.notNull("A"[dartx.codeUnits][dartx.get](0)) && dart.notNull(event.charCode) <= dart.notNull("Z"[dartx.codeUnits][dartx.get](0)) && dart.equals(dart.notNull(event.charCode) + dart.notNull(_KeyboardEventHandler._ROMAN_ALPHABET_OFFSET), dart.dload(prevEvent, _shadowCharCode))) {
          return dart.as(dart.dload(prevEvent, 'keyCode'), core.int);
        }
      }
      return KeyCode.UNKNOWN;
    }
    [_findCharCodeKeyDown](event) {
      if (event.keyLocation == 3) {
        switch (event.keyCode) {
          case KeyCode.NUM_ZERO:
          {
            return KeyCode.ZERO;
          }
          case KeyCode.NUM_ONE:
          {
            return KeyCode.ONE;
          }
          case KeyCode.NUM_TWO:
          {
            return KeyCode.TWO;
          }
          case KeyCode.NUM_THREE:
          {
            return KeyCode.THREE;
          }
          case KeyCode.NUM_FOUR:
          {
            return KeyCode.FOUR;
          }
          case KeyCode.NUM_FIVE:
          {
            return KeyCode.FIVE;
          }
          case KeyCode.NUM_SIX:
          {
            return KeyCode.SIX;
          }
          case KeyCode.NUM_SEVEN:
          {
            return KeyCode.SEVEN;
          }
          case KeyCode.NUM_EIGHT:
          {
            return KeyCode.EIGHT;
          }
          case KeyCode.NUM_NINE:
          {
            return KeyCode.NINE;
          }
          case KeyCode.NUM_MULTIPLY:
          {
            return 42;
          }
          case KeyCode.NUM_PLUS:
          {
            return 43;
          }
          case KeyCode.NUM_MINUS:
          {
            return 45;
          }
          case KeyCode.NUM_PERIOD:
          {
            return 46;
          }
          case KeyCode.NUM_DIVISION:
          {
            return 47;
          }
        }
      } else if (dart.notNull(event.keyCode) >= 65 && dart.notNull(event.keyCode) <= 90) {
        return dart.notNull(event.keyCode) + dart.notNull(_KeyboardEventHandler._ROMAN_ALPHABET_OFFSET);
      }
      switch (event.keyCode) {
        case KeyCode.SEMICOLON:
        {
          return KeyCode.FF_SEMICOLON;
        }
        case KeyCode.EQUALS:
        {
          return KeyCode.FF_EQUALS;
        }
        case KeyCode.COMMA:
        {
          return 44;
        }
        case KeyCode.DASH:
        {
          return 45;
        }
        case KeyCode.PERIOD:
        {
          return 46;
        }
        case KeyCode.SLASH:
        {
          return 47;
        }
        case KeyCode.APOSTROPHE:
        {
          return 96;
        }
        case KeyCode.OPEN_SQUARE_BRACKET:
        {
          return 91;
        }
        case KeyCode.BACKSLASH:
        {
          return 92;
        }
        case KeyCode.CLOSE_SQUARE_BRACKET:
        {
          return 93;
        }
        case KeyCode.SINGLE_QUOTE:
        {
          return 39;
        }
      }
      return event.keyCode;
    }
    [_firesKeyPressEvent](event) {
      if (!dart.notNull(html_common.Device.isIE) && !dart.notNull(html_common.Device.isWebKit)) {
        return true;
      }
      if (dart.notNull(html_common.Device.userAgent[dartx.contains]('Mac')) && dart.notNull(event.altKey)) {
        return KeyCode.isCharacterKey(event.keyCode);
      }
      if (dart.notNull(event.altKey) && !dart.notNull(event.ctrlKey)) {
        return false;
      }
      if (!dart.notNull(event.shiftKey) && (this[_keyDownList][dartx.last].keyCode == KeyCode.CTRL || this[_keyDownList][dartx.last].keyCode == KeyCode.ALT || dart.notNull(html_common.Device.userAgent[dartx.contains]('Mac')) && this[_keyDownList][dartx.last].keyCode == KeyCode.META)) {
        return false;
      }
      if (dart.notNull(html_common.Device.isWebKit) && dart.notNull(event.ctrlKey) && dart.notNull(event.shiftKey) && (event.keyCode == KeyCode.BACKSLASH || event.keyCode == KeyCode.OPEN_SQUARE_BRACKET || event.keyCode == KeyCode.CLOSE_SQUARE_BRACKET || event.keyCode == KeyCode.TILDE || event.keyCode == KeyCode.SEMICOLON || event.keyCode == KeyCode.DASH || event.keyCode == KeyCode.EQUALS || event.keyCode == KeyCode.COMMA || event.keyCode == KeyCode.PERIOD || event.keyCode == KeyCode.SLASH || event.keyCode == KeyCode.APOSTROPHE || event.keyCode == KeyCode.SINGLE_QUOTE)) {
        return false;
      }
      switch (event.keyCode) {
        case KeyCode.ENTER:
        {
          return !dart.notNull(html_common.Device.isIE);
        }
        case KeyCode.ESC:
        {
          return !dart.notNull(html_common.Device.isWebKit);
        }
      }
      return KeyCode.isCharacterKey(event.keyCode);
    }
    [_normalizeKeyCodes](event) {
      if (dart.notNull(html_common.Device.isFirefox)) {
        switch (event.keyCode) {
          case KeyCode.FF_EQUALS:
          {
            return KeyCode.EQUALS;
          }
          case KeyCode.FF_SEMICOLON:
          {
            return KeyCode.SEMICOLON;
          }
          case KeyCode.MAC_FF_META:
          {
            return KeyCode.META;
          }
          case KeyCode.WIN_KEY_FF_LINUX:
          {
            return KeyCode.WIN_KEY;
          }
        }
      }
      return event.keyCode;
    }
    processKeyDown(e) {
      if (dart.notNull(this[_keyDownList][dartx.length]) > 0 && (this[_keyDownList][dartx.last].keyCode == KeyCode.CTRL && !dart.notNull(e.ctrlKey) || this[_keyDownList][dartx.last].keyCode == KeyCode.ALT && !dart.notNull(e.altKey) || dart.notNull(html_common.Device.userAgent[dartx.contains]('Mac')) && this[_keyDownList][dartx.last].keyCode == KeyCode.META && !dart.notNull(e.metaKey))) {
        this[_keyDownList][dartx.clear]();
      }
      let event = new KeyEvent.wrap(e);
      dart.dput(event, _shadowKeyCode, this[_normalizeKeyCodes](dart.as(event, KeyboardEvent)));
      dart.dput(event, _shadowCharCode, this[_findCharCodeKeyDown](dart.as(event, KeyboardEvent)));
      if (dart.notNull(this[_keyDownList][dartx.length]) > 0 && !dart.equals(dart.dload(event, 'keyCode'), this[_keyDownList][dartx.last].keyCode) && !dart.notNull(this[_firesKeyPressEvent](dart.as(event, KeyEvent)))) {
        this.processKeyPress(e);
      }
      this[_keyDownList][dartx.add](dart.as(event, KeyboardEvent));
      this[_stream].add(dart.as(event, KeyEvent));
    }
    processKeyPress(event) {
      let e = new KeyEvent.wrap(event);
      if (dart.notNull(html_common.Device.isIE)) {
        if (dart.equals(dart.dload(e, 'keyCode'), KeyCode.ENTER) || dart.equals(dart.dload(e, 'keyCode'), KeyCode.ESC)) {
          dart.dput(e, _shadowCharCode, 0);
        } else {
          dart.dput(e, _shadowCharCode, dart.dload(e, 'keyCode'));
        }
      } else if (dart.notNull(html_common.Device.isOpera)) {
        dart.dput(e, _shadowCharCode, dart.notNull(KeyCode.isCharacterKey(dart.as(dart.dload(e, 'keyCode'), core.int))) ? dart.dload(e, 'keyCode') : 0);
      }
      dart.dput(e, _shadowKeyCode, this[_determineKeyCodeForKeypress](dart.as(e, KeyboardEvent)));
      if (dart.dload(e, _shadowKeyIdentifier) != null && dart.notNull(_KeyboardEventHandler._keyIdentifier.containsKey(dart.dload(e, _shadowKeyIdentifier)))) {
        dart.dput(e, _shadowKeyCode, _KeyboardEventHandler._keyIdentifier.get(dart.dload(e, _shadowKeyIdentifier)));
      }
      dart.dput(e, _shadowAltKey, this[_keyDownList][dartx.any](dart.fn(element => dart.as(dart.dload(element, 'altKey'), core.bool), core.bool, [dart.dynamic])));
      this[_stream].add(dart.as(e, KeyEvent));
    }
    processKeyUp(event) {
      let e = new KeyEvent.wrap(event);
      let toRemove = null;
      for (let key of this[_keyDownList]) {
        if (dart.equals(dart.dload(key, 'keyCode'), dart.dload(e, 'keyCode'))) {
          toRemove = dart.as(key, KeyboardEvent);
        }
      }
      if (toRemove != null) {
        this[_keyDownList][dartx.removeWhere](dart.fn(element => dart.equals(element, toRemove), core.bool, [dart.dynamic]));
      } else if (dart.notNull(this[_keyDownList][dartx.length]) > 0) {
        this[_keyDownList][dartx.removeLast]();
      }
      this[_stream].add(dart.as(e, KeyEvent));
    }
  }
  dart.defineNamedConstructor(_KeyboardEventHandler, 'initializeAllEventListeners');
  dart.setSignature(_KeyboardEventHandler, {
    constructors: () => ({
      _KeyboardEventHandler: [_KeyboardEventHandler, [core.String]],
      initializeAllEventListeners: [_KeyboardEventHandler, [core.String, EventTarget]]
    }),
    methods: () => ({
      forTarget: [CustomStream$(KeyEvent), [EventTarget], {useCapture: core.bool}],
      [_determineKeyCodeForKeypress]: [core.int, [KeyboardEvent]],
      [_findCharCodeKeyDown]: [core.int, [KeyboardEvent]],
      [_firesKeyPressEvent]: [core.bool, [KeyEvent]],
      [_normalizeKeyCodes]: [core.int, [KeyboardEvent]],
      processKeyDown: [dart.void, [KeyboardEvent]],
      processKeyPress: [dart.void, [KeyboardEvent]],
      processKeyUp: [dart.void, [KeyboardEvent]]
    })
  });
  _KeyboardEventHandler._EVENT_TYPE = 'KeyEvent';
  _KeyboardEventHandler._keyIdentifier = dart.const(dart.map({Up: KeyCode.UP, Down: KeyCode.DOWN, Left: KeyCode.LEFT, Right: KeyCode.RIGHT, Enter: KeyCode.ENTER, F1: KeyCode.F1, F2: KeyCode.F2, F3: KeyCode.F3, F4: KeyCode.F4, F5: KeyCode.F5, F6: KeyCode.F6, F7: KeyCode.F7, F8: KeyCode.F8, F9: KeyCode.F9, F10: KeyCode.F10, F11: KeyCode.F11, F12: KeyCode.F12, 'U+007F': KeyCode.DELETE, Home: KeyCode.HOME, End: KeyCode.END, PageUp: KeyCode.PAGE_UP, PageDown: KeyCode.PAGE_DOWN, Insert: KeyCode.INSERT}));
  dart.defineLazyProperties(_KeyboardEventHandler, {
    get _ROMAN_ALPHABET_OFFSET() {
      return dart.notNull("a"[dartx.codeUnits][dartx.get](0)) - dart.notNull("A"[dartx.codeUnits][dartx.get](0));
    }
  });
  class KeyboardEventStream extends core.Object {
    static onKeyPress(target) {
      return new _KeyboardEventHandler('keypress').forTarget(target);
    }
    static onKeyUp(target) {
      return new _KeyboardEventHandler('keyup').forTarget(target);
    }
    static onKeyDown(target) {
      return new _KeyboardEventHandler('keydown').forTarget(target);
    }
  }
  dart.setSignature(KeyboardEventStream, {
    statics: () => ({
      onKeyPress: [CustomStream$(KeyEvent), [EventTarget]],
      onKeyUp: [CustomStream$(KeyEvent), [EventTarget]],
      onKeyDown: [CustomStream$(KeyEvent), [EventTarget]]
    }),
    names: ['onKeyPress', 'onKeyUp', 'onKeyDown']
  });
  let _validators = Symbol('_validators');
  class NodeValidatorBuilder extends core.Object {
    NodeValidatorBuilder() {
      this[_validators] = dart.list([], NodeValidator);
    }
    common() {
      this[_validators] = dart.list([], NodeValidator);
      this.allowHtml5();
      this.allowTemplating();
    }
    allowNavigation(uriPolicy) {
      if (uriPolicy === void 0)
        uriPolicy = null;
      if (uriPolicy == null) {
        uriPolicy = UriPolicy.new();
      }
      this.add(_SimpleNodeValidator.allowNavigation(uriPolicy));
    }
    allowImages(uriPolicy) {
      if (uriPolicy === void 0)
        uriPolicy = null;
      if (uriPolicy == null) {
        uriPolicy = UriPolicy.new();
      }
      this.add(_SimpleNodeValidator.allowImages(uriPolicy));
    }
    allowTextElements() {
      this.add(_SimpleNodeValidator.allowTextElements());
    }
    allowInlineStyles(opts) {
      let tagName = opts && 'tagName' in opts ? opts.tagName : null;
      if (tagName == null) {
        tagName = '*';
      } else {
        tagName = tagName[dartx.toUpperCase]();
      }
      this.add(new _SimpleNodeValidator(null, {allowedAttributes: dart.list([`${tagName}::style`], core.String)}));
    }
    allowHtml5(opts) {
      let uriPolicy = opts && 'uriPolicy' in opts ? opts.uriPolicy : null;
      this.add(new _Html5NodeValidator({uriPolicy: uriPolicy}));
    }
    allowSvg() {
      this.add(new _SvgNodeValidator());
    }
    allowCustomElement(tagName, opts) {
      let uriPolicy = opts && 'uriPolicy' in opts ? opts.uriPolicy : null;
      let attributes = opts && 'attributes' in opts ? opts.attributes : null;
      let uriAttributes = opts && 'uriAttributes' in opts ? opts.uriAttributes : null;
      let tagNameUpper = tagName[dartx.toUpperCase]();
      let attrs = null;
      if (attributes != null) {
        attrs = attributes[dartx.map](dart.fn(name => `${tagNameUpper}::${dart.dsend(name, 'toLowerCase')}`, core.String, [dart.dynamic]));
      }
      let uriAttrs = null;
      if (uriAttributes != null) {
        uriAttrs = uriAttributes[dartx.map](dart.fn(name => `${tagNameUpper}::${dart.dsend(name, 'toLowerCase')}`, core.String, [dart.dynamic]));
      }
      if (uriPolicy == null) {
        uriPolicy = UriPolicy.new();
      }
      this.add(new _CustomElementNodeValidator(uriPolicy, dart.list([dart.as(tagNameUpper, core.String)], core.String), dart.as(attrs, core.Iterable$(core.String)), dart.as(uriAttrs, core.Iterable$(core.String)), false, true));
    }
    allowTagExtension(tagName, baseName, opts) {
      let uriPolicy = opts && 'uriPolicy' in opts ? opts.uriPolicy : null;
      let attributes = opts && 'attributes' in opts ? opts.attributes : null;
      let uriAttributes = opts && 'uriAttributes' in opts ? opts.uriAttributes : null;
      let baseNameUpper = baseName[dartx.toUpperCase]();
      let tagNameUpper = tagName[dartx.toUpperCase]();
      let attrs = null;
      if (attributes != null) {
        attrs = attributes[dartx.map](dart.fn(name => `${baseNameUpper}::${dart.dsend(name, 'toLowerCase')}`, core.String, [dart.dynamic]));
      }
      let uriAttrs = null;
      if (uriAttributes != null) {
        uriAttrs = uriAttributes[dartx.map](dart.fn(name => `${baseNameUpper}::${dart.dsend(name, 'toLowerCase')}`, core.String, [dart.dynamic]));
      }
      if (uriPolicy == null) {
        uriPolicy = UriPolicy.new();
      }
      this.add(new _CustomElementNodeValidator(uriPolicy, dart.list([dart.as(tagNameUpper, core.String), dart.as(baseNameUpper, core.String)], core.String), dart.as(attrs, core.Iterable$(core.String)), dart.as(uriAttrs, core.Iterable$(core.String)), true, false));
    }
    allowElement(tagName, opts) {
      let uriPolicy = opts && 'uriPolicy' in opts ? opts.uriPolicy : null;
      let attributes = opts && 'attributes' in opts ? opts.attributes : null;
      let uriAttributes = opts && 'uriAttributes' in opts ? opts.uriAttributes : null;
      this.allowCustomElement(tagName, {uriPolicy: uriPolicy, attributes: attributes, uriAttributes: uriAttributes});
    }
    allowTemplating() {
      this.add(new _TemplatingNodeValidator());
    }
    add(validator) {
      this[_validators][dartx.add](validator);
    }
    allowsElement(element) {
      return this[_validators][dartx.any](dart.fn(v => dart.as(dart.dsend(v, 'allowsElement', element), core.bool), core.bool, [dart.dynamic]));
    }
    allowsAttribute(element, attributeName, value) {
      return this[_validators][dartx.any](dart.fn(v => dart.as(dart.dsend(v, 'allowsAttribute', element, attributeName, value), core.bool), core.bool, [dart.dynamic]));
    }
  }
  NodeValidatorBuilder[dart.implements] = () => [NodeValidator];
  dart.defineNamedConstructor(NodeValidatorBuilder, 'common');
  dart.setSignature(NodeValidatorBuilder, {
    constructors: () => ({
      NodeValidatorBuilder: [NodeValidatorBuilder, []],
      common: [NodeValidatorBuilder, []]
    }),
    methods: () => ({
      allowNavigation: [dart.void, [], [UriPolicy]],
      allowImages: [dart.void, [], [UriPolicy]],
      allowTextElements: [dart.void, []],
      allowInlineStyles: [dart.void, [], {tagName: core.String}],
      allowHtml5: [dart.void, [], {uriPolicy: UriPolicy}],
      allowSvg: [dart.void, []],
      allowCustomElement: [dart.void, [core.String], {uriPolicy: UriPolicy, attributes: core.Iterable$(core.String), uriAttributes: core.Iterable$(core.String)}],
      allowTagExtension: [dart.void, [core.String, core.String], {uriPolicy: UriPolicy, attributes: core.Iterable$(core.String), uriAttributes: core.Iterable$(core.String)}],
      allowElement: [dart.void, [core.String], {uriPolicy: UriPolicy, attributes: core.Iterable$(core.String), uriAttributes: core.Iterable$(core.String)}],
      allowTemplating: [dart.void, []],
      add: [dart.void, [NodeValidator]],
      allowsElement: [core.bool, [Element]],
      allowsAttribute: [core.bool, [Element, core.String, core.String]]
    })
  });
  class _SimpleNodeValidator extends core.Object {
    static allowNavigation(uriPolicy) {
      return new _SimpleNodeValidator(uriPolicy, {allowedElements: dart.const(dart.list(['A', 'FORM'], core.String)), allowedAttributes: dart.const(dart.list(['A::accesskey', 'A::coords', 'A::hreflang', 'A::name', 'A::shape', 'A::tabindex', 'A::target', 'A::type', 'FORM::accept', 'FORM::autocomplete', 'FORM::enctype', 'FORM::method', 'FORM::name', 'FORM::novalidate', 'FORM::target'], core.String)), allowedUriAttributes: dart.const(dart.list(['A::href', 'FORM::action'], core.String))});
    }
    static allowImages(uriPolicy) {
      return new _SimpleNodeValidator(uriPolicy, {allowedElements: dart.const(dart.list(['IMG'], core.String)), allowedAttributes: dart.const(dart.list(['IMG::align', 'IMG::alt', 'IMG::border', 'IMG::height', 'IMG::hspace', 'IMG::ismap', 'IMG::name', 'IMG::usemap', 'IMG::vspace', 'IMG::width'], core.String)), allowedUriAttributes: dart.const(dart.list(['IMG::src'], core.String))});
    }
    static allowTextElements() {
      return new _SimpleNodeValidator(null, {allowedElements: dart.const(dart.list(['B', 'BLOCKQUOTE', 'BR', 'EM', 'H1', 'H2', 'H3', 'H4', 'H5', 'H6', 'HR', 'I', 'LI', 'OL', 'P', 'SPAN', 'UL'], core.String))});
    }
    _SimpleNodeValidator(uriPolicy, opts) {
      let allowedElements = opts && 'allowedElements' in opts ? opts.allowedElements : null;
      let allowedAttributes = opts && 'allowedAttributes' in opts ? opts.allowedAttributes : null;
      let allowedUriAttributes = opts && 'allowedUriAttributes' in opts ? opts.allowedUriAttributes : null;
      this.allowedElements = core.Set$(core.String).new();
      this.allowedAttributes = core.Set$(core.String).new();
      this.allowedUriAttributes = core.Set$(core.String).new();
      this.uriPolicy = uriPolicy;
      this.allowedElements.addAll(dart.as((allowedElements != null ? allowedElements : dart.const([])), core.Iterable$(core.String)));
      allowedAttributes = dart.as((allowedAttributes != null ? allowedAttributes : dart.const([])), core.Iterable$(core.String));
      allowedUriAttributes = dart.as((allowedUriAttributes != null ? allowedUriAttributes : dart.const([])), core.Iterable$(core.String));
      let legalAttributes = allowedAttributes[dartx.where](dart.fn(x => !dart.notNull(dart.as(dart.dsend(_Html5NodeValidator._uriAttributes, 'contains', x), core.bool)), core.bool, [dart.dynamic]));
      let extraUriAttributes = allowedAttributes[dartx.where](dart.fn(x => dart.as(dart.dsend(_Html5NodeValidator._uriAttributes, 'contains', x), core.bool), core.bool, [dart.dynamic]));
      this.allowedAttributes.addAll(dart.as(legalAttributes, core.Iterable$(core.String)));
      this.allowedUriAttributes.addAll(allowedUriAttributes);
      this.allowedUriAttributes.addAll(dart.as(extraUriAttributes, core.Iterable$(core.String)));
    }
    allowsElement(element) {
      return this.allowedElements.contains(element.tagName);
    }
    allowsAttribute(element, attributeName, value) {
      let tagName = element.tagName;
      if (dart.notNull(this.allowedUriAttributes.contains(`${tagName}::${attributeName}`))) {
        return this.uriPolicy.allowsUri(value);
      } else if (dart.notNull(this.allowedUriAttributes.contains(`*::${attributeName}`))) {
        return this.uriPolicy.allowsUri(value);
      } else if (dart.notNull(this.allowedAttributes.contains(`${tagName}::${attributeName}`))) {
        return true;
      } else if (dart.notNull(this.allowedAttributes.contains(`*::${attributeName}`))) {
        return true;
      } else if (dart.notNull(this.allowedAttributes.contains(`${tagName}::*`))) {
        return true;
      } else if (dart.notNull(this.allowedAttributes.contains('*::*'))) {
        return true;
      }
      return false;
    }
  }
  _SimpleNodeValidator[dart.implements] = () => [NodeValidator];
  dart.setSignature(_SimpleNodeValidator, {
    constructors: () => ({
      allowNavigation: [_SimpleNodeValidator, [UriPolicy]],
      allowImages: [_SimpleNodeValidator, [UriPolicy]],
      allowTextElements: [_SimpleNodeValidator, []],
      _SimpleNodeValidator: [_SimpleNodeValidator, [UriPolicy], {allowedElements: core.Iterable$(core.String), allowedAttributes: core.Iterable$(core.String), allowedUriAttributes: core.Iterable$(core.String)}]
    }),
    methods: () => ({
      allowsElement: [core.bool, [Element]],
      allowsAttribute: [core.bool, [Element, core.String, core.String]]
    })
  });
  class _CustomElementNodeValidator extends _SimpleNodeValidator {
    _CustomElementNodeValidator(uriPolicy, allowedElements, allowedAttributes, allowedUriAttributes, allowTypeExtension, allowCustomTag) {
      this.allowTypeExtension = allowTypeExtension == true;
      this.allowCustomTag = allowCustomTag == true;
      super._SimpleNodeValidator(uriPolicy, {allowedElements: allowedElements, allowedAttributes: allowedAttributes, allowedUriAttributes: allowedUriAttributes});
    }
    allowsElement(element) {
      if (dart.notNull(this.allowTypeExtension)) {
        let isAttr = element.attributes.get('is');
        if (isAttr != null) {
          return dart.notNull(this.allowedElements.contains(dart.dsend(isAttr, 'toUpperCase'))) && dart.notNull(this.allowedElements.contains(element.tagName));
        }
      }
      return dart.notNull(this.allowCustomTag) && dart.notNull(this.allowedElements.contains(element.tagName));
    }
    allowsAttribute(element, attributeName, value) {
      if (dart.notNull(this.allowsElement(element))) {
        if (dart.notNull(this.allowTypeExtension) && attributeName == 'is' && dart.notNull(this.allowedElements.contains(value[dartx.toUpperCase]()))) {
          return true;
        }
        return super.allowsAttribute(element, attributeName, value);
      }
      return false;
    }
  }
  dart.setSignature(_CustomElementNodeValidator, {
    constructors: () => ({_CustomElementNodeValidator: [_CustomElementNodeValidator, [UriPolicy, core.Iterable$(core.String), core.Iterable$(core.String), core.Iterable$(core.String), core.bool, core.bool]]})
  });
  let _templateAttrs = Symbol('_templateAttrs');
  class _TemplatingNodeValidator extends _SimpleNodeValidator {
    _TemplatingNodeValidator() {
      this[_templateAttrs] = core.Set$(core.String).from(dart.as(_TemplatingNodeValidator._TEMPLATE_ATTRS, core.Iterable));
      super._SimpleNodeValidator(null, {allowedElements: dart.list(['TEMPLATE'], core.String), allowedAttributes: dart.as(dart.dsend(_TemplatingNodeValidator._TEMPLATE_ATTRS, 'map', dart.fn(attr => `TEMPLATE::${attr}`, core.String, [dart.dynamic])), core.Iterable$(core.String))});
    }
    allowsAttribute(element, attributeName, value) {
      if (dart.notNull(super.allowsAttribute(element, attributeName, value))) {
        return true;
      }
      if (attributeName == 'template' && value == "") {
        return true;
      }
      if (element.attributes.get('template') == "") {
        return this[_templateAttrs].contains(attributeName);
      }
      return false;
    }
  }
  dart.setSignature(_TemplatingNodeValidator, {
    constructors: () => ({_TemplatingNodeValidator: [_TemplatingNodeValidator, []]})
  });
  _TemplatingNodeValidator._TEMPLATE_ATTRS = dart.const(dart.list(['bind', 'if', 'ref', 'repeat', 'syntax'], core.String));
  class _SvgNodeValidator extends core.Object {
    allowsElement(element) {
      if (dart.is(element, svg.ScriptElement)) {
        return false;
      }
      if (dart.is(element, svg.SvgElement) && element.tagName == 'foreignObject') {
        return false;
      }
      if (dart.is(element, svg.SvgElement)) {
        return true;
      }
      return false;
    }
    allowsAttribute(element, attributeName, value) {
      if (attributeName == 'is' || dart.notNull(attributeName[dartx.startsWith]('on'))) {
        return false;
      }
      return this.allowsElement(element);
    }
  }
  _SvgNodeValidator[dart.implements] = () => [NodeValidator];
  dart.setSignature(_SvgNodeValidator, {
    methods: () => ({
      allowsElement: [core.bool, [Element]],
      allowsAttribute: [core.bool, [Element, core.String, core.String]]
    })
  });
  class ReadyState extends core.Object {}
  ReadyState.LOADING = "loading";
  ReadyState.INTERACTIVE = "interactive";
  ReadyState.COMPLETE = "complete";
  let _list = Symbol('_list');
  let _WrappedList$ = dart.generic(function(E) {
    class _WrappedList extends collection.ListBase$(E) {
      _WrappedList(list) {
        this[_list] = list;
      }
      get iterator() {
        return new (_WrappedIterator$(E))(this[_list][dartx.iterator]);
      }
      get length() {
        return this[_list][dartx.length];
      }
      add(element) {
        dart.as(element, E);
        this[_list][dartx.add](element);
      }
      remove(element) {
        return this[_list][dartx.remove](element);
      }
      clear() {
        this[_list][dartx.clear]();
      }
      get(index) {
        return dart.as(this[_list][dartx.get](index), E);
      }
      set(index, value) {
        dart.as(value, E);
        this[_list][dartx.set](index, value);
        return value;
      }
      set length(newLength) {
        this[_list][dartx.length] = newLength;
      }
      sort(compare) {
        if (compare === void 0)
          compare = null;
        dart.as(compare, dart.functionType(core.int, [E, E]));
        this[_list][dartx.sort](compare);
      }
      indexOf(element, start) {
        if (start === void 0)
          start = 0;
        return this[_list][dartx.indexOf](element, start);
      }
      lastIndexOf(element, start) {
        if (start === void 0)
          start = null;
        return this[_list][dartx.lastIndexOf](element, start);
      }
      insert(index, element) {
        dart.as(element, E);
        return this[_list][dartx.insert](index, element);
      }
      removeAt(index) {
        return dart.as(this[_list][dartx.removeAt](index), E);
      }
      setRange(start, end, iterable, skipCount) {
        dart.as(iterable, core.Iterable$(E));
        if (skipCount === void 0)
          skipCount = 0;
        this[_list][dartx.setRange](start, end, iterable, skipCount);
      }
      removeRange(start, end) {
        this[_list][dartx.removeRange](start, end);
      }
      replaceRange(start, end, iterable) {
        dart.as(iterable, core.Iterable$(E));
        this[_list][dartx.replaceRange](start, end, iterable);
      }
      fillRange(start, end, fillValue) {
        if (fillValue === void 0)
          fillValue = null;
        dart.as(fillValue, E);
        this[_list][dartx.fillRange](start, end, fillValue);
      }
      get rawList() {
        return dart.as(this[_list], core.List$(Node));
      }
    }
    _WrappedList[dart.implements] = () => [html_common.NodeListWrapper];
    dart.setSignature(_WrappedList, {
      constructors: () => ({_WrappedList: [_WrappedList$(E), [core.List]]}),
      methods: () => ({
        add: [dart.void, [E]],
        get: [E, [core.int]],
        set: [dart.void, [core.int, E]],
        sort: [dart.void, [], [dart.functionType(core.int, [E, E])]],
        insert: [dart.void, [core.int, E]],
        removeAt: [E, [core.int]],
        setRange: [dart.void, [core.int, core.int, core.Iterable$(E)], [core.int]],
        replaceRange: [dart.void, [core.int, core.int, core.Iterable$(E)]],
        fillRange: [dart.void, [core.int, core.int], [E]]
      })
    });
    dart.defineExtensionMembers(_WrappedList, [
      'add',
      'remove',
      'clear',
      'get',
      'set',
      'sort',
      'indexOf',
      'lastIndexOf',
      'insert',
      'removeAt',
      'setRange',
      'removeRange',
      'replaceRange',
      'fillRange',
      'iterator',
      'length',
      'length'
    ]);
    return _WrappedList;
  });
  let _WrappedList = _WrappedList$();
  let _iterator = Symbol('_iterator');
  let _WrappedIterator$ = dart.generic(function(E) {
    class _WrappedIterator extends core.Object {
      _WrappedIterator(iterator) {
        this[_iterator] = iterator;
      }
      moveNext() {
        return this[_iterator].moveNext();
      }
      get current() {
        return dart.as(this[_iterator].current, E);
      }
    }
    _WrappedIterator[dart.implements] = () => [core.Iterator$(E)];
    dart.setSignature(_WrappedIterator, {
      constructors: () => ({_WrappedIterator: [_WrappedIterator$(E), [core.Iterator]]}),
      methods: () => ({moveNext: [core.bool, []]})
    });
    return _WrappedIterator;
  });
  let _WrappedIterator = _WrappedIterator$();
  class _HttpRequestUtils extends core.Object {
    static get(url, onComplete, withCredentials) {
      let request = HttpRequest.new();
      dart.dsend(request, 'open', 'GET', url, {async: true});
      dart.dput(request, 'withCredentials', withCredentials);
      dart.dsend(dart.dload(request, 'onReadyStateChange'), 'listen', dart.fn(e => {
        if (dart.equals(dart.dload(request, 'readyState'), HttpRequest.DONE)) {
          onComplete(dart.as(request, HttpRequest));
        }
      }));
      dart.dsend(request, 'send');
      return dart.as(request, HttpRequest);
    }
  }
  dart.setSignature(_HttpRequestUtils, {
    statics: () => ({get: [HttpRequest, [core.String, dart.functionType(dart.dynamic, [HttpRequest]), core.bool]]}),
    names: ['get']
  });
  let _array = Symbol('_array');
  let _current = Symbol('_current');
  let FixedSizeListIterator$ = dart.generic(function(T) {
    class FixedSizeListIterator extends core.Object {
      FixedSizeListIterator(array) {
        this[_array] = array;
        this[_position] = -1;
        this[_length] = array[dartx.length];
        this[_current] = null;
      }
      moveNext() {
        let nextPosition = dart.notNull(this[_position]) + 1;
        if (dart.notNull(nextPosition) < dart.notNull(this[_length])) {
          this[_current] = this[_array][dartx.get](nextPosition);
          this[_position] = nextPosition;
          return true;
        }
        this[_current] = null;
        this[_position] = this[_length];
        return false;
      }
      get current() {
        return this[_current];
      }
    }
    FixedSizeListIterator[dart.implements] = () => [core.Iterator$(T)];
    dart.setSignature(FixedSizeListIterator, {
      constructors: () => ({FixedSizeListIterator: [FixedSizeListIterator$(T), [core.List$(T)]]}),
      methods: () => ({moveNext: [core.bool, []]})
    });
    return FixedSizeListIterator;
  });
  let FixedSizeListIterator = FixedSizeListIterator$();
  let _VariableSizeListIterator$ = dart.generic(function(T) {
    class _VariableSizeListIterator extends core.Object {
      _VariableSizeListIterator(array) {
        this[_array] = array;
        this[_position] = -1;
        this[_current] = null;
      }
      moveNext() {
        let nextPosition = dart.notNull(this[_position]) + 1;
        if (dart.notNull(nextPosition) < dart.notNull(this[_array][dartx.length])) {
          this[_current] = this[_array][dartx.get](nextPosition);
          this[_position] = nextPosition;
          return true;
        }
        this[_current] = null;
        this[_position] = this[_array][dartx.length];
        return false;
      }
      get current() {
        return this[_current];
      }
    }
    _VariableSizeListIterator[dart.implements] = () => [core.Iterator$(T)];
    dart.setSignature(_VariableSizeListIterator, {
      constructors: () => ({_VariableSizeListIterator: [_VariableSizeListIterator$(T), [core.List$(T)]]}),
      methods: () => ({moveNext: [core.bool, []]})
    });
    return _VariableSizeListIterator;
  });
  let _VariableSizeListIterator = _VariableSizeListIterator$();
  function _convertNativeToDart_Window(win) {
    if (win == null)
      return null;
    return _DOMWindowCrossFrame._createSafe(win);
  }
  dart.fn(_convertNativeToDart_Window, WindowBase, [dart.dynamic]);
  function _convertNativeToDart_EventTarget(e) {
    if (e == null) {
      return null;
    }
    if (dart.notNull(dart.as("postMessage" in e, core.bool))) {
      let window = _DOMWindowCrossFrame._createSafe(e);
      if (dart.is(window, EventTarget)) {
        return dart.as(window, EventTarget);
      }
      return null;
    } else
      return dart.as(e, EventTarget);
  }
  dart.fn(_convertNativeToDart_EventTarget, EventTarget, [dart.dynamic]);
  let _window = Symbol('_window');
  function _convertDartToNative_EventTarget(e) {
    if (dart.is(e, _DOMWindowCrossFrame)) {
      return dart.as(dart.dload(e, _window), EventTarget);
    } else {
      return dart.as(e, EventTarget);
    }
  }
  dart.fn(_convertDartToNative_EventTarget, EventTarget, [dart.dynamic]);
  function _convertNativeToDart_XHR_Response(o) {
    if (dart.is(o, Document)) {
      return o;
    }
    return html_common.convertNativeToDart_SerializedScriptValue(o);
  }
  dart.fn(_convertNativeToDart_XHR_Response);
  function _callConstructor(constructor, interceptor) {
    return dart.fn(receiver => {
      _js_helper.setNativeSubclassDispatchRecord(receiver, interceptor);
      receiver.constructor = receiver.__proto__.constructor;
      return constructor(receiver);
    });
  }
  dart.fn(_callConstructor);
  function _callAttached(receiver) {
    return dart.dsend(receiver, 'attached');
  }
  dart.fn(_callAttached);
  function _callDetached(receiver) {
    return dart.dsend(receiver, 'detached');
  }
  dart.fn(_callDetached);
  function _callAttributeChanged(receiver, name, oldValue, newValue) {
    return dart.dsend(receiver, 'attributeChanged', name, oldValue, newValue);
  }
  dart.fn(_callAttributeChanged);
  function _makeCallbackMethod(callback) {
    return (function(invokeCallback) {
      return function() {
        return invokeCallback(this);
      };
    })(_js_helper.convertDartClosureToJS(callback, 1));
  }
  dart.fn(_makeCallbackMethod);
  function _makeCallbackMethod3(callback) {
    return (function(invokeCallback) {
      return function(arg1, arg2, arg3) {
        return invokeCallback(this, arg1, arg2, arg3);
      };
    })(_js_helper.convertDartClosureToJS(callback, 4));
  }
  dart.fn(_makeCallbackMethod3);
  function _registerCustomElement(context, document, tag, type, extendsTagName) {
    let interceptorClass = _interceptors.findInterceptorConstructorForType(type);
    if (interceptorClass == null) {
      dart.throw(new core.ArgumentError(type));
    }
    let interceptor = interceptorClass.prototype;
    let constructor = _interceptors.findConstructorForNativeSubclassType(type, 'created');
    if (constructor == null) {
      dart.throw(new core.ArgumentError(`${type} has no constructor called 'created'`));
    }
    _interceptors.getNativeInterceptor(Element.tag('article'));
    let baseClassName = _js_helper.findDispatchTagForInterceptorClass(interceptorClass);
    if (baseClassName == null) {
      dart.throw(new core.ArgumentError(type));
    }
    if (extendsTagName == null) {
      if (baseClassName != 'HTMLElement') {
        dart.throw(new core.UnsupportedError('Class must provide extendsTag if base ' + 'native class is not HtmlElement'));
      }
    } else {
      if (!dart.notNull(dart.as(document.createElement(extendsTagName) instanceof window[baseClassName], core.bool))) {
        dart.throw(new core.UnsupportedError('extendsTag does not match base native class'));
      }
    }
    let baseConstructor = context[baseClassName];
    let properties = {};
    properties.createdCallback = {value: _makeCallbackMethod(_callConstructor(constructor, interceptor))};
    properties.attachedCallback = {value: _makeCallbackMethod(_callAttached)};
    properties.detachedCallback = {value: _makeCallbackMethod(_callDetached)};
    properties.attributeChangedCallback = {value: _makeCallbackMethod3(_callAttributeChanged)};
    let baseProto = baseConstructor.prototype;
    let proto = Object.create(baseProto, properties);
    _js_helper.setNativeSubclassDispatchRecord(proto, interceptor);
    let options = {prototype: proto};
    if (extendsTagName != null) {
      options.extends = extendsTagName;
    }
    document.registerElement(tag, options);
  }
  dart.fn(_registerCustomElement, dart.void, [dart.dynamic, dart.dynamic, core.String, core.Type, core.String]);
  function _initializeCustomElement(e) {
  }
  dart.fn(_initializeCustomElement, dart.void, [Element]);
  let _interceptor = Symbol('_interceptor');
  let _constructor = Symbol('_constructor');
  let _nativeType = Symbol('_nativeType');
  class _JSElementUpgrader extends core.Object {
    _JSElementUpgrader(document, type, extendsTag) {
      this[_interceptor] = null;
      this[_constructor] = null;
      this[_nativeType] = null;
      let interceptorClass = _interceptors.findInterceptorConstructorForType(type);
      if (interceptorClass == null) {
        dart.throw(new core.ArgumentError(type));
      }
      this[_constructor] = _interceptors.findConstructorForNativeSubclassType(type, 'created');
      if (this[_constructor] == null) {
        dart.throw(new core.ArgumentError(`${type} has no constructor called 'created'`));
      }
      _interceptors.getNativeInterceptor(Element.tag('article'));
      let baseClassName = _js_helper.findDispatchTagForInterceptorClass(interceptorClass);
      if (baseClassName == null) {
        dart.throw(new core.ArgumentError(type));
      }
      if (extendsTag == null) {
        if (!dart.equals(baseClassName, 'HTMLElement')) {
          dart.throw(new core.UnsupportedError('Class must provide extendsTag if base ' + 'native class is not HtmlElement'));
        }
        this[_nativeType] = HtmlElement;
      } else {
        let element = document.createElement(extendsTag);
        if (!dart.notNull(dart.as(element instanceof window[baseClassName], core.bool))) {
          dart.throw(new core.UnsupportedError('extendsTag does not match base native class'));
        }
        this[_nativeType] = dart.dload(element, 'runtimeType');
      }
      this[_interceptor] = interceptorClass.prototype;
    }
    upgrade(element) {
      if (!dart.equals(dart.runtimeType(element), this[_nativeType])) {
        dart.throw(new core.ArgumentError(`element is not subclass of ${this[_nativeType]}`));
      }
      _js_helper.setNativeSubclassDispatchRecord(element, this[_interceptor]);
      this[_constructor](element);
      return element;
    }
  }
  _JSElementUpgrader[dart.implements] = () => [ElementUpgrader];
  dart.setSignature(_JSElementUpgrader, {
    constructors: () => ({_JSElementUpgrader: [_JSElementUpgrader, [Document, core.Type, core.String]]}),
    methods: () => ({upgrade: [Element, [Element]]})
  });
  class _DOMWindowCrossFrame extends core.Object {
    get history() {
      return _HistoryCrossFrame._createSafe(this[_window].history);
    }
    get location() {
      return _LocationCrossFrame._createSafe(this[_window].location);
    }
    get closed() {
      return dart.as(this[_window].closed, core.bool);
    }
    get opener() {
      return _DOMWindowCrossFrame._createSafe(this[_window].opener);
    }
    get parent() {
      return _DOMWindowCrossFrame._createSafe(this[_window].parent);
    }
    get top() {
      return _DOMWindowCrossFrame._createSafe(this[_window].top);
    }
    close() {
      return this[_window].close();
    }
    postMessage(message, targetOrigin, messagePorts) {
      if (messagePorts === void 0)
        messagePorts = null;
      if (messagePorts == null) {
        this[_window].postMessage(html_common.convertDartToNative_SerializedScriptValue(message), targetOrigin);
      } else {
        this[_window].postMessage(html_common.convertDartToNative_SerializedScriptValue(message), targetOrigin, messagePorts);
      }
    }
    _DOMWindowCrossFrame(window) {
      this[_window] = window;
    }
    static _createSafe(w) {
      if (dart.notNull(core.identical(w, exports.window))) {
        return dart.as(w, WindowBase);
      } else {
        return new _DOMWindowCrossFrame(w);
      }
    }
    get on() {
      return dart.throw(new core.UnsupportedError('You can only attach EventListeners to your own window.'));
    }
    [_addEventListener](type, listener, useCapture) {
      if (type === void 0)
        type = null;
      if (listener === void 0)
        listener = null;
      if (useCapture === void 0)
        useCapture = null;
      return dart.throw(new core.UnsupportedError('You can only attach EventListeners to your own window.'));
    }
    addEventListener(type, listener, useCapture) {
      if (useCapture === void 0)
        useCapture = null;
      return dart.throw(new core.UnsupportedError('You can only attach EventListeners to your own window.'));
    }
    dispatchEvent(event) {
      return dart.throw(new core.UnsupportedError('You can only attach EventListeners to your own window.'));
    }
    [_removeEventListener](type, listener, useCapture) {
      if (type === void 0)
        type = null;
      if (listener === void 0)
        listener = null;
      if (useCapture === void 0)
        useCapture = null;
      return dart.throw(new core.UnsupportedError('You can only attach EventListeners to your own window.'));
    }
    removeEventListener(type, listener, useCapture) {
      if (useCapture === void 0)
        useCapture = null;
      return dart.throw(new core.UnsupportedError('You can only attach EventListeners to your own window.'));
    }
  }
  _DOMWindowCrossFrame[dart.implements] = () => [WindowBase];
  dart.setSignature(_DOMWindowCrossFrame, {
    constructors: () => ({_DOMWindowCrossFrame: [_DOMWindowCrossFrame, [dart.dynamic]]}),
    methods: () => ({
      close: [dart.void, []],
      postMessage: [dart.void, [dart.dynamic, core.String], [core.List]],
      [_addEventListener]: [dart.void, [], [core.String, EventListener, core.bool]],
      addEventListener: [dart.void, [core.String, EventListener], [core.bool]],
      dispatchEvent: [core.bool, [Event]],
      [_removeEventListener]: [dart.void, [], [core.String, EventListener, core.bool]],
      removeEventListener: [dart.void, [core.String, EventListener], [core.bool]]
    }),
    statics: () => ({_createSafe: [WindowBase, [dart.dynamic]]}),
    names: ['_createSafe']
  });
  class _LocationCrossFrame extends core.Object {
    set href(val) {
      return _LocationCrossFrame._setHref(this[_location], val);
    }
    static _setHref(location, val) {
      location.href = val;
    }
    _LocationCrossFrame(location) {
      this[_location] = location;
    }
    static _createSafe(location) {
      if (dart.notNull(core.identical(location, exports.window.location))) {
        return dart.as(location, LocationBase);
      } else {
        return new _LocationCrossFrame(location);
      }
    }
  }
  _LocationCrossFrame[dart.implements] = () => [LocationBase];
  dart.setSignature(_LocationCrossFrame, {
    constructors: () => ({_LocationCrossFrame: [_LocationCrossFrame, [dart.dynamic]]}),
    statics: () => ({
      _setHref: [dart.void, [dart.dynamic, dart.dynamic]],
      _createSafe: [LocationBase, [dart.dynamic]]
    }),
    names: ['_setHref', '_createSafe']
  });
  let _history = Symbol('_history');
  class _HistoryCrossFrame extends core.Object {
    back() {
      return this[_history].back();
    }
    forward() {
      return this[_history].forward();
    }
    go(distance) {
      return this[_history].go(distance);
    }
    _HistoryCrossFrame(history) {
      this[_history] = history;
    }
    static _createSafe(h) {
      if (dart.notNull(core.identical(h, exports.window.history))) {
        return dart.as(h, HistoryBase);
      } else {
        return new _HistoryCrossFrame(h);
      }
    }
  }
  _HistoryCrossFrame[dart.implements] = () => [HistoryBase];
  dart.setSignature(_HistoryCrossFrame, {
    constructors: () => ({_HistoryCrossFrame: [_HistoryCrossFrame, [dart.dynamic]]}),
    methods: () => ({
      back: [dart.void, []],
      forward: [dart.void, []],
      go: [dart.void, [core.int]]
    }),
    statics: () => ({_createSafe: [HistoryBase, [dart.dynamic]]}),
    names: ['_createSafe']
  });
  dart.defineLazyProperties(KeyEvent, {
    get _keyboardEventDispatchRecord() {
      return KeyEvent._makeRecord();
    },
    get keyDownEvent() {
      return new _KeyboardEventHandler('keydown');
    },
    set keyDownEvent(_) {},
    get keyUpEvent() {
      return new _KeyboardEventHandler('keyup');
    },
    set keyUpEvent(_) {},
    get keyPressEvent() {
      return new _KeyboardEventHandler('keypress');
    },
    set keyPressEvent(_) {}
  });
  class Platform extends core.Object {}
  Platform.supportsSimd = false;
  dart.defineLazyProperties(Platform, {
    get supportsTypedData() {
      return !!window.ArrayBuffer;
    }
  });
  function _wrapZone(callback) {
    if (dart.equals(async.Zone.current, async.Zone.ROOT))
      return callback;
    if (callback == null)
      return null;
    return async.Zone.current.bindUnaryCallback(callback, {runGuarded: true});
  }
  dart.fn(_wrapZone, dart.dynamic, [dart.functionType(dart.dynamic, [dart.dynamic])]);
  function _wrapBinaryZone(callback) {
    if (dart.equals(async.Zone.current, async.Zone.ROOT))
      return callback;
    if (callback == null)
      return null;
    return async.Zone.current.bindBinaryCallback(callback, {runGuarded: true});
  }
  dart.fn(_wrapBinaryZone, dart.dynamic, [dart.functionType(dart.dynamic, [dart.dynamic, dart.dynamic])]);
  function query(relativeSelectors) {
    return exports.document.query(relativeSelectors);
  }
  dart.fn(query, Element, [core.String]);
  function queryAll(relativeSelectors) {
    return exports.document.queryAll(relativeSelectors);
  }
  dart.fn(queryAll, ElementList$(Element), [core.String]);
  function querySelector(selectors) {
    return exports.document.querySelector(selectors);
  }
  dart.fn(querySelector, Element, [core.String]);
  function querySelectorAll(selectors) {
    return exports.document.querySelectorAll(selectors);
  }
  dart.fn(querySelectorAll, ElementList$(Element), [core.String]);
  class ElementUpgrader extends core.Object {}
  class NodeValidator extends core.Object {
    static new(opts) {
      let uriPolicy = opts && 'uriPolicy' in opts ? opts.uriPolicy : null;
      return new _Html5NodeValidator({uriPolicy: uriPolicy});
    }
    static throws(base) {
      return new _ThrowsNodeValidator(base);
    }
  }
  dart.setSignature(NodeValidator, {
    constructors: () => ({
      new: [NodeValidator, [], {uriPolicy: UriPolicy}],
      throws: [NodeValidator, [NodeValidator]]
    })
  });
  class NodeTreeSanitizer extends core.Object {
    static new(validator) {
      return new _ValidatingTreeSanitizer(validator);
    }
  }
  dart.setSignature(NodeTreeSanitizer, {
    constructors: () => ({new: [NodeTreeSanitizer, [NodeValidator]]})
  });
  class _TrustedHtmlTreeSanitizer extends core.Object {
    _TrustedHtmlTreeSanitizer() {
    }
    sanitizeTree(node) {}
  }
  _TrustedHtmlTreeSanitizer[dart.implements] = () => [NodeTreeSanitizer];
  dart.setSignature(_TrustedHtmlTreeSanitizer, {
    constructors: () => ({_TrustedHtmlTreeSanitizer: [_TrustedHtmlTreeSanitizer, []]}),
    methods: () => ({sanitizeTree: [dart.void, [Node]]})
  });
  NodeTreeSanitizer.trusted = dart.const(new _TrustedHtmlTreeSanitizer());
  class UriPolicy extends core.Object {
    static new() {
      return new _SameOriginUriPolicy();
    }
  }
  dart.setSignature(UriPolicy, {
    constructors: () => ({new: [UriPolicy, []]})
  });
  let _hiddenAnchor = Symbol('_hiddenAnchor');
  let _loc = Symbol('_loc');
  class _SameOriginUriPolicy extends core.Object {
    _SameOriginUriPolicy() {
      this[_hiddenAnchor] = AnchorElement.new();
      this[_loc] = exports.window.location;
    }
    allowsUri(uri) {
      this[_hiddenAnchor].href = uri;
      return this[_hiddenAnchor].hostname == this[_loc].hostname && this[_hiddenAnchor].port == this[_loc].port && this[_hiddenAnchor].protocol == this[_loc].protocol || this[_hiddenAnchor].hostname == '' && this[_hiddenAnchor].port == '' && (this[_hiddenAnchor].protocol == ':' || this[_hiddenAnchor].protocol == '');
    }
  }
  _SameOriginUriPolicy[dart.implements] = () => [UriPolicy];
  dart.setSignature(_SameOriginUriPolicy, {
    methods: () => ({allowsUri: [core.bool, [core.String]]})
  });
  class _ThrowsNodeValidator extends core.Object {
    _ThrowsNodeValidator(validator) {
      this.validator = validator;
    }
    allowsElement(element) {
      if (!dart.notNull(this.validator.allowsElement(element))) {
        dart.throw(new core.ArgumentError(element.tagName));
      }
      return true;
    }
    allowsAttribute(element, attributeName, value) {
      if (!dart.notNull(this.validator.allowsAttribute(element, attributeName, value))) {
        dart.throw(new core.ArgumentError(`${element.tagName}[${attributeName}="${value}"]`));
      }
    }
  }
  _ThrowsNodeValidator[dart.implements] = () => [NodeValidator];
  dart.setSignature(_ThrowsNodeValidator, {
    constructors: () => ({_ThrowsNodeValidator: [_ThrowsNodeValidator, [NodeValidator]]}),
    methods: () => ({
      allowsElement: [core.bool, [Element]],
      allowsAttribute: [core.bool, [Element, core.String, core.String]]
    })
  });
  let _removeNode = Symbol('_removeNode');
  let _sanitizeElement = Symbol('_sanitizeElement');
  let _sanitizeUntrustedElement = Symbol('_sanitizeUntrustedElement');
  class _ValidatingTreeSanitizer extends core.Object {
    _ValidatingTreeSanitizer(validator) {
      this.validator = validator;
    }
    sanitizeTree(node) {
      let walk = (function(node, parent) {
        this.sanitizeNode(node, parent);
        let child = node.lastChild;
        while (child != null) {
          let nextChild = dart.dload(child, 'previousNode');
          walk(dart.as(child, Node), node);
          child = nextChild;
        }
      }).bind(this);
      dart.fn(walk, dart.void, [Node, Node]);
      walk(node, null);
    }
    [_removeNode](node, parent) {
      if (parent == null) {
        node.remove();
      } else {
        parent[_removeChild](node);
      }
    }
    [_sanitizeUntrustedElement](element, parent) {
      let corrupted = true;
      let attrs = null;
      let isAttr = null;
      try {
        attrs = element.attributes;
        isAttr = dart.dindex(attrs, 'is');
        corrupted = Element._hasCorruptedAttributes(element);
      } catch (e) {
      }

      let elementText = 'element unprintable';
      try {
        elementText = dart.toString(element);
      } catch (e) {
      }

      let elementTagName = 'element tag unavailable';
      try {
        elementTagName = element.tagName;
      } catch (e) {
      }

      this[_sanitizeElement](element, parent, dart.as(corrupted, core.bool), dart.as(elementText, core.String), dart.as(elementTagName, core.String), dart.as(attrs, core.Map), dart.as(isAttr, core.String));
    }
    [_sanitizeElement](element, parent, corrupted, text, tag, attrs, isAttr) {
      if (false != corrupted) {
        exports.window.console.warn(`Removing element due to corrupted attributes on <${text}>`);
        this[_removeNode](element, parent);
        return;
      }
      if (!dart.notNull(this.validator.allowsElement(element))) {
        exports.window.console.warn(`Removing disallowed element <${tag}>`);
        this[_removeNode](element, parent);
        return;
      }
      if (isAttr != null) {
        if (!dart.notNull(this.validator.allowsAttribute(element, 'is', isAttr))) {
          exports.window.console.warn('Removing disallowed type extension ' + `<${tag} is="${isAttr}">`);
          this[_removeNode](element, parent);
          return;
        }
      }
      let keys = attrs.keys[dartx.toList]();
      for (let i = dart.notNull(attrs.length) - 1; dart.notNull(dart.as(dart.dsend(i, '>=', 0), core.bool)); i = dart.dsend(i, '-', 1)) {
        let name = dart.dindex(keys, i);
        if (!dart.notNull(this.validator.allowsAttribute(element, dart.as(dart.dsend(name, 'toLowerCase'), core.String), dart.as(attrs.get(name), core.String)))) {
          exports.window.console.warn('Removing disallowed attribute ' + `<${tag} ${name}="${attrs.get(name)}">`);
          attrs.remove(name);
        }
      }
      if (dart.is(element, TemplateElement)) {
        let template = element;
        this.sanitizeTree(template.content);
      }
    }
    sanitizeNode(node, parent) {
      switch (node.nodeType) {
        case Node.ELEMENT_NODE:
        {
          this[_sanitizeUntrustedElement](dart.as(node, Element), parent);
          break;
        }
        case Node.COMMENT_NODE:
        case Node.DOCUMENT_FRAGMENT_NODE:
        case Node.TEXT_NODE:
        case Node.CDATA_SECTION_NODE:
        {
          break;
        }
        default:
        {
          this[_removeNode](node, parent);
        }
      }
    }
  }
  _ValidatingTreeSanitizer[dart.implements] = () => [NodeTreeSanitizer];
  dart.setSignature(_ValidatingTreeSanitizer, {
    constructors: () => ({_ValidatingTreeSanitizer: [_ValidatingTreeSanitizer, [NodeValidator]]}),
    methods: () => ({
      sanitizeTree: [dart.void, [Node]],
      [_removeNode]: [dart.void, [Node, Node]],
      [_sanitizeUntrustedElement]: [dart.void, [Element, Node]],
      [_sanitizeElement]: [dart.void, [Element, Node, core.bool, core.String, core.String, core.Map, core.String]],
      sanitizeNode: [dart.void, [Node, Node]]
    })
  });
  let __CastType0 = dart.typedef('__CastType0', () => dart.functionType(core.bool, [Element]));
  let __CastType2 = dart.typedef('__CastType2', () => dart.functionType(dart.dynamic, [dart.dynamic]));
  // Exports:
  exports.EventTarget = EventTarget;
  exports.Node = Node;
  exports.Element = Element;
  exports.HtmlElement = HtmlElement;
  exports.spawnDomUri = spawnDomUri;
  exports.AbstractWorker = AbstractWorker;
  exports.EventStreamProvider$ = EventStreamProvider$;
  exports.EventStreamProvider = EventStreamProvider;
  exports.Event = Event;
  exports.ErrorEvent = ErrorEvent;
  exports.AnchorElement = AnchorElement;
  exports.AnimationNode = AnimationNode;
  exports.Animation = Animation;
  exports.AnimationEffect = AnimationEffect;
  exports.AnimationEvent = AnimationEvent;
  exports.AnimationPlayer = AnimationPlayer;
  exports.AnimationPlayerEvent = AnimationPlayerEvent;
  exports.AnimationTimeline = AnimationTimeline;
  exports.ApplicationCache = ApplicationCache;
  exports.ProgressEvent = ProgressEvent;
  exports.ApplicationCacheErrorEvent = ApplicationCacheErrorEvent;
  exports.AreaElement = AreaElement;
  exports.MediaElement = MediaElement;
  exports.AudioElement = AudioElement;
  exports.AudioTrack = AudioTrack;
  exports.AudioTrackList = AudioTrackList;
  exports.AutocompleteErrorEvent = AutocompleteErrorEvent;
  exports.BRElement = BRElement;
  exports.BarProp = BarProp;
  exports.BaseElement = BaseElement;
  exports.BatteryManager = BatteryManager;
  exports.BeforeUnloadEvent = BeforeUnloadEvent;
  exports.Blob = Blob;
  exports.Body = Body;
  exports.BodyElement = BodyElement;
  exports.MessageEvent = MessageEvent;
  exports.PopStateEvent = PopStateEvent;
  exports.StorageEvent = StorageEvent;
  exports.ButtonElement = ButtonElement;
  exports.CharacterData = CharacterData;
  exports.Text = Text;
  exports.CDataSection = CDataSection;
  exports.CacheStorage = CacheStorage;
  exports.Canvas2DContextAttributes = Canvas2DContextAttributes;
  exports.CanvasElement = CanvasElement;
  exports.CanvasGradient = CanvasGradient;
  exports.CanvasPattern = CanvasPattern;
  exports.CanvasRenderingContext = CanvasRenderingContext;
  exports.CanvasRenderingContext2D = CanvasRenderingContext2D;
  exports.ChildNode = ChildNode;
  exports.GeofencingRegion = GeofencingRegion;
  exports.CircularGeofencingRegion = CircularGeofencingRegion;
  exports.CloseEvent = CloseEvent;
  exports.Comment = Comment;
  exports.UIEvent = UIEvent;
  exports.CompositionEvent = CompositionEvent;
  exports.Console = Console;
  exports.ConsoleBase = ConsoleBase;
  exports.ContentElement = ContentElement;
  exports.Coordinates = Coordinates;
  exports.Credential = Credential;
  exports.CredentialsContainer = CredentialsContainer;
  exports.Crypto = Crypto;
  exports.CryptoKey = CryptoKey;
  exports.Css = Css;
  exports.CssRule = CssRule;
  exports.CssCharsetRule = CssCharsetRule;
  exports.CssFilterRule = CssFilterRule;
  exports.CssFontFaceRule = CssFontFaceRule;
  exports.CssImportRule = CssImportRule;
  exports.CssKeyframeRule = CssKeyframeRule;
  exports.CssKeyframesRule = CssKeyframesRule;
  exports.CssMediaRule = CssMediaRule;
  exports.CssPageRule = CssPageRule;
  exports.CssStyleDeclarationBase = CssStyleDeclarationBase;
  exports.CssStyleDeclaration = CssStyleDeclaration;
  exports.CssStyleRule = CssStyleRule;
  exports.StyleSheet = StyleSheet;
  exports.CssStyleSheet = CssStyleSheet;
  exports.CssSupportsRule = CssSupportsRule;
  exports.CssViewportRule = CssViewportRule;
  exports.CustomEvent = CustomEvent;
  exports.DListElement = DListElement;
  exports.DataListElement = DataListElement;
  exports.DataTransfer = DataTransfer;
  exports.DataTransferItem = DataTransferItem;
  exports.DataTransferItemList = DataTransferItemList;
  exports.DatabaseCallback = DatabaseCallback;
  exports.WorkerGlobalScope = WorkerGlobalScope;
  exports.DedicatedWorkerGlobalScope = DedicatedWorkerGlobalScope;
  exports.DeprecatedStorageInfo = DeprecatedStorageInfo;
  exports.DeprecatedStorageQuota = DeprecatedStorageQuota;
  exports.DetailsElement = DetailsElement;
  exports.DeviceAcceleration = DeviceAcceleration;
  exports.DeviceLightEvent = DeviceLightEvent;
  exports.DeviceMotionEvent = DeviceMotionEvent;
  exports.DeviceOrientationEvent = DeviceOrientationEvent;
  exports.DeviceRotationRate = DeviceRotationRate;
  exports.DialogElement = DialogElement;
  exports.Entry = Entry;
  exports.DirectoryEntry = DirectoryEntry;
  exports.DirectoryReader = DirectoryReader;
  exports.DivElement = DivElement;
  exports.Document = Document;
  exports.SecurityPolicyViolationEvent = SecurityPolicyViolationEvent;
  exports.DocumentFragment = DocumentFragment;
  exports.DomError = DomError;
  exports.DomException = DomException;
  exports.DomImplementation = DomImplementation;
  exports.DomIterator = DomIterator;
  exports.DomMatrixReadOnly = DomMatrixReadOnly;
  exports.DomMatrix = DomMatrix;
  exports.DomParser = DomParser;
  exports.DomPointReadOnly = DomPointReadOnly;
  exports.DomPoint = DomPoint;
  exports.DomRectReadOnly = DomRectReadOnly;
  exports.DomTokenList = DomTokenList;
  exports.DomSettableTokenList = DomSettableTokenList;
  exports.ImmutableListMixin$ = ImmutableListMixin$;
  exports.ImmutableListMixin = ImmutableListMixin;
  exports.DomStringList = DomStringList;
  exports.DomStringMap = DomStringMap;
  exports.ElementList$ = ElementList$;
  exports.ElementList = ElementList;
  exports.MouseEvent = MouseEvent;
  exports.WheelEvent = WheelEvent;
  exports.TransitionEvent = TransitionEvent;
  exports.KeyboardEvent = KeyboardEvent;
  exports.TouchEvent = TouchEvent;
  exports.ScrollAlignment = ScrollAlignment;
  exports.EmbedElement = EmbedElement;
  exports.EventSource = EventSource;
  exports.Events = Events;
  exports.ElementEvents = ElementEvents;
  exports.ExtendableEvent = ExtendableEvent;
  exports.FederatedCredential = FederatedCredential;
  exports.FetchEvent = FetchEvent;
  exports.FieldSetElement = FieldSetElement;
  exports.File = File;
  exports.FileEntry = FileEntry;
  exports.FileError = FileError;
  exports.FileList = FileList;
  exports.FileReader = FileReader;
  exports.FileStream = FileStream;
  exports.FileSystem = FileSystem;
  exports.FileWriter = FileWriter;
  exports.FocusEvent = FocusEvent;
  exports.FontFace = FontFace;
  exports.FontFaceSet = FontFaceSet;
  exports.FontFaceSetForEachCallback = FontFaceSetForEachCallback;
  exports.FontFaceSetLoadEvent = FontFaceSetLoadEvent;
  exports.FormData = FormData;
  exports.FormElement = FormElement;
  exports.Gamepad = Gamepad;
  exports.GamepadButton = GamepadButton;
  exports.GamepadEvent = GamepadEvent;
  exports.Geofencing = Geofencing;
  exports.Geolocation = Geolocation;
  exports.Geoposition = Geoposition;
  exports.GlobalEventHandlers = GlobalEventHandlers;
  exports.HRElement = HRElement;
  exports.HashChangeEvent = HashChangeEvent;
  exports.HeadElement = HeadElement;
  exports.Headers = Headers;
  exports.HeadersForEachCallback = HeadersForEachCallback;
  exports.HeadingElement = HeadingElement;
  exports.History = History;
  exports.HtmlCollection = HtmlCollection;
  exports.HtmlDocument = HtmlDocument;
  exports.HtmlFormControlsCollection = HtmlFormControlsCollection;
  exports.HtmlHtmlElement = HtmlHtmlElement;
  exports.HtmlOptionsCollection = HtmlOptionsCollection;
  exports.HttpRequestEventTarget = HttpRequestEventTarget;
  exports.HttpRequest = HttpRequest;
  exports.HttpRequestUpload = HttpRequestUpload;
  exports.IFrameElement = IFrameElement;
  exports.ImageBitmap = ImageBitmap;
  exports.ImageData = ImageData;
  exports.ImageElement = ImageElement;
  exports.InjectedScriptHost = InjectedScriptHost;
  exports.InputElement = InputElement;
  exports.InputElementBase = InputElementBase;
  exports.HiddenInputElement = HiddenInputElement;
  exports.TextInputElementBase = TextInputElementBase;
  exports.SearchInputElement = SearchInputElement;
  exports.TextInputElement = TextInputElement;
  exports.UrlInputElement = UrlInputElement;
  exports.TelephoneInputElement = TelephoneInputElement;
  exports.EmailInputElement = EmailInputElement;
  exports.PasswordInputElement = PasswordInputElement;
  exports.RangeInputElementBase = RangeInputElementBase;
  exports.DateInputElement = DateInputElement;
  exports.MonthInputElement = MonthInputElement;
  exports.WeekInputElement = WeekInputElement;
  exports.TimeInputElement = TimeInputElement;
  exports.LocalDateTimeInputElement = LocalDateTimeInputElement;
  exports.NumberInputElement = NumberInputElement;
  exports.RangeInputElement = RangeInputElement;
  exports.CheckboxInputElement = CheckboxInputElement;
  exports.RadioButtonInputElement = RadioButtonInputElement;
  exports.FileUploadInputElement = FileUploadInputElement;
  exports.SubmitButtonInputElement = SubmitButtonInputElement;
  exports.ImageButtonInputElement = ImageButtonInputElement;
  exports.ResetButtonInputElement = ResetButtonInputElement;
  exports.ButtonInputElement = ButtonInputElement;
  exports.InputMethodContext = InputMethodContext;
  exports.InstallEvent = InstallEvent;
  exports.KeygenElement = KeygenElement;
  exports.LIElement = LIElement;
  exports.LabelElement = LabelElement;
  exports.LegendElement = LegendElement;
  exports.LinkElement = LinkElement;
  exports.LocalCredential = LocalCredential;
  exports.Location = Location;
  exports.MidiErrorCallback = MidiErrorCallback;
  exports.MidiSuccessCallback = MidiSuccessCallback;
  exports.MapElement = MapElement;
  exports.MediaController = MediaController;
  exports.MediaDeviceInfo = MediaDeviceInfo;
  exports.MediaDeviceInfoCallback = MediaDeviceInfoCallback;
  exports.MediaKeyEvent = MediaKeyEvent;
  exports.MediaError = MediaError;
  exports.MediaKeyError = MediaKeyError;
  exports.MediaKeyMessageEvent = MediaKeyMessageEvent;
  exports.MediaKeyNeededEvent = MediaKeyNeededEvent;
  exports.MediaKeySession = MediaKeySession;
  exports.MediaKeys = MediaKeys;
  exports.MediaList = MediaList;
  exports.MediaQueryList = MediaQueryList;
  exports.MediaQueryListEvent = MediaQueryListEvent;
  exports.MediaSource = MediaSource;
  exports.MediaStream = MediaStream;
  exports.MediaStreamEvent = MediaStreamEvent;
  exports.MediaStreamTrack = MediaStreamTrack;
  exports.MediaStreamTrackEvent = MediaStreamTrackEvent;
  exports.MediaStreamTrackSourcesCallback = MediaStreamTrackSourcesCallback;
  exports.MemoryInfo = MemoryInfo;
  exports.MenuElement = MenuElement;
  exports.MenuItemElement = MenuItemElement;
  exports.MessageChannel = MessageChannel;
  exports.MessagePort = MessagePort;
  exports.MetaElement = MetaElement;
  exports.Metadata = Metadata;
  exports.MetadataCallback = MetadataCallback;
  exports.MeterElement = MeterElement;
  exports.MidiAccess = MidiAccess;
  exports.MidiConnectionEvent = MidiConnectionEvent;
  exports.MidiPort = MidiPort;
  exports.MidiInput = MidiInput;
  exports.MidiMessageEvent = MidiMessageEvent;
  exports.MidiInputMap = MidiInputMap;
  exports.MidiOutput = MidiOutput;
  exports.MidiOutputMap = MidiOutputMap;
  exports.MimeType = MimeType;
  exports.MimeTypeArray = MimeTypeArray;
  exports.ModElement = ModElement;
  exports.MutationCallback = MutationCallback;
  exports.MutationObserver = MutationObserver;
  exports.MutationRecord = MutationRecord;
  exports.Navigator = Navigator;
  exports.NavigatorCpu = NavigatorCpu;
  exports.NavigatorID = NavigatorID;
  exports.NavigatorLanguage = NavigatorLanguage;
  exports.NavigatorOnLine = NavigatorOnLine;
  exports.NavigatorUserMediaError = NavigatorUserMediaError;
  exports.NetworkInformation = NetworkInformation;
  exports.NodeFilter = NodeFilter;
  exports.NodeIterator = NodeIterator;
  exports.NodeList = NodeList;
  exports.Notification = Notification;
  exports.OListElement = OListElement;
  exports.ObjectElement = ObjectElement;
  exports.OptGroupElement = OptGroupElement;
  exports.OptionElement = OptionElement;
  exports.OutputElement = OutputElement;
  exports.OverflowEvent = OverflowEvent;
  exports.PageTransitionEvent = PageTransitionEvent;
  exports.ParagraphElement = ParagraphElement;
  exports.ParamElement = ParamElement;
  exports.ParentNode = ParentNode;
  exports.Path2D = Path2D;
  exports.Performance = Performance;
  exports.PerformanceEntry = PerformanceEntry;
  exports.PerformanceMark = PerformanceMark;
  exports.PerformanceMeasure = PerformanceMeasure;
  exports.PerformanceNavigation = PerformanceNavigation;
  exports.PerformanceResourceTiming = PerformanceResourceTiming;
  exports.PerformanceTiming = PerformanceTiming;
  exports.PictureElement = PictureElement;
  exports.Plugin = Plugin;
  exports.PluginArray = PluginArray;
  exports.PluginPlaceholderElement = PluginPlaceholderElement;
  exports.PositionError = PositionError;
  exports.PreElement = PreElement;
  exports.Presentation = Presentation;
  exports.ProcessingInstruction = ProcessingInstruction;
  exports.ProgressElement = ProgressElement;
  exports.PushEvent = PushEvent;
  exports.PushManager = PushManager;
  exports.PushRegistration = PushRegistration;
  exports.QuoteElement = QuoteElement;
  exports.RtcStatsCallback = RtcStatsCallback;
  exports.Range = Range;
  exports.ReadableStream = ReadableStream;
  exports.RelatedEvent = RelatedEvent;
  exports.RequestAnimationFrameCallback = RequestAnimationFrameCallback;
  exports.ResourceProgressEvent = ResourceProgressEvent;
  exports.RtcDataChannel = RtcDataChannel;
  exports.RtcDataChannelEvent = RtcDataChannelEvent;
  exports.RtcDtmfSender = RtcDtmfSender;
  exports.RtcDtmfToneChangeEvent = RtcDtmfToneChangeEvent;
  exports.RtcIceCandidate = RtcIceCandidate;
  exports.RtcIceCandidateEvent = RtcIceCandidateEvent;
  exports.RtcPeerConnection = RtcPeerConnection;
  exports.RtcSessionDescription = RtcSessionDescription;
  exports.RtcStatsReport = RtcStatsReport;
  exports.RtcStatsResponse = RtcStatsResponse;
  exports.Screen = Screen;
  exports.ScreenOrientation = ScreenOrientation;
  exports.ScriptElement = ScriptElement;
  exports.SelectElement = SelectElement;
  exports.Selection = Selection;
  exports.ServiceWorkerClient = ServiceWorkerClient;
  exports.ServiceWorkerClients = ServiceWorkerClients;
  exports.ServiceWorkerContainer = ServiceWorkerContainer;
  exports.ServiceWorkerGlobalScope = ServiceWorkerGlobalScope;
  exports.ServiceWorkerRegistration = ServiceWorkerRegistration;
  exports.ShadowElement = ShadowElement;
  exports.ShadowRoot = ShadowRoot;
  exports.SharedWorker = SharedWorker;
  exports.SharedWorkerGlobalScope = SharedWorkerGlobalScope;
  exports.SourceBuffer = SourceBuffer;
  exports.SourceBufferList = SourceBufferList;
  exports.SourceElement = SourceElement;
  exports.SourceInfo = SourceInfo;
  exports.SpanElement = SpanElement;
  exports.SpeechGrammar = SpeechGrammar;
  exports.SpeechGrammarList = SpeechGrammarList;
  exports.SpeechRecognition = SpeechRecognition;
  exports.SpeechRecognitionError = SpeechRecognitionError;
  exports.SpeechRecognitionEvent = SpeechRecognitionEvent;
  exports.SpeechRecognitionAlternative = SpeechRecognitionAlternative;
  exports.SpeechRecognitionResult = SpeechRecognitionResult;
  exports.SpeechSynthesis = SpeechSynthesis;
  exports.SpeechSynthesisEvent = SpeechSynthesisEvent;
  exports.SpeechSynthesisUtterance = SpeechSynthesisUtterance;
  exports.SpeechSynthesisVoice = SpeechSynthesisVoice;
  exports.Storage = Storage;
  exports.StorageErrorCallback = StorageErrorCallback;
  exports.StorageInfo = StorageInfo;
  exports.StorageQuota = StorageQuota;
  exports.StorageQuotaCallback = StorageQuotaCallback;
  exports.StorageUsageCallback = StorageUsageCallback;
  exports.StyleElement = StyleElement;
  exports.StyleMedia = StyleMedia;
  exports.TableCaptionElement = TableCaptionElement;
  exports.TableCellElement = TableCellElement;
  exports.TableColElement = TableColElement;
  exports.TableElement = TableElement;
  exports.TableRowElement = TableRowElement;
  exports.TableSectionElement = TableSectionElement;
  exports.TemplateElement = TemplateElement;
  exports.TextAreaElement = TextAreaElement;
  exports.TextEvent = TextEvent;
  exports.TextMetrics = TextMetrics;
  exports.TextTrack = TextTrack;
  exports.TextTrackCue = TextTrackCue;
  exports.TextTrackCueList = TextTrackCueList;
  exports.TextTrackList = TextTrackList;
  exports.TrackEvent = TrackEvent;
  exports.TimeRanges = TimeRanges;
  exports.TimeoutHandler = TimeoutHandler;
  exports.Timing = Timing;
  exports.TitleElement = TitleElement;
  exports.Touch = Touch;
  exports.TouchList = TouchList;
  exports.TrackElement = TrackElement;
  exports.TreeWalker = TreeWalker;
  exports.UListElement = UListElement;
  exports.UnknownElement = UnknownElement;
  exports.Url = Url;
  exports.UrlUtils = UrlUtils;
  exports.UrlUtilsReadOnly = UrlUtilsReadOnly;
  exports.ValidityState = ValidityState;
  exports.VideoElement = VideoElement;
  exports.VideoPlaybackQuality = VideoPlaybackQuality;
  exports.VideoTrack = VideoTrack;
  exports.VideoTrackList = VideoTrackList;
  exports.VoidCallback = VoidCallback;
  exports.VttCue = VttCue;
  exports.VttRegion = VttRegion;
  exports.VttRegionList = VttRegionList;
  exports.WebSocket = WebSocket;
  exports.Window = Window;
  exports.WindowBase64 = WindowBase64;
  exports.WindowEventHandlers = WindowEventHandlers;
  exports.Worker = Worker;
  exports.WorkerConsole = WorkerConsole;
  exports.WorkerPerformance = WorkerPerformance;
  exports.XPathEvaluator = XPathEvaluator;
  exports.XPathExpression = XPathExpression;
  exports.XPathNSResolver = XPathNSResolver;
  exports.XPathResult = XPathResult;
  exports.XmlDocument = XmlDocument;
  exports.XmlSerializer = XmlSerializer;
  exports.XsltProcessor = XsltProcessor;
  exports.CanvasImageSource = CanvasImageSource;
  exports.WindowBase = WindowBase;
  exports.LocationBase = LocationBase;
  exports.HistoryBase = HistoryBase;
  exports.CssClassSet = CssClassSet;
  exports.CssRect = CssRect;
  exports.Dimension = Dimension;
  exports.EventListener = EventListener;
  exports.ElementStream$ = ElementStream$;
  exports.ElementStream = ElementStream;
  exports.CustomStream$ = CustomStream$;
  exports.CustomStream = CustomStream;
  exports.KeyEvent = KeyEvent;
  exports.KeyCode = KeyCode;
  exports.KeyLocation = KeyLocation;
  exports.KeyboardEventStream = KeyboardEventStream;
  exports.NodeValidatorBuilder = NodeValidatorBuilder;
  exports.ReadyState = ReadyState;
  exports.FixedSizeListIterator$ = FixedSizeListIterator$;
  exports.FixedSizeListIterator = FixedSizeListIterator;
  exports.Platform = Platform;
  exports.query = query;
  exports.queryAll = queryAll;
  exports.querySelector = querySelector;
  exports.querySelectorAll = querySelectorAll;
  exports.ElementUpgrader = ElementUpgrader;
  exports.NodeValidator = NodeValidator;
  exports.NodeTreeSanitizer = NodeTreeSanitizer;
  exports.UriPolicy = UriPolicy;
});
